/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(ne){for(var e=[],A=0,C=ne.length;A<C;A++)e[A]=$e[ne[A]];return e};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Wt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Ct}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(e,A,C){return e.apply(A,C)}),ot||(ot=function(e){return e}),ft||(ft=function(e){return e}),Ct||(Ct=function(e,A){return new e(...A)});const oi=ut(Array.prototype.forEach),jt=ut(Array.prototype.pop),wt=ut(Array.prototype.push),Et=ut(String.prototype.toLowerCase),Pt=ut(String.prototype.toString),li=ut(String.prototype.match),dt=ut(String.prototype.replace),ai=ut(String.prototype.indexOf),hi=ut(String.prototype.trim),ht=ut(RegExp.prototype.test),vt=ui(TypeError);function ut(ne){return function(e){for(var A=arguments.length,C=new Array(A>1?A-1:0),n=1;n<A;n++)C[n-1]=arguments[n];return Nt(ne,e,C)}}function ui(ne){return function(){for(var e=arguments.length,A=new Array(e),C=0;C<e;C++)A[C]=arguments[C];return Ct(ne,A)}}function Ue(ne,e,A){var C;A=(C=A)!==null&&C!==void 0?C:Et,Wt&&Wt(ne,null);let n=e.length;for(;n--;){let U=e[n];if(typeof U=="string"){const D=A(U);D!==U&&(ii(e)||(e[n]=D),U=D)}ne[U]=!0}return ne}function bt(ne){const e=ri(null);for(const[A,C]of zt(ne))e[A]=C;return e}function At(ne,e){for(;ne!==null;){const C=si(ne,e);if(C){if(C.get)return ut(C.get);if(typeof C.value=="function")return ut(C.value)}ne=ni(ne)}function A(C){return console.warn("fallback value for",C),null}return A}const Ut=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ht=ot(["#text"]),qt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),kt=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Qt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=ft(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Vt});const vi=()=>typeof window>"u"?null:window,yi=function(e,A){if(typeof e!="object"||typeof e.createPolicy!="function")return null;let C=null;const n="data-tt-policy-suffix";A&&A.hasAttribute(n)&&(C=A.getAttribute(n));const U="dompurify"+(C?"#"+C:"");try{return e.createPolicy(U,{createHTML(D){return D},createScriptURL(D){return D}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function xt(){let ne=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const e=ze=>xt(ze);if(e.version="3.0.5",e.removed=[],!ne||!ne.document||ne.document.nodeType!==9)return e.isSupported=!1,e;const A=ne.document,C=A.currentScript;let{document:n}=ne;const{DocumentFragment:U,HTMLTemplateElement:D,Node:S,Element:m,NodeFilter:p,NamedNodeMap:v=ne.NamedNodeMap||ne.MozNamedAttrMap,HTMLFormElement:I,DOMParser:a,trustedTypes:h}=ne,t=m.prototype,s=At(t,"cloneNode"),d=At(t,"nextSibling"),c=At(t,"childNodes"),l=At(t,"parentNode");if(typeof D=="function"){const ze=n.createElement("template");ze.content&&ze.content.ownerDocument&&(n=ze.content.ownerDocument)}let $,f="";const{implementation:b,createNodeIterator:u,createDocumentFragment:N,getElementsByTagName:B}=n,{importNode:P}=A;let W={};e.isSupported=typeof zt=="function"&&typeof l=="function"&&b&&b.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:z,ERB_EXPR:y,TMPLIT_EXPR:O,DATA_ATTR:H,ARIA_ATTR:E,IS_SCRIPT_OR_DATA:R,ATTR_WHITESPACE:L}=Kt;let{IS_ALLOWED_URI:G}=Kt,Z=null;const ge=Ue({},[...Ut,...Rt,...Lt,...Mt,...Ht]);let he=null;const ie=Ue({},[...qt,...It,..._t,...kt]);let fe=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Re=null,Ne=null,Be=!0,se=!0,J=!1,ae=!0,re=!1,X=!1,x=!1,te=!1,ce=!1,ye=!1,Te=!1,Ae=!0,Q=!1;const g="user-content-";let k=!0,F=!1,r={},i=null;const o=Ue({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let w=null;const M=Ue({},["audio","video","img","source","image","track"]);let T=null;const j=Ue({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),_="http://www.w3.org/1998/Math/MathML",Y="http://www.w3.org/2000/svg",oe="http://www.w3.org/1999/xhtml";let be=oe,De=!1,we=null;const Ee=Ue({},[_,Y,oe],Pt);let ve;const Pe=["application/xhtml+xml","text/html"],Me="text/html";let Ie,Ye=null;const et=n.createElement("form"),xe=function(ue){return ue instanceof RegExp||ue instanceof Function},K=function(ue){if(!(Ye&&Ye===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=bt(ue),ve=Pe.indexOf(ue.PARSER_MEDIA_TYPE)===-1?ve=Me:ve=ue.PARSER_MEDIA_TYPE,Ie=ve==="application/xhtml+xml"?Pt:Et,Z="ALLOWED_TAGS"in ue?Ue({},ue.ALLOWED_TAGS,Ie):ge,he="ALLOWED_ATTR"in ue?Ue({},ue.ALLOWED_ATTR,Ie):ie,we="ALLOWED_NAMESPACES"in ue?Ue({},ue.ALLOWED_NAMESPACES,Pt):Ee,T="ADD_URI_SAFE_ATTR"in ue?Ue(bt(j),ue.ADD_URI_SAFE_ATTR,Ie):j,w="ADD_DATA_URI_TAGS"in ue?Ue(bt(M),ue.ADD_DATA_URI_TAGS,Ie):M,i="FORBID_CONTENTS"in ue?Ue({},ue.FORBID_CONTENTS,Ie):o,Re="FORBID_TAGS"in ue?Ue({},ue.FORBID_TAGS,Ie):{},Ne="FORBID_ATTR"in ue?Ue({},ue.FORBID_ATTR,Ie):{},r="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Be=ue.ALLOW_ARIA_ATTR!==!1,se=ue.ALLOW_DATA_ATTR!==!1,J=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=ue.SAFE_FOR_TEMPLATES||!1,X=ue.WHOLE_DOCUMENT||!1,ce=ue.RETURN_DOM||!1,ye=ue.RETURN_DOM_FRAGMENT||!1,Te=ue.RETURN_TRUSTED_TYPE||!1,te=ue.FORCE_BODY||!1,Ae=ue.SANITIZE_DOM!==!1,Q=ue.SANITIZE_NAMED_PROPS||!1,k=ue.KEEP_CONTENT!==!1,F=ue.IN_PLACE||!1,G=ue.ALLOWED_URI_REGEXP||Qt,be=ue.NAMESPACE||oe,fe=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&xe(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(fe.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&xe(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(fe.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(fe.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(se=!1),ye&&(ce=!0),r&&(Z=Ue({},[...Ht]),he=[],r.html===!0&&(Ue(Z,Ut),Ue(he,qt)),r.svg===!0&&(Ue(Z,Rt),Ue(he,It),Ue(he,kt)),r.svgFilters===!0&&(Ue(Z,Lt),Ue(he,It),Ue(he,kt)),r.mathMl===!0&&(Ue(Z,Mt),Ue(he,_t),Ue(he,kt))),ue.ADD_TAGS&&(Z===ge&&(Z=bt(Z)),Ue(Z,ue.ADD_TAGS,Ie)),ue.ADD_ATTR&&(he===ie&&(he=bt(he)),Ue(he,ue.ADD_ATTR,Ie)),ue.ADD_URI_SAFE_ATTR&&Ue(T,ue.ADD_URI_SAFE_ATTR,Ie),ue.FORBID_CONTENTS&&(i===o&&(i=bt(i)),Ue(i,ue.FORBID_CONTENTS,Ie)),k&&(Z["#text"]=!0),X&&Ue(Z,["html","head","body"]),Z.table&&(Ue(Z,["tbody"]),delete Re.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');$=ue.TRUSTED_TYPES_POLICY,f=$.createHTML("")}else $===void 0&&($=yi(h,C)),$!==null&&typeof f=="string"&&(f=$.createHTML(""));ot&&ot(ue),Ye=ue}},le=Ue({},["mi","mo","mn","ms","mtext"]),me=Ue({},["foreignobject","desc","title","annotation-xml"]),ke=Ue({},["title","style","font","a","script"]),Ce=Ue({},Rt);Ue(Ce,Lt),Ue(Ce,ci);const je=Ue({},Mt);Ue(je,fi);const Qe=function(ue){let Fe=l(ue);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:be,tagName:"template"});const Le=Et(ue.tagName),qe=Et(Fe.tagName);return we[ue.namespaceURI]?ue.namespaceURI===Y?Fe.namespaceURI===oe?Le==="svg":Fe.namespaceURI===_?Le==="svg"&&(qe==="annotation-xml"||le[qe]):!!Ce[Le]:ue.namespaceURI===_?Fe.namespaceURI===oe?Le==="math":Fe.namespaceURI===Y?Le==="math"&&me[qe]:!!je[Le]:ue.namespaceURI===oe?Fe.namespaceURI===Y&&!me[qe]||Fe.namespaceURI===_&&!le[qe]?!1:!je[Le]&&(ke[Le]||!Ce[Le]):!!(ve==="application/xhtml+xml"&&we[ue.namespaceURI]):!1},Ke=function(ue){wt(e.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},Je=function(ue,Fe){try{wt(e.removed,{attribute:Fe.getAttributeNode(ue),from:Fe})}catch{wt(e.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(ue),ue==="is"&&!he[ue])if(ce||ye)try{Ke(Fe)}catch{}else try{Fe.setAttribute(ue,"")}catch{}},tt=function(ue){let Fe,Le;if(te)ue="<remove></remove>"+ue;else{const lt=li(ue,/^[\r\n\t ]+/);Le=lt&&lt[0]}ve==="application/xhtml+xml"&&be===oe&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const qe=$?$.createHTML(ue):ue;if(be===oe)try{Fe=new a().parseFromString(qe,ve)}catch{}if(!Fe||!Fe.documentElement){Fe=b.createDocument(be,"template",null);try{Fe.documentElement.innerHTML=De?f:qe}catch{}}const it=Fe.body||Fe.documentElement;return ue&&Le&&it.insertBefore(n.createTextNode(Le),it.childNodes[0]||null),be===oe?B.call(Fe,X?"html":"body")[0]:X?Fe.documentElement:it},Ze=function(ue){return u.call(ue.ownerDocument||ue,ue,p.SHOW_ELEMENT|p.SHOW_COMMENT|p.SHOW_TEXT,null,!1)},nt=function(ue){return ue instanceof I&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof v)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},st=function(ue){return typeof S=="object"?ue instanceof S:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},rt=function(ue,Fe,Le){W[ue]&&oi(W[ue],qe=>{qe.call(e,Fe,Le,Ye)})},gt=function(ue){let Fe;if(rt("beforeSanitizeElements",ue,null),nt(ue))return Ke(ue),!0;const Le=Ie(ue.nodeName);if(rt("uponSanitizeElement",ue,{tagName:Le,allowedTags:Z}),ue.hasChildNodes()&&!st(ue.firstElementChild)&&(!st(ue.content)||!st(ue.content.firstElementChild))&&ht(/<[/\w]/g,ue.innerHTML)&&ht(/<[/\w]/g,ue.textContent))return Ke(ue),!0;if(!Z[Le]||Re[Le]){if(!Re[Le]&&mt(Le)&&(fe.tagNameCheck instanceof RegExp&&ht(fe.tagNameCheck,Le)||fe.tagNameCheck instanceof Function&&fe.tagNameCheck(Le)))return!1;if(k&&!i[Le]){const qe=l(ue)||ue.parentNode,it=c(ue)||ue.childNodes;if(it&&qe){const lt=it.length;for(let Ge=lt-1;Ge>=0;--Ge)qe.insertBefore(s(it[Ge],!0),d(ue))}}return Ke(ue),!0}return ue instanceof m&&!Qe(ue)||(Le==="noscript"||Le==="noembed"||Le==="noframes")&&ht(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Ke(ue),!0):(re&&ue.nodeType===3&&(Fe=ue.textContent,Fe=dt(Fe,z," "),Fe=dt(Fe,y," "),Fe=dt(Fe,O," "),ue.textContent!==Fe&&(wt(e.removed,{element:ue.cloneNode()}),ue.textContent=Fe)),rt("afterSanitizeElements",ue,null),!1)},St=function(ue,Fe,Le){if(Ae&&(Fe==="id"||Fe==="name")&&(Le in n||Le in et))return!1;if(!(se&&!Ne[Fe]&&ht(H,Fe))){if(!(Be&&ht(E,Fe))){if(!he[Fe]||Ne[Fe]){if(!(mt(ue)&&(fe.tagNameCheck instanceof RegExp&&ht(fe.tagNameCheck,ue)||fe.tagNameCheck instanceof Function&&fe.tagNameCheck(ue))&&(fe.attributeNameCheck instanceof RegExp&&ht(fe.attributeNameCheck,Fe)||fe.attributeNameCheck instanceof Function&&fe.attributeNameCheck(Fe))||Fe==="is"&&fe.allowCustomizedBuiltInElements&&(fe.tagNameCheck instanceof RegExp&&ht(fe.tagNameCheck,Le)||fe.tagNameCheck instanceof Function&&fe.tagNameCheck(Le))))return!1}else if(!T[Fe]){if(!ht(G,dt(Le,L,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&ue!=="script"&&ai(Le,"data:")===0&&w[ue])){if(!(J&&!ht(R,dt(Le,L,"")))){if(Le)return!1}}}}}}return!0},mt=function(ue){return ue.indexOf("-")>0},Ft=function(ue){let Fe,Le,qe,it;rt("beforeSanitizeAttributes",ue,null);const{attributes:lt}=ue;if(!lt)return;const Ge={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:he};for(it=lt.length;it--;){Fe=lt[it];const{name:ct,namespaceURI:$t}=Fe;if(Le=ct==="value"?Fe.value:hi(Fe.value),qe=Ie(ct),Ge.attrName=qe,Ge.attrValue=Le,Ge.keepAttr=!0,Ge.forceKeepAttr=void 0,rt("uponSanitizeAttribute",ue,Ge),Le=Ge.attrValue,Ge.forceKeepAttr||(Je(ct,ue),!Ge.keepAttr))continue;if(!ae&&ht(/\/>/i,Le)){Je(ct,ue);continue}re&&(Le=dt(Le,z," "),Le=dt(Le,y," "),Le=dt(Le,O," "));const yt=Ie(ue.nodeName);if(St(yt,qe,Le)){if(Q&&(qe==="id"||qe==="name")&&(Je(ct,ue),Le=g+Le),$&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!$t)switch(h.getAttributeType(yt,qe)){case"TrustedHTML":{Le=$.createHTML(Le);break}case"TrustedScriptURL":{Le=$.createScriptURL(Le);break}}try{$t?ue.setAttributeNS($t,ct,Le):ue.setAttribute(ct,Le),jt(e.removed)}catch{}}}rt("afterSanitizeAttributes",ue,null)},Ot=function ze(ue){let Fe;const Le=Ze(ue);for(rt("beforeSanitizeShadowDOM",ue,null);Fe=Le.nextNode();)rt("uponSanitizeShadowNode",Fe,null),!gt(Fe)&&(Fe.content instanceof U&&ze(Fe.content),Ft(Fe));rt("afterSanitizeShadowDOM",ue,null)};return e.sanitize=function(ze){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Le,qe,it;if(De=!ze,De&&(ze="<!-->"),typeof ze!="string"&&!st(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!e.isSupported)return ze;if(x||K(ue),e.removed=[],typeof ze=="string"&&(F=!1),F){if(ze.nodeName){const ct=Ie(ze.nodeName);if(!Z[ct]||Re[ct])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof S)Fe=tt("<!---->"),Le=Fe.ownerDocument.importNode(ze,!0),Le.nodeType===1&&Le.nodeName==="BODY"||Le.nodeName==="HTML"?Fe=Le:Fe.appendChild(Le);else{if(!ce&&!re&&!X&&ze.indexOf("<")===-1)return $&&Te?$.createHTML(ze):ze;if(Fe=tt(ze),!Fe)return ce?null:Te?f:""}Fe&&te&&Ke(Fe.firstChild);const lt=Ze(F?ze:Fe);for(;qe=lt.nextNode();)gt(qe)||(qe.content instanceof U&&Ot(qe.content),Ft(qe));if(F)return ze;if(ce){if(ye)for(it=N.call(Fe.ownerDocument);Fe.firstChild;)it.appendChild(Fe.firstChild);else it=Fe;return(he.shadowroot||he.shadowrootmode)&&(it=P.call(A,it,!0)),it}let Ge=X?Fe.outerHTML:Fe.innerHTML;return X&&Z["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Vt,Fe.ownerDocument.doctype.name)&&(Ge="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Ge),re&&(Ge=dt(Ge,z," "),Ge=dt(Ge,y," "),Ge=dt(Ge,O," ")),$&&Te?$.createHTML(Ge):Ge},e.setConfig=function(ze){K(ze),x=!0},e.clearConfig=function(){Ye=null,x=!1},e.isValidAttribute=function(ze,ue,Fe){Ye||K({});const Le=Ie(ze),qe=Ie(ue);return St(Le,qe,Fe)},e.addHook=function(ze,ue){typeof ue=="function"&&(W[ze]=W[ze]||[],wt(W[ze],ue))},e.removeHook=function(ze){if(W[ze])return jt(W[ze])},e.removeHooks=function(ze){W[ze]&&(W[ze]=[])},e.removeAllHooks=function(){W={}},e}var Di=xt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define($e[42],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=e.$rR=void 0;class A{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const S=C(D);this.a!==S&&(this.a=S,this.domNode.style.maxWidth=this.a)}setWidth(D){const S=C(D);this.b!==S&&(this.b=S,this.domNode.style.width=this.b)}setHeight(D){const S=C(D);this.c!==S&&(this.c=S,this.domNode.style.height=this.c)}setTop(D){const S=C(D);this.d!==S&&(this.d=S,this.domNode.style.top=this.d)}setLeft(D){const S=C(D);this.e!==S&&(this.e=S,this.domNode.style.left=this.e)}setBottom(D){const S=C(D);this.f!==S&&(this.f=S,this.domNode.style.bottom=this.f)}setRight(D){const S=C(D);this.g!==S&&(this.g=S,this.domNode.style.right=this.g)}setPaddingTop(D){const S=C(D);this.h!==S&&(this.h=S,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const S=C(D);this.i!==S&&(this.i=S,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const S=C(D);this.j!==S&&(this.j=S,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const S=C(D);this.k!==S&&(this.k=S,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const S=C(D);this.n!==S&&(this.n=S,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const S=C(D);this.s!==S&&(this.s=S,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const S=C(D);this.t!==S&&(this.t=S,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,S){this.domNode.classList.toggle(D,S),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,S){this.domNode.setAttribute(D,S)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}e.$rR=A;function C(U){return typeof U=="number"?`${U}px`:U}function n(U){return new A(U)}e.$sR=n}),define($e[69],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JP=e.$IP=void 0;const A=new WeakMap;function C(S){if(!S.parent||S.parent===S)return null;try{const m=S.location,p=S.parent.location;if(m.origin!=="null"&&p.origin!=="null"&&m.origin!==p.origin)return null}catch{return null}return S.parent}class n{static a(m){let p=A.get(m);if(!p){p=[],A.set(m,p);let v=m,I;do I=C(v),I?p.push({window:new WeakRef(v),iframeElement:v.frameElement||null}):p.push({window:new WeakRef(v),iframeElement:null}),v=I;while(v)}return p.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,p){if(!p||m===p)return{top:0,left:0};let v=0,I=0;const a=this.a(m);for(const h of a){const t=h.window.deref();if(v+=t?.scrollY??0,I+=t?.scrollX??0,t===p||!h.iframeElement)break;const s=h.iframeElement.getBoundingClientRect();v+=s.top,I+=s.left}return{top:v,left:I}}}e.$IP=n;async function U(S,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const p=JSON.stringify({parentOrigin:S,salt:m}),I=new TextEncoder().encode(p),a=await crypto.subtle.digest("sha-256",I);return D(a)}e.$JP=U;function D(S){const p=Array.from(new Uint8Array(S)).map(v=>v.toString(16).padStart(2,"0")).join("");return BigInt(`0x${p}`).toString(32).padStart(52,"0")}}),define($e[70],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$R=e.$0R=e.$9R=e.ListDragOverEffectPosition=e.ListDragOverEffectType=void 0;var A;(function(D){D[D.Copy=0]="Copy",D[D.Move=1]="Move"})(A||(e.ListDragOverEffectType=A={}));var C;(function(D){D.Over="drop-target",D.Before="drop-target-before",D.After="drop-target-after"})(C||(e.ListDragOverEffectPosition=C={})),e.$9R={reject(){return{accept:!1}},accept(){return{accept:!0}}};class n extends Error{constructor(S,m){super(`ListError [${S}] ${m}`)}}e.$0R=n;class U{constructor(){this.c=new WeakMap}getHeight(S){return this.c.get(S)??this.d(S)}setDynamicHeight(S,m){m>0&&this.c.set(S,m)}}e.$$R=U}),define($e[71],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=void 0;class A{constructor(n){this.a=n}splice(n,U,D){this.a.forEach(S=>S.splice(n,U,D))}}e.$YR=A}),define($e[43],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=void 0;const A=20;class C{constructor(U,D,S,m,p,v){this.a=Math.round(D),this.b=Math.round(S),this.c=Math.round(U),this.d=m,this.e=p,this.f=v,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const D=Math.round(U);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(U){const D=Math.round(U);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(U){const D=Math.round(U);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,D,S,m,p){const v=Math.max(0,S-U),I=Math.max(0,v-2*D),a=m>0&&m>S;if(!a)return{computedAvailableSize:Math.round(v),computedIsNeeded:a,computedSliderSize:Math.round(I),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(A,Math.floor(S*I/m))),t=(I-h)/(m-S),s=p*t;return{computedAvailableSize:Math.round(v),computedIsNeeded:a,computedSliderSize:Math.round(h),computedSliderRatio:t,computedSliderPosition:Math.round(s)}}m(){const U=C.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const D=U-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const D=U-this.c;let S=this.f;return D<this.k?S-=this.d:S+=this.d,S}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const D=this.k+U;return Math.round(D/this.j)}}e.$xR=C}),define($e[26],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3T=e.$2T=e.$1T=e.TreeDragOverBubble=e.TreeMouseEventTarget=e.ObjectTreeElementCollapseState=e.TreeVisibility=void 0;var A;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(A||(e.TreeVisibility=A={}));var C;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(e.ObjectTreeElementCollapseState=C={}));var n;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(n||(e.TreeMouseEventTarget=n={}));var U;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(U||(e.TreeDragOverBubble=U={})),e.$1T={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:m}}};class D extends Error{constructor(p,v){super(`TreeError [${p}] ${v}`)}}e.$2T=D;class S{constructor(p){this.a=p,this.b=new WeakMap}map(p){let v=this.b.get(p);return v||(v=this.a(p),this.b.set(p,v)),v}}e.$3T=S}),define($e[21],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$window=e.$lP=e.$kP=void 0;function A(n,U){const D=n;typeof D.vscodeWindowId!="number"&&Object.defineProperty(D,"vscodeWindowId",{get:()=>U})}e.$kP=A,e.$lP=window,e.$window=e.$lP;function C(n){return n===e.$lP?!1:typeof n?.vscodeWindowId=="number"}e.$nP=C}),define($e[72],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function A(s,d,c){const l=C(s,d);if(l!==-1)return s[l]}e.$fb=A;function C(s,d,c=s.length-1){for(let l=c;l>=0;l--){const $=s[l];if(d($))return l}return-1}e.$gb=C;function n(s,d){const c=U(s,d);return c===-1?void 0:s[c]}e.$hb=n;function U(s,d,c=0,l=s.length){let $=c,f=l;for(;$<f;){const b=Math.floor(($+f)/2);d(s[b])?$=b+1:f=b}return $-1}e.$ib=U;function D(s,d){const c=S(s,d);return c===s.length?void 0:s[c]}e.$jb=D;function S(s,d,c=0,l=s.length){let $=c,f=l;for(;$<f;){const b=Math.floor(($+f)/2);d(s[b])?f=b:$=b+1}return $}e.$kb=S;function m(s,d,c=0,l=s.length){const $=S(s,d,c,l);return $===s.length?-1:$}e.$lb=m;class p{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(p.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!d(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const c=U(this.e,d,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=p;function v(s,d){if(s.length===0)return;let c=s[0];for(let l=1;l<s.length;l++){const $=s[l];d($,c)>0&&(c=$)}return c}e.$nb=v;function I(s,d){if(s.length===0)return;let c=s[0];for(let l=1;l<s.length;l++){const $=s[l];d($,c)>=0&&(c=$)}return c}e.$ob=I;function a(s,d){return v(s,(c,l)=>-d(c,l))}e.$pb=a;function h(s,d){if(s.length===0)return-1;let c=0;for(let l=1;l<s.length;l++){const $=s[l];d($,s[c])>0&&(c=l)}return c}e.$qb=h;function t(s,d){for(const c of s){const l=d(c);if(l!==void 0)return l}}e.$rb=t}),define($e[73],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function A(D,S){const m=Object.create(null);for(const p of D){const v=S(p);let I=m[v];I||(I=m[v]=[]),I.push(p)}return m}e.$K=A;function C(D,S){const m=[],p=[];for(const v of D)S.has(v)||m.push(v);for(const v of S)D.has(v)||p.push(v);return{removed:m,added:p}}e.$L=C;function n(D,S){const m=[],p=[];for(const[v,I]of D)S.has(v)||m.push(I);for(const[v,I]of S)D.has(v)||p.push(I);return{removed:m,added:p}}e.$M=n;function U(D,S){const m=new Set;for(const p of S)D.has(p)&&m.add(p);return m}e.$N=U}),define($e[74],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=e.$mt=e.$lt=void 0;function A(S,m){const p=Math.pow(10,m);return Math.round(S*p)/p}class C{constructor(m,p,v,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=A(Math.max(Math.min(1,I),0),3)}static equals(m,p){return m.r===p.r&&m.g===p.g&&m.b===p.b&&m.a===p.a}}e.$lt=C;class n{constructor(m,p,v,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=A(Math.max(Math.min(1,p),0),3),this.l=A(Math.max(Math.min(1,v),0),3),this.a=A(Math.max(Math.min(1,I),0),3)}static equals(m,p){return m.h===p.h&&m.s===p.s&&m.l===p.l&&m.a===p.a}static fromRGBA(m){const p=m.r/255,v=m.g/255,I=m.b/255,a=m.a,h=Math.max(p,v,I),t=Math.min(p,v,I);let s=0,d=0;const c=(t+h)/2,l=h-t;if(l>0){switch(d=Math.min(c<=.5?l/(2*c):l/(2-2*c),1),h){case p:s=(v-I)/l+(v<I?6:0);break;case v:s=(I-p)/l+2;break;case I:s=(p-v)/l+4;break}s*=60,s=Math.round(s)}return new n(s,d,c,a)}static i(m,p,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?m+(p-m)*6*v:v<1/2?p:v<2/3?m+(p-m)*(2/3-v)*6:m}static toRGBA(m){const p=m.h/360,{s:v,l:I,a}=m;let h,t,s;if(v===0)h=t=s=I;else{const d=I<.5?I*(1+v):I+v-I*v,c=2*I-d;h=n.i(c,d,p+1/3),t=n.i(c,d,p),s=n.i(c,d,p-1/3)}return new C(Math.round(h*255),Math.round(t*255),Math.round(s*255),a)}}e.$mt=n;class U{constructor(m,p,v,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=A(Math.max(Math.min(1,p),0),3),this.v=A(Math.max(Math.min(1,v),0),3),this.a=A(Math.max(Math.min(1,I),0),3)}static equals(m,p){return m.h===p.h&&m.s===p.s&&m.v===p.v&&m.a===p.a}static fromRGBA(m){const p=m.r/255,v=m.g/255,I=m.b/255,a=Math.max(p,v,I),h=Math.min(p,v,I),t=a-h,s=a===0?0:t/a;let d;return t===0?d=0:a===p?d=((v-I)/t%6+6)%6:a===v?d=(I-p)/t+2:d=(p-v)/t+4,new U(Math.round(d*60),s,a,m.a)}static toRGBA(m){const{h:p,s:v,v:I,a}=m,h=I*v,t=h*(1-Math.abs(p/60%2-1)),s=I-h;let[d,c,l]=[0,0,0];return p<60?(d=h,c=t):p<120?(d=t,c=h):p<180?(c=h,l=t):p<240?(c=t,l=h):p<300?(d=t,l=h):p<=360&&(d=h,l=t),d=Math.round((d+s)*255),c=Math.round((c+s)*255),l=Math.round((l+s)*255),new C(d,c,l,a)}}e.$nt=U;class D{static fromHex(m){return D.Format.CSS.parseHex(m)||D.red}static equals(m,p){return!m&&!p?!0:!m||!p?!1:m.equals(p)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof C)this.rgba=m;else if(m instanceof n)this.i=m,this.rgba=n.toRGBA(m);else if(m instanceof U)this.j=m,this.rgba=U.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&C.equals(this.rgba,m.rgba)&&n.equals(this.hsla,m.hsla)&&U.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=D.k(this.rgba.r),p=D.k(this.rgba.g),v=D.k(this.rgba.b),I=.2126*m+.7152*p+.0722*v;return A(I,4)}static k(m){const p=m/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p>v?(p+.05)/(v+.05):(v+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p>v}isDarkerThan(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p<v}lighten(m){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:p,g:v,b:I,a}=this.rgba;return new D(new C(p,v,I,a*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const p=m.rgba,v=this.rgba.a,I=p.a,a=v+I*(1-v);if(a<1e-6)return D.transparent;const h=this.rgba.r*v/a+p.r*I*(1-v)/a,t=this.rgba.g*v/a+p.g*I*(1-v)/a,s=this.rgba.b*v/a+p.b*I*(1-v)/a;return new D(new C(h,t,s,a))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:p,g:v,b:I,a}=this.rgba;return new D(new C(m.rgba.r-a*(m.rgba.r-p),m.rgba.g-a*(m.rgba.g-v),m.rgba.b-a*(m.rgba.b-I),1))}flatten(...m){const p=m.reduceRight((v,I)=>D.o(I,v));return D.o(this,p)}static o(m,p){const v=1-m.rgba.a;return new D(new C(v*p.rgba.r+m.rgba.a*m.rgba.r,v*p.rgba.g+m.rgba.a*m.rgba.g,v*p.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(m,p,v){if(m.isLighterThan(p))return m;v=v||.5;const I=m.getRelativeLuminance(),a=p.getRelativeLuminance();return v=v*(a-I)/a,m.lighten(v)}static getDarkerColor(m,p,v){if(m.isDarkerThan(p))return m;v=v||.5;const I=m.getRelativeLuminance(),a=p.getRelativeLuminance();return v=v*(I-a)/I,m.darken(v)}static{this.white=new D(new C(255,255,255,1))}static{this.black=new D(new C(0,0,0,1))}static{this.red=new D(new C(255,0,0,1))}static{this.blue=new D(new C(0,0,255,1))}static{this.green=new D(new C(0,255,0,1))}static{this.cyan=new D(new C(0,255,255,1))}static{this.lightgrey=new D(new C(211,211,211,1))}static{this.transparent=new D(new C(0,0,0,0))}}e.$ot=D,function(S){let m;(function(p){let v;(function(I){function a(u){return u.rgba.a===1?`rgb(${u.rgba.r}, ${u.rgba.g}, ${u.rgba.b})`:S.Format.CSS.formatRGBA(u)}I.formatRGB=a;function h(u){return`rgba(${u.rgba.r}, ${u.rgba.g}, ${u.rgba.b}, ${+u.rgba.a.toFixed(2)})`}I.formatRGBA=h;function t(u){return u.hsla.a===1?`hsl(${u.hsla.h}, ${(u.hsla.s*100).toFixed(2)}%, ${(u.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(u)}I.formatHSL=t;function s(u){return`hsla(${u.hsla.h}, ${(u.hsla.s*100).toFixed(2)}%, ${(u.hsla.l*100).toFixed(2)}%, ${u.hsla.a.toFixed(2)})`}I.formatHSLA=s;function d(u){const N=u.toString(16);return N.length!==2?"0"+N:N}function c(u){return`#${d(u.rgba.r)}${d(u.rgba.g)}${d(u.rgba.b)}`}I.formatHex=c;function l(u,N=!1){return N&&u.rgba.a===1?S.Format.CSS.formatHex(u):`#${d(u.rgba.r)}${d(u.rgba.g)}${d(u.rgba.b)}${d(Math.round(u.rgba.a*255))}`}I.formatHexA=l;function $(u){return u.isOpaque()?S.Format.CSS.formatHex(u):S.Format.CSS.formatRGBA(u)}I.format=$;function f(u){const N=u.length;if(N===0||u.charCodeAt(0)!==35)return null;if(N===7){const B=16*b(u.charCodeAt(1))+b(u.charCodeAt(2)),P=16*b(u.charCodeAt(3))+b(u.charCodeAt(4)),W=16*b(u.charCodeAt(5))+b(u.charCodeAt(6));return new S(new C(B,P,W,1))}if(N===9){const B=16*b(u.charCodeAt(1))+b(u.charCodeAt(2)),P=16*b(u.charCodeAt(3))+b(u.charCodeAt(4)),W=16*b(u.charCodeAt(5))+b(u.charCodeAt(6)),z=16*b(u.charCodeAt(7))+b(u.charCodeAt(8));return new S(new C(B,P,W,z/255))}if(N===4){const B=b(u.charCodeAt(1)),P=b(u.charCodeAt(2)),W=b(u.charCodeAt(3));return new S(new C(16*B+B,16*P+P,16*W+W))}if(N===5){const B=b(u.charCodeAt(1)),P=b(u.charCodeAt(2)),W=b(u.charCodeAt(3)),z=b(u.charCodeAt(4));return new S(new C(16*B+B,16*P+P,16*W+W,(16*z+z)/255))}return null}I.parseHex=f;function b(u){switch(u){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=p.CSS||(p.CSS={}))})(m=S.Format||(S.Format={}))}(D||(e.$ot=D={}))}),define($e[27],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function A(D){return(S,m,p)=>{let v=null,I=null;if(typeof p.value=="function"?(v="value",I=p.value):typeof p.get=="function"&&(v="get",I=p.get),!I)throw new Error("not supported");p[v]=D(I,m)}}function C(D,S,m){let p=null,v=null;if(typeof m.value=="function"?(p="value",v=m.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(p="get",v=m.get),!v)throw new Error("not supported");const I=`$memoize$${S}`;m[p]=function(...a){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,a)}),this[I]}}e.$zh=C;function n(D,S,m){return A((p,v)=>{const I=`$debounce$${v}`,a=`$debounce$result$${v}`;return function(...h){this[a]||(this[a]=m?m():void 0),clearTimeout(this[I]),S&&(this[a]=S(this[a],...h),h=[this[a]]),this[I]=setTimeout(()=>{p.apply(this,h),this[a]=m?m():void 0},D)}})}e.$Ah=n;function U(D,S,m){return A((p,v)=>{const I=`$throttle$timer$${v}`,a=`$throttle$result$${v}`,h=`$throttle$lastRun$${v}`,t=`$throttle$pending$${v}`;return function(...s){if(this[a]||(this[a]=m?m():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[a]=S(this[a],...s)),this[t])return;const d=this[h]+D;d<=Date.now()?(this[h]=Date.now(),p.apply(this,[this[a]]),this[a]=m?m():void 0):(this[t]=!0,this[I]=setTimeout(()=>{this[t]=!1,this[h]=Date.now(),p.apply(this,[this[a]]),this[a]=m?m():void 0},d-Date.now()))}})}e.$Bh=U}),define($e[75],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class A{constructor(n,U,D,S){this.originalStart=n,this.originalLength=U,this.modifiedStart=D,this.modifiedLength=S}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}e.$Zs=A}),define($e[6],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class A{constructor(){this.b=[],this.a=function(u){setTimeout(()=>{throw u.stack?$.isErrorNoTelemetry(u)?new $(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.b.push(u),()=>{this.d(u)}}c(u){this.b.forEach(N=>{N(u)})}d(u){this.b.splice(this.b.indexOf(u),1)}setUnexpectedErrorHandler(u){this.a=u}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(u){this.a(u),this.c(u)}onUnexpectedExternalError(u){this.a(u)}}e.$W=A,e.$X=new A;function C(b){e.$X.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=C;function n(b){if(!b||typeof b!="object")return!1;const u=b;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}e.$Z=n;function U(b){p(b)||e.$X.onUnexpectedError(b)}e.$1=U;function D(b){p(b)||e.$X.onUnexpectedExternalError(b)}e.$2=D;function S(b){if(b instanceof Error){const{name:u,message:N}=b,B=b.stacktrace||b.stack;return{$isError:!0,name:u,message:N,stack:B,noTelemetry:$.isErrorNoTelemetry(b)}}return b}e.$3=S;const m="Canceled";function p(b){return b instanceof v?!0:b instanceof Error&&b.name===m&&b.message===m}e.$4=p;class v extends Error{constructor(){super(m),this.name=this.message}}e.$5=v;function I(){const b=new Error(m);return b.name=b.message,b}e.$6=I;function a(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.$7=a;function h(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.$8=h;class t extends TypeError{constructor(u){super(u?`${u} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=t;function s(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.$0=s;class d extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}e.$$=d;class c extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}e.$_=c;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=l;class $ extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof $)return u;const N=new $;return N.message=u.message,N.stack=u.stack,N}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}e.$bb=$;class f extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.$cb=f}),define($e[12],pe([1,0,6,72]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function n(Q,g=0){return Q[Q.length-(1+g)]}e.$sb=n;function U(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}e.$tb=U;function D(Q,g,k=(F,r)=>F===r){if(Q===g)return!0;if(!Q||!g||Q.length!==g.length)return!1;for(let F=0,r=Q.length;F<r;F++)if(!k(Q[F],g[F]))return!1;return!0}e.$ub=D;function S(Q,g){const k=Q.length-1;g<k&&(Q[g]=Q[k]),Q.pop()}e.$vb=S;function m(Q,g,k){return p(Q.length,F=>k(Q[F],g))}e.$wb=m;function p(Q,g){let k=0,F=Q-1;for(;k<=F;){const r=(k+F)/2|0,i=g(r);if(i<0)k=r+1;else if(i>0)F=r-1;else return r}return-(k+1)}e.$xb=p;function v(Q,g,k){if(Q=Q|0,Q>=g.length)throw new TypeError("invalid index");const F=g[Math.floor(g.length*Math.random())],r=[],i=[],o=[];for(const w of g){const M=k(w,F);M<0?r.push(w):M>0?i.push(w):o.push(w)}return Q<r.length?v(Q,r,k):Q<r.length+o.length?o[0]:v(Q-(r.length+o.length),i,k)}e.$yb=v;function I(Q,g){const k=[];let F;for(const r of Q.slice(0).sort(g))!F||g(F[0],r)!==0?(F=[r],k.push(F)):F.push(r);return k}e.$zb=I;function*a(Q,g){let k,F;for(const r of Q)F!==void 0&&g(F,r)?k.push(r):(k&&(yield k),k=[r]),F=r;k&&(yield k)}e.$Ab=a;function h(Q,g){for(let k=0;k<=Q.length;k++)g(k===0?void 0:Q[k-1],k===Q.length?void 0:Q[k])}e.$Bb=h;function t(Q,g){for(let k=0;k<Q.length;k++)g(k===0?void 0:Q[k-1],Q[k],k+1===Q.length?void 0:Q[k+1])}e.$Cb=t;function s(Q,g,k){const F=[];function r(w,M,T){if(M===0&&T.length===0)return;const j=F[F.length-1];j&&j.start+j.deleteCount===w?(j.deleteCount+=M,j.toInsert.push(...T)):F.push({start:w,deleteCount:M,toInsert:T})}let i=0,o=0;for(;;){if(i===Q.length){r(i,0,g.slice(o));break}if(o===g.length){r(i,Q.length-i,[]);break}const w=Q[i],M=g[o],T=k(w,M);T===0?(i+=1,o+=1):T<0?(r(i,1,[]),i+=1):T>0&&(r(i,0,[M]),o+=1)}return F}e.$Db=s;function d(Q,g,k){const F=s(Q,g,k),r=[],i=[];for(const o of F)r.push(...Q.slice(o.start,o.start+o.deleteCount)),i.push(...o.toInsert);return{removed:r,added:i}}e.$Eb=d;function c(Q,g,k){if(k===0)return[];const F=Q.slice(0,k).sort(g);return $(Q,g,F,k,Q.length),F}e.top=c;function l(Q,g,k,F,r){return k===0?Promise.resolve([]):new Promise((i,o)=>{(async()=>{const w=Q.length,M=Q.slice(0,k).sort(g);for(let T=k,j=Math.min(k+F,w);T<w;T=j,j=Math.min(j+F,w)){if(T>k&&await new Promise(_=>setTimeout(_)),r&&r.isCancellationRequested)throw new A.$5;$(Q,g,M,T,j)}return M})().then(i,o)})}e.$Gb=l;function $(Q,g,k,F,r){for(const i=k.length;F<r;F++){const o=Q[F];if(g(o,k[i-1])<0){k.pop();const w=(0,C.$kb)(k,M=>g(o,M)<0);k.splice(w,0,o)}}}function f(Q){return Q.filter(g=>!!g)}e.$Hb=f;function b(Q){let g=0;for(let k=0;k<Q.length;k++)Q[k]&&(Q[g]=Q[k],g+=1);Q.length=g}e.$Ib=b;function u(Q,g,k){Q.splice(k,0,Q.splice(g,1)[0])}e.$Jb=u;function N(Q){return!Array.isArray(Q)||Q.length===0}e.$Kb=N;function B(Q){return Array.isArray(Q)&&Q.length>0}e.$Lb=B;function P(Q,g=k=>k){const k=new Set;return Q.filter(F=>{const r=g(F);return k.has(r)?!1:(k.add(r),!0)})}e.$Mb=P;function W(Q){const g=new Set;return k=>{const F=Q(k);return g.has(F)?!1:(g.add(F),!0)}}e.$Nb=W;function z(Q,g){return Q.length>0?Q[0]:g}e.$Ob=z;function y(Q,g){return Q.length>0?Q[Q.length-1]:g}e.$Pb=y;function O(Q,g,k=(F,r)=>F===r){let F=0;for(let r=0,i=Math.min(Q.length,g.length);r<i&&k(Q[r],g[r]);r++)F++;return F}e.$Qb=O;function H(Q){return[].concat(...Q)}e.$Rb=H;function E(Q,g){let k=typeof g=="number"?Q:0;typeof g=="number"?k=Q:(k=0,g=Q);const F=[];if(k<=g)for(let r=k;r<g;r++)F.push(r);else for(let r=k;r>g;r--)F.push(r);return F}e.$Sb=E;function R(Q,g,k){return Q.reduce((F,r)=>(F[g(r)]=k?k(r):r,F),Object.create(null))}e.$Tb=R;function L(Q,g){return Q.push(g),()=>G(Q,g)}e.$Ub=L;function G(Q,g){const k=Q.indexOf(g);if(k>-1)return Q.splice(k,1),g}e.$Vb=G;function Z(Q,g,k){const F=Q.slice(0,g),r=Q.slice(g);return F.concat(k,r)}e.$Wb=Z;function ge(Q,g){let k;if(typeof g=="number"){let F=g;k=()=>{const r=Math.sin(F++)*179426549;return r-Math.floor(r)}}else k=Math.random;for(let F=Q.length-1;F>0;F-=1){const r=Math.floor(k()*(F+1)),i=Q[F];Q[F]=Q[r],Q[r]=i}}e.$Xb=ge;function he(Q,g){const k=Q.indexOf(g);k>-1&&(Q.splice(k,1),Q.unshift(g))}e.$Yb=he;function ie(Q,g){const k=Q.indexOf(g);k>-1&&(Q.splice(k,1),Q.push(g))}e.$Zb=ie;function fe(Q,g){for(const k of g)Q.push(k)}e.$1b=fe;function Re(Q,g){return Array.isArray(Q)?Q.map(g):g(Q)}e.$2b=Re;function Ne(Q){return Array.isArray(Q)?Q:[Q]}e.$3b=Ne;function Be(Q){return Q[Math.floor(Math.random()*Q.length)]}e.$4b=Be;function se(Q,g,k){const F=ae(Q,g),r=Q.length,i=k.length;Q.length=r+i;for(let o=r-1;o>=F;o--)Q[o+i]=Q[o];for(let o=0;o<i;o++)Q[o+F]=k[o]}e.$5b=se;function J(Q,g,k,F){const r=ae(Q,g);let i=Q.splice(r,k);return i===void 0&&(i=[]),se(Q,r,F),i}e.$6b=J;function ae(Q,g){return g<0?Math.max(g+Q.length,0):Math.min(g,Q.length)}var re;(function(Q){function g(i){return i<0}Q.isLessThan=g;function k(i){return i<=0}Q.isLessThanOrEqual=k;function F(i){return i>0}Q.isGreaterThan=F;function r(i){return i===0}Q.isNeitherLessOrGreaterThan=r,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function X(Q,g){return(k,F)=>g(Q(k),Q(F))}e.$7b=X;function x(...Q){return(g,k)=>{for(const F of Q){const r=F(g,k);if(!re.isNeitherLessOrGreaterThan(r))return r}return re.neitherLessOrGreaterThan}}e.$8b=x;const te=(Q,g)=>Q-g;e.$9b=te;const ce=(Q,g)=>(0,e.$9b)(Q?1:0,g?1:0);e.$0b=ce;function ye(Q){return(g,k)=>-Q(g,k)}e.$$b=ye;class Te{constructor(g){this.g=g,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(g){let k=this.c;for(;k<this.g.length&&g(this.g[k]);)k++;const F=k===this.c?null:this.g.slice(this.c,k);return this.c=k,F}takeFromEndWhile(g){let k=this.d;for(;k>=0&&g(this.g[k]);)k--;const F=k===this.d?null:this.g.slice(k+1,this.d+1);return this.d=k,F}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const g=this.g[this.c];return this.c++,g}removeLast(){const g=this.g[this.d];return this.d--,g}takeCount(g){const k=this.g.slice(this.c,this.c+g);return this.c+=g,k}}e.$_b=Te;class Ae{static{this.empty=new Ae(g=>{})}constructor(g){this.iterate=g}forEach(g){this.iterate(k=>(g(k),!0))}toArray(){const g=[];return this.iterate(k=>(g.push(k),!0)),g}filter(g){return new Ae(k=>this.iterate(F=>g(F)?k(F):!0))}map(g){return new Ae(k=>this.iterate(F=>k(g(F))))}some(g){let k=!1;return this.iterate(F=>(k=g(F),!k)),k}findFirst(g){let k;return this.iterate(F=>g(F)?(k=F,!1):!0),k}findLast(g){let k;return this.iterate(F=>(g(F)&&(k=F),!0)),k}findLastMaxBy(g){let k,F=!0;return this.iterate(r=>((F||re.isGreaterThan(g(r,k)))&&(F=!1,k=r),!0)),k}}e.$ac=Ae}),define($e[76],pe([1,0,6]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function C(p,v){if(!p)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=C;function n(p,v="Unreachable"){throw new Error(v)}e.$6c=n;function U(p){if(!p)throw new A.$cb("Assertion Failed")}e.$7c=U;function D(p){p||(0,A.$1)(new A.$cb("Assertion Failed"))}e.$8c=D;function S(p){if(!p()){debugger;p(),(0,A.$1)(new A.$cb("Assertion Failed"))}}e.$9c=S;function m(p,v){let I=0;for(;I<p.length-1;){const a=p[I],h=p[I+1];if(!v(a,h))return!1;I++}return!0}e.$0c=m}),define($e[44],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function A(C,n){const U=this;let D=!1,S;return function(){if(D)return S;if(D=!0,n)try{S=C.apply(U,arguments)}finally{n()}else S=C.apply(U,arguments);return S}}e.$db=A}),define($e[77],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=void 0;class A{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}e.$uN=A,e.$vN=new A("id#")}),define($e[28],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(C){function n(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}C.is=n;const U=Object.freeze([]);function D(){return U}C.empty=D;function*S(u){yield u}C.single=S;function m(u){return n(u)?u:S(u)}C.wrap=m;function p(u){return u||U}C.from=p;function*v(u){for(let N=u.length-1;N>=0;N--)yield u[N]}C.reverse=v;function I(u){return!u||u[Symbol.iterator]().next().done===!0}C.isEmpty=I;function a(u){return u[Symbol.iterator]().next().value}C.first=a;function h(u,N){for(const B of u)if(N(B))return!0;return!1}C.some=h;function t(u,N){for(const B of u)if(N(B))return B}C.find=t;function*s(u,N){for(const B of u)N(B)&&(yield B)}C.filter=s;function*d(u,N){let B=0;for(const P of u)yield N(P,B++)}C.map=d;function*c(...u){for(const N of u)yield*N}C.concat=c;function l(u,N,B){let P=B;for(const W of u)P=N(P,W);return P}C.reduce=l;function*$(u,N,B=u.length){for(N<0&&(N+=u.length),B<0?B+=u.length:B>u.length&&(B=u.length);N<B;N++)yield u[N]}C.slice=$;function f(u,N=Number.POSITIVE_INFINITY){const B=[];if(N===0)return[B,u];const P=u[Symbol.iterator]();for(let W=0;W<N;W++){const z=P.next();if(z.done)return[B,C.empty()];B.push(z.value)}return[B,{[Symbol.iterator](){return P}}]}C.consume=f;async function b(u){const N=[];for await(const B of u)N.push(B);return Promise.resolve(N)}C.asyncToArray=b})(A||(e.Iterable=A={}))}),define($e[45],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.KeyMod=e.KeyCodeUtils=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=e.ScanCode=e.KeyCode=void 0;var A;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(A||(e.KeyCode=A={}));var C;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(C||(e.ScanCode=C={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,d){this._keyCodeToStr[s]=d,this._strToKeyCode[d.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const U=new n,D=new n,S=new n;e.$4q=new Array(230),e.$5q={};const m=[],p=Object.create(null),v=Object.create(null);e.$6q={lowerCaseToEnum:t=>v[t]||0,toEnum:t=>p[t]||0,toString:t=>m[t]||"None"},e.$7q=[],e.$8q=[];for(let t=0;t<=193;t++)e.$7q[t]=-1;for(let t=0;t<=132;t++)e.$8q[t]=-1;(function(){const t="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[1,1,"Hyper",0,t,0,t,t,t],[1,2,"Super",0,t,0,t,t,t],[1,3,"Fn",0,t,0,t,t,t],[1,4,"FnLock",0,t,0,t,t,t],[1,5,"Suspend",0,t,0,t,t,t],[1,6,"Resume",0,t,0,t,t,t],[1,7,"Turbo",0,t,0,t,t,t],[1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[1,9,"WakeUp",0,t,0,t,t,t],[0,10,"KeyA",31,"A",65,"VK_A",t,t],[0,11,"KeyB",32,"B",66,"VK_B",t,t],[0,12,"KeyC",33,"C",67,"VK_C",t,t],[0,13,"KeyD",34,"D",68,"VK_D",t,t],[0,14,"KeyE",35,"E",69,"VK_E",t,t],[0,15,"KeyF",36,"F",70,"VK_F",t,t],[0,16,"KeyG",37,"G",71,"VK_G",t,t],[0,17,"KeyH",38,"H",72,"VK_H",t,t],[0,18,"KeyI",39,"I",73,"VK_I",t,t],[0,19,"KeyJ",40,"J",74,"VK_J",t,t],[0,20,"KeyK",41,"K",75,"VK_K",t,t],[0,21,"KeyL",42,"L",76,"VK_L",t,t],[0,22,"KeyM",43,"M",77,"VK_M",t,t],[0,23,"KeyN",44,"N",78,"VK_N",t,t],[0,24,"KeyO",45,"O",79,"VK_O",t,t],[0,25,"KeyP",46,"P",80,"VK_P",t,t],[0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[0,27,"KeyR",48,"R",82,"VK_R",t,t],[0,28,"KeyS",49,"S",83,"VK_S",t,t],[0,29,"KeyT",50,"T",84,"VK_T",t,t],[0,30,"KeyU",51,"U",85,"VK_U",t,t],[0,31,"KeyV",52,"V",86,"VK_V",t,t],[0,32,"KeyW",53,"W",87,"VK_W",t,t],[0,33,"KeyX",54,"X",88,"VK_X",t,t],[0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[0,36,"Digit1",22,"1",49,"VK_1",t,t],[0,37,"Digit2",23,"2",50,"VK_2",t,t],[0,38,"Digit3",24,"3",51,"VK_3",t,t],[0,39,"Digit4",25,"4",52,"VK_4",t,t],[0,40,"Digit5",26,"5",53,"VK_5",t,t],[0,41,"Digit6",27,"6",54,"VK_6",t,t],[0,42,"Digit7",28,"7",55,"VK_7",t,t],[0,43,"Digit8",29,"8",56,"VK_8",t,t],[0,44,"Digit9",30,"9",57,"VK_9",t,t],[0,45,"Digit0",21,"0",48,"VK_0",t,t],[1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,t,0,t,t,t],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[1,64,"F1",59,"F1",112,"VK_F1",t,t],[1,65,"F2",60,"F2",113,"VK_F2",t,t],[1,66,"F3",61,"F3",114,"VK_F3",t,t],[1,67,"F4",62,"F4",115,"VK_F4",t,t],[1,68,"F5",63,"F5",116,"VK_F5",t,t],[1,69,"F6",64,"F6",117,"VK_F6",t,t],[1,70,"F7",65,"F7",118,"VK_F7",t,t],[1,71,"F8",66,"F8",119,"VK_F8",t,t],[1,72,"F9",67,"F9",120,"VK_F9",t,t],[1,73,"F10",68,"F10",121,"VK_F10",t,t],[1,74,"F11",69,"F11",122,"VK_F11",t,t],[1,75,"F12",70,"F12",123,"VK_F12",t,t],[1,76,"PrintScreen",0,t,0,t,t,t],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",t,t],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[1,80,"Home",14,"Home",36,"VK_HOME",t,t],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[1,83,"End",13,"End",35,"VK_END",t,t],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",t,t],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",t,t],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",t,t],[1,94,"NumpadEnter",3,t,0,t,t,t],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",t,t],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",t,t],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",t,t],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",t,t],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",t,t],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",t,t],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",t,t],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",t,t],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",t,t],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",t,t],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",t,t],[1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[1,108,"Power",0,t,0,t,t,t],[1,109,"NumpadEqual",0,t,0,t,t,t],[1,110,"F13",71,"F13",124,"VK_F13",t,t],[1,111,"F14",72,"F14",125,"VK_F14",t,t],[1,112,"F15",73,"F15",126,"VK_F15",t,t],[1,113,"F16",74,"F16",127,"VK_F16",t,t],[1,114,"F17",75,"F17",128,"VK_F17",t,t],[1,115,"F18",76,"F18",129,"VK_F18",t,t],[1,116,"F19",77,"F19",130,"VK_F19",t,t],[1,117,"F20",78,"F20",131,"VK_F20",t,t],[1,118,"F21",79,"F21",132,"VK_F21",t,t],[1,119,"F22",80,"F22",133,"VK_F22",t,t],[1,120,"F23",81,"F23",134,"VK_F23",t,t],[1,121,"F24",82,"F24",135,"VK_F24",t,t],[1,122,"Open",0,t,0,t,t,t],[1,123,"Help",0,t,0,t,t,t],[1,124,"Select",0,t,0,t,t,t],[1,125,"Again",0,t,0,t,t,t],[1,126,"Undo",0,t,0,t,t,t],[1,127,"Cut",0,t,0,t,t,t],[1,128,"Copy",0,t,0,t,t,t],[1,129,"Paste",0,t,0,t,t,t],[1,130,"Find",0,t,0,t,t,t],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",t,t],[1,136,"KanaMode",0,t,0,t,t,t],[0,137,"IntlYen",0,t,0,t,t,t],[1,138,"Convert",0,t,0,t,t,t],[1,139,"NonConvert",0,t,0,t,t,t],[1,140,"Lang1",0,t,0,t,t,t],[1,141,"Lang2",0,t,0,t,t,t],[1,142,"Lang3",0,t,0,t,t,t],[1,143,"Lang4",0,t,0,t,t,t],[1,144,"Lang5",0,t,0,t,t,t],[1,145,"Abort",0,t,0,t,t,t],[1,146,"Props",0,t,0,t,t,t],[1,147,"NumpadParenLeft",0,t,0,t,t,t],[1,148,"NumpadParenRight",0,t,0,t,t,t],[1,149,"NumpadBackspace",0,t,0,t,t,t],[1,150,"NumpadMemoryStore",0,t,0,t,t,t],[1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[1,152,"NumpadMemoryClear",0,t,0,t,t,t],[1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",t,t],[1,156,"NumpadClearEntry",0,t,0,t,t,t],[1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[1,0,t,6,"Alt",18,"VK_MENU",t,t],[1,0,t,57,"Meta",91,"VK_COMMAND",t,t],[1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[1,165,"BrightnessUp",0,t,0,t,t,t],[1,166,"BrightnessDown",0,t,0,t,t,t],[1,167,"MediaPlay",0,t,0,t,t,t],[1,168,"MediaRecord",0,t,0,t,t,t],[1,169,"MediaFastForward",0,t,0,t,t,t],[1,170,"MediaRewind",0,t,0,t,t,t],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",t,t],[1,174,"Eject",0,t,0,t,t,t],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[1,180,"SelectTask",0,t,0,t,t,t],[1,181,"LaunchScreenSaver",0,t,0,t,t,t],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[1,189,"ZoomToggle",0,t,0,t,t,t],[1,190,"MailReply",0,t,0,t,t,t],[1,191,"MailForward",0,t,0,t,t,t],[1,192,"MailSend",0,t,0,t,t,t],[1,0,t,114,"KeyInComposition",229,t,t,t],[1,0,t,116,"ABNT_C2",194,"VK_ABNT_C2",t,t],[1,0,t,96,"OEM_8",223,"VK_OEM_8",t,t],[1,0,t,0,t,0,"VK_KANA",t,t],[1,0,t,0,t,0,"VK_HANGUL",t,t],[1,0,t,0,t,0,"VK_JUNJA",t,t],[1,0,t,0,t,0,"VK_FINAL",t,t],[1,0,t,0,t,0,"VK_HANJA",t,t],[1,0,t,0,t,0,"VK_KANJI",t,t],[1,0,t,0,t,0,"VK_CONVERT",t,t],[1,0,t,0,t,0,"VK_NONCONVERT",t,t],[1,0,t,0,t,0,"VK_ACCEPT",t,t],[1,0,t,0,t,0,"VK_MODECHANGE",t,t],[1,0,t,0,t,0,"VK_SELECT",t,t],[1,0,t,0,t,0,"VK_PRINT",t,t],[1,0,t,0,t,0,"VK_EXECUTE",t,t],[1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[1,0,t,0,t,0,"VK_HELP",t,t],[1,0,t,0,t,0,"VK_APPS",t,t],[1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[1,0,t,0,t,0,"VK_PACKET",t,t],[1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[1,0,t,0,t,0,"VK_ATTN",t,t],[1,0,t,0,t,0,"VK_CRSEL",t,t],[1,0,t,0,t,0,"VK_EXSEL",t,t],[1,0,t,0,t,0,"VK_EREOF",t,t],[1,0,t,0,t,0,"VK_PLAY",t,t],[1,0,t,0,t,0,"VK_ZOOM",t,t],[1,0,t,0,t,0,"VK_NONAME",t,t],[1,0,t,0,t,0,"VK_PA1",t,t],[1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],d=[],c=[];for(const l of s){const[$,f,b,u,N,B,P,W,z]=l;if(c[f]||(c[f]=!0,m[f]=b,p[b]=f,v[b.toLowerCase()]=f,$&&(e.$7q[f]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(e.$8q[u]=f))),!d[u]){if(d[u]=!0,!N)throw new Error(`String representation missing for key code ${u} around scan code ${b}`);U.define(u,N),D.define(u,W||N),S.define(u,z||W||N)}B&&(e.$4q[B]=u),P&&(e.$5q[P]=u)}e.$8q[3]=46})();var I;(function(t){function s(b){return U.keyCodeToStr(b)}t.toString=s;function d(b){return U.strToKeyCode(b)}t.fromString=d;function c(b){return D.keyCodeToStr(b)}t.toUserSettingsUS=c;function l(b){return S.keyCodeToStr(b)}t.toUserSettingsGeneral=l;function $(b){return D.strToKeyCode(b)||S.strToKeyCode(b)}t.fromUserSettings=$;function f(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(b)}t.toElectronAccelerator=f})(I||(e.KeyCodeUtils=I={}));var a;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(a||(e.KeyMod=a={}));function h(t,s){const d=(s&65535)<<16>>>0;return(t|d)>>>0}e.$9q=h}),define($e[78],pe([1,0,6]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.$ar=e.$_q=e.$$q=e.$0q=void 0;var C;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(C||(C={}));function n(I,a){if(typeof I=="number"){if(I===0)return null;const h=(I&65535)>>>0,t=(I&4294901760)>>>16;return t!==0?new m([U(h,a),U(t,a)]):new m([U(h,a)])}else{const h=[];for(let t=0;t<I.length;t++)h.push(U(I[t],a));return new m(h)}}e.$0q=n;function U(I,a){const h=!!(I&2048),t=!!(I&256),s=a===2?t:h,d=!!(I&1024),c=!!(I&512),l=a===2?h:t,$=I&255;return new D(s,d,c,l,$)}e.$$q=U;class D{constructor(a,h,t,s,d){this.ctrlKey=a,this.shiftKey=h,this.altKey=t,this.metaKey=s,this.keyCode=d}equals(a){return a instanceof D&&this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.keyCode===a.keyCode}getHashCode(){const a=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${a}${h}${t}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.$_q=D;class S{constructor(a,h,t,s,d){this.ctrlKey=a,this.shiftKey=h,this.altKey=t,this.metaKey=s,this.scanCode=d}equals(a){return a instanceof S&&this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.scanCode===a.scanCode}getHashCode(){const a=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${a}${h}${t}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.$ar=S;class m{constructor(a){if(a.length===0)throw(0,A.$7)("chords");this.chords=a}getHashCode(){let a="";for(let h=0,t=this.chords.length;h<t;h++)h!==0&&(a+=";"),a+=this.chords[h].getHashCode();return a}equals(a){if(a===null||this.chords.length!==a.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(a.chords[h]))return!1;return!0}}e.$br=m;class p{constructor(a,h,t,s,d,c){this.ctrlKey=a,this.shiftKey=h,this.altKey=t,this.metaKey=s,this.keyLabel=d,this.keyAriaLabel=c}}e.$cr=p;class v{}e.$dr=v}),define($e[23],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class A{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=A}),define($e[46],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class A{static{this.Undefined=new A(void 0)}constructor(U){this.element=U,this.next=A.Undefined,this.prev=A.Undefined}}class C{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let U=this.a;for(;U!==A.Undefined;){const D=U.next;U.prev=A.Undefined,U.next=A.Undefined,U=D}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,D){const S=new A(U);if(this.a===A.Undefined)this.a=S,this.b=S;else if(D){const p=this.b;this.b=S,S.prev=p,p.next=S}else{const p=this.a;this.a=S,S.next=p,p.prev=S}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(S))}}shift(){if(this.a!==A.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==A.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==A.Undefined&&U.next!==A.Undefined){const D=U.prev;D.next=U.next,U.next.prev=D}else U.prev===A.Undefined&&U.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):U.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):U.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==A.Undefined;)yield U.element,U=U.next}}e.$4c=C}),define($e[32],pe([1,0]),function(ne,e){"use strict";var A,C,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function U($,f,b){let u=$.get(f);return u===void 0&&(u=b,$.set(f,u)),u}e.$xc=U;function D($){const f=[];return $.forEach((b,u)=>{f.push(`${u} => ${b}`)}),`Map(${$.size}) {${f.join(", ")}}`}e.$yc=D;function S($){const f=[];return $.forEach(b=>{f.push(b)}),`Set(${$.size}) {${f.join(", ")}}`}e.$zc=S;class m{constructor(f,b){this.uri=f,this.value=b}}function p($){return Array.isArray($)}class v{static{this.c=f=>f.toString()}constructor(f,b){if(this[A]="ResourceMap",f instanceof v)this.d=new Map(f.d),this.e=b??v.c;else if(p(f)){this.d=new Map,this.e=b??v.c;for(const[u,N]of f)this.set(u,N)}else this.d=new Map,this.e=f??v.c}set(f,b){return this.d.set(this.e(f),new m(f,b)),this}get(f){return this.d.get(this.e(f))?.value}has(f){return this.d.has(this.e(f))}get size(){return this.d.size}clear(){this.d.clear()}delete(f){return this.d.delete(this.e(f))}forEach(f,b){typeof b<"u"&&(f=f.bind(b));for(const[u,N]of this.d)f(N.value,N.uri,this)}*values(){for(const f of this.d.values())yield f.value}*keys(){for(const f of this.d.values())yield f.uri}*entries(){for(const f of this.d.values())yield[f.uri,f.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.d)yield[f.uri,f.value]}}e.$Ac=v;class I{constructor(f,b){this[C]="ResourceSet",!f||typeof f=="function"?this.c=new v(f):(this.c=new v(b),f.forEach(this.add,this))}get size(){return this.c.size}add(f){return this.c.set(f,f),this}clear(){this.c.clear()}delete(f){return this.c.delete(f)}forEach(f,b){this.c.forEach((u,N)=>f.call(b,N,N,this))}has(f){return this.c.has(f)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var a;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(a||(e.Touch=a={}));class h{constructor(){this[n]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(f){return this.c.has(f)}get(f,b=0){const u=this.c.get(f);if(u)return b!==0&&this.l(u,b),u.value}set(f,b,u=0){let N=this.c.get(f);if(N)N.value=b,u!==0&&this.l(N,u);else{switch(N={key:f,value:b,next:void 0,previous:void 0},u){case 0:this.j(N);break;case 1:this.i(N);break;case 2:this.j(N);break;default:this.j(N);break}this.c.set(f,N),this.f++}return this}delete(f){return!!this.remove(f)}remove(f){const b=this.c.get(f);if(b)return this.c.delete(f),this.k(b),this.f--,b.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const f=this.d;return this.c.delete(f.key),this.k(f),this.f--,f.value}forEach(f,b){const u=this.g;let N=this.d;for(;N;){if(b?f.bind(b)(N.value,N.key,this):f(N.value,N.key,this),this.g!==u)throw new Error("LinkedMap got modified during iteration.");N=N.next}}keys(){const f=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(f.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:u.key,done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}values(){const f=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(f.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:u.value,done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}entries(){const f=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(f.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:[u.key,u.value],done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(f){if(f>=this.size)return;if(f===0){this.clear();return}let b=this.d,u=this.size;for(;b&&u>f;)this.c.delete(b.key),b=b.next,u--;this.d=b,this.f=u,b&&(b.previous=void 0),this.g++}i(f){if(!this.d&&!this.e)this.e=f;else if(this.d)f.next=this.d,this.d.previous=f;else throw new Error("Invalid list");this.d=f,this.g++}j(f){if(!this.d&&!this.e)this.d=f;else if(this.e)f.previous=this.e,this.e.next=f;else throw new Error("Invalid list");this.e=f,this.g++}k(f){if(f===this.d&&f===this.e)this.d=void 0,this.e=void 0;else if(f===this.d){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.d=f.next}else if(f===this.e){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.e=f.previous}else{const b=f.next,u=f.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}f.next=void 0,f.previous=void 0,this.g++}l(f,b){if(!this.d||!this.e)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(f===this.d)return;const u=f.next,N=f.previous;f===this.e?(N.next=void 0,this.e=N):(u.previous=N,N.next=u),f.previous=void 0,f.next=this.d,this.d.previous=f,this.d=f,this.g++}else if(b===2){if(f===this.e)return;const u=f.next,N=f.previous;f===this.d?(u.previous=void 0,this.d=u):(u.previous=N,N.next=u),f.next=void 0,f.previous=this.e,this.e.next=f,this.e=f,this.g++}}}toJSON(){const f=[];return this.forEach((b,u)=>{f.push([u,b])}),f}fromJSON(f){this.clear();for(const[b,u]of f)this.set(b,u)}}e.$Cc=h;class t extends h{constructor(f,b=1){super(),this.m=f,this.n=Math.min(Math.max(0,b),1)}get limit(){return this.m}set limit(f){this.m=f,this.o()}get ratio(){return this.n}set ratio(f){this.n=Math.min(Math.max(0,f),1),this.o()}get(f,b=2){return super.get(f,b)}peek(f){return super.get(f,0)}set(f,b){return super.set(f,b,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=t;class s{constructor(){this.c=new Map}add(f){return this.c.set(f,(this.c.get(f)||0)+1),this}delete(f){let b=this.c.get(f)||0;return b===0?!1:(b--,b===0?this.c.delete(f):this.c.set(f,b),!0)}has(f){return this.c.has(f)}}e.$Ec=s;class d{constructor(f){if(this.c=new Map,this.d=new Map,f)for(const[b,u]of f)this.set(b,u)}clear(){this.c.clear(),this.d.clear()}set(f,b){this.c.set(f,b),this.d.set(b,f)}get(f){return this.c.get(f)}getKey(f){return this.d.get(f)}delete(f){const b=this.c.get(f);return b===void 0?!1:(this.c.delete(f),this.d.delete(b),!0)}forEach(f,b){this.c.forEach((u,N)=>{f.call(b,u,N,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=d;class c{constructor(){this.c=new Map}add(f,b){let u=this.c.get(f);u||(u=new Set,this.c.set(f,u)),u.add(b)}delete(f,b){const u=this.c.get(f);u&&(u.delete(b),u.size===0&&this.c.delete(f))}forEach(f,b){const u=this.c.get(f);u&&u.forEach(b)}get(f){const b=this.c.get(f);return b||new Set}}e.$Gc=c;function l($,f){if($===f)return!0;if($.size!==f.size)return!1;for(const[b,u]of $)if(!f.has(b)||f.get(b)!==u)return!1;for(const[b]of f)if(!$.has(b))return!1;return!0}e.$Hc=l}),define($e[3],pe([1,0,12,73,32,44,28]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const S=!1;let m=null;class p{constructor(){this.b=new Map}static{this.a=0}c(L){let G=this.b.get(L);return G||(G={parent:null,source:null,isSingleton:!1,value:L,idx:p.a++},this.b.set(L,G)),G}trackDisposable(L){const G=this.c(L);G.source||(G.source=new Error().stack)}setParent(L,G){const Z=this.c(L);Z.parent=G}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,G){const Z=G.get(L);if(Z)return Z;const ge=L.parent?this.f(this.c(L.parent),G):L;return G.set(L,ge),ge}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,L).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(L=10,G){let Z;if(G)Z=G;else{const Re=new Map,Ne=[...this.b.values()].filter(se=>se.source!==null&&!this.f(se,Re).isSingleton);if(Ne.length===0)return;const Be=new Set(Ne.map(se=>se.value));if(Z=Ne.filter(se=>!(se.parent&&Be.has(se.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function ge(Re){function Ne(se,J){for(;se.length>0&&J.some(ae=>typeof ae=="string"?ae===se[0]:se[0].match(ae));)se.shift()}const Be=Re.source.split(`
`).map(se=>se.trim().replace("at ","")).filter(se=>se!=="");return Ne(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const he=new n.$Gc;for(const Re of Z){const Ne=ge(Re);for(let Be=0;Be<=Ne.length;Be++)he.add(Ne.slice(0,Be).join(`
`),Re)}Z.sort((0,A.$7b)(Re=>Re.idx,A.$9b));let ie="",fe=0;for(const Re of Z.slice(0,L)){fe++;const Ne=ge(Re),Be=[];for(let se=0;se<Ne.length;se++){let J=Ne[se];J=`(shared with ${he.get(Ne.slice(0,se+1).join(`
`)).size}/${Z.length} leaks) at ${J}`;const re=he.get(Ne.slice(0,se).join(`
`)),X=(0,C.$K)([...re].map(x=>ge(x)[se]),x=>x);delete X[Ne[se]];for(const[x,te]of Object.entries(X))Be.unshift(`    - stacktraces of ${te.length} other leaks continue with ${x}`);Be.unshift(J)}ie+=`


==================== Leaking disposable ${fe}/${Z.length}: ${Re.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return Z.length>L&&(ie+=`


... and ${Z.length-L} more leaking disposables

`),{leaks:Z,details:ie}}}e.$Ic=p;function v(R){m=R}if(e.$Jc=v,S){const R="__is_disposable_tracked__";v(new class{trackDisposable(L){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[R]||console.log(G)},3e3)}setParent(L,G){if(L&&L!==u.None)try{L[R]=!0}catch{}}markAsDisposed(L){if(L&&L!==u.None)try{L[R]=!0}catch{}}markAsSingleton(L){}})}function I(R){return m?.trackDisposable(R),R}e.$Kc=I;function a(R){m?.markAsDisposed(R)}e.$Lc=a;function h(R,L){m?.setParent(R,L)}function t(R,L){if(m)for(const G of R)m.setParent(G,L)}function s(R){return m?.markAsSingleton(R),R}e.$Mc=s;function d(R){return typeof R.dispose=="function"&&R.dispose.length===0}e.$Nc=d;function c(R){if(D.Iterable.is(R)){const L=[];for(const G of R)if(G)try{G.dispose()}catch(Z){L.push(Z)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}e.$Oc=c;function l(R){for(const L of R)d(L)&&L.dispose();return[]}e.$Pc=l;function $(...R){const L=f(()=>c(R));return t(R,L),L}e.$Qc=$;function f(R){const L=I({dispose:(0,U.$db)(()=>{a(L),R()})});return L}e.$Rc=f;class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(a(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return h(L,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),h(L,null))}}e.$Sc=b;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,I(this),h(this.q,this)}dispose(){a(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Tc=u;class N{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&h(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,a(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&h(L,null),L}}e.$Uc=N;class B{constructor(L){this.a=new N,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=B;class P{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=P;class W{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(L){let G=L;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,a(this))},this}}e.$Xc=W;class z{constructor(){this.a=new Map}acquire(L,...G){let Z=this.a.get(L);Z||(Z={counter:0,object:this.b(L,...G)},this.a.set(L,Z));const{object:ge}=Z,he=(0,U.$db)(()=>{--Z.counter===0&&(this.c(L,Z.object),this.a.delete(L))});return Z.counter++,{object:ge,dispose:he}}}e.$Yc=z;class y{constructor(L){this.a=L}async acquire(L,...G){const Z=this.a.acquire(L,...G);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(ge){throw Z.dispose(),ge}}}e.$Zc=y;class O{constructor(L){this.object=L}dispose(){}}e.$1c=O;function H(R){const L=new b;try{R(L)}finally{L.dispose()}}e.$2c=H;class E{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){a(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,G,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(L)?.dispose(),this.a.set(L,G)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),function(ne,e){typeof define=="function"&&define.amd?define($e[79],pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(g,k){for(var F=0;F<k.length;F++){var r=k[F];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(g,r.key,r)}}function A(g,k,F){return k&&e(g.prototype,k),F&&e(g,F),Object.defineProperty(g,"prototype",{writable:!1}),g}function C(g,k){if(g){if(typeof g=="string")return n(g,k);var F=Object.prototype.toString.call(g).slice(8,-1);if(F==="Object"&&g.constructor&&(F=g.constructor.name),F==="Map"||F==="Set")return Array.from(g);if(F==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(F))return n(g,k)}}function n(g,k){(k==null||k>g.length)&&(k=g.length);for(var F=0,r=new Array(k);F<k;F++)r[F]=g[F];return r}function U(g,k){var F=typeof Symbol<"u"&&g[Symbol.iterator]||g["@@iterator"];if(F)return(F=F.call(g)).next.bind(F);if(Array.isArray(g)||(F=C(g))||k&&g&&typeof g.length=="number"){F&&(g=F);var r=0;return function(){return r>=g.length?{done:!0}:{done:!1,value:g[r++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=D();function S(g){ne.defaults=g}var m=/[&<>"']/,p=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(k){return a[k]};function t(g,k){if(k){if(m.test(g))return g.replace(p,h)}else if(v.test(g))return g.replace(I,h);return g}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(g){return g.replace(s,function(k,F){return F=F.toLowerCase(),F==="colon"?":":F.charAt(0)==="#"?F.charAt(1)==="x"?String.fromCharCode(parseInt(F.substring(2),16)):String.fromCharCode(+F.substring(1)):""})}var c=/(^|[^\[])\^/g;function l(g,k){g=typeof g=="string"?g:g.source,k=k||"";var F={replace:function(i,o){return o=o.source||o,o=o.replace(c,"$1"),g=g.replace(i,o),F},getRegex:function(){return new RegExp(g,k)}};return F}var $=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(g,k,F){if(g){var r;try{r=decodeURIComponent(d(F)).replace($,"").toLowerCase()}catch{return null}if(r.indexOf("javascript:")===0||r.indexOf("vbscript:")===0||r.indexOf("data:")===0)return null}k&&!f.test(F)&&(F=W(k,F));try{F=encodeURI(F).replace(/%25/g,"%")}catch{return null}return F}var u={},N=/^[^:]+:\/*[^/]*$/,B=/^([^:]+:)[\s\S]*$/,P=/^([^:]+:\/*[^/]*)[\s\S]*$/;function W(g,k){u[" "+g]||(N.test(g)?u[" "+g]=g+"/":u[" "+g]=H(g,"/",!0)),g=u[" "+g];var F=g.indexOf(":")===-1;return k.substring(0,2)==="//"?F?k:g.replace(B,"$1")+k:k.charAt(0)==="/"?F?k:g.replace(P,"$1")+k:g+k}var z={exec:function(){}};function y(g){for(var k=1,F,r;k<arguments.length;k++){F=arguments[k];for(r in F)Object.prototype.hasOwnProperty.call(F,r)&&(g[r]=F[r])}return g}function O(g,k){var F=g.replace(/\|/g,function(o,w,M){for(var T=!1,j=w;--j>=0&&M[j]==="\\";)T=!T;return T?"|":" |"}),r=F.split(/ \|/),i=0;if(r[0].trim()||r.shift(),r.length>0&&!r[r.length-1].trim()&&r.pop(),r.length>k)r.splice(k);else for(;r.length<k;)r.push("");for(;i<r.length;i++)r[i]=r[i].trim().replace(/\\\|/g,"|");return r}function H(g,k,F){var r=g.length;if(r===0)return"";for(var i=0;i<r;){var o=g.charAt(r-i-1);if(o===k&&!F)i++;else if(o!==k&&F)i++;else break}return g.slice(0,r-i)}function E(g,k){if(g.indexOf(k[1])===-1)return-1;for(var F=g.length,r=0,i=0;i<F;i++)if(g[i]==="\\")i++;else if(g[i]===k[0])r++;else if(g[i]===k[1]&&(r--,r<0))return i;return-1}function R(g){g&&g.sanitize&&!g.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(g,k){if(k<1)return"";for(var F="";k>1;)k&1&&(F+=g),k>>=1,g+=g;return F+g}function G(g,k,F,r){var i=k.href,o=k.title?t(k.title):null,w=g[1].replace(/\\([\[\]])/g,"$1");if(g[0].charAt(0)!=="!"){r.state.inLink=!0;var M={type:"link",raw:F,href:i,title:o,text:w,tokens:r.inlineTokens(w)};return r.state.inLink=!1,M}return{type:"image",raw:F,href:i,title:o,text:t(w)}}function Z(g,k){var F=g.match(/^(\s+)(?:```)/);if(F===null)return k;var r=F[1];return k.split(`
`).map(function(i){var o=i.match(/^\s+/);if(o===null)return i;var w=o[0];return w.length>=r.length?i.slice(r.length):i}).join(`
`)}var ge=function(){function g(F){this.options=F||ne.defaults}var k=g.prototype;return k.space=function(r){var i=this.rules.block.newline.exec(r);if(i&&i[0].length>0)return{type:"space",raw:i[0]}},k.code=function(r){var i=this.rules.block.code.exec(r);if(i){var o=i[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:i[0],codeBlockStyle:"indented",text:this.options.pedantic?o:H(o,`
`)}}},k.fences=function(r){var i=this.rules.block.fences.exec(r);if(i){var o=i[0],w=Z(o,i[3]||"");return{type:"code",raw:o,lang:i[2]?i[2].trim():i[2],text:w}}},k.heading=function(r){var i=this.rules.block.heading.exec(r);if(i){var o=i[2].trim();if(/#$/.test(o)){var w=H(o,"#");(this.options.pedantic||!w||/ $/.test(w))&&(o=w.trim())}return{type:"heading",raw:i[0],depth:i[1].length,text:o,tokens:this.lexer.inline(o)}}},k.hr=function(r){var i=this.rules.block.hr.exec(r);if(i)return{type:"hr",raw:i[0]}},k.blockquote=function(r){var i=this.rules.block.blockquote.exec(r);if(i){var o=i[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:i[0],tokens:this.lexer.blockTokens(o,[]),text:o}}},k.list=function(r){var i=this.rules.block.list.exec(r);if(i){var o,w,M,T,j,_,Y,oe,be,De,we,Ee,ve=i[1].trim(),Pe=ve.length>1,Me={type:"list",raw:"",ordered:Pe,start:Pe?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Pe?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Pe?ve:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");r&&(Ee=!1,!(!(i=Ie.exec(r))||this.rules.block.hr.test(r)));){if(o=i[0],r=r.substring(o.length),oe=i[2].split(`
`,1)[0],be=r.split(`
`,1)[0],this.options.pedantic?(T=2,we=oe.trimLeft()):(T=i[2].search(/[^ ]/),T=T>4?1:T,we=oe.slice(T),T+=i[1].length),_=!1,!oe&&/^ *$/.test(be)&&(o+=be+`
`,r=r.substring(be.length+1),Ee=!0),!Ee)for(var Ye=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,T-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:```|~~~)"),K=new RegExp("^ {0,"+Math.min(3,T-1)+"}#");r&&(De=r.split(`
`,1)[0],oe=De,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test(oe)||K.test(oe)||Ye.test(oe)||et.test(r)));){if(oe.search(/[^ ]/)>=T||!oe.trim())we+=`
`+oe.slice(T);else if(!_)we+=`
`+oe;else break;!_&&!oe.trim()&&(_=!0),o+=De+`
`,r=r.substring(De.length+1)}Me.loose||(Y?Me.loose=!0:/\n *\n *$/.test(o)&&(Y=!0)),this.options.gfm&&(w=/^\[[ xX]\] /.exec(we),w&&(M=w[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Me.items.push({type:"list_item",raw:o,task:!!w,checked:M,loose:!1,text:we}),Me.raw+=o}Me.items[Me.items.length-1].raw=o.trimRight(),Me.items[Me.items.length-1].text=we.trimRight(),Me.raw=Me.raw.trimRight();var le=Me.items.length;for(j=0;j<le;j++){this.lexer.state.top=!1,Me.items[j].tokens=this.lexer.blockTokens(Me.items[j].text,[]);var me=Me.items[j].tokens.filter(function(Ce){return Ce.type==="space"}),ke=me.every(function(Ce){for(var je=Ce.raw.split(""),Qe=0,Ke=U(je),Je;!(Je=Ke()).done;){var tt=Je.value;if(tt===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Me.loose&&me.length&&ke&&(Me.loose=!0,Me.items[j].loose=!0)}return Me}},k.html=function(r){var i=this.rules.block.html.exec(r);if(i){var o={type:"html",raw:i[0],pre:!this.options.sanitizer&&(i[1]==="pre"||i[1]==="script"||i[1]==="style"),text:i[0]};if(this.options.sanitize){var w=this.options.sanitizer?this.options.sanitizer(i[0]):t(i[0]);o.type="paragraph",o.text=w,o.tokens=this.lexer.inline(w)}return o}},k.def=function(r){var i=this.rules.block.def.exec(r);if(i){i[3]&&(i[3]=i[3].substring(1,i[3].length-1));var o=i[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:o,raw:i[0],href:i[2],title:i[3]}}},k.table=function(r){var i=this.rules.block.table.exec(r);if(i){var o={type:"table",header:O(i[1]).map(function(Y){return{text:Y}}),align:i[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:i[3]&&i[3].trim()?i[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(o.header.length===o.align.length){o.raw=i[0];var w=o.align.length,M,T,j,_;for(M=0;M<w;M++)/^ *-+: *$/.test(o.align[M])?o.align[M]="right":/^ *:-+: *$/.test(o.align[M])?o.align[M]="center":/^ *:-+ *$/.test(o.align[M])?o.align[M]="left":o.align[M]=null;for(w=o.rows.length,M=0;M<w;M++)o.rows[M]=O(o.rows[M],o.header.length).map(function(Y){return{text:Y}});for(w=o.header.length,T=0;T<w;T++)o.header[T].tokens=this.lexer.inline(o.header[T].text);for(w=o.rows.length,T=0;T<w;T++)for(_=o.rows[T],j=0;j<_.length;j++)_[j].tokens=this.lexer.inline(_[j].text);return o}}},k.lheading=function(r){var i=this.rules.block.lheading.exec(r);if(i)return{type:"heading",raw:i[0],depth:i[2].charAt(0)==="="?1:2,text:i[1],tokens:this.lexer.inline(i[1])}},k.paragraph=function(r){var i=this.rules.block.paragraph.exec(r);if(i){var o=i[1].charAt(i[1].length-1)===`
`?i[1].slice(0,-1):i[1];return{type:"paragraph",raw:i[0],text:o,tokens:this.lexer.inline(o)}}},k.text=function(r){var i=this.rules.block.text.exec(r);if(i)return{type:"text",raw:i[0],text:i[0],tokens:this.lexer.inline(i[0])}},k.escape=function(r){var i=this.rules.inline.escape.exec(r);if(i)return{type:"escape",raw:i[0],text:t(i[1])}},k.tag=function(r){var i=this.rules.inline.tag.exec(r);if(i)return!this.lexer.state.inLink&&/^<a /i.test(i[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(i[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(i[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(i[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:i[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(i[0]):t(i[0]):i[0]}},k.link=function(r){var i=this.rules.inline.link.exec(r);if(i){var o=i[2].trim();if(!this.options.pedantic&&/^</.test(o)){if(!/>$/.test(o))return;var w=H(o.slice(0,-1),"\\");if((o.length-w.length)%2===0)return}else{var M=E(i[2],"()");if(M>-1){var T=i[0].indexOf("!")===0?5:4,j=T+i[1].length+M;i[2]=i[2].substring(0,M),i[0]=i[0].substring(0,j).trim(),i[3]=""}}var _=i[2],Y="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(_);oe&&(_=oe[1],Y=oe[3])}else Y=i[3]?i[3].slice(1,-1):"";return _=_.trim(),/^</.test(_)&&(this.options.pedantic&&!/>$/.test(o)?_=_.slice(1):_=_.slice(1,-1)),G(i,{href:_&&_.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},i[0],this.lexer)}},k.reflink=function(r,i){var o;if((o=this.rules.inline.reflink.exec(r))||(o=this.rules.inline.nolink.exec(r))){var w=(o[2]||o[1]).replace(/\s+/g," ");if(w=i[w.toLowerCase()],!w||!w.href){var M=o[0].charAt(0);return{type:"text",raw:M,text:M}}return G(o,w,o[0],this.lexer)}},k.emStrong=function(r,i,o){o===void 0&&(o="");var w=this.rules.inline.emStrong.lDelim.exec(r);if(w&&!(w[3]&&o.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var M=w[1]||w[2]||"";if(!M||M&&(o===""||this.rules.inline.punctuation.exec(o))){var T=w[0].length-1,j,_,Y=T,oe=0,be=w[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,i=i.slice(-1*r.length+T);(w=be.exec(i))!=null;)if(j=w[1]||w[2]||w[3]||w[4]||w[5]||w[6],!!j){if(_=j.length,w[3]||w[4]){Y+=_;continue}else if((w[5]||w[6])&&T%3&&!((T+_)%3)){oe+=_;continue}if(Y-=_,!(Y>0)){if(_=Math.min(_,_+Y+oe),Math.min(T,_)%2){var De=r.slice(1,T+w.index+_);return{type:"em",raw:r.slice(0,T+w.index+_+1),text:De,tokens:this.lexer.inlineTokens(De)}}var we=r.slice(2,T+w.index+_-1);return{type:"strong",raw:r.slice(0,T+w.index+_+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},k.codespan=function(r){var i=this.rules.inline.code.exec(r);if(i){var o=i[2].replace(/\n/g," "),w=/[^ ]/.test(o),M=/^ /.test(o)&&/ $/.test(o);return w&&M&&(o=o.substring(1,o.length-1)),o=t(o,!0),{type:"codespan",raw:i[0],text:o}}},k.br=function(r){var i=this.rules.inline.br.exec(r);if(i)return{type:"br",raw:i[0]}},k.del=function(r){var i=this.rules.inline.del.exec(r);if(i)return{type:"del",raw:i[0],text:i[2],tokens:this.lexer.inlineTokens(i[2])}},k.autolink=function(r,i){var o=this.rules.inline.autolink.exec(r);if(o){var w,M;return o[2]==="@"?(w=t(this.options.mangle?i(o[1]):o[1]),M="mailto:"+w):(w=t(o[1]),M=w),{type:"link",raw:o[0],text:w,href:M,tokens:[{type:"text",raw:w,text:w}]}}},k.url=function(r,i){var o;if(o=this.rules.inline.url.exec(r)){var w,M;if(o[2]==="@")w=t(this.options.mangle?i(o[0]):o[0]),M="mailto:"+w;else{var T;do T=o[0],o[0]=this.rules.inline._backpedal.exec(o[0])[0];while(T!==o[0]);w=t(o[0]),o[1]==="www."?M="http://"+w:M=w}return{type:"link",raw:o[0],text:w,href:M,tokens:[{type:"text",raw:w,text:w}]}}},k.inlineText=function(r,i){var o=this.rules.inline.text.exec(r);if(o){var w;return this.lexer.state.inRawBlock?w=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(o[0]):t(o[0]):o[0]:w=t(this.options.smartypants?i(o[0]):o[0]),{type:"text",raw:o[0],text:w}}},g}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=l(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=l(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=l(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=l(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=l(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=l(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=y({},he),he.gfm=y({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=l(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=l(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=y({},he.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:l(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=l(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=l(he._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=l(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=l(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=l(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=l(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=l(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=l(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=l(ie.reflink).replace("label",ie._label).replace("ref",he._label).getRegex(),ie.nolink=l(ie.nolink).replace("ref",he._label).getRegex(),ie.reflinkSearch=l(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=y({},ie),ie.pedantic=y({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=y({},ie.normal,{escape:l(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=l(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=y({},ie.gfm,{br:l(ie.br).replace("{2,}","*").getRegex(),text:l(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function fe(g){return g.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Re(g){var k="",F,r,i=g.length;for(F=0;F<i;F++)r=g.charCodeAt(F),Math.random()>.5&&(r="x"+r.toString(16)),k+="&#"+r+";";return k}var Ne=function(){function g(F){this.tokens=[],this.tokens.links=Object.create(null),this.options=F||ne.defaults,this.options.tokenizer=this.options.tokenizer||new ge,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var r={block:he.normal,inline:ie.normal};this.options.pedantic?(r.block=he.pedantic,r.inline=ie.pedantic):this.options.gfm&&(r.block=he.gfm,this.options.breaks?r.inline=ie.breaks:r.inline=ie.gfm),this.tokenizer.rules=r}g.lex=function(r,i){var o=new g(i);return o.lex(r)},g.lexInline=function(r,i){var o=new g(i);return o.inlineTokens(r)};var k=g.prototype;return k.lex=function(r){r=r.replace(/\r\n|\r/g,`
`),this.blockTokens(r,this.tokens);for(var i;i=this.inlineQueue.shift();)this.inlineTokens(i.src,i.tokens);return this.tokens},k.blockTokens=function(r,i){var o=this;i===void 0&&(i=[]),this.options.pedantic?r=r.replace(/\t/g,"    ").replace(/^ +$/gm,""):r=r.replace(/^( *)(\t+)/gm,function(Y,oe,be){return oe+"    ".repeat(be.length)});for(var w,M,T,j;r;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(w=Y.call({lexer:o},r,i))?(r=r.substring(w.raw.length),i.push(w),!0):!1}))){if(w=this.tokenizer.space(r)){r=r.substring(w.raw.length),w.raw.length===1&&i.length>0?i[i.length-1].raw+=`
`:i.push(w);continue}if(w=this.tokenizer.code(r)){r=r.substring(w.raw.length),M=i[i.length-1],M&&(M.type==="paragraph"||M.type==="text")?(M.raw+=`
`+w.raw,M.text+=`
`+w.text,this.inlineQueue[this.inlineQueue.length-1].src=M.text):i.push(w);continue}if(w=this.tokenizer.fences(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.heading(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.hr(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.blockquote(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.list(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.html(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.def(r)){r=r.substring(w.raw.length),M=i[i.length-1],M&&(M.type==="paragraph"||M.type==="text")?(M.raw+=`
`+w.raw,M.text+=`
`+w.raw,this.inlineQueue[this.inlineQueue.length-1].src=M.text):this.tokens.links[w.tag]||(this.tokens.links[w.tag]={href:w.href,title:w.title});continue}if(w=this.tokenizer.table(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.lheading(r)){r=r.substring(w.raw.length),i.push(w);continue}if(T=r,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,oe=r.slice(1),be=void 0;o.options.extensions.startBlock.forEach(function(De){be=De.call({lexer:this},oe),typeof be=="number"&&be>=0&&(Y=Math.min(Y,be))}),Y<1/0&&Y>=0&&(T=r.substring(0,Y+1))}(),this.state.top&&(w=this.tokenizer.paragraph(T))){M=i[i.length-1],j&&M.type==="paragraph"?(M.raw+=`
`+w.raw,M.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=M.text):i.push(w),j=T.length!==r.length,r=r.substring(w.raw.length);continue}if(w=this.tokenizer.text(r)){r=r.substring(w.raw.length),M=i[i.length-1],M&&M.type==="text"?(M.raw+=`
`+w.raw,M.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=M.text):i.push(w);continue}if(r){var _="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return this.state.top=!0,i},k.inline=function(r,i){return i===void 0&&(i=[]),this.inlineQueue.push({src:r,tokens:i}),i},k.inlineTokens=function(r,i){var o=this;i===void 0&&(i=[]);var w,M,T,j=r,_,Y,oe;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(_=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)be.includes(_[0].slice(_[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,_.index)+"["+L("a",_[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(_=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,_.index)+"["+L("a",_[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(_=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,_.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;r;)if(Y||(oe=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(w=we.call({lexer:o},r,i))?(r=r.substring(w.raw.length),i.push(w),!0):!1}))){if(w=this.tokenizer.escape(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.tag(r)){r=r.substring(w.raw.length),M=i[i.length-1],M&&w.type==="text"&&M.type==="text"?(M.raw+=w.raw,M.text+=w.text):i.push(w);continue}if(w=this.tokenizer.link(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.reflink(r,this.tokens.links)){r=r.substring(w.raw.length),M=i[i.length-1],M&&w.type==="text"&&M.type==="text"?(M.raw+=w.raw,M.text+=w.text):i.push(w);continue}if(w=this.tokenizer.emStrong(r,j,oe)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.codespan(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.br(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.del(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.autolink(r,Re)){r=r.substring(w.raw.length),i.push(w);continue}if(!this.state.inLink&&(w=this.tokenizer.url(r,Re))){r=r.substring(w.raw.length),i.push(w);continue}if(T=r,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Ee=r.slice(1),ve=void 0;o.options.extensions.startInline.forEach(function(Pe){ve=Pe.call({lexer:this},Ee),typeof ve=="number"&&ve>=0&&(we=Math.min(we,ve))}),we<1/0&&we>=0&&(T=r.substring(0,we+1))}(),w=this.tokenizer.inlineText(T,fe)){r=r.substring(w.raw.length),w.raw.slice(-1)!=="_"&&(oe=w.raw.slice(-1)),Y=!0,M=i[i.length-1],M&&M.type==="text"?(M.raw+=w.raw,M.text+=w.text):i.push(w);continue}if(r){var De="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return i},A(g,null,[{key:"rules",get:function(){return{block:he,inline:ie}}}]),g}(),Be=function(){function g(F){this.options=F||ne.defaults}var k=g.prototype;return k.code=function(r,i,o){var w=(i||"").match(/\S*/)[0];if(this.options.highlight){var M=this.options.highlight(r,w);M!=null&&M!==r&&(o=!0,r=M)}return r=r.replace(/\n$/,"")+`
`,w?'<pre><code class="'+this.options.langPrefix+t(w,!0)+'">'+(o?r:t(r,!0))+`</code></pre>
`:"<pre><code>"+(o?r:t(r,!0))+`</code></pre>
`},k.blockquote=function(r){return`<blockquote>
`+r+`</blockquote>
`},k.html=function(r){return r},k.heading=function(r,i,o,w){if(this.options.headerIds){var M=this.options.headerPrefix+w.slug(o);return"<h"+i+' id="'+M+'">'+r+"</h"+i+`>
`}return"<h"+i+">"+r+"</h"+i+`>
`},k.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},k.list=function(r,i,o){var w=i?"ol":"ul",M=i&&o!==1?' start="'+o+'"':"";return"<"+w+M+`>
`+r+"</"+w+`>
`},k.listitem=function(r){return"<li>"+r+`</li>
`},k.checkbox=function(r){return"<input "+(r?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},k.paragraph=function(r){return"<p>"+r+`</p>
`},k.table=function(r,i){return i&&(i="<tbody>"+i+"</tbody>"),`<table>
<thead>
`+r+`</thead>
`+i+`</table>
`},k.tablerow=function(r){return`<tr>
`+r+`</tr>
`},k.tablecell=function(r,i){var o=i.header?"th":"td",w=i.align?"<"+o+' align="'+i.align+'">':"<"+o+">";return w+r+("</"+o+`>
`)},k.strong=function(r){return"<strong>"+r+"</strong>"},k.em=function(r){return"<em>"+r+"</em>"},k.codespan=function(r){return"<code>"+r+"</code>"},k.br=function(){return this.options.xhtml?"<br/>":"<br>"},k.del=function(r){return"<del>"+r+"</del>"},k.link=function(r,i,o){if(r=b(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var w='<a href="'+t(r)+'"';return i&&(w+=' title="'+i+'"'),w+=">"+o+"</a>",w},k.image=function(r,i,o){if(r=b(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var w='<img src="'+r+'" alt="'+o+'"';return i&&(w+=' title="'+i+'"'),w+=this.options.xhtml?"/>":">",w},k.text=function(r){return r},g}(),se=function(){function g(){}var k=g.prototype;return k.strong=function(r){return r},k.em=function(r){return r},k.codespan=function(r){return r},k.del=function(r){return r},k.html=function(r){return r},k.text=function(r){return r},k.link=function(r,i,o){return""+o},k.image=function(r,i,o){return""+o},k.br=function(){return""},g}(),J=function(){function g(){this.seen={}}var k=g.prototype;return k.serialize=function(r){return r.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},k.getNextSafeSlug=function(r,i){var o=r,w=0;if(this.seen.hasOwnProperty(o)){w=this.seen[r];do w++,o=r+"-"+w;while(this.seen.hasOwnProperty(o))}return i||(this.seen[r]=w,this.seen[o]=0),o},k.slug=function(r,i){i===void 0&&(i={});var o=this.serialize(r);return this.getNextSafeSlug(o,i.dryrun)},g}(),ae=function(){function g(F){this.options=F||ne.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new J}g.parse=function(r,i){var o=new g(i);return o.parse(r)},g.parseInline=function(r,i){var o=new g(i);return o.parseInline(r)};var k=g.prototype;return k.parse=function(r,i){i===void 0&&(i=!0);var o="",w,M,T,j,_,Y,oe,be,De,we,Ee,ve,Pe,Me,Ie,Ye,et,xe,K,le=r.length;for(w=0;w<le;w++){if(we=r[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(K=this.options.extensions.renderers[we.type].call({parser:this},we),K!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){o+=K||"";continue}switch(we.type){case"space":continue;case"hr":{o+=this.renderer.hr();continue}case"heading":{o+=this.renderer.heading(this.parseInline(we.tokens),we.depth,d(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{o+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(be="",oe="",j=we.header.length,M=0;M<j;M++)oe+=this.renderer.tablecell(this.parseInline(we.header[M].tokens),{header:!0,align:we.align[M]});for(be+=this.renderer.tablerow(oe),De="",j=we.rows.length,M=0;M<j;M++){for(Y=we.rows[M],oe="",_=Y.length,T=0;T<_;T++)oe+=this.renderer.tablecell(this.parseInline(Y[T].tokens),{header:!1,align:we.align[T]});De+=this.renderer.tablerow(oe)}o+=this.renderer.table(be,De);continue}case"blockquote":{De=this.parse(we.tokens),o+=this.renderer.blockquote(De);continue}case"list":{for(Ee=we.ordered,ve=we.start,Pe=we.loose,j=we.items.length,De="",M=0;M<j;M++)Ie=we.items[M],Ye=Ie.checked,et=Ie.task,Me="",Ie.task&&(xe=this.renderer.checkbox(Ye),Pe?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=xe+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=xe+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:xe}):Me+=xe),Me+=this.parse(Ie.tokens,Pe),De+=this.renderer.listitem(Me,et,Ye);o+=this.renderer.list(De,Ee,ve);continue}case"html":{o+=this.renderer.html(we.text);continue}case"paragraph":{o+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(De=we.tokens?this.parseInline(we.tokens):we.text;w+1<le&&r[w+1].type==="text";)we=r[++w],De+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);o+=i?this.renderer.paragraph(De):De;continue}default:{var me='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(me);return}else throw new Error(me)}}}return o},k.parseInline=function(r,i){i=i||this.renderer;var o="",w,M,T,j=r.length;for(w=0;w<j;w++){if(M=r[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[M.type]&&(T=this.options.extensions.renderers[M.type].call({parser:this},M),T!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(M.type))){o+=T||"";continue}switch(M.type){case"escape":{o+=i.text(M.text);break}case"html":{o+=i.html(M.text);break}case"link":{o+=i.link(M.href,M.title,this.parseInline(M.tokens,i));break}case"image":{o+=i.image(M.href,M.title,M.text);break}case"strong":{o+=i.strong(this.parseInline(M.tokens,i));break}case"em":{o+=i.em(this.parseInline(M.tokens,i));break}case"codespan":{o+=i.codespan(M.text);break}case"br":{o+=i.br();break}case"del":{o+=i.del(this.parseInline(M.tokens,i));break}case"text":{o+=i.text(M.text);break}default:{var _='Token with "'+M.type+'" type was not found.';if(this.options.silent){console.error(_);return}else throw new Error(_)}}}return o},g}();function re(g,k,F){if(typeof g>"u"||g===null)throw new Error("marked(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");if(typeof k=="function"&&(F=k,k=null),k=y({},re.defaults,k||{}),R(k),F){var r=k.highlight,i;try{i=Ne.lex(g,k)}catch(j){return F(j)}var o=function(_){var Y;if(!_)try{k.walkTokens&&re.walkTokens(i,k.walkTokens),Y=ae.parse(i,k)}catch(oe){_=oe}return k.highlight=r,_?F(_):F(null,Y)};if(!r||r.length<3||(delete k.highlight,!i.length))return o();var w=0;re.walkTokens(i,function(j){j.type==="code"&&(w++,setTimeout(function(){r(j.text,j.lang,function(_,Y){if(_)return o(_);Y!=null&&Y!==j.text&&(j.text=Y,j.escaped=!0),w--,w===0&&o()})},0))}),w===0&&o();return}function M(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+t(j.message+"",!0)+"</pre>";throw j}try{var T=Ne.lex(g,k);if(k.walkTokens){if(k.async)return Promise.all(re.walkTokens(T,k.walkTokens)).then(function(){return ae.parse(T,k)}).catch(M);re.walkTokens(T,k.walkTokens)}return ae.parse(T,k)}catch(j){M(j)}}re.options=re.setOptions=function(g){return y(re.defaults,g),S(re.defaults),re},re.getDefaults=D,re.defaults=ne.defaults,re.use=function(){for(var g=arguments.length,k=new Array(g),F=0;F<g;F++)k[F]=arguments[F];var r=y.apply(void 0,[{}].concat(k)),i=re.defaults.extensions||{renderers:{},childTokens:{}},o;k.forEach(function(w){if(w.extensions&&(o=!0,w.extensions.forEach(function(T){if(!T.name)throw new Error("extension name required");if(T.renderer){var j=i.renderers?i.renderers[T.name]:null;j?i.renderers[T.name]=function(){for(var _=arguments.length,Y=new Array(_),oe=0;oe<_;oe++)Y[oe]=arguments[oe];var be=T.renderer.apply(this,Y);return be===!1&&(be=j.apply(this,Y)),be}:i.renderers[T.name]=T.renderer}if(T.tokenizer){if(!T.level||T.level!=="block"&&T.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");i[T.level]?i[T.level].unshift(T.tokenizer):i[T.level]=[T.tokenizer],T.start&&(T.level==="block"?i.startBlock?i.startBlock.push(T.start):i.startBlock=[T.start]:T.level==="inline"&&(i.startInline?i.startInline.push(T.start):i.startInline=[T.start]))}T.childTokens&&(i.childTokens[T.name]=T.childTokens)})),w.renderer&&function(){var T=re.defaults.renderer||new Be,j=function(oe){var be=T[oe];T[oe]=function(){for(var De=arguments.length,we=new Array(De),Ee=0;Ee<De;Ee++)we[Ee]=arguments[Ee];var ve=w.renderer[oe].apply(T,we);return ve===!1&&(ve=be.apply(T,we)),ve}};for(var _ in w.renderer)j(_);r.renderer=T}(),w.tokenizer&&function(){var T=re.defaults.tokenizer||new ge,j=function(oe){var be=T[oe];T[oe]=function(){for(var De=arguments.length,we=new Array(De),Ee=0;Ee<De;Ee++)we[Ee]=arguments[Ee];var ve=w.tokenizer[oe].apply(T,we);return ve===!1&&(ve=be.apply(T,we)),ve}};for(var _ in w.tokenizer)j(_);r.tokenizer=T}(),w.walkTokens){var M=re.defaults.walkTokens;r.walkTokens=function(T){var j=[];return j.push(w.walkTokens.call(this,T)),M&&(j=j.concat(M.call(this,T))),j}}o&&(r.extensions=i),re.setOptions(r)})},re.walkTokens=function(g,k){for(var F=[],r=function(){var M=o.value;switch(F=F.concat(k.call(re,M)),M.type){case"table":{for(var T=U(M.header),j;!(j=T()).done;){var _=j.value;F=F.concat(re.walkTokens(_.tokens,k))}for(var Y=U(M.rows),oe;!(oe=Y()).done;)for(var be=oe.value,De=U(be),we;!(we=De()).done;){var Ee=we.value;F=F.concat(re.walkTokens(Ee.tokens,k))}break}case"list":{F=F.concat(re.walkTokens(M.items,k));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[M.type]?re.defaults.extensions.childTokens[M.type].forEach(function(ve){F=F.concat(re.walkTokens(M[ve],k))}):M.tokens&&(F=F.concat(re.walkTokens(M.tokens,k)))}},i=U(g),o;!(o=i()).done;)r();return F},re.parseInline=function(g,k){if(typeof g>"u"||g===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");k=y({},re.defaults,k||{}),R(k);try{var F=Ne.lexInline(g,k);return k.walkTokens&&re.walkTokens(F,k.walkTokens),ae.parseInline(F,k)}catch(r){if(r.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+t(r.message+"",!0)+"</pre>";throw r}},re.Parser=ae,re.parser=ae.parse,re.Renderer=Be,re.TextRenderer=se,re.Lexer=Ne,re.lexer=Ne.lex,re.Tokenizer=ge,re.Slugger=J,re.parse=re;var X=re.options,x=re.setOptions,te=re.use,ce=re.walkTokens,ye=re.parseInline,Te=re,Ae=ae.parse,Q=Ne.lex;ne.Lexer=Ne,ne.Parser=ae,ne.Renderer=Be,ne.Slugger=J,ne.TextRenderer=se,ne.Tokenizer=ge,ne.getDefaults=D,ne.lexer=Q,ne.marked=re,ne.options=X,ne.parse=Te,ne.parseInline=ye,ne.parser=Ae,ne.setOptions=x,ne.use=te,ne.walkTokens=ce,Object.defineProperty(ne,"__esModule",{value:!0})}),define($e[80],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=void 0;function A(s){const d=U(s);if(d&&d.length>0)return new Uint32Array(d)}e.$Tj=A;let C=0;const n=new Uint32Array(10);function U(s){if(C=0,D(s,I,4352),C>0||(D(s,a,4449),C>0)||(D(s,h,4520),C>0)||(D(s,t,12593),C))return n.subarray(0,C);if(s>=44032&&s<=55203){const d=s-44032,c=d%588,l=Math.floor(d/588),$=Math.floor(c/28),f=c%28-1;if(l<I.length?D(l,I,0):4352+l-12593<t.length&&D(4352+l,t,12593),$<a.length?D($,a,0):4449+$-12593<t.length&&D(4449+$-12593,t,12593),f>=0&&(f<h.length?D(f,h,0):4520+f-12593<t.length&&D(4520+f-12593,t,12593)),C>0)return n.subarray(0,C)}}function D(s,d,c){s>=c&&s<c+d.length&&S(d[s-c])}function S(s){s!==0&&(n[C++]=s&255,s>>8&&(n[C++]=s>>8&255),s>>16&&(n[C++]=s>>16&255))}var m;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var p;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(p||(p={}));var v;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(v||(v={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),a=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),h=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),t=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define($e[81],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hT=void 0;class A{constructor(n,U=0,D=n.length,S=U-1){this.a=n,this.b=U,this.c=D,this.d=S}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}e.$hT=A}),define($e[82],pe([1,0,81]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jT=e.$iT=void 0;class C{constructor(D=[],S=10){this.h(D),this.b=S,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new A.$hT(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const S of D)this.a.add(S)}get j(){const D=[];return this.a.forEach(S=>D.push(S)),D}}e.$iT=C;class n{get size(){return this.f}constructor(D,S=10){if(this.g=S,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let m=1;m<D.length;m++)this.add(D[m])}add(D){const S={value:D,previous:this.c,next:void 0};for(this.c.next=S,this.c=S,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const S=this.c.value;return this.a.delete(S),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),S}prepend(D){if(this.f===this.g||this.a.has(D))return;const S={value:D,previous:void 0,next:this.b};this.b.previous=S,this.b=S,this.f++,this.a.add(D)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let S=this.b;for(;S!==this.c;)S.value===D&&(S===this.b?(this.b=this.b.next,this.b.previous=void 0):(S.previous.next=S.next,S.next.previous=S.previous),this.f--),S=S.next}}e.$jT=n}),define($e[33],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function A(S,m,p){return Math.min(Math.max(S,m),p)}e.$9l=A;function C(S,m){return(m+S%m)%m}e.rot=C;class n{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=n;class U{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=U;class D{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const p=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=D}),define($e[47],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;var A;(function(C){function n(m,p){if(m.start>=p.end||p.start>=m.end)return{start:0,end:0};const v=Math.max(m.start,p.start),I=Math.min(m.end,p.end);return I-v<=0?{start:0,end:0}:{start:v,end:I}}C.intersect=n;function U(m){return m.end-m.start<=0}C.isEmpty=U;function D(m,p){return!U(n(m,p))}C.intersects=D;function S(m,p){const v=[],I={start:m.start,end:Math.min(p.start,m.end)},a={start:Math.max(p.end,m.start),end:m.end};return U(I)||v.push(I),U(a)||v.push(a),v}C.relativeComplement=S})(A||(e.Range=A={}))}),define($e[83],pe([1,0,47]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=e.$2R=e.$1R=e.$ZR=void 0;function C(m,p){const v=[];for(const I of p){if(m.start>=I.range.end)continue;if(m.end<I.range.start)break;const a=A.Range.intersect(m,I.range);A.Range.isEmpty(a)||v.push({range:a,size:I.size})}return v}e.$ZR=C;function n({start:m,end:p},v){return{start:m+v,end:p+v}}e.$1R=n;function U(m){const p=[];let v=null;for(const I of m){const a=I.range.start,h=I.range.end,t=I.size;if(v&&t===v.size){v.range.end=h;continue}v={range:{start:a,end:h},size:t},p.push(v)}return p}e.$2R=U;function D(...m){return U(m.reduce((p,v)=>p.concat(v),[]))}class S{get paddingTop(){return this.c}set paddingTop(p){this.b=this.b+p-this.c,this.c=p}constructor(p){this.a=[],this.b=0,this.c=0,this.c=p??0,this.b=this.c}splice(p,v,I=[]){const a=I.length-v,h=C({start:0,end:p},this.a),t=C({start:p+v,end:Number.POSITIVE_INFINITY},this.a).map(d=>({range:n(d.range,a),size:d.size})),s=I.map((d,c)=>({range:{start:p+c,end:p+c+1},size:d.size}));this.a=D(h,s,t),this.b=this.c+this.a.reduce((d,c)=>d+c.size*(c.range.end-c.range.start),0)}get count(){const p=this.a.length;return p?this.a[p-1].range.end:0}get size(){return this.b}indexAt(p){if(p<0)return-1;if(p<this.c)return 0;let v=0,I=this.c;for(const a of this.a){const h=a.range.end-a.range.start,t=I+h*a.size;if(p<t)return v+Math.floor((p-I)/a.size);v+=h,I=t}return v}indexAfter(p){return Math.min(this.indexAt(p)+1,this.count)}positionAt(p){if(p<0)return-1;let v=0,I=0;for(const a of this.a){const h=a.range.end-a.range.start,t=I+h;if(p<t)return this.c+v+(p-I)*a.size;v+=h*a.size,I=t}return-1}}e.$3R=S}),define($e[84],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(U){return new C(U)}constructor(U){this.c=A&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=C}),define($e[4],pe([1,0,6,44,3,46,84]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const S=!1,m=!1;var p;(function(H){H.None=()=>n.$Tc.None;function E(r){if(m){const{onDidAddListener:i}=r,o=t.create();let w=0;r.onDidAddListener=()=>{++w===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),o.print()),i?.()}}}function R(r,i){return Be(r,()=>{},0,void 0,!0,void 0,i)}H.defer=R;function L(r){return(i,o=null,w)=>{let M=!1,T;return T=r(j=>{if(!M)return T?T.dispose():M=!0,i.call(o,j)},null,w),M&&T.dispose(),T}}H.once=L;function G(r,i,o){return Re((w,M=null,T)=>r(j=>w.call(M,i(j)),null,T),o)}H.map=G;function Z(r,i,o){return Re((w,M=null,T)=>r(j=>{i(j),w.call(M,j)},null,T),o)}H.forEach=Z;function ge(r,i,o){return Re((w,M=null,T)=>r(j=>i(j)&&w.call(M,j),null,T),o)}H.filter=ge;function he(r){return r}H.signal=he;function ie(...r){return(i,o=null,w)=>{const M=(0,n.$Qc)(...r.map(T=>T(j=>i.call(o,j))));return Ne(M,w)}}H.any=ie;function fe(r,i,o,w){let M=o;return G(r,T=>(M=i(M,T),M),w)}H.reduce=fe;function Re(r,i){let o;const w={onWillAddFirstListener(){o=r(M.fire,M)},onDidRemoveLastListener(){o?.dispose()}};i||E(w);const M=new $(w);return i?.add(M),M.event}function Ne(r,i){return i instanceof Array?i.push(r):i&&i.add(r),r}function Be(r,i,o=100,w=!1,M=!1,T,j){let _,Y,oe,be=0,De;const we={leakWarningThreshold:T,onWillAddFirstListener(){_=r(ve=>{be++,Y=i(Y,ve),w&&!oe&&(Ee.fire(Y),Y=void 0),De=()=>{const Pe=Y;Y=void 0,oe=void 0,(!w||be>1)&&Ee.fire(Pe),be=0},typeof o=="number"?(clearTimeout(oe),oe=setTimeout(De,o)):oe===void 0&&(oe=0,queueMicrotask(De))})},onWillRemoveListener(){M&&be>0&&De?.()},onDidRemoveLastListener(){De=void 0,_.dispose()}};j||E(we);const Ee=new $(we);return j?.add(Ee),Ee.event}H.debounce=Be;function se(r,i=0,o){return H.debounce(r,(w,M)=>w?(w.push(M),w):[M],i,void 0,!0,void 0,o)}H.accumulate=se;function J(r,i=(w,M)=>w===M,o){let w=!0,M;return ge(r,T=>{const j=w||!i(T,M);return w=!1,M=T,j},o)}H.latch=J;function ae(r,i,o){return[H.filter(r,i,o),H.filter(r,w=>!i(w),o)]}H.split=ae;function re(r,i=!1,o=[],w){let M=o.slice(),T=r(Y=>{M?M.push(Y):_.fire(Y)});w&&w.add(T);const j=()=>{M?.forEach(Y=>_.fire(Y)),M=null},_=new $({onWillAddFirstListener(){T||(T=r(Y=>_.fire(Y)),w&&w.add(T))},onDidAddFirstListener(){M&&(i?setTimeout(j):j())},onDidRemoveLastListener(){T&&T.dispose(),T=null}});return w&&w.add(_),_.event}H.buffer=re;function X(r,i){return(w,M,T)=>{const j=i(new te);return r(function(_){const Y=j.evaluate(_);Y!==x&&w.call(M,Y)},void 0,T)}}H.chain=X;const x=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(i){return this.f.push(i),this}forEach(i){return this.f.push(o=>(i(o),o)),this}filter(i){return this.f.push(o=>i(o)?o:x),this}reduce(i,o){let w=o;return this.f.push(M=>(w=i(w,M),w)),this}latch(i=(o,w)=>o===w){let o=!0,w;return this.f.push(M=>{const T=o||!i(M,w);return o=!1,w=M,T?M:x}),this}evaluate(i){for(const o of this.f)if(i=o(i),i===x)break;return i}}function ce(r,i,o=w=>w){const w=(..._)=>j.fire(o(..._)),M=()=>r.on(i,w),T=()=>r.removeListener(i,w),j=new $({onWillAddFirstListener:M,onDidRemoveLastListener:T});return j.event}H.fromNodeEventEmitter=ce;function ye(r,i,o=w=>w){const w=(..._)=>j.fire(o(..._)),M=()=>r.addEventListener(i,w),T=()=>r.removeEventListener(i,w),j=new $({onWillAddFirstListener:M,onDidRemoveLastListener:T});return j.event}H.fromDOMEventEmitter=ye;function Te(r){return new Promise(i=>L(r)(i))}H.toPromise=Te;function Ae(r){const i=new $;return r.then(o=>{i.fire(o)},()=>{i.fire(void 0)}).finally(()=>{i.dispose()}),i.event}H.fromPromise=Ae;function Q(r,i,o){return i(o),r(w=>i(w))}H.runAndSubscribe=Q;class g{constructor(i,o){this._observable=i,this.f=0,this.g=!1;const w={onWillAddFirstListener:()=>{i.addObserver(this)},onDidRemoveLastListener:()=>{i.removeObserver(this)}};o||E(w),this.emitter=new $(w),o&&o.add(this.emitter)}beginUpdate(i){this.f++}handlePossibleChange(i){}handleChange(i,o){this.g=!0}endUpdate(i){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function k(r,i){return new g(r,i).emitter.event}H.fromObservable=k;function F(r){return(i,o,w)=>{let M=0,T=!1;const j={beginUpdate(){M++},endUpdate(){M--,M===0&&(r.reportChanges(),T&&(T=!1,i.call(o)))},handlePossibleChange(){},handleChange(){T=!0}};r.addObserver(j),r.reportChanges();const _={dispose(){r.removeObserver(j)}};return w instanceof n.$Sc?w.add(_):Array.isArray(w)&&w.push(_),_}}H.fromObservableLight=F})(p||(e.Event=p={}));class v{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${v.f++}`,v.all.add(this)}start(E){this.g=new D.$Sd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Ud=v;let I=-1;function a(H){const E=I;return I=H,{dispose(){I=E}}}e.$Vd=a;class h{constructor(E,R=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=R,this.g=0}dispose(){this.f?.clear()}check(E,R){const L=this.threshold;if(L<=0||R<L)return;this.f||(this.f=new Map);const G=this.f.get(E.value)||0;if(this.f.set(E.value,G+1),this.g-=1,this.g<=0){this.g=L*.5;let Z,ge=0;for(const[he,ie]of this.f)(!Z||ge<ie)&&(Z=he,ge=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${ge}):`),console.warn(Z)}return()=>{const Z=this.f.get(E.value)||0;this.f.set(E.value,Z-1)}}}class t{static create(){return new t(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class d{constructor(E){this.value=E,this.id=s++}}const c=2,l=(H,E)=>{if(H instanceof d)E(H);else for(let R=0;R<H.length;R++){const L=H[R];L&&E(L)}};class ${constructor(E){this.w=0,this.f=E,this.g=I>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const E=this.t;queueMicrotask(()=>{l(E,R=>R.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,R,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Tc.None;if(this.m)return n.$Tc.None;R&&(E=E.bind(R));const G=new d(E);let Z,ge;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(G.stack=t.create(),Z=this.g.check(G.stack,this.w+1)),S&&(G.stack=ge??t.create()),this.t?this.t instanceof d?(this.u??=new b,this.t=[this.t,G]):this.t.push(G):(this.f?.onWillAddFirstListener?.(this),this.t=G,this.f?.onDidAddFirstListener?.(this)),this.w++;const he=(0,n.$Rc)(()=>{Z?.(),this.x(G)});return L instanceof n.$Sc?L.add(he):Array.isArray(L)&&L.push(he),he},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const R=this.t,L=R.indexOf(E);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,R[L]=void 0;const G=this.u.current===this;if(this.w*c<=R.length){let Z=0;for(let ge=0;ge<R.length;ge++)R[ge]?R[Z++]=R[ge]:G&&(this.u.end--,Z<this.u.i&&this.u.i--);R.length=Z}}y(E,R){if(!E)return;const L=this.f?.onListenerError||A.$1;if(!L){E.value(R);return}try{E.value(R)}catch(G){L(G)}}z(E){const R=E.current.t;for(;E.i<E.end;)this.y(R[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,E);else{const R=this.u;R.enqueue(this,E,this.t.length),this.z(R)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=$;const f=()=>new b;e.$Xd=f;class b{constructor(){this.i=-1,this.end=0}enqueue(E,R,L){this.i=0,this.end=L,this.current=E,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class u extends ${async fireAsync(E,R,L){if(this.t)for(this.h||(this.h=new U.$4c),l(this.t,G=>this.h.push([G.value,E]));this.h.size>0&&!R.isCancellationRequested;){const[G,Z]=this.h.shift(),ge=[],he={...Z,token:R,waitUntil:ie=>{if(Object.isFrozen(ge))throw new Error("waitUntil can NOT be called asynchronous");L&&(ie=L(ie,G)),ge.push(ie)}};try{G(he)}catch(ie){(0,A.$1)(ie);continue}Object.freeze(ge),await Promise.allSettled(ge).then(ie=>{for(const fe of ie)fe.status==="rejected"&&(0,A.$1)(fe.reason)})}}}e.$Yd=u;class N extends ${get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new U.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Zd=N;class B extends N{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$1d=B;class P extends ${constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(R=>super.fire(R)),this.h=[]}))}}e.$2d=P;class W{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const R={event:E,listener:null};this.h.push(R),this.g&&this.m(R);const L=()=>{this.g&&this.o(R);const G=this.h.indexOf(R);this.h.splice(G,1)};return(0,n.$Rc)((0,C.$db)(L))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(R=>this.f.fire(R))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$3d=W;class z{constructor(E,R,L,G){this.f=new n.$Sc;const Z=this.f.add(new W),ge=this.f.add(new n.$3c);function he(ie){ge.set(ie,Z.add(G(ie)))}for(const ie of E)he(ie);this.f.add(R(ie=>{he(ie)})),this.f.add(L(ie=>{ge.deleteAndDispose(ie)})),this.event=Z.event}dispose(){this.f.dispose()}}e.$4d=z;class y{constructor(){this.f=[]}wrapEvent(E){return(R,L,G)=>E(Z=>{const ge=this.f[this.f.length-1];ge?ge.push(()=>R.call(L,Z)):R.call(L,Z)},void 0,G)}bufferEvents(E){const R=[];this.f.push(R);const L=E();return this.f.pop(),R.forEach(G=>G()),L}}e.$5d=y;class O{constructor(){this.f=!1,this.g=p.None,this.h=n.$Tc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=O}),define($e[16],pe([1,0,21,4]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=void 0;class n{constructor(){this.a=new Map,this.b=new C.$Wd,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new C.$Wd,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new n}getZoomLevel(c){return this.a.get(this.f(c))??0}setZoomLevel(c,l){if(this.getZoomLevel(l)===c)return;const $=this.f(l);this.a.set($,c),this.b.fire($)}getZoomFactor(c){return this.c.get(this.f(c))??1}setZoomFactor(c,l){this.c.set(this.f(l),c)}setFullscreen(c,l){if(this.isFullscreen(l)===c)return;const $=this.f(l);this.e.set($,c),this.d.fire($)}isFullscreen(c){return!!this.e.get(this.f(c))}f(c){return c.vscodeWindowId}}function U(d,c,l){typeof c=="string"&&(c=d.matchMedia(c)),c.addEventListener("change",l)}e.$pP=U;function D(d,c){n.INSTANCE.setZoomLevel(d,c)}e.$qP=D;function S(d){return n.INSTANCE.getZoomLevel(d)}e.$rP=S,e.$sP=n.INSTANCE.onDidChangeZoomLevel;function m(d){return n.INSTANCE.getZoomFactor(d)}e.$tP=m;function p(d,c){n.INSTANCE.setZoomFactor(d,c)}e.$uP=p;function v(d,c){n.INSTANCE.setFullscreen(d,c)}e.$vP=v;function I(d){return n.INSTANCE.isFullscreen(d)}e.$wP=I,e.$xP=n.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;e.$yP=a.indexOf("Firefox")>=0,e.$zP=a.indexOf("AppleWebKit")>=0,e.$AP=a.indexOf("Chrome")>=0,e.$BP=!e.$AP&&a.indexOf("Safari")>=0,e.$CP=!e.$AP&&!e.$BP&&e.$zP,e.$DP=a.indexOf("Electron/")>=0,e.$EP=a.indexOf("Android")>=0;let h=!1;if(typeof A.$lP.matchMedia=="function"){const d=A.$lP.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),c=A.$lP.matchMedia("(display-mode: fullscreen)");h=d.matches,U(A.$lP,d,({matches:l})=>{h&&c.matches||(h=l)})}function t(){return h}e.$FP=t;function s(){return navigator?.windowControlsOverlay?.visible}e.$GP=s}),define($e[22],pe([1,0,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UR=void 0;class C{get event(){return this.a.event}constructor(U,D,S){const m=p=>this.a.fire(p);this.a=new A.$Wd({onWillAddFirstListener:()=>U.addEventListener(D,m,S),onDidRemoveLastListener:()=>U.removeEventListener(D,m,S)})}dispose(){this.a.dispose()}}e.$UR=C}),define($e[29],pe([1,0,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const C=Object.freeze(function(S,m){const p=setTimeout(S.bind(m),0);return{dispose(){clearTimeout(p)}}});var n;(function(S){function m(p){return p===S.None||p===S.Cancelled||p instanceof U?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}S.isCancellationToken=m,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(n||(e.CancellationToken=n={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new A.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=n.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=n.None}}e.$7d=D}),define($e[85],pe([1,0,29]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class C{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new A.$7d,m=this.b(S.token);return this.a={promise:m,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Fe=C;class n{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const m=JSON.stringify(S);return this.b!==m&&(this.b=m,this.a=this.c(S)),this.a}}e.$Ge=n;class U{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const m=this.b(S);return this.a.set(S,m),m}}e.$He=U}),define($e[48],pe([1,0,4,3]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.$ms=e.ScrollbarVisibility=void 0;var n;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(n||(e.ScrollbarVisibility=n={}));class U{constructor(t,s,d,c,l,$,f){this.c=t,this._scrollStateBrand=void 0,this.c&&(s=s|0,d=d|0,c=c|0,l=l|0,$=$|0,f=f|0),this.rawScrollLeft=c,this.rawScrollTop=f,s<0&&(s=0),c+s>d&&(c=d-s),c<0&&(c=0),l<0&&(l=0),f+l>$&&(f=$-l),f<0&&(f=0),this.width=s,this.scrollWidth=d,this.scrollLeft=c,this.height=l,this.scrollHeight=$,this.scrollTop=f}equals(t){return this.rawScrollLeft===t.rawScrollLeft&&this.rawScrollTop===t.rawScrollTop&&this.width===t.width&&this.scrollWidth===t.scrollWidth&&this.scrollLeft===t.scrollLeft&&this.height===t.height&&this.scrollHeight===t.scrollHeight&&this.scrollTop===t.scrollTop}withScrollDimensions(t,s){return new U(this.c,typeof t.width<"u"?t.width:this.width,typeof t.scrollWidth<"u"?t.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof t.height<"u"?t.height:this.height,typeof t.scrollHeight<"u"?t.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(t){return new U(this.c,this.width,this.scrollWidth,typeof t.scrollLeft<"u"?t.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof t.scrollTop<"u"?t.scrollTop:this.rawScrollTop)}createScrollEvent(t,s){const d=this.width!==t.width,c=this.scrollWidth!==t.scrollWidth,l=this.scrollLeft!==t.scrollLeft,$=this.height!==t.height,f=this.scrollHeight!==t.scrollHeight,b=this.scrollTop!==t.scrollTop;return{inSmoothScrolling:s,oldWidth:t.width,oldScrollWidth:t.scrollWidth,oldScrollLeft:t.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:t.height,oldScrollHeight:t.scrollHeight,oldScrollTop:t.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:d,scrollWidthChanged:c,scrollLeftChanged:l,heightChanged:$,scrollHeightChanged:f,scrollTopChanged:b}}}e.$ms=U;class D extends C.$Tc{constructor(t){super(),this._scrollableBrand=void 0,this.j=this.B(new A.$Wd),this.onScroll=this.j.event,this.c=t.smoothScrollDuration,this.f=t.scheduleAtNextAnimationFrame,this.g=new U(t.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(t){this.c=t}validateScrollPosition(t){return this.g.withScrollPosition(t)}getScrollDimensions(){return this.g}setScrollDimensions(t,s){const d=this.g.withScrollDimensions(t,s);this.n(d,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(t){const s=this.g.withScrollPosition(t);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(t,s){if(this.c===0)return this.setScrollPositionNow(t);if(this.h){t={scrollLeft:typeof t.scrollLeft>"u"?this.h.to.scrollLeft:t.scrollLeft,scrollTop:typeof t.scrollTop>"u"?this.h.to.scrollTop:t.scrollTop};const d=this.g.withScrollPosition(t);if(this.h.to.scrollLeft===d.scrollLeft&&this.h.to.scrollTop===d.scrollTop)return;let c;s?c=new v(this.h.from,d,this.h.startTime,this.h.duration):c=this.h.combine(this.g,d,this.c),this.h.dispose(),this.h=c}else{const d=this.g.withScrollPosition(t);this.h=v.start(this.g,d,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const t=this.h.tick(),s=this.g.withScrollPosition(t);if(this.n(s,!0),!!this.h){if(t.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(t,s){const d=this.g;d.equals(t)||(this.g=t,this.j.fire(this.g.createScrollEvent(d,s)))}}e.$ns=D;class S{constructor(t,s,d){this.scrollLeft=t,this.scrollTop=s,this.isDone=d}}e.$os=S;function m(h,t){const s=t-h;return function(d){return h+s*a(d)}}function p(h,t,s){return function(d){return d<s?h(d/s):t((d-s)/(1-s))}}class v{constructor(t,s,d,c){this.from=t,this.to=s,this.duration=c,this.startTime=d,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(t,s,d){if(Math.abs(t-s)>2.5*d){let l,$;return t<s?(l=t+.75*d,$=s-.75*d):(l=t-.75*d,$=s+.75*d),p(m(t,l),m($,s),.33)}return m(t,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(t){this.to=t.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(t){const s=(t-this.startTime)/this.duration;if(s<1){const d=this.c(s),c=this.d(s);return new S(d,c,!1)}return new S(this.to.scrollLeft,this.to.scrollTop,!0)}combine(t,s,d){return v.start(t,s,d)}static start(t,s,d){d=d+10;const c=Date.now()-10;return new v(t,s,c,d)}}e.$ps=v;function I(h){return Math.pow(h,3)}function a(h){return 1-I(1-h)}}),define($e[86],pe([1,0,6,3]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function n(f){const b=f;return b?typeof b.read=="function":!1}e.$8d=n;function U(f){const b=f;return b?[b.on,b.pause,b.resume,b.destroy].every(u=>typeof u=="function"):!1}e.$9d=U;function D(f){const b=f;return b?U(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.$0d=D;function S(f,b){return new m(f,b)}e.$$d=S;class m{constructor(b,u){this.e=b,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(u=>u(b))}h(b){this.c.error.length===0?(0,A.$1)(b):this.c.error.slice(0).forEach(u=>u(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,u){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(b,u){if(this.a.destroyed)return;let N;switch(b){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const B=N.indexOf(u);B>=0&&N.splice(B,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(f,b){const u=[];let N;for(;(N=f.read())!==null;)u.push(N);return b(u)}e.$_d=p;function v(f,b,u){const N=[];let B;for(;(B=f.read())!==null&&N.length<u;)N.push(B);return B===null&&N.length>0?b(N):{read:()=>{if(N.length>0)return N.shift();if(typeof B<"u"){const P=B;return B=void 0,P}return f.read()}}}e.$ae=v;function I(f,b){return new Promise((u,N)=>{const B=[];a(f,{onData:P=>{b&&B.push(P)},onError:P=>{b?N(P):u(void 0)},onEnd:()=>{u(b?b(B):void 0)}})})}e.$be=I;function a(f,b,u){f.on("error",N=>{u?.isCancellationRequested||b.onError(N)}),f.on("end",()=>{u?.isCancellationRequested||b.onEnd()}),f.on("data",N=>{u?.isCancellationRequested||b.onData(N)})}e.$ce=a;function h(f,b){return new Promise((u,N)=>{const B=new C.$Sc,P=[],W=O=>{if(P.push(O),P.length>b)return B.dispose(),f.pause(),u({stream:f,buffer:P,ended:!1})},z=O=>(B.dispose(),N(O)),y=()=>(B.dispose(),u({stream:f,buffer:P,ended:!0}));B.add((0,C.$Rc)(()=>f.removeListener("error",z))),f.on("error",z),B.add((0,C.$Rc)(()=>f.removeListener("end",y))),f.on("end",y),B.add((0,C.$Rc)(()=>f.removeListener("data",W))),f.on("data",W)})}e.$de=h;function t(f,b){const u=S(b);return u.end(f),u}e.$ee=t;function s(){const f=S(()=>{throw new Error("not supported")});return f.end(),f}e.$fe=s;function d(f){let b=!1;return{read:()=>b?null:(b=!0,f)}}e.$ge=d;function c(f,b,u){const N=S(u);return a(f,{onData:B=>N.write(b.data(B)),onError:B=>N.error(b.error?b.error(B):B),onEnd:()=>N.end()}),N}e.$he=c;function l(f,b,u){let N=!1;return{read:()=>{const B=b.read();return N?B:(N=!0,B!==null?u([f,B]):f)}}}e.$ie=l;function $(f,b,u){let N=!1;const B=S(u);return a(b,{onData:P=>N?B.write(P):(N=!0,B.write(u([f,P]))),onError:P=>B.error(P),onEnd:()=>{N||(N=!0,B.write(f)),B.end()}}),B}e.$je=$}),define($e[34],pe([1,0,23,86]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const n=typeof Buffer<"u",U=new A.$V(()=>new Uint8Array(256));let D,S;class m{static alloc(R){return n?new m(Buffer.allocUnsafe(R)):new m(new Uint8Array(R))}static wrap(R){return n&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new m(R)}static fromString(R,L){return!(L?.dontUseNodeBuffer||!1)&&n?new m(Buffer.from(R)):(D||(D=new TextEncoder),new m(D.encode(R)))}static fromByteArray(R){const L=m.alloc(R.length);for(let G=0,Z=R.length;G<Z;G++)L.buffer[G]=R[G];return L}static concat(R,L){if(typeof L>"u"){L=0;for(let ge=0,he=R.length;ge<he;ge++)L+=R[ge].byteLength}const G=m.alloc(L);let Z=0;for(let ge=0,he=R.length;ge<he;ge++){const ie=R[ge];G.set(ie,Z),Z+=ie.byteLength}return G}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=m.alloc(this.byteLength);return R.set(this),R}toString(){return n?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(R,L){return new m(this.buffer.subarray(R,L))}set(R,L){if(R instanceof m)this.buffer.set(R.buffer,L);else if(R instanceof Uint8Array)this.buffer.set(R,L);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),L);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return a(this.buffer,R)}writeUInt32BE(R,L){h(this.buffer,R,L)}readUInt32LE(R){return t(this.buffer,R)}writeUInt32LE(R,L){s(this.buffer,R,L)}readUInt8(R){return d(this.buffer,R)}writeUInt8(R,L){c(this.buffer,R,L)}indexOf(R,L=0){return p(this.buffer,R instanceof m?R.buffer:R,L)}}e.$ke=m;function p(E,R,L=0){const G=R.byteLength,Z=E.byteLength;if(G===0)return 0;if(G===1)return E.indexOf(R[0]);if(G>Z-L)return-1;const ge=U.value;ge.fill(R.length);for(let Re=0;Re<R.length;Re++)ge[R[Re]]=R.length-Re-1;let he=L+R.length-1,ie=he,fe=-1;for(;he<Z;)if(E[he]===R[ie]){if(ie===0){fe=he;break}he--,ie--}else he+=Math.max(R.length-ie,ge[E[he]]),ie=R.length-1;return fe}e.$le=p;function v(E,R){return E[R+0]<<0>>>0|E[R+1]<<8>>>0}e.$me=v;function I(E,R,L){E[L+0]=R&255,R=R>>>8,E[L+1]=R&255}e.$ne=I;function a(E,R){return E[R]*2**24+E[R+1]*2**16+E[R+2]*2**8+E[R+3]}e.$oe=a;function h(E,R,L){E[L+3]=R,R=R>>>8,E[L+2]=R,R=R>>>8,E[L+1]=R,R=R>>>8,E[L]=R}e.$pe=h;function t(E,R){return E[R+0]<<0>>>0|E[R+1]<<8>>>0|E[R+2]<<16>>>0|E[R+3]<<24>>>0}e.$qe=t;function s(E,R,L){E[L+0]=R&255,R=R>>>8,E[L+1]=R&255,R=R>>>8,E[L+2]=R&255,R=R>>>8,E[L+3]=R&255}e.$re=s;function d(E,R){return E[R]}e.$se=d;function c(E,R,L){E[L]=R}e.$te=c;function l(E){return C.$_d(E,R=>m.concat(R))}e.$ue=l;function $(E){return C.$ge(E)}e.$ve=$;function f(E){return C.$be(E,R=>m.concat(R))}e.$we=f;async function b(E){return E.ended?m.concat(E.buffer):m.concat([...E.buffer,await f(E.stream)])}e.$xe=b;function u(E){return C.$ee(E,R=>m.concat(R))}e.$ye=u;function N(E){return C.$he(E,{data:R=>typeof R=="string"?m.fromString(R):m.wrap(R)},R=>m.concat(R))}e.$ze=N;function B(E){return C.$$d(R=>m.concat(R),E)}e.$Ae=B;function P(E,R){return C.$ie(E,R,L=>m.concat(L))}e.$Be=P;function W(E,R){return C.$je(E,R,L=>m.concat(L))}e.$Ce=W;function z(E){let R=0,L=0,G=0;const Z=new Uint8Array(Math.floor(E.length/4*3)),ge=ie=>{switch(L){case 3:Z[G++]=R|ie,L=0;break;case 2:Z[G++]=R|ie>>>2,R=ie<<6,L=3;break;case 1:Z[G++]=R|ie>>>4,R=ie<<4,L=2;break;default:R=ie<<2,L=1}};for(let ie=0;ie<E.length;ie++){const fe=E.charCodeAt(ie);if(fe>=65&&fe<=90)ge(fe-65);else if(fe>=97&&fe<=122)ge(fe-97+26);else if(fe>=48&&fe<=57)ge(fe-48+52);else if(fe===43||fe===45)ge(62);else if(fe===47||fe===95)ge(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ie]}`)}}const he=G;for(;L>0;)ge(0);return m.wrap(Z).slice(0,he)}e.$De=z;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function H({buffer:E},R=!0,L=!1){const G=L?O:y;let Z="";const ge=E.byteLength%3;let he=0;for(;he<E.byteLength-ge;he+=3){const ie=E[he+0],fe=E[he+1],Re=E[he+2];Z+=G[ie>>>2],Z+=G[(ie<<4|fe>>>4)&63],Z+=G[(fe<<2|Re>>>6)&63],Z+=G[Re&63]}if(ge===1){const ie=E[he+0];Z+=G[ie>>>2],Z+=G[ie<<4&63],R&&(Z+="==")}else if(ge===2){const ie=E[he+0],fe=E[he+1];Z+=G[ie>>>2],Z+=G[(ie<<4|fe>>>4)&63],Z+=G[fe<<2&63],R&&(Z+="=")}return Z}e.$Ee=H}),define($e[10],pe([1,0,85,23]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function n(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.$Ke=n;const U=/{(\d+)}/g;function D(K,...le){return le.length===0?K:K.replace(U,function(me,ke){const Ce=parseInt(ke,10);return isNaN(Ce)||Ce<0||Ce>=le.length?me:le[Ce]})}e.$Le=D;const S=/{([^}]+)}/g;function m(K,le){return Object.keys(le).length===0?K:K.replace(S,(me,ke)=>le[ke]??me)}e.$Me=m;function p(K){return K.replace(/[<>"'&]/g,le=>{switch(le){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return le})}e.$Ne=p;function v(K){return K.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.$Oe=v;function I(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=I;function a(K,le){let me=0;const ke=le.charCodeAt(0);for(let Ce=K.length-1;Ce>=0;Ce--)K.charCodeAt(Ce)===ke&&me++;return me}e.$Qe=a;function h(K,le,me="\u2026"){return K.length<=le?K:`${K.substr(0,le)}${me}`}e.$Re=h;function t(K,le,me="\u2026"){if(K.length<=le)return K;const ke=Math.ceil(le/2)-me.length/2,Ce=Math.floor(le/2)-me.length/2;return`${K.substr(0,ke)}${me}${K.substr(K.length-Ce)}`}e.$Se=t;function s(K,le=" "){const me=d(K,le);return c(me,le)}e.$Te=s;function d(K,le){if(!K||!le)return K;const me=le.length;if(me===0||K.length===0)return K;let ke=0;for(;K.indexOf(le,ke)===ke;)ke=ke+me;return K.substring(ke)}e.$Ue=d;function c(K,le){if(!K||!le)return K;const me=le.length,ke=K.length;if(me===0||ke===0)return K;let Ce=ke,je=-1;for(;je=K.lastIndexOf(le,Ce-1),!(je===-1||je+me!==Ce);){if(je===0)return"";Ce=je}return K.substring(0,Ce)}e.$Ve=c;function l(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=l;function $(K){return K.replace(/\*/g,"")}e.$Xe=$;function f(K,le,me={}){if(!K)throw new Error("Cannot create regex from empty string");le||(K=I(K)),me.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let ke="";return me.global&&(ke+="g"),me.matchCase||(ke+="i"),me.multiline&&(ke+="m"),me.unicode&&(ke+="u"),new RegExp(K,ke)}e.$Ye=f;function b(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.$Ze=b;function u(K){return K.split(/\r\n|\r|\n/)}e.$1e=u;function N(K){for(let le=0,me=K.length;le<me;le++){const ke=K.charCodeAt(le);if(ke!==32&&ke!==9)return le}return-1}e.$2e=N;function B(K,le=0,me=K.length){for(let ke=le;ke<me;ke++){const Ce=K.charCodeAt(ke);if(Ce!==32&&Ce!==9)return K.substring(le,ke)}return K.substring(le,me)}e.$3e=B;function P(K,le=K.length-1){for(let me=le;me>=0;me--){const ke=K.charCodeAt(me);if(ke!==32&&ke!==9)return me}return-1}e.$4e=P;function W(K,le,me){const ke=[];let Ce=0;for(const je of K.matchAll(le)){if(ke.push(K.slice(Ce,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ce=je.index+je[0].length,ke.push(me(je[0],...je.slice(1),je.index,K,je.groups))}return ke.push(K.slice(Ce)),Promise.all(ke).then(je=>je.join(""))}e.$5e=W;function z(K,le){return K<le?-1:K>le?1:0}e.$6e=z;function y(K,le,me=0,ke=K.length,Ce=0,je=le.length){for(;me<ke&&Ce<je;me++,Ce++){const Je=K.charCodeAt(me),tt=le.charCodeAt(Ce);if(Je<tt)return-1;if(Je>tt)return 1}const Qe=ke-me,Ke=je-Ce;return Qe<Ke?-1:Qe>Ke?1:0}e.$7e=y;function O(K,le){return H(K,le,0,K.length,0,le.length)}e.$8e=O;function H(K,le,me=0,ke=K.length,Ce=0,je=le.length){for(;me<ke&&Ce<je;me++,Ce++){let Je=K.charCodeAt(me),tt=le.charCodeAt(Ce);if(Je===tt)continue;if(Je>=128||tt>=128)return y(K.toLowerCase(),le.toLowerCase(),me,ke,Ce,je);R(Je)&&(Je-=32),R(tt)&&(tt-=32);const Ze=Je-tt;if(Ze!==0)return Ze}const Qe=ke-me,Ke=je-Ce;return Qe<Ke?-1:Qe>Ke?1:0}e.$9e=H;function E(K){return K>=48&&K<=57}e.$0e=E;function R(K){return K>=97&&K<=122}e.$$e=R;function L(K){return K>=65&&K<=90}e.$_e=L;function G(K,le){return K.length===le.length&&H(K,le)===0}e.$af=G;function Z(K,le){const me=le.length;return le.length>K.length?!1:H(K,le,0,me)===0}e.$bf=Z;function ge(K,le){const me=Math.min(K.length,le.length);let ke;for(ke=0;ke<me;ke++)if(K.charCodeAt(ke)!==le.charCodeAt(ke))return ke;return me}e.$cf=ge;function he(K,le){const me=Math.min(K.length,le.length);let ke;const Ce=K.length-1,je=le.length-1;for(ke=0;ke<me;ke++)if(K.charCodeAt(Ce-ke)!==le.charCodeAt(je-ke))return ke;return me}e.$df=he;function ie(K){return 55296<=K&&K<=56319}e.$ef=ie;function fe(K){return 56320<=K&&K<=57343}e.$ff=fe;function Re(K,le){return(K-55296<<10)+(le-56320)+65536}e.$gf=Re;function Ne(K,le,me){const ke=K.charCodeAt(me);if(ie(ke)&&me+1<le){const Ce=K.charCodeAt(me+1);if(fe(Ce))return Re(ke,Ce)}return ke}e.$hf=Ne;function Be(K,le){const me=K.charCodeAt(le-1);if(fe(me)&&le>1){const ke=K.charCodeAt(le-2);if(ie(ke))return Re(ke,me)}return me}class se{get offset(){return this.e}constructor(le,me=0){this.c=le,this.d=le.length,this.e=me}setOffset(le){this.e=le}prevCodePoint(){const le=Be(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Ne(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.$if=se;class J{get offset(){return this.c.offset}constructor(le,me=0){this.c=new se(le,me)}nextGraphemeLength(){const le=Ee.getInstance(),me=this.c,ke=me.offset;let Ce=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const je=me.offset,Qe=le.getGraphemeBreakType(me.nextCodePoint());if(De(Ce,Qe)){me.setOffset(je);break}Ce=Qe}return me.offset-ke}prevGraphemeLength(){const le=Ee.getInstance(),me=this.c,ke=me.offset;let Ce=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const je=me.offset,Qe=le.getGraphemeBreakType(me.prevCodePoint());if(De(Qe,Ce)){me.setOffset(je);break}Ce=Qe}return ke-me.offset}eol(){return this.c.eol()}}e.$jf=J;function ae(K,le){return new J(K,le).nextGraphemeLength()}e.$kf=ae;function re(K,le){return new J(K,le).prevGraphemeLength()}e.$lf=re;function X(K,le){le>0&&fe(K.charCodeAt(le))&&le--;const me=le+ae(K,le);return[me-re(K,me),me]}e.$mf=X;function x(K){const le=new J(K);let me=0;for(;!le.eol();)me++,le.nextGraphemeLength();return me}e.$nf=x;let te;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ye(K){return te||(te=ce()),te.test(K)}e.$of=ye;const Te=/^[\t\n\r\x20-\x7E]*$/;function Ae(K){return Te.test(K)}e.$pf=Ae,e.$qf=/[\u2028\u2029]/;function Q(K){return e.$qf.test(K)}e.$rf=Q;function g(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.$sf=g;function k(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.$tf=k;function F(K,le,me=""){const ke=K.trimStart();if(ke.length<le)return ke;const Ce=/\b/g;let je=0;for(;Ce.test(ke)&&!(ke.length-Ce.lastIndex<le);)je=Ce.lastIndex,Ce.lastIndex+=1;return je===0?ke:me+ke.substring(je).trimStart()}e.$uf=F;const r=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,i=/\x1b\].*?\x07/g;function o(K){return K&&(K=K.replace(r,"").replace(i,"")),K}e.$vf=o,e.$wf="\uFEFF";function w(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.$xf=w;function M(K){return w(K)?K.substr(1):K}e.$yf=M;function T(K,le){if(!K||!le||K.length<le.length)return!1;const me=le.length,ke=K.toLowerCase();let Ce=0,je=-1;for(;Ce<me;){const Qe=ke.indexOf(le[Ce],je+1);if(Qe<0)return!1;je=Qe,Ce++}return!0}e.$zf=T;function j(K,le=!1){return K?(le&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.$Af=j;function _(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.$Bf=_;function Y(K,le=1){if(le===0)return"";let me=-1;do me=K.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?K:(K[me-1]==="\r"&&me--,K.substr(0,me))}e.$Cf=Y;function oe(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.$Df=oe;function be(K){return Ee.getInstance().getGraphemeBreakType(K)}e.$Ef=be;function De(K,le){return K===0?le!==5&&le!==7:K===2&&le===3?!1:K===4||K===2||K===3||le===4||le===2||le===3?!0:!(K===8&&(le===8||le===9||le===11||le===12)||(K===11||K===9)&&(le===9||le===10)||(K===12||K===10)&&le===10||le===5||le===13||le===7||K===1||K===13&&le===14||K===6&&le===6)}var we;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=ve()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this.d,ke=me.length/3;let Ce=1;for(;Ce<=ke;)if(le<me[3*Ce])Ce=2*Ce;else if(le>me[3*Ce+1])Ce=2*Ce+1;else return me[3*Ce+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(K,le){if(K===0)return 0;const me=Me(K,le);if(me!==void 0)return me;const ke=new se(le,K);return ke.prevCodePoint(),ke.offset}e.$Ff=Pe;function Me(K,le){const me=new se(le,K);let ke=me.prevCodePoint();for(;Ie(ke)||ke===65039||ke===8419;){if(me.offset===0)return;ke=me.prevCodePoint()}if(!k(ke))return;let Ce=me.offset;return Ce>0&&me.prevCodePoint()===8205&&(Ce=me.offset),Ce}function Ie(K){return 127995<=K&&K<=127999}var Ye;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$Gf="\xA0";class et{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new A.$Ge(le=>{function me(Ze){const nt=new Map;for(let st=0;st<Ze.length;st+=2)nt.set(Ze[st],Ze[st+1]);return nt}function ke(Ze,nt){const st=new Map(Ze);for(const[rt,gt]of nt)st.set(rt,gt);return st}function Ce(Ze,nt){if(!Ze)return nt;const st=new Map;for(const[rt,gt]of Ze)nt.has(rt)&&st.set(rt,gt);return st}const je=this.c.value;let Qe=le.filter(Ze=>!Ze.startsWith("_")&&Ze in je);Qe.length===0&&(Qe=["_default"]);let Ke;for(const Ze of Qe){const nt=me(je[Ze]);Ke=Ce(Ke,nt)}const Je=me(je._common),tt=ke(Je,Ke);return new et(tt)})}static getInstance(le){return et.d.get(Array.from(le))}static{this.e=new C.$V(()=>Object.keys(et.c.value).filter(le=>!le.startsWith("_")))}static getLocales(){return et.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=et;class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(le){return xe.e().has(le)}static get codePoints(){return xe.e()}}e.$If=xe}),define($e[35],pe([1,0,32,80,10]),function(ne,e,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.FuzzyScore=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.or=void 0;function U(...T){return function(j,_){for(let Y=0,oe=T.length;Y<oe;Y++){const be=T[Y](j,_);if(be)return be}return null}}e.or=U,e.$Vj=D.bind(void 0,!1),e.$Wj=D.bind(void 0,!0);function D(T,j,_){if(!_||_.length<j.length)return null;let Y;return T?Y=n.$bf(_,j):Y=_.indexOf(j)===0,Y?j.length>0?[{start:0,end:j.length}]:[]:null}function S(T,j){const _=j.toLowerCase().indexOf(T.toLowerCase());return _===-1?null:[{start:_,end:_+T.length}]}e.$Xj=S;function m(T,j){return p(T.toLowerCase(),j.toLowerCase(),0,0)}e.$Yj=m;function p(T,j,_,Y){if(_===T.length)return[];if(Y===j.length)return null;if(T[_]===j[Y]){let oe=null;return(oe=p(T,j,_+1,Y+1))?f({start:Y,end:Y+1},oe):null}return p(T,j,_,Y+1)}function v(T){return 97<=T&&T<=122}function I(T){return 65<=T&&T<=90}e.$Zj=I;function a(T){return 48<=T&&T<=57}function h(T){return T===32||T===9||T===10||T===13}const t=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(T=>t.add(T.charCodeAt(0)));function s(T){return h(T)||t.has(T)}function d(T,j){return T===j||s(T)&&s(j)}const c=new Map;function l(T){if(c.has(T))return c.get(T);let j;const _=(0,C.$Tj)(T);return _&&(j=_),c.set(T,j),j}function $(T){return v(T)||I(T)||a(T)}function f(T,j){return j.length===0?j=[T]:T.end===j[0].start?j[0].start=T.start:j.unshift(T),j}function b(T,j){for(let _=j;_<T.length;_++){const Y=T.charCodeAt(_);if(I(Y)||a(Y)||_>0&&!$(T.charCodeAt(_-1)))return _}return T.length}function u(T,j,_,Y){if(_===T.length)return[];if(Y===j.length)return null;if(T[_]!==j[Y].toLowerCase())return null;{let oe=null,be=Y+1;for(oe=u(T,j,_+1,Y+1);!oe&&(be=b(j,be))<j.length;)oe=u(T,j,_+1,be),be++;return oe===null?null:f({start:Y,end:Y+1},oe)}}function N(T){let j=0,_=0,Y=0,oe=0,be=0;for(let Pe=0;Pe<T.length;Pe++)be=T.charCodeAt(Pe),I(be)&&j++,v(be)&&_++,$(be)&&Y++,a(be)&&oe++;const De=j/T.length,we=_/T.length,Ee=Y/T.length,ve=oe/T.length;return{upperPercent:De,lowerPercent:we,alphaPercent:Ee,numericPercent:ve}}function B(T){const{upperPercent:j,lowerPercent:_}=T;return _===0&&j>.6}function P(T){const{upperPercent:j,lowerPercent:_,alphaPercent:Y,numericPercent:oe}=T;return _>.2&&j<.8&&Y>.6&&oe<.2}function W(T){let j=0,_=0,Y=0,oe=0;for(let be=0;be<T.length;be++)Y=T.charCodeAt(be),I(Y)&&j++,v(Y)&&_++,h(Y)&&oe++;return(j===0||_===0)&&oe===0?T.length<=30:j<=5}function z(T,j){if(!j||(j=j.trim(),j.length===0)||!W(T)||j.length>60)return null;const _=N(j);if(!P(_)){if(!B(_))return null;j=j.toLowerCase()}let Y=null,oe=0;for(T=T.toLowerCase();oe<j.length&&(Y=u(T,j,0,oe))===null;)oe=b(j,oe+1);return Y}e.$1j=z;function y(T,j,_=!1){if(!j||j.length===0)return null;let Y=null,oe=0;for(T=T.toLowerCase(),j=j.toLowerCase();oe<j.length&&(Y=O(T,j,0,oe,_),Y===null);)oe=H(j,oe+1);return Y}e.$2j=y;function O(T,j,_,Y,oe){let be=0;if(_===T.length)return[];if(Y===j.length)return null;if(!d(T.charCodeAt(_),j.charCodeAt(Y))){const Ee=l(T.charCodeAt(_));if(!Ee)return null;for(let ve=0;ve<Ee.length;ve++)if(!d(Ee[ve],j.charCodeAt(Y+ve)))return null;be+=Ee.length-1}let De=null,we=Y+be+1;if(De=O(T,j,_+1,we,oe),!oe)for(;!De&&(we=H(j,we))<j.length;)De=O(T,j,_+1,we,oe),we++;if(!De)return null;if(T.charCodeAt(_)!==j.charCodeAt(Y)){const Ee=l(T.charCodeAt(_));if(!Ee)return De;for(let ve=0;ve<Ee.length;ve++)if(Ee[ve]!==j.charCodeAt(Y+ve))return De}return f({start:Y,end:Y+be+1},De)}function H(T,j){for(let _=j;_<T.length;_++)if(s(T.charCodeAt(_))||_>0&&s(T.charCodeAt(_-1)))return _;return T.length}const E=U(e.$Wj,z,S),R=U(e.$Wj,z,m),L=new A.$Dc(1e4);function G(T,j,_=!1){if(typeof T!="string"||typeof j!="string")return null;let Y=L.get(T);Y||(Y=new RegExp(n.$We(T),"i"),L.set(T,Y));const oe=Y.exec(j);return oe?[{start:oe.index,end:oe.index+oe[0].length}]:_?R(T,j):E(T,j)}e.$3j=G;function Z(T,j){const _=k(T,T.toLowerCase(),0,j,j.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?he(_):null}e.$4j=Z;function ge(T,j,_,Y,oe,be){const De=Math.min(13,T.length);for(;_<De;_++){const we=k(T,j,_,Y,oe,be,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,be]}e.$5j=ge;function he(T){if(typeof T>"u")return[];const j=[],_=T[1];for(let Y=T.length-1;Y>1;Y--){const oe=T[Y]+_,be=j[j.length-1];be&&be.end===oe?be.end=oe+1:j.push({start:oe,end:oe+1})}return j}e.$6j=he;const ie=128;function fe(){const T=[],j=[];for(let _=0;_<=ie;_++)j[_]=0;for(let _=0;_<=ie;_++)T.push(j.slice(0));return T}function Re(T){const j=[];for(let _=0;_<=T;_++)j[_]=0;return j}const Ne=Re(2*ie),Be=Re(2*ie),se=fe(),J=fe(),ae=fe(),re=!1;function X(T,j,_,Y,oe){function be(we,Ee,ve=" "){for(;we.length<Ee;)we=ve+we;return we}let De=` |   |${Y.split("").map(we=>be(we,3)).join("|")}
`;for(let we=0;we<=_;we++)we===0?De+=" |":De+=`${j[we-1]}|`,De+=T[we].slice(0,oe+1).map(Ee=>be(Ee.toString(),3)).join("|")+`
`;return De}function x(T,j,_,Y){T=T.substr(j),_=_.substr(Y),console.log(X(J,T,T.length,_,_.length)),console.log(X(ae,T,T.length,_,_.length)),console.log(X(se,T,T.length,_,_.length))}function te(T,j){if(j<0||j>=T.length)return!1;const _=T.codePointAt(j);switch(_){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.$tf(_)}}function ce(T,j){if(j<0||j>=T.length)return!1;switch(T.charCodeAt(j)){case 32:case 9:return!0;default:return!1}}function ye(T,j,_){return j[T]!==_[T]}function Te(T,j,_,Y,oe,be,De=!1){for(;j<_&&oe<be;)T[j]===Y[oe]&&(De&&(Ne[j]=oe),j+=1),oe+=1;return j===_}e.$7j=Te;var Ae;(function(T){T[T.Diag=1]="Diag",T[T.Left=2]="Left",T[T.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var Q;(function(T){T.Default=[-100,0];function j(_){return!_||_.length===2&&_[0]===-100&&_[1]===0}T.isDefault=j})(Q||(e.FuzzyScore=Q={}));class g{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(j,_){this.firstMatchCanBeWeak=j,this.boostFullMatch=_}}e.$8j=g;function k(T,j,_,Y,oe,be,De=g.default){const we=T.length>ie?ie:T.length,Ee=Y.length>ie?ie:Y.length;if(_>=we||be>=Ee||we-_>Ee-be||!Te(j,_,we,oe,be,Ee,!0))return;F(we,Ee,_,be,j,oe);let ve=1,Pe=1,Me=_,Ie=be;const Ye=[!1];for(ve=1,Me=_;Me<we;ve++,Me++){const me=Ne[Me],ke=Be[Me],Ce=Me+1<we?Be[Me+1]:Ee;for(Pe=me-be+1,Ie=me;Ie<Ce;Pe++,Ie++){let je=Number.MIN_SAFE_INTEGER,Qe=!1;Ie<=ke&&(je=r(T,j,Me,_,Y,oe,Ie,Ee,be,se[ve-1][Pe-1]===0,Ye));let Ke=0;je!==Number.MAX_SAFE_INTEGER&&(Qe=!0,Ke=je+J[ve-1][Pe-1]);const Je=Ie>me,tt=Je?J[ve][Pe-1]+(se[ve][Pe-1]>0?-5:0):0,Ze=Ie>me+1&&se[ve][Pe-1]>0,nt=Ze?J[ve][Pe-2]+(se[ve][Pe-2]>0?-5:0):0;if(Ze&&(!Je||nt>=tt)&&(!Qe||nt>=Ke))J[ve][Pe]=nt,ae[ve][Pe]=3,se[ve][Pe]=0;else if(Je&&(!Qe||tt>=Ke))J[ve][Pe]=tt,ae[ve][Pe]=2,se[ve][Pe]=0;else if(Qe)J[ve][Pe]=Ke,ae[ve][Pe]=1,se[ve][Pe]=se[ve-1][Pe-1]+1;else throw new Error("not possible")}}if(re&&x(T,_,Y,be),!Ye[0]&&!De.firstMatchCanBeWeak)return;ve--,Pe--;const et=[J[ve][Pe],be];let xe=0,K=0;for(;ve>=1;){let me=Pe;do{const ke=ae[ve][me];if(ke===3)me=me-2;else if(ke===2)me=me-1;else break}while(me>=1);xe>1&&j[_+ve-1]===oe[be+Pe-1]&&!ye(me+be-1,Y,oe)&&xe+1>se[ve][me]&&(me=Pe),me===Pe?xe++:xe=1,K||(K=me),ve--,Pe=me-1,et.push(Pe)}Ee===we&&De.boostFullMatch&&(et[0]+=2);const le=K-we;return et[0]-=le,et}e.$9j=k;function F(T,j,_,Y,oe,be){let De=T-1,we=j-1;for(;De>=_&&we>=Y;)oe[De]===be[we]&&(Be[De]=we,De--),we--}function r(T,j,_,Y,oe,be,De,we,Ee,ve,Pe){if(j[_]!==be[De])return Number.MIN_SAFE_INTEGER;let Me=1,Ie=!1;return De===_-Y?Me=T[_]===oe[De]?7:5:ye(De,oe,be)&&(De===0||!ye(De-1,oe,be))?(Me=T[_]===oe[De]?7:5,Ie=!0):te(be,De)&&(De===0||!te(be,De-1))?Me=5:(te(be,De-1)||ce(be,De-1))&&(Me=5,Ie=!0),Me>1&&_===Y&&(Pe[0]=!0),Ie||(Ie=ye(De,oe,be)||te(be,De-1)||ce(be,De-1)),_===Y?De>Ee&&(Me-=Ie?3:5):ve?Me+=Ie?2:0:Me+=Ie?0:1,De+1===we&&(Me-=Ie?3:5),Me}function i(T,j,_,Y,oe,be,De){return w(T,j,_,Y,oe,be,!0,De)}e.$0j=i;function o(T,j,_,Y,oe,be,De){return w(T,j,_,Y,oe,be,!1,De)}e.$$j=o;function w(T,j,_,Y,oe,be,De,we){let Ee=k(T,j,_,Y,oe,be,we);if(Ee&&!De)return Ee;if(T.length>=3){const ve=Math.min(7,T.length-1);for(let Pe=_+1;Pe<ve;Pe++){const Me=M(T,Pe);if(Me){const Ie=k(Me,Me.toLowerCase(),_,Y,oe,be,we);Ie&&(Ie[0]-=3,(!Ee||Ie[0]>Ee[0])&&(Ee=Ie))}}}return Ee}function M(T,j){if(j+1>=T.length)return;const _=T[j],Y=T[j+1];if(_!==Y)return T.slice(0,j)+Y+_+T.slice(j+2)}}),define($e[49],pe([1,0,10]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;function C(c){return n(c,0)}e.$Vi=C;function n(c,l){switch(typeof c){case"object":return c===null?U(349,l):Array.isArray(c)?m(c,l):p(c,l);case"string":return S(c,l);case"boolean":return D(c,l);case"number":return U(c,l);case"undefined":return U(937,l);default:return U(617,l)}}e.$Wi=n;function U(c,l){return(l<<5)-l+c|0}e.$Xi=U;function D(c,l){return U(c?433:863,l)}function S(c,l){l=U(149417,l);for(let $=0,f=c.length;$<f;$++)l=U(c.charCodeAt($),l);return l}e.$Yi=S;function m(c,l){return l=U(104579,l),c.reduce(($,f)=>n(f,$),l)}function p(c,l){return l=U(181387,l),Object.keys(c).sort().reduce(($,f)=>($=S(f,$),n(c[f],$)),l)}class v{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=n(l,this.g),this.g}}e.$Zi=v;var I;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function a(c,l,$=32){const f=$-l,b=~((1<<f)-1);return(c<<l|(b&c)>>>f)>>>0}function h(c,l=0,$=c.byteLength,f=0){for(let b=0;b<$;b++)c[l+b]=f}function t(c,l,$="0"){for(;c.length<l;)c=$+c;return c}function s(c,l=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):t((c>>>0).toString(16),l/4)}e.$1i=s;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const $=l.length;if($===0)return;const f=this.p;let b=this.r,u=this.u,N,B;for(u!==0?(N=u,B=-1,u=0):(N=l.charCodeAt(0),B=0);;){let P=N;if(A.$ef(N))if(B+1<$){const W=l.charCodeAt(B+1);A.$ff(W)?(B++,P=A.$gf(N,W)):P=65533}else{u=N;break}else A.$ff(N)&&(P=65533);if(b=this.w(f,b,P),B++,B<$)N=l.charCodeAt(B);else break}this.r=b,this.u=u}w(l,$,f){return f<128?l[$++]=f:f<2048?(l[$++]=192|(f&1984)>>>6,l[$++]=128|(f&63)>>>0):f<65536?(l[$++]=224|(f&61440)>>>12,l[$++]=128|(f&4032)>>>6,l[$++]=128|(f&63)>>>0):(l[$++]=240|(f&1835008)>>>18,l[$++]=128|(f&258048)>>>12,l[$++]=128|(f&4032)>>>6,l[$++]=128|(f&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,l[0]=l[64],l[1]=l[65],l[2]=l[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=d.g,$=this.q;for(let y=0;y<64;y+=4)l.setUint32(y,$.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)l.setUint32(y,a(l.getUint32(y-12,!1)^l.getUint32(y-32,!1)^l.getUint32(y-56,!1)^l.getUint32(y-64,!1),1),!1);let f=this.h,b=this.l,u=this.m,N=this.n,B=this.o,P,W,z;for(let y=0;y<80;y++)y<20?(P=b&u|~b&N,W=1518500249):y<40?(P=b^u^N,W=1859775393):y<60?(P=b&u|b&N|u&N,W=2400959708):(P=b^u^N,W=3395469782),z=a(f,5)+P+B+W+l.getUint32(y*4,!1)&4294967295,B=N,N=u,u=a(b,30),b=f,f=z;this.h=this.h+f&4294967295,this.l=this.l+b&4294967295,this.m=this.m+u&4294967295,this.n=this.n+N&4294967295,this.o=this.o+B&4294967295}}e.$2i=d}),define($e[87],pe([1,0,75,49]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=e.$1s=void 0;class n{constructor(a){this.a=a}getElements(){const a=this.a,h=new Int32Array(a.length);for(let t=0,s=a.length;t<s;t++)h[t]=a.charCodeAt(t);return h}}e.$1s=n;function U(I,a,h){return new v(new n(I),new n(a)).ComputeDiff(h).changes}e.$2s=U;class D{static Assert(a,h){if(!a)throw new Error(h)}}class S{static Copy(a,h,t,s,d){for(let c=0;c<d;c++)t[s+c]=a[h+c]}static Copy2(a,h,t,s,d){for(let c=0;c<d;c++)t[s+c]=a[h+c]}}var m;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class p{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new A.$Zs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(a,h){this.b=Math.min(this.b,a),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(a,h){this.b=Math.min(this.b,a),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class v{constructor(a,h,t=null){this.a=t,this.b=a,this.c=h;const[s,d,c]=v.o(a),[l,$,f]=v.o(h);this.d=c&&f,this.e=s,this.f=d,this.g=l,this.h=$,this.k=[],this.m=[]}static n(a){return a.length>0&&typeof a[0]=="string"}static o(a){const h=a.getElements();if(v.n(h)){const t=new Int32Array(h.length);for(let s=0,d=h.length;s<d;s++)t[s]=(0,C.$Yi)(h[s],0);return[h,t,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(a,h){return this.f[a]!==this.h[h]?!1:this.d?this.e[a]===this.g[h]:!0}q(a,h){if(!this.p(a,h))return!1;const t=v.r(this.b,a),s=v.r(this.c,h);return t===s}static r(a,h){return typeof a.getStrictElement=="function"?a.getStrictElement(h):null}s(a,h){return this.f[a]!==this.f[h]?!1:this.d?this.e[a]===this.e[h]:!0}u(a,h){return this.h[a]!==this.h[h]?!1:this.d?this.g[a]===this.g[h]:!0}ComputeDiff(a){return this.v(0,this.f.length-1,0,this.h.length-1,a)}v(a,h,t,s,d){const c=[!1];let l=this.w(a,h,t,s,c);return d&&(l=this.z(l)),{quitEarly:c[0],changes:l}}w(a,h,t,s,d){for(d[0]=!1;a<=h&&t<=s&&this.p(a,t);)a++,t++;for(;h>=a&&s>=t&&this.p(h,s);)h--,s--;if(a>h||t>s){let u;return t<=s?(D.Assert(a===h+1,"originalStart should only be one more than originalEnd"),u=[new A.$Zs(a,0,t,s-t+1)]):a<=h?(D.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),u=[new A.$Zs(a,h-a+1,t,0)]):(D.Assert(a===h+1,"originalStart should only be one more than originalEnd"),D.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),u=[]),u}const c=[0],l=[0],$=this.y(a,h,t,s,c,l,d),f=c[0],b=l[0];if($!==null)return $;if(!d[0]){const u=this.w(a,f,t,b,d);let N=[];return d[0]?N=[new A.$Zs(f+1,h-(f+1)+1,b+1,s-(b+1)+1)]:N=this.w(f+1,h,b+1,s,d),this.H(u,N)}return[new A.$Zs(a,h-a+1,t,s-t+1)]}x(a,h,t,s,d,c,l,$,f,b,u,N,B,P,W,z,y,O){let H=null,E=null,R=new p,L=h,G=t,Z=B[0]-z[0]-s,ge=-1073741824,he=this.k.length-1;do{const ie=Z+a;ie===L||ie<G&&f[ie-1]<f[ie+1]?(u=f[ie+1],P=u-Z-s,u<ge&&R.MarkNextChange(),ge=u,R.AddModifiedElement(u+1,P),Z=ie+1-a):(u=f[ie-1]+1,P=u-Z-s,u<ge&&R.MarkNextChange(),ge=u-1,R.AddOriginalElement(u,P+1),Z=ie-1-a),he>=0&&(f=this.k[he],a=f[0],L=1,G=f.length-1)}while(--he>=-1);if(H=R.getReverseChanges(),O[0]){let ie=B[0]+1,fe=z[0]+1;if(H!==null&&H.length>0){const Re=H[H.length-1];ie=Math.max(ie,Re.getOriginalEnd()),fe=Math.max(fe,Re.getModifiedEnd())}E=[new A.$Zs(ie,N-ie+1,fe,W-fe+1)]}else{R=new p,L=c,G=l,Z=B[0]-z[0]-$,ge=1073741824,he=y?this.m.length-1:this.m.length-2;do{const ie=Z+d;ie===L||ie<G&&b[ie-1]>=b[ie+1]?(u=b[ie+1]-1,P=u-Z-$,u>ge&&R.MarkNextChange(),ge=u+1,R.AddOriginalElement(u+1,P+1),Z=ie+1-d):(u=b[ie-1],P=u-Z-$,u>ge&&R.MarkNextChange(),ge=u,R.AddModifiedElement(u+1,P+1),Z=ie-1-d),he>=0&&(b=this.m[he],d=b[0],L=1,G=b.length-1)}while(--he>=-1);E=R.getChanges()}return this.H(H,E)}y(a,h,t,s,d,c,l){let $=0,f=0,b=0,u=0,N=0,B=0;a--,t--,d[0]=0,c[0]=0,this.k=[],this.m=[];const P=h-a+(s-t),W=P+1,z=new Int32Array(W),y=new Int32Array(W),O=s-t,H=h-a,E=a-t,R=h-s,G=(H-O)%2===0;z[O]=a,y[H]=h,l[0]=!1;for(let Z=1;Z<=P/2+1;Z++){let ge=0,he=0;b=this.J(O-Z,Z,O,W),u=this.J(O+Z,Z,O,W);for(let fe=b;fe<=u;fe+=2){fe===b||fe<u&&z[fe-1]<z[fe+1]?$=z[fe+1]:$=z[fe-1]+1,f=$-(fe-O)-E;const Re=$;for(;$<h&&f<s&&this.p($+1,f+1);)$++,f++;if(z[fe]=$,$+f>ge+he&&(ge=$,he=f),!G&&Math.abs(fe-H)<=Z-1&&$>=y[fe])return d[0]=$,c[0]=f,Re<=y[fe]&&1447>0&&Z<=1448?this.x(O,b,u,E,H,N,B,R,z,y,$,h,d,f,s,c,G,l):null}const ie=(ge-a+(he-t)-Z)/2;if(this.a!==null&&!this.a(ge,ie))return l[0]=!0,d[0]=ge,c[0]=he,ie>0&&1447>0&&Z<=1448?this.x(O,b,u,E,H,N,B,R,z,y,$,h,d,f,s,c,G,l):(a++,t++,[new A.$Zs(a,h-a+1,t,s-t+1)]);N=this.J(H-Z,Z,H,W),B=this.J(H+Z,Z,H,W);for(let fe=N;fe<=B;fe+=2){fe===N||fe<B&&y[fe-1]>=y[fe+1]?$=y[fe+1]-1:$=y[fe-1],f=$-(fe-H)-R;const Re=$;for(;$>a&&f>t&&this.p($,f);)$--,f--;if(y[fe]=$,G&&Math.abs(fe-O)<=Z&&$<=z[fe])return d[0]=$,c[0]=f,Re>=z[fe]&&1447>0&&Z<=1448?this.x(O,b,u,E,H,N,B,R,z,y,$,h,d,f,s,c,G,l):null}if(Z<=1447){let fe=new Int32Array(u-b+2);fe[0]=O-b+1,S.Copy2(z,b,fe,1,u-b+1),this.k.push(fe),fe=new Int32Array(B-N+2),fe[0]=H-N+1,S.Copy2(y,N,fe,1,B-N+1),this.m.push(fe)}}return this.x(O,b,u,E,H,N,B,R,z,y,$,h,d,f,s,c,G,l)}z(a){for(let h=0;h<a.length;h++){const t=a[h],s=h<a.length-1?a[h+1].originalStart:this.f.length,d=h<a.length-1?a[h+1].modifiedStart:this.h.length,c=t.originalLength>0,l=t.modifiedLength>0;for(;t.originalStart+t.originalLength<s&&t.modifiedStart+t.modifiedLength<d&&(!c||this.s(t.originalStart,t.originalStart+t.originalLength))&&(!l||this.u(t.modifiedStart,t.modifiedStart+t.modifiedLength));){const f=this.q(t.originalStart,t.modifiedStart);if(this.q(t.originalStart+t.originalLength,t.modifiedStart+t.modifiedLength)&&!f)break;t.originalStart++,t.modifiedStart++}const $=[null];if(h<a.length-1&&this.I(a[h],a[h+1],$)){a[h]=$[0],a.splice(h+1,1),h--;continue}}for(let h=a.length-1;h>=0;h--){const t=a[h];let s=0,d=0;if(h>0){const u=a[h-1];s=u.originalStart+u.originalLength,d=u.modifiedStart+u.modifiedLength}const c=t.originalLength>0,l=t.modifiedLength>0;let $=0,f=this.G(t.originalStart,t.originalLength,t.modifiedStart,t.modifiedLength);for(let u=1;;u++){const N=t.originalStart-u,B=t.modifiedStart-u;if(N<s||B<d||c&&!this.s(N,N+t.originalLength)||l&&!this.u(B,B+t.modifiedLength))break;const W=(N===s&&B===d?5:0)+this.G(N,t.originalLength,B,t.modifiedLength);W>f&&(f=W,$=u)}t.originalStart-=$,t.modifiedStart-=$;const b=[null];if(h>0&&this.I(a[h-1],a[h],b)){a[h-1]=b[0],a.splice(h,1),h++;continue}}if(this.d)for(let h=1,t=a.length;h<t;h++){const s=a[h-1],d=a[h],c=d.originalStart-s.originalStart-s.originalLength,l=s.originalStart,$=d.originalStart+d.originalLength,f=$-l,b=s.modifiedStart,u=d.modifiedStart+d.modifiedLength,N=u-b;if(c<5&&f<20&&N<20){const B=this.A(l,f,b,N,c);if(B){const[P,W]=B;(P!==s.originalStart+s.originalLength||W!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=P-s.originalStart,s.modifiedLength=W-s.modifiedStart,d.originalStart=P+c,d.modifiedStart=W+c,d.originalLength=$-d.originalStart,d.modifiedLength=u-d.modifiedStart)}}}return a}A(a,h,t,s,d){if(h<d||s<d)return null;const c=a+h-d+1,l=t+s-d+1;let $=0,f=0,b=0;for(let u=a;u<c;u++)for(let N=t;N<l;N++){const B=this.B(u,N,d);B>0&&B>$&&($=B,f=u,b=N)}return $>0?[f,b]:null}B(a,h,t){let s=0;for(let d=0;d<t;d++){if(!this.p(a+d,h+d))return 0;s+=this.e[a+d].length}return s}C(a){return a<=0||a>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[a])}D(a,h){if(this.C(a)||this.C(a-1))return!0;if(h>0){const t=a+h;if(this.C(t-1)||this.C(t))return!0}return!1}E(a){return a<=0||a>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[a])}F(a,h){if(this.E(a)||this.E(a-1))return!0;if(h>0){const t=a+h;if(this.E(t-1)||this.E(t))return!0}return!1}G(a,h,t,s){const d=this.D(a,h)?1:0,c=this.F(t,s)?1:0;return d+c}H(a,h){const t=[];if(a.length===0||h.length===0)return h.length>0?h:a;if(this.I(a[a.length-1],h[0],t)){const s=new Array(a.length+h.length-1);return S.Copy(a,0,s,0,a.length-1),s[a.length-1]=t[0],S.Copy(h,1,s,a.length,h.length-1),s}else{const s=new Array(a.length+h.length);return S.Copy(a,0,s,0,a.length),S.Copy(h,0,s,a.length,h.length),s}}I(a,h,t){if(D.Assert(a.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),D.Assert(a.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),a.originalStart+a.originalLength>=h.originalStart||a.modifiedStart+a.modifiedLength>=h.modifiedStart){const s=a.originalStart;let d=a.originalLength;const c=a.modifiedStart;let l=a.modifiedLength;return a.originalStart+a.originalLength>=h.originalStart&&(d=h.originalStart+h.originalLength-a.originalStart),a.modifiedStart+a.modifiedLength>=h.modifiedStart&&(l=h.modifiedStart+h.modifiedLength-a.modifiedStart),t[0]=new A.$Zs(s,d,c,l),!0}else return t[0]=null,!1}J(a,h,t,s){if(a>=0&&a<s)return a;const d=t,c=s-t-1,l=h%2===0;if(a<0){const $=d%2===0;return l===$?0:1}else{const $=c%2===0;return l===$?s-1:s-2}}}e.$3s=v}),define($e[50],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define($e[88],pe([1,0,12,10]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class n{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const t=h.charCodeAt(0),s=this.b.charCodeAt(this.c);return t-s}value(){return this.b[this.c]}}e.$0h=n;class U{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$7e)(h,this.b,0,h.length,this.c,this.d):(0,C.$9e)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=U;class D{constructor(h=!0,t=!0){this.f=h,this.g=t}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let t=h.length-1;t>=0;t--,this.c--){const s=this.b.charCodeAt(t);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const t=this.b.charCodeAt(this.e);if(t===47||this.f&&t===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$7e)(h,this.b,0,h.length,this.d,this.e):(0,C.$9e)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=D;var S;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(S||(S={}));class m{constructor(h,t){this.f=h,this.g=t,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$8e)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$8e)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$6e)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$6e)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=m;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(v||(v={}));class I{static forUris(h=()=>!1,t=()=>!1){return new I(new m(h,t))}static forPaths(h=!1){return new I(new D(void 0,!h))}static forStrings(){return new I(new n)}static forConfigKeys(){return new I(new U)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,t){if(t){const s=t.slice(0);(0,A.$Xb)(s);for(const d of s)this.set(d,h)}else{const s=h.slice(0);(0,A.$Xb)(s);for(const d of s)this.set(d[0],d[1])}}set(h,t){const s=this.b.reset(h);let d;this.c||(this.c=new p,this.c.segment=s.value());const c=[];for(d=this.c;;){const $=s.cmp(d.segment);if($>0)d.left||(d.left=new p,d.left.segment=s.value()),c.push([-1,d]),d=d.left;else if($<0)d.right||(d.right=new p,d.right.segment=s.value()),c.push([1,d]),d=d.right;else if(s.hasNext())s.next(),d.mid||(d.mid=new p,d.mid.segment=s.value()),c.push([0,d]),d=d.mid;else break}const l=d.value;d.value=t,d.key=h;for(let $=c.length-1;$>=0;$--){const f=c[$][1];f.updateHeight();const b=f.balanceFactor();if(b<-1||b>1){const u=c[$][0],N=c[$+1][0];if(u===1&&N===1)c[$][1]=f.rotateLeft();else if(u===-1&&N===-1)c[$][1]=f.rotateRight();else if(u===1&&N===-1)f.right=c[$+1][1]=c[$+1][1].rotateRight(),c[$][1]=f.rotateLeft();else if(u===-1&&N===1)f.left=c[$+1][1]=c[$+1][1].rotateLeft(),c[$][1]=f.rotateRight();else throw new Error;if($>0)switch(c[$-1][0]){case-1:c[$-1][1].left=c[$][1];break;case 1:c[$-1][1].right=c[$][1];break;case 0:c[$-1][1].mid=c[$][1];break}else this.c=c[0][1]}}return l}get(h){return this.d(h)?.value}d(h){const t=this.b.reset(h);let s=this.c;for(;s;){const d=t.cmp(s.segment);if(d>0)s=s.left;else if(d<0)s=s.right;else if(t.hasNext())t.next(),s=s.mid;else break}return s}has(h){const t=this.d(h);return!(t?.value===void 0&&t?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,t){const s=this.b.reset(h),d=[];let c=this.c;for(;c;){const l=s.cmp(c.segment);if(l>0)d.push([-1,c]),c=c.left;else if(l<0)d.push([1,c]),c=c.right;else if(s.hasNext())s.next(),d.push([0,c]),c=c.mid;else break}if(c){if(t?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const l=this.f(c.right);if(l.key){const{key:$,value:f,segment:b}=l;this.e(l.key,!1),c.key=$,c.value=f,c.segment=b}}else{const l=c.left??c.right;if(d.length>0){const[$,f]=d[d.length-1];switch($){case-1:f.left=l;break;case 0:f.mid=l;break;case 1:f.right=l;break}}else this.c=l}for(let l=d.length-1;l>=0;l--){const $=d[l][1];$.updateHeight();const f=$.balanceFactor();if(f>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),d[l][1]=$.rotateLeft()):f<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),d[l][1]=$.rotateRight()),l>0)switch(d[l-1][0]){case-1:d[l-1][1].left=d[l][1];break;case 1:d[l-1][1].right=d[l][1];break;case 0:d[l-1][1].mid=d[l][1];break}else this.c=d[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const t=this.b.reset(h);let s=this.c,d;for(;s;){const c=t.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(t.hasNext())t.next(),d=s.value||d,s=s.mid;else break}return s&&s.value||d}findSuperstr(h){return this.g(h,!1)}g(h,t){const s=this.b.reset(h);let d=this.c;for(;d;){const c=s.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(s.hasNext())s.next(),d=d.mid;else return d.mid?this.h(d.mid):t?d.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[t,s]of this)h(s,t)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const t=[];return this.j(h,t),t[Symbol.iterator]()}j(h,t){h&&(h.left&&this.j(h.left,t),h.value&&t.push([h.key,h.value]),h.mid&&this.j(h.mid,t),h.right&&this.j(h.right,t))}_isBalanced(){const h=t=>{if(!t)return!0;const s=t.balanceFactor();return s<-1||s>1?!1:h(t.left)&&h(t.right)};return h(this.c)}}e.$bi=I}),define($e[7],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function A(b){return typeof b=="string"}e.$Jf=A;function C(b){return Array.isArray(b)&&b.every(u=>A(u))}e.$Kf=C;function n(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.$Lf=n;function U(b){const u=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof u}e.$Mf=U;function D(b){return typeof b=="number"&&!isNaN(b)}e.$Nf=D;function S(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.$Of=S;function m(b){return b===!0||b===!1}e.$Pf=m;function p(b){return typeof b>"u"}e.$Qf=p;function v(b){return!I(b)}e.$Rf=v;function I(b){return p(b)||b===null}e.$Sf=I;function a(b,u){if(!b)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.$Tf=a;function h(b){if(I(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.$Uf=h;function t(...b){const u=[];for(let N=0;N<b.length;N++){const B=b[N];if(I(B))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);u.push(B)}return u}e.$Vf=t;const s=Object.prototype.hasOwnProperty;function d(b){if(!n(b))return!1;for(const u in b)if(s.call(b,u))return!1;return!0}e.$Wf=d;function c(b){return typeof b=="function"}e.$Xf=c;function l(...b){return b.length>0&&b.every(c)}e.$Yf=l;function $(b,u){const N=Math.min(b.length,u.length);for(let B=0;B<N;B++)f(b[B],u[B])}e.$Zf=$;function f(b,u){if(A(u)){if(typeof b!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(c(u)){try{if(b instanceof u)return}catch{}if(!I(b)&&b.constructor===u||u.length===1&&u.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=f}),define($e[17],pe([1,0,7]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=void 0;const C=Object.create(null);function n(S,m){if((0,A.$Jf)(m)){const p=C[m];if(p===void 0)throw new Error(`${S} references an unknown codicon: ${m}`);m=p}return C[S]=m,{id:S}}function U(){return C}e.$_j=U;function D(){return Object.values(e.$bk)}e.$ak=D,e.$bk={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugBreakpointPending:n("debug-breakpoint-pending",60377),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),gitStash:n("git-stash",60454),gitStashApply:n("git-stash-apply",60455),gitStashPop:n("git-stash-pop",60456),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define($e[51],pe([1,0,7]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function C(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const l=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,f])=>{l[$]=f&&typeof f=="object"?C(f):f}),l}e.$yn=C;function n(c){if(!c||typeof c!="object")return c;const l=[c];for(;l.length>0;){const $=l.shift();Object.freeze($);for(const f in $)if(U.call($,f)){const b=$[f];typeof b=="object"&&!Object.isFrozen(b)&&!(0,A.$Mf)(b)&&l.push(b)}}return c}e.$zn=n;const U=Object.prototype.hasOwnProperty;function D(c,l){return S(c,l,new Set)}e.$An=D;function S(c,l,$){if((0,A.$Sf)(c))return c;const f=l(c);if(typeof f<"u")return f;if(Array.isArray(c)){const b=[];for(const u of c)b.push(S(u,l,$));return b}if((0,A.$Lf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const b={};for(const u in c)U.call(c,u)&&(b[u]=S(c[u],l,$));return $.delete(c),b}return c}function m(c,l,$=!0){return(0,A.$Lf)(c)?((0,A.$Lf)(l)&&Object.keys(l).forEach(f=>{f in c?$&&((0,A.$Lf)(c[f])&&(0,A.$Lf)(l[f])?m(c[f],l[f],$):c[f]=l[f]):c[f]=l[f]}),c):l}e.$Bn=m;function p(c,l){if(c===l)return!0;if(c==null||l===null||l===void 0||typeof c!=typeof l||typeof c!="object"||Array.isArray(c)!==Array.isArray(l))return!1;let $,f;if(Array.isArray(c)){if(c.length!==l.length)return!1;for($=0;$<c.length;$++)if(!p(c[$],l[$]))return!1}else{const b=[];for(f in c)b.push(f);b.sort();const u=[];for(f in l)u.push(f);if(u.sort(),!p(b,u))return!1;for($=0;$<b.length;$++)if(!p(c[b[$]],l[b[$]]))return!1}return!0}e.$Cn=p;function v(c){const l=new Set;return JSON.stringify(c,($,f)=>{if((0,A.$Lf)(f)||Array.isArray(f)){if(l.has(f))return"[Circular]";l.add(f)}return f})}e.$Dn=v;function I(c,l){const $=Object.create(null);return!c||!l||Object.keys(l).forEach(b=>{const u=c[b],N=l[b];p(u,N)||($[b]=N)}),$}e.$En=I;function a(c,l){const $=l.toLowerCase(),f=Object.keys(c).find(b=>b.toLowerCase()===$);return f?c[f]:c[l]}e.$Fn=a;function h(c,l){const $=Object.create(null);for(const[f,b]of Object.entries(c))l(f,b)&&($[f]=b);return $}e.$Gn=h;function t(c){let l=[];for(;Object.prototype!==c;)l=l.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return l}e.$Hn=t;function s(c){const l=[];for(const $ of t(c))typeof c[$]=="function"&&l.push($);return l}e.$In=s;function d(c,l){const $=b=>function(){const u=Array.prototype.slice.call(arguments,0);return l(b,u)},f={};for(const b of c)f[b]=$(b);return f}e.$Jn=d}),define($e[18],pe([1,0,17]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var C;(function(D){function S(m){return m&&typeof m=="object"&&typeof m.id=="string"}D.isThemeColor=S})(C||(e.ThemeColor=C={}));function n(D){return{id:D}}e.$ck=n;var U;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function m(l){const $=S.exec(l.id);if(!$)return m(A.$bk.error);const[,f,b]=$,u=["codicon","codicon-"+f];return b&&u.push("codicon-modifier-"+b.substring(1)),u}D.asClassNameArray=m;function p(l){return m(l).join(" ")}D.asClassName=p;function v(l){return"."+m(l).join(".")}D.asCSSSelector=v;function I(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||C.isThemeColor(l.color))}D.isThemeIcon=I;const a=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function h(l){const $=a.exec(l);if(!$)return;const[,f]=$;return{id:f}}D.fromString=h;function t(l){return{id:l}}D.fromId=t;function s(l,$){let f=l.id;const b=f.lastIndexOf("~");return b!==-1&&(f=f.substring(0,b)),$&&(f=`${f}~${$}`),{id:f}}D.modify=s;function d(l){const $=l.id.lastIndexOf("~");if($!==-1)return l.id.substring($+1)}D.getModifier=d;function c(l,$){return l.id===$.id&&l.color?.id===$.color?.id}D.isEqual=c})(U||(e.ThemeIcon=U={}))}),define($e[36],pe([1,0,35,10,18]),function(ne,e,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=void 0;const U="$(",D=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${D.source}`,"g");function m(c){return c.replace(S,(l,$)=>$?l:`\\${l}`)}e.$dk=m;const p=new RegExp(`\\\\${D.source}`,"g");function v(c){return c.replace(p,l=>`\\${l}`)}e.$ek=v;const I=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function a(c){return c.indexOf(U)===-1?c:c.replace(I,(l,$,f,b)=>f?l:$||b||"")}e.$fk=a;function h(c){return c?c.replace(/\$\((.*?)\)/g,(l,$)=>` ${$} `).trim():""}e.$gk=h;const t=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(c){t.lastIndex=0;let l="";const $=[];let f=0;for(;;){const b=t.lastIndex,u=t.exec(c),N=c.substring(b,u?.index);if(N.length>0){l+=N;for(let B=0;B<N.length;B++)$.push(f)}if(!u)break;f+=u[0].length}return{text:l,iconOffsets:$}}e.$hk=s;function d(c,l,$=!1){const{text:f,iconOffsets:b}=l;if(!b||b.length===0)return(0,A.$3j)(c,f,$);const u=(0,C.$Ue)(f," "),N=f.length-u.length,B=(0,A.$3j)(c,u,$);if(B)for(const P of B){const W=b[P.start+N]+N;P.start+=W,P.end+=W}return B}e.$ik=d}),define($e[89],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JU=e.$IU=void 0,e.$IU="vscode:contextmenu",e.$JU="vscode:onCloseContextMenu"}),define($e[90],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QU=void 0;class A{constructor(n,U){this.a=n,this.onMessage=U}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$QU=A}),define($e[30],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=e.$Q=e.$P=e.$O=void 0;const A=globalThis.vscode;e.$O=A.ipcRenderer,e.$P=A.ipcMessagePort,e.$Q=A.webFrame,e.$R=A.process,e.$S=A.context}),define($e[91],pe([1,0,89,30]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MU=void 0;let n=0;function U(S,m,p){const v=[],I=n++,a=`vscode:onContextMenu${I}`,h=(t,s,d)=>{v[s].click?.(d)};C.$O.once(a,h),C.$O.once(A.$JU,(t,s)=>{s===I&&(C.$O.removeListener(a,h),p?.())}),C.$O.send(A.$IU,I,S.map(t=>D(t,v)),a,m)}e.$MU=U;function D(S,m){const p={id:m.length,label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:typeof S.enabled=="boolean"?S.enabled:!0,visible:typeof S.visible=="boolean"?S.visible:!0};return m.push(S),Array.isArray(S.submenu)&&(p.submenu=S.submenu.map(v=>D(v,m))),p}}),define($e[52],pe([8]),{}),define($e[92],pe([8]),{}),define($e[93],pe([8]),{}),define($e[94],pe([8]),{}),define($e[95],pe([1,0,93,94]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0})}),define($e[96],pe([8]),{}),define($e[97],pe([8]),{}),define($e[98],pe([8]),{}),define($e[99],pe([8]),{}),define($e[100],pe([8]),{}),define($e[101],pe([8]),{}),define($e[102],pe([8]),{}),define($e[103],pe([8]),{}),define($e[104],pe([8]),{}),define($e[105],pe([13,11]),function(ne,e){return ne.create("vs/base/browser/ui/actionbar/actionViewItems",e)}),define($e[106],pe([13,11]),function(ne,e){return ne.create("vs/base/browser/ui/findinput/findInput",e)}),define($e[107],pe([13,11]),function(ne,e){return ne.create("vs/base/browser/ui/findinput/findInputToggles",e)}),define($e[108],pe([13,11]),function(ne,e){return ne.create("vs/base/browser/ui/iconLabel/iconLabelHover",e)}),define($e[109],pe([13,11]),function(ne,e){return ne.create("vs/base/browser/ui/inputbox/inputBox",e)}),define($e[110],pe([13,11]),function(ne,e){return ne.create("vs/base/browser/ui/selectBox/selectBoxCustom",e)}),define($e[111],pe([13,11]),function(ne,e){return ne.create("vs/base/browser/ui/tree/abstractTree",e)}),define($e[112],pe([13,11]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define($e[37],pe([1,0,4,3,112]),function(ne,e,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class U extends C.$Tc{constructor(a,h="",t="",s=!0,d){super(),this.h=this.B(new A.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=h,this.u=t,this.w=s,this.C=d}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,h){this.C&&await this.C(a)}}e.$Mi=U;class D extends C.$Tc{constructor(){super(...arguments),this.f=this.B(new A.$Wd),this.onWillRun=this.f.event,this.m=this.B(new A.$Wd),this.onDidRun=this.m.event}async run(a,h){if(!a.enabled)return;this.f.fire({action:a});let t;try{await this.u(a,h)}catch(s){t=s}this.m.fire({action:a,error:t})}async u(a,h){await a.run(h)}}e.$Ni=D;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let h=[];for(const t of a)t.length&&(h.length?h=[...h,new S,...t]:h=t);return h}static{this.ID="vs.actions.separator"}async run(){}}e.$Oi=S;class m{get actions(){return this.a}constructor(a,h,t,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=h,this.class=s,this.a=t}async run(){}}e.$Pi=m;class p extends U{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,n.localize(0,null),void 0,!1)}}e.$Qi=p;function v(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...a)=>I.run(...a),tooltip:I.label}}e.$Ri=v}),define($e[113],pe([13,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define($e[5],pe([1,0,113]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let C=!1,n=!1,U=!1,D=!1,S=!1,m=!1,p=!1,v=!1,I=!1,a=!1,h,t=e.$g,s=e.$g,d,c;const l=globalThis;let $;typeof l.vscode<"u"&&typeof l.vscode.process<"u"?$=l.vscode.process:typeof process<"u"&&($=process);const f=typeof $?.versions?.electron=="string",b=f&&$?.type==="renderer";if(typeof $=="object"){C=$.platform==="win32",n=$.platform==="darwin",U=$.platform==="linux",D=U&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=f,I=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,t=e.$g;const E=$.env.VSCODE_NLS_CONFIG;if(E)try{const R=JSON.parse(E),L=R.availableLanguages["*"];h=R.locale,s=R.osLocale,t=L||e.$g,d=R._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!b?(c=navigator.userAgent,C=c.indexOf("Windows")>=0,n=c.indexOf("Macintosh")>=0,v=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=c.indexOf("Linux")>=0,a=c?.indexOf("Mobi")>=0,m=!0,h=A.getConfiguredDefaultLocale(A.localize(0,null))||e.$g,t=h,s=navigator.language):console.error("Unable to resolve platform.");var u;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(u||(e.Platform=u={}));function N(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=N;let B=0;n?B=1:C?B=3:U&&(B=2),e.$i=C,e.$j=n,e.$k=U,e.$l=D,e.$m=S,e.$n=p,e.$o=m,e.$p=m&&typeof l.importScripts=="function",e.$q=e.$p?l.origin:void 0,e.$r=v,e.$s=a,e.$t=I,e.$u=B,e.$v=c,e.$w=t;var P;(function(E){function R(){return e.$w}E.value=R;function L(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=L;function G(){return e.$w==="en"}E.isDefault=G})(P||(e.Language=P={})),e.$x=h,e.$y=s,e.$z=d,e.$A=typeof l.postMessage=="function"&&!l.importScripts,e.$B=(()=>{if(e.$A){const E=[];l.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let G=0,Z=E.length;G<Z;G++){const ge=E[G];if(ge.id===L.data.vscodeScheduleAsyncWork){E.splice(G,1),ge.callback();return}}});let R=0;return L=>{const G=++R;E.push({id:G,callback:L}),l.postMessage({vscodeScheduleAsyncWork:G},"*")}}return E=>setTimeout(E)})();var W;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(W||(e.OperatingSystem=W={})),e.OS=n||v?2:C?1:3;let z=!0,y=!1;function O(){if(!y){y=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,z=new Uint16Array(E.buffer)[0]===513}return z}e.$D=O,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function H(E){return parseFloat(E)>=20}e.$J=H}),define($e[114],pe([1,0,16,21,5]),function(ne,e,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.KeyboardSupport=void 0;var U;(function(D){D[D.Always=0]="Always",D[D.FullScreen=1]="FullScreen",D[D.None=2]="None"})(U||(e.KeyboardSupport=U={})),e.$HP={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:n.$m||A.$FP()?0:navigator.keyboard||A.$BP?1:2,touch:"ontouchstart"in C.$lP||navigator.maxTouchPoints>0,pointerEvents:C.$lP.PointerEvent&&("ontouchstart"in C.$lP||navigator.maxTouchPoints>0)}}),define($e[14],pe([1,0,16,45,78,5]),function(ne,e,A,C,n,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=e.$OP=e.$NP=void 0;function D(t){if(t.charCode){const d=String.fromCharCode(t.charCode).toUpperCase();return C.KeyCodeUtils.fromString(d)}const s=t.keyCode;if(s===3)return 7;if(A.$yP)switch(s){case 59:return 85;case 60:if(U.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$j)return 57;break}else if(A.$zP){if(U.$j&&s===93)return 57;if(!U.$j&&s===92)return 57}return C.$4q[s]||0}const S=U.$j?256:2048,m=512,p=1024,v=U.$j?2048:256;function I(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode}, key: ${t.key}`}e.$NP=I;function a(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode} ('${C.KeyCodeUtils.toString(t.keyCode)}')`}e.$OP=a;class h{constructor(s){this._standardKeyboardEventBrand=!0;const d=s;this.browserEvent=d,this.target=d.target,this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,this.altGraphKey=d.getModifierState("AltGraph"),this.keyCode=D(d),this.code=d.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let d=0;return this.ctrlKey&&(d|=S),this.altKey&&(d|=m),this.shiftKey&&(d|=p),this.metaKey&&(d|=v),d|=s,d}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.$_q(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}e.$PP=h}),define($e[19],pe([1,0,16,69,5]),function(ne,e,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=e.$LP=e.$KP=void 0;class U{constructor(p,v){this.timestamp=Date.now(),this.browserEvent=v,this.leftButton=v.button===0,this.middleButton=v.button===1,this.rightButton=v.button===2,this.buttons=v.buttons,this.target=v.target,this.detail=v.detail||1,v.type==="dblclick"&&(this.detail=2),this.ctrlKey=v.ctrlKey,this.shiftKey=v.shiftKey,this.altKey=v.altKey,this.metaKey=v.metaKey,typeof v.pageX=="number"?(this.posx=v.pageX,this.posy=v.pageY):(this.posx=v.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=v.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const I=C.$IP.getPositionOfChildWindowRelativeToAncestorWindow(p,v.view);this.posx-=I.left,this.posy-=I.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}e.$KP=U;class D extends U{constructor(p,v){super(p,v),this.dataTransfer=v.dataTransfer}}e.$LP=D;class S{constructor(p,v=0,I=0){if(this.browserEvent=p||null,this.target=p?p.target||p.targetNode||p.srcElement:null,this.deltaY=I,this.deltaX=v,p){const a=p,h=p,t=p.view?.devicePixelRatio||1;if(typeof a.wheelDeltaY<"u")A.$AP?this.deltaY=a.wheelDeltaY/(120*t):this.deltaY=a.wheelDeltaY/120;else if(typeof h.VERTICAL_AXIS<"u"&&h.axis===h.VERTICAL_AXIS)this.deltaY=-h.detail/3;else if(p.type==="wheel"){const s=p;s.deltaMode===s.DOM_DELTA_LINE?A.$yP&&!n.$j?this.deltaY=-p.deltaY/3:this.deltaY=-p.deltaY:this.deltaY=-p.deltaY/40}if(typeof a.wheelDeltaX<"u")A.$BP&&n.$i?this.deltaX=-(a.wheelDeltaX/120):A.$AP?this.deltaX=a.wheelDeltaX/(120*t):this.deltaX=a.wheelDeltaX/120;else if(typeof h.HORIZONTAL_AXIS<"u"&&h.axis===h.HORIZONTAL_AXIS)this.deltaX=-p.detail/3;else if(p.type==="wheel"){const s=p;s.deltaMode===s.DOM_DELTA_LINE?A.$yP&&!n.$j?this.deltaX=-p.deltaX/3:this.deltaX=-p.deltaX:this.deltaX=-p.deltaX/40}this.deltaY===0&&this.deltaX===0&&p.wheelDelta&&(A.$AP?this.deltaY=p.wheelDelta/(120*t):this.deltaY=p.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}e.$MP=S}),define($e[115],pe([1,0,5]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let C;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const U=n.process;C={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return A.$i?"win32":A.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$dc=C.platform,e.$ec=C.arch}),define($e[24],pe([1,0,115]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const C=65,n=97,U=90,D=122,S=46,m=47,p=92,v=58,I=63;class a extends Error{constructor(N,B,P){let W;typeof B=="string"&&B.indexOf("not ")===0?(W="must not be",B=B.replace(/^not /,"")):W="must be";const z=N.indexOf(".")!==-1?"property":"argument";let y=`The "${N}" ${z} ${W} of type ${B}`;y+=`. Received type ${typeof P}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function h(u,N){if(u===null||typeof u!="object")throw new a(N,"Object",u)}function t(u,N){if(typeof u!="string")throw new a(N,"string",u)}const s=A.$dc==="win32";function d(u){return u===m||u===p}function c(u){return u===m}function l(u){return u>=C&&u<=U||u>=n&&u<=D}function $(u,N,B,P){let W="",z=0,y=-1,O=0,H=0;for(let E=0;E<=u.length;++E){if(E<u.length)H=u.charCodeAt(E);else{if(P(H))break;H=m}if(P(H)){if(!(y===E-1||O===1))if(O===2){if(W.length<2||z!==2||W.charCodeAt(W.length-1)!==S||W.charCodeAt(W.length-2)!==S){if(W.length>2){const R=W.lastIndexOf(B);R===-1?(W="",z=0):(W=W.slice(0,R),z=W.length-1-W.lastIndexOf(B)),y=E,O=0;continue}else if(W.length!==0){W="",z=0,y=E,O=0;continue}}N&&(W+=W.length>0?`${B}..`:"..",z=2)}else W.length>0?W+=`${B}${u.slice(y+1,E)}`:W=u.slice(y+1,E),z=E-y-1;y=E,O=0}else H===S&&O!==-1?++O:O=-1}return W}function f(u,N){h(N,"pathObject");const B=N.dir||N.root,P=N.base||`${N.name||""}${N.ext||""}`;return B?B===N.root?`${B}${P}`:`${B}${u}${P}`:P}e.$fc={resolve(...u){let N="",B="",P=!1;for(let W=u.length-1;W>=-1;W--){let z;if(W>=0){if(z=u[W],t(z,"path"),z.length===0)continue}else N.length===0?z=A.cwd():(z=A.env[`=${N}`]||A.cwd(),(z===void 0||z.slice(0,2).toLowerCase()!==N.toLowerCase()&&z.charCodeAt(2)===p)&&(z=`${N}\\`));const y=z.length;let O=0,H="",E=!1;const R=z.charCodeAt(0);if(y===1)d(R)&&(O=1,E=!0);else if(d(R))if(E=!0,d(z.charCodeAt(1))){let L=2,G=L;for(;L<y&&!d(z.charCodeAt(L));)L++;if(L<y&&L!==G){const Z=z.slice(G,L);for(G=L;L<y&&d(z.charCodeAt(L));)L++;if(L<y&&L!==G){for(G=L;L<y&&!d(z.charCodeAt(L));)L++;(L===y||L!==G)&&(H=`\\\\${Z}\\${z.slice(G,L)}`,O=L)}}}else O=1;else l(R)&&z.charCodeAt(1)===v&&(H=z.slice(0,2),O=2,y>2&&d(z.charCodeAt(2))&&(E=!0,O=3));if(H.length>0)if(N.length>0){if(H.toLowerCase()!==N.toLowerCase())continue}else N=H;if(P){if(N.length>0)break}else if(B=`${z.slice(O)}\\${B}`,P=E,E&&N.length>0)break}return B=$(B,!P,"\\",d),P?`${N}\\${B}`:`${N}${B}`||"."},normalize(u){t(u,"path");const N=u.length;if(N===0)return".";let B=0,P,W=!1;const z=u.charCodeAt(0);if(N===1)return c(z)?"\\":u;if(d(z))if(W=!0,d(u.charCodeAt(1))){let O=2,H=O;for(;O<N&&!d(u.charCodeAt(O));)O++;if(O<N&&O!==H){const E=u.slice(H,O);for(H=O;O<N&&d(u.charCodeAt(O));)O++;if(O<N&&O!==H){for(H=O;O<N&&!d(u.charCodeAt(O));)O++;if(O===N)return`\\\\${E}\\${u.slice(H)}\\`;O!==H&&(P=`\\\\${E}\\${u.slice(H,O)}`,B=O)}}}else B=1;else l(z)&&u.charCodeAt(1)===v&&(P=u.slice(0,2),B=2,N>2&&d(u.charCodeAt(2))&&(W=!0,B=3));let y=B<N?$(u.slice(B),!W,"\\",d):"";return y.length===0&&!W&&(y="."),y.length>0&&d(u.charCodeAt(N-1))&&(y+="\\"),P===void 0?W?`\\${y}`:y:W?`${P}\\${y}`:`${P}${y}`},isAbsolute(u){t(u,"path");const N=u.length;if(N===0)return!1;const B=u.charCodeAt(0);return d(B)||N>2&&l(B)&&u.charCodeAt(1)===v&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let N,B;for(let z=0;z<u.length;++z){const y=u[z];t(y,"path"),y.length>0&&(N===void 0?N=B=y:N+=`\\${y}`)}if(N===void 0)return".";let P=!0,W=0;if(typeof B=="string"&&d(B.charCodeAt(0))){++W;const z=B.length;z>1&&d(B.charCodeAt(1))&&(++W,z>2&&(d(B.charCodeAt(2))?++W:P=!1))}if(P){for(;W<N.length&&d(N.charCodeAt(W));)W++;W>=2&&(N=`\\${N.slice(W)}`)}return e.$fc.normalize(N)},relative(u,N){if(t(u,"from"),t(N,"to"),u===N)return"";const B=e.$fc.resolve(u),P=e.$fc.resolve(N);if(B===P||(u=B.toLowerCase(),N=P.toLowerCase(),u===N))return"";let W=0;for(;W<u.length&&u.charCodeAt(W)===p;)W++;let z=u.length;for(;z-1>W&&u.charCodeAt(z-1)===p;)z--;const y=z-W;let O=0;for(;O<N.length&&N.charCodeAt(O)===p;)O++;let H=N.length;for(;H-1>O&&N.charCodeAt(H-1)===p;)H--;const E=H-O,R=y<E?y:E;let L=-1,G=0;for(;G<R;G++){const ge=u.charCodeAt(W+G);if(ge!==N.charCodeAt(O+G))break;ge===p&&(L=G)}if(G!==R){if(L===-1)return P}else{if(E>R){if(N.charCodeAt(O+G)===p)return P.slice(O+G+1);if(G===2)return P.slice(O+G)}y>R&&(u.charCodeAt(W+G)===p?L=G:G===2&&(L=3)),L===-1&&(L=0)}let Z="";for(G=W+L+1;G<=z;++G)(G===z||u.charCodeAt(G)===p)&&(Z+=Z.length===0?"..":"\\..");return O+=L,Z.length>0?`${Z}${P.slice(O,H)}`:(P.charCodeAt(O)===p&&++O,P.slice(O,H))},toNamespacedPath(u){if(typeof u!="string"||u.length===0)return u;const N=e.$fc.resolve(u);if(N.length<=2)return u;if(N.charCodeAt(0)===p){if(N.charCodeAt(1)===p){const B=N.charCodeAt(2);if(B!==I&&B!==S)return`\\\\?\\UNC\\${N.slice(2)}`}}else if(l(N.charCodeAt(0))&&N.charCodeAt(1)===v&&N.charCodeAt(2)===p)return`\\\\?\\${N}`;return u},dirname(u){t(u,"path");const N=u.length;if(N===0)return".";let B=-1,P=0;const W=u.charCodeAt(0);if(N===1)return d(W)?u:".";if(d(W)){if(B=P=1,d(u.charCodeAt(1))){let O=2,H=O;for(;O<N&&!d(u.charCodeAt(O));)O++;if(O<N&&O!==H){for(H=O;O<N&&d(u.charCodeAt(O));)O++;if(O<N&&O!==H){for(H=O;O<N&&!d(u.charCodeAt(O));)O++;if(O===N)return u;O!==H&&(B=P=O+1)}}}}else l(W)&&u.charCodeAt(1)===v&&(B=N>2&&d(u.charCodeAt(2))?3:2,P=B);let z=-1,y=!0;for(let O=N-1;O>=P;--O)if(d(u.charCodeAt(O))){if(!y){z=O;break}}else y=!1;if(z===-1){if(B===-1)return".";z=B}return u.slice(0,z)},basename(u,N){N!==void 0&&t(N,"ext"),t(u,"path");let B=0,P=-1,W=!0,z;if(u.length>=2&&l(u.charCodeAt(0))&&u.charCodeAt(1)===v&&(B=2),N!==void 0&&N.length>0&&N.length<=u.length){if(N===u)return"";let y=N.length-1,O=-1;for(z=u.length-1;z>=B;--z){const H=u.charCodeAt(z);if(d(H)){if(!W){B=z+1;break}}else O===-1&&(W=!1,O=z+1),y>=0&&(H===N.charCodeAt(y)?--y===-1&&(P=z):(y=-1,P=O))}return B===P?P=O:P===-1&&(P=u.length),u.slice(B,P)}for(z=u.length-1;z>=B;--z)if(d(u.charCodeAt(z))){if(!W){B=z+1;break}}else P===-1&&(W=!1,P=z+1);return P===-1?"":u.slice(B,P)},extname(u){t(u,"path");let N=0,B=-1,P=0,W=-1,z=!0,y=0;u.length>=2&&u.charCodeAt(1)===v&&l(u.charCodeAt(0))&&(N=P=2);for(let O=u.length-1;O>=N;--O){const H=u.charCodeAt(O);if(d(H)){if(!z){P=O+1;break}continue}W===-1&&(z=!1,W=O+1),H===S?B===-1?B=O:y!==1&&(y=1):B!==-1&&(y=-1)}return B===-1||W===-1||y===0||y===1&&B===W-1&&B===P+1?"":u.slice(B,W)},format:f.bind(null,"\\"),parse(u){t(u,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return N;const B=u.length;let P=0,W=u.charCodeAt(0);if(B===1)return d(W)?(N.root=N.dir=u,N):(N.base=N.name=u,N);if(d(W)){if(P=1,d(u.charCodeAt(1))){let L=2,G=L;for(;L<B&&!d(u.charCodeAt(L));)L++;if(L<B&&L!==G){for(G=L;L<B&&d(u.charCodeAt(L));)L++;if(L<B&&L!==G){for(G=L;L<B&&!d(u.charCodeAt(L));)L++;L===B?P=L:L!==G&&(P=L+1)}}}}else if(l(W)&&u.charCodeAt(1)===v){if(B<=2)return N.root=N.dir=u,N;if(P=2,d(u.charCodeAt(2))){if(B===3)return N.root=N.dir=u,N;P=3}}P>0&&(N.root=u.slice(0,P));let z=-1,y=P,O=-1,H=!0,E=u.length-1,R=0;for(;E>=P;--E){if(W=u.charCodeAt(E),d(W)){if(!H){y=E+1;break}continue}O===-1&&(H=!1,O=E+1),W===S?z===-1?z=E:R!==1&&(R=1):z!==-1&&(R=-1)}return O!==-1&&(z===-1||R===0||R===1&&z===O-1&&z===y+1?N.base=N.name=u.slice(y,O):(N.name=u.slice(y,z),N.base=u.slice(y,O),N.ext=u.slice(z,O))),y>0&&y!==P?N.dir=u.slice(0,y-1):N.dir=N.root,N},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(s){const u=/\\/g;return()=>{const N=A.cwd().replace(u,"/");return N.slice(N.indexOf("/"))}}return()=>A.cwd()})();e.$gc={resolve(...u){let N="",B=!1;for(let P=u.length-1;P>=-1&&!B;P--){const W=P>=0?u[P]:b();t(W,"path"),W.length!==0&&(N=`${W}/${N}`,B=W.charCodeAt(0)===m)}return N=$(N,!B,"/",c),B?`/${N}`:N.length>0?N:"."},normalize(u){if(t(u,"path"),u.length===0)return".";const N=u.charCodeAt(0)===m,B=u.charCodeAt(u.length-1)===m;return u=$(u,!N,"/",c),u.length===0?N?"/":B?"./":".":(B&&(u+="/"),N?`/${u}`:u)},isAbsolute(u){return t(u,"path"),u.length>0&&u.charCodeAt(0)===m},join(...u){if(u.length===0)return".";let N;for(let B=0;B<u.length;++B){const P=u[B];t(P,"path"),P.length>0&&(N===void 0?N=P:N+=`/${P}`)}return N===void 0?".":e.$gc.normalize(N)},relative(u,N){if(t(u,"from"),t(N,"to"),u===N||(u=e.$gc.resolve(u),N=e.$gc.resolve(N),u===N))return"";const B=1,P=u.length,W=P-B,z=1,y=N.length-z,O=W<y?W:y;let H=-1,E=0;for(;E<O;E++){const L=u.charCodeAt(B+E);if(L!==N.charCodeAt(z+E))break;L===m&&(H=E)}if(E===O)if(y>O){if(N.charCodeAt(z+E)===m)return N.slice(z+E+1);if(E===0)return N.slice(z+E)}else W>O&&(u.charCodeAt(B+E)===m?H=E:E===0&&(H=0));let R="";for(E=B+H+1;E<=P;++E)(E===P||u.charCodeAt(E)===m)&&(R+=R.length===0?"..":"/..");return`${R}${N.slice(z+H)}`},toNamespacedPath(u){return u},dirname(u){if(t(u,"path"),u.length===0)return".";const N=u.charCodeAt(0)===m;let B=-1,P=!0;for(let W=u.length-1;W>=1;--W)if(u.charCodeAt(W)===m){if(!P){B=W;break}}else P=!1;return B===-1?N?"/":".":N&&B===1?"//":u.slice(0,B)},basename(u,N){N!==void 0&&t(N,"ext"),t(u,"path");let B=0,P=-1,W=!0,z;if(N!==void 0&&N.length>0&&N.length<=u.length){if(N===u)return"";let y=N.length-1,O=-1;for(z=u.length-1;z>=0;--z){const H=u.charCodeAt(z);if(H===m){if(!W){B=z+1;break}}else O===-1&&(W=!1,O=z+1),y>=0&&(H===N.charCodeAt(y)?--y===-1&&(P=z):(y=-1,P=O))}return B===P?P=O:P===-1&&(P=u.length),u.slice(B,P)}for(z=u.length-1;z>=0;--z)if(u.charCodeAt(z)===m){if(!W){B=z+1;break}}else P===-1&&(W=!1,P=z+1);return P===-1?"":u.slice(B,P)},extname(u){t(u,"path");let N=-1,B=0,P=-1,W=!0,z=0;for(let y=u.length-1;y>=0;--y){const O=u.charCodeAt(y);if(O===m){if(!W){B=y+1;break}continue}P===-1&&(W=!1,P=y+1),O===S?N===-1?N=y:z!==1&&(z=1):N!==-1&&(z=-1)}return N===-1||P===-1||z===0||z===1&&N===P-1&&N===B+1?"":u.slice(N,P)},format:f.bind(null,"/"),parse(u){t(u,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return N;const B=u.charCodeAt(0)===m;let P;B?(N.root="/",P=1):P=0;let W=-1,z=0,y=-1,O=!0,H=u.length-1,E=0;for(;H>=P;--H){const R=u.charCodeAt(H);if(R===m){if(!O){z=H+1;break}continue}y===-1&&(O=!1,y=H+1),R===S?W===-1?W=H:E!==1&&(E=1):W!==-1&&(E=-1)}if(y!==-1){const R=z===0&&B?1:z;W===-1||E===0||E===1&&W===y-1&&W===z+1?N.base=N.name=u.slice(R,y):(N.name=u.slice(R,W),N.base=u.slice(R,y),N.ext=u.slice(W,y))}return z>0?N.dir=u.slice(0,z-1):B&&(N.dir="/"),N},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=s?e.$fc.normalize:e.$gc.normalize,e.$ic=s?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=s?e.$fc.join:e.$gc.join,e.$kc=s?e.$fc.resolve:e.$gc.resolve,e.$lc=s?e.$fc.relative:e.$gc.relative,e.$mc=s?e.$fc.dirname:e.$gc.dirname,e.$nc=s?e.$fc.basename:e.$gc.basename,e.$oc=s?e.$fc.extname:e.$gc.extname,e.$pc=s?e.$fc.format:e.$gc.format,e.$qc=s?e.$fc.parse:e.$gc.parse,e.$rc=s?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=s?e.$fc.sep:e.$gc.sep,e.$tc=s?e.$fc.delimiter:e.$gc.delimiter}),define($e[116],pe([1,0,24,5,10,7]),function(ne,e,A,C,n,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function D(z){return z===47||z===92}e.$2f=D;function S(z){return z.replace(/[\\/]/g,A.$gc.sep)}e.$3f=S;function m(z){return z.indexOf("/")===-1&&(z=S(z)),/^[a-zA-Z]:(\/|$)/.test(z)&&(z="/"+z),z}e.$4f=m;function p(z,y=A.$gc.sep){if(!z)return"";const O=z.length,H=z.charCodeAt(0);if(D(H)){if(D(z.charCodeAt(1))&&!D(z.charCodeAt(2))){let R=3;const L=R;for(;R<O&&!D(z.charCodeAt(R));R++);if(L!==R&&!D(z.charCodeAt(R+1))){for(R+=1;R<O;R++)if(D(z.charCodeAt(R)))return z.slice(0,R+1).replace(/[\\/]/g,y)}}return y}else if(c(H)&&z.charCodeAt(1)===58)return D(z.charCodeAt(2))?z.slice(0,2)+y:z.slice(0,2);let E=z.indexOf("://");if(E!==-1){for(E+=3;E<O;E++)if(D(z.charCodeAt(E)))return z.slice(0,E+1)}return""}e.$5f=p;function v(z){if(!C.$i||!z||z.length<5)return!1;let y=z.charCodeAt(0);if(y!==92||(y=z.charCodeAt(1),y!==92))return!1;let O=2;const H=O;for(;O<z.length&&(y=z.charCodeAt(O),y!==92);O++);return!(H===O||(y=z.charCodeAt(O+1),isNaN(y)||y===92))}e.$6f=v;const I=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(z,y=C.$i){const O=y?I:a;return!(!z||z.length===0||/^\s+$/.test(z)||(O.lastIndex=0,O.test(z))||y&&h.test(z)||z==="."||z===".."||y&&z[z.length-1]==="."||y&&z.length!==z.trim().length||z.length>255)}e.$7f=t;function s(z,y,O){const H=z===y;return!O||H?H:!z||!y?!1:(0,n.$af)(z,y)}e.$8f=s;function d(z,y,O,H=A.sep){if(z===y)return!0;if(!z||!y||y.length>z.length)return!1;if(O){if(!(0,n.$bf)(z,y))return!1;if(y.length===z.length)return!0;let R=y.length;return y.charAt(y.length-1)===H&&R--,z.charAt(R)===H}return y.charAt(y.length-1)!==H&&(y+=H),z.indexOf(y)===0}e.$9f=d;function c(z){return z>=65&&z<=90||z>=97&&z<=122}e.$0f=c;function l(z,y){return C.$i&&z.endsWith(":")&&(z+=A.sep),(0,A.$ic)(z)||(z=(0,A.$jc)(y,z)),z=(0,A.$hc)(z),C.$i?(z=(0,n.$Ve)(z,A.sep),z.endsWith(":")&&(z+=A.sep)):(z=(0,n.$Ve)(z,A.sep),z||(z=A.sep)),z}e.$$f=l;function $(z){const y=(0,A.$hc)(z);return C.$i?z.length>3?!1:f(y)&&(z.length===2||y.charCodeAt(2)===92):y===A.$gc.sep}e.$_f=$;function f(z,y=C.$i){return y?c(z.charCodeAt(0))&&z.charCodeAt(1)===58:!1}e.$ag=f;function b(z,y=C.$i){return f(z,y)?z[0]:void 0}e.$bg=b;function u(z,y,O){return y.length>z.length?-1:z===y?0:(O&&(z=z.toLowerCase(),y=y.toLowerCase()),z.indexOf(y))}e.$cg=u;function N(z){const y=z.split(":");let O,H,E;for(const R of y){const L=Number(R);(0,U.$Nf)(L)?H===void 0?H=L:E===void 0&&(E=L):O=O?[O,R].join(":"):R}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:H!==void 0?H:void 0,column:E!==void 0?E:H!==void 0?1:void 0}}e.$dg=N;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",P="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function W(z,y,O=8){let H="";for(let R=0;R<O;R++){let L;R===0&&C.$i&&!y&&(O===3||O===4)?L=P:L=B,H+=L.charAt(Math.floor(Math.random()*L.length))}let E;return y?E=`${y}-${H}`:E=H,z?(0,A.$jc)(z,E):E}e.$eg=W}),define($e[117],pe([1,0,24]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(v){const I=(0,A.$oc)(v),a=C[I.toLowerCase()];return a!==void 0?a:D(v)}e.$is=U;function D(v){const I=(0,A.$oc)(v);return n[I.toLowerCase()]}e.$js=D;function S(v){for(const I in n)if(n[I]===v)return I}e.$ks=S;const m=/^(.+)\/(.+?)(;.+)?$/;function p(v,I){const a=m.exec(v);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:I?void 0:v}e.$ls=p}),define($e[15],pe([1,0,24,5]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,U=/^\//,D=/^\/\//;function S(P,W){if(!P.scheme&&W)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${P.authority}", path: "${P.path}", query: "${P.query}", fragment: "${P.fragment}"}`);if(P.scheme&&!n.test(P.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(P.path){if(P.authority){if(!U.test(P.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(P.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(P,W){return!P&&!W?"file":P}function p(P,W){switch(P){case"https":case"http":case"file":W?W[0]!==I&&(W=I+W):W=I;break}return W}const v="",I="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(W){return W instanceof h?!0:W?typeof W.authority=="string"&&typeof W.fragment=="string"&&typeof W.path=="string"&&typeof W.query=="string"&&typeof W.scheme=="string"&&typeof W.fsPath=="string"&&typeof W.with=="function"&&typeof W.toString=="function":!1}constructor(W,z,y,O,H,E=!1){typeof W=="object"?(this.scheme=W.scheme||v,this.authority=W.authority||v,this.path=W.path||v,this.query=W.query||v,this.fragment=W.fragment||v):(this.scheme=m(W,E),this.authority=z||v,this.path=p(this.scheme,y||v),this.query=O||v,this.fragment=H||v,S(this,E))}get fsPath(){return f(this,!1)}with(W){if(!W)return this;let{scheme:z,authority:y,path:O,query:H,fragment:E}=W;return z===void 0?z=this.scheme:z===null&&(z=v),y===void 0?y=this.authority:y===null&&(y=v),O===void 0?O=this.path:O===null&&(O=v),H===void 0?H=this.query:H===null&&(H=v),E===void 0?E=this.fragment:E===null&&(E=v),z===this.scheme&&y===this.authority&&O===this.path&&H===this.query&&E===this.fragment?this:new d(z,y,O,H,E)}static parse(W,z=!1){const y=a.exec(W);return y?new d(y[2]||v,B(y[4]||v),B(y[5]||v),B(y[7]||v),B(y[9]||v),z):new d(v,v,v,v,v)}static file(W){let z=v;if(C.$i&&(W=W.replace(/\\/g,I)),W[0]===I&&W[1]===I){const y=W.indexOf(I,2);y===-1?(z=W.substring(2),W=I):(z=W.substring(2,y),W=W.substring(y)||I)}return new d("file",z,W,v,v)}static from(W,z){return new d(W.scheme,W.authority,W.path,W.query,W.fragment,z)}static joinPath(W,...z){if(!W.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return C.$i&&W.scheme==="file"?y=h.file(A.$fc.join(f(W,!0),...z)).path:y=A.$gc.join(W.path,...z),W.with({path:y})}toString(W=!1){return b(this,W)}toJSON(){return this}static revive(W){if(W){if(W instanceof h)return W;{const z=new d(W);return z._formatted=W.external??null,z._fsPath=W._sep===s?W.fsPath??null:null,z}}else return W}}e.URI=h;function t(P){return!P||typeof P!="object"?!1:typeof P.scheme=="string"&&(typeof P.authority=="string"||typeof P.authority>"u")&&(typeof P.path=="string"||typeof P.path>"u")&&(typeof P.query=="string"||typeof P.query>"u")&&(typeof P.fragment=="string"||typeof P.fragment>"u")}e.$vc=t;const s=C.$i?1:void 0;class d extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(W=!1){return W?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const W={$mid:1};return this._fsPath&&(W.fsPath=this._fsPath,W._sep=s),this._formatted&&(W.external=this._formatted),this.path&&(W.path=this.path),this.scheme&&(W.scheme=this.scheme),this.authority&&(W.authority=this.authority),this.query&&(W.query=this.query),this.fragment&&(W.fragment=this.fragment),W}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function l(P,W,z){let y,O=-1;for(let H=0;H<P.length;H++){const E=P.charCodeAt(H);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||W&&E===47||z&&E===91||z&&E===93||z&&E===58)O!==-1&&(y+=encodeURIComponent(P.substring(O,H)),O=-1),y!==void 0&&(y+=P.charAt(H));else{y===void 0&&(y=P.substr(0,H));const R=c[E];R!==void 0?(O!==-1&&(y+=encodeURIComponent(P.substring(O,H)),O=-1),y+=R):O===-1&&(O=H)}}return O!==-1&&(y+=encodeURIComponent(P.substring(O))),y!==void 0?y:P}function $(P){let W;for(let z=0;z<P.length;z++){const y=P.charCodeAt(z);y===35||y===63?(W===void 0&&(W=P.substr(0,z)),W+=c[y]):W!==void 0&&(W+=P[z])}return W!==void 0?W:P}function f(P,W){let z;return P.authority&&P.path.length>1&&P.scheme==="file"?z=`//${P.authority}${P.path}`:P.path.charCodeAt(0)===47&&(P.path.charCodeAt(1)>=65&&P.path.charCodeAt(1)<=90||P.path.charCodeAt(1)>=97&&P.path.charCodeAt(1)<=122)&&P.path.charCodeAt(2)===58?W?z=P.path.substr(1):z=P.path[1].toLowerCase()+P.path.substr(2):z=P.path,C.$i&&(z=z.replace(/\//g,"\\")),z}e.$wc=f;function b(P,W){const z=W?$:l;let y="",{scheme:O,authority:H,path:E,query:R,fragment:L}=P;if(O&&(y+=O,y+=":"),(H||O==="file")&&(y+=I,y+=I),H){let G=H.indexOf("@");if(G!==-1){const Z=H.substr(0,G);H=H.substr(G+1),G=Z.lastIndexOf(":"),G===-1?y+=z(Z,!1,!1):(y+=z(Z.substr(0,G),!1,!1),y+=":",y+=z(Z.substr(G+1),!1,!0)),y+="@"}H=H.toLowerCase(),G=H.lastIndexOf(":"),G===-1?y+=z(H,!1,!0):(y+=z(H.substr(0,G),!1,!0),y+=H.substr(G))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const G=E.charCodeAt(1);G>=65&&G<=90&&(E=`/${String.fromCharCode(G+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const G=E.charCodeAt(0);G>=65&&G<=90&&(E=`${String.fromCharCode(G+32)}:${E.substr(2)}`)}y+=z(E,!0,!1)}return R&&(y+="?",y+=z(R,!1,!1)),L&&(y+="#",y+=W?L:l(L,!1,!1)),y}function u(P){try{return decodeURIComponent(P)}catch{return P.length>3?P.substr(0,3)+u(P.substr(3)):P}}const N=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function B(P){return P.match(N)?P.replace(N,W=>u(W)):P}}),define($e[53],pe([1,0,34,15]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function n(m){return JSON.stringify(m,D)}e.$Ch=n;function U(m){let p=JSON.parse(m);return p=S(p),p}e.$Dh=U;function D(m,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:p.flags}:p}function S(m,p=0){if(!m||p>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return C.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof A.$ke||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let v=0;v<m.length;++v)m[v]=S(m[v],p+1);else for(const v in m)Object.hasOwnProperty.call(m,v)&&(m[v]=S(m[v],p+1))}return m}e.$Eh=S}),define($e[31],pe([1,0,6,5,10,15]),function(ne,e,A,C,n,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var D;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function S(a,h){return U.URI.isUri(a)?(0,n.$af)(a.scheme,h):(0,n.$bf)(a,h+":")}e.$fg=S;function m(a,...h){return h.some(t=>S(a,t))}e.$gg=m,e.$hg="vscode-tkn",e.$ig="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${D.vscodeRemoteResource}`}set(h,t,s){this.a[h]=t,this.b[h]=s}setConnectionToken(h,t){this.c[h]=t}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch($){return A.$1($),h}const t=h.authority;let s=this.a[t];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const d=this.b[t],c=this.c[t];let l=`path=${encodeURIComponent(h.path)}`;return typeof c=="string"&&(l+=`&${e.$ig}=${encodeURIComponent(c)}`),U.URI.from({scheme:C.$o?this.d:D.vscodeRemoteResource,authority:`${s}:${d}`,path:this.f,query:l})}}e.$jg=new p,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class v{static{this.a=e.$og}asBrowserUri(h){const t=this.b(h,ne);return this.uriToBrowserUri(t)}uriToBrowserUri(h){return h.scheme===D.vscodeRemote?e.$jg.rewrite(h):h.scheme===D.file&&(C.$m||C.$q===`${D.vscodeFileResource}://${v.a}`)?h.with({scheme:D.vscodeFileResource,authority:h.authority||v.a,query:null,fragment:null}):h}asFileUri(h){const t=this.b(h,ne);return this.uriToFileUri(t)}uriToFileUri(h){return h.scheme===D.vscodeFileResource?h.with({scheme:D.file,authority:h.authority!==v.a?h.authority:null,query:null,fragment:null}):h}b(h,t){return U.URI.isUri(h)?h:U.URI.parse(t.toUrl(h))}}e.$pg=new v;var I;(function(a){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(h.get("3"));const t="vscode-coi";function s(c){let l;typeof c=="string"?l=new URL(c).searchParams:c instanceof URL?l=c.searchParams:U.URI.isUri(c)&&(l=new URL(c.toString(!0)).searchParams);const $=l?.get(t);if($)return h.get($)}a.getHeadersFromQuery=s;function d(c,l,$){if(!globalThis.crossOriginIsolated)return;const f=l&&$?"3":$?"2":"1";c instanceof URLSearchParams?c.set(t,f):c[t]=f}a.addSearchParam=d})(I||(e.COI=I={}))}),define($e[38],pe([1,0,116,31,24,5,10,15]),function(ne,e,A,C,n,U,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function m(h){return(0,S.$wc)(h,!0)}e.$wg=m;class p{constructor(t){this.a=t}compare(t,s,d=!1){return t===s?0:(0,D.$6e)(this.getComparisonKey(t,d),this.getComparisonKey(s,d))}isEqual(t,s,d=!1){return t===s?!0:!t||!s?!1:this.getComparisonKey(t,d)===this.getComparisonKey(s,d)}getComparisonKey(t,s=!1){return t.with({path:this.a(t)?t.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(t){return this.a(t)}isEqualOrParent(t,s,d=!1){if(t.scheme===s.scheme){if(t.scheme===C.Schemas.file)return A.$9f(m(t),m(s),this.a(t))&&t.query===s.query&&(d||t.fragment===s.fragment);if((0,e.$Ng)(t.authority,s.authority))return A.$9f(t.path,s.path,this.a(t),"/")&&t.query===s.query&&(d||t.fragment===s.fragment)}return!1}joinPath(t,...s){return S.URI.joinPath(t,...s)}basenameOrAuthority(t){return(0,e.$Fg)(t)||t.authority}basename(t){return n.$gc.basename(t.path)}extname(t){return n.$gc.extname(t.path)}dirname(t){if(t.path.length===0)return t;let s;return t.scheme===C.Schemas.file?s=S.URI.file(n.$mc(m(t))).path:(s=n.$gc.dirname(t.path),t.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),s="/")),t.with({path:s})}normalizePath(t){if(!t.path.length)return t;let s;return t.scheme===C.Schemas.file?s=S.URI.file(n.$hc(m(t))).path:s=n.$gc.normalize(t.path),t.with({path:s})}relativePath(t,s){if(t.scheme!==s.scheme||!(0,e.$Ng)(t.authority,s.authority))return;if(t.scheme===C.Schemas.file){const l=n.$lc(m(t),m(s));return U.$i?A.$3f(l):l}let d=t.path||"/";const c=s.path||"/";if(this.a(t)){let l=0;for(const $=Math.min(d.length,c.length);l<$&&!(d.charCodeAt(l)!==c.charCodeAt(l)&&d.charAt(l).toLowerCase()!==c.charAt(l).toLowerCase());l++);d=c.substr(0,l)+d.substr(l)}return n.$gc.relative(d,c)}resolvePath(t,s){if(t.scheme===C.Schemas.file){const d=S.URI.file(n.$kc(m(t),s));return t.with({authority:d.authority,path:d.path})}return s=A.$4f(s),t.with({path:n.$gc.resolve(t.path,s)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,s){return t===s||t!==void 0&&s!==void 0&&(0,D.$af)(t,s)}hasTrailingPathSeparator(t,s=n.sep){if(t.scheme===C.Schemas.file){const d=m(t);return d.length>A.$5f(d).length&&d[d.length-1]===s}else{const d=t.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,s=n.sep){return(0,e.$Og)(t,s)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,s=n.sep){let d=!1;if(t.scheme===C.Schemas.file){const c=m(t);d=c!==void 0&&c.length===A.$5f(c).length&&c[c.length-1]===s}else{s="/";const c=t.path;d=c.length===1&&c.charCodeAt(c.length-1)===47}return!d&&!(0,e.$Og)(t,s)?t.with({path:t.path+"/"}):t}}e.$xg=p,e.$yg=new p(()=>!1),e.$zg=new p(h=>h.scheme===C.Schemas.file?!U.$k:!0),e.$Ag=new p(h=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function v(h,t){const s=[];for(let d=0;d<h.length;d++){const c=t(h[d]);h.some((l,$)=>$===d?!1:(0,e.$Cg)(c,t(l)))||s.push(h[d])}return s}e.$Rg=v;var I;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function t(s){const d=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach($=>{const[f,b]=$.split(":");f&&b&&d.set(f,b)});const l=s.path.substring(0,s.path.indexOf(";"));return l&&d.set(h.META_DATA_MIME,l),d}h.parseMetaData=t})(I||(e.DataUri=I={}));function a(h,t,s){if(t){let d=h.path;return d&&d[0]!==n.$gc.sep&&(d=n.$gc.sep+d),h.with({scheme:s,authority:t,path:d})}return h.with({scheme:s})}e.$Sg=a}),define($e[9],pe([1,0,29,6,4,3,38,5,50,23]),function(ne,e,A,C,n,U,D,S,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function v(F){return!!F&&typeof F.then=="function"}e.$Tg=v;function I(F){const r=new A.$7d,i=F(r.token),o=new Promise((w,M)=>{const T=r.token.onCancellationRequested(()=>{T.dispose(),M(new C.$5)});Promise.resolve(i).then(j=>{T.dispose(),r.dispose(),w(j)},j=>{T.dispose(),r.dispose(),M(j)})});return new class{cancel(){r.cancel(),r.dispose()}then(w,M){return o.then(w,M)}catch(w){return this.then(void 0,w)}finally(w){return o.finally(w)}}}e.$Ug=I;function a(F,r,i){return new Promise((o,w)=>{const M=r.onCancellationRequested(()=>{M.dispose(),o(i)});F.then(o,w).finally(()=>M.dispose())})}e.$Vg=a;function h(F,r){return new Promise((i,o)=>{const w=r.onCancellationRequested(()=>{w.dispose(),o(new C.$5)});F.then(i,o).finally(()=>w.dispose())})}e.$Wg=h;async function t(F){let r=-1;const i=F.map((o,w)=>o.then(M=>(r=w,M)));try{return await Promise.race(i)}finally{F.forEach((o,w)=>{w!==r&&o.cancel()})}}e.$Xg=t;function s(F,r,i){let o;const w=setTimeout(()=>{o?.(void 0),i?.()},r);return Promise.race([F.finally(()=>clearTimeout(w)),new Promise(M=>o=M)])}e.$Yg=s;function d(F){return new Promise((r,i)=>{const o=F();v(o)?o.then(r,i):r(o)})}e.$Zg=d;function c(){let F,r;return{promise:new Promise((o,w)=>{F=o,r=w}),resolve:F,reject:r}}e.$1g=c;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(r){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=r,!this.b){const i=()=>{if(this.b=null,this.f)return;const o=this.queue(this.d);return this.d=null,o};this.b=new Promise(o=>{this.a.then(i,i).then(o)})}return new Promise((i,o)=>{this.b.then(i,o)})}return this.a=r(),new Promise((i,o)=>{this.a.then(w=>{this.a=null,i(w)},w=>{this.a=null,o(w)})})}dispose(){this.f=!0}}e.$2g=l;class ${constructor(){this.a=Promise.resolve(null)}queue(r){return this.a=this.a.then(()=>r(),()=>r())}}e.$3g=$;class f{constructor(){this.a=new Map}queue(r,i){const w=(this.a.get(r)??Promise.resolve()).catch(()=>{}).then(i).finally(()=>{this.a.get(r)===w&&this.a.delete(r)});return this.a.set(r,w),w}}e.$4g=f;const b=(F,r)=>{let i=!0;const o=setTimeout(()=>{i=!1,r()},F);return{isTriggered:()=>i,dispose:()=>{clearTimeout(o),i=!1}}},u=F=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,F())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class N{constructor(r){this.defaultDelay=r,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(r,i=this.defaultDelay){this.g=r,this.h(),this.b||(this.b=new Promise((w,M)=>{this.d=w,this.f=M}).then(()=>{if(this.b=null,this.d=null,this.g){const w=this.g;return this.g=null,w()}}));const o=()=>{this.a=null,this.d?.(null)};return this.a=i===m.$Td?u(o):b(i,o),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=N;class B{constructor(r){this.a=new N(r),this.b=new l}trigger(r,i){return this.a.trigger(()=>this.b.queue(r),i)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=B;class P{constructor(){this.a=!1,this.b=new Promise((r,i)=>{this.d=r})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=P;class W extends P{constructor(r){super(),this.f=setTimeout(()=>this.open(),r)}open(){clearTimeout(this.f),super.open()}}e.$8g=W;function z(F,r){return r?new Promise((i,o)=>{const w=setTimeout(()=>{M.dispose(),i()},F),M=r.onCancellationRequested(()=>{clearTimeout(w),M.dispose(),o(new C.$5)})}):I(i=>z(F,i))}e.$9g=z;function y(F,r=0,i){const o=setTimeout(()=>{F(),i&&w.dispose()},r),w=(0,U.$Rc)(()=>{clearTimeout(o),i?.deleteAndLeak(w)});return i?.add(w),w}e.$0g=y;function O(F){const r=[];let i=0;const o=F.length;function w(){return i<o?F[i++]():null}function M(T){T!=null&&r.push(T);const j=w();return j?j.then(M):Promise.resolve(r)}return Promise.resolve(null).then(M)}e.$$g=O;function H(F,r=o=>!!o,i=null){let o=0;const w=F.length,M=()=>{if(o>=w)return Promise.resolve(i);const T=F[o++];return Promise.resolve(T()).then(_=>r(_)?Promise.resolve(_):M())};return M()}e.$_g=H;function E(F,r=o=>!!o,i=null){if(F.length===0)return Promise.resolve(i);let o=F.length;const w=()=>{o=-1;for(const M of F)M.cancel?.()};return new Promise((M,T)=>{for(const j of F)j.then(_=>{--o>=0&&r(_)?(w(),M(_)):o===0&&M(i)}).catch(_=>{--o>=0&&(w(),T(_))})})}e.$ah=E;class R{constructor(r){this.a=0,this.b=!1,this.f=r,this.g=[],this.d=0,this.h=new n.$Wd}whenIdle(){return this.size>0?n.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(r){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((i,o)=>{this.g.push({factory:r,c:i,e:o}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const r=this.g.shift();this.d++;const i=r.factory();i.then(r.c,r.e),i.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=R;class L extends R{constructor(){super(1)}}e.$ch=L;class G{constructor(){this.a=new ae,this.b=0}queue(r){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,r())):this.a.run(this.b++,r())}}e.$dh=G;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const r=new x;return this.b.add(r),r.p}g(){for(const[,r]of this.a)if(r.size>0)return!1;return!0}queueSize(r,i=D.$yg){const o=i.getComparisonKey(r);return this.a.get(o)?.size??0}queueFor(r,i,o=D.$yg){const w=o.getComparisonKey(r);let M=this.a.get(w);if(!M){M=new L;const T=this.f++,j=n.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(w),this.h(),this.d?.deleteAndDispose(T),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$3c),this.d.set(T,j),this.a.set(w,M)}return M.queue(i)}h(){this.g()&&this.j()}j(){for(const r of this.b)r.complete();this.b.clear()}dispose(){for(const[,r]of this.a)r.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=Z;class ge{constructor(r,i){this.a=-1,typeof r=="function"&&typeof i=="number"&&this.setIfNotSet(r,i)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(r,i){this.cancel(),this.a=setTimeout(()=>{this.a=-1,r()},i)}setIfNotSet(r,i){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,r()},i))}}e.$fh=ge;class he{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(r,i,o=globalThis){this.cancel();const w=o.setInterval(()=>{r()},i);this.d=(0,U.$Rc)(()=>{o.clearInterval(w),this.d=void 0})}dispose(){this.cancel()}}e.$gh=he;class ie{constructor(r,i){this.b=-1,this.a=r,this.d=i,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(r=this.d){this.cancel(),this.b=setTimeout(this.f,r)}get delay(){return this.d}set delay(r){this.d=r}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=ie;class fe{constructor(r,i){i%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${i}ms is not a multiple of 1000ms.`),this.a=r,this.b=i,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(r=this.b){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(r/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=fe;class Re extends ie{constructor(r,i){super(r,i),this.j=[]}work(r){this.j.push(r),this.isScheduled()||this.schedule()}h(){const r=this.j;this.j=[],this.a?.(r)}dispose(){this.j=[],super.dispose()}}e.$jh=Re;class Ne extends U.$Tc{constructor(r,i){super(),this.g=r,this.h=i,this.a=[],this.b=this.B(new U.$Uc),this.f=!1}get pending(){return this.a.length}work(r){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+r.length>this.g.maxBufferedWork)return!1}else if(this.pending+r.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const i of r)this.a.push(i);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=Ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(F,r)=>{(0,S.$B)(()=>{if(i)return;const o=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,o-Date.now())}}))});let i=!1;return{dispose(){i||(i=!0)}}}:e.$mh=(F,r,i)=>{const o=F.requestIdleCallback(r,typeof i=="number"?{timeout:i}:void 0);let w=!1;return{dispose(){w||(w=!0,F.cancelIdleCallback(o))}}},e.$lh=F=>(0,e.$mh)(globalThis,F)}();class Be{constructor(r,i){this.g=!1,this.d=()=>{try{this.j=i()}catch(o){this.l=o}finally{this.g=!0}},this.f=(0,e.$mh)(r,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=Be;class se extends Be{constructor(r){super(globalThis,r)}}e.$oh=se;async function J(F,r,i){let o;for(let w=0;w<i;w++)try{return await F()}catch(M){o=M,await z(r)}throw o}e.$ph=J;class ae{isRunning(r){return typeof r=="number"?this.a?.taskId===r:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(r,i,o){return this.a={taskId:r,cancel:()=>o?.(),promise:i},i.then(()=>this.d(r),()=>this.d(r)),i}d(r){this.a&&r===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const r=this.b;this.b=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this.b)this.b.run=r;else{const{promise:i,resolve:o,reject:w}=c();this.b={run:r,promise:i,promiseResolve:o,promiseReject:w}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=ae;class re{constructor(r,i=()=>Date.now()){this.d=r,this.f=i,this.a=0,this.b=0}increment(){const r=this.f();return r-this.a>this.d&&(this.a=r,this.b=0),this.b++,this.b}}e.$rh=re;var X;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(X||(X={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((r,i)=>{this.a=r,this.b=i})}complete(r){return new Promise(i=>{this.a(r),this.d={outcome:0,value:r},i()})}error(r){return new Promise(i=>{this.b(r),this.d={outcome:1,value:r},i()})}cancel(){return this.error(new C.$5)}}e.$sh=x;var te;(function(F){async function r(o){let w;const M=await Promise.all(o.map(T=>T.then(j=>j,j=>{w||(w=j)})));if(typeof w<"u")throw w;return M}F.settled=r;function i(o){return new Promise(async(w,M)=>{try{await o(w,M)}catch(T){M(T)}})}F.withAsyncBody=i})(te||(e.Promises=te={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(r){this.a=void 0,this.b=void 0,this.d=!1,this.promise=r.then(i=>(this.a=i,this.d=!0,i),i=>{throw this.b=i,this.d=!0,i})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=ce;class ye{constructor(r){this.b=r,this.a=new p.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=ye;var Te;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(Te||(Te={}));class Ae{static fromArray(r){return new Ae(i=>{i.emitMany(r)})}static fromPromise(r){return new Ae(async i=>{i.emitMany(await r)})}static fromPromises(r){return new Ae(async i=>{await Promise.all(r.map(async o=>i.emitOne(await o)))})}static merge(r){return new Ae(async i=>{await Promise.all(r.map(async o=>{for await(const w of o)i.emitOne(w)}))})}static{this.EMPTY=Ae.fromArray([])}constructor(r){this.a=0,this.b=[],this.d=null,this.f=new n.$Wd,queueMicrotask(async()=>{const i={emitOne:o=>this.g(o),emitMany:o=>this.h(o),reject:o=>this.k(o)};try{await Promise.resolve(r(i)),this.j()}catch(o){this.k(o)}finally{i.emitOne=void 0,i.emitMany=void 0,i.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(r<this.b.length)return{done:!1,value:this.b[r++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(r,i){return new Ae(async o=>{for await(const w of r)o.emitOne(i(w))})}map(r){return Ae.map(this,r)}static filter(r,i){return new Ae(async o=>{for await(const w of r)i(w)&&o.emitOne(w)})}filter(r){return Ae.filter(this,r)}static coalesce(r){return Ae.filter(r,i=>!!i)}coalesce(){return Ae.coalesce(this)}static async toPromise(r){const i=[];for await(const o of r)i.push(o);return i}toPromise(){return Ae.toPromise(this)}g(r){this.a===0&&(this.b.push(r),this.f.fire())}h(r){this.a===0&&(this.b=this.b.concat(r),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(r){this.a===0&&(this.a=2,this.d=r,this.f.fire())}}e.$vh=Ae;class Q extends Ae{constructor(r,i){super(i),this.l=r}cancel(){this.l.cancel()}}e.$wh=Q;function g(F){const r=new A.$7d,i=F(r.token);return new Q(r,async o=>{const w=r.token.onCancellationRequested(()=>{w.dispose(),r.dispose(),o.reject(new C.$5)});try{for await(const M of i){if(r.token.isCancellationRequested)return;o.emitOne(M)}w.dispose(),r.dispose()}catch(M){w.dispose(),r.dispose(),o.reject(M)}})}e.$xh=g;class k{constructor(){this.a=new x,this.b=new Ae(o=>{if(r){o.reject(r);return}return i&&o.emitMany(i),this.d=w=>o.reject(w),this.f=w=>o.emitOne(w),this.a.p});let r,i;this.f=o=>{i||(i=[]),i.push(o)},this.d=o=>{r||(r=o)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(r){this.d(r),this.a.complete()}emitOne(r){this.f(r)}}e.$yh=k}),define($e[2],pe([1,0,16,114,14,19,9,6,4,118,3,31,5,15,49,21]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a,h,t,s){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$mR=e.$lR=e.h=e.$jR=e.$iR=e.$hR=e.$gR=e.$fR=e.$eR=e.$dR=e.$cR=e.DetectedFullscreenMode=e.$bR=e.$aR=e.$_Q=e.$$Q=e.$0Q=e.$9Q=e.$8Q=e.$7Q=e.$6Q=e.$5Q=e.$4Q=e.$3Q=e.$2Q=e.$1Q=e.$ZQ=e.$YQ=e.$XQ=e.$=e.Namespace=e.$VQ=e.$UQ=e.$TQ=e.$SQ=e.$RQ=e.$QQ=e.$PQ=e.$OQ=e.$NQ=e.$MQ=e.$LQ=e.$KQ=e.$JQ=e.$IQ=e.$HQ=e.$GQ=e.$FQ=e.$EQ=e.$DQ=e.$CQ=e.$BQ=e.$AQ=e.$zQ=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.$sQ=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.onDidUnregisterWindow=e.onWillUnregisterWindow=e.onDidRegisterWindow=e.hasWindow=e.getWindowById=e.getWindowId=e.getWindowsCount=e.getWindows=e.getDocument=e.getWindow=e.registerWindow=void 0,d=function(){const q=new Map;(0,s.$kP)(s.$lP,1);const V={window:s.$lP,disposables:new v.$Sc};q.set(s.$lP.vscodeWindowId,V);const ee=new m.$Wd,de=new m.$Wd,Se=new m.$Wd;function We(Oe,He){return(typeof Oe=="number"?q.get(Oe):void 0)??(He?V:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:de.event,registerWindow(Oe){if(q.has(Oe.vscodeWindowId))return v.$Tc.None;const He=new v.$Sc,_e={window:Oe,disposables:He.add(new v.$Sc)};return q.set(Oe.vscodeWindowId,_e),He.add((0,v.$Rc)(()=>{q.delete(Oe.vscodeWindowId),de.fire(Oe)})),He.add($(Oe,e.$MQ.BEFORE_UNLOAD,()=>{Se.fire(Oe)})),ee.fire(_e),He},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return q.has(Oe)},getWindowById:We,getWindow(Oe){const He=Oe;if(He?.ownerDocument?.defaultView)return He.ownerDocument.defaultView.window;const _e=Oe;return _e?.view?_e.view.window:s.$lP},getDocument(Oe){const He=Oe;return(0,e.getWindow)(He).document}}}(),e.registerWindow=d.registerWindow,e.getWindow=d.getWindow,e.getDocument=d.getDocument,e.getWindows=d.getWindows,e.getWindowsCount=d.getWindowsCount,e.getWindowId=d.getWindowId,e.getWindowById=d.getWindowById,e.hasWindow=d.hasWindow,e.onDidRegisterWindow=d.onDidRegisterWindow,e.onWillUnregisterWindow=d.onWillUnregisterWindow,e.onDidUnregisterWindow=d.onDidUnregisterWindow;function c(q){for(;q.firstChild;)q.firstChild.remove()}e.$RP=c;class l{constructor(V,ee,de,Se){this.f=V,this.g=ee,this.d=de,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function $(q,V,ee,de){return new l(q,V,ee,de)}e.$SP=$;function f(q,V){return function(ee){return V(new U.$KP(q,ee))}}function b(q){return function(V){return q(new n.$PP(V))}}const u=function(V,ee,de,Se){let We=de;return ee==="click"||ee==="mousedown"?We=f((0,e.getWindow)(V),de):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(We=b(de)),$(V,ee,We,Se)};e.$TP=u;const N=function(V,ee,de){const Se=f((0,e.getWindow)(V),ee);return P(V,Se,de)};e.$UP=N;const B=function(V,ee,de){const Se=f((0,e.getWindow)(V),ee);return z(V,Se,de)};e.$VP=B;function P(q,V,ee){return $(q,a.$r&&C.$HP.pointerEvents?e.$MQ.POINTER_DOWN:e.$MQ.MOUSE_DOWN,V,ee)}e.$WP=P;function W(q,V,ee){return $(q,a.$r&&C.$HP.pointerEvents?e.$MQ.POINTER_MOVE:e.$MQ.MOUSE_MOVE,V,ee)}e.$XP=W;function z(q,V,ee){return $(q,a.$r&&C.$HP.pointerEvents?e.$MQ.POINTER_UP:e.$MQ.MOUSE_UP,V,ee)}e.$YP=z;function y(q,V,ee){return(0,D.$mh)(q,V,ee)}e.$ZP=y;class O extends D.$nh{constructor(V,ee){super(V,ee)}}e.$1P=O;function H(q,V,ee,de){let Se=0;const We=q.setInterval(()=>{Se++,(typeof de=="number"&&Se>=de||V()===!0)&&Oe.dispose()},ee),Oe=(0,v.$Rc)(()=>{q.clearInterval(We)});return Oe}e.$4P=H;class E extends D.$gh{constructor(V){super(),this.f=V&&(0,e.getWindow)(V)}cancelAndSet(V,ee,de){return super.cancelAndSet(V,ee,de??this.f)}}e.$5P=E;class R{constructor(V,ee=0){this.d=V,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(V){(0,S.$1)(V)}}static sort(V,ee){return ee.priority-V.priority}}(function(){const q=new Map,V=new Map,ee=new Map,de=new Map,Se=We=>{ee.set(We,!1);const Oe=q.get(We)??[];for(V.set(We,Oe),q.set(We,[]),de.set(We,!0);Oe.length>0;)Oe.sort(R.sort),Oe.shift().execute();de.set(We,!1)};e.$3P=(We,Oe,He=0)=>{const _e=(0,e.getWindowId)(We),Ve=new R(Oe,He);let at=q.get(_e);return at||(at=[],q.set(_e,at)),at.push(Ve),ee.get(_e)||(ee.set(_e,!0),We.requestAnimationFrame(()=>Se(_e))),Ve},e.$2P=(We,Oe,He)=>{const _e=(0,e.getWindowId)(We);if(de.get(_e)){const Ve=new R(Oe,He);let at=V.get(_e);return at||(at=[],V.set(_e,at)),at.push(Ve),Ve}else return(0,e.$3P)(We,Oe,He)}})();function L(q,V){return(0,e.$3P)(q,V,1e4)}e.$6P=L;function G(q,V){return(0,e.$3P)(q,V,-1e4)}e.$7P=G;const Z=8,ge=function(q,V){return V};class he extends v.$Tc{constructor(V,ee,de,Se=ge,We=Z){super();let Oe=null,He=0;const _e=this.B(new D.$fh),Ve=()=>{He=new Date().getTime(),de(Oe),Oe=null};this.B($(V,ee,at=>{Oe=Se(Oe,at);const Tt=new Date().getTime()-He;Tt>=We?(_e.cancel(),Ve()):_e.setIfNotSet(Ve,We-Tt)}))}}function ie(q,V,ee,de,Se){return new he(q,V,ee,de,Se)}e.$8P=ie;function fe(q){return(0,e.getWindow)(q).getComputedStyle(q,null)}e.$9P=fe;function Re(q,V){const ee=(0,e.getWindow)(q),de=ee.document;if(q!==de.body)return new Be(q.clientWidth,q.clientHeight);if(a.$r&&ee?.visualViewport)return new Be(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Be(ee.innerWidth,ee.innerHeight);if(de.body&&de.body.clientWidth&&de.body.clientHeight)return new Be(de.body.clientWidth,de.body.clientHeight);if(de.documentElement&&de.documentElement.clientWidth&&de.documentElement.clientHeight)return new Be(de.documentElement.clientWidth,de.documentElement.clientHeight);if(V)return Re(V);throw new Error("Unable to figure out browser width and height")}e.$0P=Re;class Ne{static d(V,ee){return parseFloat(ee)||0}static f(V,ee,de){const Se=fe(V),We=Se?Se.getPropertyValue(ee):"0";return Ne.d(V,We)}static getBorderLeftWidth(V){return Ne.f(V,"border-left-width","borderLeftWidth")}static getBorderRightWidth(V){return Ne.f(V,"border-right-width","borderRightWidth")}static getBorderTopWidth(V){return Ne.f(V,"border-top-width","borderTopWidth")}static getBorderBottomWidth(V){return Ne.f(V,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(V){return Ne.f(V,"padding-left","paddingLeft")}static getPaddingRight(V){return Ne.f(V,"padding-right","paddingRight")}static getPaddingTop(V){return Ne.f(V,"padding-top","paddingTop")}static getPaddingBottom(V){return Ne.f(V,"padding-bottom","paddingBottom")}static getMarginLeft(V){return Ne.f(V,"margin-left","marginLeft")}static getMarginTop(V){return Ne.f(V,"margin-top","marginTop")}static getMarginRight(V){return Ne.f(V,"margin-right","marginRight")}static getMarginBottom(V){return Ne.f(V,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(V,ee){this.width=V,this.height=ee}with(V=this.width,ee=this.height){return V!==this.width||ee!==this.height?new Be(V,ee):this}static is(V){return typeof V=="object"&&typeof V.height=="number"&&typeof V.width=="number"}static lift(V){return V instanceof Be?V:new Be(V.width,V.height)}static equals(V,ee){return V===ee?!0:!V||!ee?!1:V.width===ee.width&&V.height===ee.height}}e.$$P=Be;function se(q){let V=q.offsetParent,ee=q.offsetTop,de=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){ee-=q.scrollTop;const Se=M(q)?null:fe(q);Se&&(de-=Se.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===V&&(de+=Ne.getBorderLeftWidth(q),ee+=Ne.getBorderTopWidth(q),ee+=q.offsetTop,de+=q.offsetLeft,V=q.offsetParent)}return{left:de,top:ee}}e.$_P=se;function J(q,V,ee){typeof V=="number"&&(q.style.width=`${V}px`),typeof ee=="number"&&(q.style.height=`${ee}px`)}e.$aQ=J;function ae(q,V,ee,de,Se,We="absolute"){typeof V=="number"&&(q.style.top=`${V}px`),typeof ee=="number"&&(q.style.right=`${ee}px`),typeof de=="number"&&(q.style.bottom=`${de}px`),typeof Se=="number"&&(q.style.left=`${Se}px`),q.style.position=We}e.$bQ=ae;function re(q){const V=q.getBoundingClientRect(),ee=(0,e.getWindow)(q);return{left:V.left+ee.scrollX,top:V.top+ee.scrollY,width:V.width,height:V.height}}e.$cQ=re;function X(q){let V=q,ee=1;do{const de=fe(V).zoom;de!=null&&de!=="1"&&(ee*=de),V=V.parentElement}while(V!==null&&V!==V.ownerDocument.documentElement);return ee}e.$dQ=X;function x(q){const V=Ne.getMarginLeft(q)+Ne.getMarginRight(q);return q.offsetWidth+V}e.$eQ=x;function te(q){const V=Ne.getBorderLeftWidth(q)+Ne.getBorderRightWidth(q),ee=Ne.getPaddingLeft(q)+Ne.getPaddingRight(q);return q.offsetWidth-V-ee}e.$fQ=te;function ce(q){const V=Ne.getMarginLeft(q)+Ne.getMarginRight(q);return q.scrollWidth+V}e.$gQ=ce;function ye(q){const V=Ne.getBorderTopWidth(q)+Ne.getBorderBottomWidth(q),ee=Ne.getPaddingTop(q)+Ne.getPaddingBottom(q);return q.offsetHeight-V-ee}e.$hQ=ye;function Te(q){const V=Ne.getMarginTop(q)+Ne.getMarginBottom(q);return q.offsetHeight+V}e.$iQ=Te;function Ae(q,V){if(q===null)return 0;const ee=se(q),de=se(V);return ee.left-de.left}function Q(q,V){const ee=V.map(Se=>Math.max(ce(Se),x(Se))+Ae(Se,q)||0);return Math.max(...ee)}e.$jQ=Q;function g(q,V){return!!V?.contains(q)}e.$kQ=g;const k="parentFlowToElementId";function F(q,V){q.dataset[k]=V.id}e.$lQ=F;function r(q){const V=q.dataset[k];return typeof V=="string"?q.ownerDocument.getElementById(V):null}function i(q,V){let ee=q;for(;ee;){if(ee===V)return!0;if(ee instanceof HTMLElement){const de=r(ee);if(de){ee=de;continue}}ee=ee.parentNode}return!1}e.$mQ=i;function o(q,V,ee){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(V))return q;if(ee){if(typeof ee=="string"){if(q.classList.contains(ee))return null}else if(q===ee)return null}q=q.parentNode}return null}e.$nQ=o;function w(q,V,ee){return!!o(q,V,ee)}e.$oQ=w;function M(q){return q&&!!q.host&&!!q.mode}e.$pQ=M;function T(q){return!!j(q)}e.$qQ=T;function j(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return M(q)?q:null}e.$rQ=j;function _(){let q=De().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}e.$sQ=_;function Y(q){return _()===q}e.$tQ=Y;function oe(q){return g(_(),q)}e.$uQ=oe;function be(q){return q.ownerDocument===De()}e.$vQ=be;function De(){return(0,e.getWindowsCount)()<=1?s.$lP.document:Array.from((0,e.getWindows)()).map(({window:V})=>V.document).find(V=>V.hasFocus())??s.$lP.document}e.$wQ=De;function we(){return De().defaultView?.window??s.$lP}e.$xQ=we;function Ee(q){const V=(0,e.getWindow)(q);V.document.hasFocus()||V.focus()}e.$yQ=Ee;const ve=new Map;function Pe(q){return ve.has(q)}e.$zQ=Pe;function Me(){return new Ie}e.$AQ=Me;class Ie{constructor(){this.d="",this.f=void 0}setStyle(V){V!==this.d&&(this.d=V,this.f?this.f.innerText=V:this.f=Ye(s.$lP.document.head,ee=>ee.innerText=V))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ye(q=s.$lP.document.head,V,ee){const de=document.createElement("style");if(de.type="text/css",de.media="screen",V?.(de),q.appendChild(de),ee&&ee.add((0,v.$Rc)(()=>q.removeChild(de))),q===s.$lP.document.head){const Se=new Set;ve.set(de,Se);for(const{window:We,disposables:Oe}of(0,e.getWindows)()){if(We===s.$lP)continue;const He=Oe.add(xe(de,Se,We));ee?.add(He)}}return de}e.$BQ=Ye;function et(q){const V=new v.$Sc;for(const[ee,de]of ve)V.add(xe(ee,de,q));return V}e.$CQ=et;function xe(q,V,ee){const de=new v.$Sc,Se=q.cloneNode(!0);ee.document.head.appendChild(Se),de.add((0,v.$Rc)(()=>ee.document.head.removeChild(Se)));for(const We of je(q))Se.sheet?.insertRule(We.cssText,Se.sheet?.cssRules.length);return de.add(e.$DQ.observe(q,de,{childList:!0})(()=>{Se.textContent=q.textContent})),V.add(Se),de.add((0,v.$Rc)(()=>V.delete(Se))),de}e.$DQ=new class{constructor(){this.mutationObservers=new Map}observe(q,V,ee){let de=this.mutationObservers.get(q);de||(de=new Map,this.mutationObservers.set(q,de));const Se=(0,t.$Vi)(ee);let We=de.get(Se);if(We)We.users+=1;else{const Oe=new m.$Wd,He=new MutationObserver(Ve=>Oe.fire(Ve));He.observe(q,ee);const _e=We={users:1,observer:He,onDidMutate:Oe.event};V.add((0,v.$Rc)(()=>{_e.users-=1,_e.users===0&&(Oe.dispose(),He.disconnect(),de?.delete(Se),de?.size===0&&this.mutationObservers.delete(q))})),de.set(Se,We)}return We.onDidMutate}};function K(q=s.$lP.document.head){return me("meta",q)}e.$EQ=K;function le(q=s.$lP.document.head){return me("link",q)}e.$FQ=le;function me(q,V=s.$lP.document.head){const ee=document.createElement(q);return V.appendChild(ee),ee}let ke=null;function Ce(){return ke||(ke=Ye()),ke}function je(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Qe(q,V,ee=Ce()){if(!(!ee||!V)){ee.sheet?.insertRule(`${q} {${V}}`,0);for(const de of ve.get(ee)??[])Qe(q,V,de)}}e.$GQ=Qe;function Ke(q,V=Ce()){if(!V)return;const ee=je(V),de=[];for(let Se=0;Se<ee.length;Se++){const We=ee[Se];Je(We)&&We.selectorText.indexOf(q)!==-1&&de.push(Se)}for(let Se=de.length-1;Se>=0;Se--)V.sheet?.deleteRule(de[Se]);for(const Se of ve.get(V)??[])Ke(q,Se)}e.$HQ=Ke;function Je(q){return typeof q.selectorText=="string"}function tt(q){return q instanceof MouseEvent||q instanceof(0,e.getWindow)(q).MouseEvent}e.$IQ=tt;function Ze(q){return q instanceof KeyboardEvent||q instanceof(0,e.getWindow)(q).KeyboardEvent}e.$JQ=Ze;function nt(q){return q instanceof PointerEvent||q instanceof(0,e.getWindow)(q).PointerEvent}e.$KQ=nt;function st(q){return q instanceof DragEvent||q instanceof(0,e.getWindow)(q).DragEvent}e.$LQ=st,e.$MQ={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:A.$zP?"webkitAnimationStart":"animationstart",ANIMATION_END:A.$zP?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:A.$zP?"webkitAnimationIteration":"animationiteration"};function rt(q){const V=q;return!!(V&&typeof V.preventDefault=="function"&&typeof V.stopPropagation=="function")}e.$NQ=rt,e.$OQ={stop:(q,V)=>(q.preventDefault(),V&&q.stopPropagation(),q)};function gt(q){const V=[];for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)V[ee]=q.scrollTop,q=q.parentNode;return V}e.$PQ=gt;function St(q,V){for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)q.scrollTop!==V[ee]&&(q.scrollTop=V[ee]),q=q.parentNode}e.$QQ=St;class mt extends v.$Tc{static m(V){if(V instanceof HTMLElement){const ee=j(V),de=ee?ee.activeElement:V.ownerDocument.activeElement;return g(de,V)}else{const ee=V;return g(ee.document.activeElement,ee.document)}}constructor(V){super(),this.f=this.B(new m.$Wd),this.onDidFocus=this.f.event,this.g=this.B(new m.$Wd),this.onDidBlur=this.g.event;let ee=mt.m(V),de=!1;const Se=()=>{de=!1,ee||(ee=!0,this.f.fire())},We=()=>{ee&&(de=!0,(V instanceof HTMLElement?(0,e.getWindow)(V):V).setTimeout(()=>{de&&(de=!1,ee=!1,this.g.fire())},0))};this.j=()=>{mt.m(V)!==ee&&(ee?We():Se())},this.B($(V,e.$MQ.FOCUS,Se,!0)),this.B($(V,e.$MQ.BLUR,We,!0)),V instanceof HTMLElement&&(this.B($(V,e.$MQ.FOCUS_IN,()=>this.j())),this.B($(V,e.$MQ.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Ft(q){return new mt(q)}e.$RQ=Ft;function Ot(q,V){return q.after(V),V}e.$SQ=Ot;function ze(q,...V){if(q.append(...V),V.length===1&&typeof V[0]!="string")return V[0]}e.$TQ=ze;function ue(q,V){return q.insertBefore(V,q.firstChild),V}e.$UQ=ue;function Fe(q,...V){q.innerText="",ze(q,...V)}e.$VQ=Fe;const Le=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var qe;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(qe||(e.Namespace=qe={}));function it(q,V,ee,...de){const Se=Le.exec(V);if(!Se)throw new Error("Bad use of emmet");const We=Se[1]||"div";let Oe;return q!==qe.HTML?Oe=document.createElementNS(q,We):Oe=document.createElement(We),Se[3]&&(Oe.id=Se[3]),Se[4]&&(Oe.className=Se[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([He,_e])=>{typeof _e>"u"||(/^on\w+$/.test(He)?Oe[He]=_e:He==="selected"?_e&&Oe.setAttribute(He,"true"):Oe.setAttribute(He,_e))}),Oe.append(...de),Oe}function lt(q,V,...ee){return it(qe.HTML,q,V,...ee)}e.$=lt,lt.SVG=function(q,V,...ee){return it(qe.SVG,q,V,...ee)};function Ge(q,V){const ee=[];return q.forEach((de,Se)=>{Se>0&&(V instanceof Node?ee.push(V.cloneNode()):ee.push(document.createTextNode(V))),ee.push(de)}),ee}e.$XQ=Ge;function ct(q,...V){q?$t(...V):yt(...V)}e.$YQ=ct;function $t(...q){for(const V of q)V.style.display="",V.removeAttribute("aria-hidden")}e.$ZQ=$t;function yt(...q){for(const V of q)V.style.display="none",V.setAttribute("aria-hidden","true")}e.$1Q=yt;function Gt(q,V){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(V))return q;q=q.parentNode}return null}function Ai(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&Gt(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}e.$2Q=Ai;function ki(q){return V=>{V.preventDefault(),V.stopPropagation(),q(V)}}e.$3Q=ki;function Si(q){return new Promise(V=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)V(void 0);else{const de=()=>{q.window.removeEventListener("DOMContentLoaded",de,!1),V()};q.window.addEventListener("DOMContentLoaded",de,!1)}})}e.$4Q=Si;function Fi(q,V){const ee=q.devicePixelRatio*V;return Math.max(1,Math.floor(ee))/q.devicePixelRatio}e.$5Q=Fi;function Ti(q){s.$lP.open(q,"_blank","noopener")}e.$6Q=Ti;const Xt=780,Yt=640;function Ni(q){const V=Math.floor(s.$lP.screenLeft+s.$lP.innerWidth/2-Xt/2),ee=Math.floor(s.$lP.screenTop+s.$lP.innerHeight/2-Yt/2);s.$lP.open(q,"_blank",`width=${Xt},height=${Yt},top=${ee},left=${V}`)}e.$7Q=Ni;function Ci(q,V=!0){const ee=s.$lP.open();return ee?(V&&(ee.opener=null),ee.location.href=q,!0):!1}e.$8Q=Ci;function Pi(q,V){const ee=()=>{V(),de=(0,e.$3P)(q,ee)};let de=(0,e.$3P)(q,ee);return(0,v.$Rc)(()=>de.dispose())}e.$9Q=Pi,I.$jg.setPreferredWebSchema(/^https:/.test(s.$lP.location.href)?"https":"http");function Ri(q){return q?`url('${I.$pg.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}e.$0Q=Ri;function Li(q){return`'${q.replace(/'/g,"%27")}'`}e.$$Q=Li;function Zt(q,V){if(q!==void 0){const ee=q.match(/^\s*var\((.+)\)$/);if(ee){const de=ee[1].split(",",2);return de.length===2&&(V=Zt(de[1].trim(),V)),`var(${de[0]}, ${V})`}return q}return V}e.$_Q=Zt;function Mi(q,V){let ee;if(h.URI.isUri(q))ee=q.toString(!0);else{const We=new Blob([q]);ee=URL.createObjectURL(We),setTimeout(()=>URL.revokeObjectURL(ee))}const de=we(),Se=document.createElement("a");de.document.body.appendChild(Se),Se.download=V,Se.href=ee,Se.click(),setTimeout(()=>de.document.body.removeChild(Se))}e.$aR=Mi;function Ii(){return new Promise(q=>{const V=we(),ee=document.createElement("input");V.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(ee,"input"))(()=>{q(ee.files??void 0)}),ee.click(),setTimeout(()=>V.document.body.removeChild(ee))})}e.$bR=Ii;var Dt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(Dt||(e.DetectedFullscreenMode=Dt={}));function Oi(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:Dt.BROWSER,guess:!1}:(a.$j||a.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:Dt.BROWSER,guess:!0}:null}e.$cR=Oi;function Jt(q,V=!1){const ee=document.createElement("a");return p.addHook("afterSanitizeAttributes",de=>{for(const Se of["href","src"])if(de.hasAttribute(Se)){const We=de.getAttribute(Se);if(Se==="href"&&We.startsWith("#"))continue;if(ee.href=We,!q.includes(ee.protocol.replace(/:$/,""))){if(V&&Se==="src"&&ee.href.startsWith("data:"))continue;de.removeAttribute(Se)}}}),(0,v.$Rc)(()=>{p.removeHook("afterSanitizeAttributes")})}e.$dR=Jt;const Bi=[I.Schemas.http,I.Schemas.https,I.Schemas.command];e.$eR=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Wi(q,V){const ee=Jt(Bi);try{const de=p.sanitize(V,zi);q.innerHTML=de}finally{ee.dispose()}}e.$fR=Wi;function ji(q){const V=new Uint16Array(q.length);for(let Se=0;Se<V.length;Se++)V[Se]=q.charCodeAt(Se);let ee="";const de=new Uint8Array(V.buffer);for(let Se=0;Se<de.length;Se++)ee+=String.fromCharCode(de[Se]);return ee}function Ui(q){return btoa(ji(q))}e.$gR=Ui;class pt extends m.$Wd{constructor(){super(),this.o=new v.$Sc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m.Event.runAndSubscribe(e.onDidRegisterWindow,({window:V,disposables:ee})=>this.C(V,ee),{window:s.$lP,disposables:this.o}))}C(V,ee){ee.add($(V,"keydown",de=>{if(de.defaultPrevented)return;const Se=new n.$PP(de);if(!(Se.keyCode===6&&de.repeat)){if(de.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(de.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(de.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(de.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Se.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyPressed&&(this.A.event=de,this.fire(this.A))}},!0)),ee.add($(V,"keyup",de=>{de.defaultPrevented||(!de.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!de.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!de.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!de.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyReleased&&(this.A.event=de,this.fire(this.A)))},!0)),ee.add($(V.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add($(V.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add($(V.document.body,"mousemove",de=>{de.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add($(V,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}e.$hR=pt;function Hi(q){const V=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return V?V.pop():void 0}e.$iR=Hi;class qi extends v.$Tc{constructor(V,ee){super(),this.j=V,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B($(this.j,e.$MQ.DRAG_START,V=>{this.m.onDragStart?.(V)})),this.m.onDrag&&this.B($(this.j,e.$MQ.DRAG,V=>{this.m.onDrag?.(V)})),this.B($(this.j,e.$MQ.DRAG_ENTER,V=>{this.f++,this.g=V.timeStamp,this.m.onDragEnter?.(V)})),this.B($(this.j,e.$MQ.DRAG_OVER,V=>{V.preventDefault(),this.m.onDragOver?.(V,V.timeStamp-this.g)})),this.B($(this.j,e.$MQ.DRAG_LEAVE,V=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(V))})),this.B($(this.j,e.$MQ.DRAG_END,V=>{this.f=0,this.g=0,this.m.onDragEnd?.(V)})),this.B($(this.j,e.$MQ.DROP,V=>{this.f=0,this.g=0,this.m.onDrop?.(V)}))}}e.$jR=qi;const _i=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Qi(q,...V){let ee,de;Array.isArray(V[0])?(ee={},de=V[0]):(ee=V[0]||{},de=V[1]);const Se=_i.exec(q);if(!Se||!Se.groups)throw new Error("Bad use of h");const We=Se.groups.tag||"div",Oe=document.createElement(We);Se.groups.id&&(Oe.id=Se.groups.id);const He=[];if(Se.groups.class)for(const Ve of Se.groups.class.split("."))Ve!==""&&He.push(Ve);if(ee.className!==void 0)for(const Ve of ee.className.split("."))Ve!==""&&He.push(Ve);He.length>0&&(Oe.className=He.join(" "));const _e={};if(Se.groups.name&&(_e[Se.groups.name]=Oe),de)for(const Ve of de)Ve instanceof HTMLElement?Oe.appendChild(Ve):typeof Ve=="string"?Oe.append(Ve):"root"in Ve&&(Object.assign(_e,Ve),Oe.appendChild(Ve.root));for(const[Ve,at]of Object.entries(ee))if(Ve!=="className")if(Ve==="style")for(const[Tt,Bt]of Object.entries(at))Oe.style.setProperty(ei(Tt),typeof Bt=="number"?Bt+"px":""+Bt);else Ve==="tabIndex"?Oe.tabIndex=at:Oe.setAttribute(ei(Ve),at.toString());return _e.root=Oe,_e}e.h=Qi;function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,V,ee){for(const{name:de,value:Se}of q.attributes)(!ee||ee.includes(de))&&V.setAttribute(de,Se)}e.$lR=ti;function Vi(q,V,ee){const de=q.getAttribute(ee);de?V.setAttribute(ee,de):V.removeAttribute(ee)}function Ki(q,V,ee){ti(q,V,ee);const de=new v.$Sc;return de.add(e.$DQ.observe(q,de,{attributes:!0,attributeFilter:ee})(Se=>{for(const We of Se)We.type==="attributes"&&We.attributeName&&Vi(q,V,We.attributeName)})),de}e.$mR=Ki}),define($e[54],pe([1,0,2,3,117]),function(ne,e,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pR=e.$oR=e.$nR=void 0;class U extends C.$Tc{constructor(m,p){super(),this.B((0,A.$SP)(m,"dragover",v=>{v.preventDefault(),this.a||(this.a=setTimeout(()=>{p(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(v=>{this.B((0,A.$SP)(m,v,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}e.$nR=U,e.$oR={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$hs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(S,m,p,v,I){const a=document.createElement("div");if(a.className=p,a.textContent=m,I&&(a.style.color=I),v&&(a.style.background=v),S.dataTransfer){const h=(0,A.getWindow)(S).document;h.body.appendChild(a),S.dataTransfer.setDragImage(a,-10,-10),setTimeout(()=>h.body.removeChild(a),0)}}e.$pR=D}),define($e[55],pe([1,0,2]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=e.$SR=e.$RR=void 0;function C(a,h={}){const t=U(h);return t.textContent=a,t}e.$RR=C;function n(a,h={}){const t=U(h);return m(t,p(a,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),t}e.$SR=n;function U(a){const h=a.inline?"span":"div",t=document.createElement(h);return a.className&&(t.className=a.className),t}e.$TR=U;class D{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var S;(function(a){a[a.Invalid=0]="Invalid",a[a.Root=1]="Root",a[a.Text=2]="Text",a[a.Bold=3]="Bold",a[a.Italics=4]="Italics",a[a.Action=5]="Action",a[a.ActionClose=6]="ActionClose",a[a.Code=7]="Code",a[a.NewLine=8]="NewLine"})(S||(S={}));function m(a,h,t,s){let d;if(h.type===2)d=document.createTextNode(h.content||"");else if(h.type===3)d=document.createElement("b");else if(h.type===4)d=document.createElement("i");else if(h.type===7&&s)d=document.createElement("code");else if(h.type===5&&t){const c=document.createElement("a");t.disposables.add(A.$TP(c,"click",l=>{t.callback(String(h.index),l)})),d=c}else h.type===8?d=document.createElement("br"):h.type===1&&(d=a);d&&a!==d&&a.appendChild(d),d&&Array.isArray(h.children)&&h.children.forEach(c=>{m(d,c,t,s)})}function p(a,h){const t={type:1,children:[]};let s=0,d=t;const c=[],l=new D(a);for(;!l.eos();){let $=l.next();const f=$==="\\"&&I(l.peek(),h)!==0;if(f&&($=l.next()),!f&&v($,h)&&$===l.peek()){l.advance(),d.type===2&&(d=c.pop());const b=I($,h);if(d.type===b||d.type===5&&b===6)d=c.pop();else{const u={type:b,children:[]};b===5&&(u.index=s,s++),d.children.push(u),c.push(d),d=u}}else if($===`
`)d.type===2&&(d=c.pop()),d.children.push({type:8});else if(d.type!==2){const b={type:2,content:$};d.children.push(b),c.push(d),d=b}else d.content+=$}return d.type===2&&(d=c.pop()),c.length,t}function v(a,h){return I(a,h)!==0}function I(a,h){switch(a){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define($e[56],pe([1,0,2,3]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=void 0;class n{constructor(){this.a=new C.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,S){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const m=this.c;this.c=null,D&&m&&m(S)}isMonitoring(){return!!this.b}startMonitoring(D,S,m,p,v){this.isMonitoring()&&this.stopMonitoring(!1),this.b=p,this.c=v;let I=D;try{D.setPointerCapture(S),this.a.add((0,C.$Rc)(()=>{try{D.releasePointerCapture(S)}catch{}}))}catch{I=A.getWindow(D)}this.a.add(A.$SP(I,A.$MQ.POINTER_MOVE,a=>{if(a.buttons!==m){this.stopMonitoring(!0);return}a.preventDefault(),this.b(a)})),this.a.add(A.$SP(I,A.$MQ.POINTER_UP,a=>this.stopMonitoring(!0)))}}e.$tR=n});var Xe=this&&this.__decorate||function(ne,e,A,C){var n=arguments.length,U=n<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,A):C,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(ne,e,A,C);else for(var S=ne.length-1;S>=0;S--)(D=ne[S])&&(U=(n<3?D(U):n>3?D(e,A,U):D(e,A))||U);return n>3&&U&&Object.defineProperty(e,A,U),U};define($e[25],pe([1,0,2,21,12,27,4,3,46]),function(ne,e,A,C,n,U,D,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=e.EventType=void 0;var p;(function(I){I.Tap="-monaco-gesturetap",I.Change="-monaco-gesturechange",I.Start="-monaco-gesturestart",I.End="-monaco-gesturesend",I.Contextmenu="-monaco-gesturecontextmenu"})(p||(e.EventType=p={}));class v extends S.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new m.$4c,this.h=new m.$4c,this.m={},this.j=null,this.n=0,this.B(D.Event.runAndSubscribe(A.onDidRegisterWindow,({window:a,disposables:h})=>{h.add(A.$SP(a.document,"touchstart",t=>this.s(t),{passive:!1})),h.add(A.$SP(a.document,"touchend",t=>this.u(a,t))),h.add(A.$SP(a.document,"touchmove",t=>this.D(t),{passive:!1}))},{window:C.$lP,disposables:this.q}))}static addTarget(a){if(!v.isTouchDevice())return S.$Tc.None;v.b||(v.b=(0,S.$Mc)(new v));const h=v.b.g.push(a);return(0,S.$Rc)(h)}static ignoreTarget(a){if(!v.isTouchDevice())return S.$Tc.None;v.b||(v.b=(0,S.$Mc)(new v));const h=v.b.h.push(a);return(0,S.$Rc)(h)}static isTouchDevice(){return"ontouchstart"in C.$lP||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(a){const h=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let t=0,s=a.targetTouches.length;t<s;t++){const d=a.targetTouches.item(t);this.m[d.identifier]={id:d.identifier,initialTarget:d.target,initialTimeStamp:h,initialPageX:d.pageX,initialPageY:d.pageY,rollingTimestamps:[h],rollingPageX:[d.pageX],rollingPageY:[d.pageY]};const c=this.w(p.Start,d.target);c.pageX=d.pageX,c.pageY=d.pageY,this.z(c)}this.f&&(a.preventDefault(),a.stopPropagation(),this.f=!1)}u(a,h){const t=Date.now(),s=Object.keys(this.m).length;for(let d=0,c=h.changedTouches.length;d<c;d++){const l=h.changedTouches.item(d);if(!this.m.hasOwnProperty(String(l.identifier))){console.warn("move of an UNKNOWN touch",l);continue}const $=this.m[l.identifier],f=Date.now()-$.initialTimeStamp;if(f<v.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const b=this.w(p.Tap,$.initialTarget);b.pageX=n.$sb($.rollingPageX),b.pageY=n.$sb($.rollingPageY),this.z(b)}else if(f>=v.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const b=this.w(p.Contextmenu,$.initialTarget);b.pageX=n.$sb($.rollingPageX),b.pageY=n.$sb($.rollingPageY),this.z(b)}else if(s===1){const b=n.$sb($.rollingPageX),u=n.$sb($.rollingPageY),N=n.$sb($.rollingTimestamps)-$.rollingTimestamps[0],B=b-$.rollingPageX[0],P=u-$.rollingPageY[0],W=[...this.g].filter(z=>$.initialTarget instanceof Node&&z.contains($.initialTarget));this.C(a,W,t,Math.abs(B)/N,B>0?1:-1,b,Math.abs(P)/N,P>0?1:-1,u)}this.z(this.w(p.End,$.initialTarget)),delete this.m[l.identifier]}this.f&&(h.preventDefault(),h.stopPropagation(),this.f=!1)}w(a,h){const t=document.createEvent("CustomEvent");return t.initEvent(a,!1,!0),t.initialTarget=h,t.tapCount=0,t}z(a){if(a.type===p.Tap){const h=new Date().getTime();let t=0;h-this.n>v.r?t=1:t=2,this.n=h,a.tapCount=t}else(a.type===p.Change||a.type===p.Contextmenu)&&(this.n=0);if(a.initialTarget instanceof Node){for(const h of this.h)if(h.contains(a.initialTarget))return;for(const h of this.g)h.contains(a.initialTarget)&&(h.dispatchEvent(a),this.f=!0)}}C(a,h,t,s,d,c,l,$,f){this.j=A.$3P(a,()=>{const b=Date.now(),u=b-t;let N=0,B=0,P=!0;s+=v.a*u,l+=v.a*u,s>0&&(P=!1,N=d*s*u),l>0&&(P=!1,B=$*l*u);const W=this.w(p.Change);W.translationX=N,W.translationY=B,h.forEach(z=>z.dispatchEvent(W)),P||this.C(a,h,b,s,d,c+N,l,$,f+B)})}D(a){const h=Date.now();for(let t=0,s=a.changedTouches.length;t<s;t++){const d=a.changedTouches.item(t);if(!this.m.hasOwnProperty(String(d.identifier))){console.warn("end of an UNKNOWN touch",d);continue}const c=this.m[d.identifier],l=this.w(p.Change,c.initialTarget);l.translationX=d.pageX-n.$sb(c.rollingPageX),l.translationY=d.pageY-n.$sb(c.rollingPageY),l.pageX=d.pageX,l.pageY=d.pageY,this.z(l),c.rollingPageX.length>3&&(c.rollingPageX.shift(),c.rollingPageY.shift(),c.rollingTimestamps.shift()),c.rollingPageX.push(d.pageX),c.rollingPageY.push(d.pageY),c.rollingTimestamps.push(h)}this.f&&(a.preventDefault(),a.stopPropagation(),this.f=!1)}}e.$qR=v,Xe([U.$zh],v,"isTouchDevice",null)}),define($e[57],pe([1,0,2,92]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XR=e.$WR=e.$VR=void 0;const C=2e4;let n,U,D,S,m;function p(h){n=document.createElement("div"),n.className="monaco-aria-container";const t=()=>{const d=document.createElement("div");return d.className="monaco-alert",d.setAttribute("role","alert"),d.setAttribute("aria-atomic","true"),n.appendChild(d),d};U=t(),D=t();const s=()=>{const d=document.createElement("div");return d.className="monaco-status",d.setAttribute("aria-live","polite"),d.setAttribute("aria-atomic","true"),n.appendChild(d),d};S=s(),m=s(),h.appendChild(n)}e.$VR=p;function v(h){n&&(U.textContent!==h?(A.$RP(D),a(U,h)):(A.$RP(U),a(D,h)))}e.$WR=v;function I(h){n&&(S.textContent!==h?(A.$RP(m),a(S,h)):(A.$RP(S),a(m,h)))}e.$XR=I;function a(h,t){A.$RP(h),t.length>C&&(t=t.substr(0,C)),h.textContent=t,h.style.visibility="hidden",h.style.visibility="visible"}}),define($e[119],pe([1,0,2,18]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=e.$oS=void 0;const n=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(S){const m=new Array;let p,v=0,I=0;for(;(p=n.exec(S))!==null;){I=p.index||0,v<I&&m.push(S.substring(v,I)),v=(p.index||0)+p[0].length;const[,a,h]=p;m.push(a?`$(${h})`:D({id:h}))}return v<S.length&&m.push(S.substring(v)),m}e.$oS=U;function D(S){const m=A.$("span");return m.classList.add(...C.ThemeIcon.asClassNameArray(S)),m}e.$pS=D}),define($e[120],pe([1,0,2]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;function C(U){try{U.parentElement?.removeChild(U)}catch{}}class n{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let S=this.h(D).pop(),m=!1;if(S)m=this.b.has(S.domNode),m&&this.b.delete(S.domNode);else{const p=(0,A.$)(".monaco-list-row"),I=this.i(D).renderTemplate(p);S={domNode:p,templateId:D,templateData:I}}return{row:S,isReusingConnectedDomNode:m}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const S of this.b)this.g(S);this.b.clear(),this.c=!1}}f(D){const{domNode:S,templateId:m}=D;S&&(this.c?this.b.add(S):this.g(S)),this.h(m).push(D)}g(D){D.classList.remove("scrolling"),C(D)}h(D){let S=this.a.get(D);return S||(S=[],this.a.set(D,S)),S}dispose(){this.a.forEach((D,S)=>{for(const m of D)this.i(S).disposeTemplate(m.templateData),m.templateData=null}),this.a.clear(),this.b.clear()}i(D){const S=this.d.get(D);if(!S)throw new Error(`No renderer found for ${D}`);return S}}e.$4R=n}),define($e[121],pe([1,0,9,3]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yR=void 0;class n extends C.$Tc{constructor(D,S,m){super(),this.a=D,this.b=S,this.c=m,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new A.$fh)}setVisibility(D){this.a!==D&&(this.a=D,this.s())}setShouldBeVisible(D){this.g=D,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const D=this.r();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.j!==D&&(this.j=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(D){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}e.$yR=n}),define($e[122],pe([1,0,2,25,12,4,3,5]),function(ne,e,A,C,n,U,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wS=void 0;class m extends D.$Tc{constructor(v,I,a,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Wd),this.h=a,this.j(),this.setOptions(v,I)}j(){this.B(C.$qR.addTarget(this.a)),[C.EventType.Tap].forEach(v=>{this.B(A.$SP(this.a,v,I=>{this.a.focus()}))}),this.B(A.$TP(this.a,"click",v=>{A.$OQ.stop(v,!0)})),this.B(A.$TP(this.a,"change",v=>{this.a.title=v.target.value,this.g.fire({index:v.target.selectedIndex,selected:v.target.value})})),this.B(A.$TP(this.a,"keydown",v=>{let I=!1;S.$j?(v.keyCode===18||v.keyCode===16||v.keyCode===10)&&(I=!0):(v.keyCode===18&&v.altKey||v.keyCode===10||v.keyCode===3)&&(I=!0),I&&v.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(v,I){(!this.c||!n.$ub(this.c,v))&&(this.c=v,this.a.options.length=0,this.c.forEach((a,h)=>{this.a.add(this.m(a.text,h,a.isDisabled))})),I!==void 0&&this.select(I)}select(v){this.c.length===0?this.f=0:v>=0&&v<this.c.length?this.f=v:v>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(v){this.b.ariaLabel=v,this.a.setAttribute("aria-label",v)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(v){this.a.tabIndex=v?0:-1}render(v){v.classList.add("select-container"),v.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(v){this.h=v,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(v,I,a){const h=document.createElement("option");return h.value=v,h.text=v,h.disabled=!!a,h}}e.$wS=m}),define($e[58],pe([1,0,26,12,9,50,87,4,28]),function(ne,e,A,C,n,U,D,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6T=e.$5T=e.$4T=void 0;function p(h){return typeof h=="object"&&"visibility"in h&&"data"in h}e.$4T=p;function v(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}e.$5T=v;function I(h){return typeof h.collapsible=="boolean"}class a{constructor(t,s,d,c={}){this.o=t,this.p=s,this.rootRef=[],this.d=new S.$5d,this.f=new S.$Wd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new S.$Wd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new S.$Wd,this.onDidSplice=this.l.event,this.m=new n.$5g(U.$Td),this.h=typeof c.collapseByDefault>"u"?!1:c.collapseByDefault,this.j=c.filter,this.k=typeof c.autoExpandSingleChildren>"u"?!1:c.autoExpandSingleChildren,this.c={parent:void 0,element:d,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(t,s,d=m.Iterable.empty(),c={}){if(t.length===0)throw new A.$2T(this.o,"Invalid tree location");c.diffIdentityProvider?this.q(c.diffIdentityProvider,t,s,d,c):this.s(t,s,d,c)}q(t,s,d,c=m.Iterable.empty(),l,$=l.diffDepth??0){const{parentNode:f}=this.G(s);if(!f.lastDiffIds)return this.s(s,d,c,l);const b=[...c],u=s[s.length-1],N=new D.$3s({getElements:()=>f.lastDiffIds},{getElements:()=>[...f.children.slice(0,u),...b,...f.children.slice(u+d)].map(y=>t.getId(y.element).toString())}).ComputeDiff(!1);if(N.quitEarly)return f.lastDiffIds=void 0,this.s(s,d,b,l);const B=s.slice(0,-1),P=(y,O,H)=>{if($>0)for(let E=0;E<H;E++)y--,O--,this.q(t,[...B,y,0],Number.MAX_SAFE_INTEGER,b[O].children,l,$-1)};let W=Math.min(f.children.length,u+d),z=b.length;for(const y of N.changes.sort((O,H)=>H.originalStart-O.originalStart))P(W,z,W-(y.originalStart+y.originalLength)),W=y.originalStart,z=y.modifiedStart-u,this.s([...B,W],y.originalLength,m.Iterable.slice(b,z,z+y.modifiedLength),l);P(W,z,W)}s(t,s,d=m.Iterable.empty(),{onDidCreateNode:c,onDidDeleteNode:l,diffIdentityProvider:$}){const{parentNode:f,listIndex:b,revealed:u,visible:N}=this.G(t),B=[],P=m.Iterable.map(d,G=>this.w(G,f,f.visible?1:0,u,B,c)),W=t[t.length-1];let z=0;for(let G=W;G>=0&&G<f.children.length;G--){const Z=f.children[G];if(Z.visible){z=Z.visibleChildIndex;break}}const y=[];let O=0,H=0;for(const G of P)y.push(G),H+=G.renderNodeCount,G.visible&&(G.visibleChildIndex=z+O++);const E=(0,C.$6b)(f.children,W,s,y);$?f.lastDiffIds?(0,C.$6b)(f.lastDiffIds,W,s,y.map(G=>$.getId(G.element).toString())):f.lastDiffIds=f.children.map(G=>$.getId(G.element).toString()):f.lastDiffIds=void 0;let R=0;for(const G of E)G.visible&&R++;if(R!==0)for(let G=W+y.length;G<f.children.length;G++){const Z=f.children[G];Z.visible&&(Z.visibleChildIndex-=R)}if(f.visibleChildrenCount+=O-R,u&&N){const G=E.reduce((Z,ge)=>Z+(ge.visible?ge.renderNodeCount:0),0);this.B(f,H-G),this.p.splice(b,G,B)}if(E.length>0&&l){const G=Z=>{l(Z),Z.children.forEach(G)};E.forEach(G)}this.l.fire({insertedNodes:y,deletedNodes:E});let L=f;for(;L;){if(L.visibility===2){this.m.trigger(()=>this.refilter());break}L=L.parent}}rerender(t){if(t.length===0)throw new A.$2T(this.o,"Invalid tree location");const{node:s,listIndex:d,revealed:c}=this.F(t);s.visible&&c&&this.p.splice(d,1,[s])}updateElementHeight(t,s){if(t.length===0)throw new A.$2T(this.o,"Invalid tree location");const{listIndex:d}=this.F(t);this.p.updateElementHeight(d,s)}has(t){return this.D(t)}getListIndex(t){const{listIndex:s,visible:d,revealed:c}=this.F(t);return d&&c?s:-1}getListRenderCount(t){return this.E(t).renderNodeCount}isCollapsible(t){return this.E(t).collapsible}setCollapsible(t,s){const d=this.E(t);typeof s>"u"&&(s=!d.collapsible);const c={collapsible:s};return this.d.bufferEvents(()=>this.t(t,c))}isCollapsed(t){return this.E(t).collapsed}setCollapsed(t,s,d){const c=this.E(t);typeof s>"u"&&(s=!c.collapsed);const l={collapsed:s,recursive:d||!1};return this.d.bufferEvents(()=>this.t(t,l))}t(t,s){const{node:d,listIndex:c,revealed:l}=this.F(t),$=this.u(d,c,l,s);if(d!==this.c&&this.k&&$&&!I(s)&&d.collapsible&&!d.collapsed&&!s.recursive){let f=-1;for(let b=0;b<d.children.length;b++)if(d.children[b].visible)if(f>-1){f=-1;break}else f=b;f>-1&&this.t([...t,f],s)}return $}u(t,s,d,c){const l=this.v(t,c,!1);if(!d||!t.visible||!l)return l;const $=t.renderNodeCount,f=this.x(t),b=$-(s===-1?0:1);return this.p.splice(s+1,b,f.slice(1)),l}v(t,s,d){let c;if(t===this.c?c=!1:(I(s)?(c=t.collapsible!==s.collapsible,t.collapsible=s.collapsible):t.collapsible?(c=t.collapsed!==s.collapsed,t.collapsed=s.collapsed):c=!1,c&&this.f.fire({node:t,deep:d})),!I(s)&&s.recursive)for(const l of t.children)c=this.v(l,s,!0)||c;return c}expandTo(t){this.d.bufferEvents(()=>{let s=this.E(t);for(;s.parent;)s=s.parent,t=t.slice(0,t.length-1),s.collapsed&&this.t(t,{collapsed:!1,recursive:!1})})}refilter(){const t=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,t,s),this.m.cancel()}w(t,s,d,c,l,$){const f={parent:s,element:t.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof t.collapsible=="boolean"?t.collapsible:typeof t.collapsed<"u",collapsed:typeof t.collapsed>"u"?this.h:t.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},b=this.C(f,d);f.visibility=b,c&&l.push(f);const u=t.children||m.Iterable.empty(),N=c&&b!==0&&!f.collapsed;let B=0,P=1;for(const W of u){const z=this.w(W,f,b,N,l,$);f.children.push(z),P+=z.renderNodeCount,z.visible&&(z.visibleChildIndex=B++)}return f.collapsible=f.collapsible||f.children.length>0,f.visibleChildrenCount=B,f.visible=b===2?B>0:b===1,f.visible?f.collapsed||(f.renderNodeCount=P):(f.renderNodeCount=0,c&&l.pop()),$?.(f),f}x(t){const s=t.renderNodeCount,d=[];return this.y(t,d),this.B(t.parent,d.length-s),d}y(t,s){if(t.visible===!1)return 0;if(s.push(t),t.renderNodeCount=1,!t.collapsed)for(const d of t.children)t.renderNodeCount+=this.y(d,s);return this.g.fire(t),t.renderNodeCount}z(t){const s=t.renderNodeCount,d=[];return this.A(t,t.visible?1:0,d),this.B(t.parent,d.length-s),d}A(t,s,d,c=!0){let l;if(t!==this.c){if(l=this.C(t,s),l===0)return t.visible=!1,t.renderNodeCount=0,!1;c&&d.push(t)}const $=d.length;t.renderNodeCount=t===this.c?0:1;let f=!1;if(!t.collapsed||l!==0){let b=0;for(const u of t.children)f=this.A(u,l,d,c&&!t.collapsed)||f,u.visible&&(u.visibleChildIndex=b++);t.visibleChildrenCount=b}else t.visibleChildrenCount=0;return t!==this.c&&(t.visible=l===2?f:l===1,t.visibility=l),t.visible?t.collapsed||(t.renderNodeCount+=d.length-$):(t.renderNodeCount=0,c&&d.pop()),this.g.fire(t),t.visible}B(t,s){if(s!==0)for(;t;)t.renderNodeCount+=s,this.g.fire(t),t=t.parent}C(t,s){const d=this.j?this.j.filter(t.element,s):1;return typeof d=="boolean"?(t.filterData=void 0,d?1:0):p(d)?(t.filterData=d.data,v(d.visibility)):(t.filterData=void 0,v(d))}D(t,s=this.c){if(!t||t.length===0)return!0;const[d,...c]=t;return d<0||d>s.children.length?!1:this.D(c,s.children[d])}E(t,s=this.c){if(!t||t.length===0)return s;const[d,...c]=t;if(d<0||d>s.children.length)throw new A.$2T(this.o,"Invalid tree location");return this.E(c,s.children[d])}F(t){if(t.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:d,revealed:c,visible:l}=this.G(t),$=t[t.length-1];if($<0||$>s.children.length)throw new A.$2T(this.o,"Invalid tree location");const f=s.children[$];return{node:f,listIndex:d,revealed:c,visible:l&&f.visible}}G(t,s=this.c,d=0,c=!0,l=!0){const[$,...f]=t;if($<0||$>s.children.length)throw new A.$2T(this.o,"Invalid tree location");for(let b=0;b<$;b++)d+=s.children[b].renderNodeCount;return c=c&&!s.collapsed,l=l&&s.visible,f.length===0?{parentNode:s,listIndex:d,revealed:c,visible:l}:this.G(f,s.children[$],d+1,c,l)}getNode(t=[]){return this.E(t)}getNodeLocation(t){const s=[];let d=t;for(;d.parent;)s.push(d.parent.children.indexOf(d)),d=d.parent;return s.reverse()}getParentNodeLocation(t){if(t.length!==0)return t.length===1?[]:(0,C.$tb)(t)[0]}getFirstElementChild(t){const s=this.E(t);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(t=[]){const s=this.E(t);if(s.children.length!==0)return this.H(s)}H(t){return t.children.length===0?t.element:this.H(t.children[t.children.length-1])}}e.$6T=a}),define($e[123],pe([1,0,58,26,28]),function(ne,e,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aU=void 0;class U{get size(){return this.d.size}constructor(S,m,p={}){this.k=S,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new A.$6T(S,m,null,p),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,p.sorter&&(this.j={compare(v,I){return p.sorter.compare(v.element,I.element)}}),this.h=p.identityProvider}setChildren(S,m=n.Iterable.empty(),p={}){const v=this.o(S);this.l(v,this.m(m),p)}l(S,m=n.Iterable.empty(),p){const v=new Set,I=new Set,a=t=>{if(t.element===null)return;const s=t;if(v.add(s.element),this.d.set(s.element,s),this.h){const d=this.h.getId(s.element).toString();I.add(d),this.f.set(d,s)}p.onDidCreateNode?.(s)},h=t=>{if(t.element===null)return;const s=t;if(v.has(s.element)||this.d.delete(s.element),this.h){const d=this.h.getId(s.element).toString();I.has(d)||this.f.delete(d)}p.onDidDeleteNode?.(s)};this.c.splice([...S,0],Number.MAX_VALUE,m,{...p,onDidCreateNode:a,onDidDeleteNode:h})}m(S=n.Iterable.empty()){return this.j&&(S=[...S].sort(this.j.compare.bind(this.j))),n.Iterable.map(S,m=>{let p=this.d.get(m.element);if(!p&&this.h){const a=this.h.getId(m.element).toString();p=this.f.get(a)}if(!p){let a;return typeof m.collapsed>"u"?a=void 0:m.collapsed===C.ObjectTreeElementCollapseState.Collapsed||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?a=!0:m.collapsed===C.ObjectTreeElementCollapseState.Expanded||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?a=!1:a=!!m.collapsed,{...m,children:this.m(m.children),collapsed:a}}const v=typeof m.collapsible=="boolean"?m.collapsible:p.collapsible;let I;return typeof m.collapsed>"u"||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?I=p.collapsed:m.collapsed===C.ObjectTreeElementCollapseState.Collapsed?I=!0:m.collapsed===C.ObjectTreeElementCollapseState.Expanded?I=!1:I=!!m.collapsed,{...m,collapsible:v,collapsed:I,children:this.m(m.children)}})}rerender(S){const m=this.o(S);this.c.rerender(m)}updateElementHeight(S,m){const p=this.o(S);this.c.updateElementHeight(p,m)}resort(S=null,m=!0){if(!this.j)return;const p=this.o(S),v=this.c.getNode(p);this.l(p,this.n(v,m),{})}n(S,m,p=!0){let v=[...S.children];return(m||p)&&(v=v.sort(this.j.compare.bind(this.j))),n.Iterable.map(v,I=>({element:I.element,collapsible:I.collapsible,collapsed:I.collapsed,children:this.n(I,m,!1)}))}getFirstElementChild(S=null){const m=this.o(S);return this.c.getFirstElementChild(m)}getLastElementAncestor(S=null){const m=this.o(S);return this.c.getLastElementAncestor(m)}has(S){return this.d.has(S)}getListIndex(S){const m=this.o(S);return this.c.getListIndex(m)}getListRenderCount(S){const m=this.o(S);return this.c.getListRenderCount(m)}isCollapsible(S){const m=this.o(S);return this.c.isCollapsible(m)}setCollapsible(S,m){const p=this.o(S);return this.c.setCollapsible(p,m)}isCollapsed(S){const m=this.o(S);return this.c.isCollapsed(m)}setCollapsed(S,m,p){const v=this.o(S);return this.c.setCollapsed(v,m,p)}expandTo(S){const m=this.o(S);this.c.expandTo(m)}refilter(){this.c.refilter()}getNode(S=null){if(S===null)return this.c.getNode(this.c.rootRef);const m=this.d.get(S);if(!m)throw new C.$2T(this.k,`Tree element not found: ${S}`);return m}getNodeLocation(S){return S.element}getParentNodeLocation(S){if(S===null)throw new C.$2T(this.k,"Invalid getParentNodeLocation call");const m=this.d.get(S);if(!m)throw new C.$2T(this.k,`Tree element not found: ${S}`);const p=this.c.getNodeLocation(m),v=this.c.getParentNodeLocation(p);return this.c.getNode(v).element}o(S){if(S===null)return[];const m=this.d.get(S);if(!m)throw new C.$2T(this.k,`Tree element not found: ${S}`);return this.c.getNodeLocation(m)}}e.$aU=U}),define($e[20],pe([1,0,2,14,19,25,3]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uR=void 0;class S extends D.$Tc{f(p,v){this.B(A.$SP(p,A.$MQ.CLICK,I=>v(new n.$KP(A.getWindow(p),I))))}j(p,v){this.B(A.$SP(p,A.$MQ.MOUSE_DOWN,I=>v(new n.$KP(A.getWindow(p),I))))}m(p,v){this.B(A.$SP(p,A.$MQ.MOUSE_OVER,I=>v(new n.$KP(A.getWindow(p),I))))}u(p,v){this.B(A.$SP(p,A.$MQ.MOUSE_LEAVE,I=>v(new n.$KP(A.getWindow(p),I))))}z(p,v){this.B(A.$SP(p,A.$MQ.KEY_DOWN,I=>v(new C.$PP(I))))}C(p,v){this.B(A.$SP(p,A.$MQ.KEY_UP,I=>v(new C.$PP(I))))}D(p,v){this.B(A.$SP(p,A.$MQ.INPUT,v))}F(p,v){this.B(A.$SP(p,A.$MQ.BLUR,v))}G(p,v){this.B(A.$SP(p,A.$MQ.FOCUS,v))}H(p,v){this.B(A.$SP(p,A.$MQ.CHANGE,v))}I(p){return U.$qR.ignoreTarget(p)}}e.$uR=S}),define($e[39],pe([1,0,56,20,9,18,2]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wR=e.$vR=void 0,e.$vR=11;class S extends C.$uR{constructor(p){super(),this.a=p.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=p.bgWidth+"px",this.bgDomNode.style.height=p.bgHeight+"px",typeof p.top<"u"&&(this.bgDomNode.style.top="0px"),typeof p.left<"u"&&(this.bgDomNode.style.left="0px"),typeof p.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof p.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=p.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(p.icon)),this.domNode.style.position="absolute",this.domNode.style.width=e.$vR+"px",this.domNode.style.height=e.$vR+"px",typeof p.top<"u"&&(this.domNode.style.top=p.top+"px"),typeof p.left<"u"&&(this.domNode.style.left=p.left+"px"),typeof p.bottom<"u"&&(this.domNode.style.bottom=p.bottom+"px"),typeof p.right<"u"&&(this.domNode.style.right=p.right+"px"),this.g=this.B(new A.$tR),this.B(D.$TP(this.bgDomNode,D.$MQ.POINTER_DOWN,v=>this.h(v))),this.B(D.$TP(this.domNode,D.$MQ.POINTER_DOWN,v=>this.h(v))),this.b=this.B(new D.$5P),this.c=this.B(new n.$fh)}h(p){if(!p.target||!(p.target instanceof Element))return;const v=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,D.getWindow(p))};this.a(),this.b.cancel(),this.c.cancelAndSet(v,200),this.g.startMonitoring(p.target,p.pointerId,p.buttons,I=>{},()=>{this.b.cancel(),this.c.cancel()}),p.preventDefault()}}e.$wR=S}),define($e[59],pe([1,0,2,42,56,39,121,20,5]),function(ne,e,A,C,n,U,D,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;const p=140;class v extends S.$uR{constructor(a){super(),this.g=a.lazyRender,this.a=a.host,this.b=a.scrollable,this.c=a.scrollByPage,this.h=a.scrollbarState,this.n=this.B(new D.$yR(a.visibility,"visible scrollbar "+a.extraScrollbarClassName,"invisible scrollbar "+a.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$tR),this.s=!0,this.domNode=(0,C.$sR)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(A.$SP(this.domNode.domNode,A.$MQ.POINTER_DOWN,h=>this.M(h)))}t(a){const h=this.B(new U.$wR(a));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}w(a,h,t,s){this.slider=(0,C.$sR)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(a),this.slider.setLeft(h),typeof t=="number"&&this.slider.setWidth(t),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(A.$SP(this.slider.domNode,A.$MQ.POINTER_DOWN,d=>{d.button===0&&(d.preventDefault(),this.O(d))})),this.f(this.slider.domNode,d=>{d.leftButton&&d.stopPropagation()})}y(a){return this.h.setVisibleSize(a)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(a){return this.h.setScrollSize(a)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(a){return this.h.setScrollPosition(a)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(a){a.target===this.domNode.domNode&&this.N(a)}delegatePointerDown(a){const h=this.domNode.domNode.getClientRects()[0].top,t=h+this.h.getSliderPosition(),s=h+this.h.getSliderPosition()+this.h.getSliderSize(),d=this.U(a);t<=d&&d<=s?a.button===0&&(a.preventDefault(),this.O(a)):this.N(a)}N(a){let h,t;if(a.target===this.domNode.domNode&&typeof a.offsetX=="number"&&typeof a.offsetY=="number")h=a.offsetX,t=a.offsetY;else{const d=A.$cQ(this.domNode.domNode);h=a.pageX-d.left,t=a.pageY-d.top}const s=this.S(h,t);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),a.button===0&&(a.preventDefault(),this.O(a))}O(a){if(!a.target||!(a.target instanceof Element))return;const h=this.U(a),t=this.W(a),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(a.target,a.pointerId,a.buttons,d=>{const c=this.W(d),l=Math.abs(c-t);if(m.$i&&l>p){this.P(s.getScrollPosition());return}const f=this.U(d)-h;this.P(s.getDesiredScrollPositionFromDelta(f))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(a){const h={};this.writeScrollPosition(h,a),this.b.setScrollPositionNow(h)}updateScrollbarSize(a){this.X(a),this.h.setScrollbarSize(a),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}e.$zR=v}),define($e[124],pe([1,0,19,59,39,43,17]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AR=void 0;class S extends C.$zR{constructor(p,v,I){const a=p.getScrollDimensions(),h=p.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:I,scrollbarState:new U.$xR(v.horizontalHasArrows?v.arrowSize:0,v.horizontal===2?0:v.horizontalScrollbarSize,v.vertical===2?0:v.verticalScrollbarSize,a.width,a.scrollWidth,h.scrollLeft),visibility:v.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:v.scrollByPage}),v.horizontalHasArrows){const t=(v.arrowSize-n.$vR)/2,s=(v.horizontalScrollbarSize-n.$vR)/2;this.t({className:"scra",icon:D.$bk.scrollbarButtonLeft,top:s,left:t,bottom:void 0,right:void 0,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$MP(null,1,0))}),this.t({className:"scra",icon:D.$bk.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:t,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$MP(null,-1,0))})}this.w(Math.floor((v.horizontalScrollbarSize-v.horizontalSliderSize)/2),0,void 0,v.horizontalSliderSize)}R(p,v){this.slider.setWidth(p),this.slider.setLeft(v)}Q(p,v){this.domNode.setWidth(p),this.domNode.setHeight(v),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this.s=this.J(p.scrollWidth)||this.s,this.s=this.L(p.scrollLeft)||this.s,this.s=this.y(p.width)||this.s,this.s}S(p,v){return p}U(p){return p.pageX}W(p){return p.pageY}X(p){this.slider.setHeight(p)}writeScrollPosition(p,v){p.scrollLeft=v}updateOptions(p){this.updateScrollbarSize(p.horizontal===2?0:p.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this.n.setVisibility(p.horizontal),this.c=p.scrollByPage}}e.$AR=S}),define($e[125],pe([1,0,19,59,39,43,17]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BR=void 0;class S extends C.$zR{constructor(p,v,I){const a=p.getScrollDimensions(),h=p.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:I,scrollbarState:new U.$xR(v.verticalHasArrows?v.arrowSize:0,v.vertical===2?0:v.verticalScrollbarSize,0,a.height,a.scrollHeight,h.scrollTop),visibility:v.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:v.scrollByPage}),v.verticalHasArrows){const t=(v.arrowSize-n.$vR)/2,s=(v.verticalScrollbarSize-n.$vR)/2;this.t({className:"scra",icon:D.$bk.scrollbarButtonUp,top:t,left:s,bottom:void 0,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$MP(null,0,1))}),this.t({className:"scra",icon:D.$bk.scrollbarButtonDown,top:void 0,left:s,bottom:t,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$MP(null,0,-1))})}this.w(0,Math.floor((v.verticalScrollbarSize-v.verticalSliderSize)/2),v.verticalSliderSize,void 0)}R(p,v){this.slider.setHeight(p),this.slider.setTop(v)}Q(p,v){this.domNode.setWidth(v),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this.s=this.J(p.scrollHeight)||this.s,this.s=this.L(p.scrollTop)||this.s,this.s=this.y(p.height)||this.s,this.s}S(p,v){return v}U(p){return p.pageY}W(p){return p.pageX}X(p){this.slider.setWidth(p)}writeScrollPosition(p,v){p.scrollTop=v}updateOptions(p){this.updateScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(p.vertical),this.c=p.scrollByPage}}e.$BR=S}),define($e[60],pe([1,0,16,2,42,19,124,125,20,9,4,3,5,48,99]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GR=e.$FR=e.$ER=e.$DR=e.$CR=void 0;const t=500,s=50,d=!0;class c{constructor(P,W,z){this.timestamp=P,this.deltaX=W,this.deltaY=z,this.score=0}}class l{static{this.INSTANCE=new l}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let P=1,W=0,z=1,y=this.d;do{const O=y===this.c?P:Math.pow(2,-z);if(P-=O,W+=this.b[y].score*O,y===this.c)break;y=(this.a+y-1)%this.a,z++}while(!0);return W<=.5}acceptStandardWheelEvent(P){if(A.$AP){const W=C.getWindow(P.browserEvent),z=(0,A.$tP)(W);this.accept(Date.now(),P.deltaX*z,P.deltaY*z)}else this.accept(Date.now(),P.deltaX,P.deltaY)}accept(P,W,z){const y=new c(P,W,z);y.score=this.f(y),this.c===-1&&this.d===-1?(this.b[0]=y,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=y)}f(P){if(Math.abs(P.deltaX)>0&&Math.abs(P.deltaY)>0)return 1;let W=.5;const z=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(P.deltaX)||!this.g(P.deltaY))&&(W+=.25),Math.min(Math.max(W,0),1)}g(P){return Math.abs(Math.round(P)-P)<.01}}e.$CR=l;class $ extends m.$uR{get options(){return this.a}constructor(P,W,z){super(),this.O=this.B(new v.$Wd),this.onScroll=this.O.event,this.P=this.B(new v.$Wd),this.onWillScroll=this.P.event,P.style.overflow="hidden",this.a=N(W),this.b=z,this.B(this.b.onScroll(O=>{this.P.fire(O),this.S(O),this.O.fire(O)}));const y={onMouseWheel:O=>this.R(O),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new S.$BR(this.b,this.a,y)),this.g=this.B(new D.$AR(this.b,this.a,y)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(P),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$sR)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$sR)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$sR)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,O=>this.Z(O)),this.u(this.t,O=>this.Y(O)),this.L=this.B(new p.$fh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,I.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(P){this.c.delegatePointerDown(P)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(P){this.b.setScrollDimensions(P,!1)}updateClassName(P){this.a.className=P,a.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(P){typeof P.handleMouseWheel<"u"&&(this.a.handleMouseWheel=P.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof P.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=P.mouseWheelScrollSensitivity),typeof P.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=P.fastScrollSensitivity),typeof P.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=P.scrollPredominantAxis),typeof P.horizontal<"u"&&(this.a.horizontal=P.horizontal),typeof P.vertical<"u"&&(this.a.vertical=P.vertical),typeof P.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=P.horizontalScrollbarSize),typeof P.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=P.verticalScrollbarSize),typeof P.scrollByPage<"u"&&(this.a.scrollByPage=P.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(P){this.N=P}delegateScrollFromMouseWheelEvent(P){this.R(new U.$MP(P))}Q(P){if(this.w.length>0!==P&&(this.w=(0,I.$Oc)(this.w),P)){const z=y=>{this.R(new U.$MP(y))};this.w.push(C.$SP(this.t,C.$MQ.MOUSE_WHEEL,z,{passive:!1}))}}R(P){if(P.browserEvent?.defaultPrevented)return;const W=l.INSTANCE;d&&W.acceptStandardWheelEvent(P);let z=!1;if(P.deltaY||P.deltaX){let O=P.deltaY*this.a.mouseWheelScrollSensitivity,H=P.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&H+O===0?H=O=0:Math.abs(O)>=Math.abs(H)?H=0:O=0),this.a.flipAxes&&([O,H]=[H,O]);const E=!a.$j&&P.browserEvent&&P.browserEvent.shiftKey;(this.a.scrollYToX||E)&&!H&&(H=O,O=0),P.browserEvent&&P.browserEvent.altKey&&(H=H*this.a.fastScrollSensitivity,O=O*this.a.fastScrollSensitivity);const R=this.b.getFutureScrollPosition();let L={};if(O){const G=s*O,Z=R.scrollTop-(G<0?Math.floor(G):Math.ceil(G));this.c.writeScrollPosition(L,Z)}if(H){const G=s*H,Z=R.scrollLeft-(G<0?Math.floor(G):Math.ceil(G));this.g.writeScrollPosition(L,Z)}L=this.b.validateScrollPosition(L),(R.scrollLeft!==L.scrollLeft||R.scrollTop!==L.scrollTop)&&(d&&this.a.mouseWheelSmoothScroll&&W.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(L):this.b.setScrollPositionNow(L),z=!0)}let y=z;!y&&this.a.alwaysConsumeMouseWheel&&(y=!0),!y&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(y=!0),y&&(P.preventDefault(),P.stopPropagation())}S(P){this.M=this.g.onDidScroll(P)||this.M,this.M=this.c.onDidScroll(P)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const P=this.b.getCurrentScrollPosition(),W=P.scrollTop>0,z=P.scrollLeft>0,y=z?" left":"",O=W?" top":"",H=z||W?" top-left-corner":"";this.n.setClassName(`shadow${y}`),this.r.setClassName(`shadow${O}`),this.s.setClassName(`shadow${H}${O}${y}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(P){this.J=!1,this.ab()}Z(P){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),t)}}e.$DR=$;class f extends ${constructor(P,W){W=W||{},W.mouseWheelSmoothScroll=!1;const z=new h.$ns({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:y=>C.$3P(C.getWindow(P),y)});super(P,W,z),this.B(z)}setScrollPosition(P){this.b.setScrollPositionNow(P)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}e.$ER=f;class b extends ${constructor(P,W,z){super(P,W,z)}setScrollPosition(P){P.reuseAnimation?this.b.setScrollPositionSmooth(P,P.reuseAnimation):this.b.setScrollPositionNow(P)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}e.$FR=b;class u extends ${constructor(P,W){W=W||{},W.mouseWheelSmoothScroll=!1;const z=new h.$ns({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:y=>C.$3P(C.getWindow(P),y)});super(P,W,z),this.B(z),this.cb=P,this.B(this.onScroll(y=>{y.scrollTopChanged&&(this.cb.scrollTop=y.scrollTop),y.scrollLeftChanged&&(this.cb.scrollLeft=y.scrollLeft)})),this.scanDomNode()}setScrollPosition(P){this.b.setScrollPositionNow(P)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}e.$GR=u;function N(B){const P={lazyRender:typeof B.lazyRender<"u"?B.lazyRender:!1,className:typeof B.className<"u"?B.className:"",useShadows:typeof B.useShadows<"u"?B.useShadows:!0,handleMouseWheel:typeof B.handleMouseWheel<"u"?B.handleMouseWheel:!0,flipAxes:typeof B.flipAxes<"u"?B.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof B.consumeMouseWheelIfScrollbarIsNeeded<"u"?B.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof B.alwaysConsumeMouseWheel<"u"?B.alwaysConsumeMouseWheel:!1,scrollYToX:typeof B.scrollYToX<"u"?B.scrollYToX:!1,mouseWheelScrollSensitivity:typeof B.mouseWheelScrollSensitivity<"u"?B.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof B.fastScrollSensitivity<"u"?B.fastScrollSensitivity:5,scrollPredominantAxis:typeof B.scrollPredominantAxis<"u"?B.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof B.mouseWheelSmoothScroll<"u"?B.mouseWheelSmoothScroll:!0,arrowSize:typeof B.arrowSize<"u"?B.arrowSize:11,listenOnDomNode:typeof B.listenOnDomNode<"u"?B.listenOnDomNode:null,horizontal:typeof B.horizontal<"u"?B.horizontal:1,horizontalScrollbarSize:typeof B.horizontalScrollbarSize<"u"?B.horizontalScrollbarSize:10,horizontalSliderSize:typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:0,horizontalHasArrows:typeof B.horizontalHasArrows<"u"?B.horizontalHasArrows:!1,vertical:typeof B.vertical<"u"?B.vertical:1,verticalScrollbarSize:typeof B.verticalScrollbarSize<"u"?B.verticalScrollbarSize:10,verticalHasArrows:typeof B.verticalHasArrows<"u"?B.verticalHasArrows:!1,verticalSliderSize:typeof B.verticalSliderSize<"u"?B.verticalSliderSize:0,scrollByPage:typeof B.scrollByPage<"u"?B.scrollByPage:!1};return P.horizontalSliderSize=typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:P.horizontalScrollbarSize,P.verticalSliderSize=typeof B.verticalSliderSize<"u"?B.verticalSliderSize:P.verticalScrollbarSize,a.$j&&(P.className+=" mac"),P}}),define($e[61],pe([1,0,54,2,22,25,60,12,9,27,4,3,47,48,83,120,6,33]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a,h,t,s,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8R=e.$7R=e.$6R=e.$5R=e.ListViewTargetSector=void 0;const l={CurrentDragAndDropData:void 0};var $;(function(z){z[z.TOP=0]="TOP",z[z.CENTER_TOP=1]="CENTER_TOP",z[z.CENTER_BOTTOM=2]="CENTER_BOTTOM",z[z.BOTTOM=3]="BOTTOM"})($||(e.ListViewTargetSector=$={}));const f={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(z){return[z]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class b{get context(){return this.d}set context(y){this.d=y}constructor(y){this.elements=y}update(){}getData(){return this.elements}}e.$5R=b;class u{constructor(y){this.elements=y}update(){}getData(){return this.elements}}e.$6R=u;class N{constructor(){this.types=[],this.files=[]}update(y){if(y.types&&this.types.splice(0,this.types.length,...y.types),y.files){this.files.splice(0,this.files.length);for(let O=0;O<y.files.length;O++){const H=y.files.item(O);H&&(H.size||H.type)&&this.files.push(H)}}}getData(){return{types:this.types,files:this.files}}}e.$7R=N;function B(z,y){return Array.isArray(z)&&Array.isArray(y)?(0,S.$ub)(z,y):z===y}class P{constructor(y){y?.getSetSize?this.getSetSize=y.getSetSize.bind(y):this.getSetSize=(O,H,E)=>E,y?.getPosInSet?this.getPosInSet=y.getPosInSet.bind(y):this.getPosInSet=(O,H)=>H+1,y?.getRole?this.getRole=y.getRole.bind(y):this.getRole=O=>"listitem",y?.isChecked?this.isChecked=y.isChecked.bind(y):this.isChecked=O=>{}}}class W{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(y){if(y!==this.P){if(y&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=y,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const O of this.d)this.ab(O);this.X(),this.q.setScrollDimensions({width:(0,C.$fQ)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(y,O,H,E=f){if(this.R=O,this.domId=`list_id_${++W.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new m.$5g(50),this.v=!1,this.x=I.$Tc.None,this.y=0,this.G=!1,this.K=I.$Tc.None,this.L=I.$Tc.None,this.M=new I.$Sc,this.N=new v.$Wd,this.O=new v.$Wd,this.onDidChangeContentHeight=v.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=v.Event.latch(this.O.event,void 0,this.M),this.P=!1,E.horizontalScrolling&&E.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(E.paddingTop??0);for(const L of H)this.j.set(L.templateId,L);this.h=this.M.add(new s.$4R(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof E.mouseSupport=="boolean"?E.mouseSupport:!0),this.P=E.horizontalScrolling??f.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof E.paddingBottom>"u"?0:E.paddingBottom,this.D=new P(E.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(E.transformOptimization??f.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(U.$qR.addTarget(this.o)),this.p=this.M.add(new h.$ns({forceIntegerValues:!0,smoothScrollDuration:E.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:L=>(0,C.$3P)((0,C.getWindow)(this.domNode),L)})),this.q=this.M.add(new D.$FR(this.o,{alwaysConsumeMouseWheel:E.alwaysConsumeMouseWheel??f.alwaysConsumeMouseWheel,horizontal:1,vertical:E.verticalScrollMode??f.verticalScrollMode,useShadows:E.useShadows??f.useShadows,mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity,fastScrollSensitivity:E.fastScrollSensitivity,scrollByPage:E.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),y.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,C.$SP)(this.o,U.EventType.Change,L=>this.jb(L))),this.M.add((0,C.$SP)(this.q.getDomNode(),"scroll",L=>L.target.scrollTop=0)),this.M.add((0,C.$SP)(this.domNode,"dragover",L=>this.lb(this.hb(L)))),this.M.add((0,C.$SP)(this.domNode,"drop",L=>this.nb(this.hb(L)))),this.M.add((0,C.$SP)(this.domNode,"dragleave",L=>this.mb(this.hb(L)))),this.M.add((0,C.$SP)(this.domNode,"dragend",L=>this.ob(L))),this.z=E.setRowLineHeight??f.setRowLineHeight,this.A=E.setRowHeight??f.setRowHeight,this.B=E.supportDynamicHeights??f.supportDynamicHeights,this.F=E.dnd??this.M.add(f.dnd),this.layout(E.initialSize?.height,E.initialSize?.width)}updateOptions(y){y.paddingBottom!==void 0&&(this.C=y.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),y.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(y.smoothScrolling?125:0),y.horizontalScrolling!==void 0&&(this.Q=y.horizontalScrolling);let O;if(y.scrollByPage!==void 0&&(O={...O??{},scrollByPage:y.scrollByPage}),y.mouseWheelScrollSensitivity!==void 0&&(O={...O??{},mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity}),y.fastScrollSensitivity!==void 0&&(O={...O??{},fastScrollSensitivity:y.fastScrollSensitivity}),O&&this.q.updateOptions(O),y.paddingTop!==void 0&&y.paddingTop!==this.g.paddingTop){const H=this.vb(this.k,this.m),E=y.paddingTop-this.g.paddingTop;this.g.paddingTop=y.paddingTop,this.Y(H,Math.max(0,this.k+E),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(y){this.q.delegateScrollFromMouseWheelEvent(y)}delegateVerticalScrollbarPointerDown(y){this.q.delegateVerticalScrollbarPointerDown(y)}updateElementHeight(y,O,H){if(y<0||y>=this.d.length)return;const E=this.d[y].size;if(typeof O>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[y].lastDynamicHeightWidth=void 0,O=E+this.xb(y)}if(E===O)return;const R=this.vb(this.k,this.m);let L=0;y<R.start||H!==null&&H>y&&H<R.end?L=O-E:L=0,this.g.splice(y,1,[{size:O}]),this.d[y].size=O,this.Y(R,Math.max(0,this.k+L),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(y){return new t.$3R(y)}splice(y,O,H=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(y,O,H)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(y,O,H=[]){const E=this.vb(this.k,this.m),R={start:y,end:y+O},L=a.Range.intersect(E,R),G=new Map;for(let te=L.end-1;te>=L.start;te--){const ce=this.d[te];if(ce.dragStartDisposable.dispose(),ce.checkedDisposable.dispose(),ce.row){let ye=G.get(ce.templateId);ye||(ye=[],G.set(ce.templateId,ye));const Te=this.j.get(ce.templateId);Te&&Te.disposeElement&&Te.disposeElement(ce.element,te,ce.row.templateData,ce.size),ye.push(ce.row)}ce.row=null}const Z={start:y+O,end:this.d.length},ge=a.Range.intersect(Z,E),he=a.Range.relativeComplement(Z,E),ie=H.map(te=>({id:String(this.f++),element:te,templateId:this.R.getTemplateId(te),size:this.R.getHeight(te),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(te),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:I.$Tc.None,checkedDisposable:I.$Tc.None}));let fe;y===0&&O>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ie),fe=this.d,this.d=ie):(this.g.splice(y,O,ie),fe=this.d.splice(y,O,...ie));const Re=H.length-O,Ne=this.vb(this.k,this.m),Be=(0,t.$1R)(ge,Re),se=a.Range.intersect(Ne,Be);for(let te=se.start;te<se.end;te++)this.bb(this.d[te],te);const J=a.Range.relativeComplement(Be,Ne);for(const te of J)for(let ce=te.start;ce<te.end;ce++)this.db(ce);const ae=he.map(te=>(0,t.$1R)(te,Re)),X=[{start:y,end:y+H.length},...ae].map(te=>a.Range.intersect(Ne,te)),x=this.yb(X);for(const te of X)for(let ce=te.start;ce<te.end;ce++){const ye=this.d[ce],Ae=G.get(ye.templateId)?.pop();this.Z(ce,x,Ae)}for(const te of G.values())for(const ce of te)this.h.release(ce);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),fe.map(te=>te.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$3P)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let y=0;for(const O of this.d)typeof O.width<"u"&&(y=Math.max(y,O.width));this.E=y,this.q.setScrollDimensions({scrollWidth:y===0?0:y+10}),this.O.fire(this.E)}updateWidth(y){if(!this.Q||typeof this.E>"u")return;const O=this.d[y];this.ab(O),typeof O.width<"u"&&O.width>this.E&&(this.E=O.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const y of this.d)y.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const y=this.firstVisibleIndex,O=this.g.positionAt(y),H=this.g.positionAt(y+1);return H!==-1&&(H-O)/2+O<this.scrollTop?y+1:y}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(y){return this.d[y].element}indexOf(y){return this.d.findIndex(O=>O.element===y)}domElement(y){const O=this.d[y].row;return O&&O.domNode}elementHeight(y){return this.d[y].size}elementTop(y){return this.g.positionAt(y)}indexAt(y){return this.g.indexAt(y)}indexAfter(y){return this.g.indexAfter(y)}layout(y,O){const H={height:typeof y=="number"?y:(0,C.$hQ)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,H.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(H),typeof O<"u"&&(this.n=O,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof O=="number"?O:(0,C.$fQ)(this.domNode)})}Y(y,O,H,E,R,L=!1){const G=this.vb(O,H),Z=a.Range.relativeComplement(G,y),ge=a.Range.relativeComplement(y,G),he=this.yb(Z);if(L){const ie=a.Range.intersect(y,G);for(let fe=ie.start;fe<ie.end;fe++)this.bb(this.d[fe],fe)}this.h.transact(()=>{for(const ie of ge)for(let fe=ie.start;fe<ie.end;fe++)this.db(fe);for(const ie of Z)for(let fe=ie.start;fe<ie.end;fe++)this.Z(fe,he)}),E!==void 0&&(this.o.style.left=`-${E}px`),this.o.style.top=`-${O}px`,this.Q&&R!==void 0&&(this.o.style.width=`${Math.max(R,this.n)}px`),this.k=O,this.m=H}Z(y,O,H){const E=this.d[y];let R=!1;if(!E.row)if(H)E.row=H;else{const he=this.h.alloc(E.templateId);E.row=he.row,R=he.isReusingConnectedDomNode}const L=this.D.getRole(E.element)||"listitem";E.row.domNode.setAttribute("role",L);const G=this.D.isChecked(E.element);if(typeof G=="boolean")E.row.domNode.setAttribute("aria-checked",String(!!G));else if(G){const he=ie=>E.row.domNode.setAttribute("aria-checked",String(!!ie));he(G.value),E.checkedDisposable=G.onDidChange(he)}(R||!E.row.domNode.parentElement)&&(O?this.o.insertBefore(E.row.domNode,O):this.o.appendChild(E.row.domNode)),this.bb(E,y);const Z=this.j.get(E.templateId);if(!Z)throw new Error(`No renderer found for template id ${E.templateId}`);Z?.renderElement(E.element,y,E.row.templateData,E.size);const ge=this.F.getDragURI(E.element);E.dragStartDisposable.dispose(),E.row.domNode.draggable=!!ge,ge&&(E.dragStartDisposable=(0,C.$SP)(E.row.domNode,"dragstart",he=>this.kb(E.element,ge,he))),this.Q&&(this.ab(E),this.W())}ab(y){if(!y.row||!y.row.domNode)return;y.row.domNode.style.width="fit-content",y.width=(0,C.$fQ)(y.row.domNode);const O=(0,C.getWindow)(y.row.domNode).getComputedStyle(y.row.domNode);O.paddingLeft&&(y.width+=parseFloat(O.paddingLeft)),O.paddingRight&&(y.width+=parseFloat(O.paddingRight)),y.row.domNode.style.width=""}bb(y,O){y.row.domNode.style.top=`${this.elementTop(O)}px`,this.A&&(y.row.domNode.style.height=`${y.size}px`),this.z&&(y.row.domNode.style.lineHeight=`${y.size}px`),y.row.domNode.setAttribute("data-index",`${O}`),y.row.domNode.setAttribute("data-last-element",O===this.length-1?"true":"false"),y.row.domNode.setAttribute("data-parity",O%2===0?"even":"odd"),y.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(y.element,O,this.length))),y.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(y.element,O))),y.row.domNode.setAttribute("id",this.getElementDomId(O)),y.row.domNode.classList.toggle("drop-target",y.dropTarget)}db(y){const O=this.d[y];if(O.dragStartDisposable.dispose(),O.checkedDisposable.dispose(),O.row){const H=this.j.get(O.templateId);H&&H.disposeElement&&H.disposeElement(O.element,y,O.row.templateData,O.size),this.h.release(O.row),O.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(y,O){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:y,reuseAnimation:O})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(y){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:y})}get scrollTop(){return this.getScrollTop()}set scrollTop(y){this.setScrollTop(y)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return v.Event.map(this.M.add(new n.$UR(this.domNode,"click")).event,y=>this.eb(y),this.M)}get onMouseDblClick(){return v.Event.map(this.M.add(new n.$UR(this.domNode,"dblclick")).event,y=>this.eb(y),this.M)}get onMouseMiddleClick(){return v.Event.filter(v.Event.map(this.M.add(new n.$UR(this.domNode,"auxclick")).event,y=>this.eb(y),this.M),y=>y.browserEvent.button===1,this.M)}get onMouseUp(){return v.Event.map(this.M.add(new n.$UR(this.domNode,"mouseup")).event,y=>this.eb(y),this.M)}get onMouseDown(){return v.Event.map(this.M.add(new n.$UR(this.domNode,"mousedown")).event,y=>this.eb(y),this.M)}get onMouseOver(){return v.Event.map(this.M.add(new n.$UR(this.domNode,"mouseover")).event,y=>this.eb(y),this.M)}get onMouseMove(){return v.Event.map(this.M.add(new n.$UR(this.domNode,"mousemove")).event,y=>this.eb(y),this.M)}get onMouseOut(){return v.Event.map(this.M.add(new n.$UR(this.domNode,"mouseout")).event,y=>this.eb(y),this.M)}get onContextMenu(){return v.Event.any(v.Event.map(this.M.add(new n.$UR(this.domNode,"contextmenu")).event,y=>this.eb(y),this.M),v.Event.map(this.M.add(new n.$UR(this.domNode,U.EventType.Contextmenu)).event,y=>this.gb(y),this.M))}get onTouchStart(){return v.Event.map(this.M.add(new n.$UR(this.domNode,"touchstart")).event,y=>this.fb(y),this.M)}get onTap(){return v.Event.map(this.M.add(new n.$UR(this.o,U.EventType.Tap)).event,y=>this.gb(y),this.M)}eb(y){const O=this.ub(y.target||null),H=typeof O>"u"?void 0:this.d[O],E=H&&H.element;return{browserEvent:y,index:O,element:E}}fb(y){const O=this.ub(y.target||null),H=typeof O>"u"?void 0:this.d[O],E=H&&H.element;return{browserEvent:y,index:O,element:E}}gb(y){const O=this.ub(y.initialTarget||null),H=typeof O>"u"?void 0:this.d[O],E=H&&H.element;return{browserEvent:y,index:O,element:E}}hb(y){const O=this.ub(y.target||null),H=typeof O>"u"?void 0:this.d[O],E=H&&H.element,R=this.tb(y,O);return{browserEvent:y,index:O,element:E,sector:R}}ib(y){try{const O=this.vb(this.k,this.m);this.Y(O,y.scrollTop,y.height,y.scrollLeft,y.scrollWidth),this.B&&this.wb(y.scrollTop,y.height,y.inSmoothScrolling)}catch(O){throw console.error("Got bad scroll event:",y),O}}jb(y){y.preventDefault(),y.stopPropagation(),this.scrollTop-=y.translationY}kb(y,O,H){if(!H.dataTransfer)return;const E=this.F.getDragElements(y);if(H.dataTransfer.effectAllowed="copyMove",H.dataTransfer.setData(A.$oR.TEXT,O),H.dataTransfer.setDragImage){let R;this.F.getDragLabel&&(R=this.F.getDragLabel(E,H)),typeof R>"u"&&(R=String(E.length));const L=(0,C.$)(".monaco-drag-image");L.textContent=R;const Z=(ge=>{for(;ge&&!ge.classList.contains("monaco-workbench");)ge=ge.parentElement;return ge||this.domNode.ownerDocument})(this.domNode);Z.appendChild(L),H.dataTransfer.setDragImage(L,-10,-10),setTimeout(()=>Z.removeChild(L),0)}this.domNode.classList.add("dragging"),this.H=new b(E),l.CurrentDragAndDropData=new u(E),this.F.onDragStart?.(this.H,H)}lb(y){if(y.browserEvent.preventDefault(),this.L.dispose(),l.CurrentDragAndDropData&&l.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(y.browserEvent),!y.browserEvent.dataTransfer))return!1;if(!this.H)if(l.CurrentDragAndDropData)this.H=l.CurrentDragAndDropData;else{if(!y.browserEvent.dataTransfer.types)return!1;this.H=new N}const O=this.F.onDragOver(this.H,y.element,y.index,y.sector,y.browserEvent);if(this.G=typeof O=="boolean"?O:O.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;y.browserEvent.dataTransfer.dropEffect=typeof O!="boolean"&&O.effect?.type===0?"copy":"move";let H;typeof O!="boolean"&&O.feedback?H=O.feedback:typeof y.index>"u"?H=[-1]:H=[y.index],H=(0,S.$Mb)(H).filter(R=>R>=-1&&R<this.length).sort((R,L)=>R-L),H=H[0]===-1?[-1]:H;let E=typeof O!="boolean"&&O.effect&&O.effect.position?O.effect.position:"drop-target";if(B(this.I,H)&&this.J===E)return!0;if(this.I=H,this.J=E,this.K.dispose(),H[0]===-1)this.domNode.classList.add(E),this.o.classList.add(E),this.K=(0,I.$Rc)(()=>{this.domNode.classList.remove(E),this.o.classList.remove(E)});else{if(H.length>1&&E!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");E==="drop-target-after"&&H[0]<this.length-1&&(H[0]+=1,E="drop-target-before");for(const R of H){const L=this.d[R];L.dropTarget=!0,L.row?.domNode.classList.add(E)}this.K=(0,I.$Rc)(()=>{for(const R of H){const L=this.d[R];L.dropTarget=!1,L.row?.domNode.classList.remove(E)}})}return!0}mb(y){this.L.dispose(),this.L=(0,m.$0g)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,y.element,y.index,y.browserEvent)}nb(y){if(!this.G)return;const O=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,l.CurrentDragAndDropData=void 0,!(!O||!y.browserEvent.dataTransfer)&&(y.browserEvent.preventDefault(),O.update(y.browserEvent.dataTransfer),this.F.drop(O,y.element,y.index,y.sector,y.browserEvent))}ob(y){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,l.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(y)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=I.$Tc.None}qb(y){if(!this.w){const O=(0,C.$_P)(this.domNode).top;this.w=(0,C.$9Q)((0,C.getWindow)(this.domNode),this.rb.bind(this,O))}this.x.dispose(),this.x=(0,m.$0g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=y.pageY}rb(y){if(this.y===void 0)return;const O=this.y-y,H=this.renderHeight-35;O<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(O-35))):O>H&&(this.scrollTop+=Math.min(14,Math.floor(.3*(O-H))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(y,O){if(O===void 0)return;const H=y.offsetY/this.d[O].size,E=Math.floor(H/.25);return(0,c.$9l)(E,0,3)}ub(y){const O=this.q.getDomNode();let H=y;for(;H instanceof HTMLElement&&H!==this.o&&O.contains(H);){const E=H.getAttribute("data-index");if(E){const R=Number(E);if(!isNaN(R))return R}H=H.parentElement}}vb(y,O){return{start:this.g.indexAt(y),end:this.g.indexAfter(y+O-1)}}wb(y,O,H){const E=this.vb(y,O);let R,L;y===this.elementTop(E.start)?(R=E.start,L=0):E.end-E.start>1&&(R=E.start+1,L=this.elementTop(R)-y);let G=0;for(;;){const Z=this.vb(y,O);let ge=!1;for(let he=Z.start;he<Z.end;he++){const ie=this.xb(he);ie!==0&&this.g.splice(he,1,[this.d[he]]),G+=ie,ge=ge||ie!==0}if(!ge){G!==0&&this.V();const he=a.Range.relativeComplement(E,Z);for(const fe of he)for(let Re=fe.start;Re<fe.end;Re++)this.d[Re].row&&this.db(Re);const ie=a.Range.relativeComplement(Z,E);for(const fe of ie)for(let Re=fe.start;Re<fe.end;Re++){const Ne=Re+1,Be=Ne<this.d.length?this.d[Ne].row:null,se=Be?Be.domNode:null;this.Z(Re,se)}for(let fe=Z.start;fe<Z.end;fe++)this.d[fe].row&&this.bb(this.d[fe],fe);if(typeof R=="number"){const fe=this.p.getFutureScrollPosition().scrollTop-y,Re=this.elementTop(R)-L+fe;this.setScrollTop(Re,H)}this.N.fire(this.contentHeight);return}}}xb(y){const O=this.d[y];if(this.R.getDynamicHeight){const L=this.R.getDynamicHeight(O.element);if(L!==null){const G=O.size;return O.size=L,O.lastDynamicHeightWidth=this.n,L-G}}if(!O.hasDynamicHeight||O.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(O.element))return 0;const H=O.size;if(O.row)return O.row.domNode.style.height="",O.size=O.row.domNode.offsetHeight,O.lastDynamicHeightWidth=this.n,O.size-H;const{row:E}=this.h.alloc(O.templateId);E.domNode.style.height="",this.o.appendChild(E.domNode);const R=this.j.get(O.templateId);if(!R)throw new d.$cb("Missing renderer for templateId: "+O.templateId);return R.renderElement(O.element,y,E.templateData,void 0),O.size=E.domNode.offsetHeight,R.disposeElement?.(O.element,y,E.templateData,void 0),this.R.setDynamicHeight?.(O.element,O.size),O.lastDynamicHeightWidth=this.n,this.o.removeChild(E.domNode),this.h.release(E),O.size-H}yb(y){const O=y[y.length-1];if(!O)return null;const H=this.d[O.end];return!H||!H.row?null:H.row.domNode}getElementDomId(y){return`${this.domId}_${y}`}dispose(){for(const y of this.d)if(y.dragStartDisposable.dispose(),y.checkedDisposable.dispose(),y.row){const O=this.j.get(y.row.templateId);O&&(O.disposeElement?.(y.element,-1,y.row.templateData,void 0),O.disposeTemplate(y.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}e.$8R=W,Xe([p.$zh],W.prototype,"onMouseClick",null),Xe([p.$zh],W.prototype,"onMouseDblClick",null),Xe([p.$zh],W.prototype,"onMouseMiddleClick",null),Xe([p.$zh],W.prototype,"onMouseUp",null),Xe([p.$zh],W.prototype,"onMouseDown",null),Xe([p.$zh],W.prototype,"onMouseOver",null),Xe([p.$zh],W.prototype,"onMouseMove",null),Xe([p.$zh],W.prototype,"onMouseOut",null),Xe([p.$zh],W.prototype,"onContextMenu",null),Xe([p.$zh],W.prototype,"onTouchStart",null),Xe([p.$zh],W.prototype,"onTap",null)}),define($e[40],pe([1,0,2,22,14,25,57,71,12,9,74,27,4,35,3,33,5,7,70,61,19,98]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a,h,t,s,d,c,l,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nS=e.$mS=e.$lS=e.$kS=e.$jS=e.$iS=e.$hS=e.TypeNavigationMode=e.$gS=e.$fS=e.$eS=e.$dS=e.$cS=e.$bS=e.$aS=e.$_R=void 0;class b{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,k,F){const r=this.c.findIndex(i=>i.templateData===F);if(r>=0){const i=this.c[r];this.d.unrender(F),i.index=k}else{const i={index:k,templateData:F};this.c.push(i)}this.d.renderIndex(k,F)}splice(g,k,F){const r=[];for(const i of this.c)i.index<g?r.push(i):i.index>=g+k&&r.push({index:i.index+F-k,templateData:i.templateData});this.c=r}renderIndexes(g){for(const{index:k,templateData:F}of this.c)g.indexOf(k)>-1&&this.d.renderIndex(k,F)}disposeTemplate(g){const k=this.c.findIndex(F=>F.templateData===g);k<0||this.c.splice(k,1)}}class u{get name(){return this.g}get renderer(){return new b(this)}constructor(g){this.g=g,this.c=[],this.d=[],this.f=new a.$Wd,this.onChange=this.f.event}splice(g,k,F){const r=F.length-k,i=g+k,o=[];let w=0;for(;w<this.d.length&&this.d[w]<g;)o.push(this.d[w++]);for(let M=0;M<F.length;M++)F[M]&&o.push(M+g);for(;w<this.d.length&&this.d[w]>=i;)o.push(this.d[w++]+r);this.renderer.splice(g,k,F.length),this.h(o,o)}renderIndex(g,k){k.classList.toggle(this.g,this.contains(g))}unrender(g){g.classList.remove(this.g)}set(g,k){return this.h(g,[...g].sort(te),k)}h(g,k,F){const r=this.c,i=this.d;this.c=g,this.d=k;const o=X(i,g);return this.renderer.renderIndexes(o),this.f.fire({indexes:g,browserEvent:F}),r}get(){return this.c}contains(g){return(0,m.$wb)(this.d,g,te)>=0}dispose(){(0,t.$Oc)(this.f)}}Xe([I.$zh],u.prototype,"renderer",null);class N extends u{constructor(g){super("selected"),this.k=g}renderIndex(g,k){super.renderIndex(g,k),this.k&&(this.contains(g)?k.setAttribute("aria-selected","true"):k.setAttribute("aria-selected","false"))}}class B{constructor(g,k,F){this.c=g,this.d=k,this.f=F}splice(g,k,F){if(!this.f)return this.c.splice(g,k,new Array(F.length).fill(!1));const r=this.c.get().map(w=>this.f.getId(this.d.element(w)).toString());if(r.length===0)return this.c.splice(g,k,new Array(F.length).fill(!1));const i=new Set(r),o=F.map(w=>i.has(this.f.getId(w).toString()));this.c.splice(g,k,o)}}function P(Q){return Q.tagName==="INPUT"||Q.tagName==="TEXTAREA"}e.$_R=P;function W(Q,g){return Q.classList.contains(g)?!0:Q.classList.contains("monaco-list")||!Q.parentElement?!1:W(Q.parentElement,g)}function z(Q){return W(Q,"monaco-editor")}e.$aS=z;function y(Q){return W(Q,"monaco-custom-toggle")}e.$bS=y;function O(Q){return W(Q,"action-item")}e.$cS=O;function H(Q){return W(Q,"monaco-tl-twistie")}e.$dS=H;function E(Q){return W(Q,"monaco-tree-sticky-row")}e.$eS=E;function R(Q){return Q.classList.contains("monaco-tree-sticky-container")}e.$fS=R;function L(Q){return Q.tagName==="A"&&Q.classList.contains("monaco-button")||Q.tagName==="DIV"&&Q.classList.contains("monaco-button-dropdown")?!0:Q.classList.contains("monaco-list")||!Q.parentElement?!1:L(Q.parentElement)}e.$gS=L;class G{get g(){return a.Event.chain(this.c.add(new C.$UR(this.k.domNode,"keydown")).event,g=>g.filter(k=>!P(k.target)).map(k=>new n.$PP(k)))}constructor(g,k,F){this.h=g,this.k=k,this.c=new t.$Sc,this.d=new t.$Sc,this.f=F.multipleSelectionSupport,this.c.add(this.g(r=>{switch(r.keyCode){case 3:return this.l(r);case 16:return this.o(r);case 18:return this.p(r);case 11:return this.q(r);case 12:return this.s(r);case 9:return this.u(r);case 31:this.f&&(d.$j?r.metaKey:r.ctrlKey)&&this.t(r)}}))}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.f=g.multipleSelectionSupport)}l(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection(this.h.getFocus(),g.browserEvent)}o(g){g.preventDefault(),g.stopPropagation(),this.h.focusPrevious(1,!1,g.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.h.focusNext(1,!1,g.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.h.focusPreviousPage(g.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.h.focusNextPage(g.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}t(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection((0,m.$Sb)(this.h.length),g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(g){this.h.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.h.setSelection([],g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([I.$zh],G.prototype,"g",null);var Z;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.Trigger=1]="Trigger"})(Z||(e.TypeNavigationMode=Z={}));var ge;(function(Q){Q[Q.Idle=0]="Idle",Q[Q.Typing=1]="Typing"})(ge||(ge={})),e.$hS=new class{mightProducePrintableCharacter(Q){return Q.ctrlKey||Q.metaKey||Q.altKey?!1:Q.keyCode>=31&&Q.keyCode<=56||Q.keyCode>=21&&Q.keyCode<=30||Q.keyCode>=98&&Q.keyCode<=107||Q.keyCode>=85&&Q.keyCode<=95}};class he{constructor(g,k,F,r,i){this.o=g,this.p=k,this.q=F,this.s=r,this.t=i,this.c=!1,this.d=ge.Idle,this.f=Z.Automatic,this.g=!1,this.h=-1,this.k=new t.$Sc,this.l=new t.$Sc,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??Z.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const k=a.Event.chain(this.k.add(new C.$UR(this.p.domNode,"keydown")).event,i=>i.filter(o=>!P(o.target)).filter(()=>this.f===Z.Automatic||this.g).map(o=>new n.$PP(o)).filter(o=>g||this.s(o)).filter(o=>this.t.mightProducePrintableCharacter(o)).forEach(o=>A.$OQ.stop(o,!0)).map(o=>o.browserEvent.key)),F=a.Event.debounce(k,()=>null,800,void 0,void 0,void 0,this.k);a.Event.reduce(a.Event.any(k,F),(i,o)=>o===null?null:(i||"")+o,void 0,this.k)(this.x,this,this.k),F(this.w,this,this.k),k(()=>g=!0,void 0,this.k),F(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const k=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));k&&(0,D.$WR)(k)}this.h=-1}x(g){if(!g){this.d=ge.Idle,this.g=!1;return}const k=this.o.getFocus(),F=k.length>0?k[0]:0,r=this.d===ge.Idle?1:0;this.d=ge.Typing;for(let i=0;i<this.o.length;i++){const o=(F+i+r)%this.o.length,w=this.q.getKeyboardNavigationLabel(this.p.element(o)),M=w&&w.toString();if(this.o.options.typeNavigationEnabled){if(typeof M<"u"){if((0,h.$Wj)(g,M)){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}const T=(0,h.$4j)(g,M);if(T&&T[0].end-T[0].start>1&&T.length===1){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}}}else if(typeof M>"u"||(0,h.$Wj)(g,M)){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ie{constructor(g,k){this.d=g,this.f=k,this.c=new t.$Sc;const F=a.Event.chain(this.c.add(new C.$UR(k.domNode,"keydown")).event,i=>i.filter(o=>!P(o.target)).map(o=>new n.$PP(o)));a.Event.chain(F,i=>i.filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey))(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const k=this.d.getFocus();if(k.length===0)return;const F=this.f.domElement(k[0]);if(!F)return;const r=F.querySelector("[tabIndex]");if(!r||!(r instanceof HTMLElement)||r.tabIndex===-1)return;const i=(0,A.getWindow)(r).getComputedStyle(r);i.visibility==="hidden"||i.display==="none"||(g.preventDefault(),g.stopPropagation(),r.focus())}dispose(){this.c.dispose()}}function fe(Q){return d.$j?Q.browserEvent.metaKey:Q.browserEvent.ctrlKey}e.$iS=fe;function Re(Q){return Q.browserEvent.shiftKey}e.$jS=Re;function Ne(Q){return(0,A.$IQ)(Q)&&Q.button===2}const Be={isSelectionSingleChangeEvent:fe,isSelectionRangeChangeEvent:Re};class se{constructor(g){this.k=g,this.f=new t.$Sc,this.g=new a.$Wd,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Be),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(U.$qR.addTarget(g.getHTMLElement()))),a.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Be))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){z(g.browserEvent.target)||(0,A.$sQ)()!==g.browserEvent.target&&this.k.domFocus()}t(g){if(P(g.browserEvent.target)||z(g.browserEvent.target))return;const k=typeof g.index>"u"?[]:[g.index];this.k.setFocus(k,g.browserEvent)}u(g){if(!this.d||P(g.browserEvent.target)||z(g.browserEvent.target)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const k=g.index;if(typeof k>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.q(g))return this.w(g);this.k.setFocus([k],g.browserEvent),this.k.setAnchor(k),Ne(g.browserEvent)||this.k.setSelection([k],g.browserEvent),this.g.fire(g)}v(g){if(P(g.browserEvent.target)||z(g.browserEvent.target)||this.q(g)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const k=this.k.getFocus();this.k.setSelection(k,g.browserEvent)}w(g){const k=g.index;let F=this.k.getAnchor();if(this.p(g)){typeof F>"u"&&(F=this.k.getFocus()[0]??k,this.k.setAnchor(F));const r=Math.min(F,k),i=Math.max(F,k),o=(0,m.$Sb)(r,i+1),w=this.k.getSelection(),M=re(X(w,[F]),F);if(M.length===0)return;const T=X(o,x(w,M));this.k.setSelection(T,g.browserEvent),this.k.setFocus([k],g.browserEvent)}else if(this.o(g)){const r=this.k.getSelection(),i=r.filter(o=>o!==k);this.k.setFocus([k]),this.k.setAnchor(k),r.length===i.length?this.k.setSelection([...i,k],g.browserEvent):this.k.setSelection(i,g.browserEvent)}}dispose(){this.f.dispose()}}e.$kS=se;class J{constructor(g,k){this.c=g,this.d=k}style(g){const k=this.d&&`.${this.d}`,F=[];g.listBackground&&F.push(`.monaco-list${k} .monaco-list-rows { background: ${g.listBackground}; }`),g.listFocusBackground&&(F.push(`.monaco-list${k}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),F.push(`.monaco-list${k}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(F.push(`.monaco-list${k}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),F.push(`.monaco-list${k}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionBackground&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(F.push(`.monaco-list${k} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),F.push(`.monaco-list${k} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&F.push(`.monaco-list${k} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(F.push(`.monaco-list${k} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),F.push(`.monaco-list${k} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(F.push(`.monaco-list${k} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),F.push(`.monaco-list${k} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&F.push(`.monaco-list${k} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&F.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&F.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`);const r=(0,A.$_Q)(g.listFocusAndSelectionOutline,(0,A.$_Q)(g.listSelectionOutline,g.listFocusOutline??""));r&&F.push(`.monaco-list${k}:focus .monaco-list-row.focused.selected { outline: 1px solid ${r}; outline-offset: -1px;}`),g.listFocusOutline&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${k}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`);const i=(0,A.$_Q)(g.listSelectionOutline,g.listInactiveFocusOutline??"");i&&F.push(`.monaco-list${k} .monaco-list-row.focused.selected { outline: 1px dotted ${i}; outline-offset: -1px; }`),g.listSelectionOutline&&F.push(`.monaco-list${k} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listInactiveFocusOutline&&F.push(`.monaco-list${k} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&F.push(`.monaco-list${k} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropOverBackground&&F.push(`
				.monaco-list${k}.drop-target,
				.monaco-list${k} .monaco-list-rows.drop-target,
				.monaco-list${k} .monaco-list-row.drop-target { background-color: ${g.listDropOverBackground} !important; color: inherit !important; }
			`),g.listDropBetweenBackground&&(F.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${k} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`),F.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${k} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`)),g.tableColumnsBorder&&F.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),g.tableOddRowsBackgroundColor&&F.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=F.join(`
`)}}e.$lS=J,e.$mS={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:v.$ot.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:v.$ot.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:v.$ot.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function re(Q,g){const k=Q.indexOf(g);if(k===-1)return[];const F=[];let r=k-1;for(;r>=0&&Q[r]===g-(k-r);)F.push(Q[r--]);for(F.reverse(),r=k;r<Q.length&&Q[r]===g+(r-k);)F.push(Q[r++]);return F}function X(Q,g){const k=[];let F=0,r=0;for(;F<Q.length||r<g.length;)if(F>=Q.length)k.push(g[r++]);else if(r>=g.length)k.push(Q[F++]);else if(Q[F]===g[r]){k.push(Q[F]),F++,r++;continue}else Q[F]<g[r]?k.push(Q[F++]):k.push(g[r++]);return k}function x(Q,g){const k=[];let F=0,r=0;for(;F<Q.length||r<g.length;)if(F>=Q.length)k.push(g[r++]);else if(r>=g.length)k.push(Q[F++]);else if(Q[F]===g[r]){F++,r++;continue}else Q[F]<g[r]?k.push(Q[F++]):r++;return k}const te=(Q,g)=>Q-g;class ce{constructor(g,k){this.c=g,this.d=k}get templateId(){return this.c}renderTemplate(g){return this.d.map(k=>k.renderTemplate(g))}renderElement(g,k,F,r){let i=0;for(const o of this.d)o.renderElement(g,k,F[i++],r)}disposeElement(g,k,F,r){let i=0;for(const o of this.d)o.disposeElement?.(g,k,F[i],r),i+=1}disposeTemplate(g){let k=0;for(const F of this.d)F.disposeTemplate(g[k++])}}class ye{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,k,F){const r=this.c.getAriaLabel(g);r?F.setAttribute("aria-label",r):F.removeAttribute("aria-label");const i=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof i=="number"?F.setAttribute("aria-level",`${i}`):F.removeAttribute("aria-level")}disposeTemplate(g){}}class Te{constructor(g,k){this.c=g,this.d=k}getDragElements(g){const k=this.c.getSelectedElements();return k.indexOf(g)>-1?k:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,k){if(this.d.getDragLabel)return this.d.getDragLabel(g,k)}onDragStart(g,k){this.d.onDragStart?.(g,k)}onDragOver(g,k,F,r,i){return this.d.onDragOver(g,k,F,r,i)}onDragLeave(g,k,F,r){this.d.onDragLeave?.(g,k,F,r)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,k,F,r,i){this.d.drop(g,k,F,r,i)}dispose(){this.d.dispose()}}class Ae{get onDidChangeFocus(){return a.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.G(g),this.y)}get onDidChangeSelection(){return a.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.G(g),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const k=a.Event.chain(this.y.add(new C.$UR(this.k.domNode,"keydown")).event,i=>i.map(o=>new n.$PP(o)).filter(o=>g=o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>A.$OQ.stop(o,!0)).filter(()=>!1)),F=a.Event.chain(this.y.add(new C.$UR(this.k.domNode,"keyup")).event,i=>i.forEach(()=>g=!1).map(o=>new n.$PP(o)).filter(o=>o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>A.$OQ.stop(o,!0)).map(({browserEvent:o})=>{const w=this.getFocus(),M=w.length?w[0]:void 0,T=typeof M<"u"?this.k.element(M):void 0,j=typeof M<"u"?this.k.domElement(M):this.k.domNode;return{index:M,element:T,anchor:j,browserEvent:o}})),r=a.Event.chain(this.k.onContextMenu,i=>i.filter(o=>!g).map(({element:o,index:w,browserEvent:M})=>({element:o,index:w,anchor:new f.$KP((0,A.getWindow)(this.k.domNode),M),browserEvent:M})));return a.Event.any(k,F,r)}get onKeyDown(){return this.y.add(new C.$UR(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$UR(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$UR(this.k.domNode,"keypress")).event}get onDidFocus(){return a.Event.signal(this.y.add(new C.$UR(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return a.Event.signal(this.y.add(new C.$UR(this.k.domNode,"blur",!0)).event)}constructor(g,k,F,r,i=ae){this.A=g,this.B=i,this.c=new u("focused"),this.f=new u("anchor"),this.g=new a.$5d,this.x="",this.y=new t.$Sc,this.z=new a.$Wd,this.onDidDispose=this.z.event;const o=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(o!=="listbox");const w=[this.c.renderer,this.d.renderer];this.u=i.accessibilityProvider,this.u&&(w.push(new ye(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),r=r.map(T=>new ce(T.templateId,[...w,T]));const M={...i,dnd:i.dnd&&new Te(this,i.dnd)};if(this.k=this.C(k,F,r,M),this.k.domNode.setAttribute("role",o),i.styleController)this.q=i.styleController(this.k.domId);else{const T=(0,A.$BQ)(this.k.domNode);this.q=new J(T,this.k.domId)}if(this.o=new S.$YR([new B(this.c,this.k,i.identityProvider),new B(this.d,this.k,i.identityProvider),new B(this.f,this.k,i.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ie(this,this.k)),(typeof i.keyboardSupport!="boolean"||i.keyboardSupport)&&(this.v=new G(this,this.k,i),this.y.add(this.v)),i.keyboardNavigationLabelProvider){const T=i.keyboardNavigationDelegate||e.$hS;this.t=new he(this,this.k,i.keyboardNavigationLabelProvider,i.keyboardNavigationEventFilter??(()=>!0),T),this.y.add(this.t)}this.w=this.D(i),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(g,k,F,r){return new $.$8R(g,k,F,r)}D(g){return new se(this)}updateOptions(g={}){this.B={...this.B,...g},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.B}splice(g,k,F=[]){if(g<0||g>this.k.length)throw new l.$0R(this.A,`Invalid start index: ${g}`);if(k<0)throw new l.$0R(this.A,`Invalid delete count: ${k}`);k===0&&F.length===0||this.g.bufferEvents(()=>this.o.splice(g,k,F))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,k){this.k.updateElementHeight(g,k,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}indexAt(g){return this.k.indexAt(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(g){this.x=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,k){this.k.layout(g,k)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,k){for(const F of g)if(F<0||F>=this.length)throw new l.$0R(this.A,`Invalid index ${F}`);this.d.set(g,k)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new l.$0R(this.A,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,m.$Ob)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,k){for(const F of g)if(F<0||F>=this.length)throw new l.$0R(this.A,`Invalid index ${F}`);this.c.set(g,k)}focusNext(g=1,k=!1,F,r){if(this.length===0)return;const i=this.c.get(),o=this.E(i.length>0?i[0]+g:0,k,r);o>-1&&this.setFocus([o],F)}focusPrevious(g=1,k=!1,F,r){if(this.length===0)return;const i=this.c.get(),o=this.F(i.length>0?i[0]-g:0,k,r);o>-1&&this.setFocus([o],F)}async focusNextPage(g,k){let F=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);F=F===0?0:F-1;const r=this.getFocus()[0];if(r!==F&&(r===void 0||F>r)){const i=this.F(F,!1,k);i>-1&&r!==i?this.setFocus([i],g):this.setFocus([F],g)}else{const i=this.k.getScrollTop();let o=i+this.k.renderHeight;F>r&&(o-=this.k.elementHeight(F)),this.k.setScrollTop(o),this.k.getScrollTop()!==i&&(this.setFocus([]),await(0,p.$9g)(0),await this.focusNextPage(g,k))}}async focusPreviousPage(g,k,F=()=>0){let r;const i=F(),o=this.k.getScrollTop()+i;o===0?r=this.k.indexAt(o):r=this.k.indexAfter(o-1);const w=this.getFocus()[0];if(w!==r&&(w===void 0||w>=r)){const M=this.E(r,!1,k);M>-1&&w!==M?this.setFocus([M],g):this.setFocus([r],g)}else{const M=o;this.k.setScrollTop(o-this.k.renderHeight-i),this.k.getScrollTop()+F()!==M&&(this.setFocus([]),await(0,p.$9g)(0),await this.focusPreviousPage(g,k,F))}}focusLast(g,k){if(this.length===0)return;const F=this.F(this.length-1,!1,k);F>-1&&this.setFocus([F],g)}focusFirst(g,k){this.focusNth(0,g,k)}focusNth(g,k,F){if(this.length===0)return;const r=this.E(g,!1,F);r>-1&&this.setFocus([r],k)}E(g,k=!1,F){for(let r=0;r<this.length;r++){if(g>=this.length&&!k)return-1;if(g=g%this.length,!F||F(this.element(g)))return g;g++}return-1}F(g,k=!1,F){for(let r=0;r<this.length;r++){if(g<0&&!k)return-1;if(g=(this.length+g%this.length)%this.length,!F||F(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,k,F=0){if(g<0||g>=this.length)throw new l.$0R(this.A,`Invalid index ${g}`);const r=this.k.getScrollTop(),i=this.k.elementTop(g),o=this.k.elementHeight(g);if((0,c.$Nf)(k)){const w=o-this.k.renderHeight+F;this.k.setScrollTop(w*(0,s.$9l)(k,0,1)+i-F)}else{const w=i+o,M=r+this.k.renderHeight;i<r+F&&w>=M||(i<r+F||w>=M&&o>=this.k.renderHeight?this.k.setScrollTop(i-F):w>=M&&this.k.setScrollTop(w-this.k.renderHeight))}}getRelativeTop(g,k=0){if(g<0||g>=this.length)throw new l.$0R(this.A,`Invalid index ${g}`);const F=this.k.getScrollTop(),r=this.k.elementTop(g),i=this.k.elementHeight(g);if(r<F+k||r+i>F+this.k.renderHeight)return null;const o=i-this.k.renderHeight+k;return Math.abs((F+k-r)/o)}isDOMFocused(){return(0,A.$tQ)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(g){return this.k.getElementDomId(g)}getElementTop(g){return this.k.elementTop(g)}style(g){this.q.style(g)}G({indexes:g,browserEvent:k}){return{indexes:g,elements:g.map(F=>this.k.element(F)),browserEvent:k}}H(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.I()}I(){const g=this.c.get();if(g.length>0){let k;this.u?.getActiveDescendantId&&(k=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",k||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}e.$nS=Ae,Xe([I.$zh],Ae.prototype,"onDidChangeFocus",null),Xe([I.$zh],Ae.prototype,"onDidChangeSelection",null),Xe([I.$zh],Ae.prototype,"onContextMenu",null),Xe([I.$zh],Ae.prototype,"onKeyDown",null),Xe([I.$zh],Ae.prototype,"onKeyUp",null),Xe([I.$zh],Ae.prototype,"onKeyPress",null),Xe([I.$zh],Ae.prototype,"onDidFocus",null),Xe([I.$zh],Ae.prototype,"onDidBlur",null)}),define($e[62],pe([1,0,6,36,38,10,15]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(S||(e.MarkdownStringTextNewlineStyle=S={}));class m{constructor(l="",$=!1){if(this.value=l,typeof this.value!="string")throw(0,A.$7)("value");typeof $=="boolean"?(this.isTrusted=$,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=$.isTrusted??void 0,this.supportThemeIcons=$.supportThemeIcons??!1,this.supportHtml=$.supportHtml??!1)}appendText(l,$=0){return this.value+=a(this.supportThemeIcons?(0,C.$dk)(l):l).replace(/([ \t]+)/g,(f,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,$===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,$){return this.value+=`
${h($,l)}
`,this}appendLink(l,$,f){return this.value+="[",this.value+=this.c($,"]"),this.value+="](",this.value+=this.c(String(l),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(l,$){const f=new RegExp((0,U.$Pe)($),"g");return l.replace(f,(b,u)=>l.charAt(u-1)!=="\\"?`\\${b}`:b)}}e.$jk=m;function p(c){return v(c)?!c.value:Array.isArray(c)?c.every(p):!0}e.$kk=p;function v(c){return c instanceof m?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.$lk=v;function I(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,n.$Bg)(D.URI.from(c.baseUri),D.URI.from(l.baseUri)))}e.$mk=I;function a(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$nk=a;function h(c,l){const $=c.match(/^`+/gm)?.reduce((b,u)=>b.length>u.length?b:u).length??0,f=$>=3?$+1:3;return[`${"`".repeat(f)}${l}`,c,`${"`".repeat(f)}`].join(`
`)}e.$ok=h;function t(c){return c.replace(/"/g,"&quot;")}e.$pk=t;function s(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$qk=s;function d(c){const l=[],$=c.split("|").map(b=>b.trim());c=$[0];const f=$[1];if(f){const b=/height=(\d+)/.exec(f),u=/width=(\d+)/.exec(f),N=b?b[1]:"",B=u?u[1]:"",P=isFinite(parseInt(B)),W=isFinite(parseInt(N));P&&l.push(`width="${B}"`),W&&l.push(`height="${N}"`)}return{href:c,dimensions:l}}e.$rk=d}),define($e[126],pe([1,0,2,118,22,55,14,19,119,6,4,62,36,77,23,3,79,53,31,51,38,10,15]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a,h,t,s,d,c,l,$,f,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uS=e.$tS=e.$sS=e.$rS=e.$qS=void 0;const N=Object.freeze({image:(x,te,ce)=>{let ye=[],Te=[];return x&&({href:x,dimensions:ye}=(0,I.$rk)(x),Te.push(`src="${(0,I.$pk)(x)}"`)),ce&&Te.push(`alt="${(0,I.$pk)(ce)}"`),te&&Te.push(`title="${(0,I.$pk)(te)}"`),ye.length&&(Te=Te.concat(ye)),"<img "+Te.join(" ")+">"},paragraph:x=>`<p>${x}</p>`,link:(x,te,ce)=>typeof x!="string"?"":(x===ce&&(ce=(0,I.$qk)(ce)),te=typeof te=="string"?(0,I.$pk)((0,I.$qk)(te)):"",x=(0,I.$qk)(x),x=x.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${x}" title="${te||x}" draggable="false">${ce}</a>`)});function B(x,te={},ce={}){const ye=new s.$Sc;let Te=!1;const Ae=(0,U.$TR)(te),Q=function(T){let j;try{j=(0,c.$Dh)(decodeURIComponent(T))}catch{}return j?(j=(0,$.$An)(j,_=>{if(x.uris&&x.uris[_])return u.URI.revive(x.uris[_])}),encodeURIComponent(JSON.stringify(j))):T},g=function(T,j){const _=x.uris&&x.uris[T];let Y=u.URI.revive(_);return j?T.startsWith(l.Schemas.data+":")?T:(Y||(Y=u.URI.parse(T)),l.$pg.uriToBrowserUri(Y).toString(!0)):!Y||u.URI.parse(T).toString()===Y.toString()?T:(Y.query&&(Y=Y.with({query:Q(Y.query)})),Y.toString())},k=new d.marked.Renderer;k.image=N.image,k.link=N.link,k.paragraph=N.paragraph;const F=[],r=[];if(te.codeBlockRendererSync?k.code=(T,j)=>{const _=h.$vN.nextId(),Y=te.codeBlockRendererSync(P(j),T);return r.push([_,Y]),`<div class="code" data-code="${_}">${(0,b.$Oe)(T)}</div>`}:te.codeBlockRenderer&&(k.code=(T,j)=>{const _=h.$vN.nextId(),Y=te.codeBlockRenderer(P(j),T);return F.push(Y.then(oe=>[_,oe])),`<div class="code" data-code="${_}">${(0,b.$Oe)(T)}</div>`}),te.actionHandler){const T=function(Y){let oe=Y.target;if(!(oe.tagName!=="A"&&(oe=oe.parentElement,!oe||oe.tagName!=="A")))try{let be=oe.dataset.href;be&&(x.baseUri&&(be=W(u.URI.from(x.baseUri),be)),te.actionHandler.callback(be,Y))}catch(be){(0,p.$1)(be)}finally{Y.preventDefault()}},j=te.actionHandler.disposables.add(new n.$UR(Ae,"click")),_=te.actionHandler.disposables.add(new n.$UR(Ae,"auxclick"));te.actionHandler.disposables.add(v.Event.any(j.event,_.event)(Y=>{const oe=new S.$KP(A.getWindow(Ae),Y);!oe.leftButton&&!oe.middleButton||T(oe)})),te.actionHandler.disposables.add(A.$SP(Ae,"keydown",Y=>{const oe=new D.$PP(Y);!oe.equals(10)&&!oe.equals(3)||T(oe)}))}x.supportHtml||(ce.sanitizer=T=>(x.isTrusted?T.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?T:"",ce.sanitize=!0,ce.silent=!0),ce.renderer=k;let i=x.value??"";i.length>1e5&&(i=`${i.substr(0,1e5)}\u2026`),x.supportThemeIcons&&(i=(0,a.$ek)(i));let o;if(te.fillInIncompleteTokens){const T={...d.marked.defaults,...ce},j=d.marked.lexer(i,T),_=ge(j);o=d.marked.parser(_,T)}else o=d.marked.parse(i,ce);x.supportThemeIcons&&(o=(0,m.$oS)(o).map(j=>typeof j=="string"?j:j.outerHTML).join(""));const M=new DOMParser().parseFromString(z(x,o),"text/html");if(M.body.querySelectorAll("img").forEach(T=>{const j=T.getAttribute("src");if(j){let _=j;try{x.baseUri&&(_=W(u.URI.from(x.baseUri),_))}catch{}T.src=g(_,!0)}}),M.body.querySelectorAll("a").forEach(T=>{const j=T.getAttribute("href");if(T.setAttribute("href",""),!j||/^data:|javascript:/i.test(j)||/^command:/i.test(j)&&!x.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(j))T.replaceWith(...T.childNodes);else{let _=g(j,!1);x.baseUri&&(_=W(u.URI.from(x.baseUri),j)),T.dataset.href=_}}),Ae.innerHTML=z(x,M.body.innerHTML),F.length>0)Promise.all(F).then(T=>{if(Te)return;const j=new Map(T),_=Ae.querySelectorAll("div[data-code]");for(const Y of _){const oe=j.get(Y.dataset.code??"");oe&&A.$VQ(Y,oe)}te.asyncRenderCallback?.()});else if(r.length>0){const T=new Map(r),j=Ae.querySelectorAll("div[data-code]");for(const _ of j){const Y=T.get(_.dataset.code??"");Y&&A.$VQ(_,Y)}}if(te.asyncRenderCallback)for(const T of Ae.getElementsByTagName("img")){const j=ye.add(A.$SP(T,"load",()=>{j.dispose(),te.asyncRenderCallback()}))}return{element:Ae,dispose:()=>{Te=!0,ye.dispose()}}}e.$qS=B;function P(x){if(!x)return"";const te=x.split(/[\s+|:|,|\{|\?]/,1);return te.length?te[0]:x}function W(x,te){return/^\w[\w\d+.-]*:/.test(te)?te:x.path.endsWith("/")?(0,f.$Lg)(x,te).toString():(0,f.$Lg)((0,f.$Hg)(x),te).toString()}function z(x,te){const{config:ce,allowedSchemes:ye}=y(x);C.addHook("uponSanitizeAttribute",(Ae,Q)=>{if(Q.attrName==="style"||Q.attrName==="class"){if(Ae.tagName==="SPAN"){if(Q.attrName==="style"){Q.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Q.attrValue);return}else if(Q.attrName==="class"){Q.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Q.attrValue);return}}Q.keepAttr=!1;return}else if(Ae.tagName==="INPUT"&&Ae.attributes.getNamedItem("type")?.value==="checkbox"){if(Q.attrName==="type"&&Q.attrValue==="checkbox"||Q.attrName==="disabled"||Q.attrName==="checked"){Q.keepAttr=!0;return}Q.keepAttr=!1}}),C.addHook("uponSanitizeElement",(Ae,Q)=>{Q.tagName==="input"&&(Ae.attributes.getNamedItem("type")?.value==="checkbox"?Ae.setAttribute("disabled",""):Ae.parentElement?.removeChild(Ae))});const Te=A.$dR(ye);try{return C.sanitize(te,{...ce,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),Te.dispose()}}e.$rS=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function y(x){const te=[l.Schemas.http,l.Schemas.https,l.Schemas.mailto,l.Schemas.data,l.Schemas.file,l.Schemas.vscodeFileResource,l.Schemas.vscodeRemote,l.Schemas.vscodeRemoteResource];return x.isTrusted&&te.push(l.Schemas.command),{config:{ALLOWED_TAGS:[...A.$eR],ALLOWED_ATTR:e.$rS,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:te}}function O(x){return typeof x=="string"?x:H(x)}e.$sS=O;function H(x){let te=x.value??"";te.length>1e5&&(te=`${te.substr(0,1e5)}\u2026`);const ce=d.marked.parse(te,{renderer:R.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ye=>E.get(ye)??ye);return z({isTrusted:!1},ce).toString()}e.$tS=H;const E=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),R=new t.$V(()=>{const x=new d.marked.Renderer;return x.code=te=>te,x.blockquote=te=>te,x.html=te=>"",x.heading=(te,ce,ye)=>te+`
`,x.hr=()=>"",x.list=(te,ce)=>te,x.listitem=te=>te+`
`,x.paragraph=te=>te+`
`,x.table=(te,ce)=>te+ce+`
`,x.tablerow=te=>te,x.tablecell=(te,ce)=>te+" ",x.strong=te=>te,x.em=te=>te,x.codespan=te=>te,x.br=()=>`
`,x.del=te=>te,x.image=(te,ce,ye)=>"",x.text=te=>te,x.link=(te,ce,ye)=>ye,x});function L(x){let te="";return x.forEach(ce=>{te+=ce.raw}),te}function G(x){for(let te=0;te<x.tokens.length;te++){const ce=x.tokens[te];if(ce.type==="text"){const ye=ce.raw.split(`
`),Te=ye[ye.length-1];if(Te.includes("`"))return ie(x);if(Te.includes("**"))return J(x);if(Te.match(/\*\w/))return fe(x);if(Te.match(/(^|\s)__\w/))return ae(x);if(Te.match(/(^|\s)_\w/))return Re(x);if(Te.match(/(^|\s)\[.*\]\(\w*/)){const Ae=x.tokens.slice(te+1);return Ae[0]?.type==="link"&&Ae[1]?.type==="text"&&Ae[1].raw.match(/^ *"[^"]*$/)?Be(x):Ne(x)}else{if(Z(Te))return Ne(x);if(Te.match(/(^|\s)\[\w/)&&!x.tokens.slice(te+1).some(Ae=>Z(Ae.raw)))return se(x)}}}}function Z(x){return!!x.match(/^[^\[]*\]\([^\)]*$/)}function ge(x){let te,ce;for(te=0;te<x.length;te++){const ye=x[te];let Te;if(ye.type==="paragraph"&&(Te=ye.raw.match(/(\n|^)(````*)/))){const Ae=Te[2];ce=he(x.slice(te),Ae);break}if(ye.type==="paragraph"&&ye.raw.match(/(\n|^)\|/)){ce=X(x.slice(te));break}if(te===x.length-1&&ye.type==="paragraph"){const Ae=G(ye);if(Ae){ce=[Ae];break}}}if(ce){const ye=[...x.slice(0,te),...ce];return ye.links=x.links,ye}return x}e.$uS=ge;function he(x,te){const ce=L(x);return d.marked.lexer(ce+`
${te}`)}function ie(x){return re(x,"`")}function fe(x){return re(x,"*")}function Re(x){return re(x,"_")}function Ne(x){return re(x,")")}function Be(x){return re(x,'")')}function se(x){return re(x,"](about:blank)")}function J(x){return re(x,"**")}function ae(x){return re(x,"__")}function re(x,te){const ce=L(Array.isArray(x)?x:[x]);return d.marked.lexer(ce+te)[0]}function X(x){const te=L(x),ce=te.split(`
`);let ye,Te=!1;for(let Ae=0;Ae<ce.length;Ae++){const Q=ce[Ae].trim();if(typeof ye>"u"&&Q.match(/^\s*\|/)){const g=Q.match(/(\|[^\|]+)(?=\||$)/g);g&&(ye=g.length)}else if(typeof ye=="number")if(Q.match(/^\s*\|/)){if(Ae!==ce.length-1)return;Te=!0}else return}if(typeof ye=="number"&&ye>0){const Ae=Te?ce.slice(0,-1).join(`
`):te,Q=!!Ae.match(/\|\s*$/),g=Ae+(Q?"":"|")+`
|${" --- |".repeat(ye)}`;return d.marked.lexer(g)}}}),define($e[127],pe([1,0,2,9,29,62,36,3,7,108]),function(ne,e,A,C,n,U,D,S,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LR=e.$KR=void 0;function v(h,t){(0,m.$Jf)(t)?h.title=(0,D.$fk)(t):t?.markdownNotSupportedFallback?h.title=t.markdownNotSupportedFallback:h.removeAttribute("title")}e.$KR=v;class I{constructor(t,s,d){this.c=t,this.d=s,this.f=d}async update(t,s,d){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let c;if(t===void 0||(0,m.$Jf)(t)||t instanceof HTMLElement)c=t;else if(!(0,m.$Xf)(t.markdown))c=t.markdown??t.markdownNotSupportedFallback;else{this.a||this.g((0,p.localize)(0,null),s),this.b=new n.$7d;const l=this.b.token;if(c=await t.markdown(l),c===void 0&&(c=t.markdownNotSupportedFallback),this.isDisposed||l.isCancellationRequested)return}this.g(c,s,d)}g(t,s,d){const c=this.a;if(this.h(t)){const l={content:t,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!c},position:{hoverPosition:2},...d};this.a=this.c.showHover(l,s)}c?.dispose()}h(t){return t?(0,U.$lk)(t)?!!t.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function a(h,t,s,d){let c,l;const $=(H,E)=>{const R=l!==void 0;H&&(l?.dispose(),l=void 0),E&&(c?.dispose(),c=void 0),R&&h.onDidHideHover?.()},f=(H,E,R)=>new C.$fh(async()=>{(!l||l.isDisposed)&&(l=new I(h,R||t,H>0),await l.update(s,E,d))},H);let b=!1;const u=A.$SP(t,A.$MQ.MOUSE_DOWN,()=>{b=!0,$(!0,!0)},!0),N=A.$SP(t,A.$MQ.MOUSE_UP,()=>{b=!1},!0),B=A.$SP(t,A.$MQ.MOUSE_LEAVE,H=>{b=!1,$(!1,H.fromElement===t)},!0),P=()=>{if(c)return;const H=new S.$Sc,E={targetElements:[t],dispose:()=>{}};if(h.placement===void 0||h.placement==="mouse"){const R=L=>{E.x=L.x+10,L.target instanceof HTMLElement&&L.target.classList.contains("action-label")&&$(!0,!0)};H.add(A.$SP(t,A.$MQ.MOUSE_MOVE,R,!0))}H.add(f(h.delay,!1,E)),c=H},W=A.$SP(t,A.$MQ.MOUSE_OVER,P,!0),z=()=>{if(b||c)return;const H={targetElements:[t],dispose:()=>{}},E=new S.$Sc,R=()=>$(!0,!0);E.add(A.$SP(t,A.$MQ.BLUR,R,!0)),E.add(f(h.delay,!1,H)),c=E},y=A.$SP(t,A.$MQ.FOCUS,z,!0);return{show:H=>{$(!1,!0),f(0,H)},hide:()=>{$(!0,!0)},update:async(H,E)=>{s=H,await l?.update(s,void 0,E)},dispose:()=>{W.dispose(),B.dispose(),u.dispose(),N.dispose(),y.dispose(),$(!0,!0)}}}e.$LR=a}),define($e[128],pe([1,0,2,22,14,126,40,12,4,45,3,5,110,101]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vS=void 0;const h=A.$,t="selectOption.entry.template";class s{get templateId(){return t}renderTemplate(l){const $=Object.create(null);return $.root=l,$.text=A.$TQ(l,h(".option-text")),$.detail=A.$TQ(l,h(".option-detail")),$.decoratorRight=A.$TQ(l,h(".option-decorator-right")),$}renderElement(l,$,f){const b=f,u=l.text,N=l.detail,B=l.decoratorRight,P=l.isDisabled;b.text.textContent=u,b.detail.textContent=N||"",b.decoratorRight.innerText=B||"",P?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(l){}}class d extends v.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(l,$,f,b,u){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=b,this.g=u||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=d.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new m.$Wd,this.B(this.r),this.O(),this.N(f),this.n=$||0,l&&this.setOptions(l,$),this.Q()}getHeight(){return 22}getTemplateId(){return t}N(l){this.u=l,this.w=A.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=A.$TQ(this.w,h(".select-box-details-pane"));const $=A.$TQ(this.w,h(".select-box-dropdown-container-width-control")),f=A.$TQ($,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",A.$TQ(f,this.D),this.G=0,this.y=A.$BQ(this.w),this.w.setAttribute("draggable","true"),this.B(A.$SP(this.w,A.$MQ.DRAG_START,b=>{A.$OQ.stop(b,!0)}))}O(){this.B(A.$TP(this.h,"change",$=>{this.n=$.target.selectedIndex,this.r.fire({index:$.target.selectedIndex,selected:$.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(A.$SP(this.h,A.$MQ.CLICK,$=>{A.$OQ.stop($),this.f?this.X(!0):this.W()})),this.B(A.$SP(this.h,A.$MQ.MOUSE_DOWN,$=>{A.$OQ.stop($)}));let l;this.B(A.$SP(this.h,"touchstart",$=>{l=this.f})),this.B(A.$SP(this.h,"touchend",$=>{A.$OQ.stop($),l?this.X(!0):this.W()})),this.B(A.$SP(this.h,A.$MQ.KEY_DOWN,$=>{const f=new n.$PP($);let b=!1;I.$j?(f.keyCode===18||f.keyCode===16||f.keyCode===10||f.keyCode===3)&&(b=!0):(f.keyCode===18&&f.altKey||f.keyCode===16&&f.altKey||f.keyCode===10||f.keyCode===3)&&(b=!0),b&&(this.W(),A.$OQ.stop($,!0))}))}get onDidSelect(){return this.r.event}setOptions(l,$){S.$ub(this.m,l)||(this.m=l,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((f,b)=>{this.h.add(this.U(f.text,b,f.isDisabled)),typeof f.description=="string"&&(this.H=!0)})),$!==void 0&&(this.select($),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(l){l>=0&&l<this.m.length?this.n=l:l>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(l){this.g.ariaLabel=l,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(l){this.h.tabIndex=l?0:-1}render(l){this.j=l,l.classList.add("select-container"),l.appendChild(this.h),this.R()}Q(){const l=[];this.s.listFocusBackground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(l.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),l.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),l.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=l.join(`
`)}R(){const l=this.s.selectBackground??"",$=this.s.selectForeground??"",f=this.s.selectBorder??"";this.h.style.backgroundColor=l,this.h.style.color=$,this.h.style.borderColor=f}S(){const l=this.s.selectBackground??"",$=A.$_Q(this.s.selectListBackground,l);this.C.style.backgroundColor=$,this.I.style.backgroundColor=$;const f=this.s.focusBorder??"";this.w.style.outlineColor=f,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(l,$,f){const b=document.createElement("option");return b.value=l,b.text=l,b.disabled=!!f,b}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:l=>this.Y(l,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:l=>this.Y(l),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(l){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),l&&this.h.focus(),this.u.hideContextView())}Y(l,$){return l.appendChild(this.w),this.ab($),{dispose:()=>{try{l.removeChild(this.w)}catch{}}}}Z(){let l=0;return this.m.forEach(($,f)=>{this.hb(f),this.I.offsetHeight>l&&(l=this.I.offsetHeight)}),l}ab(l){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const $=A.getWindow(this.h),f=A.$cQ(this.h),b=A.getWindow(this.h).getComputedStyle(this.h),u=parseFloat(b.getPropertyValue("--dropdown-padding-top"))+parseFloat(b.getPropertyValue("--dropdown-padding-bottom")),N=$.innerHeight-f.top-f.height-(this.g.minBottomMargin||0),B=f.top-d.b,P=this.h.offsetWidth,W=this.bb(this.D),z=Math.max(W,Math.round(P)).toString()+"px";this.w.style.width=z,this.z.getHTMLElement().style.height="",this.z.layout();let y=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const O=this.H?this.L:0,H=y+u+O,E=Math.floor((N-u-O)/this.getHeight()),R=Math.floor((B-u-O)/this.getHeight());if(l)return f.top+f.height>$.innerHeight-22||f.top<d.b||E<1&&R<1?!1:(E<d.c&&R>E&&this.m.length>E?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(f.top+f.height>$.innerHeight-22||f.top<d.b||this.G===0&&E<1||this.G===1&&R<1)return this.X(!0),!1;if(this.G===0){if(this.f&&E+R<1)return this.X(!0),!1;H>N&&(y=E*this.getHeight())}else H>B&&(y=R*this.getHeight());return this.z.layout(y),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=y+u+"px",this.w.style.height=""):this.w.style.height=y+u+"px",this.hb(this.n),this.w.style.width=z,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(l){let $=0;if(l){let f=0,b=0;this.m.forEach((u,N)=>{const B=u.detail?u.detail.length:0,P=u.decoratorRight?u.decoratorRight.length:0,W=u.text.length+B+P;W>b&&(f=N,b=W)}),l.textContent=this.m[f].text+(this.m[f].decoratorRight?this.m[f].decoratorRight+" ":""),$=A.$eQ(l)}return $}cb(l){if(this.z)return;this.C=A.$TQ(l,h(".select-box-dropdown-list-container")),this.t=new s,this.z=new D.$nS("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let u=b.text;return b.detail&&(u+=`. ${b.detail}`),b.decoratorRight&&(u+=`. ${b.decoratorRight}`),b.description&&(u+=`. ${b.description}`),u},getWidgetAriaLabel:()=>(0,a.localize)(0,null),getRole:()=>I.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const $=this.B(new C.$UR(this.C,"keydown")),f=m.Event.chain($.event,b=>b.filter(()=>this.z.length>0).map(u=>new n.$PP(u)));this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===3))(this.jb,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===2))(this.jb,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===9))(this.ib,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===16))(this.lb,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===18))(this.kb,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===12))(this.nb,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===11))(this.mb,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===14))(this.ob,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode===13))(this.pb,this)),this.B(m.Event.chain(f,b=>b.filter(u=>u.keyCode>=21&&u.keyCode<=56||u.keyCode>=85&&u.keyCode<=113))(this.qb,this)),this.B(A.$SP(this.z.getHTMLElement(),A.$MQ.POINTER_UP,b=>this.db(b))),this.B(this.z.onMouseOver(b=>typeof b.index<"u"&&this.z.setFocus([b.index]))),this.B(this.z.onDidChangeFocus(b=>this.gb(b))),this.B(A.$SP(this.w,A.$MQ.FOCUS_OUT,b=>{!this.f||A.$kQ(b.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(l){if(!this.z.length)return;A.$OQ.stop(l);const $=l.target;if(!$||$.classList.contains("slider"))return;const f=$.closest(".monaco-list-row");if(!f)return;const b=Number(f.getAttribute("data-index")),u=f.classList.contains("option-disabled");b>=0&&b<this.m.length&&!u&&(this.n=b,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(l,$){const f=u=>{for(let N=0;N<u.childNodes.length;N++){const B=u.childNodes.item(N);(B.tagName&&B.tagName.toLowerCase())==="img"?u.removeChild(B):f(B)}},b=(0,U.$qS)({value:l,supportThemeIcons:!0},{actionHandler:$});return b.element.classList.add("select-box-description-markdown"),f(b.element),b.element}gb(l){!this.f||!this.H||this.hb(l.indexes[0])}hb(l){this.I.innerText="";const $=this.m[l],f=$?.description??"",b=$?.descriptionIsMarkdown??!1;if(f){if(b){const u=$.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(f,u))}else this.I.innerText=f;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(l){A.$OQ.stop(l),this.select(this.F),this.X(!0)}jb(l){A.$OQ.stop(l),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(l){if(this.n<this.m.length-1){A.$OQ.stop(l,!0);const $=this.m[this.n+1].isDisabled;if($&&this.m.length>this.n+2)this.n+=2;else{if($)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(l){this.n>0&&(A.$OQ.stop(l,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(l){A.$OQ.stop(l),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(l){A.$OQ.stop(l),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(l){A.$OQ.stop(l),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(l){A.$OQ.stop(l),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(l){const $=p.KeyCodeUtils.toString(l.keyCode);let f=-1;for(let b=0;b<this.m.length-1;b++)if(f=(b+this.n+1)%this.m.length,this.m[f].text.charAt(0).toUpperCase()===$&&!this.m[f].isDisabled){this.select(f),this.z.setFocus([f]),this.z.reveal(this.z.getFocus()[0]),A.$OQ.stop(l);break}}dispose(){this.X(!1),super.dispose()}}e.$vS=d}),define($e[129],pe([1,0,40,128,122,20,5,100]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yS=e.$xS=void 0,e.$xS={...A.$mS,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class S extends U.$uR{constructor(p,v,I,a,h){super(),D.$j&&!h?.useCustomDrawn?this.a=new n.$wS(p,v,a,h):this.a=new C.$vS(p,v,I,a,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(p,v){this.a.setOptions(p,v)}select(p){this.a.select(p)}setAriaLabel(p){this.a.setAriaLabel(p)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(p){this.a.setFocusable(p)}render(p){this.a.render(p)}}e.$yS=S}),define($e[63],pe([1,0,16,54,2,25,127,129,37,3,5,7,105,52]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GS=e.$FS=e.$ES=void 0;class h extends p.$Tc{get action(){return this._action}constructor(c,l,$={}){super(),this.m=$,this._context=c||this,this._action=l,l instanceof m.$Mi&&this.B(l.onDidChange(f=>{this.element&&this.t(f)}))}t(c){c.enabled!==void 0&&this.u(),c.checked!==void 0&&this.H(),c.class!==void 0&&this.G(),c.label!==void 0&&(this.w(),this.D()),c.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new m.$Ni)),this.j}set actionRunner(c){this.j=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const l=this.element=c;this.B(U.$qR.addTarget(c));const $=this.m&&this.m.draggable;$&&(c.draggable=!0,A.$yP&&this.B((0,n.$SP)(c,n.$MQ.DRAG_START,f=>f.dataTransfer?.setData(C.$oR.TEXT,this._action.label)))),this.B((0,n.$SP)(l,U.EventType.Tap,f=>this.onClick(f,!0))),this.B((0,n.$SP)(l,n.$MQ.MOUSE_DOWN,f=>{$||n.$OQ.stop(f,!0),this._action.enabled&&f.button===0&&l.classList.add("active")})),v.$j&&this.B((0,n.$SP)(l,n.$MQ.CONTEXT_MENU,f=>{f.button===0&&f.ctrlKey===!0&&this.onClick(f)})),this.B((0,n.$SP)(l,n.$MQ.CLICK,f=>{n.$OQ.stop(f,!0),this.m&&this.m.isMenu||this.onClick(f)})),this.B((0,n.$SP)(l,n.$MQ.DBLCLICK,f=>{n.$OQ.stop(f,!0)})),[n.$MQ.MOUSE_UP,n.$MQ.MOUSE_OUT].forEach(f=>{this.B((0,n.$SP)(l,f,b=>{n.$OQ.stop(b),l.classList.remove("active")}))})}onClick(c,l=!1){n.$OQ.stop(c,!0);const $=I.$Sf(this._context)?this.m?.useEventAsContext?c:{preserveFocus:l}:this._context;this.actionRunner.run(this._action,$)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const c=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(c):(this.f=(0,D.$LR)(this.m.hoverDelegate,this.element,c),this.q.add(this.f))):this.element.title=c}F(){if(this.element){const c=this.C()??"";this.element.setAttribute("aria-label",c)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}e.$ES=h;class t extends h{constructor(c,l,$){super(c,l,$),this.m=$,this.m.icon=$.icon!==void 0?$.icon:!1,this.m.label=$.label!==void 0?$.label:!0,this.L=""}render(c){super.render(c),I.$Tf(this.element);const l=document.createElement("a");if(l.classList.add("action-label"),l.setAttribute("role",this.M()),this.I=l,this.element.appendChild(l),this.m.label&&this.m.keybinding){const $=document.createElement("span");$.classList.add("keybinding"),$.textContent=this.m.keybinding,this.element.appendChild($)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===m.$Oi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(c){this.I&&(this.I.tabIndex=c?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(c=this.action.label,this.m.keybinding&&(c=a.localize(0,null,c,this.m.keybinding))),c??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const c=this.C()??"";this.I.setAttribute("aria-label",c)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}e.$FS=t;class s extends h{constructor(c,l,$,f,b,u,N){super(c,l),this.b=new S.$yS($,f,b,u,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(c,l){this.b.setOptions(c,l)}select(c){this.b.select(c)}g(){this.B(this.b.onDidSelect(c=>this.n(c.selected,c.index)))}n(c,l){this.actionRunner.run(this._action,this.r(c,l))}r(c,l){return c}setFocusable(c){this.b.setFocusable(c)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(c){this.b.render(c)}}e.$GS=s}),define($e[64],pe([1,0,2,14,63,37,4,3,7,52]),function(ne,e,A,C,n,U,D,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NR=e.$MR=e.ActionsOrientation=void 0;var p;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(p||(e.ActionsOrientation=p={}));class v extends S.$Tc{constructor(h,t={}){super(),this.g=this.B(new S.$Sc),this.r=this.B(new S.$3c),this.w=!1,this.y=!0,this.C=this.B(new D.$Wd),this.onDidBlur=this.C.event,this.D=this.B(new D.$Wd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new D.$Wd),this.onDidRun=this.G.event,this.H=this.B(new D.$Wd),this.onWillRun=this.H.event,this.b=t,this.j=t.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$Ni,this.g.add(this.f)),this.g.add(this.f.onDidRun(c=>this.G.fire(c))),this.g.add(this.f.onWillRun(c=>this.H.fire(c))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",t.animated!==!1&&this.domNode.classList.add("animated");let s,d;switch(this.m){case 0:s=[15],d=[17];break;case 1:s=[16],d=[18],this.domNode.className+=" vertical";break}this.B(A.$SP(this.domNode,A.$MQ.KEY_DOWN,c=>{const l=new C.$PP(c);let $=!0;const f=typeof this.t=="number"?this.viewItems[this.t]:void 0;s&&(l.equals(s[0])||l.equals(s[1]))?$=this.P():d&&(l.equals(d[0])||l.equals(d[1]))?$=this.O():l.equals(9)&&this.F?this.D.fire():l.equals(14)?$=this.M():l.equals(13)?$=this.N():l.equals(2)&&f instanceof n.$ES&&f.trapsArrowNavigation?$=this.O():this.J(l)?this.n.keyDown?this.R(l):this.w=!0:$=!1,$&&(l.preventDefault(),l.stopPropagation())})),this.B(A.$SP(this.domNode,A.$MQ.KEY_UP,c=>{const l=new C.$PP(c);this.J(l)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(l)),l.preventDefault(),l.stopPropagation()):(l.equals(2)||l.equals(1026)||l.equals(16)||l.equals(18)||l.equals(15)||l.equals(17))&&this.L()})),this.u=this.B(A.$RQ(this.domNode)),this.B(this.u.onDidBlur(()=>{(A.$sQ()===this.domNode||!A.$kQ(A.$sQ(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),h.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(h){h?this.z.setAttribute("aria-label",h):this.z.removeAttribute("aria-label")}setFocusable(h){if(this.y=h,this.y){const t=this.viewItems.find(s=>s instanceof n.$ES&&s.isEnabled());t instanceof n.$ES&&t.setFocusable(!0)}else this.viewItems.forEach(t=>{t instanceof n.$ES&&t.setFocusable(!1)})}J(h){let t=!1;return this.n.keys.forEach(s=>{t=t||h.equals(s)}),t}L(){for(let h=0;h<this.z.children.length;h++){const t=this.z.children[h];if(A.$kQ(A.$sQ(),t)){this.t=h,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(h){this.j=h,this.viewItems.forEach(t=>t.setActionContext(h))}get actionRunner(){return this.f}set actionRunner(h){this.f=h,this.g.clear(),this.g.add(this.f.onDidRun(t=>this.G.fire(t))),this.g.add(this.f.onWillRun(t=>this.H.fire(t))),this.viewItems.forEach(t=>t.actionRunner=h)}getContainer(){return this.domNode}hasAction(h){return this.viewItems.findIndex(t=>t.action.id===h.id)!==-1}getAction(h){if(typeof h=="number")return this.viewItems[h]?.action;if(h instanceof HTMLElement){for(;h.parentElement!==this.z;){if(!h.parentElement)return;h=h.parentElement}for(let t=0;t<this.z.childNodes.length;t++)if(this.z.childNodes[t]===h)return this.viewItems[t].action}}push(h,t={}){const s=Array.isArray(h)?h:[h];let d=m.$Nf(t.index)?t.index:null;s.forEach(c=>{const l=document.createElement("li");l.className="action-item",l.setAttribute("role","presentation");let $;const f={hoverDelegate:this.b.hoverDelegate,...t};this.b.actionViewItemProvider&&($=this.b.actionViewItemProvider(c,f)),$||($=new n.$FS(this.context,c,f)),this.b.allowContextMenu||this.r.set($,A.$SP(l,A.$MQ.CONTEXT_MENU,b=>{A.$OQ.stop(b,!0)})),$.actionRunner=this.f,$.setActionContext(this.context),$.render(l),this.y&&$ instanceof n.$ES&&this.viewItems.length===0&&$.setFocusable(!0),d===null||d<0||d>=this.z.children.length?(this.z.appendChild(l),this.viewItems.push($)):(this.z.insertBefore(l,this.z.children[d]),this.viewItems.splice(d,0,$),d++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(h){if(h>=0&&h<this.z.children.length){const t=this.z.children.item(h);if(t)return t.clientWidth}return 0}getHeight(h){if(h>=0&&h<this.z.children.length){const t=this.z.children.item(h);if(t)return t.clientHeight}return 0}pull(h){h>=0&&h<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[h]),this.r.deleteAndDispose(this.viewItems[h]),(0,S.$Oc)(this.viewItems.splice(h,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,S.$Oc)(this.viewItems),this.r.clearAndDisposeAll(),A.$RP(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(h){let t=!1,s;if(h===void 0?t=!0:typeof h=="number"?s=h:typeof h=="boolean"&&(t=h),t&&typeof this.t>"u"){const d=this.viewItems.findIndex(c=>c.isEnabled());this.t=d===-1?void 0:d,this.Q(void 0,void 0,!0)}else s!==void 0&&(this.t=s),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(h){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const t=this.t;let s;do{if(!h&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=t,!1;this.t=(this.t+1)%this.viewItems.length,s=this.viewItems[this.t]}while(this.t!==t&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===U.$Oi.ID));return this.Q(),!0}P(h){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const t=this.t;let s;do{if(this.t=this.t-1,this.t<0){if(!h&&this.b.preventLoopNavigation)return this.t=t,!1;this.t=this.viewItems.length-1}s=this.viewItems[this.t]}while(this.t!==t&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===U.$Oi.ID));return this.Q(!0),!0}Q(h,t,s=!1){typeof this.t>"u"&&this.z.focus({preventScroll:t}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const d=this.t!==void 0?this.viewItems[this.t]:void 0;if(d){let c=!0;m.$Xf(d.focus)||(c=!1),this.b.focusOnlyEnabledItems&&m.$Xf(d.isEnabled)&&!d.isEnabled()&&(c=!1),d.action.id===U.$Oi.ID&&(c=!1),c?(s||this.s!==this.t)&&(d.focus(h),this.s=this.t):(this.z.focus({preventScroll:t}),this.s=void 0),c&&d.showHover?.()}}R(h){if(typeof this.t>"u")return;const t=this.viewItems[this.t];if(t instanceof n.$ES){const s=t._context===null||t._context===void 0?h:t._context;this.run(t._action,s)}}async run(h,t){await this.f.run(h,t)}dispose(){this.j=void 0,this.viewItems=(0,S.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}e.$MR=v;function I(a){if(!a.length)return a;let h=-1;for(let s=0;s<a.length;s++)if(a[s].id!==U.$Oi.ID){h=s;break}if(h===-1)return[];a=a.slice(h);for(let s=a.length-1;s>=0&&a[s].id===U.$Oi.ID;s--)a.splice(s,1);let t=!1;for(let s=a.length-1;s>=0;s--){const d=a[s].id===U.$Oi.ID;d&&!t?a.splice(s,1):d?d&&(t=!1):t=!0}return a}e.$NR=I}),define($e[65],pe([1,0,2,22,55,64,57,60,20,4,82,51,109,97]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mT=e.$lT=e.$kT=e.MessageType=void 0;const h=A.$;var t;(function(c){c[c.INFO=1]="INFO",c[c.WARNING=2]="WARNING",c[c.ERROR=3]="ERROR"})(t||(e.MessageType=t={})),e.$kT={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends m.$uR{constructor(l,$,f){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new p.$Wd),this.onDidChange=this.O.event,this.P=this.B(new p.$Wd),this.onDidHeightChange=this.P.event,this.a=$,this.g=f,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=A.$TQ(l,h(".monaco-inputbox.idle"));const b=this.g.flexibleHeight?"textarea":"input",u=A.$TQ(this.element,h(".ibwrapper"));if(this.b=A.$TQ(u,h(b+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=A.$TQ(u,h("div.mirror")),this.y.innerText="\xA0",this.N=new S.$ER(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),A.$TQ(l,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(P=>this.b.scrollTop=P.scrollTop));const N=this.B(new C.$UR(l.ownerDocument,"selectionchange")),B=p.Event.filter(N.event,()=>l.ownerDocument.getSelection()?.anchorNode===u);this.B(B(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$MR(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(l){this.n=l,this.b.setAttribute("placeholder",l)}setTooltip(l){this.r=l,this.b.title=l}setAriaLabel(l){this.s=l,l?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(l){this.b.value!==l&&(this.b.value=l,this.Y())}get step(){return this.b.step}set step(l){this.b.step=l}get height(){return typeof this.J=="number"?this.J:A.$iQ(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return A.$tQ(this.b)}select(l=null){this.b.select(),l&&(this.b.setSelectionRange(l.start,l.end),l.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const l=this.b.selectionStart;if(l===null)return null;const $=this.b.selectionEnd??l;return{start:l,end:$}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(l){l?this.enable():this.disable()}get width(){return A.$eQ(this.b)}set width(l){if(this.g.flexibleHeight&&this.g.flexibleWidth){let $=0;if(this.y){const f=parseFloat(this.y.style.paddingLeft||"")||0,b=parseFloat(this.y.style.paddingRight||"")||0;$=f+b}this.b.style.width=l-$+"px"}else this.b.style.width=l+"px";this.y&&(this.y.style.width=l+"px")}set paddingRight(l){this.b.style.width=`calc(100% - ${l}px)`,this.y&&(this.y.style.paddingRight=l+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const l=this.L,$=this.J,f=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:l,height:$}),this.N.setScrollPosition({scrollTop:f})}showMessage(l,$){if(this.w==="open"&&(0,I.$Cn)(this.h,l))return;this.h=l,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(l.type));const f=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${A.$_Q(f.border,"transparent")}`,this.h.content&&(this.hasFocus()||$)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let l=null;return this.t&&(l=this.t(this.value),l?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(l)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),l?.type}stylesForType(l){const $=this.g.inputBoxStyles;switch(l){case 1:return{border:$.inputValidationInfoBorder,background:$.inputValidationInfoBackground,foreground:$.inputValidationInfoForeground};case 2:return{border:$.inputValidationWarningBorder,background:$.inputValidationWarningBackground,foreground:$.inputValidationWarningForeground};default:return{border:$.inputValidationErrorBorder,background:$.inputValidationErrorBackground,foreground:$.inputValidationErrorForeground}}}U(l){switch(l){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let l;const $=()=>l.style.width=A.$eQ(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:b=>{if(!this.h)return null;l=A.$TQ(b,h(".monaco-inputbox-container")),$();const u={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,n.$SR)(this.h.content,u):(0,n.$RR)(this.h.content,u);N.classList.add(this.U(this.h.type));const B=this.stylesForType(this.h.type);return N.style.backgroundColor=B.background??"",N.style.color=B.foreground??"",N.style.border=B.border?`1px solid ${B.border}`:"",A.$TQ(l,N),null},onHide:()=>{this.w="closed"},layout:$});let f;this.h.type===3?f=a.localize(0,null,this.h.content):this.h.type===2?f=a.localize(1,null,this.h.content):f=a.localize(2,null,this.h.content),D.$WR(f),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const l=this.value,f=l.charCodeAt(l.length-1)===10?" ":"";(l+f).replace(/\u000c/g,"")?this.y.textContent=l+f:this.y.innerText="\xA0",this.layout()}ab(){const l=this.g.inputBoxStyles,$=l.inputBackground??"",f=l.inputForeground??"",b=l.inputBorder??"";this.element.style.backgroundColor=$,this.element.style.color=f,this.b.style.backgroundColor="inherit",this.b.style.color=f,this.element.style.border=`1px solid ${A.$_Q(b,"transparent")}`}layout(){if(!this.y)return;const l=this.L;this.L=A.$iQ(this.y),l!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(l){const $=this.inputElement,f=$.selectionStart,b=$.selectionEnd,u=$.value;f!==null&&b!==null&&(this.value=u.substr(0,f)+l+u.substr(b),$.setSelectionRange(f+1,f+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}e.$lT=s;class d extends s{constructor(l,$,f){const b=a.localize(3,null,"\u21C5"),u=a.localize(4,null,"\u21C5");super(l,$,f),this.db=this.B(new p.$Wd),this.onDidFocus=this.db.event,this.eb=this.B(new p.$Wd),this.onDidBlur=this.eb.event,this.bb=new v.$iT(f.history,100);const N=()=>{if(f.showHistoryHint&&f.showHistoryHint()&&!this.n.endsWith(b)&&!this.n.endsWith(u)&&this.bb.getHistory().length){const B=this.n.endsWith(")")?b:u,P=this.n+B;f.showPlaceholderOnFocus&&!A.$tQ(this.b)?this.n=P:this.setPlaceHolder(P)}};this.cb=new MutationObserver((B,P)=>{B.forEach(W=>{W.target.textContent||N()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const B=P=>{if(this.n.endsWith(P)){const W=this.n.slice(0,this.n.length-P.length);return f.showPlaceholderOnFocus?this.n=W:this.setPlaceHolder(W),!0}else return!1};B(u)||B(b)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(l){this.value&&(l||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(l){const $=this.getHistory();this.clearHistory(),l.forEach(f=>{this.bb.add(f)}),$.forEach(f=>{this.bb.add(f)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let l=this.jb();l&&(l=l===this.value?this.jb():l),this.value=l??"",D.$XR(this.value?this.value:a.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let l=this.ib();l&&(l=l===this.value?this.ib():l),l&&(this.value=l,D.$XR(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(l){super.setPlaceHolder(l),this.setTooltip(l)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let l=this.bb.current();return l||(l=this.bb.last(),this.bb.next()),l}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}e.$mT=d}),define($e[66],pe([1,0,63,20,17,18,4,2,102]),function(ne,e,A,C,n,U,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DS=e.$CS=e.$BS=e.$AS=e.$zS=void 0,e.$zS={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class m extends A.$ES{constructor(h,t,s){super(h,t,s),this.a=this.B(new p({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:s.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:s.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:s.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(h){this.element=h,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}e.$AS=m;class p extends C.$uR{constructor(h){super(),this.a=this.B(new D.$Wd),this.onChange=this.a.event,this.b=this.B(new D.$Wd),this.onKeyDown=this.b.event,this.c=h,this.s=this.c.isChecked;const t=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,t.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&t.push(...this.c.actionClassName.split(" ")),this.s&&t.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...t),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,s=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),s.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,s=>{if(s.keyCode===10||s.keyCode===3){this.checked=!this.s,this.a.fire(!0),s.preventDefault(),s.stopPropagation();return}this.b.fire(s)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(h){this.s=h,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(h){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=h,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 22}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(h){this.domNode.title=h,this.domNode.setAttribute("aria-label",h)}}e.$BS=p;class v extends C.$uR{constructor(h,t,s){super(),this.g=h,this.h=t,this.a=this.B(new D.$Wd),this.onChange=this.a.event,this.b=new p({title:this.g,isChecked:this.h,icon:n.$bk.check,actionClassName:"monaco-checkbox",...e.$zS}),this.domNode=this.b.domNode,this.c=s,this.n(),this.B(this.b.onChange(d=>{this.n(),this.a.fire(d)}))}get checked(){return this.b.checked}set checked(h){this.b.checked=h,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,S.$tQ)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}e.$CS=v;class I extends A.$ES{constructor(h,t,s){super(h,t,s),this.a=this.B(new v(this._action.label,!!this._action.checked,s.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(h){if(this.element=h,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const t=this.element.appendChild((0,S.$)("span.checkbox-label",void 0,this._action.label));this.B((0,S.$SP)(t,S.$MQ.CLICK,s=>{this.a.checked=!this.a.checked,s.stopPropagation(),s.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}e.$DS=I}),define($e[130],pe([1,0,66,17,107]),function(ne,e,A,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zT=e.$yT=e.$xT=void 0;const U=n.localize(0,null),D=n.localize(1,null),S=n.localize(2,null);class m extends A.$BS{constructor(a){super({icon:C.$bk.caseSensitive,title:U+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}e.$xT=m;class p extends A.$BS{constructor(a){super({icon:C.$bk.wholeWord,title:D+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}e.$yT=p;class v extends A.$BS{constructor(a){super({icon:C.$bk.regex,title:S+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}e.$zT=v}),define($e[131],pe([1,0,2,130,65,20,4,106,3,96]),function(ne,e,A,C,n,U,D,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=void 0;const p=S.localize(0,null);class v extends U.$uR{static{this.OPTION_CHANGE="optionChange"}constructor(a,h,t){super(),this.n=!0,this.s=!1,this.w=this.B(new m.$Uc),this.N=[],this.O=this.B(new D.$Wd),this.onDidOptionChange=this.O.event,this.P=this.B(new D.$Wd),this.onKeyDown=this.P.event,this.Q=this.B(new D.$Wd),this.onMouseDown=this.Q.event,this.R=this.B(new D.$Wd),this.onInput=this.R.event,this.S=this.B(new D.$Wd),this.onKeyUp=this.S.event,this.U=this.B(new D.$Wd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new D.$Wd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=t.placeholder||"",this.b=t.validation,this.c=t.label||p,this.h=!!t.showCommonFindToggles;const s=t.appendCaseSensitiveLabel||"",d=t.appendWholeWordsLabel||"",c=t.appendRegexLabel||"",l=t.history||[],$=!!t.flexibleHeight,f=!!t.flexibleWidth,b=t.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$mT(this.domNode,h,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:l,showHistoryHint:t.showHistoryHint,flexibleHeight:$,flexibleWidth:f,flexibleMaxHeight:b,inputBoxStyles:t.inputBoxStyles})),this.h){this.J=this.B(new C.$zT({appendTitle:c,isChecked:!1,...t.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new C.$yT({appendTitle:d,isChecked:!1,...t.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$xT({appendTitle:s,isChecked:!1,...t.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const u=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const B=u.indexOf(this.domNode.ownerDocument.activeElement);if(B>=0){let P=-1;N.equals(17)?P=(B+1)%u.length:N.equals(15)&&(B===0?P=u.length-1:P=B-1),N.equals(9)?(u[B].blur(),this.inputBox.focus()):P>=0&&u[P].focus(),A.$OQ.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(t?.additionalToggles),this.y&&this.domNode.appendChild(this.y),a?.appendChild(this.domNode),this.B(A.$SP(this.inputBox.inputElement,"compositionstart",u=>{this.s=!0})),this.B(A.$SP(this.inputBox.inputElement,"compositionend",u=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,u=>this.P.fire(u)),this.C(this.inputBox.inputElement,u=>this.S.fire(u)),this.D(this.inputBox.inputElement,u=>this.R.fire()),this.j(this.inputBox.inputElement,u=>this.Q.fire(u))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(a){this.inputBox.layout(),this.X(a.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const a of this.N)a.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const a of this.N)a.disable()}setFocusInputOnOptionClick(a){this.n=a}setEnabled(a){a?this.enable():this.disable()}setAdditionalToggles(a){for(const h of this.N)h.domNode.remove();this.N=[],this.w.value=new m.$Sc;for(const h of a??[])this.w.value.add(h),this.y.appendChild(h.domNode),this.w.value.add(h.onChange(t=>{this.O.fire(t),!t&&this.n&&this.inputBox.focus()})),this.N.push(h);this.N.length>0&&(this.y.style.display=""),this.X()}X(a=!1){a?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((h,t)=>h+t.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(a){this.inputBox.value!==a&&(this.inputBox.value=a)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(a){this.M&&(this.M.checked=a)}getWholeWords(){return this.L?.checked??!1}setWholeWords(a){this.L&&(this.L.checked=a)}getRegex(){return this.J?.checked??!1}setRegex(a){this.J&&(this.J.checked=a,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(a){this.inputBox.showMessage(a)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}e.$AT=v}),define($e[132],pe([1,0,2,22,14,64,131,65,61,40,66,58,26,37,12,9,17,18,32,4,35,3,33,7,111,103]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a,h,t,s,d,c,l,$,f,b,u,N,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_T=e.AbstractTreePart=e.TreeFindMatchType=e.TreeFindMode=e.$$T=e.$0T=e.$9T=e.RenderIndentGuides=e.$8T=e.$7T=void 0;class P extends m.$5R{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(o=>o.element)),this.c=i}}function W(r){return r instanceof m.$5R?new P(r):r}class z{constructor(i,o){this.d=i,this.f=o,this.b=b.$Tc.None,this.c=new b.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,o){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(w=>w.element),o)}onDragStart(i,o){this.f.onDragStart?.(W(i),o)}onDragOver(i,o,w,M,T,j=!0){const _=this.f.onDragOver(W(i),o&&o.element,w,M,T),Y=this.a!==o;if(Y&&(this.b.dispose(),this.a=o),typeof o>"u")return _;if(Y&&typeof _!="boolean"&&_.autoExpand&&(this.b=(0,s.$0g)(()=>{const Ee=this.d(),ve=Ee.getNodeLocation(o);Ee.isCollapsed(ve)&&Ee.setCollapsed(ve,!1),this.a=void 0},500,this.c)),typeof _=="boolean"||!_.accept||typeof _.bubble>"u"||_.feedback){if(!j){const Ee=typeof _=="boolean"?_:_.accept,ve=typeof _=="boolean"?void 0:_.effect;return{accept:Ee,effect:ve,feedback:[w]}}return _}if(_.bubble===1){const Ee=this.d(),ve=Ee.getNodeLocation(o),Pe=Ee.getParentNodeLocation(ve),Me=Ee.getNode(Pe),Ie=Pe&&Ee.getListIndex(Pe);return this.onDragOver(i,Me,Ie,M,T,!1)}const oe=this.d(),be=oe.getNodeLocation(o),De=oe.getListIndex(be),we=oe.getListRenderCount(be);return{..._,feedback:(0,t.$Sb)(De,De+we)}}drop(i,o,w,M,T){this.b.dispose(),this.a=void 0,this.f.drop(W(i),o&&o.element,w,M,T)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function y(r,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(o){return i.identityProvider.getId(o.element)}},dnd:i.dnd&&new z(r,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(o){return i.multipleSelectionController.isSelectionSingleChangeEvent({...o,element:o.element})},isSelectionRangeChangeEvent(o){return i.multipleSelectionController.isSelectionRangeChangeEvent({...o,element:o.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(o){const w=r(),M=w.getNodeLocation(o),T=w.getParentNodeLocation(M);return w.getNode(T).visibleChildrenCount},getPosInSet(o){return o.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?o=>i.accessibilityProvider.isChecked(o.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?o=>i.accessibilityProvider.getRole(o.element):()=>"treeitem",getAriaLabel(o){return i.accessibilityProvider.getAriaLabel(o.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?o=>i.accessibilityProvider.getAriaLevel(o.element):o=>o.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(o=>i.accessibilityProvider.getActiveDescendantId(o.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(o){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(o.element)}}}}class O{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,o){this.a.setDynamicHeight?.(i.element,o)}}e.$7T=O;class H{static lift(i){return i instanceof H?i:new H(i)}static empty(i=0){return new H({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const o of i.expanded)this.expanded[o]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}e.$8T=H;var E;(function(r){r.None="none",r.OnHover="onHover",r.Always="always"})(E||(e.RenderIndentGuides=E={}));class R{get elements(){return this.b}constructor(i,o=[]){this.b=o,this.a=new b.$Sc,this.onDidChange=$.Event.forEach(i,w=>this.b=w,this.a)}dispose(){this.a.dispose()}}class L{static{this.a=8}constructor(i,o,w,M,T,j={}){this.o=i,this.p=o,this.q=M,this.s=T,this.b=new Map,this.c=new Map,this.d=L.a,this.f=!1,this.g=!1,this.j=new Set,this.k=b.$Tc.None,this.m=new b.$Sc,this.templateId=i.templateId,this.updateOptions(j),$.Event.map(w,_=>_.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const o=(0,u.$9l)(i.indent,0,40);if(o!==this.d){this.d=o;for(const[w,M]of this.c)this.v(w,M)}}if(typeof i.renderIndentGuides<"u"){const o=i.renderIndentGuides!==E.None;if(o!==this.g){this.g=o;for(const[w,M]of this.c)this.w(w,M);if(this.k.dispose(),o){const w=new b.$Sc;this.q.onDidChange(this.x,this,w),this.k=w,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const o=(0,A.$TQ)(i,(0,A.$)(".monaco-tl-row")),w=(0,A.$TQ)(o,(0,A.$)(".monaco-tl-indent")),M=(0,A.$TQ)(o,(0,A.$)(".monaco-tl-twistie")),T=(0,A.$TQ)(o,(0,A.$)(".monaco-tl-contents")),j=this.o.renderTemplate(T);return{container:i,indent:w,twistie:M,indentGuidesDisposable:b.$Tc.None,templateData:j}}renderElement(i,o,w,M){this.c.set(i,w),this.b.set(i.element,i),this.v(i,w),this.o.renderElement(i,o,w.templateData,M)}disposeElement(i,o,w,M){w.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,o,w.templateData,M),typeof M=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const o=this.b.get(i);o&&this.u(o)}u(i){const o=this.c.get(i);o&&(this.x(this.q.elements),this.v(i,o))}v(i,o){const w=L.a+(i.depth-1)*this.d;o.twistie.style.paddingLeft=`${w}px`,o.indent.style.width=`${w+this.d-16}px`,i.collapsible?o.container.setAttribute("aria-expanded",String(!i.collapsed)):o.container.removeAttribute("aria-expanded"),o.twistie.classList.remove(...c.ThemeIcon.asClassNameArray(d.$bk.treeItemExpanded));let M=!1;this.o.renderTwistie&&(M=this.o.renderTwistie(i.element,o.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(M||o.twistie.classList.add(...c.ThemeIcon.asClassNameArray(d.$bk.treeItemExpanded)),o.twistie.classList.add("collapsible"),o.twistie.classList.toggle("collapsed",i.collapsed)):o.twistie.classList.remove("collapsible","collapsed"),this.w(i,o)}w(i,o){if((0,A.$RP)(o.indent),o.indentGuidesDisposable.dispose(),!this.g)return;const w=new b.$Sc,M=this.p();for(;;){const T=M.getNodeLocation(i),j=M.getParentNodeLocation(T);if(!j)break;const _=M.getNode(j),Y=(0,A.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(_)&&Y.classList.add("active"),o.indent.childElementCount===0?o.indent.appendChild(Y):o.indent.insertBefore(Y,o.indent.firstElementChild),this.s.add(_,Y),w.add((0,b.$Rc)(()=>this.s.delete(_,Y))),i=_}o.indentGuidesDisposable=w}x(i){if(!this.g)return;const o=new Set,w=this.p();i.forEach(M=>{const T=w.getNodeLocation(M);try{const j=w.getParentNodeLocation(T);M.collapsible&&M.children.length>0&&!M.collapsed?o.add(M):j&&o.add(w.getNode(j))}catch{}}),this.j.forEach(M=>{o.has(M)||this.s.forEach(M,T=>T.classList.remove("active"))}),o.forEach(M=>{this.j.has(M)||this.s.forEach(M,T=>T.classList.add("active"))}),this.j=o}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,b.$Oc)(this.m)}}e.$9T=L;class G{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,o,w){this.g=i,this.j=o,this.k=w,this.a=0,this.b=0,this.c="",this.d="",this.f=new b.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,o){let w=1;if(this.k){const j=this.k.filter(i,o);if(typeof j=="boolean"?w=j?1:0:(0,I.$4T)(j)?w=(0,I.$5T)(j.visibility):w=j,w===0)return!1}if(this.a++,!this.c)return this.b++,{data:f.FuzzyScore.Default,visibility:w};const M=this.j.getKeyboardNavigationLabel(i),T=Array.isArray(M)?M:[M];for(const j of T){const _=j&&j.toString();if(typeof _>"u")return{data:f.FuzzyScore.Default,visibility:w};let Y;if(this.g.findMatchType===fe.Contiguous){const oe=_.toLowerCase().indexOf(this.d);if(oe>-1){Y=[Number.MAX_SAFE_INTEGER,0];for(let be=this.d.length;be>0;be--)Y.push(oe+be-1)}}else Y=(0,f.$9j)(this.c,this.d,0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Y)return this.b++,T.length===1?{data:Y,visibility:w}:{data:{label:_,score:Y},visibility:w}}return this.g.findMode===ie.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:f.FuzzyScore.Default,visibility:w}}m(){this.a=0,this.b=0}dispose(){(0,b.$Oc)(this.f)}}class Z extends v.$BS{constructor(i){super({icon:d.$bk.listFilter,title:(0,B.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}e.$0T=Z;class ge extends v.$BS{constructor(i){super({icon:d.$bk.searchFuzzy,title:(0,B.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}e.$$T=ge;const he={inputBoxStyles:S.$kT,toggleStyles:v.$zS,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ie;(function(r){r[r.Highlight=0]="Highlight",r[r.Filter=1]="Filter"})(ie||(e.TreeFindMode=ie={}));var fe;(function(r){r[r.Fuzzy=0]="Fuzzy",r[r.Contiguous=1]="Contiguous"})(fe||(e.TreeFindMatchType=fe={}));class Re extends b.$Tc{set mode(i){this.b.checked=i===ie.Filter,this.f.inputBox.setPlaceHolder(i===ie.Filter?(0,B.localize)(2,null):(0,B.localize)(3,null))}set matchType(i){this.c.checked=i===fe.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,o,w,M,T,j){super(),this.t=o,this.a=(0,A.h)(".monaco-tree-type-filter",[(0,A.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,A.h)(".monaco-tree-type-filter-input@findInput"),(0,A.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new $.$Wd,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,b.$Rc)(()=>i.removeChild(this.a.root)));const _=j?.styles??he;_.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=_.listFilterWidgetBackground),_.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${_.listFilterWidgetShadow}`),this.b=this.B(new Z({..._.toggleStyles,isChecked:M===ie.Filter})),this.c=this.B(new ge({..._.toggleStyles,isChecked:T===fe.Fuzzy})),this.onDidChangeMode=$.Event.map(this.b.onChange,()=>this.b.checked?ie.Filter:ie.Highlight,this.q),this.onDidChangeMatchType=$.Event.map(this.c.onChange,()=>this.c.checked?fe.Fuzzy:fe.Contiguous,this.q),this.f=this.B(new D.$AT(this.a.findInput,w,{label:(0,B.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:_.inputBoxStyles,toggleStyles:_.toggleStyles,history:j?.history})),this.g=this.B(new U.$MR(this.a.actionbar)),this.mode=M;const Y=this.B(new C.$UR(this.f.inputBox.inputElement,"keydown")),oe=$.Event.chain(Y.event,Ee=>Ee.map(ve=>new n.$PP(ve)));this.B(oe(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const be=this.B(new h.$Mi("close",(0,B.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(be,{icon:!0,label:!1});const De=this.B(new C.$UR(this.a.grab,"mousedown"));this.B(De.event(Ee=>{const ve=new b.$Sc,Pe=ve.add(new C.$UR((0,A.getWindow)(Ee),"mousemove")),Me=ve.add(new C.$UR((0,A.getWindow)(Ee),"mouseup")),Ie=this.m,Ye=Ee.pageX,et=this.s,xe=Ee.pageY;this.a.grab.classList.add("grabbing");const K=this.a.root.style.transition;this.a.root.style.transition="unset";const le=me=>{const ke=me.pageX-Ye;this.m=Ie-ke;const Ce=me.pageY-xe;this.s=et+Ce,this.layout()};ve.add(Pe.event(le)),ve.add(Me.event(me=>{le(me),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=K,ve.dispose()}))}));const we=$.Event.chain(this.B(new C.$UR(this.a.grab,"keydown")).event,Ee=>Ee.map(ve=>new n.$PP(ve)));this.B(we(Ee=>{let ve,Pe;if(Ee.keyCode===15?ve=Number.POSITIVE_INFINITY:Ee.keyCode===17?ve=0:Ee.keyCode===10&&(ve=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?Pe=0:Ee.keyCode===18&&(Pe=Number.POSITIVE_INFINITY),ve!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=ve,this.layout()),Pe!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=Pe;const Me=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Me},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,u.$9l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,u.$9l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$9g)(300),super.dispose()}}class Ne{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,o,w,M,T,j={}){this.t=i,this.u=w,this.v=M,this.w=T,this.x=j,this.b="",this.c="",this.j=0,this.k=new $.$Wd,this.onDidChangeMode=this.k.event,this.m=new $.$Wd,this.onDidChangeMatchType=this.m.event,this.o=new $.$Wd,this.onDidChangePattern=this.o.event,this.p=new $.$Wd,this.onDidChangeOpenState=this.p.event,this.q=new b.$Sc,this.s=new b.$Sc,this.d=i.options.defaultFindMode??ie.Highlight,this.f=i.options.defaultFindMatchType??fe.Fuzzy,o.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Re(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,w=>!f.FuzzyScore.isDefault(w.filterData));const o=this.t.getFocus();if(o.length>0){const w=o[0];this.t.getRelativeTop(w)===null&&this.t.reveal(w,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,B.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!f.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Be(r,i){return r.position===i.position&&se(r,i)}function se(r,i){return r.node.element===i.node.element&&r.startIndex===i.startIndex&&r.height===i.height&&r.endIndex===i.endIndex}class J{constructor(i=[]){this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,t.$ub)(this.stickyNodes,i.stickyNodes,Be)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const o=this.stickyNodes[this.count-2];return o.position+o.height!==i.position}animationStateChanged(i){if(!(0,t.$ub)(this.stickyNodes,i.stickyNodes,se)||this.count===0)return!1;const o=this.stickyNodes[this.count-1],w=i.stickyNodes[i.count-1];return o.position!==w.position}}class ae{constrainStickyScrollNodes(i,o,w){for(let M=0;M<i.length;M++){const T=i[M];if(T.position+T.height>w||M>=o)return i.slice(0,M)}return i}}class re extends b.$Tc{constructor(i,o,w,M,T,j={}){super(),this.g=i,this.j=o,this.m=w,this.s=T,this.c=.4;const _=this.validateStickySettings(j);this.b=_.stickyScrollMaxItemCount,this.a=j.stickyScrollDelegate??new ae,this.f=this.B(new X(w.getScrollableElement(),w,i,M,T,j.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(w.onDidScroll(()=>this.u())),this.B(w.onDidChangeContentHeight(()=>this.u())),this.B(i.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(i){return this.f.getNode(i)}t(i){let o;if(i===0?o=this.m.firstVisibleIndex:o=this.m.indexAt(i+this.m.scrollTop),!(o<0||o>=this.m.length))return this.m.element(o)}u(){const i=this.t(0);if(!i||this.g.scrollTop===0){this.f.setState(void 0);return}const o=this.w(i);this.f.setState(o)}w(i){const o=[];let w=i,M=0,T=this.z(w,void 0,M);for(;T&&(o.push(T),M+=T.height,!(o.length<=this.b&&(w=this.y(T),!w)));)T=this.z(w,T.node,M);const j=this.H(o);return j.length?new J(j):void 0}y(i){return this.t(i.position+i.height)}z(i,o,w){const M=this.F(i,o);if(M&&!(M===i&&(!this.J(i)||this.C(i,w))))return this.D(M,w)}C(i,o){const w=this.L(i),M=this.m.getElementTop(w),T=o;return this.m.scrollTop===M-T}D(i,o){const w=this.s.getHeight(i),{startIndex:M,endIndex:T}=this.M(i),j=this.G(T,o,w);return{node:i,position:j,height:w,startIndex:M,endIndex:T}}F(i,o=void 0){let w=i,M=this.I(w);for(;M;){if(M===o)return w;w=M,M=this.I(w)}if(o===void 0)return w}G(i,o,w){let M=this.m.getRelativeTop(i);if(M===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const oe=this.s.getHeight(this.m.element(i)),be=this.m.getRelativeTop(i+1);M=be?be-oe/this.m.renderHeight:null}if(M===null)return o;const T=this.m.element(i),j=this.s.getHeight(T),Y=M*this.m.renderHeight+j;return o+w>Y&&o<=Y?Y-w:o}H(i){if(i.length===0)return[];const o=this.m.renderHeight*this.c,w=i[i.length-1];if(i.length<=this.b&&w.position+w.height<=o)return i;const M=this.a.constrainStickyScrollNodes(i,this.b,o);if(!M.length)return[];const T=M[M.length-1];if(M.length>this.b||T.position+T.height>o)throw new Error("stickyScrollDelegate violates constraints");return M}I(i){const o=this.j.getNodeLocation(i),w=this.j.getParentNodeLocation(o);return w?this.j.getNode(w):void 0}J(i){const o=this.j.getNodeLocation(i);return this.j.getListRenderCount(o)>1}L(i){const o=this.j.getNodeLocation(i);return this.j.getListIndex(o)}M(i){const o=this.j.getNodeLocation(i),w=this.j.getListIndex(o);if(w<0)throw new Error("Node not found in tree");const M=this.j.getListRenderCount(o),T=w+M-1;return{startIndex:w,endIndex:T}}nodePositionTopBelowWidget(i){const o=[];let w=this.I(i);for(;w;)o.push(w),w=this.I(w);let M=0;for(let T=0;T<o.length&&T<this.b;T++)M+=this.s.getHeight(o[T]);return M}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(i={}){if(!i.stickyScrollMaxItemCount)return;const o=this.validateStickySettings(i);this.b!==o.stickyScrollMaxItemCount&&(this.b=o.stickyScrollMaxItemCount,this.u())}validateStickySettings(i){let o=7;return typeof i.stickyScrollMaxItemCount=="number"&&(o=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:o}}}class X{constructor(i,o,w,M,T,j){this.g=o,this.j=w,this.k=M,this.m=T,this.o=j,this.c=[],this.d=new b.$Sc,this.a=(0,A.$)(".monaco-tree-sticky-container.empty"),i.appendChild(this.a);const _=(0,A.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(_),this.f=new x(this.a,o),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(o=>o.node===i)}setState(i){const o=!!this.b&&this.b.count>0,w=!!i&&i.count>0;if(!o&&!w||o&&w&&this.b.equal(i))return;if(o!==w&&this.s(w),!w){this.b=void 0,this.c=[],this.d.clear();return}const M=i.stickyNodes[i.count-1];if(this.b&&i.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${M.position}px`;else{this.d.clear();const T=Array(i.count);for(let j=i.count-1;j>=0;j--){const _=i.stickyNodes[j],{element:Y,disposable:oe}=this.p(_,j,i.count);T[j]=Y,this.a.appendChild(Y),this.d.add(oe)}this.f.updateElements(T,i),this.c=T}this.b=i,this.a.style.height=`${M.position+M.height}px`}p(i,o,w){const M=i.startIndex,T=document.createElement("div");T.style.top=`${i.position}px`,T.style.height=`${i.height}px`,T.style.lineHeight=`${i.height}px`,T.classList.add("monaco-tree-sticky-row"),T.classList.add("monaco-list-row"),T.setAttribute("data-index",`${M}`),T.setAttribute("data-parity",M%2===0?"even":"odd"),T.setAttribute("id",this.g.getElementID(M)),this.q(T,i.node.element,o,w);const j=this.m.getTemplateId(i.node),_=this.k.find(De=>De.templateId===j);if(!_)throw new Error(`No renderer found for template id ${j}`);let Y=i.node;Y===this.j.getNode(this.j.getNodeLocation(i.node))&&(Y=new Proxy(i.node,{}));const oe=_.renderTemplate(T);_.renderElement(Y,i.startIndex,oe,i.height);const be=(0,b.$Rc)(()=>{_.disposeElement(Y,i.startIndex,oe,i.height),_.disposeTemplate(oe),T.remove()});return{element:T,disposable:be}}q(i,o,w,M){if(!this.o)return;this.o.getSetSize&&i.setAttribute("aria-setsize",String(this.o.getSetSize(o,w,M))),this.o.getPosInSet&&i.setAttribute("aria-posinset",String(this.o.getPosInSet(o,w))),this.o.getRole&&i.setAttribute("role",this.o.getRole(o)??"treeitem");const T=this.o.getAriaLabel(o);T&&i.setAttribute("aria-label",T);const j=this.o.getAriaLevel&&this.o.getAriaLevel(o);typeof j=="number"&&i.setAttribute("aria-level",`${j}`),i.setAttribute("aria-selected",String(!1))}s(i){this.a.classList.toggle("empty",!i),i||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class x extends b.$Tc{get m(){return this.j}set m(i){i!==this.j&&(this.f.fire(i),this.j=i)}constructor(i,o){super(),this.s=i,this.t=o,this.a=-1,this.b=[],this.f=new $.$Wd,this.onDidChangeHasFocus=this.f.event,this.g=new $.$Wd,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(w=>this.w(w))),this.B(this.t.onMouseDown(w=>this.y(w))),this.B(this.t.onContextMenu(w=>this.u(w)))}u(i){const o=i.browserEvent.target;if(!(0,p.$fS)(o)&&!(0,p.$eS)(o)){this.focusedLast()&&this.t.domFocus();return}if(!(0,A.$JQ)(i.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const j=this.c.stickyNodes.findIndex(_=>_.node.element===i.element?.element);if(j===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(j);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const M=this.c.stickyNodes[this.a].node.element,T=this.b[this.a];this.g.fire({element:M,anchor:T,browserEvent:i.browserEvent,isStickyScroll:!0})}w(i){if(this.m&&this.c){if(i.key==="ArrowUp")this.z(Math.max(0,this.a-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.a>=this.c.count-1){const o=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([o]),this.C(o,this.c)}else this.z(this.a+1);i.preventDefault(),i.stopPropagation()}}}y(i){const o=i.browserEvent.target;!(0,p.$fS)(o)&&!(0,p.$eS)(o)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation())}updateElements(i,o){if(o&&o.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(o&&o.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const w=this.a;if(this.D(),this.b=i,this.c=o,o){const M=(0,u.$9l)(w,0,o.count-1);this.F(M)}else this.m&&this.t.domFocus();this.s.tabIndex=o?0:-1}z(i){const o=this.c;if(!o)throw new Error("Cannot set focus when state is undefined");if(this.F(i),!(i<o.count-1)&&o.lastNodePartiallyVisible()){const w=o.stickyNodes[i];this.C(w.endIndex+1,o)}}C(i,o){const w=o.stickyNodes[o.count-1],M=o.count>1?o.stickyNodes[o.count-2]:void 0,T=this.t.getElementTop(i),j=M?M.position+M.height+w.height:w.height;this.t.scrollTop=T-j}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.c&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&i>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const o=this.a;o>=0&&this.G(this.b[o],!1),i>=0&&this.G(this.b[i],!0),this.a=i}G(i,o){i.classList.toggle("focused",o)}H(i){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function te(r){let i=a.TreeMouseEventTarget.Unknown;return(0,A.$oQ)(r.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=a.TreeMouseEventTarget.Twistie:(0,A.$oQ)(r.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=a.TreeMouseEventTarget.Element:(0,A.$oQ)(r.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=a.TreeMouseEventTarget.Filter),{browserEvent:r.browserEvent,element:r.element?r.element.element:null,target:i}}function ce(r){const i=(0,p.$fS)(r.browserEvent.target);return{element:r.element?r.element.element:null,browserEvent:r.browserEvent,anchor:r.anchor,isStickyScroll:i}}function ye(r,i){i(r),r.children.forEach(o=>ye(o,i))}class Te{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,o){this.g=i,this.j=o,this.a=[],this.c=new $.$Wd,this.onDidChange=this.c.event}set(i,o){!o?.__forceEvent&&(0,t.$ub)(this.a,i)||this.k(i,!1,o)}k(i,o,w){if(this.a=[...i],this.b=void 0,this.d=void 0,!o){const M=this;this.c.fire({get elements(){return M.get()},browserEvent:w})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:o}){if(!this.j){const Y=this.m(),oe=be=>Y.delete(be);o.forEach(be=>ye(be,oe)),this.set([...Y.values()]);return}const w=new Set,M=Y=>w.add(this.j.getId(Y.element).toString());o.forEach(Y=>ye(Y,M));const T=new Map,j=Y=>T.set(this.j.getId(Y.element).toString(),Y);i.forEach(Y=>ye(Y,j));const _=[];for(const Y of this.a){const oe=this.j.getId(Y.element).toString();if(!w.has(oe))_.push(Y);else{const De=T.get(oe);De&&De.visible&&_.push(De)}}if(this.a.length>0&&_.length===0){const Y=this.g();Y&&_.push(Y)}this.k(_,!0)}m(){const i=new Set;for(const o of this.a)i.add(o);return i}}class Ae extends p.$kS{constructor(i,o,w){super(i),this.x=o,this.y=w}u(i){if((0,p.$gS)(i.browserEvent.target)||(0,p.$_R)(i.browserEvent.target)||(0,p.$aS)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const o=i.element;if(!o)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const w=i.browserEvent.target,M=w.classList.contains("monaco-tl-twistie")||w.classList.contains("monaco-icon-label")&&w.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,T=(0,p.$eS)(i.browserEvent.target);let j=!1;if(T?j=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?j=this.x.expandOnlyOnTwistieClick(o.element):j=!!this.x.expandOnlyOnTwistieClick,T)this.A(i,o);else{if(j&&!M&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(o.collapsible&&(!T||M)){const _=this.x.getNodeLocation(o),Y=i.browserEvent.altKey;if(this.x.setFocus([_]),this.x.toggleCollapsed(_,Y),j&&M){i.browserEvent.isHandledByList=!0;return}}T||super.u(i)}A(i,o){if((0,p.$bS)(i.browserEvent.target)||(0,p.$cS)(i.browserEvent.target))return;const w=this.y();if(!w)throw new Error("Sticky scroll controller not found");const M=this.k.indexOf(o),T=this.k.getElementTop(M),j=w.nodePositionTopBelowWidget(o);this.x.scrollTop=T-j,this.k.domFocus(),this.k.setFocus([M]),this.k.setSelection([M])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}s(i){const o=i.browserEvent.target;if(!(0,p.$fS)(o)&&!(0,p.$eS)(o)){super.s(i);return}}t(i){const o=i.browserEvent.target;if(!(0,p.$fS)(o)&&!(0,p.$eS)(o)){super.t(i);return}}}class Q extends p.$nS{constructor(i,o,w,M,T,j,_,Y){super(i,o,w,M,Y),this.p=T,this.s=j,this.K=_}D(i){return new Ae(this,i.tree,i.stickyScrollProvider)}splice(i,o,w=[]){if(super.splice(i,o,w),w.length===0)return;const M=[],T=[];let j;w.forEach((_,Y)=>{this.p.has(_)&&M.push(i+Y),this.s.has(_)&&T.push(i+Y),this.K.has(_)&&(j=i+Y)}),M.length>0&&super.setFocus((0,t.$Mb)([...super.getFocus(),...M])),T.length>0&&super.setSelection((0,t.$Mb)([...super.getSelection(),...T])),typeof j=="number"&&super.setAnchor(j)}setFocus(i,o,w=!1){super.setFocus(i,o),w||this.p.set(i.map(M=>this.element(M)),o)}setSelection(i,o,w=!1){super.setSelection(i,o),w||this.s.set(i.map(M=>this.element(M)),o)}setAnchor(i,o=!1){super.setAnchor(i),o||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}var g;(function(r){r[r.Tree=0]="Tree",r[r.StickyScroll=1]="StickyScroll"})(g||(e.AbstractTreePart=g={}));class k{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return $.Event.map(this.j.onMouseClick,te)}get onMouseDblClick(){return $.Event.filter($.Event.map(this.j.onMouseDblClick,te),i=>i.target!==a.TreeMouseEventTarget.Filter)}get onContextMenu(){return $.Event.any($.Event.filter($.Event.map(this.j.onContextMenu,ce),i=>!i.isStickyScroll),this.B?.onContextMenu??$.Event.None)}get onTap(){return $.Event.map(this.j.onTap,te)}get onPointer(){return $.Event.map(this.j.onPointer,te)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return $.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ie.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??fe.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:$.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,o,w,M,T={}){this.G=i,this.H=T,this.y=new $.$5d,this.onDidChangeFindOpenState=$.Event.None,this.onDidChangeStickyScrollFocused=$.Event.None,this.D=new b.$Sc,this.E=new $.$Wd,this.onWillRefilter=this.E.event,this.F=new $.$Wd,this.onDidUpdateOptions=this.F.event,this.p=new O(w);const j=new $.$6d,_=new $.$6d,Y=this.D.add(new R(_.event)),oe=new l.$Gc;this.k=M.map(ve=>new L(ve,()=>this.o,j.event,Y,oe,T));for(const ve of this.k)this.D.add(ve);let be;T.keyboardNavigationLabelProvider&&(be=new G(this,T.keyboardNavigationLabelProvider,T.filter),T={...T,filter:be},this.D.add(be)),this.q=new Te(()=>this.j.getFocusedElements()[0],T.identityProvider),this.w=new Te(()=>this.j.getSelectedElements()[0],T.identityProvider),this.x=new Te(()=>this.j.getAnchorElement(),T.identityProvider),this.j=new Q(i,o,this.p,this.k,this.q,this.w,this.x,{...y(()=>this.o,T),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,T),j.input=this.o.onDidChangeCollapseState;const De=$.Event.forEach(this.o.onDidSplice,ve=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(ve),this.w.onDidModelSplice(ve)})},this.D);De(()=>null,null,this.D);const we=this.D.add(new $.$Wd),Ee=this.D.add(new s.$5g(0));if(this.D.add($.Event.any(De,this.q.onDidChange,this.w.onDidChange)(()=>{Ee.trigger(()=>{const ve=new Set;for(const Pe of this.q.getNodes())ve.add(Pe);for(const Pe of this.w.getNodes())ve.add(Pe);we.fire([...ve.values()])})})),_.input=we.event,T.keyboardSupport!==!1){const ve=$.Event.chain(this.j.onKeyDown,Pe=>Pe.filter(Me=>!(0,p.$_R)(Me.target)).map(Me=>new n.$PP(Me)));$.Event.chain(ve,Pe=>Pe.filter(Me=>Me.keyCode===15))(this.J,this,this.D),$.Event.chain(ve,Pe=>Pe.filter(Me=>Me.keyCode===17))(this.K,this,this.D),$.Event.chain(ve,Pe=>Pe.filter(Me=>Me.keyCode===10))(this.L,this,this.D)}if((T.findWidgetEnabled??!0)&&T.keyboardNavigationLabelProvider&&T.contextViewProvider){const ve=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Ne(this,this.o,this.j,be,T.contextViewProvider,ve),this.A=Pe=>this.z.shouldAllowFocus(Pe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=$.Event.None,this.onDidChangeFindMatchType=$.Event.None;T.enableStickyScroll&&(this.B=new re(this,this.o,this.j,this.k,this.p,T),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,A.$BQ)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===E.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const o of this.k)o.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===E.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?(this.B=new re(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=$.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const o=this.o.getListIndex(i);o!==-1&&this.j.updateWidth(o)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,A.$tQ)(this.getHTMLElement())}layout(i,o){this.j.layout(i,o),(0,N.$Nf)(o)&&this.z?.layout(o)}style(i){const o=`.${this.j.domId}`,w=[];i.treeIndentGuidesStroke&&(w.push(`.monaco-list${o}:hover .monaco-tl-indent > .indent-guide, .monaco-list${o}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),w.push(`.monaco-list${o} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(w.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),w.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const M=(0,A.$_Q)(i.listFocusAndSelectionOutline,(0,A.$_Q)(i.listSelectionOutline,i.listFocusOutline??""));M&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${M}; outline-offset: -1px;}`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=w.join(`
`),this.j.style(i)}getParentElement(i){const o=this.o.getParentNodeLocation(i);return this.o.getNode(o).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,o=!1){return this.o.setCollapsed(i,!0,o)}expand(i,o=!1){return this.o.setCollapsed(i,!1,o)}toggleCollapsed(i,o=!1){return this.o.setCollapsed(i,void 0,o)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,o){return this.o.setCollapsible(i,o)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const o=this.o.getNode(i);this.x.set([o]);const w=this.o.getListIndex(i);w>-1&&this.j.setAnchor(w,!0)})}getAnchor(){return(0,t.$Ob)(this.x.get(),void 0)}setSelection(i,o){this.y.bufferEvents(()=>{const w=i.map(T=>this.o.getNode(T));this.w.set(w,o);const M=i.map(T=>this.o.getListIndex(T)).filter(T=>T>-1);this.j.setSelection(M,o,!0)})}getSelection(){return this.w.get()}setFocus(i,o){this.y.bufferEvents(()=>{const w=i.map(T=>this.o.getNode(T));this.q.set(w,o);const M=i.map(T=>this.o.getListIndex(T)).filter(T=>T>-1);this.j.setFocus(M,o,!0)})}focusNext(i=1,o=!1,w,M=(0,A.$JQ)(w)&&w.altKey?void 0:this.A){this.j.focusNext(i,o,w,M)}focusPrevious(i=1,o=!1,w,M=(0,A.$JQ)(w)&&w.altKey?void 0:this.A){this.j.focusPrevious(i,o,w,M)}focusNextPage(i,o=(0,A.$JQ)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,o)}focusPreviousPage(i,o=(0,A.$JQ)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,o,()=>this.B?.height??0)}focusLast(i,o=(0,A.$JQ)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,o)}focusFirst(i,o=(0,A.$JQ)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,o)}getFocus(){return this.q.get()}getStickyScrollFocus(){const i=this.B?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(i,o){this.o.expandTo(i);const w=this.o.getListIndex(i);if(w!==-1)if(!this.B)this.j.reveal(w,o);else{const M=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(w,o,M)}}getRelativeTop(i){const o=this.o.getListIndex(i);if(o===-1)return null;const w=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(o,w?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new a.$2T(this.G,"Can't get tree view state without an identity provider");const o=j=>i.getId(j).toString(),w=H.empty(this.scrollTop);for(const j of this.getFocus())w.focus.add(o(j));for(const j of this.getSelection())w.selection.add(o(j));const M=this.o.getNode(),T=[M];for(;T.length>0;){const j=T.shift();j!==M&&j.collapsible&&(w.expanded[o(j.element)]=j.collapsed?0:1),T.push(...j.children)}return w}J(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],M=this.o.getNodeLocation(w);if(!this.o.setCollapsed(M,!0)){const j=this.o.getParentNodeLocation(M);if(!j)return;const _=this.o.getListIndex(j);this.j.reveal(_),this.j.setFocus([_])}}K(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],M=this.o.getNodeLocation(w);if(!this.o.setCollapsed(M,!1)){if(!w.children.some(Y=>Y.visible))return;const[j]=this.j.getFocus(),_=j+1;this.j.reveal(_),this.j.setFocus([_])}}L(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],M=this.o.getNodeLocation(w),T=i.browserEvent.altKey;this.o.setCollapsed(M,void 0,T)}navigate(i){return new F(this.j,this.o,i)}dispose(){(0,b.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}e.$_T=k;class F{constructor(i,o,w){this.b=i,this.c=o,w?this.a=this.c.getListIndex(w):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define($e[133],pe([1,0,132,123,26,28]),function(ne,e,A,C,n,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kU=void 0;class D extends A.$_T{constructor(m,p,v,I,a,h={}){super(m,p,v,I,h),this.f=m,this.g=a,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(m,p){if(p&&!this.c)throw new n.$2T(this.f,"Can't restore tree view state without an identity provider");if(this.b=m,!m){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!p){this.m(m);return}const v=[],I=[],a=t=>{const s=this.c.getId(t).toString();return!p.expanded[s]},h=t=>{const s=this.c.getId(t.element).toString();p.focus.has(s)&&v.push(t.element),p.selection.has(s)&&I.push(t.element)};this.m(m,a,h),this.setFocus(v),this.setSelection(I),p&&typeof p.scrollTop=="number"&&(this.scrollTop=p.scrollTop)}updateChildren(m=this.b){if(typeof this.b>"u")throw new n.$2T(this.f,"Tree input not set");let p;this.c&&(p=v=>{const I=this.c.getId(v).toString(),a=this.d.get(I);if(a)return a.collapsed}),this.m(m,p)}resort(m=this.b,p=!0){this.o.resort(m===this.b?null:m,p)}refresh(m){if(m===void 0){this.j.rerender();return}this.o.rerender(m)}m(m,p,v){let I;if(this.c){const a=new Set,h=v;v=t=>{const s=this.c.getId(t.element).toString();a.add(s),this.d.set(s,t),h?.(t)},I=t=>{const s=this.c.getId(t.element).toString();a.has(s)||this.d.delete(s)}}this.o.setChildren(m===this.b?null:m,this.s(m,p).elements,{onDidCreateNode:v,onDidDeleteNode:I})}s(m,p){const v=[...this.g.getChildren(m)];return{elements:U.Iterable.map(v,a=>{const{elements:h,size:t}=this.s(a,p),s=this.g.hasChildren?this.g.hasChildren(a):void 0,d=t===0?void 0:p&&p(a);return{element:a,children:h,collapsible:s,collapsed:d}}),size:v.length}}M(m,p,v){return new C.$aU(m,p,v)}}e.$kU=D}),define($e[67],pe([1,0,12,9,34,29,27,6,4,3,53,10,7]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.ProxyChannel=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.RequestInitiator=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;var h;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(h||(h={}));function t(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(s||(s={}));function d(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(c||(c={}));function l(se){let J=0;for(let ae=0;;ae+=7){const re=se.read(1);if(J|=(re.buffer[0]&127)<<ae,!(re.buffer[0]&128))return J}}const $=B(0);function f(se,J){if(J===0){se.write($);return}let ae=0;for(let X=J;X!==0;X=X>>>7)ae++;const re=n.$ke.alloc(ae);for(let X=0;J!==0;X++)re.buffer[X]=J&127,J=J>>>7,J>0&&(re.buffer[X]|=128);se.write(re)}class b{constructor(J){this.b=J,this.a=0}read(J){const ae=this.b.slice(this.a,this.a+J);return this.a+=ae.byteLength,ae}}e.$Fh=b;class u{constructor(){this.a=[]}get buffer(){return n.$ke.concat(this.a)}write(J){this.a.push(J)}}e.$Gh=u;var N;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(N||(N={}));function B(se){const J=n.$ke.alloc(1);return J.writeUInt8(se,0),J}const P={Undefined:B(N.Undefined),String:B(N.String),Buffer:B(N.Buffer),VSBuffer:B(N.VSBuffer),Array:B(N.Array),Object:B(N.Object),Uint:B(N.Int)},W=typeof Buffer<"u";function z(se,J){if(typeof J>"u")se.write(P.Undefined);else if(typeof J=="string"){const ae=n.$ke.fromString(J);se.write(P.String),f(se,ae.byteLength),se.write(ae)}else if(W&&Buffer.isBuffer(J)){const ae=n.$ke.wrap(J);se.write(P.Buffer),f(se,ae.byteLength),se.write(ae)}else if(J instanceof n.$ke)se.write(P.VSBuffer),f(se,J.byteLength),se.write(J);else if(Array.isArray(J)){se.write(P.Array),f(se,J.length);for(const ae of J)z(se,ae)}else if(typeof J=="number"&&(J|0)===J)se.write(P.Uint),f(se,J);else{const ae=n.$ke.fromString(JSON.stringify(J));se.write(P.Object),f(se,ae.byteLength),se.write(ae)}}e.$Hh=z;function y(se){switch(se.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return se.read(l(se)).toString();case N.Buffer:return se.read(l(se)).buffer;case N.VSBuffer:return se.read(l(se));case N.Array:{const ae=l(se),re=[];for(let X=0;X<ae;X++)re.push(y(se));return re}case N.Object:return JSON.parse(se.read(l(se)).toString());case N.Int:return l(se)}}e.$Ih=y;class O{constructor(J,ae,re=null,X=1e3){this.h=J,this.j=ae,this.k=re,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(J,ae){this.b.set(J,ae),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const ae=this.o([J.type]);this.k?.logOutgoing(ae,0,1,d(J.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([J.type,J.id],J.data);this.k?.logOutgoing(ae,J.id,1,d(J.type),J.data);return}}}o(J,ae=void 0){const re=new u;return z(re,J),z(re,ae),this.p(re.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const ae=new b(J),re=y(ae),X=y(ae),x=re[0];switch(x){case 100:return this.k?.logIncoming(J.byteLength,re[1],1,`${t(x)}: ${re[2]}.${re[3]}`,X),this.s({type:x,id:re[1],channelName:re[2],name:re[3],arg:X});case 102:return this.k?.logIncoming(J.byteLength,re[1],1,`${t(x)}: ${re[2]}.${re[3]}`,X),this.t({type:x,id:re[1],channelName:re[2],name:re[3],arg:X});case 101:return this.k?.logIncoming(J.byteLength,re[1],1,`${t(x)}`),this.u({type:x,id:re[1]});case 103:return this.k?.logIncoming(J.byteLength,re[1],1,`${t(x)}`),this.u({type:x,id:re[1]})}}s(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const re=new U.$7d;let X;try{X=ae.call(this.j,J.name,J.arg,re.token)}catch(ce){X=Promise.reject(ce)}const x=J.id;X.then(ce=>{this.m({id:x,data:ce,type:201})},ce=>{ce instanceof Error?this.m({id:x,data:{message:ce.message,name:ce.name,stack:ce.stack?ce.stack.split?ce.stack.split(`
`):ce.stack:void 0},type:202}):this.m({id:x,data:ce,type:203})}).finally(()=>{te.dispose(),this.d.delete(J.id)});const te=(0,p.$Rc)(()=>re.cancel());this.d.set(J.id,te)}t(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const re=J.id,x=ae.listen(this.j,J.name,J.arg)(te=>this.m({id:re,data:te,type:204}));this.d.set(J.id,x)}u(J){const ae=this.d.get(J.id);ae&&(ae.dispose(),this.d.delete(J.id))}v(J){let ae=this.g.get(J.channelName);ae||(ae=[],this.g.set(J.channelName,ae));const re=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:J,timeoutTimer:re})}w(J){const ae=this.g.get(J);if(ae){for(const re of ae)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=O;var H;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(H||(e.RequestInitiator=H={}));class E{constructor(J,ae=null){this.l=J,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ae}getChannel(J){const ae=this;return{call(re,X,x){return ae.a?Promise.reject(new S.$5):ae.m(J,re,X,x)},listen(re,X){return ae.a?m.Event.None:ae.o(J,re,X)}}}m(J,ae,re,X=U.CancellationToken.None){const x=this.g++,ce={id:x,type:100,channelName:J,name:ae,arg:re};if(X.isCancellationRequested)return Promise.reject(new S.$5);let ye;return new Promise((Ae,Q)=>{if(X.isCancellationRequested)return Q(new S.$5);const g=()=>{const i=o=>{switch(o.type){case 201:this.f.delete(x),Ae(o.data);break;case 202:{this.f.delete(x);const w=new Error(o.data.message);w.stack=Array.isArray(o.data.stack)?o.data.stack.join(`
`):o.data.stack,w.name=o.data.name,Q(w);break}case 203:this.f.delete(x),Q(o.data);break}};this.f.set(x,i),this.p(ce)};let k=null;this.b===c.Idle?g():(k=(0,C.$Ug)(i=>this.u()),k.then(()=>{k=null,g()}));const F=()=>{k?(k.cancel(),k=null):this.p({id:x,type:101}),Q(new S.$5)},r=X.onCancellationRequested(F);ye=(0,p.$Qc)((0,p.$Rc)(F),r),this.d.add(ye)}).finally(()=>{ye.dispose(),this.d.delete(ye)})}o(J,ae,re){const X=this.g++,te={id:X,type:102,channelName:J,name:ae,arg:re};let ce=null;const ye=new m.$Wd({onWillAddFirstListener:()=>{ce=(0,C.$Ug)(Ae=>this.u()),ce.then(()=>{ce=null,this.d.add(ye),this.p(te)})},onDidRemoveLastListener:()=>{ce?(ce.cancel(),ce=null):(this.d.delete(ye),this.p({id:X,type:103}))}}),Te=Ae=>ye.fire(Ae.data);return this.f.set(X,Te),ye.event}p(J){switch(J.type){case 100:case 102:{const ae=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(ae,J.id,0,`${t(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const ae=this.q([J.type,J.id]);this.j?.logOutgoing(ae,J.id,0,t(J.type));return}}}q(J,ae=void 0){const re=new u;return z(re,J),z(re,ae),this.r(re.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const ae=new b(J),re=y(ae),X=y(ae),x=re[0];switch(x){case 200:return this.j?.logIncoming(J.byteLength,0,0,d(x)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,re[1],0,d(x),X),this.t({type:re[0],id:re[1],data:X})}}t(J){if(J.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=E,Xe([D.$zh],E.prototype,"onDidInitializePromise",null);class R{get connections(){const J=[];return this.f.forEach(ae=>J.push(ae)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new m.$Wd,this.onDidAddConnection=this.g.event,this.h=new m.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new p.$Sc,this.j.add(J(({protocol:ae,onDidClientDisconnect:re})=>{const X=m.Event.once(ae.onMessage);this.j.add(X(x=>{const te=new b(x),ce=y(te),ye=new O(ae,ce),Te=new E(ae);this.a.forEach((Q,g)=>ye.registerChannel(g,Q));const Ae={channelServer:ye,channelClient:Te,ctx:ce};this.f.add(Ae),this.g.fire(Ae),this.j.add(re(()=>{ye.dispose(),Te.dispose(),this.f.delete(Ae),this.h.fire(Ae)}))}))}))}getChannel(J,ae){const re=this;return{call(X,x,te){let ce;if((0,a.$Xf)(ae)){const Te=(0,A.$4b)(re.connections.filter(ae));ce=Te?Promise.resolve(Te):m.Event.toPromise(m.Event.filter(re.onDidAddConnection,ae))}else ce=ae.routeCall(re,X,x);const ye=ce.then(Te=>Te.channelClient.getChannel(J));return G(ye).call(X,x,te)},listen(X,x){if((0,a.$Xf)(ae))return re.k(J,ae,X,x);const te=ae.routeEvent(re,X,x).then(ce=>ce.channelClient.getChannel(J));return G(te).listen(X,x)}}}k(J,ae,re,X){const x=this;let te;const ce=new m.$Wd({onWillAddFirstListener:()=>{te=new p.$Sc;const ye=new m.$3d,Te=new Map,Ae=g=>{const F=g.channelClient.getChannel(J).listen(re,X),r=ye.add(F);Te.set(g,r)},Q=g=>{const k=Te.get(g);k&&(k.dispose(),Te.delete(g))};x.connections.filter(ae).forEach(Ae),m.Event.filter(x.onDidAddConnection,ae)(Ae,void 0,te),x.onDidRemoveConnection(Q,void 0,te),ye.event(ce.fire,ce,te),te.add(ye)},onDidRemoveLastListener:()=>{te?.dispose(),te=void 0}});return ce.event}registerChannel(J,ae){this.a.set(J,ae);for(const re of this.f)re.channelServer.registerChannel(J,ae)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Lh=R;class L{constructor(J,ae,re=null){const X=new u;z(X,ae),J.send(X.buffer),this.a=new E(J,re),this.d=new O(J,ae,re)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,ae){this.d.registerChannel(J,ae)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Mh=L;function G(se){return{call(J,ae,re){return se.then(X=>X.call(J,ae,re))},listen(J,ae){const re=new m.$6d;return se.then(X=>re.input=X.listen(J,ae)),re.event}}}e.$Nh=G;function Z(se){let J=!1;return{call(ae,re,X){return J?se.call(ae,re,X):(0,C.$9g)(0).then(()=>J=!0).then(()=>se.call(ae,re,X))},listen(ae,re){if(J)return se.listen(ae,re);const X=new m.$6d;return(0,C.$9g)(0).then(()=>J=!0).then(()=>X.input=se.listen(ae,re)),X.event}}}e.$Oh=Z;class ge{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const ae of J.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await m.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Ph=ge;var he;(function(se){function J(x,te,ce){const ye=x,Te=ce&&ce.disableMarshalling,Ae=new Map;for(const Q in ye)re(Q)&&Ae.set(Q,m.Event.buffer(ye[Q],!0,void 0,te));return new class{listen(Q,g,k){const F=Ae.get(g);if(F)return F;if(X(g)){const r=ye[g];if(typeof r=="function")return r.call(ye,k)}throw new S.$bb(`Event not found: ${g}`)}call(Q,g,k){const F=ye[g];if(typeof F=="function"){if(!Te&&Array.isArray(k))for(let i=0;i<k.length;i++)k[i]=(0,v.$Eh)(k[i]);let r=F.apply(ye,k);return r instanceof Promise||(r=Promise.resolve(r)),r}throw new S.$bb(`Method not found: ${g}`)}}}se.fromService=J;function ae(x,te){const ce=te&&te.disableMarshalling;return new Proxy({},{get(ye,Te){if(typeof Te=="string")return te?.properties?.has(Te)?te.properties.get(Te):X(Te)?function(Ae){return x.listen(Te,Ae)}:re(Te)?x.listen(Te):async function(...Ae){let Q;te&&!(0,a.$Sf)(te.context)?Q=[te.context,...Ae]:Q=Ae;const g=await x.call(Te,Q);return ce?g:(0,v.$Eh)(g)};throw new S.$bb(`Property not found: ${String(Te)}`)}})}se.toService=ae;function re(x){return x[0]==="o"&&x[1]==="n"&&I.$_e(x.charCodeAt(2))}function X(x){return/^onDynamic/.test(x)&&I.$_e(x.charCodeAt(9))}})(he||(e.ProxyChannel=he={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const J=se.toString();if(J!=="[object Object]")return J}return se}function Re(se){return Array.isArray(se)?se.map(fe):fe(se)}function Ne(se,J,ae,re,X,x,te){te=Re(te);const ce=ie[X],ye=ce[re%ce.length];let Te=[`%c[${se}]%c[${String(J).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(x)?(Te=Te.concat(te),Te.push(")")):Te.push(te),console.log.apply(console,Te)}class Be{constructor(J,ae){this.d=J,this.f=ae,this.a=0,this.b=0}logOutgoing(J,ae,re,X,x){this.b+=J,Ne(this.d,this.b,J,ae,re,X,x)}logIncoming(J,ae,re,X,x){this.a+=J,Ne(this.f,this.a,J,ae,re,X,x)}}e.$Qh=Be}),define($e[134],pe([1,0,34,4,67,90,30]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UU=void 0;class S extends n.$Mh{static f(){const p=C.Event.fromNodeEventEmitter(D.$O,"vscode:message",(v,I)=>A.$ke.wrap(I));return D.$O.send("vscode:hello"),new U.$QU(D.$O,p)}constructor(p){const v=S.f();super(v,p),this.b=v}dispose(){this.b.disconnect(),super.dispose()}}e.$UU=S}),define($e[135],pe([13,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define($e[136],pe([13,11]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define($e[41],pe([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var A;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(m){return m[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(A||(e._util=A={})),e.$7h=n("instantiationService");function C(D,S,m){S[A.DI_TARGET]===S?S[A.DI_DEPENDENCIES].push({id:D,index:m}):(S[A.DI_DEPENDENCIES]=[{id:D,index:m}],S[A.DI_TARGET]=S)}function n(D){if(A.serviceIds.has(D))return A.serviceIds.get(D);const S=function(m,p,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(S,m,v)};return S.toString=()=>D,A.serviceIds.set(D,S),S}e.$8h=n;function U(D){return D}e.$9h=U}),define($e[137],pe([1,0,41]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.ID=void 0,e.ID="diagnosticsService",e.$Lm=(0,A.$8h)(e.ID);function C(U){return!!U.hostName&&!!U.errorMessage}e.$Mm=C;class n{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Nm=n}),define($e[138],pe([1,0,88,24,10,7,15,135,41,5,31,23]),function(ne,e,A,C,n,U,D,S,m,p,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,m.$8h)("fileService");function a(X){return X.create===!0}e.$tk=a;var h;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var t;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(t||(e.FilePermission=t={}));function s(X){const x=X;return!!x&&typeof x.onDidChange=="function"}e.$uk=s;var d;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function c(X){return!!(X.capabilities&2)}e.$vk=c;function l(X){return!!(X.capabilities&8)}e.$wk=l;function $(X){return!!(X.capabilities&131072)}e.$xk=$;function f(X){return!!(X.capabilities&4)}e.$yk=f;function b(X){return!!(X.capabilities&16)}e.$zk=b;function u(X){return c(X)?!!(X.capabilities&16384):!1}e.$Ak=u;function N(X){return c(X)?!!(X.capabilities&32768):!1}e.$Bk=N;function B(X){return!!(X.capabilities&65536)}e.$Ck=B;function P(X){return!!(X.capabilities&2048)}e.$Dk=P;var W;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(W||(e.FileSystemProviderErrorCode=W={}));class z extends Error{static create(x,te){const ce=new z(x.toString(),te);return H(ce,te),ce}constructor(x,te){super(x),this.code=te}}e.$Ek=z;function y(X,x){return z.create(X,x)}e.$Fk=y;function O(X){return X||y((0,S.localize)(0,null),W.Unknown)}e.$Gk=O;function H(X,x){return X.name=x?`${x} (FileSystemError)`:"FileSystemError",X}e.$Hk=H;function E(X){if(!X)return W.Unknown;if(X instanceof z)return X.code;const x=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!x)return W.Unknown;switch(x[1]){case W.FileExists:return W.FileExists;case W.FileIsADirectory:return W.FileIsADirectory;case W.FileNotADirectory:return W.FileNotADirectory;case W.FileNotFound:return W.FileNotFound;case W.FileTooLarge:return W.FileTooLarge;case W.FileWriteLocked:return W.FileWriteLocked;case W.NoPermissions:return W.NoPermissions;case W.Unavailable:return W.Unavailable}return W.Unknown}e.$Ik=E;function R(X){if(X instanceof ie)return X.fileOperationResult;switch(E(X)){case W.FileNotFound:return 1;case W.FileIsADirectory:return 0;case W.FileNotADirectory:return 9;case W.FileWriteLocked:return 5;case W.NoPermissions:return 6;case W.FileExists:return 4;case W.FileTooLarge:return 7;default:return 10}}e.$Jk=R;var L;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class G{constructor(x,te,ce){this.resource=x,this.operation=te,this.target=ce}isOperation(x){return this.operation===x}}e.$Kk=G;var Z;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(Z||(e.FileChangeType=Z={}));class ge{static{this.a=null}constructor(x,te){this.c=te,this.b=void 0,this.d=new I.$V(()=>{const ce=A.$bi.forUris(()=>this.c);return ce.fill(this.rawAdded.map(ye=>[ye,!0])),ce}),this.f=new I.$V(()=>{const ce=A.$bi.forUris(()=>this.c);return ce.fill(this.rawUpdated.map(ye=>[ye,!0])),ce}),this.g=new I.$V(()=>{const ce=A.$bi.forUris(()=>this.c);return ce.fill(this.rawDeleted.map(ye=>[ye,!0])),ce}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ce of x){switch(ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}this.b!==ge.a&&(typeof ce.cId=="number"?this.b===void 0?this.b=ce.cId:this.b!==ce.cId&&(this.b=ge.a):this.b!==void 0&&(this.b=ge.a))}}contains(x,...te){return this.h(x,{includeChildren:!1},...te)}affects(x,...te){return this.h(x,{includeChildren:!0},...te)}h(x,te,...ce){if(!x)return!1;const ye=ce.length>0;return!!((!ye||ce.includes(1))&&(this.d.value.get(x)||te.includeChildren&&this.d.value.findSuperstr(x))||(!ye||ce.includes(0))&&(this.f.value.get(x)||te.includeChildren&&this.f.value.findSuperstr(x))||(!ye||ce.includes(2))&&(this.g.value.findSubstr(x)||te.includeChildren&&this.g.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.b===x}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=ge;function he(X,x,te){return!X||!x||X===x||x.length>X.length?!1:(x.charAt(x.length-1)!==C.sep&&(x+=C.sep),te?(0,n.$bf)(X,x):X.indexOf(x)===0)}e.$Mk=he;class ie extends Error{constructor(x,te,ce){super(x),this.fileOperationResult=te,this.options=ce}}e.$Nk=ie;class fe extends ie{constructor(x,te,ce,ye){super(x,te,ye),this.fileOperationResult=te,this.size=ce}}e.$Ok=fe;class Re extends ie{constructor(x,te,ce){super(x,2,ce),this.stat=te}}e.$Pk=Re;var Ne;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ne||(e.FileOperationResult=Ne={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var Be;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(e.FileKind=Be={})),e.$Xk="";function se(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$Yk=se;async function J(X,x){if(!x.hasProvider(D.URI.from({scheme:X.scheme})))return new Promise(te=>{const ce=x.onDidChangeFileSystemProviderRegistrations(ye=>{ye.scheme===X.scheme&&ye.added&&(ce.dispose(),te())})})}e.$Zk=J;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(x){return(0,U.$Nf)(x)||(x=0),x<ae.KB?(0,S.localize)(1,null,x.toFixed(0)):x<ae.MB?(0,S.localize)(2,null,(x/ae.KB).toFixed(2)):x<ae.GB?(0,S.localize)(3,null,(x/ae.MB).toFixed(2)):x<ae.TB?(0,S.localize)(4,null,(x/ae.GB).toFixed(2)):(0,S.localize)(5,null,(x/ae.TB).toFixed(2))}}e.$1k=ae;function re(X){const x=typeof X=="string"||X?.scheme===v.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===v.Schemas.file?1024*ae.MB:x?10*ae.MB:p.$o?50*ae.MB:1024*ae.MB}e.$2k=re}),define($e[139],pe([1,0,41]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6$b=e.$5$b=void 0,e.$5$b=(0,A.$8h)("mainProcessService");class C{constructor(U,D){this.a=U,this.b=D}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,D){this.a.registerChannel(U,D)}}e.$6$b=C}),define($e[140],pe([1,0,3,134]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=void 0;class n extends A.$Tc{constructor(D){super(),this.a=this.B(new C.$UU(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,S){this.a.registerChannel(D,S)}}e.$7$b=n});var Ei=this&&this.__param||function(ne,e){return function(A,C){e(A,C,ne)}};define($e[141],pe([1,0,67,139]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$$b=void 0;let n=class{constructor(D,S){return this.windowId=D,A.ProxyChannel.toService(S.getChannel("nativeHost"),{context:D,properties:(()=>{const m=new Map;return m.set("windowId",D),m})()})}};e.$$$b=n,e.$$$b=n=Xe([Ei(1,C.$5$b)],n)}),define($e[68],pe([1,0,76,7]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class n{constructor(){this.a=new Map}add(D,S){A.ok(C.$Jf(D)),A.ok(C.$Lf(S)),A.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Kn=new n}),define($e[142],pe([1,0,4,68]),function(ne,e,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function n(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class U{constructor(){this.b=new A.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,p){this.a[n(m)]=p,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const D=new U;C.$Kn.add(e.$Ln.JSONContribution,D)}),define($e[143],pe([1,0,9,17,18,4,7,15,136,142,68]),function(ne,e,A,C,n,U,D,S,m,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var I;(function(f){function b(u,N){let B=u.defaults;for(;n.ThemeIcon.isThemeIcon(B);){const P=t.getIcon(B.id);if(!P)return;B=P.defaults}return B}f.getDefinition=b})(I||(e.IconContribution=I={}));var a;(function(f){function b(N){return{weight:N.weight,style:N.style,src:N.src.map(B=>({format:B.format,location:B.location.toString()}))}}f.toJSONObject=b;function u(N){const B=P=>(0,D.$Jf)(P)?P:void 0;if(N&&Array.isArray(N.src)&&N.src.every(P=>(0,D.$Jf)(P.format)&&(0,D.$Jf)(P.location)))return{weight:B(N.weight),style:B(N.style),src:N.src.map(P=>({format:P.format,location:S.URI.parse(P.location)}))}}f.fromJSONObject=u})(a||(e.IconFontDefinition=a={}));class h{constructor(){this.a=new U.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,u,N,B){const P=this.b[b];if(P){if(N&&!P.description){P.description=N,this.d.properties[b].markdownDescription=`${N} $(${b})`;const y=this.e.enum.indexOf(b);y!==-1&&(this.e.enumDescriptions[y]=N),this.a.fire()}return P}const W={id:b,description:N,defaults:u,deprecationMessage:B};this.b[b]=W;const z={$ref:"#/definitions/icons"};return B&&(z.deprecationMessage=B),N&&(z.markdownDescription=`${N}: $(${b})`),this.d.properties[b]=z,this.e.enum.push(b),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const u=this.e.enum.indexOf(b);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,u){const N=this.f[b];return N||(this.f[b]=u,this.a.fire(),u)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(P,W)=>P.id.localeCompare(W.id),u=P=>{for(;n.ThemeIcon.isThemeIcon(P.defaults);)P=this.b[P.defaults.id];return`codicon codicon-${P?P.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const B=Object.keys(this.b).map(P=>this.b[P]);for(const P of B.filter(W=>!!W.description).sort(b))N.push(`|<i class="${u(P)}"></i>|${P.id}|${n.ThemeIcon.isThemeIcon(P.defaults)?P.defaults.id:P.id}|${P.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const P of B.filter(W=>!n.ThemeIcon.isThemeIcon(W.defaults)).sort(b))N.push(`|<i class="${u(P)}"></i>|${P.id}|`);return N.join(`
`)}}const t=new h;v.$Kn.add(e.$yw.IconContribution,t);function s(f,b,u,N){return t.registerIcon(f,b,u,N)}e.$zw=s;function d(){return t}e.$Aw=d;function c(){const f=(0,C.$_j)();for(const b in f){const u="\\"+f[b].toString(16);t.registerIcon(b,{fontCharacter:u})}}c(),e.$Bw="vscode://schemas/icons";const l=v.$Kn.as(p.$Ln.JSONContribution);l.registerSchema(e.$Bw,t.getIconSchema());const $=new A.$hh(()=>l.notifySchemaChanged(e.$Bw),200);t.onDidChange(()=>{$.isScheduled()||$.schedule()}),e.$Cw=s("widget-close",C.$bk.close,(0,m.localize)(2,null)),e.$Dw=s("goto-previous-location",C.$bk.arrowUp,(0,m.localize)(3,null)),e.$Ew=s("goto-next-location",C.$bk.arrowDown,(0,m.localize)(4,null)),e.$Fw=n.ThemeIcon.modify(C.$bk.sync,"spin"),e.$Gw=n.ThemeIcon.modify(C.$bk.loading,"spin")}),define($e[144],pe([1,0,2,4,3,18,143]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LFb=e.$KFb=void 0;function S(p){const v=new n.$Sc,I=v.add(new C.$Wd),a=(0,D.$Aw)();return v.add(a.onDidChange(()=>I.fire())),p&&v.add(p.onDidProductIconThemeChange(()=>I.fire())),{dispose:()=>v.dispose(),onDidChange:I.event,getCSS(){const h=p?p.getProductIconTheme():new m,t={},s=c=>{const l=h.getIcon(c);if(!l)return;const $=l.font;return $?(t[$.id]=$.definition,`.codicon-${c.id}:before { content: '${l.fontCharacter}'; font-family: ${(0,A.$$Q)($.id)}; }`):`.codicon-${c.id}:before { content: '${l.fontCharacter}'; }`},d=[];for(const c of a.getIcons()){const l=s(c);l&&d.push(l)}for(const c in t){const l=t[c],$=l.weight?`font-weight: ${l.weight};`:"",f=l.style?`font-style: ${l.style};`:"",b=l.src.map(u=>`${(0,A.$0Q)(u.location)} format('${u.format}')`).join(", ");d.push(`@font-face { src: ${b}; font-family: ${(0,A.$$Q)(c)};${$}${f} font-display: block; }`)}return d.join(`
`)}}}e.$KFb=S;class m{getIcon(v){const I=(0,D.$Aw)();let a=v.defaults;for(;U.ThemeIcon.isThemeIcon(a);){const h=I.getIcon(a.id);if(!h)return;a=h.defaults}return a}}e.$LFb=m}),define($e[145],pe([1,0,5]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=void 0,e.$PC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(c){return typeof c.parentId=="number"}e.$QC=C;function n(c){return!!c.workspaceUri}e.$RC=n;function U(c){return!!c.folderUri}e.$SC=U;function D(c){return!!c.fileUri}e.$TC=D;function S(c){const l=a(c),$=c.getValue("window.menuBarVisibility");return $==="default"||l&&$==="compact"||A.$j&&A.$m?"classic":$}e.$UC=S;var m;(function(c){c.TITLE_BAR_STYLE="window.titleBarStyle",c.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(m||(e.TitleBarSetting=m={}));var p;(function(c){c.NATIVE="native",c.CUSTOM="custom"})(p||(e.TitlebarStyle=p={}));var v;(function(c){c.AUTO="auto",c.WINDOWED="windowed",c.NEVER="never"})(v||(e.CustomTitleBarVisibility=v={}));function I(c,l){return!0}e.$VC=I;function a(c,l){return l||(l=h(c)),l==="native"}e.$WC=a;function h(c){if(A.$o)return"custom";const l=c.getValue("window");if(l){if(A.$j&&l.nativeTabs===!0||A.$j&&l.nativeFullScreen===!1)return"native";const b=l.titleBarStyle;if(b==="native"||b==="custom")return b}return A.$k?"native":"custom"}e.$XC=h;function t(c){return!(!A.$i||A.$o||a(c))}e.$YC=t;function s(c){const l=c.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}e.$ZC=s;function d(c=0){return Math.pow(1.2,c)}e.$1C=d}),define($e[146],pe([1,0,16,2,21,30,145]),function(ne,e,A,C,n,U,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=e.$d_b=e.$c_b=e.$b_b=e.$a_b=e.ApplyZoomTarget=void 0;var S;(function(a){a[a.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",a[a.ALL_WINDOWS=2]="ALL_WINDOWS"})(S||(e.ApplyZoomTarget=S={})),e.$a_b=8,e.$b_b=-8;function m(a,h){a=Math.min(Math.max(a,e.$b_b),e.$a_b);const t=[];h===S.ACTIVE_WINDOW?t.push((0,C.$xQ)()):h===S.ALL_WINDOWS?t.push(...Array.from((0,C.getWindows)()).map(({window:s})=>s)):t.push(h);for(const s of t)p(s)?.webFrame?.setZoomLevel(a),(0,A.$uP)((0,D.$1C)(a),s),(0,A.$qP)(a,s)}e.$c_b=m;function p(a){if(a===n.$lP)return{ipcRenderer:U.$O,webFrame:U.$Q};{const h=a;if(h?.vscode?.ipcRenderer&&h?.vscode?.webFrame)return h.vscode}}function v(a){m((0,A.$rP)(typeof a=="number"?(0,C.$xQ)():a)+1,a)}e.$d_b=v;function I(a){m((0,A.$rP)(typeof a=="number"?(0,C.$xQ)():a)-1,a)}e.$e_b=I}),define($e[147],pe([1,0,11,2,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(ne,e,A,C,n,U,D,S,m,p,v,I,a,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startup=void 0;const d=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,c=/\s--inspect-port=(?<port>\d+)/;class l{getHeight(E){return 22}getTemplateId(E){return W(E)?"process":B(E)?"machine":(0,m.$Mm)(E)?"error":P(E)?"header":""}}class ${hasChildren(E){return(0,m.$Mm)(E)?!1:W(E)?!!E.children?.length:!0}getChildren(E){return W(E)?E.children?E.children:[]:(0,m.$Mm)(E)?[]:P(E)?E.processRoots.length>1?E.processRoots:[E.processRoots[0].rootProcess]:B(E)?[E.rootProcess]:[E.processes]}}class f{constructor(){this.templateId="header"}renderTemplate(E){const R=(0,C.$TQ)(E,(0,C.$)(".row")),L=(0,C.$TQ)(R,(0,C.$)(".nameLabel")),G=(0,C.$TQ)(R,(0,C.$)(".cpu")),Z=(0,C.$TQ)(R,(0,C.$)(".memory")),ge=(0,C.$TQ)(R,(0,C.$)(".pid"));return{name:L,CPU:G,memory:Z,PID:ge}}renderElement(E,R,L,G){L.name.textContent=(0,A.localize)(0,null),L.CPU.textContent=(0,A.localize)(1,null),L.PID.textContent=(0,A.localize)(2,null),L.memory.textContent=(0,A.localize)(3,null)}disposeTemplate(E){}}class b{constructor(){this.templateId="machine"}renderTemplate(E){const R=Object.create(null),L=(0,C.$TQ)(E,(0,C.$)(".row"));return R.name=(0,C.$TQ)(L,(0,C.$)(".nameLabel")),R}renderElement(E,R,L,G){L.name.textContent=E.element.name}disposeTemplate(E){}}class u{constructor(){this.templateId="error"}renderTemplate(E){const R=Object.create(null),L=(0,C.$TQ)(E,(0,C.$)(".row"));return R.name=(0,C.$TQ)(L,(0,C.$)(".nameLabel")),R}renderElement(E,R,L,G){L.name.textContent=E.element.errorMessage}disposeTemplate(E){}}class N{constructor(E,R,L){this.a=E,this.b=R,this.c=L,this.templateId="process"}renderTemplate(E){const R=(0,C.$TQ)(E,(0,C.$)(".row")),L=(0,C.$TQ)(R,(0,C.$)(".nameLabel")),G=(0,C.$TQ)(R,(0,C.$)(".cpu")),Z=(0,C.$TQ)(R,(0,C.$)(".memory")),ge=(0,C.$TQ)(R,(0,C.$)(".pid"));return{name:L,CPU:G,PID:ge,memory:Z}}renderElement(E,R,L,G){const{element:Z}=E,ge=Z.pid.toFixed(0);let he=Z.name;this.c.has(Z.pid)&&(he=this.c.get(Z.pid)),L.name.textContent=he,L.name.title=Z.cmd,L.CPU.textContent=Z.load.toFixed(0),L.PID.textContent=ge,L.PID.parentElement.id=`pid-${ge}`;const ie=this.a==="win32"?Z.mem:this.b*(Z.mem/100);L.memory.textContent=(ie/p.$1k.MB).toFixed(0)}disposeTemplate(E){}}function B(H){return!!H.name&&!!H.rootProcess}function P(H){return!!H.processRoots}function W(H){return!!H.pid}class z{constructor(E,R){this.f=R,this.b=new Map;const L=new v.$7$b(E);this.c=new I.$$$b(E,L),this.k(R.styles),this.g(R),S.$O.on("vscode:pidToNameResponse",(G,Z)=>{this.b.clear();for(const[ge,he]of Z)this.b.set(ge,he)}),S.$O.on("vscode:listProcessesResponse",async(G,Z)=>{Z.forEach((ge,he)=>{W(ge.rootProcess)&&(ge.rootProcess.name=he===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Z}}),this.d.layout(s.$lP.innerHeight,s.$lP.innerWidth)):await this.h(Z),this.m(0)}),this.a=Date.now(),S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")}g(E){s.$lP.document.onkeydown=R=>{const L=E.platform==="darwin"?R.metaKey:R.ctrlKey;L&&R.keyCode===87&&(R.stopPropagation(),R.preventDefault(),S.$O.send("vscode:closeProcessExplorer")),L&&R.keyCode===187&&(0,h.$d_b)(s.$lP),L&&R.keyCode===189&&(0,h.$e_b)(s.$lP)}}async h(E){const R=s.$lP.document.getElementById("process-list");if(!R)return;const{totalmem:L}=await this.c.getOSStatistics(),G=[new N(this.f.platform,L,this.b),new f,new b,new u];this.d=new n.$kU("processExplorer",R,new l,G,new $,{identityProvider:{getId:Z=>W(Z)?Z.pid.toString():(0,m.$Mm)(Z)?Z.hostName:P(Z)?"processes":B(Z)?Z.name:"header"}}),this.d.setInput({processes:{processRoots:E}}),this.d.layout(s.$lP.innerHeight,s.$lP.innerWidth),this.d.onKeyDown(Z=>{const ge=new t.$PP(Z);if(ge.keyCode===35&&ge.altKey){const he=this.n();Promise.all(he.map(ie=>this.c.killProcess(ie,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Z=>{W(Z.element)&&this.l(Z.element,!0)}),R.style.height=`${s.$lP.innerHeight}px`,s.$lP.addEventListener("resize",()=>{R.style.height=`${s.$lP.innerHeight}px`,this.d?.layout(s.$lP.innerHeight,s.$lP.innerWidth)})}i(E){const R=d.exec(E);return R&&R.groups.port!=="0"||E.indexOf("node ")>=0||E.indexOf("node.exe")>=0}j(E){const R={type:"node",request:"attach",name:`process ${E.pid}`};let L=d.exec(E.cmd);L?R.port=Number(L.groups.port):R.processId=String(E.pid),L=c.exec(E.cmd),L&&(R.port=Number(L.groups.port)),S.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[R]})}k(E){const R=(0,C.$BQ)(),L=[];E.listFocusBackground&&(L.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${E.listFocusBackground}; }`),L.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${E.listFocusBackground}; }`)),E.listFocusForeground&&L.push(`.monaco-list:focus .monaco-list-row.focused { color: ${E.listFocusForeground}; }`),E.listActiveSelectionBackground&&(L.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${E.listActiveSelectionBackground}; }`),L.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${E.listActiveSelectionBackground}; }`)),E.listActiveSelectionForeground&&L.push(`.monaco-list:focus .monaco-list-row.selected { color: ${E.listActiveSelectionForeground}; }`),E.listHoverBackground&&L.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${E.listHoverBackground}; }`),E.listHoverForeground&&L.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${E.listHoverForeground}; }`),E.listFocusOutline&&L.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${E.listFocusOutline}; outline-offset: -1px; }`),E.listHoverOutline&&L.push(`.monaco-list-row:hover { outline: 1px dashed ${E.listHoverOutline}; outline-offset: -1px; }`),E.scrollbarShadowColor&&L.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${E.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${E.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${E.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),E.scrollbarSliderBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${E.scrollbarSliderBackgroundColor};
				}
			`),E.scrollbarSliderHoverBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${E.scrollbarSliderHoverBackgroundColor};
				}
			`),E.scrollbarSliderActiveBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${E.scrollbarSliderActiveBackgroundColor};
				}
			`),R.textContent=L.join(`
`),E.color&&(s.$lP.document.body.style.color=E.color)}l(E,R){const L=[],G=Number(E.pid);R&&(L.push({accelerator:"Alt+E",label:(0,A.localize)(4,null),click:()=>{this.c.killProcess(G,"SIGTERM")}}),L.push({label:(0,A.localize)(5,null),click:()=>{this.c.killProcess(G,"SIGKILL")}}),L.push({type:"separator"})),L.push({label:(0,A.localize)(6,null),click:()=>{const Z=this.n();Z?.includes(G)||(Z.length=0,Z.push(G));const ge=Z?.map(he=>s.$lP.document.getElementById(`pid-${he}`)).filter(he=>!!he);if(ge){const he=ge.map(ie=>ie.innerText).filter(ie=>!!ie);this.c.writeClipboardText(he.join(`
`))}}}),L.push({label:(0,A.localize)(7,null),click:()=>{const Z=s.$lP.document.getElementById("process-list");Z&&this.c.writeClipboardText(Z.innerText)}}),E&&R&&this.i(E.cmd)&&(L.push({type:"separator"}),L.push({label:(0,A.localize)(8,null),click:()=>{this.j(E)}})),(0,D.$MU)(L)}m(E){setTimeout(()=>{const R=Date.now(),L=E+R-this.a;this.a=R,L>1e3?(S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")):this.m(L)},200)}n(){return this.d?.getSelection()?.map(E=>{if(!(!E||!("pid"in E)))return E.pid}).filter(E=>!!E)}}function y(){const H=(0,C.$BQ)();H.id="codiconStyles";const E=(0,a.$KFb)(void 0);function R(){H.textContent=E.getCSS()}const L=new U.$hh(R,0);E.onDidChange(()=>L.schedule()),L.schedule()}function O(H){const E=H.data.platform==="win32"?"windows":H.data.platform==="linux"?"linux":"mac";s.$lP.document.body.classList.add(E),y(),(0,h.$c_b)(H.data.zoomLevel,s.$lP),new z(H.windowId,H.data)}e.startup=O})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/937f7b7f88cd044a6ee410bae9578259e52d4582/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
