/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","vs/base/common/htmlContent","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function($e){for(var e=[],D=0,M=$e.length;D<M;D++)e[D]=ke[$e[D]];return e};define(ke[157],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const d=new Map,P=new Map,A=new Map,w=new Map;function $(k,S){k.has(S.detail)||k.set(S.detail,-S.timestamp)}function E(k,S){const c=k.get(S.detail);c&&(c>=0||k.set(S.detail,c+S.timestamp))}let R=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(R=$e.getStats().slice(0).sort((k,S)=>k.timestamp-S.timestamp));for(const k of R)switch(k.type){case 10:$(d,k);break;case 11:case 12:E(d,k);break;case 21:$(P,k);break;case 22:E(P,k);break;case 33:$(A,k);break;case 34:E(A,k);break;case 31:$(w,k);break;case 32:E(w,k);break}let C=0;A.forEach(k=>C+=k);function p(k){const S=[];return k.forEach((c,m)=>S.push([m,c])),S}return{amdLoad:p(d),amdInvoke:p(P),nodeRequire:p(A),nodeEval:p(w),nodeRequireTotal:C}}static toMarkdownTable(d,P){let A="";const w=[];return d.forEach(($,E)=>{w[E]=$.length}),P.forEach($=>{$.forEach((E,R)=>{typeof E>"u"&&(E=$[R]="-");const C=E.toString().length;w[R]=Math.max(C,w[R])})}),d.forEach(($,E)=>{A+=`| ${$+" ".repeat(w[E]-$.toString().length)} `}),A+=`|
`,d.forEach(($,E)=>{A+=`| ${"-".repeat(w[E])} `}),A+=`|
`,P.forEach($=>{$.forEach((E,R)=>{typeof E<"u"&&(A+=`| ${E+" ".repeat(w[R]-E.toString().length)} `)}),A+=`|
`}),A}}e.$U=D}),define(ke[158],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(c,m,a){const i=M(c,m);if(i!==-1)return c[i]}e.$fb=D;function M(c,m,a=c.length-1){for(let i=a;i>=0;i--){const r=c[i];if(m(r))return i}return-1}e.$gb=M;function d(c,m){const a=P(c,m);return a===-1?void 0:c[a]}e.$hb=d;function P(c,m,a=0,i=c.length){let r=a,n=i;for(;r<n;){const o=Math.floor((r+n)/2);m(c[o])?r=o+1:n=o}return r-1}e.$ib=P;function A(c,m){const a=w(c,m);return a===c.length?void 0:c[a]}e.$jb=A;function w(c,m,a=0,i=c.length){let r=a,n=i;for(;r<n;){const o=Math.floor((r+n)/2);m(c[o])?n=o:r=o+1}return r}e.$kb=w;function $(c,m,a=0,i=c.length){const r=w(c,m,a,i);return r===c.length?-1:r}e.$lb=$;class E{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(E.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const a=P(this.e,m,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=E;function R(c,m){if(c.length===0)return;let a=c[0];for(let i=1;i<c.length;i++){const r=c[i];m(r,a)>0&&(a=r)}return a}e.$nb=R;function C(c,m){if(c.length===0)return;let a=c[0];for(let i=1;i<c.length;i++){const r=c[i];m(r,a)>=0&&(a=r)}return a}e.$ob=C;function p(c,m){return R(c,(a,i)=>-m(a,i))}e.$pb=p;function k(c,m){if(c.length===0)return-1;let a=0;for(let i=1;i<c.length;i++){const r=c[i];m(r,c[a])>0&&(a=i)}return a}e.$qb=k;function S(c,m){for(const a of c){const i=m(a);if(i!==void 0)return i}}e.$rb=S}),define(ke[74],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(A,w){const $=Object.create(null);for(const E of A){const R=w(E);let C=$[R];C||(C=$[R]=[]),C.push(E)}return $}e.$K=D;function M(A,w){const $=[],E=[];for(const R of A)w.has(R)||$.push(R);for(const R of w)A.has(R)||E.push(R);return{removed:$,added:E}}e.$L=M;function d(A,w){const $=[],E=[];for(const[R,C]of A)w.has(R)||$.push(C);for(const[R,C]of w)A.has(R)||E.push(C);return{removed:$,added:E}}e.$M=d;function P(A,w){const $=new Set;for(const E of w)A.has(E)&&$.add(E);return $}e.$N=P}),define(ke[52],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function D(A){return(w,$,E)=>{let R=null,C=null;if(typeof E.value=="function"?(R="value",C=E.value):typeof E.get=="function"&&(R="get",C=E.get),!C)throw new Error("not supported");E[R]=A(C,$)}}function M(A,w,$){let E=null,R=null;if(typeof $.value=="function"?(E="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(E="get",R=$.get),!R)throw new Error("not supported");const C=`$memoize$${w}`;$[E]=function(...p){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[C]}}e.$zh=M;function d(A,w,$){return D((E,R)=>{const C=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...k){this[p]||(this[p]=$?$():void 0),clearTimeout(this[C]),w&&(this[p]=w(this[p],...k),k=[this[p]]),this[C]=setTimeout(()=>{E.apply(this,k),this[p]=$?$():void 0},A)}})}e.$Ah=d;function P(A,w,$){return D((E,R)=>{const C=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,k=`$throttle$lastRun$${R}`,S=`$throttle$pending$${R}`;return function(...c){if(this[p]||(this[p]=$?$():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),w&&(this[p]=w(this[p],...c)),this[S])return;const m=this[k]+A;m<=Date.now()?(this[k]=Date.now(),E.apply(this,[this[p]]),this[p]=$?$():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[k]=Date.now(),E.apply(this,[this[p]]),this[p]=$?$():void 0},m-Date.now()))}})}e.$Bh=P}),define(ke[14],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(h=>{h(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function M(o){e.$X.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=M;function d(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=d;function P(o){E(o)||e.$X.onUnexpectedError(o)}e.$1=P;function A(o){E(o)||e.$X.onUnexpectedExternalError(o)}e.$2=A;function w(o){if(o instanceof Error){const{name:t,message:h}=o,s=o.stacktrace||o.stack;return{$isError:!0,name:t,message:h,stack:s,noTelemetry:r.isErrorNoTelemetry(o)}}return o}e.$3=w;const $="Canceled";function E(o){return o instanceof R?!0:o instanceof Error&&o.name===$&&o.message===$}e.$4=E;class R extends Error{constructor(){super($),this.name=this.message}}e.$5=R;function C(){const o=new Error($);return o.name=o.message,o}e.$6=C;function p(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.$7=p;function k(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.$8=k;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function c(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.$0=c;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const h=new r;return h.message=t.message,h.stack=t.stack,h}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(ke[19],Se([1,0,14,158]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function d(he,fe=0){return he[he.length-(1+fe)]}e.$sb=d;function P(he){if(he.length===0)throw new Error("Invalid tail call");return[he.slice(0,he.length-1),he[he.length-1]]}e.$tb=P;function A(he,fe,ue=(me,V)=>me===V){if(he===fe)return!0;if(!he||!fe||he.length!==fe.length)return!1;for(let me=0,V=he.length;me<V;me++)if(!ue(he[me],fe[me]))return!1;return!0}e.$ub=A;function w(he,fe){const ue=he.length-1;fe<ue&&(he[fe]=he[ue]),he.pop()}e.$vb=w;function $(he,fe,ue){return E(he.length,me=>ue(he[me],fe))}e.$wb=$;function E(he,fe){let ue=0,me=he-1;for(;ue<=me;){const V=(ue+me)/2|0,Y=fe(V);if(Y<0)ue=V+1;else if(Y>0)me=V-1;else return V}return-(ue+1)}e.$xb=E;function R(he,fe,ue){if(he=he|0,he>=fe.length)throw new TypeError("invalid index");const me=fe[Math.floor(fe.length*Math.random())],V=[],Y=[],de=[];for(const pe of fe){const Pe=ue(pe,me);Pe<0?V.push(pe):Pe>0?Y.push(pe):de.push(pe)}return he<V.length?R(he,V,ue):he<V.length+de.length?de[0]:R(he-(V.length+de.length),Y,ue)}e.$yb=R;function C(he,fe){const ue=[];let me;for(const V of he.slice(0).sort(fe))!me||fe(me[0],V)!==0?(me=[V],ue.push(me)):me.push(V);return ue}e.$zb=C;function*p(he,fe){let ue,me;for(const V of he)me!==void 0&&fe(me,V)?ue.push(V):(ue&&(yield ue),ue=[V]),me=V;ue&&(yield ue)}e.$Ab=p;function k(he,fe){for(let ue=0;ue<=he.length;ue++)fe(ue===0?void 0:he[ue-1],ue===he.length?void 0:he[ue])}e.$Bb=k;function S(he,fe){for(let ue=0;ue<he.length;ue++)fe(ue===0?void 0:he[ue-1],he[ue],ue+1===he.length?void 0:he[ue+1])}e.$Cb=S;function c(he,fe,ue){const me=[];function V(pe,Pe,ve){if(Pe===0&&ve.length===0)return;const Ce=me[me.length-1];Ce&&Ce.start+Ce.deleteCount===pe?(Ce.deleteCount+=Pe,Ce.toInsert.push(...ve)):me.push({start:pe,deleteCount:Pe,toInsert:ve})}let Y=0,de=0;for(;;){if(Y===he.length){V(Y,0,fe.slice(de));break}if(de===fe.length){V(Y,he.length-Y,[]);break}const pe=he[Y],Pe=fe[de],ve=ue(pe,Pe);ve===0?(Y+=1,de+=1):ve<0?(V(Y,1,[]),Y+=1):ve>0&&(V(Y,0,[Pe]),de+=1)}return me}e.$Db=c;function m(he,fe,ue){const me=c(he,fe,ue),V=[],Y=[];for(const de of me)V.push(...he.slice(de.start,de.start+de.deleteCount)),Y.push(...de.toInsert);return{removed:V,added:Y}}e.$Eb=m;function a(he,fe,ue){if(ue===0)return[];const me=he.slice(0,ue).sort(fe);return r(he,fe,me,ue,he.length),me}e.top=a;function i(he,fe,ue,me,V){return ue===0?Promise.resolve([]):new Promise((Y,de)=>{(async()=>{const pe=he.length,Pe=he.slice(0,ue).sort(fe);for(let ve=ue,Ce=Math.min(ue+me,pe);ve<pe;ve=Ce,Ce=Math.min(Ce+me,pe)){if(ve>ue&&await new Promise(B=>setTimeout(B)),V&&V.isCancellationRequested)throw new D.$5;r(he,fe,Pe,ve,Ce)}return Pe})().then(Y,de)})}e.$Gb=i;function r(he,fe,ue,me,V){for(const Y=ue.length;me<V;me++){const de=he[me];if(fe(de,ue[Y-1])<0){ue.pop();const pe=(0,M.$kb)(ue,Pe=>fe(de,Pe)<0);ue.splice(pe,0,de)}}}function n(he){return he.filter(fe=>!!fe)}e.$Hb=n;function o(he){let fe=0;for(let ue=0;ue<he.length;ue++)he[ue]&&(he[fe]=he[ue],fe+=1);he.length=fe}e.$Ib=o;function t(he,fe,ue){he.splice(ue,0,he.splice(fe,1)[0])}e.$Jb=t;function h(he){return!Array.isArray(he)||he.length===0}e.$Kb=h;function s(he){return Array.isArray(he)&&he.length>0}e.$Lb=s;function f(he,fe=ue=>ue){const ue=new Set;return he.filter(me=>{const V=fe(me);return ue.has(V)?!1:(ue.add(V),!0)})}e.$Mb=f;function l(he){const fe=new Set;return ue=>{const me=he(ue);return fe.has(me)?!1:(fe.add(me),!0)}}e.$Nb=l;function u(he,fe){return he.length>0?he[0]:fe}e.$Ob=u;function v(he,fe){return he.length>0?he[he.length-1]:fe}e.$Pb=v;function I(he,fe,ue=(me,V)=>me===V){let me=0;for(let V=0,Y=Math.min(he.length,fe.length);V<Y&&ue(he[V],fe[V]);V++)me++;return me}e.$Qb=I;function b(he){return[].concat(...he)}e.$Rb=b;function g(he,fe){let ue=typeof fe=="number"?he:0;typeof fe=="number"?ue=he:(ue=0,fe=he);const me=[];if(ue<=fe)for(let V=ue;V<fe;V++)me.push(V);else for(let V=ue;V>fe;V--)me.push(V);return me}e.$Sb=g;function y(he,fe,ue){return he.reduce((me,V)=>(me[fe(V)]=ue?ue(V):V,me),Object.create(null))}e.$Tb=y;function L(he,fe){return he.push(fe),()=>T(he,fe)}e.$Ub=L;function T(he,fe){const ue=he.indexOf(fe);if(ue>-1)return he.splice(ue,1),fe}e.$Vb=T;function U(he,fe,ue){const me=he.slice(0,fe),V=he.slice(fe);return me.concat(ue,V)}e.$Wb=U;function j(he,fe){let ue;if(typeof fe=="number"){let me=fe;ue=()=>{const V=Math.sin(me++)*179426549;return V-Math.floor(V)}}else ue=Math.random;for(let me=he.length-1;me>0;me-=1){const V=Math.floor(ue()*(me+1)),Y=he[me];he[me]=he[V],he[V]=Y}}e.$Xb=j;function F(he,fe){const ue=he.indexOf(fe);ue>-1&&(he.splice(ue,1),he.unshift(fe))}e.$Yb=F;function N(he,fe){const ue=he.indexOf(fe);ue>-1&&(he.splice(ue,1),he.push(fe))}e.$Zb=N;function O(he,fe){for(const ue of fe)he.push(ue)}e.$1b=O;function z(he,fe){return Array.isArray(he)?he.map(fe):fe(he)}e.$2b=z;function K(he){return Array.isArray(he)?he:[he]}e.$3b=K;function te(he){return he[Math.floor(Math.random()*he.length)]}e.$4b=te;function x(he,fe,ue){const me=Z(he,fe),V=he.length,Y=ue.length;he.length=V+Y;for(let de=V-1;de>=me;de--)he[de+Y]=he[de];for(let de=0;de<Y;de++)he[de+me]=ue[de]}e.$5b=x;function X(he,fe,ue,me){const V=Z(he,fe);let Y=he.splice(V,ue);return Y===void 0&&(Y=[]),x(he,V,me),Y}e.$6b=X;function Z(he,fe){return fe<0?Math.max(fe+he.length,0):Math.min(fe,he.length)}var ce;(function(he){function fe(Y){return Y<0}he.isLessThan=fe;function ue(Y){return Y<=0}he.isLessThanOrEqual=ue;function me(Y){return Y>0}he.isGreaterThan=me;function V(Y){return Y===0}he.isNeitherLessOrGreaterThan=V,he.greaterThan=1,he.lessThan=-1,he.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function _(he,fe){return(ue,me)=>fe(he(ue),he(me))}e.$7b=_;function ge(...he){return(fe,ue)=>{for(const me of he){const V=me(fe,ue);if(!ce.isNeitherLessOrGreaterThan(V))return V}return ce.neitherLessOrGreaterThan}}e.$8b=ge;const ne=(he,fe)=>he-fe;e.$9b=ne;const J=(he,fe)=>(0,e.$9b)(he?1:0,fe?1:0);e.$0b=J;function W(he){return(fe,ue)=>-he(fe,ue)}e.$$b=W;class re{constructor(fe){this.g=fe,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(fe){let ue=this.c;for(;ue<this.g.length&&fe(this.g[ue]);)ue++;const me=ue===this.c?null:this.g.slice(this.c,ue);return this.c=ue,me}takeFromEndWhile(fe){let ue=this.d;for(;ue>=0&&fe(this.g[ue]);)ue--;const me=ue===this.d?null:this.g.slice(ue+1,this.d+1);return this.d=ue,me}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const fe=this.g[this.c];return this.c++,fe}removeLast(){const fe=this.g[this.d];return this.d--,fe}takeCount(fe){const ue=this.g.slice(this.c,this.c+fe);return this.c+=fe,ue}}e.$_b=re;class ye{static{this.empty=new ye(fe=>{})}constructor(fe){this.iterate=fe}forEach(fe){this.iterate(ue=>(fe(ue),!0))}toArray(){const fe=[];return this.iterate(ue=>(fe.push(ue),!0)),fe}filter(fe){return new ye(ue=>this.iterate(me=>fe(me)?ue(me):!0))}map(fe){return new ye(ue=>this.iterate(me=>ue(fe(me))))}some(fe){let ue=!1;return this.iterate(me=>(ue=fe(me),!ue)),ue}findFirst(fe){let ue;return this.iterate(me=>fe(me)?(ue=me,!1):!0),ue}findLast(fe){let ue;return this.iterate(me=>(fe(me)&&(ue=me),!0)),ue}findLastMaxBy(fe){let ue,me=!0;return this.iterate(V=>((me||ce.isGreaterThan(fe(V,ue)))&&(me=!1,ue=V),!0)),ue}}e.$ac=ye}),define(ke[61],Se([1,0,14]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function M(E,R){if(!E)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=M;function d(E,R="Unreachable"){throw new Error(R)}e.$6c=d;function P(E){if(!E)throw new D.$cb("Assertion Failed")}e.$7c=P;function A(E){E||(0,D.$1)(new D.$cb("Assertion Failed"))}e.$8c=A;function w(E){if(!E()){debugger;E(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$9c=w;function $(E,R){let C=0;for(;C<E.length-1;){const p=E[C],k=E[C+1];if(!R(p,k))return!1;C++}return!0}e.$0c=$}),define(ke[75],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(M,d){const P=this;let A=!1,w;return function(){if(A)return w;if(A=!0,d)try{w=M.apply(P,arguments)}finally{d()}else w=M.apply(P,arguments);return w}}e.$db=D}),define(ke[121],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=void 0;class D{constructor(d){this.a=d,this.b=0}nextId(){return this.a+ ++this.b}}e.$uN=D,e.$vN=new D("id#")}),define(ke[53],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(M){function d(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}M.is=d;const P=Object.freeze([]);function A(){return P}M.empty=A;function*w(t){yield t}M.single=w;function $(t){return d(t)?t:w(t)}M.wrap=$;function E(t){return t||P}M.from=E;function*R(t){for(let h=t.length-1;h>=0;h--)yield t[h]}M.reverse=R;function C(t){return!t||t[Symbol.iterator]().next().done===!0}M.isEmpty=C;function p(t){return t[Symbol.iterator]().next().value}M.first=p;function k(t,h){for(const s of t)if(h(s))return!0;return!1}M.some=k;function S(t,h){for(const s of t)if(h(s))return s}M.find=S;function*c(t,h){for(const s of t)h(s)&&(yield s)}M.filter=c;function*m(t,h){let s=0;for(const f of t)yield h(f,s++)}M.map=m;function*a(...t){for(const h of t)yield*h}M.concat=a;function i(t,h,s){let f=s;for(const l of t)f=h(f,l);return f}M.reduce=i;function*r(t,h,s=t.length){for(h<0&&(h+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);h<s;h++)yield t[h]}M.slice=r;function n(t,h=Number.POSITIVE_INFINITY){const s=[];if(h===0)return[s,t];const f=t[Symbol.iterator]();for(let l=0;l<h;l++){const u=f.next();if(u.done)return[s,M.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return f}}]}M.consume=n;async function o(t){const h=[];for await(const s of t)h.push(s);return Promise.resolve(h)}M.asyncToArray=o})(D||(e.Iterable=D={}))}),define(ke[159],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var d;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function A(t,h=!1){let s=0;const f=t.length;let l="",u=0,v=16,I=0;function b(F){let N=0,O=0;for(;N<F;){const z=t.charCodeAt(s);if(z>=48&&z<=57)O=O*16+z-48;else if(z>=65&&z<=70)O=O*16+z-65+10;else if(z>=97&&z<=102)O=O*16+z-97+10;else break;s++,N++}return N<F&&(O=-1),O}function g(F){s=F,l="",u=0,v=16,I=0}function y(){const F=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&E(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&E(t.charCodeAt(s)))for(s++;s<t.length&&E(t.charCodeAt(s));)s++;else return I=3,t.substring(F,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&E(t.charCodeAt(s))){for(s++;s<t.length&&E(t.charCodeAt(s));)s++;N=s}else I=3;return t.substring(F,N)}function L(){let F="",N=s;for(;;){if(s>=f){F+=t.substring(N,s),I=2;break}const O=t.charCodeAt(s);if(O===34){F+=t.substring(N,s),s++;break}if(O===92){if(F+=t.substring(N,s),s++,s>=f){I=2;break}switch(t.charCodeAt(s++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const K=b(4);K>=0?F+=String.fromCharCode(K):I=4;break}default:I=5}N=s;continue}if(O>=0&&O<=31)if($(O)){F+=t.substring(N,s),I=2;break}else I=6;s++}return F}function T(){if(l="",I=0,u=s,s>=f)return u=f,v=17;let F=t.charCodeAt(s);if(w(F)){do s++,l+=String.fromCharCode(F),F=t.charCodeAt(s);while(w(F));return v=15}if($(F))return s++,l+=String.fromCharCode(F),F===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),v=14;switch(F){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,l=L(),v=10;case 47:{const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<f&&!$(t.charCodeAt(s));)s++;return l=t.substring(N,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const O=f-1;let z=!1;for(;s<O;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,I=1),l=t.substring(N,s),v=13}return l+=String.fromCharCode(F),s++,v=16}case 45:if(l+=String.fromCharCode(F),s++,s===f||!E(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=y(),v=11;default:for(;s<f&&U(F);)s++,F=t.charCodeAt(s);if(u!==s){switch(l=t.substring(u,s),l){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return l+=String.fromCharCode(F),s++,v=16}}function U(F){if(w(F)||$(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let F;do F=T();while(F>=12&&F<=15);return F}return{setPosition:g,getPosition:()=>s,scan:h?j:T,getToken:()=>v,getTokenValue:()=>l,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>I}}e.$dn=A;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,h){const s=[],f=new Object;let l;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function I(b,g,y,L){u.value=b,u.offset=g,u.length=y,u.type=L,u.colonOffset=void 0,l=u}try{r(t,{onObjectBegin:(b,g)=>{if(h<=b)throw f;l=void 0,v=h>b,s.push("")},onObjectProperty:(b,g,y)=>{if(h<g||(I(b,g,y,"property"),s[s.length-1]=b,h<=g+y))throw f},onObjectEnd:(b,g)=>{if(h<=b)throw f;l=void 0,s.pop()},onArrayBegin:(b,g)=>{if(h<=b)throw f;l=void 0,s.push(0)},onArrayEnd:(b,g)=>{if(h<=b)throw f;l=void 0,s.pop()},onLiteralValue:(b,g,y)=>{if(h<g||(I(b,g,y,o(b)),h<=g+y))throw f},onSeparator:(b,g,y)=>{if(h<=g)throw f;if(b===":"&&l&&l.type==="property")l.colonOffset=g,v=!1,l=void 0;else if(b===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(v=!0,s[s.length-1]=""),l=void 0}}})}catch(b){if(b!==f)throw b}return{path:s,previousNode:l,isAtPropertyKey:v,matches:b=>{let g=0;for(let y=0;g<b.length&&y<s.length;y++)if(b[g]===s[y]||b[g]==="*")g++;else if(b[g]!=="**")return!1;return g===b.length}}}e.$en=C;function p(t,h=[],s=P.DEFAULT){let f=null,l=[];const u=[];function v(b){Array.isArray(l)?l.push(b):f!==null&&(l[f]=b)}return r(t,{onObjectBegin:()=>{const b={};v(b),u.push(l),l=b,f=null},onObjectProperty:b=>{f=b},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{const b=[];v(b),u.push(l),l=b,f=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:v,onError:(b,g,y)=>{h.push({error:b,offset:g,length:y})}},s),l[0]}e.$fn=p;function k(t,h=[],s=P.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(b){f.type==="property"&&(f.length=b-f.offset,f=f.parent)}function u(b){return f.children.push(b),b}r(t,{onObjectBegin:b=>{f=u({type:"object",offset:b,length:-1,parent:f,children:[]})},onObjectProperty:(b,g,y)=>{f=u({type:"property",offset:g,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:b,offset:g,length:y,parent:f})},onObjectEnd:(b,g)=>{f.length=b+g-f.offset,f=f.parent,l(b+g)},onArrayBegin:(b,g)=>{f=u({type:"array",offset:b,length:-1,parent:f,children:[]})},onArrayEnd:(b,g)=>{f.length=b+g-f.offset,f=f.parent,l(b+g)},onLiteralValue:(b,g,y)=>{u({type:o(b),offset:g,length:y,parent:f,value:b}),l(g+y)},onSeparator:(b,g,y)=>{f.type==="property"&&(b===":"?f.colonOffset=g:b===","&&l(g))},onError:(b,g,y)=>{h.push({error:b,offset:g,length:y})}},s);const I=f.children[0];return I&&delete I.parent,I}e.$gn=k;function S(t,h){if(!t)return;let s=t;for(const f of h)if(typeof f=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===f){s=u.children[1],l=!0;break}if(!l)return}else{const l=f;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.$hn=S;function c(t){if(!t.parent||!t.parent.children)return[];const h=c(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;h.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&h.push(s)}return h}e.$in=c;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const h=Object.create(null);for(const s of t.children){const f=s.children[1];f&&(h[s.children[0].value]=m(f))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$jn=m;function a(t,h,s=!1){return h>=t.offset&&h<t.offset+t.length||s&&h===t.offset+t.length}e.$kn=a;function i(t,h,s=!1){if(a(t,h,s)){const f=t.children;if(Array.isArray(f))for(let l=0;l<f.length&&f[l].offset<=h;l++){const u=i(f[l],h,s);if(u)return u}return t}}e.$ln=i;function r(t,h,s=P.DEFAULT){const f=A(t,!1);function l(_){return _?()=>_(f.getTokenOffset(),f.getTokenLength()):()=>!0}function u(_){return _?ge=>_(ge,f.getTokenOffset(),f.getTokenLength()):()=>!0}const v=l(h.onObjectBegin),I=u(h.onObjectProperty),b=l(h.onObjectEnd),g=l(h.onArrayBegin),y=l(h.onArrayEnd),L=u(h.onLiteralValue),T=u(h.onSeparator),U=l(h.onComment),j=u(h.onError),F=s&&s.disallowComments,N=s&&s.allowTrailingComma;function O(){for(;;){const _=f.scan();switch(f.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:F||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(_){case 12:case 13:F?z(10):U();break;case 16:z(1);break;case 15:case 14:break;default:return _}}}function z(_,ge=[],ne=[]){if(j(_),ge.length+ne.length>0){let J=f.getToken();for(;J!==17;){if(ge.indexOf(J)!==-1){O();break}else if(ne.indexOf(J)!==-1)break;J=O()}}}function K(_){const ge=f.getTokenValue();return _?L(ge):I(ge),O(),!0}function te(){switch(f.getToken()){case 11:{let _=0;try{_=JSON.parse(f.getTokenValue()),typeof _!="number"&&(z(2),_=0)}catch{z(2)}L(_);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return O(),!0}function x(){return f.getToken()!==10?(z(3,[],[2,5]),!1):(K(!1),f.getToken()===6?(T(":"),O(),ce()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function X(){v(),O();let _=!1;for(;f.getToken()!==2&&f.getToken()!==17;){if(f.getToken()===5){if(_||z(4,[],[]),T(","),O(),f.getToken()===2&&N)break}else _&&z(6,[],[]);x()||z(4,[],[2,5]),_=!0}return b(),f.getToken()!==2?z(7,[2],[]):O(),!0}function Z(){g(),O();let _=!1;for(;f.getToken()!==4&&f.getToken()!==17;){if(f.getToken()===5){if(_||z(4,[],[]),T(","),O(),f.getToken()===4&&N)break}else _&&z(6,[],[]);ce()||z(4,[],[4,5]),_=!0}return y(),f.getToken()!==4?z(8,[4],[]):O(),!0}function ce(){switch(f.getToken()){case 3:return Z();case 1:return X();case 10:return K(!0);default:return te()}}return O(),f.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):ce()?(f.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.$mn=r;function n(t,h){const s=A(t),f=[];let l,u=0,v;do switch(v=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:u!==v&&f.push(t.substring(u,v)),h!==void 0&&f.push(s.getTokenValue().replace(/[^\r\n]/g,h)),u=s.getPosition();break}while(l!==17);return f.join("")}e.$nn=n;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$on=o}),define(ke[43],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(d){this.d=d,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(d){this.c=d}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ke[76],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(P){this.element=P,this.next=D.Undefined,this.prev=D.Undefined}}class M{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let P=this.a;for(;P!==D.Undefined;){const A=P.next;P.prev=D.Undefined,P.next=D.Undefined,P=A}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,A){const w=new D(P);if(this.a===D.Undefined)this.a=w,this.b=w;else if(A){const E=this.b;this.b=w,w.prev=E,E.next=w}else{const E=this.a;this.a=w,w.next=E,E.prev=w}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(w))}}shift(){if(this.a!==D.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==D.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==D.Undefined&&P.next!==D.Undefined){const A=P.prev;A.next=P.next,P.next.prev=A}else P.prev===D.Undefined&&P.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):P.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):P.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==D.Undefined;)yield P.element,P=P.next}}e.$4c=M}),define(ke[28],Se([1,0]),function($e,e){"use strict";var D,M,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(r,n,o){let t=r.get(n);return t===void 0&&(t=o,r.set(n,t)),t}e.$xc=P;function A(r){const n=[];return r.forEach((o,t)=>{n.push(`${t} => ${o}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.$yc=A;function w(r){const n=[];return r.forEach(o=>{n.push(o)}),`Set(${r.size}) {${n.join(", ")}}`}e.$zc=w;class ${constructor(n,o){this.uri=n,this.value=o}}function E(r){return Array.isArray(r)}class R{static{this.c=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof R)this.d=new Map(n.d),this.e=o??R.c;else if(E(n)){this.d=new Map,this.e=o??R.c;for(const[t,h]of n)this.set(t,h)}else this.d=new Map,this.e=n??R.c}set(n,o){return this.d.set(this.e(n),new $(n,o)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[t,h]of this.d)n(h.value,h.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=R;class C{constructor(n,o){this[M]="ResourceSet",!n||typeof n=="function"?this.c=new R(n):(this.c=new R(o),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,o){this.c.forEach((t,h)=>n.call(o,h,h,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class k{constructor(){this[d]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,o=0){const t=this.c.get(n);if(t)return o!==0&&this.l(t,o),t.value}set(n,o,t=0){let h=this.c.get(n);if(h)h.value=o,t!==0&&this.l(h,t);else{switch(h={key:n,value:o,next:void 0,previous:void 0},t){case 0:this.j(h);break;case 1:this.i(h);break;case 2:this.j(h);break;default:this.j(h);break}this.c.set(n,h),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.c.get(n);if(o)return this.c.delete(n),this.k(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,o){const t=this.g;let h=this.d;for(;h;){if(o?n.bind(o)(h.value,h.key,this):n(h.value,h.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const n=this,o=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}values(){const n=this,o=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}entries(){const n=this,o=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.d,t=this.size;for(;o&&t>n;)this.c.delete(o.key),o=o.next,t--;this.d=o,this.f=t,o&&(o.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const o=n.next,t=n.previous;if(!o||!t)throw new Error("Invalid list");o.previous=t,t.next=o}n.next=void 0,n.previous=void 0,this.g++}l(n,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.d)return;const t=n.next,h=n.previous;n===this.e?(h.next=void 0,this.e=h):(t.previous=h,h.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(o===2){if(n===this.e)return;const t=n.next,h=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=h,h.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((o,t)=>{n.push([t,o])}),n}fromJSON(n){this.clear();for(const[o,t]of n)this.set(o,t)}}e.$Cc=k;class S extends k{constructor(n,o=1){super(),this.m=n,this.n=Math.min(Math.max(0,o),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class c{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let o=this.c.get(n)||0;return o===0?!1:(o--,o===0?this.c.delete(n):this.c.set(n,o),!0)}has(n){return this.c.has(n)}}e.$Ec=c;class m{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[o,t]of n)this.set(o,t)}clear(){this.c.clear(),this.d.clear()}set(n,o){this.c.set(n,o),this.d.set(o,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const o=this.c.get(n);return o===void 0?!1:(this.c.delete(n),this.d.delete(o),!0)}forEach(n,o){this.c.forEach((t,h)=>{n.call(o,t,h,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=m;class a{constructor(){this.c=new Map}add(n,o){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(o)}delete(n,o){const t=this.c.get(n);t&&(t.delete(o),t.size===0&&this.c.delete(n))}forEach(n,o){const t=this.c.get(n);t&&t.forEach(o)}get(n){const o=this.c.get(n);return o||new Set}}e.$Gc=a;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[o,t]of r)if(!n.has(o)||n.get(o)!==t)return!1;for(const[o]of n)if(!r.has(o))return!1;return!0}e.$Hc=i}),define(ke[3],Se([1,0,19,74,28,75,53]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const w=!1;let $=null;class E{constructor(){this.b=new Map}static{this.a=0}c(L){let T=this.b.get(L);return T||(T={parent:null,source:null,isSingleton:!1,value:L,idx:E.a++},this.b.set(L,T)),T}trackDisposable(L){const T=this.c(L);T.source||(T.source=new Error().stack)}setParent(L,T){const U=this.c(L);U.parent=T}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,T){const U=T.get(L);if(U)return U;const j=L.parent?this.f(this.c(L.parent),T):L;return T.set(L,j),j}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,L).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(L=10,T){let U;if(T)U=T;else{const z=new Map,K=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,z).isSingleton);if(K.length===0)return;const te=new Set(K.map(x=>x.value));if(U=K.filter(x=>!(x.parent&&te.has(x.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function j(z){function K(x,X){for(;x.length>0&&X.some(Z=>typeof Z=="string"?Z===x[0]:x[0].match(Z));)x.shift()}const te=z.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return K(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const F=new d.$Gc;for(const z of U){const K=j(z);for(let te=0;te<=K.length;te++)F.add(K.slice(0,te).join(`
`),z)}U.sort((0,D.$7b)(z=>z.idx,D.$9b));let N="",O=0;for(const z of U.slice(0,L)){O++;const K=j(z),te=[];for(let x=0;x<K.length;x++){let X=K[x];X=`(shared with ${F.get(K.slice(0,x+1).join(`
`)).size}/${U.length} leaks) at ${X}`;const ce=F.get(K.slice(0,x).join(`
`)),_=(0,M.$K)([...ce].map(ge=>j(ge)[x]),ge=>ge);delete _[K[x]];for(const[ge,ne]of Object.entries(_))te.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${ge}`);te.unshift(X)}N+=`


==================== Leaking disposable ${O}/${U.length}: ${z.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return U.length>L&&(N+=`


... and ${U.length-L} more leaking disposables

`),{leaks:U,details:N}}}e.$Ic=E;function R(y){$=y}if(e.$Jc=R,w){const y="__is_disposable_tracked__";R(new class{trackDisposable(L){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[y]||console.log(T)},3e3)}setParent(L,T){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsDisposed(L){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsSingleton(L){}})}function C(y){return $?.trackDisposable(y),y}e.$Kc=C;function p(y){$?.markAsDisposed(y)}e.$Lc=p;function k(y,L){$?.setParent(y,L)}function S(y,L){if($)for(const T of y)$.setParent(T,L)}function c(y){return $?.markAsSingleton(y),y}e.$Mc=c;function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=m;function a(y){if(A.Iterable.is(y)){const L=[];for(const T of y)if(T)try{T.dispose()}catch(U){L.push(U)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=a;function i(y){for(const L of y)m(L)&&L.dispose();return[]}e.$Pc=i;function r(...y){const L=n(()=>a(y));return S(y,L),L}e.$Qc=r;function n(y){const L=C({dispose:(0,P.$db)(()=>{p(L),y()})});return L}e.$Rc=n;class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return k(L,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),k(L,null))}}e.$Sc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,C(this),k(this.q,this)}dispose(){p(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Tc=t;class h{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&k(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&k(L,null),L}}e.$Uc=h;class s{constructor(L){this.a=new h,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class f{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=f;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(L){let T=L;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,p(this))},this}}e.$Xc=l;class u{constructor(){this.a=new Map}acquire(L,...T){let U=this.a.get(L);U||(U={counter:0,object:this.b(L,...T)},this.a.set(L,U));const{object:j}=U,F=(0,P.$db)(()=>{--U.counter===0&&(this.c(L,U.object),this.a.delete(L))});return U.counter++,{object:j,dispose:F}}}e.$Yc=u;class v{constructor(L){this.a=L}async acquire(L,...T){const U=this.a.acquire(L,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(j){throw U.dispose(),j}}}e.$Zc=v;class I{constructor(L){this.object=L}dispose(){}}e.$1c=I;function b(y){const L=new o;try{y(L)}finally{L.dispose()}}e.$2c=b;class g{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,T,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(L)?.dispose(),this.a.set(L,T)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=g}),function($e,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(fe,ue){for(var me=0;me<ue.length;me++){var V=ue[me];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(fe,V.key,V)}}function D(fe,ue,me){return ue&&e(fe.prototype,ue),me&&e(fe,me),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function M(fe,ue){if(fe){if(typeof fe=="string")return d(fe,ue);var me=Object.prototype.toString.call(fe).slice(8,-1);if(me==="Object"&&fe.constructor&&(me=fe.constructor.name),me==="Map"||me==="Set")return Array.from(fe);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return d(fe,ue)}}function d(fe,ue){(ue==null||ue>fe.length)&&(ue=fe.length);for(var me=0,V=new Array(ue);me<ue;me++)V[me]=fe[me];return V}function P(fe,ue){var me=typeof Symbol<"u"&&fe[Symbol.iterator]||fe["@@iterator"];if(me)return(me=me.call(fe)).next.bind(me);if(Array.isArray(fe)||(me=M(fe))||ue&&fe&&typeof fe.length=="number"){me&&(fe=me);var V=0;return function(){return V>=fe.length?{done:!0}:{done:!1,value:fe[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function w(fe){$e.defaults=fe}var $=/[&<>"']/,E=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ue){return p[ue]};function S(fe,ue){if(ue){if($.test(fe))return fe.replace(E,k)}else if(R.test(fe))return fe.replace(C,k);return fe}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(fe){return fe.replace(c,function(ue,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var a=/(^|[^\[])\^/g;function i(fe,ue){fe=typeof fe=="string"?fe:fe.source,ue=ue||"";var me={replace:function(Y,de){return de=de.source||de,de=de.replace(a,"$1"),fe=fe.replace(Y,de),me},getRegex:function(){return new RegExp(fe,ue)}};return me}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(fe,ue,me){if(fe){var V;try{V=decodeURIComponent(m(me)).replace(r,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}ue&&!n.test(me)&&(me=l(ue,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var t={},h=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(fe,ue){t[" "+fe]||(h.test(fe)?t[" "+fe]=fe+"/":t[" "+fe]=b(fe,"/",!0)),fe=t[" "+fe];var me=fe.indexOf(":")===-1;return ue.substring(0,2)==="//"?me?ue:fe.replace(s,"$1")+ue:ue.charAt(0)==="/"?me?ue:fe.replace(f,"$1")+ue:fe+ue}var u={exec:function(){}};function v(fe){for(var ue=1,me,V;ue<arguments.length;ue++){me=arguments[ue];for(V in me)Object.prototype.hasOwnProperty.call(me,V)&&(fe[V]=me[V])}return fe}function I(fe,ue){var me=fe.replace(/\|/g,function(de,pe,Pe){for(var ve=!1,Ce=pe;--Ce>=0&&Pe[Ce]==="\\";)ve=!ve;return ve?"|":" |"}),V=me.split(/ \|/),Y=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>ue)V.splice(ue);else for(;V.length<ue;)V.push("");for(;Y<V.length;Y++)V[Y]=V[Y].trim().replace(/\\\|/g,"|");return V}function b(fe,ue,me){var V=fe.length;if(V===0)return"";for(var Y=0;Y<V;){var de=fe.charAt(V-Y-1);if(de===ue&&!me)Y++;else if(de!==ue&&me)Y++;else break}return fe.slice(0,V-Y)}function g(fe,ue){if(fe.indexOf(ue[1])===-1)return-1;for(var me=fe.length,V=0,Y=0;Y<me;Y++)if(fe[Y]==="\\")Y++;else if(fe[Y]===ue[0])V++;else if(fe[Y]===ue[1]&&(V--,V<0))return Y;return-1}function y(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(fe,ue){if(ue<1)return"";for(var me="";ue>1;)ue&1&&(me+=fe),ue>>=1,fe+=fe;return me+fe}function T(fe,ue,me,V){var Y=ue.href,de=ue.title?S(ue.title):null,pe=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){V.state.inLink=!0;var Pe={type:"link",raw:me,href:Y,title:de,text:pe,tokens:V.inlineTokens(pe)};return V.state.inLink=!1,Pe}return{type:"image",raw:me,href:Y,title:de,text:S(pe)}}function U(fe,ue){var me=fe.match(/^(\s+)(?:```)/);if(me===null)return ue;var V=me[1];return ue.split(`
`).map(function(Y){var de=Y.match(/^\s+/);if(de===null)return Y;var pe=de[0];return pe.length>=V.length?Y.slice(V.length):Y}).join(`
`)}var j=function(){function fe(me){this.options=me||$e.defaults}var ue=fe.prototype;return ue.space=function(V){var Y=this.rules.block.newline.exec(V);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},ue.code=function(V){var Y=this.rules.block.code.exec(V);if(Y){var de=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?de:b(de,`
`)}}},ue.fences=function(V){var Y=this.rules.block.fences.exec(V);if(Y){var de=Y[0],pe=U(de,Y[3]||"");return{type:"code",raw:de,lang:Y[2]?Y[2].trim():Y[2],text:pe}}},ue.heading=function(V){var Y=this.rules.block.heading.exec(V);if(Y){var de=Y[2].trim();if(/#$/.test(de)){var pe=b(de,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(de=pe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:de,tokens:this.lexer.inline(de)}}},ue.hr=function(V){var Y=this.rules.block.hr.exec(V);if(Y)return{type:"hr",raw:Y[0]}},ue.blockquote=function(V){var Y=this.rules.block.blockquote.exec(V);if(Y){var de=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(de,[]),text:de}}},ue.list=function(V){var Y=this.rules.block.list.exec(V);if(Y){var de,pe,Pe,ve,Ce,B,Q,ee,H,oe,le,Re,je=Y[1].trim(),He=je.length>1,Qe={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(Re=!1,!(!(Y=_e.exec(V))||this.rules.block.hr.test(V)));){if(de=Y[0],V=V.substring(de.length),ee=Y[2].split(`
`,1)[0],H=V.split(`
`,1)[0],this.options.pedantic?(ve=2,le=ee.trimLeft()):(ve=Y[2].search(/[^ ]/),ve=ve>4?1:ve,le=ee.slice(ve),ve+=Y[1].length),B=!1,!ee&&/^ *$/.test(H)&&(de+=H+`
`,V=V.substring(H.length+1),Re=!0),!Re)for(var at=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),Le=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");V&&(oe=V.split(`
`,1)[0],ee=oe,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(ee)||Le.test(ee)||at.test(ee)||st.test(V)));){if(ee.search(/[^ ]/)>=ve||!ee.trim())le+=`
`+ee.slice(ve);else if(!B)le+=`
`+ee;else break;!B&&!ee.trim()&&(B=!0),de+=oe+`
`,V=V.substring(oe.length+1)}Qe.loose||(Q?Qe.loose=!0:/\n *\n *$/.test(de)&&(Q=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(le),pe&&(Pe=pe[0]!=="[ ] ",le=le.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:de,task:!!pe,checked:Pe,loose:!1,text:le}),Qe.raw+=de}Qe.items[Qe.items.length-1].raw=de.trimRight(),Qe.items[Qe.items.length-1].text=le.trimRight(),Qe.raw=Qe.raw.trimRight();var ze=Qe.items.length;for(Ce=0;Ce<ze;Ce++){this.lexer.state.top=!1,Qe.items[Ce].tokens=this.lexer.blockTokens(Qe.items[Ce].text,[]);var Ae=Qe.items[Ce].tokens.filter(function(ie){return ie.type==="space"}),Ze=Ae.every(function(ie){for(var se=ie.raw.split(""),Ie=0,qe=P(se),Ye;!(Ye=qe()).done;){var it=Ye.value;if(it===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Qe.loose&&Ae.length&&Ze&&(Qe.loose=!0,Qe.items[Ce].loose=!0)}return Qe}},ue.html=function(V){var Y=this.rules.block.html.exec(V);if(Y){var de={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(Y[0]):S(Y[0]);de.type="paragraph",de.text=pe,de.tokens=this.lexer.inline(pe)}return de}},ue.def=function(V){var Y=this.rules.block.def.exec(V);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var de=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:de,raw:Y[0],href:Y[2],title:Y[3]}}},ue.table=function(V){var Y=this.rules.block.table.exec(V);if(Y){var de={type:"table",header:I(Y[1]).map(function(Q){return{text:Q}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=Y[0];var pe=de.align.length,Pe,ve,Ce,B;for(Pe=0;Pe<pe;Pe++)/^ *-+: *$/.test(de.align[Pe])?de.align[Pe]="right":/^ *:-+: *$/.test(de.align[Pe])?de.align[Pe]="center":/^ *:-+ *$/.test(de.align[Pe])?de.align[Pe]="left":de.align[Pe]=null;for(pe=de.rows.length,Pe=0;Pe<pe;Pe++)de.rows[Pe]=I(de.rows[Pe],de.header.length).map(function(Q){return{text:Q}});for(pe=de.header.length,ve=0;ve<pe;ve++)de.header[ve].tokens=this.lexer.inline(de.header[ve].text);for(pe=de.rows.length,ve=0;ve<pe;ve++)for(B=de.rows[ve],Ce=0;Ce<B.length;Ce++)B[Ce].tokens=this.lexer.inline(B[Ce].text);return de}}},ue.lheading=function(V){var Y=this.rules.block.lheading.exec(V);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},ue.paragraph=function(V){var Y=this.rules.block.paragraph.exec(V);if(Y){var de=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:de,tokens:this.lexer.inline(de)}}},ue.text=function(V){var Y=this.rules.block.text.exec(V);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},ue.escape=function(V){var Y=this.rules.inline.escape.exec(V);if(Y)return{type:"escape",raw:Y[0],text:S(Y[1])}},ue.tag=function(V){var Y=this.rules.inline.tag.exec(V);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):S(Y[0]):Y[0]}},ue.link=function(V){var Y=this.rules.inline.link.exec(V);if(Y){var de=Y[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var pe=b(de.slice(0,-1),"\\");if((de.length-pe.length)%2===0)return}else{var Pe=g(Y[2],"()");if(Pe>-1){var ve=Y[0].indexOf("!")===0?5:4,Ce=ve+Y[1].length+Pe;Y[2]=Y[2].substring(0,Pe),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var B=Y[2],Q="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);ee&&(B=ee[1],Q=ee[3])}else Q=Y[3]?Y[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(de)?B=B.slice(1):B=B.slice(1,-1)),T(Y,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},ue.reflink=function(V,Y){var de;if((de=this.rules.inline.reflink.exec(V))||(de=this.rules.inline.nolink.exec(V))){var pe=(de[2]||de[1]).replace(/\s+/g," ");if(pe=Y[pe.toLowerCase()],!pe||!pe.href){var Pe=de[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return T(de,pe,de[0],this.lexer)}},ue.emStrong=function(V,Y,de){de===void 0&&(de="");var pe=this.rules.inline.emStrong.lDelim.exec(V);if(pe&&!(pe[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=pe[1]||pe[2]||"";if(!Pe||Pe&&(de===""||this.rules.inline.punctuation.exec(de))){var ve=pe[0].length-1,Ce,B,Q=ve,ee=0,H=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,Y=Y.slice(-1*V.length+ve);(pe=H.exec(Y))!=null;)if(Ce=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Ce){if(B=Ce.length,pe[3]||pe[4]){Q+=B;continue}else if((pe[5]||pe[6])&&ve%3&&!((ve+B)%3)){ee+=B;continue}if(Q-=B,!(Q>0)){if(B=Math.min(B,B+Q+ee),Math.min(ve,B)%2){var oe=V.slice(1,ve+pe.index+B);return{type:"em",raw:V.slice(0,ve+pe.index+B+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}var le=V.slice(2,ve+pe.index+B-1);return{type:"strong",raw:V.slice(0,ve+pe.index+B+1),text:le,tokens:this.lexer.inlineTokens(le)}}}}}},ue.codespan=function(V){var Y=this.rules.inline.code.exec(V);if(Y){var de=Y[2].replace(/\n/g," "),pe=/[^ ]/.test(de),Pe=/^ /.test(de)&&/ $/.test(de);return pe&&Pe&&(de=de.substring(1,de.length-1)),de=S(de,!0),{type:"codespan",raw:Y[0],text:de}}},ue.br=function(V){var Y=this.rules.inline.br.exec(V);if(Y)return{type:"br",raw:Y[0]}},ue.del=function(V){var Y=this.rules.inline.del.exec(V);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},ue.autolink=function(V,Y){var de=this.rules.inline.autolink.exec(V);if(de){var pe,Pe;return de[2]==="@"?(pe=S(this.options.mangle?Y(de[1]):de[1]),Pe="mailto:"+pe):(pe=S(de[1]),Pe=pe),{type:"link",raw:de[0],text:pe,href:Pe,tokens:[{type:"text",raw:pe,text:pe}]}}},ue.url=function(V,Y){var de;if(de=this.rules.inline.url.exec(V)){var pe,Pe;if(de[2]==="@")pe=S(this.options.mangle?Y(de[0]):de[0]),Pe="mailto:"+pe;else{var ve;do ve=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(ve!==de[0]);pe=S(de[0]),de[1]==="www."?Pe="http://"+pe:Pe=pe}return{type:"link",raw:de[0],text:pe,href:Pe,tokens:[{type:"text",raw:pe,text:pe}]}}},ue.inlineText=function(V,Y){var de=this.rules.inline.text.exec(V);if(de){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):S(de[0]):de[0]:pe=S(this.options.smartypants?Y(de[0]):de[0]),{type:"text",raw:de[0],text:pe}}},fe}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=i(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=i(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=i(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=i(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=i(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=v({},F),F.gfm=v({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=i(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=v({},F.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:i(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(F._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",F._label).getRegex(),N.nolink=i(N.nolink).replace("ref",F._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=v({},N),N.pedantic=v({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=v({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=v({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(fe){var ue="",me,V,Y=fe.length;for(me=0;me<Y;me++)V=fe.charCodeAt(me),Math.random()>.5&&(V="x"+V.toString(16)),ue+="&#"+V+";";return ue}var K=function(){function fe(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||$e.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:F.normal,inline:N.normal};this.options.pedantic?(V.block=F.pedantic,V.inline=N.pedantic):this.options.gfm&&(V.block=F.gfm,this.options.breaks?V.inline=N.breaks:V.inline=N.gfm),this.tokenizer.rules=V}fe.lex=function(V,Y){var de=new fe(Y);return de.lex(V)},fe.lexInline=function(V,Y){var de=new fe(Y);return de.inlineTokens(V)};var ue=fe.prototype;return ue.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},ue.blockTokens=function(V,Y){var de=this;Y===void 0&&(Y=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(Q,ee,H){return ee+"    ".repeat(H.length)});for(var pe,Pe,ve,Ce;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(pe=Q.call({lexer:de},V,Y))?(V=V.substring(pe.raw.length),Y.push(pe),!0):!1}))){if(pe=this.tokenizer.space(V)){V=V.substring(pe.raw.length),pe.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(pe);continue}if(pe=this.tokenizer.code(V)){V=V.substring(pe.raw.length),Pe=Y[Y.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(pe);continue}if(pe=this.tokenizer.fences(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.heading(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.hr(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.blockquote(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.list(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.html(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.def(V)){V=V.substring(pe.raw.length),Pe=Y[Y.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.lheading(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(ve=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,ee=V.slice(1),H=void 0;de.options.extensions.startBlock.forEach(function(oe){H=oe.call({lexer:this},ee),typeof H=="number"&&H>=0&&(Q=Math.min(Q,H))}),Q<1/0&&Q>=0&&(ve=V.substring(0,Q+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(ve))){Pe=Y[Y.length-1],Ce&&Pe.type==="paragraph"?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(pe),Ce=ve.length!==V.length,V=V.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(V)){V=V.substring(pe.raw.length),Pe=Y[Y.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+pe.raw,Pe.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(pe);continue}if(V){var B="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,Y},ue.inline=function(V,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:V,tokens:Y}),Y},ue.inlineTokens=function(V,Y){var de=this;Y===void 0&&(Y=[]);var pe,Pe,ve,Ce=V,B,Q,ee;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)H.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,B.index)+"["+L("a",B[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,B.index)+"["+L("a",B[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,B.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(Q||(ee=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(pe=le.call({lexer:de},V,Y))?(V=V.substring(pe.raw.length),Y.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.tag(V)){V=V.substring(pe.raw.length),Pe=Y[Y.length-1],Pe&&pe.type==="text"&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):Y.push(pe);continue}if(pe=this.tokenizer.link(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(pe.raw.length),Pe=Y[Y.length-1],Pe&&pe.type==="text"&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):Y.push(pe);continue}if(pe=this.tokenizer.emStrong(V,Ce,ee)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.codespan(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.br(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.del(V)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.autolink(V,z)){V=V.substring(pe.raw.length),Y.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(V,z))){V=V.substring(pe.raw.length),Y.push(pe);continue}if(ve=V,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,Re=V.slice(1),je=void 0;de.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Re),typeof je=="number"&&je>=0&&(le=Math.min(le,je))}),le<1/0&&le>=0&&(ve=V.substring(0,le+1))}(),pe=this.tokenizer.inlineText(ve,O)){V=V.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(ee=pe.raw.slice(-1)),Q=!0,Pe=Y[Y.length-1],Pe&&Pe.type==="text"?(Pe.raw+=pe.raw,Pe.text+=pe.text):Y.push(pe);continue}if(V){var oe="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return Y},D(fe,null,[{key:"rules",get:function(){return{block:F,inline:N}}}]),fe}(),te=function(){function fe(me){this.options=me||$e.defaults}var ue=fe.prototype;return ue.code=function(V,Y,de){var pe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(V,pe);Pe!=null&&Pe!==V&&(de=!0,V=Pe)}return V=V.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+S(pe,!0)+'">'+(de?V:S(V,!0))+`</code></pre>
`:"<pre><code>"+(de?V:S(V,!0))+`</code></pre>
`},ue.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},ue.html=function(V){return V},ue.heading=function(V,Y,de,pe){if(this.options.headerIds){var Pe=this.options.headerPrefix+pe.slug(de);return"<h"+Y+' id="'+Pe+'">'+V+"</h"+Y+`>
`}return"<h"+Y+">"+V+"</h"+Y+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(V,Y,de){var pe=Y?"ol":"ul",Pe=Y&&de!==1?' start="'+de+'"':"";return"<"+pe+Pe+`>
`+V+"</"+pe+`>
`},ue.listitem=function(V){return"<li>"+V+`</li>
`},ue.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(V){return"<p>"+V+`</p>
`},ue.table=function(V,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Y+`</table>
`},ue.tablerow=function(V){return`<tr>
`+V+`</tr>
`},ue.tablecell=function(V,Y){var de=Y.header?"th":"td",pe=Y.align?"<"+de+' align="'+Y.align+'">':"<"+de+">";return pe+V+("</"+de+`>
`)},ue.strong=function(V){return"<strong>"+V+"</strong>"},ue.em=function(V){return"<em>"+V+"</em>"},ue.codespan=function(V){return"<code>"+V+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(V){return"<del>"+V+"</del>"},ue.link=function(V,Y,de){if(V=o(this.options.sanitize,this.options.baseUrl,V),V===null)return de;var pe='<a href="'+S(V)+'"';return Y&&(pe+=' title="'+Y+'"'),pe+=">"+de+"</a>",pe},ue.image=function(V,Y,de){if(V=o(this.options.sanitize,this.options.baseUrl,V),V===null)return de;var pe='<img src="'+V+'" alt="'+de+'"';return Y&&(pe+=' title="'+Y+'"'),pe+=this.options.xhtml?"/>":">",pe},ue.text=function(V){return V},fe}(),x=function(){function fe(){}var ue=fe.prototype;return ue.strong=function(V){return V},ue.em=function(V){return V},ue.codespan=function(V){return V},ue.del=function(V){return V},ue.html=function(V){return V},ue.text=function(V){return V},ue.link=function(V,Y,de){return""+de},ue.image=function(V,Y,de){return""+de},ue.br=function(){return""},fe}(),X=function(){function fe(){this.seen={}}var ue=fe.prototype;return ue.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(V,Y){var de=V,pe=0;if(this.seen.hasOwnProperty(de)){pe=this.seen[V];do pe++,de=V+"-"+pe;while(this.seen.hasOwnProperty(de))}return Y||(this.seen[V]=pe,this.seen[de]=0),de},ue.slug=function(V,Y){Y===void 0&&(Y={});var de=this.serialize(V);return this.getNextSafeSlug(de,Y.dryrun)},fe}(),Z=function(){function fe(me){this.options=me||$e.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new X}fe.parse=function(V,Y){var de=new fe(Y);return de.parse(V)},fe.parseInline=function(V,Y){var de=new fe(Y);return de.parseInline(V)};var ue=fe.prototype;return ue.parse=function(V,Y){Y===void 0&&(Y=!0);var de="",pe,Pe,ve,Ce,B,Q,ee,H,oe,le,Re,je,He,Qe,_e,at,st,rt,Le,ze=V.length;for(pe=0;pe<ze;pe++){if(le=V[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(Le=this.options.extensions.renderers[le.type].call({parser:this},le),Le!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){de+=Le||"";continue}switch(le.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(le.tokens),le.depth,m(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(H="",ee="",Ce=le.header.length,Pe=0;Pe<Ce;Pe++)ee+=this.renderer.tablecell(this.parseInline(le.header[Pe].tokens),{header:!0,align:le.align[Pe]});for(H+=this.renderer.tablerow(ee),oe="",Ce=le.rows.length,Pe=0;Pe<Ce;Pe++){for(Q=le.rows[Pe],ee="",B=Q.length,ve=0;ve<B;ve++)ee+=this.renderer.tablecell(this.parseInline(Q[ve].tokens),{header:!1,align:le.align[ve]});oe+=this.renderer.tablerow(ee)}de+=this.renderer.table(H,oe);continue}case"blockquote":{oe=this.parse(le.tokens),de+=this.renderer.blockquote(oe);continue}case"list":{for(Re=le.ordered,je=le.start,He=le.loose,Ce=le.items.length,oe="",Pe=0;Pe<Ce;Pe++)_e=le.items[Pe],at=_e.checked,st=_e.task,Qe="",_e.task&&(rt=this.renderer.checkbox(at),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Qe+=rt),Qe+=this.parse(_e.tokens,He),oe+=this.renderer.listitem(Qe,st,at);de+=this.renderer.list(oe,Re,je);continue}case"html":{de+=this.renderer.html(le.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(oe=le.tokens?this.parseInline(le.tokens):le.text;pe+1<ze&&V[pe+1].type==="text";)le=V[++pe],oe+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);de+=Y?this.renderer.paragraph(oe):oe;continue}default:{var Ae='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return de},ue.parseInline=function(V,Y){Y=Y||this.renderer;var de="",pe,Pe,ve,Ce=V.length;for(pe=0;pe<Ce;pe++){if(Pe=V[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(ve=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){de+=ve||"";continue}switch(Pe.type){case"escape":{de+=Y.text(Pe.text);break}case"html":{de+=Y.html(Pe.text);break}case"link":{de+=Y.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,Y));break}case"image":{de+=Y.image(Pe.href,Pe.title,Pe.text);break}case"strong":{de+=Y.strong(this.parseInline(Pe.tokens,Y));break}case"em":{de+=Y.em(this.parseInline(Pe.tokens,Y));break}case"codespan":{de+=Y.codespan(Pe.text);break}case"br":{de+=Y.br();break}case"del":{de+=Y.del(this.parseInline(Pe.tokens,Y));break}case"text":{de+=Y.text(Pe.text);break}default:{var B='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return de},fe}();function ce(fe,ue,me){if(typeof fe>"u"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof ue=="function"&&(me=ue,ue=null),ue=v({},ce.defaults,ue||{}),y(ue),me){var V=ue.highlight,Y;try{Y=K.lex(fe,ue)}catch(Ce){return me(Ce)}var de=function(B){var Q;if(!B)try{ue.walkTokens&&ce.walkTokens(Y,ue.walkTokens),Q=Z.parse(Y,ue)}catch(ee){B=ee}return ue.highlight=V,B?me(B):me(null,Q)};if(!V||V.length<3||(delete ue.highlight,!Y.length))return de();var pe=0;ce.walkTokens(Y,function(Ce){Ce.type==="code"&&(pe++,setTimeout(function(){V(Ce.text,Ce.lang,function(B,Q){if(B)return de(B);Q!=null&&Q!==Ce.text&&(Ce.text=Q,Ce.escaped=!0),pe--,pe===0&&de()})},0))}),pe===0&&de();return}function Pe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(Ce.message+"",!0)+"</pre>";throw Ce}try{var ve=K.lex(fe,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ce.walkTokens(ve,ue.walkTokens)).then(function(){return Z.parse(ve,ue)}).catch(Pe);ce.walkTokens(ve,ue.walkTokens)}return Z.parse(ve,ue)}catch(Ce){Pe(Ce)}}ce.options=ce.setOptions=function(fe){return v(ce.defaults,fe),w(ce.defaults),ce},ce.getDefaults=A,ce.defaults=$e.defaults,ce.use=function(){for(var fe=arguments.length,ue=new Array(fe),me=0;me<fe;me++)ue[me]=arguments[me];var V=v.apply(void 0,[{}].concat(ue)),Y=ce.defaults.extensions||{renderers:{},childTokens:{}},de;ue.forEach(function(pe){if(pe.extensions&&(de=!0,pe.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var Ce=Y.renderers?Y.renderers[ve.name]:null;Ce?Y.renderers[ve.name]=function(){for(var B=arguments.length,Q=new Array(B),ee=0;ee<B;ee++)Q[ee]=arguments[ee];var H=ve.renderer.apply(this,Q);return H===!1&&(H=Ce.apply(this,Q)),H}:Y.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[ve.level]?Y[ve.level].unshift(ve.tokenizer):Y[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?Y.startBlock?Y.startBlock.push(ve.start):Y.startBlock=[ve.start]:ve.level==="inline"&&(Y.startInline?Y.startInline.push(ve.start):Y.startInline=[ve.start]))}ve.childTokens&&(Y.childTokens[ve.name]=ve.childTokens)})),pe.renderer&&function(){var ve=ce.defaults.renderer||new te,Ce=function(ee){var H=ve[ee];ve[ee]=function(){for(var oe=arguments.length,le=new Array(oe),Re=0;Re<oe;Re++)le[Re]=arguments[Re];var je=pe.renderer[ee].apply(ve,le);return je===!1&&(je=H.apply(ve,le)),je}};for(var B in pe.renderer)Ce(B);V.renderer=ve}(),pe.tokenizer&&function(){var ve=ce.defaults.tokenizer||new j,Ce=function(ee){var H=ve[ee];ve[ee]=function(){for(var oe=arguments.length,le=new Array(oe),Re=0;Re<oe;Re++)le[Re]=arguments[Re];var je=pe.tokenizer[ee].apply(ve,le);return je===!1&&(je=H.apply(ve,le)),je}};for(var B in pe.tokenizer)Ce(B);V.tokenizer=ve}(),pe.walkTokens){var Pe=ce.defaults.walkTokens;V.walkTokens=function(ve){var Ce=[];return Ce.push(pe.walkTokens.call(this,ve)),Pe&&(Ce=Ce.concat(Pe.call(this,ve))),Ce}}de&&(V.extensions=Y),ce.setOptions(V)})},ce.walkTokens=function(fe,ue){for(var me=[],V=function(){var Pe=de.value;switch(me=me.concat(ue.call(ce,Pe)),Pe.type){case"table":{for(var ve=P(Pe.header),Ce;!(Ce=ve()).done;){var B=Ce.value;me=me.concat(ce.walkTokens(B.tokens,ue))}for(var Q=P(Pe.rows),ee;!(ee=Q()).done;)for(var H=ee.value,oe=P(H),le;!(le=oe()).done;){var Re=le.value;me=me.concat(ce.walkTokens(Re.tokens,ue))}break}case"list":{me=me.concat(ce.walkTokens(Pe.items,ue));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Pe.type]?ce.defaults.extensions.childTokens[Pe.type].forEach(function(je){me=me.concat(ce.walkTokens(Pe[je],ue))}):Pe.tokens&&(me=me.concat(ce.walkTokens(Pe.tokens,ue)))}},Y=P(fe),de;!(de=Y()).done;)V();return me},ce.parseInline=function(fe,ue){if(typeof fe>"u"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");ue=v({},ce.defaults,ue||{}),y(ue);try{var me=K.lexInline(fe,ue);return ue.walkTokens&&ce.walkTokens(me,ue.walkTokens),Z.parseInline(me,ue)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(V.message+"",!0)+"</pre>";throw V}},ce.Parser=Z,ce.parser=Z.parse,ce.Renderer=te,ce.TextRenderer=x,ce.Lexer=K,ce.lexer=K.lex,ce.Tokenizer=j,ce.Slugger=X,ce.parse=ce;var _=ce.options,ge=ce.setOptions,ne=ce.use,J=ce.walkTokens,W=ce.parseInline,re=ce,ye=Z.parse,he=K.lex;$e.Lexer=K,$e.Parser=Z,$e.Renderer=te,$e.Slugger=X,$e.TextRenderer=x,$e.Tokenizer=j,$e.getDefaults=A,$e.lexer=he,$e.marked=ce,$e.options=_,$e.parse=re,$e.parseInline=W,$e.parser=ye,$e.setOptions=ge,$e.use=ne,$e.walkTokens=J,Object.defineProperty($e,"__esModule",{value:!0})}),define(ke[161],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=void 0;function D(c){const m=P(c);if(m&&m.length>0)return new Uint32Array(m)}e.$Tj=D;let M=0;const d=new Uint32Array(10);function P(c){if(M=0,A(c,C,4352),M>0||(A(c,p,4449),M>0)||(A(c,k,4520),M>0)||(A(c,S,12593),M))return d.subarray(0,M);if(c>=44032&&c<=55203){const m=c-44032,a=m%588,i=Math.floor(m/588),r=Math.floor(a/28),n=a%28-1;if(i<C.length?A(i,C,0):4352+i-12593<S.length&&A(4352+i,S,12593),r<p.length?A(r,p,0):4449+r-12593<S.length&&A(4449+r-12593,S,12593),n>=0&&(n<k.length?A(n,k,0):4520+n-12593<S.length&&A(4520+n-12593,S,12593)),M>0)return d.subarray(0,M)}}function A(c,m,a){c>=a&&c<a+m.length&&w(m[c-a])}function w(c){c!==0&&(d[M++]=c&255,c>>8&&(d[M++]=c>>8&255),c>>16&&(d[M++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var E;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(E||(E={}));var R;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(R||(R={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),k=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[77],Se([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=void 0;const M=new D.$Dc(1e4);function d(E){return $(E,"NFC",M)}e.$Il=d;const P=new D.$Dc(1e4);function A(E){return $(E,"NFD",P)}e.$Jl=A;const w=/[^\u0000-\u0080]/;function $(E,R,C){if(!E)return E;const p=C.get(E);if(p)return p;let k;return w.test(E)?k=E.normalize(R):k=E,C.set(E,k),k}e.$Kl=function(){const E=/[\u0300-\u036f]/g;return function(R){return A(R).replace(E,"")}}()}),define(ke[122],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function D(w,$,E){return Math.min(Math.max(w,$),E)}e.$9l=D;function M(w,$){return($+w%$)%$}e.rot=M;class d{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=d;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=P;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const E=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=A}),function(){function $e(d){const P=[];typeof d=="number"&&P.push("code/timeOrigin",d);function A($){P.push($,Date.now())}function w(){const $=[];for(let E=0;E<P.length;E+=2)$.push({name:P[E],startTime:P[E+1]});return $}return{mark:A,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(d+A.startTime)});return P}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=D(M))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var M in D)(typeof exports=="object"?exports:$e)[M]=D[M]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(M){if(e[M])return e[M].exports;var d=e[M]={i:M,l:!1,exports:{}};return $e[M].call(d.exports,d,d.exports,D),d.l=!0,d.exports}return D.m=$e,D.c=e,D.d=function(M,d,P){D.o(M,d)||Object.defineProperty(M,d,{enumerable:!0,get:P})},D.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},D.t=function(M,d){if(1&d&&(M=D(M)),8&d||4&d&&typeof M=="object"&&M&&M.__esModule)return M;var P=Object.create(null);if(D.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:M}),2&d&&typeof M!="string")for(var A in M)D.d(P,A,function(w){return M[w]}.bind(null,A));return P},D.n=function(M){var d=M&&M.__esModule?function(){return M.default}:function(){return M};return D.d(d,"a",d),d},D.o=function(M,d){return Object.prototype.hasOwnProperty.call(M,d)},D.p="",D(D.s=0)}([function($e,e,D){(function(M){var d;e=$e.exports=ne,d=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],$=e.src=[],E=0,R=E++;$[R]="0|[1-9]\\d*";var C=E++;$[C]="[0-9]+";var p=E++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=E++;$[k]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var S=E++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var c=E++;$[c]="(?:"+$[R]+"|"+$[p]+")";var m=E++;$[m]="(?:"+$[C]+"|"+$[p]+")";var a=E++;$[a]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var i=E++;$[i]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var r=E++;$[r]="[0-9A-Za-z-]+";var n=E++;$[n]="(?:\\+("+$[r]+"(?:\\."+$[r]+")*))";var o=E++,t="v?"+$[k]+$[a]+"?"+$[n]+"?";$[o]="^"+t+"$";var h="[v=\\s]*"+$[S]+$[i]+"?"+$[n]+"?",s=E++;$[s]="^"+h+"$";var f=E++;$[f]="((?:<|>)?=?)";var l=E++;$[l]=$[C]+"|x|X|\\*";var u=E++;$[u]=$[R]+"|x|X|\\*";var v=E++;$[v]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[a]+")?"+$[n]+"?)?)?";var I=E++;$[I]="[v=\\s]*("+$[l]+")(?:\\.("+$[l]+")(?:\\.("+$[l]+")(?:"+$[i]+")?"+$[n]+"?)?)?";var b=E++;$[b]="^"+$[f]+"\\s*"+$[v]+"$";var g=E++;$[g]="^"+$[f]+"\\s*"+$[I]+"$";var y=E++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=E++;$[L]="(?:~>?)";var T=E++;$[T]="(\\s*)"+$[L]+"\\s+",w[T]=new RegExp($[T],"g");var U=E++;$[U]="^"+$[L]+$[v]+"$";var j=E++;$[j]="^"+$[L]+$[I]+"$";var F=E++;$[F]="(?:\\^)";var N=E++;$[N]="(\\s*)"+$[F]+"\\s+",w[N]=new RegExp($[N],"g");var O=E++;$[O]="^"+$[F]+$[v]+"$";var z=E++;$[z]="^"+$[F]+$[I]+"$";var K=E++;$[K]="^"+$[f]+"\\s*("+h+")$|^$";var te=E++;$[te]="^"+$[f]+"\\s*("+t+")$|^$";var x=E++;$[x]="(\\s*)"+$[f]+"\\s*("+h+"|"+$[v]+")",w[x]=new RegExp($[x],"g");var X=E++;$[X]="^\\s*("+$[v]+")\\s+-\\s+("+$[v]+")\\s*$";var Z=E++;$[Z]="^\\s*("+$[I]+")\\s+-\\s+("+$[I]+")\\s*$";var ce=E++;$[ce]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)d(_,$[_]),w[_]||(w[_]=new RegExp($[_]));function ge(H,oe){if(H instanceof ne)return H;if(typeof H!="string"||H.length>P||!(oe?w[s]:w[o]).test(H))return null;try{return new ne(H,oe)}catch{return null}}function ne(H,oe){if(H instanceof ne){if(H.loose===oe)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ne))return new ne(H,oe);d("SemVer",H,oe),this.loose=oe;var le=H.trim().match(oe?w[s]:w[o]);if(!le)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var je=+Re;if(je>=0&&je<A)return je}return Re}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=ge,e.valid=function(H,oe){var le=ge(H,oe);return le?le.version:null},e.clean=function(H,oe){var le=ge(H.trim().replace(/^[=v]+/,""),oe);return le?le.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(H){return d("SemVer.compare",this.version,this.loose,H),H instanceof ne||(H=new ne(H,this.loose)),this.compareMain(H)||this.comparePre(H)},ne.prototype.compareMain=function(H){return H instanceof ne||(H=new ne(H,this.loose)),W(this.major,H.major)||W(this.minor,H.minor)||W(this.patch,H.patch)},ne.prototype.comparePre=function(H){if(H instanceof ne||(H=new ne(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var oe=0;do{var le=this.prerelease[oe],Re=H.prerelease[oe];if(d("prerelease compare",oe,le,Re),le===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(le===void 0)return-1;if(le!==Re)return W(le,Re)}while(++oe)},ne.prototype.inc=function(H,oe){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,oe,le,Re){typeof le=="string"&&(Re=le,le=void 0);try{return new ne(H,le).inc(oe,Re).version}catch{return null}},e.diff=function(H,oe){if(fe(H,oe))return null;var le=ge(H),Re=ge(oe);if(le.prerelease.length||Re.prerelease.length){for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Re[je])return"pre"+je;return"prerelease"}for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Re[je])return je},e.compareIdentifiers=W;var J=/^[0-9]+$/;function W(H,oe){var le=J.test(H),Re=J.test(oe);return le&&Re&&(H=+H,oe=+oe),le&&!Re?-1:Re&&!le?1:H<oe?-1:H>oe?1:0}function re(H,oe,le){return new ne(H,le).compare(new ne(oe,le))}function ye(H,oe,le){return re(H,oe,le)>0}function he(H,oe,le){return re(H,oe,le)<0}function fe(H,oe,le){return re(H,oe,le)===0}function ue(H,oe,le){return re(H,oe,le)!==0}function me(H,oe,le){return re(H,oe,le)>=0}function V(H,oe,le){return re(H,oe,le)<=0}function Y(H,oe,le,Re){var je;switch(oe){case"===":typeof H=="object"&&(H=H.version),typeof le=="object"&&(le=le.version),je=H===le;break;case"!==":typeof H=="object"&&(H=H.version),typeof le=="object"&&(le=le.version),je=H!==le;break;case"":case"=":case"==":je=fe(H,le,Re);break;case"!=":je=ue(H,le,Re);break;case">":je=ye(H,le,Re);break;case">=":je=me(H,le,Re);break;case"<":je=he(H,le,Re);break;case"<=":je=V(H,le,Re);break;default:throw new TypeError("Invalid operator: "+oe)}return je}function de(H,oe){if(H instanceof de){if(H.loose===oe)return H;H=H.value}if(!(this instanceof de))return new de(H,oe);d("comparator",H,oe),this.loose=oe,this.parse(H),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(H,oe){return W(oe,H)},e.major=function(H,oe){return new ne(H,oe).major},e.minor=function(H,oe){return new ne(H,oe).minor},e.patch=function(H,oe){return new ne(H,oe).patch},e.compare=re,e.compareLoose=function(H,oe){return re(H,oe,!0)},e.rcompare=function(H,oe,le){return re(oe,H,le)},e.sort=function(H,oe){return H.sort(function(le,Re){return e.compare(le,Re,oe)})},e.rsort=function(H,oe){return H.sort(function(le,Re){return e.rcompare(le,Re,oe)})},e.gt=ye,e.lt=he,e.eq=fe,e.neq=ue,e.gte=me,e.lte=V,e.cmp=Y,e.Comparator=de;var pe={};function Pe(H,oe){if(H instanceof Pe)return H.loose===oe?H:new Pe(H.raw,oe);if(H instanceof de)return new Pe(H.value,oe);if(!(this instanceof Pe))return new Pe(H,oe);if(this.loose=oe,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function ve(H){return!H||H.toLowerCase()==="x"||H==="*"}function Ce(H,oe,le,Re,je,He,Qe,_e,at,st,rt,Le,ze){return((oe=ve(le)?"":ve(Re)?">="+le+".0.0":ve(je)?">="+le+"."+Re+".0":">="+oe)+" "+(_e=ve(at)?"":ve(st)?"<"+(+at+1)+".0.0":ve(rt)?"<"+at+"."+(+st+1)+".0":Le?"<="+at+"."+st+"."+rt+"-"+Le:"<="+_e)).trim()}function B(H,oe){for(var le=0;le<H.length;le++)if(!H[le].test(oe))return!1;if(oe.prerelease.length){for(le=0;le<H.length;le++)if(d(H[le].semver),H[le].semver!==pe&&H[le].semver.prerelease.length>0){var Re=H[le].semver;if(Re.major===oe.major&&Re.minor===oe.minor&&Re.patch===oe.patch)return!0}return!1}return!0}function Q(H,oe,le){try{oe=new Pe(oe,le)}catch{return!1}return oe.test(H)}function ee(H,oe,le,Re){var je,He,Qe,_e,at;switch(H=new ne(H,Re),oe=new Pe(oe,Re),le){case">":je=ye,He=V,Qe=he,_e=">",at=">=";break;case"<":je=he,He=me,Qe=ye,_e="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Q(H,oe,Re))return!1;for(var st=0;st<oe.set.length;++st){var rt=oe.set[st],Le=null,ze=null;if(rt.forEach(function(Ae){Ae.semver===pe&&(Ae=new de(">=0.0.0")),Le=Le||Ae,ze=ze||Ae,je(Ae.semver,Le.semver,Re)?Le=Ae:Qe(Ae.semver,ze.semver,Re)&&(ze=Ae)}),Le.operator===_e||Le.operator===at||(!ze.operator||ze.operator===_e)&&He(H,ze.semver)||ze.operator===at&&Qe(H,ze.semver))return!1}return!0}de.prototype.parse=function(H){var oe=this.loose?w[K]:w[te],le=H.match(oe);if(!le)throw new TypeError("Invalid comparator: "+H);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new ne(le[2],this.loose):this.semver=pe},de.prototype.toString=function(){return this.value},de.prototype.test=function(H){return d("Comparator.test",H,this.loose),this.semver===pe||(typeof H=="string"&&(H=new ne(H,this.loose)),Y(H,this.operator,this.semver,this.loose))},de.prototype.intersects=function(H,oe){if(!(H instanceof de))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Pe(H.value,oe),Q(this.value,le,oe);if(H.operator==="")return le=new Pe(this.value,oe),Q(H.semver,le,oe);var Re=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),He=this.semver.version===H.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),_e=Y(this.semver,"<",H.semver,oe)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),at=Y(this.semver,">",H.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Re||je||He&&Qe||_e||at},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(H){var oe=this.loose;H=H.trim(),d("range",H,oe);var le=oe?w[Z]:w[X];H=H.replace(le,Ce),d("hyphen replace",H),H=H.replace(w[x],"$1$2$3"),d("comparator trim",H,w[x]),H=(H=(H=H.replace(w[T],"$1~")).replace(w[N],"$1^")).split(/\s+/).join(" ");var Re=oe?w[K]:w[te],je=H.split(" ").map(function(He){return function(Qe,_e){return d("comp",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Le,ze){d("caret",Le,ze);var Ae=ze?w[z]:w[O];return Le.replace(Ae,function(Ze,ie,se,Ie,qe){var Ye;return d("caret",Le,Ze,ie,se,Ie,qe),ve(ie)?Ye="":ve(se)?Ye=">="+ie+".0.0 <"+(+ie+1)+".0.0":ve(Ie)?Ye=ie==="0"?">="+ie+"."+se+".0 <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+".0 <"+(+ie+1)+".0.0":qe?(d("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=ie==="0"?se==="0"?">="+ie+"."+se+"."+Ie+qe+" <"+ie+"."+se+"."+(+Ie+1):">="+ie+"."+se+"."+Ie+qe+" <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+"."+Ie+qe+" <"+(+ie+1)+".0.0"):(d("no pr"),Ye=ie==="0"?se==="0"?">="+ie+"."+se+"."+Ie+" <"+ie+"."+se+"."+(+Ie+1):">="+ie+"."+se+"."+Ie+" <"+ie+"."+(+se+1)+".0":">="+ie+"."+se+"."+Ie+" <"+(+ie+1)+".0.0"),d("caret return",Ye),Ye})}(rt,st)}).join(" ")}(Qe,_e),d("caret",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Le,ze){var Ae=ze?w[j]:w[U];return Le.replace(Ae,function(Ze,ie,se,Ie,qe){var Ye;return d("tilde",Le,Ze,ie,se,Ie,qe),ve(ie)?Ye="":ve(se)?Ye=">="+ie+".0.0 <"+(+ie+1)+".0.0":ve(Ie)?Ye=">="+ie+"."+se+".0 <"+ie+"."+(+se+1)+".0":qe?(d("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=">="+ie+"."+se+"."+Ie+qe+" <"+ie+"."+(+se+1)+".0"):Ye=">="+ie+"."+se+"."+Ie+" <"+ie+"."+(+se+1)+".0",d("tilde return",Ye),Ye})}(rt,st)}).join(" ")}(Qe,_e),d("tildes",Qe),Qe=function(at,st){return d("replaceXRanges",at,st),at.split(/\s+/).map(function(rt){return function(Le,ze){Le=Le.trim();var Ae=ze?w[g]:w[b];return Le.replace(Ae,function(Ze,ie,se,Ie,qe,Ye){d("xRange",Le,Ze,ie,se,Ie,qe,Ye);var it=ve(se),nt=it||ve(Ie),Oe=nt||ve(qe);return ie==="="&&Oe&&(ie=""),it?Ze=ie===">"||ie==="<"?"<0.0.0":"*":ie&&Oe?(nt&&(Ie=0),Oe&&(qe=0),ie===">"?(ie=">=",nt?(se=+se+1,Ie=0,qe=0):Oe&&(Ie=+Ie+1,qe=0)):ie==="<="&&(ie="<",nt?se=+se+1:Ie=+Ie+1),Ze=ie+se+"."+Ie+"."+qe):nt?Ze=">="+se+".0.0 <"+(+se+1)+".0.0":Oe&&(Ze=">="+se+"."+Ie+".0 <"+se+"."+(+Ie+1)+".0"),d("xRange return",Ze),Ze})}(rt,st)}).join(" ")}(Qe,_e),d("xrange",Qe),Qe=function(at,st){return d("replaceStars",at,st),at.trim().replace(w[ce],"")}(Qe,_e),d("stars",Qe),Qe}(He,oe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Re)})),je=je.map(function(He){return new de(He,oe)})},Pe.prototype.intersects=function(H,oe){if(!(H instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Re){return H.set.some(function(je){return je.every(function(He){return Re.intersects(He,oe)})})})})},e.toComparators=function(H,oe){return new Pe(H,oe).set.map(function(le){return le.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new ne(H,this.loose));for(var oe=0;oe<this.set.length;oe++)if(B(this.set[oe],H))return!0;return!1},e.satisfies=Q,e.maxSatisfying=function(H,oe,le){var Re=null,je=null;try{var He=new Pe(oe,le)}catch{return null}return H.forEach(function(Qe){He.test(Qe)&&(Re&&je.compare(Qe)!==-1||(je=new ne(Re=Qe,le)))}),Re},e.minSatisfying=function(H,oe,le){var Re=null,je=null;try{var He=new Pe(oe,le)}catch{return null}return H.forEach(function(Qe){He.test(Qe)&&(Re&&je.compare(Qe)!==1||(je=new ne(Re=Qe,le)))}),Re},e.validRange=function(H,oe){try{return new Pe(H,oe).range||"*"}catch{return null}},e.ltr=function(H,oe,le){return ee(H,oe,"<",le)},e.gtr=function(H,oe,le){return ee(H,oe,">",le)},e.outside=ee,e.prerelease=function(H,oe){var le=ge(H,oe);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(H,oe,le){return H=new Pe(H,le),oe=new Pe(oe,le),H.intersects(oe)},e.coerce=function(H){if(H instanceof ne)return H;if(typeof H!="string")return null;var oe=H.match(w[y]);return oe==null?null:ge((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function($e,e){var D,M,d=$e.exports={};function P(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function w(m){if(D===setTimeout)return setTimeout(m,0);if((D===P||!D)&&setTimeout)return D=setTimeout,setTimeout(m,0);try{return D(m,0)}catch{try{return D.call(null,m,0)}catch{return D.call(this,m,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:P}catch{D=P}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var $,E=[],R=!1,C=-1;function p(){R&&$&&(R=!1,$.length?E=$.concat(E):C=-1,E.length&&k())}function k(){if(!R){var m=w(p);R=!0;for(var a=E.length;a;){for($=E,E=[];++C<a;)$&&$[C].run();C=-1,a=E.length}$=null,R=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(m)}}function S(m,a){this.fun=m,this.array=a}function c(){}d.nextTick=function(m){var a=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)a[i-1]=arguments[i];E.push(new S(m,a)),E.length!==1||R||w(k)},S.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=c,d.addListener=c,d.once=c,d.off=c,d.removeListener=c,d.removeAllListeners=c,d.emit=c,d.prependListener=c,d.prependOnceListener=c,d.listeners=function(m){return[]},d.binding=function(m){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(m){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(P){return new M(P)}constructor(P){this.c=D&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=M}),define(ke[4],Se([1,0,14,75,3,76,38]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const w=!1,$=!1;var E;(function(b){b.None=()=>d.$Tc.None;function g(V){if($){const{onDidAddListener:Y}=V,de=S.create();let pe=0;V.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),Y?.()}}}function y(V,Y){return te(V,()=>{},0,void 0,!0,void 0,Y)}b.defer=y;function L(V){return(Y,de=null,pe)=>{let Pe=!1,ve;return ve=V(Ce=>{if(!Pe)return ve?ve.dispose():Pe=!0,Y.call(de,Ce)},null,pe),Pe&&ve.dispose(),ve}}b.once=L;function T(V,Y,de){return z((pe,Pe=null,ve)=>V(Ce=>pe.call(Pe,Y(Ce)),null,ve),de)}b.map=T;function U(V,Y,de){return z((pe,Pe=null,ve)=>V(Ce=>{Y(Ce),pe.call(Pe,Ce)},null,ve),de)}b.forEach=U;function j(V,Y,de){return z((pe,Pe=null,ve)=>V(Ce=>Y(Ce)&&pe.call(Pe,Ce),null,ve),de)}b.filter=j;function F(V){return V}b.signal=F;function N(...V){return(Y,de=null,pe)=>{const Pe=(0,d.$Qc)(...V.map(ve=>ve(Ce=>Y.call(de,Ce))));return K(Pe,pe)}}b.any=N;function O(V,Y,de,pe){let Pe=de;return T(V,ve=>(Pe=Y(Pe,ve),Pe),pe)}b.reduce=O;function z(V,Y){let de;const pe={onWillAddFirstListener(){de=V(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};Y||g(pe);const Pe=new r(pe);return Y?.add(Pe),Pe.event}function K(V,Y){return Y instanceof Array?Y.push(V):Y&&Y.add(V),V}function te(V,Y,de=100,pe=!1,Pe=!1,ve,Ce){let B,Q,ee,H=0,oe;const le={leakWarningThreshold:ve,onWillAddFirstListener(){B=V(je=>{H++,Q=Y(Q,je),pe&&!ee&&(Re.fire(Q),Q=void 0),oe=()=>{const He=Q;Q=void 0,ee=void 0,(!pe||H>1)&&Re.fire(He),H=0},typeof de=="number"?(clearTimeout(ee),ee=setTimeout(oe,de)):ee===void 0&&(ee=0,queueMicrotask(oe))})},onWillRemoveListener(){Pe&&H>0&&oe?.()},onDidRemoveLastListener(){oe=void 0,B.dispose()}};Ce||g(le);const Re=new r(le);return Ce?.add(Re),Re.event}b.debounce=te;function x(V,Y=0,de){return b.debounce(V,(pe,Pe)=>pe?(pe.push(Pe),pe):[Pe],Y,void 0,!0,void 0,de)}b.accumulate=x;function X(V,Y=(pe,Pe)=>pe===Pe,de){let pe=!0,Pe;return j(V,ve=>{const Ce=pe||!Y(ve,Pe);return pe=!1,Pe=ve,Ce},de)}b.latch=X;function Z(V,Y,de){return[b.filter(V,Y,de),b.filter(V,pe=>!Y(pe),de)]}b.split=Z;function ce(V,Y=!1,de=[],pe){let Pe=de.slice(),ve=V(Q=>{Pe?Pe.push(Q):B.fire(Q)});pe&&pe.add(ve);const Ce=()=>{Pe?.forEach(Q=>B.fire(Q)),Pe=null},B=new r({onWillAddFirstListener(){ve||(ve=V(Q=>B.fire(Q)),pe&&pe.add(ve))},onDidAddFirstListener(){Pe&&(Y?setTimeout(Ce):Ce())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return pe&&pe.add(B),B.event}b.buffer=ce;function _(V,Y){return(pe,Pe,ve)=>{const Ce=Y(new ne);return V(function(B){const Q=Ce.evaluate(B);Q!==ge&&pe.call(Pe,Q)},void 0,ve)}}b.chain=_;const ge=Symbol("HaltChainable");class ne{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(de=>(Y(de),de)),this}filter(Y){return this.f.push(de=>Y(de)?de:ge),this}reduce(Y,de){let pe=de;return this.f.push(Pe=>(pe=Y(pe,Pe),pe)),this}latch(Y=(de,pe)=>de===pe){let de=!0,pe;return this.f.push(Pe=>{const ve=de||!Y(Pe,pe);return de=!1,pe=Pe,ve?Pe:ge}),this}evaluate(Y){for(const de of this.f)if(Y=de(Y),Y===ge)break;return Y}}function J(V,Y,de=pe=>pe){const pe=(...B)=>Ce.fire(de(...B)),Pe=()=>V.on(Y,pe),ve=()=>V.removeListener(Y,pe),Ce=new r({onWillAddFirstListener:Pe,onDidRemoveLastListener:ve});return Ce.event}b.fromNodeEventEmitter=J;function W(V,Y,de=pe=>pe){const pe=(...B)=>Ce.fire(de(...B)),Pe=()=>V.addEventListener(Y,pe),ve=()=>V.removeEventListener(Y,pe),Ce=new r({onWillAddFirstListener:Pe,onDidRemoveLastListener:ve});return Ce.event}b.fromDOMEventEmitter=W;function re(V){return new Promise(Y=>L(V)(Y))}b.toPromise=re;function ye(V){const Y=new r;return V.then(de=>{Y.fire(de)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}b.fromPromise=ye;function he(V,Y,de){return Y(de),V(pe=>Y(pe))}b.runAndSubscribe=he;class fe{constructor(Y,de){this._observable=Y,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};de||g(pe),this.emitter=new r(pe),de&&de.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,de){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(V,Y){return new fe(V,Y).emitter.event}b.fromObservable=ue;function me(V){return(Y,de,pe)=>{let Pe=0,ve=!1;const Ce={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(V.reportChanges(),ve&&(ve=!1,Y.call(de)))},handlePossibleChange(){},handleChange(){ve=!0}};V.addObserver(Ce),V.reportChanges();const B={dispose(){V.removeObserver(Ce)}};return pe instanceof d.$Sc?pe.add(B):Array.isArray(pe)&&pe.push(B),B}}b.fromObservableLight=me})(E||(e.Event=E={}));class R{static{this.all=new Set}static{this.f=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${R.f++}`,R.all.add(this)}start(g){this.g=new A.$Sd,this.listenerCount=g}stop(){if(this.g){const g=this.g.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.g=void 0}}}e.$Ud=R;let C=-1;function p(b){const g=C;return C=b,{dispose(){C=g}}}e.$Vd=p;class k{constructor(g,y=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=y,this.g=0}dispose(){this.f?.clear()}check(g,y){const L=this.threshold;if(L<=0||y<L)return;this.f||(this.f=new Map);const T=this.f.get(g.value)||0;if(this.f.set(g.value,T+1),this.g-=1,this.g<=0){this.g=L*.5;let U,j=0;for(const[F,N]of this.f)(!U||j<N)&&(U=F,j=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${j}):`),console.warn(U)}return()=>{const U=this.f.get(g.value)||0;this.f.set(g.value,U-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class m{constructor(g){this.value=g,this.id=c++}}const a=2,i=(b,g)=>{if(b instanceof m)g(b);else for(let y=0;y<b.length;y++){const L=b[y];L&&g(L)}};class r{constructor(g){this.w=0,this.f=g,this.g=C>0||this.f?.leakWarningThreshold?new k(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const g=this.t;queueMicrotask(()=>{i(g,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(g,y,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.$Tc.None;if(this.m)return d.$Tc.None;y&&(g=g.bind(y));const T=new m(g);let U,j;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=S.create(),U=this.g.check(T.stack,this.w+1)),w&&(T.stack=j??S.create()),this.t?this.t instanceof m?(this.u??=new o,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,d.$Rc)(()=>{U?.(),this.x(T)});return L instanceof d.$Sc?L.add(F):Array.isArray(L)&&L.push(F),F},this.q}x(g){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,L=y.indexOf(g);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[L]=void 0;const T=this.u.current===this;if(this.w*a<=y.length){let U=0;for(let j=0;j<y.length;j++)y[j]?y[U++]=y[j]:T&&(this.u.end--,U<this.u.i&&this.u.i--);y.length=U}}y(g,y){if(!g)return;const L=this.f?.onListenerError||D.$1;if(!L){g.value(y);return}try{g.value(y)}catch(T){L(T)}}z(g){const y=g.current.t;for(;g.i<g.end;)this.y(y[g.i++],g.value);g.reset()}fire(g){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,g);else{const y=this.u;y.enqueue(this,g,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=r;const n=()=>new o;e.$Xd=n;class o{constructor(){this.i=-1,this.end=0}enqueue(g,y,L){this.i=0,this.end=L,this.current=g,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(g,y,L){if(this.t)for(this.h||(this.h=new P.$4c),i(this.t,T=>this.h.push([T.value,g]));this.h.size>0&&!y.isCancellationRequested;){const[T,U]=this.h.shift(),j=[],F={...U,token:y,waitUntil:N=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");L&&(N=L(N,T)),j.push(N)}};try{T(F)}catch(N){(0,D.$1)(N);continue}Object.freeze(j),await Promise.allSettled(j).then(N=>{for(const O of N)O.status==="rejected"&&(0,D.$1)(O.reason)})}}}e.$Yd=t;class h extends r{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new P.$4c,this.A=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.A(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.w&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$Zd=h;class s extends h{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$1d=s;class f extends r{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$2d=f;class l{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(g){const y={event:g,listener:null};this.h.push(y),this.g&&this.m(y);const L=()=>{this.g&&this.o(y);const T=this.h.indexOf(y);this.h.splice(T,1)};return(0,d.$Rc)((0,M.$db)(L))}j(){this.g=!0,this.h.forEach(g=>this.m(g))}k(){this.g=!1,this.h.forEach(g=>this.o(g))}m(g){g.listener=g.event(y=>this.f.fire(y))}o(g){g.listener?.dispose(),g.listener=null}dispose(){this.f.dispose();for(const g of this.h)g.listener?.dispose();this.h=[]}}e.$3d=l;class u{constructor(g,y,L,T){this.f=new d.$Sc;const U=this.f.add(new l),j=this.f.add(new d.$3c);function F(N){j.set(N,U.add(T(N)))}for(const N of g)F(N);this.f.add(y(N=>{F(N)})),this.f.add(L(N=>{j.deleteAndDispose(N)})),this.event=U.event}dispose(){this.f.dispose()}}e.$4d=u;class v{constructor(){this.f=[]}wrapEvent(g){return(y,L,T)=>g(U=>{const j=this.f[this.f.length-1];j?j.push(()=>y.call(L,U)):y.call(L,U)},void 0,T)}bufferEvents(g){const y=[];this.f.push(y);const L=g();return this.f.pop(),y.forEach(T=>T()),L}}e.$5d=v;class I{constructor(){this.f=!1,this.g=E.None,this.h=d.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(g){this.g=g,this.f&&(this.h.dispose(),this.h=g(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=I}),define(ke[22],Se([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const M=Object.freeze(function(w,$){const E=setTimeout(w.bind($),0);return{dispose(){clearTimeout(E)}}});var d;(function(w){function $(E){return E===w.None||E===w.Cancelled||E instanceof P?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}w.isCancellationToken=$,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(d||(e.CancellationToken=d={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new D.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=d.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=d.None}}e.$7d=A}),define(ke[162],Se([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class M{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new D.$7d,$=this.b(w.token);return this.a={promise:$,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$Fe=M;class d{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const $=JSON.stringify(w);return this.b!==$&&(this.b=$,this.a=this.c(w)),this.a}}e.$Ge=d;class P{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const $=this.b(w);return this.a.set(w,$),$}}e.$He=P}),define(ke[98],Se([1,0,14,3]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function d(n){const o=n;return o?typeof o.read=="function":!1}e.$8d=d;function P(n){const o=n;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}e.$9d=P;function A(n){const o=n;return o?P(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.$0d=A;function w(n,o){return new $(n,o)}e.$$d=w;class ${constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,D.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let h;switch(o){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const s=h.indexOf(t);s>=0&&h.splice(s,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(n,o){const t=[];let h;for(;(h=n.read())!==null;)t.push(h);return o(t)}e.$_d=E;function R(n,o,t){const h=[];let s;for(;(s=n.read())!==null&&h.length<t;)h.push(s);return s===null&&h.length>0?o(h):{read:()=>{if(h.length>0)return h.shift();if(typeof s<"u"){const f=s;return s=void 0,f}return n.read()}}}e.$ae=R;function C(n,o){return new Promise((t,h)=>{const s=[];p(n,{onData:f=>{o&&s.push(f)},onError:f=>{o?h(f):t(void 0)},onEnd:()=>{t(o?o(s):void 0)}})})}e.$be=C;function p(n,o,t){n.on("error",h=>{t?.isCancellationRequested||o.onError(h)}),n.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),n.on("data",h=>{t?.isCancellationRequested||o.onData(h)})}e.$ce=p;function k(n,o){return new Promise((t,h)=>{const s=new M.$Sc,f=[],l=I=>{if(f.push(I),f.length>o)return s.dispose(),n.pause(),t({stream:n,buffer:f,ended:!1})},u=I=>(s.dispose(),h(I)),v=()=>(s.dispose(),t({stream:n,buffer:f,ended:!0}));s.add((0,M.$Rc)(()=>n.removeListener("error",u))),n.on("error",u),s.add((0,M.$Rc)(()=>n.removeListener("end",v))),n.on("end",v),s.add((0,M.$Rc)(()=>n.removeListener("data",l))),n.on("data",l)})}e.$de=k;function S(n,o){const t=w(o);return t.end(n),t}e.$ee=S;function c(){const n=w(()=>{throw new Error("not supported")});return n.end(),n}e.$fe=c;function m(n){let o=!1;return{read:()=>o?null:(o=!0,n)}}e.$ge=m;function a(n,o,t){const h=w(t);return p(n,{onData:s=>h.write(o.data(s)),onError:s=>h.error(o.error?o.error(s):s),onEnd:()=>h.end()}),h}e.$he=a;function i(n,o,t){let h=!1;return{read:()=>{const s=o.read();return h?s:(h=!0,s!==null?t([n,s]):n)}}}e.$ie=i;function r(n,o,t){let h=!1;const s=w(t);return p(o,{onData:f=>h?s.write(f):(h=!0,s.write(t([n,f]))),onError:f=>s.error(f),onEnd:()=>{h||(h=!0,s.write(n)),s.end()}}),s}e.$je=r}),define(ke[21],Se([1,0,43,98]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const d=typeof Buffer<"u",P=new D.$V(()=>new Uint8Array(256));let A,w;class ${static alloc(y){return d?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return d&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,L){return!(L?.dontUseNodeBuffer||!1)&&d?new $(Buffer.from(y)):(A||(A=new TextEncoder),new $(A.encode(y)))}static fromByteArray(y){const L=$.alloc(y.length);for(let T=0,U=y.length;T<U;T++)L.buffer[T]=y[T];return L}static concat(y,L){if(typeof L>"u"){L=0;for(let j=0,F=y.length;j<F;j++)L+=y[j].byteLength}const T=$.alloc(L);let U=0;for(let j=0,F=y.length;j<F;j++){const N=y[j];T.set(N,U),U+=N.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return d?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(y,L){return new $(this.buffer.subarray(y,L))}set(y,L){if(y instanceof $)this.buffer.set(y.buffer,L);else if(y instanceof Uint8Array)this.buffer.set(y,L);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),L);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return p(this.buffer,y)}writeUInt32BE(y,L){k(this.buffer,y,L)}readUInt32LE(y){return S(this.buffer,y)}writeUInt32LE(y,L){c(this.buffer,y,L)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,L){a(this.buffer,y,L)}indexOf(y,L=0){return E(this.buffer,y instanceof $?y.buffer:y,L)}}e.$ke=$;function E(g,y,L=0){const T=y.byteLength,U=g.byteLength;if(T===0)return 0;if(T===1)return g.indexOf(y[0]);if(T>U-L)return-1;const j=P.value;j.fill(y.length);for(let z=0;z<y.length;z++)j[y[z]]=y.length-z-1;let F=L+y.length-1,N=F,O=-1;for(;F<U;)if(g[F]===y[N]){if(N===0){O=F;break}F--,N--}else F+=Math.max(y.length-N,j[g[F]]),N=y.length-1;return O}e.$le=E;function R(g,y){return g[y+0]<<0>>>0|g[y+1]<<8>>>0}e.$me=R;function C(g,y,L){g[L+0]=y&255,y=y>>>8,g[L+1]=y&255}e.$ne=C;function p(g,y){return g[y]*2**24+g[y+1]*2**16+g[y+2]*2**8+g[y+3]}e.$oe=p;function k(g,y,L){g[L+3]=y,y=y>>>8,g[L+2]=y,y=y>>>8,g[L+1]=y,y=y>>>8,g[L]=y}e.$pe=k;function S(g,y){return g[y+0]<<0>>>0|g[y+1]<<8>>>0|g[y+2]<<16>>>0|g[y+3]<<24>>>0}e.$qe=S;function c(g,y,L){g[L+0]=y&255,y=y>>>8,g[L+1]=y&255,y=y>>>8,g[L+2]=y&255,y=y>>>8,g[L+3]=y&255}e.$re=c;function m(g,y){return g[y]}e.$se=m;function a(g,y,L){g[L]=y}e.$te=a;function i(g){return M.$_d(g,y=>$.concat(y))}e.$ue=i;function r(g){return M.$ge(g)}e.$ve=r;function n(g){return M.$be(g,y=>$.concat(y))}e.$we=n;async function o(g){return g.ended?$.concat(g.buffer):$.concat([...g.buffer,await n(g.stream)])}e.$xe=o;function t(g){return M.$ee(g,y=>$.concat(y))}e.$ye=t;function h(g){return M.$he(g,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}e.$ze=h;function s(g){return M.$$d(y=>$.concat(y),g)}e.$Ae=s;function f(g,y){return M.$ie(g,y,L=>$.concat(L))}e.$Be=f;function l(g,y){return M.$je(g,y,L=>$.concat(L))}e.$Ce=l;function u(g){let y=0,L=0,T=0;const U=new Uint8Array(Math.floor(g.length/4*3)),j=N=>{switch(L){case 3:U[T++]=y|N,L=0;break;case 2:U[T++]=y|N>>>2,y=N<<6,L=3;break;case 1:U[T++]=y|N>>>4,y=N<<4,L=2;break;default:y=N<<2,L=1}};for(let N=0;N<g.length;N++){const O=g.charCodeAt(N);if(O>=65&&O<=90)j(O-65);else if(O>=97&&O<=122)j(O-97+26);else if(O>=48&&O<=57)j(O-48+52);else if(O===43||O===45)j(62);else if(O===47||O===95)j(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${g[N]}`)}}const F=T;for(;L>0;)j(0);return $.wrap(U).slice(0,F)}e.$De=u;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:g},y=!0,L=!1){const T=L?I:v;let U="";const j=g.byteLength%3;let F=0;for(;F<g.byteLength-j;F+=3){const N=g[F+0],O=g[F+1],z=g[F+2];U+=T[N>>>2],U+=T[(N<<4|O>>>4)&63],U+=T[(O<<2|z>>>6)&63],U+=T[z&63]}if(j===1){const N=g[F+0];U+=T[N>>>2],U+=T[N<<4&63],y&&(U+="==")}else if(j===2){const N=g[F+0],O=g[F+1];U+=T[N>>>2],U+=T[(N<<4|O>>>4)&63],U+=T[O<<2&63],y&&(U+="=")}return U}e.$Ee=b}),define(ke[13],Se([1,0,162,43]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function d(Le){return!Le||typeof Le!="string"?!0:Le.trim().length===0}e.$Ke=d;const P=/{(\d+)}/g;function A(Le,...ze){return ze.length===0?Le:Le.replace(P,function(Ae,Ze){const ie=parseInt(Ze,10);return isNaN(ie)||ie<0||ie>=ze.length?Ae:ze[ie]})}e.$Le=A;const w=/{([^}]+)}/g;function $(Le,ze){return Object.keys(ze).length===0?Le:Le.replace(w,(Ae,Ze)=>ze[Ze]??Ae)}e.$Me=$;function E(Le){return Le.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}e.$Ne=E;function R(Le){return Le.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}e.$Oe=R;function C(Le){return Le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=C;function p(Le,ze){let Ae=0;const Ze=ze.charCodeAt(0);for(let ie=Le.length-1;ie>=0;ie--)Le.charCodeAt(ie)===Ze&&Ae++;return Ae}e.$Qe=p;function k(Le,ze,Ae="\u2026"){return Le.length<=ze?Le:`${Le.substr(0,ze)}${Ae}`}e.$Re=k;function S(Le,ze,Ae="\u2026"){if(Le.length<=ze)return Le;const Ze=Math.ceil(ze/2)-Ae.length/2,ie=Math.floor(ze/2)-Ae.length/2;return`${Le.substr(0,Ze)}${Ae}${Le.substr(Le.length-ie)}`}e.$Se=S;function c(Le,ze=" "){const Ae=m(Le,ze);return a(Ae,ze)}e.$Te=c;function m(Le,ze){if(!Le||!ze)return Le;const Ae=ze.length;if(Ae===0||Le.length===0)return Le;let Ze=0;for(;Le.indexOf(ze,Ze)===Ze;)Ze=Ze+Ae;return Le.substring(Ze)}e.$Ue=m;function a(Le,ze){if(!Le||!ze)return Le;const Ae=ze.length,Ze=Le.length;if(Ae===0||Ze===0)return Le;let ie=Ze,se=-1;for(;se=Le.lastIndexOf(ze,ie-1),!(se===-1||se+Ae!==ie);){if(se===0)return"";ie=se}return Le.substring(0,ie)}e.$Ve=a;function i(Le){return Le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=i;function r(Le){return Le.replace(/\*/g,"")}e.$Xe=r;function n(Le,ze,Ae={}){if(!Le)throw new Error("Cannot create regex from empty string");ze||(Le=C(Le)),Ae.wholeWord&&(/\B/.test(Le.charAt(0))||(Le="\\b"+Le),/\B/.test(Le.charAt(Le.length-1))||(Le=Le+"\\b"));let Ze="";return Ae.global&&(Ze+="g"),Ae.matchCase||(Ze+="i"),Ae.multiline&&(Ze+="m"),Ae.unicode&&(Ze+="u"),new RegExp(Le,Ze)}e.$Ye=n;function o(Le){return Le.source==="^"||Le.source==="^$"||Le.source==="$"||Le.source==="^\\s*$"?!1:!!(Le.exec("")&&Le.lastIndex===0)}e.$Ze=o;function t(Le){return Le.split(/\r\n|\r|\n/)}e.$1e=t;function h(Le){for(let ze=0,Ae=Le.length;ze<Ae;ze++){const Ze=Le.charCodeAt(ze);if(Ze!==32&&Ze!==9)return ze}return-1}e.$2e=h;function s(Le,ze=0,Ae=Le.length){for(let Ze=ze;Ze<Ae;Ze++){const ie=Le.charCodeAt(Ze);if(ie!==32&&ie!==9)return Le.substring(ze,Ze)}return Le.substring(ze,Ae)}e.$3e=s;function f(Le,ze=Le.length-1){for(let Ae=ze;Ae>=0;Ae--){const Ze=Le.charCodeAt(Ae);if(Ze!==32&&Ze!==9)return Ae}return-1}e.$4e=f;function l(Le,ze,Ae){const Ze=[];let ie=0;for(const se of Le.matchAll(ze)){if(Ze.push(Le.slice(ie,se.index)),se.index===void 0)throw new Error("match.index should be defined");ie=se.index+se[0].length,Ze.push(Ae(se[0],...se.slice(1),se.index,Le,se.groups))}return Ze.push(Le.slice(ie)),Promise.all(Ze).then(se=>se.join(""))}e.$5e=l;function u(Le,ze){return Le<ze?-1:Le>ze?1:0}e.$6e=u;function v(Le,ze,Ae=0,Ze=Le.length,ie=0,se=ze.length){for(;Ae<Ze&&ie<se;Ae++,ie++){const Ye=Le.charCodeAt(Ae),it=ze.charCodeAt(ie);if(Ye<it)return-1;if(Ye>it)return 1}const Ie=Ze-Ae,qe=se-ie;return Ie<qe?-1:Ie>qe?1:0}e.$7e=v;function I(Le,ze){return b(Le,ze,0,Le.length,0,ze.length)}e.$8e=I;function b(Le,ze,Ae=0,Ze=Le.length,ie=0,se=ze.length){for(;Ae<Ze&&ie<se;Ae++,ie++){let Ye=Le.charCodeAt(Ae),it=ze.charCodeAt(ie);if(Ye===it)continue;if(Ye>=128||it>=128)return v(Le.toLowerCase(),ze.toLowerCase(),Ae,Ze,ie,se);y(Ye)&&(Ye-=32),y(it)&&(it-=32);const nt=Ye-it;if(nt!==0)return nt}const Ie=Ze-Ae,qe=se-ie;return Ie<qe?-1:Ie>qe?1:0}e.$9e=b;function g(Le){return Le>=48&&Le<=57}e.$0e=g;function y(Le){return Le>=97&&Le<=122}e.$$e=y;function L(Le){return Le>=65&&Le<=90}e.$_e=L;function T(Le,ze){return Le.length===ze.length&&b(Le,ze)===0}e.$af=T;function U(Le,ze){const Ae=ze.length;return ze.length>Le.length?!1:b(Le,ze,0,Ae)===0}e.$bf=U;function j(Le,ze){const Ae=Math.min(Le.length,ze.length);let Ze;for(Ze=0;Ze<Ae;Ze++)if(Le.charCodeAt(Ze)!==ze.charCodeAt(Ze))return Ze;return Ae}e.$cf=j;function F(Le,ze){const Ae=Math.min(Le.length,ze.length);let Ze;const ie=Le.length-1,se=ze.length-1;for(Ze=0;Ze<Ae;Ze++)if(Le.charCodeAt(ie-Ze)!==ze.charCodeAt(se-Ze))return Ze;return Ae}e.$df=F;function N(Le){return 55296<=Le&&Le<=56319}e.$ef=N;function O(Le){return 56320<=Le&&Le<=57343}e.$ff=O;function z(Le,ze){return(Le-55296<<10)+(ze-56320)+65536}e.$gf=z;function K(Le,ze,Ae){const Ze=Le.charCodeAt(Ae);if(N(Ze)&&Ae+1<ze){const ie=Le.charCodeAt(Ae+1);if(O(ie))return z(Ze,ie)}return Ze}e.$hf=K;function te(Le,ze){const Ae=Le.charCodeAt(ze-1);if(O(Ae)&&ze>1){const Ze=Le.charCodeAt(ze-2);if(N(Ze))return z(Ze,Ae)}return Ae}class x{get offset(){return this.e}constructor(ze,Ae=0){this.c=ze,this.d=ze.length,this.e=Ae}setOffset(ze){this.e=ze}prevCodePoint(){const ze=te(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=K(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$if=x;class X{get offset(){return this.c.offset}constructor(ze,Ae=0){this.c=new x(ze,Ae)}nextGraphemeLength(){const ze=Re.getInstance(),Ae=this.c,Ze=Ae.offset;let ie=ze.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const se=Ae.offset,Ie=ze.getGraphemeBreakType(Ae.nextCodePoint());if(oe(ie,Ie)){Ae.setOffset(se);break}ie=Ie}return Ae.offset-Ze}prevGraphemeLength(){const ze=Re.getInstance(),Ae=this.c,Ze=Ae.offset;let ie=ze.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const se=Ae.offset,Ie=ze.getGraphemeBreakType(Ae.prevCodePoint());if(oe(Ie,ie)){Ae.setOffset(se);break}ie=Ie}return Ze-Ae.offset}eol(){return this.c.eol()}}e.$jf=X;function Z(Le,ze){return new X(Le,ze).nextGraphemeLength()}e.$kf=Z;function ce(Le,ze){return new X(Le,ze).prevGraphemeLength()}e.$lf=ce;function _(Le,ze){ze>0&&O(Le.charCodeAt(ze))&&ze--;const Ae=ze+Z(Le,ze);return[Ae-ce(Le,Ae),Ae]}e.$mf=_;function ge(Le){const ze=new X(Le);let Ae=0;for(;!ze.eol();)Ae++,ze.nextGraphemeLength();return Ae}e.$nf=ge;let ne;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Le){return ne||(ne=J()),ne.test(Le)}e.$of=W;const re=/^[\t\n\r\x20-\x7E]*$/;function ye(Le){return re.test(Le)}e.$pf=ye,e.$qf=/[\u2028\u2029]/;function he(Le){return e.$qf.test(Le)}e.$rf=he;function fe(Le){return Le>=11904&&Le<=55215||Le>=63744&&Le<=64255||Le>=65281&&Le<=65374}e.$sf=fe;function ue(Le){return Le>=127462&&Le<=127487||Le===8986||Le===8987||Le===9200||Le===9203||Le>=9728&&Le<=10175||Le===11088||Le===11093||Le>=127744&&Le<=128591||Le>=128640&&Le<=128764||Le>=128992&&Le<=129008||Le>=129280&&Le<=129535||Le>=129648&&Le<=129782}e.$tf=ue;function me(Le,ze,Ae=""){const Ze=Le.trimStart();if(Ze.length<ze)return Ze;const ie=/\b/g;let se=0;for(;ie.test(Ze)&&!(Ze.length-ie.lastIndex<ze);)se=ie.lastIndex,ie.lastIndex+=1;return se===0?Ze:Ae+Ze.substring(se).trimStart()}e.$uf=me;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Y=/\x1b\].*?\x07/g;function de(Le){return Le&&(Le=Le.replace(V,"").replace(Y,"")),Le}e.$vf=de,e.$wf="\uFEFF";function pe(Le){return!!(Le&&Le.length>0&&Le.charCodeAt(0)===65279)}e.$xf=pe;function Pe(Le){return pe(Le)?Le.substr(1):Le}e.$yf=Pe;function ve(Le,ze){if(!Le||!ze||Le.length<ze.length)return!1;const Ae=ze.length,Ze=Le.toLowerCase();let ie=0,se=-1;for(;ie<Ae;){const Ie=Ze.indexOf(ze[ie],se+1);if(Ie<0)return!1;se=Ie,ie++}return!0}e.$zf=ve;function Ce(Le,ze=!1){return Le?(ze&&(Le=Le.replace(/\\./g,"")),Le.toLowerCase()!==Le):!1}e.$Af=Ce;function B(Le){return Le.charAt(0).toUpperCase()+Le.slice(1)}e.$Bf=B;function Q(Le,ze=1){if(ze===0)return"";let Ae=-1;do Ae=Le.indexOf(`
`,Ae+1),ze--;while(ze>0&&Ae>=0);return Ae===-1?Le:(Le[Ae-1]==="\r"&&Ae--,Le.substr(0,Ae))}e.$Cf=Q;function ee(Le){return Le=Le%(2*26),Le<26?String.fromCharCode(97+Le):String.fromCharCode(65+Le-26)}e.$Df=ee;function H(Le){return Re.getInstance().getGraphemeBreakType(Le)}e.$Ef=H;function oe(Le,ze){return Le===0?ze!==5&&ze!==7:Le===2&&ze===3?!1:Le===4||Le===2||Le===3||ze===4||ze===2||ze===3?!0:!(Le===8&&(ze===8||ze===9||ze===11||ze===12)||(Le===11||Le===9)&&(ze===9||ze===10)||(Le===12||Le===10)&&ze===10||ze===5||ze===13||ze===7||Le===1||Le===13&&ze===14||Le===6&&ze===6)}var le;(function(Le){Le[Le.Other=0]="Other",Le[Le.Prepend=1]="Prepend",Le[Le.CR=2]="CR",Le[Le.LF=3]="LF",Le[Le.Control=4]="Control",Le[Le.Extend=5]="Extend",Le[Le.Regional_Indicator=6]="Regional_Indicator",Le[Le.SpacingMark=7]="SpacingMark",Le[Le.L=8]="L",Le[Le.V=9]="V",Le[Le.T=10]="T",Le[Le.LV=11]="LV",Le[Le.LVT=12]="LVT",Le[Le.ZWJ=13]="ZWJ",Le[Le.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=je()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const Ae=this.d,Ze=Ae.length/3;let ie=1;for(;ie<=Ze;)if(ze<Ae[3*ie])ie=2*ie;else if(ze>Ae[3*ie+1])ie=2*ie+1;else return Ae[3*ie+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Le,ze){if(Le===0)return 0;const Ae=Qe(Le,ze);if(Ae!==void 0)return Ae;const Ze=new x(ze,Le);return Ze.prevCodePoint(),Ze.offset}e.$Ff=He;function Qe(Le,ze){const Ae=new x(ze,Le);let Ze=Ae.prevCodePoint();for(;_e(Ze)||Ze===65039||Ze===8419;){if(Ae.offset===0)return;Ze=Ae.prevCodePoint()}if(!ue(Ze))return;let ie=Ae.offset;return ie>0&&Ae.prevCodePoint()===8205&&(ie=Ae.offset),ie}function _e(Le){return 127995<=Le&&Le<=127999}var at;(function(Le){Le[Le.zwj=8205]="zwj",Le[Le.emojiVariantSelector=65039]="emojiVariantSelector",Le[Le.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.$Gf="\xA0";class st{static{this.c=new M.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ge(ze=>{function Ae(nt){const Oe=new Map;for(let yt=0;yt<nt.length;yt+=2)Oe.set(nt[yt],nt[yt+1]);return Oe}function Ze(nt,Oe){const yt=new Map(nt);for(const[Dt,Tt]of Oe)yt.set(Dt,Tt);return yt}function ie(nt,Oe){if(!nt)return Oe;const yt=new Map;for(const[Dt,Tt]of nt)Oe.has(Dt)&&yt.set(Dt,Tt);return yt}const se=this.c.value;let Ie=ze.filter(nt=>!nt.startsWith("_")&&nt in se);Ie.length===0&&(Ie=["_default"]);let qe;for(const nt of Ie){const Oe=Ae(se[nt]);qe=ie(qe,Oe)}const Ye=Ae(se._common),it=Ze(Ye,qe);return new st(it)})}static getInstance(ze){return st.d.get(Array.from(ze))}static{this.e=new M.$V(()=>Object.keys(st.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return st.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=st;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(ze){return rt.e().has(ze)}static get codePoints(){return rt.e()}}e.$If=rt}),define(ke[123],Se([1,0,28,161,13]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.FuzzyScore=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.or=void 0;function P(...ve){return function(Ce,B){for(let Q=0,ee=ve.length;Q<ee;Q++){const H=ve[Q](Ce,B);if(H)return H}return null}}e.or=P,e.$Vj=A.bind(void 0,!1),e.$Wj=A.bind(void 0,!0);function A(ve,Ce,B){if(!B||B.length<Ce.length)return null;let Q;return ve?Q=d.$bf(B,Ce):Q=B.indexOf(Ce)===0,Q?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function w(ve,Ce){const B=Ce.toLowerCase().indexOf(ve.toLowerCase());return B===-1?null:[{start:B,end:B+ve.length}]}e.$Xj=w;function $(ve,Ce){return E(ve.toLowerCase(),Ce.toLowerCase(),0,0)}e.$Yj=$;function E(ve,Ce,B,Q){if(B===ve.length)return[];if(Q===Ce.length)return null;if(ve[B]===Ce[Q]){let ee=null;return(ee=E(ve,Ce,B+1,Q+1))?n({start:Q,end:Q+1},ee):null}return E(ve,Ce,B,Q+1)}function R(ve){return 97<=ve&&ve<=122}function C(ve){return 65<=ve&&ve<=90}e.$Zj=C;function p(ve){return 48<=ve&&ve<=57}function k(ve){return ve===32||ve===9||ve===10||ve===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ve=>S.add(ve.charCodeAt(0)));function c(ve){return k(ve)||S.has(ve)}function m(ve,Ce){return ve===Ce||c(ve)&&c(Ce)}const a=new Map;function i(ve){if(a.has(ve))return a.get(ve);let Ce;const B=(0,M.$Tj)(ve);return B&&(Ce=B),a.set(ve,Ce),Ce}function r(ve){return R(ve)||C(ve)||p(ve)}function n(ve,Ce){return Ce.length===0?Ce=[ve]:ve.end===Ce[0].start?Ce[0].start=ve.start:Ce.unshift(ve),Ce}function o(ve,Ce){for(let B=Ce;B<ve.length;B++){const Q=ve.charCodeAt(B);if(C(Q)||p(Q)||B>0&&!r(ve.charCodeAt(B-1)))return B}return ve.length}function t(ve,Ce,B,Q){if(B===ve.length)return[];if(Q===Ce.length)return null;if(ve[B]!==Ce[Q].toLowerCase())return null;{let ee=null,H=Q+1;for(ee=t(ve,Ce,B+1,Q+1);!ee&&(H=o(Ce,H))<Ce.length;)ee=t(ve,Ce,B+1,H),H++;return ee===null?null:n({start:Q,end:Q+1},ee)}}function h(ve){let Ce=0,B=0,Q=0,ee=0,H=0;for(let He=0;He<ve.length;He++)H=ve.charCodeAt(He),C(H)&&Ce++,R(H)&&B++,r(H)&&Q++,p(H)&&ee++;const oe=Ce/ve.length,le=B/ve.length,Re=Q/ve.length,je=ee/ve.length;return{upperPercent:oe,lowerPercent:le,alphaPercent:Re,numericPercent:je}}function s(ve){const{upperPercent:Ce,lowerPercent:B}=ve;return B===0&&Ce>.6}function f(ve){const{upperPercent:Ce,lowerPercent:B,alphaPercent:Q,numericPercent:ee}=ve;return B>.2&&Ce<.8&&Q>.6&&ee<.2}function l(ve){let Ce=0,B=0,Q=0,ee=0;for(let H=0;H<ve.length;H++)Q=ve.charCodeAt(H),C(Q)&&Ce++,R(Q)&&B++,k(Q)&&ee++;return(Ce===0||B===0)&&ee===0?ve.length<=30:Ce<=5}function u(ve,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!l(ve)||Ce.length>60)return null;const B=h(Ce);if(!f(B)){if(!s(B))return null;Ce=Ce.toLowerCase()}let Q=null,ee=0;for(ve=ve.toLowerCase();ee<Ce.length&&(Q=t(ve,Ce,0,ee))===null;)ee=o(Ce,ee+1);return Q}e.$1j=u;function v(ve,Ce,B=!1){if(!Ce||Ce.length===0)return null;let Q=null,ee=0;for(ve=ve.toLowerCase(),Ce=Ce.toLowerCase();ee<Ce.length&&(Q=I(ve,Ce,0,ee,B),Q===null);)ee=b(Ce,ee+1);return Q}e.$2j=v;function I(ve,Ce,B,Q,ee){let H=0;if(B===ve.length)return[];if(Q===Ce.length)return null;if(!m(ve.charCodeAt(B),Ce.charCodeAt(Q))){const Re=i(ve.charCodeAt(B));if(!Re)return null;for(let je=0;je<Re.length;je++)if(!m(Re[je],Ce.charCodeAt(Q+je)))return null;H+=Re.length-1}let oe=null,le=Q+H+1;if(oe=I(ve,Ce,B+1,le,ee),!ee)for(;!oe&&(le=b(Ce,le))<Ce.length;)oe=I(ve,Ce,B+1,le,ee),le++;if(!oe)return null;if(ve.charCodeAt(B)!==Ce.charCodeAt(Q)){const Re=i(ve.charCodeAt(B));if(!Re)return oe;for(let je=0;je<Re.length;je++)if(Re[je]!==Ce.charCodeAt(Q+je))return oe}return n({start:Q,end:Q+H+1},oe)}function b(ve,Ce){for(let B=Ce;B<ve.length;B++)if(c(ve.charCodeAt(B))||B>0&&c(ve.charCodeAt(B-1)))return B;return ve.length}const g=P(e.$Wj,u,w),y=P(e.$Wj,u,$),L=new D.$Dc(1e4);function T(ve,Ce,B=!1){if(typeof ve!="string"||typeof Ce!="string")return null;let Q=L.get(ve);Q||(Q=new RegExp(d.$We(ve),"i"),L.set(ve,Q));const ee=Q.exec(Ce);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:B?y(ve,Ce):g(ve,Ce)}e.$3j=T;function U(ve,Ce){const B=ue(ve,ve.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?F(B):null}e.$4j=U;function j(ve,Ce,B,Q,ee,H){const oe=Math.min(13,ve.length);for(;B<oe;B++){const le=ue(ve,Ce,B,Q,ee,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return le}return[0,H]}e.$5j=j;function F(ve){if(typeof ve>"u")return[];const Ce=[],B=ve[1];for(let Q=ve.length-1;Q>1;Q--){const ee=ve[Q]+B,H=Ce[Ce.length-1];H&&H.end===ee?H.end=ee+1:Ce.push({start:ee,end:ee+1})}return Ce}e.$6j=F;const N=128;function O(){const ve=[],Ce=[];for(let B=0;B<=N;B++)Ce[B]=0;for(let B=0;B<=N;B++)ve.push(Ce.slice(0));return ve}function z(ve){const Ce=[];for(let B=0;B<=ve;B++)Ce[B]=0;return Ce}const K=z(2*N),te=z(2*N),x=O(),X=O(),Z=O(),ce=!1;function _(ve,Ce,B,Q,ee){function H(le,Re,je=" "){for(;le.length<Re;)le=je+le;return le}let oe=` |   |${Q.split("").map(le=>H(le,3)).join("|")}
`;for(let le=0;le<=B;le++)le===0?oe+=" |":oe+=`${Ce[le-1]}|`,oe+=ve[le].slice(0,ee+1).map(Re=>H(Re.toString(),3)).join("|")+`
`;return oe}function ge(ve,Ce,B,Q){ve=ve.substr(Ce),B=B.substr(Q),console.log(_(X,ve,ve.length,B,B.length)),console.log(_(Z,ve,ve.length,B,B.length)),console.log(_(x,ve,ve.length,B,B.length))}function ne(ve,Ce){if(Ce<0||Ce>=ve.length)return!1;const B=ve.codePointAt(Ce);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!d.$tf(B)}}function J(ve,Ce){if(Ce<0||Ce>=ve.length)return!1;switch(ve.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function W(ve,Ce,B){return Ce[ve]!==B[ve]}function re(ve,Ce,B,Q,ee,H,oe=!1){for(;Ce<B&&ee<H;)ve[Ce]===Q[ee]&&(oe&&(K[Ce]=ee),Ce+=1),ee+=1;return Ce===B}e.$7j=re;var ye;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var he;(function(ve){ve.Default=[-100,0];function Ce(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}ve.isDefault=Ce})(he||(e.FuzzyScore=he={}));class fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,B){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=B}}e.$8j=fe;function ue(ve,Ce,B,Q,ee,H,oe=fe.default){const le=ve.length>N?N:ve.length,Re=Q.length>N?N:Q.length;if(B>=le||H>=Re||le-B>Re-H||!re(Ce,B,le,ee,H,Re,!0))return;me(le,Re,B,H,Ce,ee);let je=1,He=1,Qe=B,_e=H;const at=[!1];for(je=1,Qe=B;Qe<le;je++,Qe++){const Ae=K[Qe],Ze=te[Qe],ie=Qe+1<le?te[Qe+1]:Re;for(He=Ae-H+1,_e=Ae;_e<ie;He++,_e++){let se=Number.MIN_SAFE_INTEGER,Ie=!1;_e<=Ze&&(se=V(ve,Ce,Qe,B,Q,ee,_e,Re,H,x[je-1][He-1]===0,at));let qe=0;se!==Number.MAX_SAFE_INTEGER&&(Ie=!0,qe=se+X[je-1][He-1]);const Ye=_e>Ae,it=Ye?X[je][He-1]+(x[je][He-1]>0?-5:0):0,nt=_e>Ae+1&&x[je][He-1]>0,Oe=nt?X[je][He-2]+(x[je][He-2]>0?-5:0):0;if(nt&&(!Ye||Oe>=it)&&(!Ie||Oe>=qe))X[je][He]=Oe,Z[je][He]=3,x[je][He]=0;else if(Ye&&(!Ie||it>=qe))X[je][He]=it,Z[je][He]=2,x[je][He]=0;else if(Ie)X[je][He]=qe,Z[je][He]=1,x[je][He]=x[je-1][He-1]+1;else throw new Error("not possible")}}if(ce&&ge(ve,B,Q,H),!at[0]&&!oe.firstMatchCanBeWeak)return;je--,He--;const st=[X[je][He],H];let rt=0,Le=0;for(;je>=1;){let Ae=He;do{const Ze=Z[je][Ae];if(Ze===3)Ae=Ae-2;else if(Ze===2)Ae=Ae-1;else break}while(Ae>=1);rt>1&&Ce[B+je-1]===ee[H+He-1]&&!W(Ae+H-1,Q,ee)&&rt+1>x[je][Ae]&&(Ae=He),Ae===He?rt++:rt=1,Le||(Le=Ae),je--,He=Ae-1,st.push(He)}Re===le&&oe.boostFullMatch&&(st[0]+=2);const ze=Le-le;return st[0]-=ze,st}e.$9j=ue;function me(ve,Ce,B,Q,ee,H){let oe=ve-1,le=Ce-1;for(;oe>=B&&le>=Q;)ee[oe]===H[le]&&(te[oe]=le,oe--),le--}function V(ve,Ce,B,Q,ee,H,oe,le,Re,je,He){if(Ce[B]!==H[oe])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return oe===B-Q?Qe=ve[B]===ee[oe]?7:5:W(oe,ee,H)&&(oe===0||!W(oe-1,ee,H))?(Qe=ve[B]===ee[oe]?7:5,_e=!0):ne(H,oe)&&(oe===0||!ne(H,oe-1))?Qe=5:(ne(H,oe-1)||J(H,oe-1))&&(Qe=5,_e=!0),Qe>1&&B===Q&&(He[0]=!0),_e||(_e=W(oe,ee,H)||ne(H,oe-1)||J(H,oe-1)),B===Q?oe>Re&&(Qe-=_e?3:5):je?Qe+=_e?2:0:Qe+=_e?0:1,oe+1===le&&(Qe-=_e?3:5),Qe}function Y(ve,Ce,B,Q,ee,H,oe){return pe(ve,Ce,B,Q,ee,H,!0,oe)}e.$0j=Y;function de(ve,Ce,B,Q,ee,H,oe){return pe(ve,Ce,B,Q,ee,H,!1,oe)}e.$$j=de;function pe(ve,Ce,B,Q,ee,H,oe,le){let Re=ue(ve,Ce,B,Q,ee,H,le);if(Re&&!oe)return Re;if(ve.length>=3){const je=Math.min(7,ve.length-1);for(let He=B+1;He<je;He++){const Qe=Pe(ve,He);if(Qe){const _e=ue(Qe,Qe.toLowerCase(),B,Q,ee,H,le);_e&&(_e[0]-=3,(!Re||_e[0]>Re[0])&&(Re=_e))}}}return Re}function Pe(ve,Ce){if(Ce+1>=ve.length)return;const B=ve[Ce],Q=ve[Ce+1];if(B!==Q)return ve.slice(0,Ce)+Q+B+ve.slice(Ce+2)}}),define(ke[54],Se([1,0,13]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;function M(a){return d(a,0)}e.$Vi=M;function d(a,i){switch(typeof a){case"object":return a===null?P(349,i):Array.isArray(a)?$(a,i):E(a,i);case"string":return w(a,i);case"boolean":return A(a,i);case"number":return P(a,i);case"undefined":return P(937,i);default:return P(617,i)}}e.$Wi=d;function P(a,i){return(i<<5)-i+a|0}e.$Xi=P;function A(a,i){return P(a?433:863,i)}function w(a,i){i=P(149417,i);for(let r=0,n=a.length;r<n;r++)i=P(a.charCodeAt(r),i);return i}e.$Yi=w;function $(a,i){return i=P(104579,i),a.reduce((r,n)=>d(n,r),i)}function E(a,i){return i=P(181387,i),Object.keys(a).sort().reduce((r,n)=>(r=w(n,r),d(a[n],r)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=d(i,this.g),this.g}}e.$Zi=R;var C;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function p(a,i,r=32){const n=r-i,o=~((1<<n)-1);return(a<<i|(o&a)>>>n)>>>0}function k(a,i=0,r=a.byteLength,n=0){for(let o=0;o<r;o++)a[i+o]=n}function S(a,i,r="0"){for(;a.length<i;)a=r+a;return a}function c(a,i=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(r=>r.toString(16).padStart(2,"0")).join(""):S((a>>>0).toString(16),i/4)}e.$1i=c;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const r=i.length;if(r===0)return;const n=this.p;let o=this.r,t=this.u,h,s;for(t!==0?(h=t,s=-1,t=0):(h=i.charCodeAt(0),s=0);;){let f=h;if(D.$ef(h))if(s+1<r){const l=i.charCodeAt(s+1);D.$ff(l)?(s++,f=D.$gf(h,l)):f=65533}else{t=h;break}else D.$ff(h)&&(f=65533);if(o=this.w(n,o,f),s++,s<r)h=i.charCodeAt(s);else break}this.r=o,this.u=t}w(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=m.g,r=this.q;for(let v=0;v<64;v+=4)i.setUint32(v,r.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)i.setUint32(v,p(i.getUint32(v-12,!1)^i.getUint32(v-32,!1)^i.getUint32(v-56,!1)^i.getUint32(v-64,!1),1),!1);let n=this.h,o=this.l,t=this.m,h=this.n,s=this.o,f,l,u;for(let v=0;v<80;v++)v<20?(f=o&t|~o&h,l=1518500249):v<40?(f=o^t^h,l=1859775393):v<60?(f=o&t|o&h|t&h,l=2400959708):(f=o^t^h,l=3395469782),u=p(n,5)+f+s+l+i.getUint32(v*4,!1)&4294967295,s=h,h=t,t=p(o,30),o=n,n=u;this.h=this.h+n&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+h&4294967295,this.o=this.o+s&4294967295}}e.$2i=m}),define(ke[39],Se([1,0,13]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(M||(M={})),function(d){const P="error",A="warning",w="warn",$="info",E="ignore";function R(p){return p?D.$af(P,p)?d.Error:D.$af(A,p)||D.$af(w,p)?d.Warning:D.$af($,p)?d.Info:d.Ignore:d.Ignore}d.fromValue=R;function C(p){switch(p){case d.Error:return P;case d.Warning:return A;case d.Info:return $;default:return E}}d.toString=C}(M||(M={})),e.default=M}),define(ke[163],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(ke[78],Se([1,0,19,13]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class d{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const S=k.charCodeAt(0),c=this.b.charCodeAt(this.c);return S-c}value(){return this.b[this.c]}}e.$0h=d;class P{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,M.$7e)(k,this.b,0,k.length,this.c,this.d):(0,M.$9e)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=P;class A{constructor(k=!0,S=!0){this.f=k,this.g=S}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let S=k.length-1;S>=0;S--,this.c--){const c=this.b.charCodeAt(S);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,M.$7e)(k,this.b,0,k.length,this.d,this.e):(0,M.$9e)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=A;var w;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(w||(w={}));class ${constructor(k,S){this.f=k,this.g=S,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,M.$8e)(k,this.c.scheme);if(this.d[this.e]===2)return(0,M.$8e)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,M.$6e)(k,this.c.query);if(this.d[this.e]===5)return(0,M.$6e)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=$;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(R||(R={}));class C{static forUris(k=()=>!1,S=()=>!1){return new C(new $(k,S))}static forPaths(k=!1){return new C(new A(void 0,!k))}static forStrings(){return new C(new d)}static forConfigKeys(){return new C(new P)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,S){if(S){const c=S.slice(0);(0,D.$Xb)(c);for(const m of c)this.set(m,k)}else{const c=k.slice(0);(0,D.$Xb)(c);for(const m of c)this.set(m[0],m[1])}}set(k,S){const c=this.b.reset(k);let m;this.c||(this.c=new E,this.c.segment=c.value());const a=[];for(m=this.c;;){const r=c.cmp(m.segment);if(r>0)m.left||(m.left=new E,m.left.segment=c.value()),a.push([-1,m]),m=m.left;else if(r<0)m.right||(m.right=new E,m.right.segment=c.value()),a.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new E,m.mid.segment=c.value()),a.push([0,m]),m=m.mid;else break}const i=m.value;m.value=S,m.key=k;for(let r=a.length-1;r>=0;r--){const n=a[r][1];n.updateHeight();const o=n.balanceFactor();if(o<-1||o>1){const t=a[r][0],h=a[r+1][0];if(t===1&&h===1)a[r][1]=n.rotateLeft();else if(t===-1&&h===-1)a[r][1]=n.rotateRight();else if(t===1&&h===-1)n.right=a[r+1][1]=a[r+1][1].rotateRight(),a[r][1]=n.rotateLeft();else if(t===-1&&h===1)n.left=a[r+1][1]=a[r+1][1].rotateLeft(),a[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(a[r-1][0]){case-1:a[r-1][1].left=a[r][1];break;case 1:a[r-1][1].right=a[r][1];break;case 0:a[r-1][1].mid=a[r][1];break}else this.c=a[0][1]}}return i}get(k){return this.d(k)?.value}d(k){const S=this.b.reset(k);let c=this.c;for(;c;){const m=S.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(S.hasNext())S.next(),c=c.mid;else break}return c}has(k){const S=this.d(k);return!(S?.value===void 0&&S?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,S){const c=this.b.reset(k),m=[];let a=this.c;for(;a;){const i=c.cmp(a.segment);if(i>0)m.push([-1,a]),a=a.left;else if(i<0)m.push([1,a]),a=a.right;else if(c.hasNext())c.next(),m.push([0,a]),a=a.mid;else break}if(a){if(S?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const i=this.f(a.right);if(i.key){const{key:r,value:n,segment:o}=i;this.e(i.key,!1),a.key=r,a.value=n,a.segment=o}}else{const i=a.left??a.right;if(m.length>0){const[r,n]=m[m.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=m.length-1;i>=0;i--){const r=m[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),m[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),m[i][1]=r.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this.c=m[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const S=this.b.reset(k);let c=this.c,m;for(;c;){const a=S.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(S.hasNext())S.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(k){return this.g(k,!1)}g(k,S){const c=this.b.reset(k);let m=this.c;for(;m;){const a=c.cmp(m.segment);if(a>0)m=m.left;else if(a<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this.h(m.mid):S?m.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[S,c]of this)k(c,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const S=[];return this.j(k,S),S[Symbol.iterator]()}j(k,S){k&&(k.left&&this.j(k.left,S),k.value&&S.push([k.key,k.value]),k.mid&&this.j(k.mid,S),k.right&&this.j(k.right,S))}_isBalanced(){const k=S=>{if(!S)return!0;const c=S.balanceFactor();return c<-1||c>1?!1:k(S.left)&&k(S.right)};return k(this.c)}}e.$bi=C}),define(ke[18],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function D(o){return typeof o=="string"}e.$Jf=D;function M(o){return Array.isArray(o)&&o.every(t=>D(t))}e.$Kf=M;function d(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.$Lf=d;function P(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.$Mf=P;function A(o){return typeof o=="number"&&!isNaN(o)}e.$Nf=A;function w(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.$Of=w;function $(o){return o===!0||o===!1}e.$Pf=$;function E(o){return typeof o>"u"}e.$Qf=E;function R(o){return!C(o)}e.$Rf=R;function C(o){return E(o)||o===null}e.$Sf=C;function p(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Tf=p;function k(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.$Uf=k;function S(...o){const t=[];for(let h=0;h<o.length;h++){const s=o[h];if(C(s))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);t.push(s)}return t}e.$Vf=S;const c=Object.prototype.hasOwnProperty;function m(o){if(!d(o))return!1;for(const t in o)if(c.call(o,t))return!1;return!0}e.$Wf=m;function a(o){return typeof o=="function"}e.$Xf=a;function i(...o){return o.length>0&&o.every(a)}e.$Yf=i;function r(o,t){const h=Math.min(o.length,t.length);for(let s=0;s<h;s++)n(o[s],t[s])}e.$Zf=r;function n(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!C(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=n}),define(ke[79],Se([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=void 0;const M=Object.create(null);function d(w,$){if((0,D.$Jf)($)){const E=M[$];if(E===void 0)throw new Error(`${w} references an unknown codicon: ${$}`);$=E}return M[w]=$,{id:w}}function P(){return M}e.$_j=P;function A(){return Object.values(e.$bk)}e.$ak=A,e.$bk={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),gitPullRequestLabel:d("git-pull-request-label",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugBreakpointPending:d("debug-breakpoint-pending",60377),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),gitPullRequestMilestone:d("git-pull-request-milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),gitPullRequestReviewer:d("git-pull-request-reviewer",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),gitPullRequestAssignee:d("git-pull-request-assignee",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),mic:d("mic",60434),thumbsDownFilled:d("thumbsdown-filled",60435),thumbsUpFilled:d("thumbsup-filled",60436),coffee:d("coffee",60437),snake:d("snake",60438),game:d("game",60439),vr:d("vr",60440),chip:d("chip",60441),piano:d("piano",60442),music:d("music",60443),micFilled:d("mic-filled",60444),gitFetch:d("git-fetch",60445),copilot:d("copilot",60446),lightbulbSparkle:d("lightbulb-sparkle",60447),lightbulbSparkleAutofix:d("lightbulb-sparkle-autofix",60447),robot:d("robot",60448),sparkleFilled:d("sparkle-filled",60449),diffSingle:d("diff-single",60450),diffMultiple:d("diff-multiple",60451),surroundWith:d("surround-with",60452),gitStash:d("git-stash",60454),gitStashApply:d("git-stash-apply",60455),gitStashPop:d("git-stash-pop",60456),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function M(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const i=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?M(n):n}),i}e.$yn=M;function d(a){if(!a||typeof a!="object")return a;const i=[a];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(P.call(r,n)){const o=r[n];typeof o=="object"&&!Object.isFrozen(o)&&!(0,D.$Mf)(o)&&i.push(o)}}return a}e.$zn=d;const P=Object.prototype.hasOwnProperty;function A(a,i){return w(a,i,new Set)}e.$An=A;function w(a,i,r){if((0,D.$Sf)(a))return a;const n=i(a);if(typeof n<"u")return n;if(Array.isArray(a)){const o=[];for(const t of a)o.push(w(t,i,r));return o}if((0,D.$Lf)(a)){if(r.has(a))throw new Error("Cannot clone recursive data-structure");r.add(a);const o={};for(const t in a)P.call(a,t)&&(o[t]=w(a[t],i,r));return r.delete(a),o}return a}function $(a,i,r=!0){return(0,D.$Lf)(a)?((0,D.$Lf)(i)&&Object.keys(i).forEach(n=>{n in a?r&&((0,D.$Lf)(a[n])&&(0,D.$Lf)(i[n])?$(a[n],i[n],r):a[n]=i[n]):a[n]=i[n]}),a):i}e.$Bn=$;function E(a,i){if(a===i)return!0;if(a==null||i===null||i===void 0||typeof a!=typeof i||typeof a!="object"||Array.isArray(a)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(a)){if(a.length!==i.length)return!1;for(r=0;r<a.length;r++)if(!E(a[r],i[r]))return!1}else{const o=[];for(n in a)o.push(n);o.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!E(o,t))return!1;for(r=0;r<o.length;r++)if(!E(a[o[r]],i[o[r]]))return!1}return!0}e.$Cn=E;function R(a){const i=new Set;return JSON.stringify(a,(r,n)=>{if((0,D.$Lf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$Dn=R;function C(a,i){const r=Object.create(null);return!a||!i||Object.keys(i).forEach(o=>{const t=a[o],h=i[o];E(t,h)||(r[o]=h)}),r}e.$En=C;function p(a,i){const r=i.toLowerCase(),n=Object.keys(a).find(o=>o.toLowerCase()===r);return n?a[n]:a[i]}e.$Fn=p;function k(a,i){const r=Object.create(null);for(const[n,o]of Object.entries(a))i(n,o)&&(r[n]=o);return r}e.$Gn=k;function S(a){let i=[];for(;Object.prototype!==a;)i=i.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return i}e.$Hn=S;function c(a){const i=[];for(const r of S(a))typeof a[r]=="function"&&i.push(r);return i}e.$In=c;function m(a,i){const r=o=>function(){const t=Array.prototype.slice.call(arguments,0);return i(o,t)},n={};for(const o of a)n[o]=r(o);return n}e.$Jn=m}),define(ke[55],Se([1,0,79]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var M;(function(A){function w($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=w})(M||(e.ThemeColor=M={}));function d(A){return{id:A}}e.$ck=d;var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(i){const r=w.exec(i.id);if(!r)return $(D.$bk.error);const[,n,o]=r,t=["codicon","codicon-"+n];return o&&t.push("codicon-modifier-"+o.substring(1)),t}A.asClassNameArray=$;function E(i){return $(i).join(" ")}A.asClassName=E;function R(i){return"."+$(i).join(".")}A.asCSSSelector=R;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}A.isThemeIcon=C;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function k(i){const r=p.exec(i);if(!r)return;const[,n]=r;return{id:n}}A.fromString=k;function S(i){return{id:i}}A.fromId=S;function c(i,r){let n=i.id;const o=n.lastIndexOf("~");return o!==-1&&(n=n.substring(0,o)),r&&(n=`${n}~${r}`),{id:n}}A.modify=c;function m(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}A.getModifier=m;function a(i,r){return i.id===r.id&&i.color?.id===r.color?.id}A.isEqual=a})(P||(e.ThemeIcon=P={}))}),define(ke[164],Se([1,0,123,13,55]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=void 0;const P="$(",A=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${A.source}`,"g");function $(a){return a.replace(w,(i,r)=>r?i:`\\${i}`)}e.$dk=$;const E=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(E,i=>`\\${i}`)}e.$ek=R;const C=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(a){return a.indexOf(P)===-1?a:a.replace(C,(i,r,n,o)=>n?i:r||o||"")}e.$fk=p;function k(a){return a?a.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.$gk=k;const S=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(a){S.lastIndex=0;let i="";const r=[];let n=0;for(;;){const o=S.lastIndex,t=S.exec(a),h=a.substring(o,t?.index);if(h.length>0){i+=h;for(let s=0;s<h.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.$hk=c;function m(a,i,r=!1){const{text:n,iconOffsets:o}=i;if(!o||o.length===0)return(0,D.$3j)(a,n,r);const t=(0,M.$Ue)(n," "),h=n.length-t.length,s=(0,D.$3j)(a,t,r);if(s)for(const f of s){const l=o[f.start+h]+h;f.start+=l,f.end+=l}return s}e.$ik=m}),define(ke[124],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=e.$Ie=e.Constants=void 0;var D;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function M(P){return P<0?0:P>255?255:P|0}e.$Ie=M;function d(P){return P<0?0:P>4294967295?4294967295:P|0}e.$Je=d}),define(ke[30],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(d){return D.test(d)}e.$qg=M,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function(w){for(let $=0;$<w.length;$++)w[$]=Math.floor(Math.random()*256);return w};const P=new Uint8Array(16),A=[];for(let w=0;w<256;w++)A.push(w.toString(16).padStart(2,"0"));return function(){d(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,E="";return E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E}}()}),define(ke[165],Se([1,0,19,53,30]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function P(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$pt=P;function A(C,p,k){const S={id:(0,d.$rg)(),name:C,uri:p,data:k};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$qt=A;class w{constructor(){this.a=new Map}get size(){let p=0;for(const k of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const k=[...this.a.keys()];return M.Iterable.some(this,([S,c])=>c.asFile())&&k.push("files"),R($(p),k)}get(p){return this.a.get(this.b(p))?.[0]}append(p,k){const S=this.a.get(p);S?S.push(k):this.a.set(this.b(p),[k])}replace(p,k){this.a.set(this.b(p),[k])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,k]of this.a)for(const S of k)yield[p,S]}b(p){return $(p)}}e.$rt=w;function $(C){return C.toLowerCase()}function E(C,p){return R($(C),p.map($))}e.$st=E;function R(C,p){if(C==="*/*")return p.length>0;if(p.includes(C))return!0;const k=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[S,c,m]=k;return m==="*"?p.some(a=>a.startsWith(c+"/")):!1}e.$tt=Object.freeze({create:C=>(0,D.$Mb)(C.map(p=>p.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$tt.split(C).filter(p=>!p.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function M(w,$,E,R=1){let C=!1;return new Promise(p=>{const k=setTimeout(()=>{if(!C)return C=!0,p(0)},E);d(w,$,R,S=>{if(!C)return C=!0,clearTimeout(k),p(S)})})}e.$tg=M;function d(w,$,E,R){if($===0)return R(0);const C=new D.Socket;C.once("connect",()=>(A(C),d(w+E,$-1,E,R))),C.once("data",()=>{}),C.once("error",p=>(A(C),p.code!=="ECONNREFUSED"?d(w+E,$-1,E,R):R(w))),C.connect(w,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(w,$,E,R="127.0.0.1"){let C=!1,p,k=1;const S=D.createServer({pauseOnConnect:!0});function c(m,a){C||(C=!0,S.removeAllListeners(),S.close(),p&&clearTimeout(p),a(m))}return new Promise(m=>{p=setTimeout(()=>{c(0,m)},E),S.on("listening",()=>{c(w,m)}),S.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&k<$?(w++,k++,S.listen(w,R)):c(0,m)}),S.on("close",()=>{c(0,m)}),S.listen(w,R)})}e.$vg=P;function A(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch($){console.error($)}}}),define(ke[125],Se([1,0,124]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=void 0;class M{constructor(w){const $=(0,D.$Ie)(w);this.c=$,this.a=M.d($),this.b=new Map}static d(w){const $=new Uint8Array(256);return $.fill(w),$}set(w,$){const E=(0,D.$Ie)($);w>=0&&w<256?this.a[w]=E:this.b.set(w,E)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ht=M;var d;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(d||(d={}));class P{constructor(){this.a=new M(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$it=P}),define(ke[167],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var D;(function(d){d[d.Unknown=0]="Unknown",d[d.Invalid=3]="Invalid",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function M(d){let P=0,A=0,w=0,$=0;for(let E=0,R=d.length;E<R;E++){const C=d.charCodeAt(E);C===13?(P===0&&(A=E),P++,E+1<R&&d.charCodeAt(E+1)===10?($|=2,E++):$|=3,w=E+1):C===10&&($|=1,P===0&&(A=E),P++,w=E+1)}return P===0&&(A=d.length),[P,A,d.length-w,$]}e.$wt=M}),define(ke[48],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class D{constructor(d,P){this.lineNumber=d,this.column=P}with(d=this.lineNumber,P=this.column){return d===this.lineNumber&&P===this.column?this:new D(d,P)}delta(d=0,P=0){return this.with(this.lineNumber+d,this.column+P)}equals(d){return D.equals(this,d)}static equals(d,P){return!d&&!P?!0:!!d&&!!P&&d.lineNumber===P.lineNumber&&d.column===P.column}isBefore(d){return D.isBefore(this,d)}static isBefore(d,P){return d.lineNumber<P.lineNumber?!0:P.lineNumber<d.lineNumber?!1:d.column<P.column}isBeforeOrEqual(d){return D.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,P){return d.lineNumber<P.lineNumber?!0:P.lineNumber<d.lineNumber?!1:d.column<=P.column}static compare(d,P){const A=d.lineNumber|0,w=P.lineNumber|0;if(A===w){const $=d.column|0,E=P.column|0;return $-E}return A-w}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new D(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Vs=D}),define(ke[29],Se([1,0,48]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class M{constructor(P,A,w,$){P>w||P===w&&A>$?(this.startLineNumber=w,this.startColumn=$,this.endLineNumber=P,this.endColumn=A):(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=w,this.endColumn=$)}isEmpty(){return M.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return M.containsPosition(this,P)}static containsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<P.startColumn||A.lineNumber===P.endLineNumber&&A.column>P.endColumn)}static strictContainsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<=P.startColumn||A.lineNumber===P.endLineNumber&&A.column>=P.endColumn)}containsRange(P){return M.containsRange(this,P)}static containsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>P.endColumn)}strictContainsRange(P){return M.strictContainsRange(this,P)}static strictContainsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<=P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>=P.endColumn)}plusRange(P){return M.plusRange(this,P)}static plusRange(P,A){let w,$,E,R;return A.startLineNumber<P.startLineNumber?(w=A.startLineNumber,$=A.startColumn):A.startLineNumber===P.startLineNumber?(w=A.startLineNumber,$=Math.min(A.startColumn,P.startColumn)):(w=P.startLineNumber,$=P.startColumn),A.endLineNumber>P.endLineNumber?(E=A.endLineNumber,R=A.endColumn):A.endLineNumber===P.endLineNumber?(E=A.endLineNumber,R=Math.max(A.endColumn,P.endColumn)):(E=P.endLineNumber,R=P.endColumn),new M(w,$,E,R)}intersectRanges(P){return M.intersectRanges(this,P)}static intersectRanges(P,A){let w=P.startLineNumber,$=P.startColumn,E=P.endLineNumber,R=P.endColumn;const C=A.startLineNumber,p=A.startColumn,k=A.endLineNumber,S=A.endColumn;return w<C?(w=C,$=p):w===C&&($=Math.max($,p)),E>k?(E=k,R=S):E===k&&(R=Math.min(R,S)),w>E||w===E&&$>R?null:new M(w,$,E,R)}equalsRange(P){return M.equalsRange(this,P)}static equalsRange(P,A){return!P&&!A?!0:!!P&&!!A&&P.startLineNumber===A.startLineNumber&&P.startColumn===A.startColumn&&P.endLineNumber===A.endLineNumber&&P.endColumn===A.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(P){return new D.$Vs(P.endLineNumber,P.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(P){return new D.$Vs(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,A){return new M(this.startLineNumber,this.startColumn,P,A)}setStartPosition(P,A){return new M(P,A,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(P){return new M(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(P){return new M(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new M(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,A=P){return new M(P.lineNumber,P.column,A.lineNumber,A.column)}static lift(P){return P?new M(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn)}static areIntersecting(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,A){if(P&&A){const E=P.startLineNumber|0,R=A.startLineNumber|0;if(E===R){const C=P.startColumn|0,p=A.startColumn|0;if(C===p){const k=P.endLineNumber|0,S=A.endLineNumber|0;if(k===S){const c=P.endColumn|0,m=A.endColumn|0;return c-m}return k-S}return C-p}return E-R}return(P?1:0)-(A?1:0)}static compareRangesUsingEnds(P,A){return P.endLineNumber===A.endLineNumber?P.endColumn===A.endColumn?P.startLineNumber===A.startLineNumber?P.startColumn-A.startColumn:P.startLineNumber-A.startLineNumber:P.endColumn-A.endColumn:P.endLineNumber-A.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Ws=M}),define(ke[168],Se([1,0,29]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class M{static insert(P,A){return{range:new D.$Ws(P.lineNumber,P.column,P.lineNumber,P.column),text:A,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,A){return{range:P,text:A}}static replaceMove(P,A){return{range:P,text:A,forceMoveMarkers:!0}}}e.$Xs=M}),define(ke[169],Se([1,0,48,29]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.SelectionDirection=void 0;var d;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class P extends M.$Ws{constructor(w,$,E,R){super(w,$,E,R),this.selectionStartLineNumber=w,this.selectionStartColumn=$,this.positionLineNumber=E,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return P.selectionsEqual(this,w)}static selectionsEqual(w,$){return w.selectionStartLineNumber===$.selectionStartLineNumber&&w.selectionStartColumn===$.selectionStartColumn&&w.positionLineNumber===$.positionLineNumber&&w.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,w,$):new P(w,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Vs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Vs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,$){return this.getDirection()===0?new P(w,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,w,$)}static fromPositions(w,$=w){return new P(w.lineNumber,w.column,$.lineNumber,$.column)}static fromRange(w,$){return $===0?new P(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new P(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new P(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,$){if(w&&!$||!w&&$)return!1;if(!w&&!$)return!0;if(w.length!==$.length)return!1;for(let E=0,R=w.length;E<R;E++)if(!this.selectionsEqual(w[E],$[E]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,$,E,R,C){return C===0?new P(w,$,E,R):new P(E,R,w,$)}}e.$Ys=P}),define(ke[170],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0,e.$us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,125]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.$jt=e.WordCharacterClass=void 0;var M;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class d extends D.$ht{constructor(w){super(0);for(let $=0,E=w.length;$<E;$++)this.set(w.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$jt=d;function P(A){const w={};return $=>(w.hasOwnProperty($)||(w[$]=A($)),w[$])}e.$kt=P(A=>new d(A))}),define(ke[126],Se([1,0,53,3,76]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.$ys=e.$xs=e.$ws=e.$vs=void 0,e.$vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(C=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$vs)C.indexOf(k)>=0||(p+="\\"+k);return p+="\\s]+)",new RegExp(p,"g")}e.$ws=P();function A(C){let p=e.$ws;if(C&&C instanceof RegExp)if(C.global)p=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),p=new RegExp(C.source,k)}return p.lastIndex=0,p}e.$xs=A;const w=new d.$4c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const p=w.unshift(C);return(0,M.$Rc)(p)}e.$ys=$;function E(C,p,k,S,c){if(p=A(p),c||(c=D.Iterable.first(w)),k.length>c.maxLen){let n=C-c.maxLen/2;return n<0?n=0:S+=n,k=k.substring(n,C+c.maxLen/2),E(C,p,k,S,c)}const m=Date.now(),a=C-1-S;let i=-1,r=null;for(let n=1;!(Date.now()-m>=c.timeBudget);n++){const o=a-c.windowSize*n;p.lastIndex=Math.max(0,o);const t=R(p,k,a,i);if(!t&&r||(r=t,o<=0))break;i=o}if(r){const n={word:r[0],startColumn:S+1+r.index,endColumn:S+1+r.index+r[0].length};return p.lastIndex=0,n}return null}e.$zs=E;function R(C,p,k,S){let c;for(;c=C.exec(p);){const m=c.index||0;if(m<=k&&C.lastIndex>=k)return c;if(S>0&&m>S)return null}return null}}),define(ke[172],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$Tt=e.IndentAction=void 0;var D;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class M{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let $=0,E=w.notIn.length;$<E;$++)switch(w.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,$){if(w.getTokenCount()===0)return!0;const E=w.findTokenIndexAtOffset($-2),R=w.getStandardTokenType(E);return this.isOK(R)}g(w,$){for(let E=w;E<=$;E++){const R=String.fromCharCode(E);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Tt=M;class d{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of w)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Ut=d;function P(A,w,$){A.has(w)?A.get(w).push($):A.set(w,[$])}}),define(ke[173],Se([1,0,125]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PZ=e.$OZ=e.$NZ=e.State=void 0;var M;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(M||(e.State=M={}));class d{constructor(S,c,m){const a=new Uint8Array(S*c);for(let i=0,r=S*c;i<r;i++)a[i]=m;this.a=a,this.rows=S,this.cols=c}get(S,c){return this.a[S*this.cols+c]}set(S,c,m){this.a[S*this.cols+c]=m}}class P{constructor(S){let c=0,m=0;for(let i=0,r=S.length;i<r;i++){const[n,o,t]=S[i];o>c&&(c=o),n>m&&(m=n),t>m&&(m=t)}c++,m++;const a=new d(m,c,0);for(let i=0,r=S.length;i<r;i++){const[n,o,t]=S[i];a.set(n,o,t)}this.a=a,this.b=c}nextState(S,c){return c<0||c>=this.b?0:this.a.get(S,c)}}e.$NZ=P;let A=null;function w(){return A===null&&(A=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var $;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})($||($={}));let E=null;function R(){if(E===null){E=new D.$ht(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<k.length;c++)E.set(k.charCodeAt(c),1);const S=".,;:";for(let c=0;c<S.length;c++)E.set(S.charCodeAt(c),2)}return E}class C{static a(S,c,m,a,i){let r=i-1;do{const n=c.charCodeAt(r);if(S.get(n)!==2)break;r--}while(r>a);if(a>0){const n=c.charCodeAt(a-1),o=c.charCodeAt(r);(n===40&&o===41||n===91&&o===93||n===123&&o===125)&&r--}return{range:{startLineNumber:m,startColumn:a+1,endLineNumber:m,endColumn:r+2},url:c.substring(a,r+1)}}static computeLinks(S,c=w()){const m=R(),a=[];for(let i=1,r=S.getLineCount();i<=r;i++){const n=S.getLineContent(i),o=n.length;let t=0,h=0,s=0,f=1,l=!1,u=!1,v=!1,I=!1;for(;t<o;){let b=!1;const g=n.charCodeAt(t);if(f===13){let y;switch(g){case 40:l=!0,y=0;break;case 41:y=l?0:1;break;case 91:v=!0,u=!0,y=0;break;case 93:v=!1,y=u?0:1;break;case 123:I=!0,y=0;break;case 125:y=I?0:1;break;case 39:case 34:case 96:s===g?y=1:s===39||s===34||s===96?y=0:y=1;break;case 42:y=s===42?1:0;break;case 124:y=s===124?1:0;break;case 32:y=v?0:1;break;default:y=m.get(g)}y===1&&(a.push(C.a(m,n,i,h,t)),b=!0)}else if(f===12){let y;g===91?(u=!0,y=0):y=m.get(g),y===1?b=!0:f=13}else f=c.nextState(f,g),f===0&&(b=!0);b&&(f=1,l=!1,u=!1,I=!1,h=t+1,s=g),t++}f===13&&a.push(C.a(m,n,i,h,o))}return a}}e.$OZ=C;function p(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:C.computeLinks(k)}e.$PZ=p}),define(ke[80],Se([1,0,24]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.ModelConstants=e.PositionAffinity=e.$dv=e.TrackedRangeStickiness=e.$cv=e.$bv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(e.OverviewRulerLane=M={}));var d;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(d||(e.GlyphMarginLane=d={}));var P;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var A;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var w;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(w||(e.EndOfLinePreference=w={}));var $;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,D.$Cn)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$bv=R;class C{constructor(o,t){this._findMatchBrand=void 0,this.range=o,this.matches=t}}e.$cv=C;var p;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function k(n){return n&&typeof n.read=="function"}e.$dv=k;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var c;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class m{constructor(o,t,h,s,f,l){this.identifier=o,this.range=t,this.text=h,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=f,this._isTracked=l}}e.$ev=m;class a{constructor(o,t,h){this.regex=o,this.wordSeparators=t,this.simpleSearch=h}}e.$fv=a;class i{constructor(o,t,h){this.reverseEdits=o,this.changes=t,this.trimAutoWhitespaceLineNumbers=h}}e.$gv=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$hv=r}),define(ke[174],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.NodeColor=e.$UB=void 0;class D{constructor(m,a){this.piece=m,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VB)return d(this.right);let m=this;for(;m.parent!==e.$VB&&m.parent.left!==m;)m=m.parent;return m.parent===e.$VB?e.$VB:m.parent}prev(){if(this.left!==e.$VB)return P(this.left);let m=this;for(;m.parent!==e.$VB&&m.parent.right!==m;)m=m.parent;return m.parent===e.$VB?e.$VB:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UB=D;var M;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$VB=new D(null,0),e.$VB.parent=e.$VB,e.$VB.left=e.$VB,e.$VB.right=e.$VB,e.$VB.color=0;function d(c){for(;c.left!==e.$VB;)c=c.left;return c}e.$WB=d;function P(c){for(;c.right!==e.$VB;)c=c.right;return c}e.$XB=P;function A(c){return c===e.$VB?0:c.size_left+c.piece.length+A(c.right)}function w(c){return c===e.$VB?0:c.lf_left+c.piece.lineFeedCnt+w(c.right)}function $(){e.$VB.parent=e.$VB}function E(c,m){const a=m.right;a.size_left+=m.size_left+(m.piece?m.piece.length:0),a.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=a.left,a.left!==e.$VB&&(a.left.parent=m),a.parent=m.parent,m.parent===e.$VB?c.root=a:m.parent.left===m?m.parent.left=a:m.parent.right=a,a.left=m,m.parent=a}e.$YB=E;function R(c,m){const a=m.left;m.left=a.right,a.right!==e.$VB&&(a.right.parent=m),a.parent=m.parent,m.size_left-=a.size_left+(a.piece?a.piece.length:0),m.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),m.parent===e.$VB?c.root=a:m===m.parent.right?m.parent.right=a:m.parent.left=a,a.right=m,m.parent=a}e.$ZB=R;function C(c,m){let a,i;if(m.left===e.$VB?(i=m,a=i.right):m.right===e.$VB?(i=m,a=i.left):(i=d(m.right),a=i.right),i===c.root){c.root=a,a.color=0,m.detach(),$(),c.root.parent=e.$VB;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=a:i.parent.right=a,i===m?(a.parent=i.parent,S(c,a)):(i.parent===m?a.parent=i:a.parent=i.parent,S(c,a),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===c.root?c.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.$VB&&(i.left.parent=i),i.right!==e.$VB&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,S(c,i)),m.detach(),a.parent.left===a){const o=A(a),t=w(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const h=o-a.parent.size_left,s=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,k(c,a.parent,h,s)}}if(S(c,a.parent),r){$();return}let n;for(;a!==c.root&&a.color===0;)a===a.parent.left?(n=a.parent.right,n.color===1&&(n.color=0,a.parent.color=1,E(c,a.parent),n=a.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,a=a.parent):(n.right.color===0&&(n.left.color=0,n.color=1,R(c,n),n=a.parent.right),n.color=a.parent.color,a.parent.color=0,n.right.color=0,E(c,a.parent),a=c.root)):(n=a.parent.left,n.color===1&&(n.color=0,a.parent.color=1,R(c,a.parent),n=a.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,a=a.parent):(n.left.color===0&&(n.right.color=0,n.color=1,E(c,n),n=a.parent.left),n.color=a.parent.color,a.parent.color=0,n.left.color=0,R(c,a.parent),a=c.root));a.color=0,$()}e.$1B=C;function p(c,m){for(S(c,m);m!==c.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const a=m.parent.parent.right;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,E(c,m)),m.parent.color=0,m.parent.parent.color=1,R(c,m.parent.parent))}else{const a=m.parent.parent.left;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,R(c,m)),m.parent.color=0,m.parent.parent.color=1,E(c,m.parent.parent))}c.root.color=0}e.$2B=p;function k(c,m,a,i){for(;m!==c.root&&m!==e.$VB;)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=i),m=m.parent}e.$3B=k;function S(c,m){let a=0,i=0;if(m!==c.root){for(;m!==c.root&&m===m.parent.right;)m=m.parent;if(m!==c.root)for(m=m.parent,a=A(m.left)-m.size_left,i=w(m.left)-m.lf_left,m.size_left+=a,m.lf_left+=i;m!==c.root&&(a!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=i),m=m.parent}}e.$4B=S}),define(ke[175],Se([1,0,19,124]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=void 0;class d{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,E){$=(0,M.$Je)($);const R=this.a,C=this.b,p=E.length;return p===0?!1:(this.a=new Uint32Array(R.length+p),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($),$+p),this.a.set(E,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,E){return $=(0,M.$Je)($),E=(0,M.$Je)(E),this.a[$]===E?!1:(this.a[$]=E,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,E){$=(0,M.$Je)($),E=(0,M.$Je)(E);const R=this.a,C=this.b;if($>=R.length)return!1;const p=R.length-$;return E>=p&&(E=p),E===0?!1:(this.a=new Uint32Array(R.length-E),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($+E),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,M.$Je)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),$>=this.a.length&&($=this.a.length-1);for(let R=E;R<=$;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let E=0,R=this.a.length-1,C=0,p=0,k=0;for(;E<=R;)if(C=E+(R-E)/2|0,p=this.b[C],k=p-this.a[C],$<k)R=C-1;else if($>=p)E=C+1;else break;return new A(C,$-k)}}e.$kv=d;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const E=this.e[$],R=E>0?this.d[E-1]:0;return new A(E,$-R)}removeValues($,E){this.a.splice($,E),this.f($)}insertValues($,E){this.a=(0,D.$Wb)(this.a,$,E),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,E=this.a.length;$<E;$++){const R=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+R;for(let p=0;p<R;p++)this.e[C+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,E){this.a[$]!==E&&(this.a[$]=E,this.f($))}}e.$lv=P;class A{constructor($,E){this.index=$,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=E}}e.$mv=A}),define(ke[176],Se([1,0,13,48,175]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=void 0;class P{constructor(w,$,E,R){this.d=w,this.f=$,this.g=E,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const $=w.changes;for(const E of $)this.o(E.range),this.p(new M.$Vs(E.range.startLineNumber,E.range.startColumn),E.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,$=this.f.length,E=new Uint32Array($);for(let R=0;R<$;R++)E[R]=this.f[R].length+w;this.j=new d.$kv(E)}}n(w,$){this.f[w]=$,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,$){if($.length===0)return;const E=(0,D.$1e)($);if(E.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+E[0]+this.f[w.lineNumber-1].substring(w.column-1));return}E[E.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+E[0]);const R=new Uint32Array(E.length-1);for(let C=1;C<E.length;C++)this.f.splice(w.lineNumber+C-1,0,E[C]),R[C-1]=E[C].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,R)}}e.$nv=P}),define(ke[99],Se([1,0,13,171,48,29,80]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0B=e.$9B=e.$8B=e.$7B=e.$6B=e.$5B=void 0;const w=999;class ${constructor(i,r,n,o){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=E(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=D.$Ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new A.$fv(r,this.wordSeparators?(0,M.$kt)(this.wordSeparators):null,n?this.searchString:null)}}e.$5B=$;function E(a){if(!a||a.length===0)return!1;for(let i=0,r=a.length;i<r;i++){const n=a.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const o=a.charCodeAt(i);if(o===110||o===114||o===87)return!0}}return!1}e.$6B=E;function R(a,i,r){if(!r)return new A.$cv(a,null);const n=[];for(let o=0,t=i.length;o<t;o++)n[o]=i[o];return new A.$cv(a,n)}e.$7B=R;class C{constructor(i){const r=[];let n=0;for(let o=0,t=i.length;o<t;o++)i.charCodeAt(o)===10&&(r[n++]=o);this.a=r}findLineFeedCountBeforeOffset(i){const r=this.a;let n=0,o=r.length-1;if(o===-1||i<=r[0])return 0;for(;n<o;){const t=n+((o-n)/2>>0);r[t]>=i?o=t-1:r[t+1]>=i?(n=t,o=t):n=t+1}return n+1}}class p{static findMatches(i,r,n,o,t){const h=r.parseSearchRequest();return h?h.regex.multiline?this.b(i,n,new m(h.wordSeparators,h.regex),o,t):this.c(i,n,h,o,t):[]}static a(i,r,n,o,t,h){let s,f=0;o?(f=o.findLineFeedCountBeforeOffset(t),s=r+t+f):s=r+t;let l;if(o){const b=o.findLineFeedCountBeforeOffset(t+h.length)-f;l=s+h.length+b}else l=s+h.length;const u=i.getPositionAt(s),v=i.getPositionAt(l);return new P.$Ws(u.lineNumber,u.column,v.lineNumber,v.column)}static b(i,r,n,o,t){const h=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),f=i.getEOL()===`\r
`?new C(s):null,l=[];let u=0,v;for(n.reset(0);v=n.next(s);)if(l[u++]=R(this.a(i,h,s,f,v.index,v[0]),v,o),u>=t)return l;return l}static c(i,r,n,o,t){const h=[];let s=0;if(r.startLineNumber===r.endLineNumber){const l=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this.d(n,l,r.startLineNumber,r.startColumn-1,s,h,o,t),h}const f=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this.d(n,f,r.startLineNumber,r.startColumn-1,s,h,o,t);for(let l=r.startLineNumber+1;l<r.endLineNumber&&s<t;l++)s=this.d(n,i.getLineContent(l),l,0,s,h,o,t);if(s<t){const l=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this.d(n,l,r.endLineNumber,0,s,h,o,t)}return h}static d(i,r,n,o,t,h,s,f){const l=i.wordSeparators;if(!s&&i.simpleSearch){const I=i.simpleSearch,b=I.length,g=r.length;let y=-b;for(;(y=r.indexOf(I,y+b))!==-1;)if((!l||c(l,r,g,y,b))&&(h[t++]=new A.$cv(new P.$Ws(n,y+1+o,n,y+1+b+o),null),t>=f))return t;return t}const u=new m(i.wordSeparators,i.regex);let v;u.reset(0);do if(v=u.next(r),v&&(h[t++]=R(new P.$Ws(n,v.index+1+o,n,v.index+1+v[0].length+o),v,s),t>=f))return t;while(v);return t}static findNextMatch(i,r,n,o){const t=r.parseSearchRequest();if(!t)return null;const h=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,h,o):this.f(i,n,h,o)}static e(i,r,n,o){const t=new d.$Vs(r.lineNumber,1),h=i.getOffsetAt(t),s=i.getLineCount(),f=i.getValueInRange(new P.$Ws(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),l=i.getEOL()===`\r
`?new C(f):null;n.reset(r.column-1);const u=n.next(f);return u?R(this.a(i,h,f,l,u.index,u[0]),u,o):r.lineNumber!==1||r.column!==1?this.e(i,new d.$Vs(1,1),n,o):null}static f(i,r,n,o){const t=i.getLineCount(),h=r.lineNumber,s=i.getLineContent(h),f=this.g(n,s,h,r.column,o);if(f)return f;for(let l=1;l<=t;l++){const u=(h+l-1)%t,v=i.getLineContent(u+1),I=this.g(n,v,u+1,1,o);if(I)return I}return null}static g(i,r,n,o,t){i.reset(o-1);const h=i.next(r);return h?R(new P.$Ws(n,h.index+1,n,h.index+1+h[0].length),h,t):null}static findPreviousMatch(i,r,n,o){const t=r.parseSearchRequest();if(!t)return null;const h=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,h,o):this.j(i,n,h,o)}static h(i,r,n,o){const t=this.b(i,new P.$Ws(1,1,r.lineNumber,r.column),n,o,10*w);if(t.length>0)return t[t.length-1];const h=i.getLineCount();return r.lineNumber!==h||r.column!==i.getLineMaxColumn(h)?this.h(i,new d.$Vs(h,i.getLineMaxColumn(h)),n,o):null}static j(i,r,n,o){const t=i.getLineCount(),h=r.lineNumber,s=i.getLineContent(h).substring(0,r.column-1),f=this.k(n,s,h,o);if(f)return f;for(let l=1;l<=t;l++){const u=(t+h-l-1)%t,v=i.getLineContent(u+1),I=this.k(n,v,u+1,o);if(I)return I}return null}static k(i,r,n,o){let t=null,h;for(i.reset(0);h=i.next(r);)t=R(new P.$Ws(n,h.index+1,n,h.index+1+h[0].length),h,o);return t}}e.$8B=p;function k(a,i,r,n,o){if(n===0)return!0;const t=i.charCodeAt(n-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const h=i.charCodeAt(n);if(a.get(h)!==0)return!0}return!1}function S(a,i,r,n,o){if(n+o===r)return!0;const t=i.charCodeAt(n+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const h=i.charCodeAt(n+o-1);if(a.get(h)!==0)return!0}return!1}function c(a,i,r,n,o){return k(a,i,r,n,o)&&S(a,i,r,n,o)}e.$9B=c;class m{constructor(i,r){this._wordSeparators=i,this.a=r,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const r=i.length;let n;do{if(this.b+this.c===r||(n=this.a.exec(i),!n))return null;const o=n.index,t=n[0].length;if(o===this.b&&t===this.c){if(t===0){D.$hf(i,r,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||c(this._wordSeparators,i,r,o,t))return n}while(n);return null}}e.$0B=m}),define(ke[127],Se([1,0,48,29,80,174,99]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=void 0;const w=65535;function $(a){let i;return a[a.length-1]<65536?i=new Uint16Array(a.length):i=new Uint32Array(a.length),i.set(a,0),i}class E{constructor(i,r,n,o,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=o,this.isBasicASCII=t}}function R(a,i=!0){const r=[0];let n=1;for(let o=0,t=a.length;o<t;o++){const h=a.charCodeAt(o);h===13?o+1<t&&a.charCodeAt(o+1)===10?(r[n++]=o+2,o++):r[n++]=o+1:h===10&&(r[n++]=o+1)}return i?$(r):r}e.$$B=R;function C(a,i){a.length=0,a[0]=0;let r=1,n=0,o=0,t=0,h=!0;for(let f=0,l=i.length;f<l;f++){const u=i.charCodeAt(f);u===13?f+1<l&&i.charCodeAt(f+1)===10?(t++,a[r++]=f+2,f++):(n++,a[r++]=f+1):u===10?(o++,a[r++]=f+1):h&&u!==9&&(u<32||u>126)&&(h=!1)}const s=new E($(a),n,o,t,h);return a.length=0,s}e.$_B=C;class p{constructor(i,r,n,o,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=o,this.length=t}}e.$aC=p;class k{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$bC=k;class S{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==P.$VB&&i.iterate(i.root,n=>(n!==P.$VB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const n=this.b;for(let o=0;o<n.length;o++){const t=n[o];if(t.node.parent===null||t.nodeStartOffset>=i){n[o]=null,r=!0;continue}}if(r){const o=[];for(const t of n)t!==null&&o.push(t);this.b=o}}}class m{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this.a=[new k("",[0])],this.g={line:0,column:0},this.root=P.$VB,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=n;let o=null;for(let t=0,h=i.length;t<h;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const s=new p(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),o=this.S(o,s)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=w,n=r-Math.floor(r/3),o=n*2;let t="",h=0;const s=[];if(this.iterate(this.root,f=>{const l=this.R(f),u=l.length;if(h<=n||h+u<o)return t+=l,h+=u,!0;const v=t.replace(/\r\n|\r|\n/g,i);return s.push(new k(v,R(v))),t=l,h=u,!0}),h>0){const f=t.replace(/\r\n|\r|\n/g,i);s.push(new k(f,R(f)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,o=>{if(o===P.$VB)return!0;const t=this.R(o),h=t.length,s=i.G(r),f=i.G(r+h),l=i.getValueInRange2(s,f);return r+=h,t===l})}getOffsetAt(i,r){let n=0,o=this.root;for(;o!==P.$VB;)if(o.left!==P.$VB&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){n+=o.size_left;const t=this.B(o,i-o.lf_left-2);return n+=t+r-1}else i-=o.lf_left+o.piece.lineFeedCnt,n+=o.size_left+o.piece.length,o=o.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const o=i;for(;r!==P.$VB;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.A(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const h=this.getOffsetAt(n+1,1),s=o-h;return new D.$Vs(n+1,s+1)}return new D.$Vs(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===P.$VB){const t=this.getOffsetAt(n+1,1),h=o-i-t;return new D.$Vs(n+1,h+1)}else r=r.right;return new D.$Vs(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,o);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,f=this.a[s.piece.bufferIndex].buffer,l=this.u(s.piece.bufferIndex,s.piece.start);return f.substring(l+i.remainder,l+r.remainder)}let n=i.node;const o=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let h=o.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==P.$VB;){const s=this.a[n.piece.bufferIndex].buffer,f=this.u(n.piece.bufferIndex,n.piece.start);if(n===r.node){h+=s.substring(f,f+r.remainder);break}else h+=s.substr(f,n.piece.length);n=n.next()}return h}getLinesContent(){const i=[];let r=0,n="",o=!1;return this.iterate(this.root,t=>{if(t===P.$VB)return!0;const h=t.piece;let s=h.length;if(s===0)return!0;const f=this.a[h.bufferIndex].buffer,l=this.a[h.bufferIndex].lineStarts,u=h.start.line,v=h.end.line;let I=l[u]+h.start.column;if(o&&(f.charCodeAt(I)===10&&(I++,s--),i[r++]=n,n="",o=!1,s===0))return!0;if(u===v)return!this.f&&f.charCodeAt(I+s-1)===13?(o=!0,n+=f.substr(I,s-1)):n+=f.substr(I,s),!0;n+=this.f?f.substring(I,Math.max(I,l[u+1]-this.e)):f.substring(I,l[u+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let b=u+1;b<v;b++)n=this.f?f.substring(l[b],l[b+1]-this.e):f.substring(l[b],l[b+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this.f&&f.charCodeAt(l[v]+h.end.column-1)===13?(o=!0,h.end.column===0?r--:n=f.substr(l[v],h.end.column-1)):n=f.substr(l[v],h.end.column),!0}),o&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this.a[r.piece.bufferIndex],o=this.u(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(o)}else{const r=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(o)}}getLineCharCode(i,r){const n=this.H(i,r+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}findMatchesInNode(i,r,n,o,t,h,s,f,l,u,v){const I=this.a[i.piece.bufferIndex],b=this.u(i.piece.bufferIndex,i.piece.start),g=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,h);let L;const T={line:0,column:0};let U,j;r._wordSeparators?(U=I.buffer.substring(g,y),j=F=>F+g,r.reset(0)):(U=I.buffer,j=F=>F,r.reset(g));do if(L=r.next(U),L){if(j(L.index)>=y)return u;this.s(i,j(L.index)-b,T);const F=this.t(i.piece.bufferIndex,t,T),N=T.line===t.line?T.column-t.column+o:T.column+1,O=N+L[0].length;if(v[u++]=(0,A.$7B)(new M.$Ws(n+F,N,n+F,O),L,f),j(L.index)+L[0].length>=y||u>=l)return u}while(L);return u}findMatchesLineByLine(i,r,n,o){const t=[];let h=0;const s=new A.$0B(r.wordSeparators,r.regex);let f=this.H(i.startLineNumber,i.startColumn);if(f===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let u=this.s(f.node,f.remainder);const v=this.s(l.node,l.remainder);if(f.node===l.node)return this.findMatchesInNode(f.node,s,i.startLineNumber,i.startColumn,u,v,r,n,o,h,t),t;let I=i.startLineNumber,b=f.node;for(;b!==l.node;){const y=this.t(b.piece.bufferIndex,u,b.piece.end);if(y>=1){const T=this.a[b.piece.bufferIndex].lineStarts,U=this.u(b.piece.bufferIndex,b.piece.start),j=T[u.line+y],F=I===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(b,s,I,F,u,this.s(b,j-U),r,n,o,h,t),h>=o)return t;I+=y}const L=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const T=this.getLineContent(I).substring(L,i.endColumn-1);return h=this.n(r,s,T,i.endLineNumber,L,h,t,n,o),t}if(h=this.n(r,s,this.getLineContent(I).substr(L),I,L,h,t,n,o),h>=o)return t;I++,f=this.H(I,1),b=f.node,u=this.s(f.node,f.remainder)}if(I===i.endLineNumber){const y=I===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(I).substring(y,i.endColumn-1);return h=this.n(r,s,L,i.endLineNumber,y,h,t,n,o),t}const g=I===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(l.node,s,I,g,u,v,r,n,o,h,t),t}n(i,r,n,o,t,h,s,f,l){const u=i.wordSeparators;if(!f&&i.simpleSearch){const I=i.simpleSearch,b=I.length,g=n.length;let y=-b;for(;(y=n.indexOf(I,y+b))!==-1;)if((!u||(0,A.$9B)(u,n,g,y,b))&&(s[h++]=new d.$cv(new M.$Ws(o,y+1+t,o,y+1+b+t),null),h>=l))return h;return h}let v;r.reset(0);do if(v=r.next(n),v&&(s[h++]=(0,A.$7B)(new M.$Ws(o,v.index+1+t,o,v.index+1+v[0].length+t),v,f),h>=l))return h;while(v);return h}insert(i,r,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==P.$VB){const{node:o,remainder:t,nodeStartOffset:h}=this.G(i),s=o.piece,f=s.bufferIndex,l=this.s(o,t);if(o.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&h+s.length===i&&r.length<w){this.F(o,r),this.y();return}if(h===i)this.o(r,o),this.h.validate(i);else if(h+o.piece.length>i){const u=[];let v=new p(s.bufferIndex,l,s.end,this.t(s.bufferIndex,l,s.end),this.u(f,s.end)-this.u(f,l));if(this.K()&&this.M(r)&&this.I(o,t)===10){const y={line:v.start.line+1,column:0};v=new p(v.bufferIndex,y,v.end,this.t(v.bufferIndex,y,v.end),v.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(o,t-1)===13){const y=this.s(o,t-1);this.C(o,y),r="\r"+r,o.piece.length===0&&u.push(o)}else this.C(o,l);else this.C(o,l);const I=this.w(r);v.length>0&&this.S(o,v);let b=o;for(let g=0;g<I.length;g++)b=this.S(b,I[g]);this.v(u)}else this.q(r,o)}else{const o=this.w(r);let t=this.T(null,o[0]);for(let h=1;h<o.length;h++)t=this.S(t,o[h])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===P.$VB)return;const n=this.G(i),o=this.G(i+r),t=n.node,h=o.node;if(t===h){const I=this.s(t,n.remainder),b=this.s(t,o.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const g=t.next();(0,P.$1B)(this,t),this.N(g),this.y();return}this.D(t,b),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+r){this.C(t,I),this.O(t),this.y();return}this.E(t,I,b),this.y();return}const s=[],f=this.s(t,n.remainder);this.C(t,f),this.h.validate(i),t.piece.length===0&&s.push(t);const l=this.s(h,o.remainder);this.D(h,l),h.piece.length===0&&s.push(h);const u=t.next();for(let I=u;I!==P.$VB&&I!==h;I=I.next())s.push(I);const v=t.piece.length===0?t.prev():t;this.v(s),this.O(v),this.y()}o(i,r){const n=[];if(this.K()&&this.M(i)&&this.L(r)){const h=r.piece,s={line:h.start.line+1,column:0},f=new p(h.bufferIndex,s,h.end,this.t(h.bufferIndex,s,h.end),h.length-1);r.piece=f,i+=`
`,(0,P.$3B)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const o=this.w(i);let t=this.T(r,o[o.length-1]);for(let h=o.length-2;h>=0;h--)t=this.T(t,o[h]);this.N(t),this.v(n)}q(i,r){this.Q(i,r)&&(i+=`
`);const n=this.w(i),o=this.S(r,n[0]);let t=o;for(let h=1;h<n.length;h++)t=this.S(t,n[h]);this.N(o)}s(i,r,n){const o=i.piece,t=i.piece.bufferIndex,h=this.a[t].lineStarts,f=h[o.start.line]+o.start.column+r;let l=o.start.line,u=o.end.line,v=0,I=0,b=0;for(;l<=u&&(v=l+(u-l)/2|0,b=h[v],v!==u);)if(I=h[v+1],f<b)u=v-1;else if(f>=I)l=v+1;else break;return n?(n.line=v,n.column=f-b,null):{line:v,column:f-b}}t(i,r,n){if(n.column===0)return n.line-r.line;const o=this.a[i].lineStarts;if(n.line===o.length-1)return n.line-r.line;const t=o[n.line+1],h=o[n.line]+n.column;if(t>h+1)return n.line-r.line;const s=h-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,P.$1B)(this,i[r])}w(i){if(i.length>w){const u=[];for(;i.length>w;){const I=i.charCodeAt(w-1);let b;I===13||I>=55296&&I<=56319?(b=i.substring(0,w-1),i=i.substring(w-1)):(b=i.substring(0,w),i=i.substring(w));const g=R(b);u.push(new p(this.a.length,{line:0,column:0},{line:g.length-1,column:b.length-g[g.length-1]},g.length-1,b.length)),this.a.push(new k(b,g))}const v=R(i);return u.push(new p(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new k(i,v)),u}let r=this.a[0].buffer.length;const n=R(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let u=0;u<n.length;u++)n[u]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let u=0;u<n.length;u++)n[u]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[h],f={line:h,column:s},l=new p(0,o,f,this.t(0,o,f),t-r);return this.g=f,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let n=this.root,o="";const t=this.h.get2(i);if(t){n=t.node;const h=this.B(n,i-t.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,f=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)o=s.substring(f+h,f+n.piece.length);else{const l=this.B(n,i-t.nodeStartLineNumber);return s.substring(f+h,f+l-r)}}else{let h=0;const s=i;for(;n!==P.$VB;)if(n.left!==P.$VB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const f=this.B(n,i-n.lf_left-2),l=this.B(n,i-n.lf_left-1),u=this.a[n.piece.bufferIndex].buffer,v=this.u(n.piece.bufferIndex,n.piece.start);return h+=n.size_left,this.h.set({node:n,nodeStartOffset:h,nodeStartLineNumber:s-(i-1-n.lf_left)}),u.substring(v+f,v+l-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const f=this.B(n,i-n.lf_left-2),l=this.a[n.piece.bufferIndex].buffer,u=this.u(n.piece.bufferIndex,n.piece.start);o=l.substring(u+f,u+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,h+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==P.$VB;){const h=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),f=this.u(n.piece.bufferIndex,n.piece.start);return o+=h.substring(f,f+s-r),o}else{const s=this.u(n.piece.bufferIndex,n.piece.start);o+=h.substr(s,n.piece.length)}n=n.next()}return o}y(){let i=this.root,r=1,n=0;for(;i!==P.$VB;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=n,this.h.validate(this.c)}A(i,r){const n=i.piece,o=this.s(i,r),t=o.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===r){const h=this.t(i.piece.bufferIndex,n.start,o);if(h!==t)return{index:h,remainder:0}}return{index:t,remainder:o.column}}B(i,r){if(r<0)return 0;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?o[n.end.line]+n.end.column-o[n.start.line]-n.start.column:o[t]-o[n.start.line]-n.start.column}C(i,r){const n=i.piece,o=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),h=r,s=this.u(n.bufferIndex,h),f=this.t(n.bufferIndex,n.start,h),l=f-o,u=s-t,v=n.length+u;i.piece=new p(n.bufferIndex,n.start,h,f,v),(0,P.$3B)(this,i,u,l)}D(i,r){const n=i.piece,o=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),h=r,s=this.t(n.bufferIndex,h,n.end),f=this.u(n.bufferIndex,h),l=s-o,u=t-f,v=n.length+u;i.piece=new p(n.bufferIndex,h,n.end,s,v),(0,P.$3B)(this,i,u,l)}E(i,r,n){const o=i.piece,t=o.start,h=o.end,s=o.length,f=o.lineFeedCnt,l=r,u=this.t(o.bufferIndex,o.start,l),v=this.u(o.bufferIndex,r)-this.u(o.bufferIndex,t);i.piece=new p(o.bufferIndex,o.start,l,u,v),(0,P.$3B)(this,i,v-s,u-f);const I=new p(o.bufferIndex,n,h,this.t(o.bufferIndex,n,h),this.u(o.bufferIndex,h)-this.u(o.bufferIndex,n)),b=this.S(i,I);this.N(b)}F(i,r){this.Q(r,i)&&(r+=`
`);const n=this.K()&&this.L(r)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=r;const t=R(r,!1);for(let b=0;b<t.length;b++)t[b]+=o;if(n){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const h=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[h],f={line:h,column:s},l=i.piece.length+r.length,u=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,f),I=v-u;i.piece=new p(i.piece.bufferIndex,i.piece.start,f,v,l),this.g=f,(0,P.$3B)(this,i,r.length,I)}G(i){let r=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let o=0;for(;r!==P.$VB;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){o+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:o};return this.h.set(t),t}else i-=r.size_left+r.piece.length,o+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let n=this.root,o=0;for(;n!==P.$VB;)if(n.left!==P.$VB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),h=this.B(n,i-n.lf_left-1);return o+=n.size_left,{node:n,remainder:Math.min(t+r-1,h),nodeStartOffset:o}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:o};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,o+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==P.$VB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),h=this.J(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:h}}else if(n.piece.length>=r-1){const t=this.J(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(o)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===P.$VB||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this.a[r.bufferIndex].lineStarts,o=r.start.line,t=n[o]+r.start.column;return o===n.length-1||n[o+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===P.$VB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const n=[],o=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new p(i.piece.bufferIndex,i.piece.start,t,s,h),(0,P.$3B)(this,i,-1,-1),i.piece.length===0&&n.push(i);const f={line:r.piece.start.line+1,column:0},l=r.piece.length-1,u=this.t(r.piece.bufferIndex,f,r.piece.end);r.piece=new p(r.piece.bufferIndex,f,r.piece.end,u,l),(0,P.$3B)(this,r,-1,-1),r.piece.length===0&&n.push(r);const v=this.w(`\r
`);this.S(i,v[0]);for(let I=0;I<n.length;I++)(0,P.$1B)(this,n[I])}Q(i,r){if(this.K()&&this.M(i)){const n=r.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,P.$1B)(this,n);else{const o=n.piece,t={line:o.start.line+1,column:0},h=o.length-1,s=this.t(o.bufferIndex,t,o.end);n.piece=new p(o.bufferIndex,t,o.end,s,h),(0,P.$3B)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===P.$VB)return r(P.$VB);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}R(i){if(i===P.$VB)return"";const r=this.a[i.piece.bufferIndex],n=i.piece,o=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return r.buffer.substring(o,t)}getPieceContent(i){const r=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return r.buffer.substring(n,o)}S(i,r){const n=new P.$UB(r,1);if(n.left=P.$VB,n.right=P.$VB,n.parent=P.$VB,n.size_left=0,n.lf_left=0,this.root===P.$VB)this.root=n,n.color=0;else if(i.right===P.$VB)i.right=n,n.parent=i;else{const t=(0,P.$WB)(i.right);t.left=n,n.parent=t}return(0,P.$2B)(this,n),n}T(i,r){const n=new P.$UB(r,1);if(n.left=P.$VB,n.right=P.$VB,n.parent=P.$VB,n.size_left=0,n.lf_left=0,this.root===P.$VB)this.root=n,n.color=0;else if(i.left===P.$VB)i.left=n,n.parent=i;else{const o=(0,P.$XB)(i.left);o.right=n,n.parent=o}return(0,P.$2B)(this,n),n}U(i){let r="";return this.iterate(i,n=>(r+=this.R(n),!0)),r}}e.$cC=m}),define(ke[177],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8=e.$F8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const A=this.a.get(P);return this.a.delete(P),A}}addDragOperationTransfer(P,A){this.a.set(P,A)}}e.$F8=D;class M{constructor(P){this.identifier=P}}e.$G8=M}),define(ke[178],Se([1,0,4,3]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class d{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,$){return this.a.set(w,$),this.handleChange([w]),(0,M.$Rc)(()=>{this.a.get(w)===$&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,$){this.b.get(w)?.dispose();const E=new P(this,w,$);return this.b.set(w,E),(0,M.$Rc)(()=>{const R=this.b.get(w);!R||R!==E||(this.b.delete(w),R.dispose())})}async getOrCreate(w){const $=this.get(w);if($)return $;const E=this.b.get(w);return!E||E.isResolved?null:(await E.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const E=this.b.get(w);return!!(!E||E.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$vt=d;class P extends M.$Tc{get isResolved(){return this.c}constructor(w,$,E){super(),this.f=w,this.g=$,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(ke[179],Se([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class P extends M.$Tc{constructor(p,k="",S="",c=!0,m){super(),this.h=this.B(new D.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=k,this.u=S,this.w=c,this.C=m}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,k){this.C&&await this.C(p)}}e.$Mi=P;class A extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$Wd),this.onWillRun=this.f.event,this.m=this.B(new D.$Wd),this.onDidRun=this.m.event}async run(p,k){if(!p.enabled)return;this.f.fire({action:p});let S;try{await this.u(p,k)}catch(c){S=c}this.m.fire({action:p,error:S})}async u(p,k){await p.run(k)}}e.$Ni=A;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let k=[];for(const S of p)S.length&&(k.length?k=[...k,new w,...S]:k=S);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$Oi=w;class ${get actions(){return this.a}constructor(p,k,S,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=k,this.class=c,this.a=S}async run(){}}e.$Pi=$;class E extends P{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,d.localize(0,null),void 0,!1)}}e.$Qi=E;function R(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...p)=>C.run(...p),tooltip:C.label}}e.$Ri=R}),define(ke[181],Se([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const M=60,d=M*60,P=d*24,A=P*7,w=P*30,$=P*365;function E(p,k,S,c){typeof p!="number"&&(p=p.getTime());const m=Math.round((new Date().getTime()-p)/1e3);if(m<-30)return(0,D.localize)(0,null,E(new Date().getTime()+m*1e3,!1));if(!c&&m<30)return(0,D.localize)(1,null);let a;return m<M?(a=m,k?a===1?S?(0,D.localize)(2,null,a):(0,D.localize)(3,null,a):S?(0,D.localize)(4,null,a):(0,D.localize)(5,null,a):a===1?S?(0,D.localize)(6,null,a):(0,D.localize)(7,null,a):S?(0,D.localize)(8,null,a):(0,D.localize)(9,null,a)):m<d?(a=Math.floor(m/M),k?a===1?S?(0,D.localize)(10,null,a):(0,D.localize)(11,null,a):S?(0,D.localize)(12,null,a):(0,D.localize)(13,null,a):a===1?S?(0,D.localize)(14,null,a):(0,D.localize)(15,null,a):S?(0,D.localize)(16,null,a):(0,D.localize)(17,null,a)):m<P?(a=Math.floor(m/d),k?a===1?S?(0,D.localize)(18,null,a):(0,D.localize)(19,null,a):S?(0,D.localize)(20,null,a):(0,D.localize)(21,null,a):a===1?S?(0,D.localize)(22,null,a):(0,D.localize)(23,null,a):S?(0,D.localize)(24,null,a):(0,D.localize)(25,null,a)):m<A?(a=Math.floor(m/P),k?a===1?(0,D.localize)(26,null,a):(0,D.localize)(27,null,a):a===1?(0,D.localize)(28,null,a):(0,D.localize)(29,null,a)):m<w?(a=Math.floor(m/A),k?a===1?S?(0,D.localize)(30,null,a):(0,D.localize)(31,null,a):S?(0,D.localize)(32,null,a):(0,D.localize)(33,null,a):a===1?S?(0,D.localize)(34,null,a):(0,D.localize)(35,null,a):S?(0,D.localize)(36,null,a):(0,D.localize)(37,null,a)):m<$?(a=Math.floor(m/w),k?a===1?S?(0,D.localize)(38,null,a):(0,D.localize)(39,null,a):S?(0,D.localize)(40,null,a):(0,D.localize)(41,null,a):a===1?S?(0,D.localize)(42,null,a):(0,D.localize)(43,null,a):S?(0,D.localize)(44,null,a):(0,D.localize)(45,null,a)):(a=Math.floor(m/$),k?a===1?S?(0,D.localize)(46,null,a):(0,D.localize)(47,null,a):S?(0,D.localize)(48,null,a):(0,D.localize)(49,null,a):a===1?S?(0,D.localize)(50,null,a):(0,D.localize)(51,null,a):S?(0,D.localize)(52,null,a):(0,D.localize)(53,null,a))}e.$xm=E;function R(p,k){const S=Math.abs(p/1e3);return S<1?k?(0,D.localize)(54,null,p):(0,D.localize)(55,null,p):S<M?k?(0,D.localize)(56,null,Math.round(p)/1e3):(0,D.localize)(57,null,Math.round(p)/1e3):S<d?k?(0,D.localize)(58,null,Math.round(p/(1e3*M))):(0,D.localize)(59,null,Math.round(p/(1e3*M))):S<P?k?(0,D.localize)(60,null,Math.round(p/(1e3*d))):(0,D.localize)(61,null,Math.round(p/(1e3*d))):(0,D.localize)(62,null,Math.round(p/(1e3*P)))}e.$ym=R;function C(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=C}),define(ke[183],Se([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,183]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function P(C,p){return p&&(C.stack||C.stacktrace)?d.localize(0,null,w(C),A(C.stack)||A(C.stacktrace)):w(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function w(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?d.localize(1,null,C.message):C.message||d.localize(2,null)}function $(C=null,p=!1){if(!C)return d.localize(3,null);if(Array.isArray(C)){const k=D.$Hb(C),S=$(k[0],p);return k.length>1?d.localize(4,null,S,k.length):S}if(M.$Jf(C))return C;if(C.detail){const k=C.detail;if(k.error)return P(k.error,p);if(k.exception)return P(k.exception,p)}return C.stack?P(C,p):C.message?C.message:d.localize(5,null)}e.$Si=$;function E(C){const p=C;return p instanceof Error&&Array.isArray(p.actions)}e.$Ti=E;function R(C,p){let k;return typeof C=="string"?k=new Error(C):k=C,k.actions=p,k}e.$Ui=R}),define(ke[184],Se([9,10]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,184]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let M=!1,d=!1,P=!1,A=!1,w=!1,$=!1,E=!1,R=!1,C=!1,p=!1,k,S=e.$g,c=e.$g,m,a;const i=globalThis;let r;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?r=i.vscode.process:typeof process<"u"&&(r=process);const n=typeof r?.versions?.electron=="string",o=n&&r?.type==="renderer";if(typeof r=="object"){M=r.platform==="win32",d=r.platform==="darwin",P=r.platform==="linux",A=P&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,E=n,C=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,S=e.$g;const g=r.env.VSCODE_NLS_CONFIG;if(g)try{const y=JSON.parse(g),L=y.availableLanguages["*"];k=y.locale,c=y.osLocale,S=L||e.$g,m=y._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,M=a.indexOf("Windows")>=0,d=a.indexOf("Macintosh")>=0,R=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=a.indexOf("Linux")>=0,p=a?.indexOf("Mobi")>=0,$=!0,k=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=k,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(g){g[g.Web=0]="Web",g[g.Mac=1]="Mac",g[g.Linux=2]="Linux",g[g.Windows=3]="Windows"})(t||(e.Platform=t={}));function h(g){switch(g){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=h;let s=0;d?s=1:M?s=3:P&&(s=2),e.$i=M,e.$j=d,e.$k=P,e.$l=A,e.$m=w,e.$n=E,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=R,e.$s=p,e.$t=C,e.$u=s,e.$v=a,e.$w=S;var f;(function(g){function y(){return e.$w}g.value=y;function L(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}g.isDefaultVariant=L;function T(){return e.$w==="en"}g.isDefault=T})(f||(e.Language=f={})),e.$x=k,e.$y=c,e.$z=m,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const g=[];i.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let T=0,U=g.length;T<U;T++){const j=g[T];if(j.id===L.data.vscodeScheduleAsyncWork){g.splice(T,1),j.callback();return}}});let y=0;return L=>{const T=++y;g.push({id:T,callback:L}),i.postMessage({vscodeScheduleAsyncWork:T},"*")}}return g=>setTimeout(g)})();var l;(function(g){g[g.Windows=1]="Windows",g[g.Macintosh=2]="Macintosh",g[g.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=d||R?2:M?1:3;let u=!0,v=!1;function I(){if(!v){v=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,u=new Uint16Array(g.buffer)[0]===513}return u}e.$D=I,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(g){return parseFloat(g)>=20}e.$J=b}),define(ke[49],Se([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let M;const d=globalThis.vscode;if(typeof d<"u"&&typeof d.process<"u"){const P=d.process;M={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.$dc=M.platform,e.$ec=M.arch}),define(ke[17],Se([1,0,49]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const M=65,d=97,P=90,A=122,w=46,$=47,E=92,R=58,C=63;class p extends Error{constructor(h,s,f){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const u=h.indexOf(".")!==-1?"property":"argument";let v=`The "${h}" ${u} ${l} of type ${s}`;v+=`. Received type ${typeof f}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,h){if(t===null||typeof t!="object")throw new p(h,"Object",t)}function S(t,h){if(typeof t!="string")throw new p(h,"string",t)}const c=D.$dc==="win32";function m(t){return t===$||t===E}function a(t){return t===$}function i(t){return t>=M&&t<=P||t>=d&&t<=A}function r(t,h,s,f){let l="",u=0,v=-1,I=0,b=0;for(let g=0;g<=t.length;++g){if(g<t.length)b=t.charCodeAt(g);else{if(f(b))break;b=$}if(f(b)){if(!(v===g-1||I===1))if(I===2){if(l.length<2||u!==2||l.charCodeAt(l.length-1)!==w||l.charCodeAt(l.length-2)!==w){if(l.length>2){const y=l.lastIndexOf(s);y===-1?(l="",u=0):(l=l.slice(0,y),u=l.length-1-l.lastIndexOf(s)),v=g,I=0;continue}else if(l.length!==0){l="",u=0,v=g,I=0;continue}}h&&(l+=l.length>0?`${s}..`:"..",u=2)}else l.length>0?l+=`${s}${t.slice(v+1,g)}`:l=t.slice(v+1,g),u=g-v-1;v=g,I=0}else b===w&&I!==-1?++I:I=-1}return l}function n(t,h){k(h,"pathObject");const s=h.dir||h.root,f=h.base||`${h.name||""}${h.ext||""}`;return s?s===h.root?`${s}${f}`:`${s}${t}${f}`:f}e.$fc={resolve(...t){let h="",s="",f=!1;for(let l=t.length-1;l>=-1;l--){let u;if(l>=0){if(u=t[l],S(u,"path"),u.length===0)continue}else h.length===0?u=D.cwd():(u=D.env[`=${h}`]||D.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==h.toLowerCase()&&u.charCodeAt(2)===E)&&(u=`${h}\\`));const v=u.length;let I=0,b="",g=!1;const y=u.charCodeAt(0);if(v===1)m(y)&&(I=1,g=!0);else if(m(y))if(g=!0,m(u.charCodeAt(1))){let L=2,T=L;for(;L<v&&!m(u.charCodeAt(L));)L++;if(L<v&&L!==T){const U=u.slice(T,L);for(T=L;L<v&&m(u.charCodeAt(L));)L++;if(L<v&&L!==T){for(T=L;L<v&&!m(u.charCodeAt(L));)L++;(L===v||L!==T)&&(b=`\\\\${U}\\${u.slice(T,L)}`,I=L)}}}else I=1;else i(y)&&u.charCodeAt(1)===R&&(b=u.slice(0,2),I=2,v>2&&m(u.charCodeAt(2))&&(g=!0,I=3));if(b.length>0)if(h.length>0){if(b.toLowerCase()!==h.toLowerCase())continue}else h=b;if(f){if(h.length>0)break}else if(s=`${u.slice(I)}\\${s}`,f=g,g&&h.length>0)break}return s=r(s,!f,"\\",m),f?`${h}\\${s}`:`${h}${s}`||"."},normalize(t){S(t,"path");const h=t.length;if(h===0)return".";let s=0,f,l=!1;const u=t.charCodeAt(0);if(h===1)return a(u)?"\\":t;if(m(u))if(l=!0,m(t.charCodeAt(1))){let I=2,b=I;for(;I<h&&!m(t.charCodeAt(I));)I++;if(I<h&&I!==b){const g=t.slice(b,I);for(b=I;I<h&&m(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&!m(t.charCodeAt(I));)I++;if(I===h)return`\\\\${g}\\${t.slice(b)}\\`;I!==b&&(f=`\\\\${g}\\${t.slice(b,I)}`,s=I)}}}else s=1;else i(u)&&t.charCodeAt(1)===R&&(f=t.slice(0,2),s=2,h>2&&m(t.charCodeAt(2))&&(l=!0,s=3));let v=s<h?r(t.slice(s),!l,"\\",m):"";return v.length===0&&!l&&(v="."),v.length>0&&m(t.charCodeAt(h-1))&&(v+="\\"),f===void 0?l?`\\${v}`:v:l?`${f}\\${v}`:`${f}${v}`},isAbsolute(t){S(t,"path");const h=t.length;if(h===0)return!1;const s=t.charCodeAt(0);return m(s)||h>2&&i(s)&&t.charCodeAt(1)===R&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let h,s;for(let u=0;u<t.length;++u){const v=t[u];S(v,"path"),v.length>0&&(h===void 0?h=s=v:h+=`\\${v}`)}if(h===void 0)return".";let f=!0,l=0;if(typeof s=="string"&&m(s.charCodeAt(0))){++l;const u=s.length;u>1&&m(s.charCodeAt(1))&&(++l,u>2&&(m(s.charCodeAt(2))?++l:f=!1))}if(f){for(;l<h.length&&m(h.charCodeAt(l));)l++;l>=2&&(h=`\\${h.slice(l)}`)}return e.$fc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h)return"";const s=e.$fc.resolve(t),f=e.$fc.resolve(h);if(s===f||(t=s.toLowerCase(),h=f.toLowerCase(),t===h))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===E;)l++;let u=t.length;for(;u-1>l&&t.charCodeAt(u-1)===E;)u--;const v=u-l;let I=0;for(;I<h.length&&h.charCodeAt(I)===E;)I++;let b=h.length;for(;b-1>I&&h.charCodeAt(b-1)===E;)b--;const g=b-I,y=v<g?v:g;let L=-1,T=0;for(;T<y;T++){const j=t.charCodeAt(l+T);if(j!==h.charCodeAt(I+T))break;j===E&&(L=T)}if(T!==y){if(L===-1)return f}else{if(g>y){if(h.charCodeAt(I+T)===E)return f.slice(I+T+1);if(T===2)return f.slice(I+T)}v>y&&(t.charCodeAt(l+T)===E?L=T:T===2&&(L=3)),L===-1&&(L=0)}let U="";for(T=l+L+1;T<=u;++T)(T===u||t.charCodeAt(T)===E)&&(U+=U.length===0?"..":"\\..");return I+=L,U.length>0?`${U}${f.slice(I,b)}`:(f.charCodeAt(I)===E&&++I,f.slice(I,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const h=e.$fc.resolve(t);if(h.length<=2)return t;if(h.charCodeAt(0)===E){if(h.charCodeAt(1)===E){const s=h.charCodeAt(2);if(s!==C&&s!==w)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(i(h.charCodeAt(0))&&h.charCodeAt(1)===R&&h.charCodeAt(2)===E)return`\\\\?\\${h}`;return t},dirname(t){S(t,"path");const h=t.length;if(h===0)return".";let s=-1,f=0;const l=t.charCodeAt(0);if(h===1)return m(l)?t:".";if(m(l)){if(s=f=1,m(t.charCodeAt(1))){let I=2,b=I;for(;I<h&&!m(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&m(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&!m(t.charCodeAt(I));)I++;if(I===h)return t;I!==b&&(s=f=I+1)}}}}else i(l)&&t.charCodeAt(1)===R&&(s=h>2&&m(t.charCodeAt(2))?3:2,f=s);let u=-1,v=!0;for(let I=h-1;I>=f;--I)if(m(t.charCodeAt(I))){if(!v){u=I;break}}else v=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let s=0,f=-1,l=!0,u;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let v=h.length-1,I=-1;for(u=t.length-1;u>=s;--u){const b=t.charCodeAt(u);if(m(b)){if(!l){s=u+1;break}}else I===-1&&(l=!1,I=u+1),v>=0&&(b===h.charCodeAt(v)?--v===-1&&(f=u):(v=-1,f=I))}return s===f?f=I:f===-1&&(f=t.length),t.slice(s,f)}for(u=t.length-1;u>=s;--u)if(m(t.charCodeAt(u))){if(!l){s=u+1;break}}else f===-1&&(l=!1,f=u+1);return f===-1?"":t.slice(s,f)},extname(t){S(t,"path");let h=0,s=-1,f=0,l=-1,u=!0,v=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(h=f=2);for(let I=t.length-1;I>=h;--I){const b=t.charCodeAt(I);if(m(b)){if(!u){f=I+1;break}continue}l===-1&&(u=!1,l=I+1),b===w?s===-1?s=I:v!==1&&(v=1):s!==-1&&(v=-1)}return s===-1||l===-1||v===0||v===1&&s===l-1&&s===f+1?"":t.slice(s,l)},format:n.bind(null,"\\"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.length;let f=0,l=t.charCodeAt(0);if(s===1)return m(l)?(h.root=h.dir=t,h):(h.base=h.name=t,h);if(m(l)){if(f=1,m(t.charCodeAt(1))){let L=2,T=L;for(;L<s&&!m(t.charCodeAt(L));)L++;if(L<s&&L!==T){for(T=L;L<s&&m(t.charCodeAt(L));)L++;if(L<s&&L!==T){for(T=L;L<s&&!m(t.charCodeAt(L));)L++;L===s?f=L:L!==T&&(f=L+1)}}}}else if(i(l)&&t.charCodeAt(1)===R){if(s<=2)return h.root=h.dir=t,h;if(f=2,m(t.charCodeAt(2))){if(s===3)return h.root=h.dir=t,h;f=3}}f>0&&(h.root=t.slice(0,f));let u=-1,v=f,I=-1,b=!0,g=t.length-1,y=0;for(;g>=f;--g){if(l=t.charCodeAt(g),m(l)){if(!b){v=g+1;break}continue}I===-1&&(b=!1,I=g+1),l===w?u===-1?u=g:y!==1&&(y=1):u!==-1&&(y=-1)}return I!==-1&&(u===-1||y===0||y===1&&u===I-1&&u===v+1?h.base=h.name=t.slice(v,I):(h.name=t.slice(v,u),h.base=t.slice(v,I),h.ext=t.slice(u,I))),v>0&&v!==f?h.dir=t.slice(0,v-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(c){const t=/\\/g;return()=>{const h=D.cwd().replace(t,"/");return h.slice(h.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let h="",s=!1;for(let f=t.length-1;f>=-1&&!s;f--){const l=f>=0?t[f]:o();S(l,"path"),l.length!==0&&(h=`${l}/${h}`,s=l.charCodeAt(0)===$)}return h=r(h,!s,"/",a),s?`/${h}`:h.length>0?h:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=r(t,!h,"/",a),t.length===0?h?"/":s?"./":".":(s&&(t+="/"),h?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let h;for(let s=0;s<t.length;++s){const f=t[s];S(f,"path"),f.length>0&&(h===void 0?h=f:h+=`/${f}`)}return h===void 0?".":e.$gc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h||(t=e.$gc.resolve(t),h=e.$gc.resolve(h),t===h))return"";const s=1,f=t.length,l=f-s,u=1,v=h.length-u,I=l<v?l:v;let b=-1,g=0;for(;g<I;g++){const L=t.charCodeAt(s+g);if(L!==h.charCodeAt(u+g))break;L===$&&(b=g)}if(g===I)if(v>I){if(h.charCodeAt(u+g)===$)return h.slice(u+g+1);if(g===0)return h.slice(u+g)}else l>I&&(t.charCodeAt(s+g)===$?b=g:g===0&&(b=0));let y="";for(g=s+b+1;g<=f;++g)(g===f||t.charCodeAt(g)===$)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(u+b)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$;let s=-1,f=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===$){if(!f){s=l;break}}else f=!1;return s===-1?h?"/":".":h&&s===1?"//":t.slice(0,s)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let s=0,f=-1,l=!0,u;if(h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let v=h.length-1,I=-1;for(u=t.length-1;u>=0;--u){const b=t.charCodeAt(u);if(b===$){if(!l){s=u+1;break}}else I===-1&&(l=!1,I=u+1),v>=0&&(b===h.charCodeAt(v)?--v===-1&&(f=u):(v=-1,f=I))}return s===f?f=I:f===-1&&(f=t.length),t.slice(s,f)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===$){if(!l){s=u+1;break}}else f===-1&&(l=!1,f=u+1);return f===-1?"":t.slice(s,f)},extname(t){S(t,"path");let h=-1,s=0,f=-1,l=!0,u=0;for(let v=t.length-1;v>=0;--v){const I=t.charCodeAt(v);if(I===$){if(!l){s=v+1;break}continue}f===-1&&(l=!1,f=v+1),I===w?h===-1?h=v:u!==1&&(u=1):h!==-1&&(u=-1)}return h===-1||f===-1||u===0||u===1&&h===f-1&&h===s+1?"":t.slice(h,f)},format:n.bind(null,"/"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.charCodeAt(0)===$;let f;s?(h.root="/",f=1):f=0;let l=-1,u=0,v=-1,I=!0,b=t.length-1,g=0;for(;b>=f;--b){const y=t.charCodeAt(b);if(y===$){if(!I){u=b+1;break}continue}v===-1&&(I=!1,v=b+1),y===w?l===-1?l=b:g!==1&&(g=1):l!==-1&&(g=-1)}if(v!==-1){const y=u===0&&s?1:u;l===-1||g===0||g===1&&l===v-1&&l===u+1?h.base=h.name=t.slice(y,v):(h.name=t.slice(y,l),h.base=t.slice(y,v),h.ext=t.slice(l,v))}return u>0?h.dir=t.slice(0,u-1):s&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(ke[128],Se([1,0,43,17]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=void 0;const d=new D.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),P=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(I,b,g=!1){const y=I||"",L=b||"",T=d.value.collator.compare(y,L);return d.value.collatorIsNumeric&&T===0&&y!==L?y<L?-1:1:T}e.$Kq=w;function $(I,b){const g=P.value.collator;return I=I||"",b=b||"",n(g,I,b)}e.$Lq=$;function E(I,b){const g=P.value.collator;return I=I||"",b=b||"",s(I,b)||n(g,I,b)}e.$Mq=E;function R(I,b){const g=P.value.collator;return I=I||"",b=b||"",h(I,b)||n(g,I,b)}e.$Nq=R;function C(I,b){return I=I||"",b=b||"",I===b?0:I<b?-1:1}e.$Oq=C;function p(I,b){const[g,y]=i(I),[L,T]=i(b);let U=d.value.collator.compare(y,T);if(U===0){if(d.value.collatorIsNumeric&&y!==T)return y<T?-1:1;if(U=d.value.collator.compare(g,L),d.value.collatorIsNumeric&&U===0&&g!==L)return g<L?-1:1}return U}e.$Pq=p;function k(I,b){I=I||"",b=b||"";const g=r(I),y=r(b),L=P.value.collator,T=A.value.collator;return n(T,g,y)||n(L,I,b)}e.$Qq=k;function S(I,b){I=I||"",b=b||"";const g=r(I),y=r(b),L=P.value.collator,T=A.value.collator;return n(T,g,y)||s(I,b)||n(L,I,b)}e.$Rq=S;function c(I,b){I=I||"",b=b||"";const g=r(I),y=r(b),L=P.value.collator,T=A.value.collator;return n(T,g,y)||h(I,b)||n(L,I,b)}e.$Sq=c;function m(I,b){I=I||"",b=b||"";const g=r(I).toLowerCase(),y=r(b).toLowerCase();return g!==y?g<y?-1:1:I!==b?I<b?-1:1:0}e.$Tq=m;const a=/^(.*?)(\.([^.]*))?$/;function i(I,b=!1){const g=I?a.exec(I):[];let y=[g&&g[1]||"",g&&g[3]||""];return b&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function r(I){const b=I?a.exec(I):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function n(I,b,g){const y=I.compare(b,g);return y!==0?y:b.length!==g.length?b.length<g.length?-1:1:0}function o(I){const b=I.charAt(0);return b.toLocaleUpperCase()!==b}function t(I){const b=I.charAt(0);return b.toLocaleLowerCase()!==b}function h(I,b){return o(I)&&t(b)?-1:t(I)&&o(b)?1:0}function s(I,b){return t(I)&&o(b)?-1:o(I)&&t(b)?1:0}function f(I,b,g=!1){return g||(I=I&&I.toLowerCase(),b=b&&b.toLowerCase()),I===b?0:I<b?-1:1}function l(I,b,g=!1){const y=I.split(M.sep),L=b.split(M.sep),T=y.length-1,U=L.length-1;let j,F;for(let N=0;;N++){if(j=T===N,F=U===N,j&&F)return w(y[N],L[N],g);if(j)return-1;if(F)return 1;const O=f(y[N],L[N],g);if(O!==0)return O}}e.$Uq=l;function u(I,b,g){const y=I.toLowerCase(),L=b.toLowerCase(),T=v(I,b,g);if(T)return T;const U=y.endsWith(g),j=L.endsWith(g);if(U!==j)return U?-1:1;const F=w(y,L);return F!==0?F:y.localeCompare(L)}e.$Vq=u;function v(I,b,g){const y=I.toLowerCase(),L=b.toLowerCase(),T=y.startsWith(g),U=L.startsWith(g);if(T!==U)return T?-1:1;if(T&&U){if(y.length<L.length)return-1;if(y.length>L.length)return 1}return 0}e.$Wq=v}),define(ke[34],Se([1,0,17,11,13,18]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function A(u){return u===47||u===92}e.$2f=A;function w(u){return u.replace(/[\\/]/g,D.$gc.sep)}e.$3f=w;function $(u){return u.indexOf("/")===-1&&(u=w(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.$4f=$;function E(u,v=D.$gc.sep){if(!u)return"";const I=u.length,b=u.charCodeAt(0);if(A(b)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let y=3;const L=y;for(;y<I&&!A(u.charCodeAt(y));y++);if(L!==y&&!A(u.charCodeAt(y+1))){for(y+=1;y<I;y++)if(A(u.charCodeAt(y)))return u.slice(0,y+1).replace(/[\\/]/g,v)}}return v}else if(a(b)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+v:u.slice(0,2);let g=u.indexOf("://");if(g!==-1){for(g+=3;g<I;g++)if(A(u.charCodeAt(g)))return u.slice(0,g+1)}return""}e.$5f=E;function R(u){if(!M.$i||!u||u.length<5)return!1;let v=u.charCodeAt(0);if(v!==92||(v=u.charCodeAt(1),v!==92))return!1;let I=2;const b=I;for(;I<u.length&&(v=u.charCodeAt(I),v!==92);I++);return!(b===I||(v=u.charCodeAt(I+1),isNaN(v)||v===92))}e.$6f=R;const C=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(u,v=M.$i){const I=v?C:p;return!(!u||u.length===0||/^\s+$/.test(u)||(I.lastIndex=0,I.test(u))||v&&k.test(u)||u==="."||u===".."||v&&u[u.length-1]==="."||v&&u.length!==u.trim().length||u.length>255)}e.$7f=S;function c(u,v,I){const b=u===v;return!I||b?b:!u||!v?!1:(0,d.$af)(u,v)}e.$8f=c;function m(u,v,I,b=D.sep){if(u===v)return!0;if(!u||!v||v.length>u.length)return!1;if(I){if(!(0,d.$bf)(u,v))return!1;if(v.length===u.length)return!0;let y=v.length;return v.charAt(v.length-1)===b&&y--,u.charAt(y)===b}return v.charAt(v.length-1)!==b&&(v+=b),u.indexOf(v)===0}e.$9f=m;function a(u){return u>=65&&u<=90||u>=97&&u<=122}e.$0f=a;function i(u,v){return M.$i&&u.endsWith(":")&&(u+=D.sep),(0,D.$ic)(u)||(u=(0,D.$jc)(v,u)),u=(0,D.$hc)(u),M.$i?(u=(0,d.$Ve)(u,D.sep),u.endsWith(":")&&(u+=D.sep)):(u=(0,d.$Ve)(u,D.sep),u||(u=D.sep)),u}e.$$f=i;function r(u){const v=(0,D.$hc)(u);return M.$i?u.length>3?!1:n(v)&&(u.length===2||v.charCodeAt(2)===92):v===D.$gc.sep}e.$_f=r;function n(u,v=M.$i){return v?a(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.$ag=n;function o(u,v=M.$i){return n(u,v)?u[0]:void 0}e.$bg=o;function t(u,v,I){return v.length>u.length?-1:u===v?0:(I&&(u=u.toLowerCase(),v=v.toLowerCase()),u.indexOf(v))}e.$cg=t;function h(u){const v=u.split(":");let I,b,g;for(const y of v){const L=Number(y);(0,P.$Nf)(L)?b===void 0?b=L:g===void 0&&(g=L):I=I?[I,y].join(":"):y}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:b!==void 0?b:void 0,column:g!==void 0?g:b!==void 0?1:void 0}}e.$dg=h;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(u,v,I=8){let b="";for(let y=0;y<I;y++){let L;y===0&&M.$i&&!v&&(I===3||I===4)?L=f:L=s,b+=L.charAt(Math.floor(Math.random()*L.length))}let g;return v?g=`${v}-${b}`:g=b,u?(0,D.$jc)(u,g):g}e.$eg=l}),define(ke[129],Se([1,0,128,123,54,17,11,13]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=void 0;const $=0,E=[$,[]];function R(z,K,te,x){if(!z||!K)return E;const X=z.length,Z=K.length;if(X<Z)return E;const ce=z.toLowerCase();return C(K,te,Z,z,ce,X,x)}e.$Xq=R;function C(z,K,te,x,X,Z,ce){const _=[],ge=[];for(let re=0;re<te;re++){const ye=re*Z,he=ye-Z,fe=re>0,ue=z[re],me=K[re];for(let V=0;V<Z;V++){const Y=V>0,de=ye+V,pe=de-1,Pe=he+V-1,ve=Y?_[pe]:0,Ce=fe&&Y?_[Pe]:0,B=fe&&Y?ge[Pe]:0;let Q;!Ce&&fe?Q=0:Q=p(ue,me,x,X,V,B),Q&&Ce+Q>=ve&&(ce||fe||X.startsWith(K,V))?(ge[de]=B+1,_[de]=Ce+Q):(ge[de]=$,_[de]=ve)}}const ne=[];let J=te-1,W=Z-1;for(;J>=0&&W>=0;){const re=J*Z+W;ge[re]===$||(ne.push(W),J--),W--}return[_[te*Z-1],ne.reverse()]}function p(z,K,te,x,X,Z){let ce=0;if(!k(K,x[X]))return ce;if(ce+=1,Z>0&&(ce+=Z*5),z===te[X]&&(ce+=1),X===0)ce+=8;else{const _=S(te.charCodeAt(X-1));_?ce+=_:(0,M.$Zj)(te.charCodeAt(X))&&Z===0&&(ce+=2)}return ce}function k(z,K){return z===K?!0:z==="/"||z==="\\"?K==="/"||K==="\\":!1}function S(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function m(z,K,te=0,x=0){const X=K;return X.values&&X.values.length>1?a(z,X.values,te,x):i(z,K,te,x)}e.$Yq=m;function a(z,K,te,x){let X=0;const Z=[];for(const ce of K){const[_,ge]=i(z,ce,te,x);if(typeof _!="number")return c;X+=_,Z.push(...ge)}return[X,I(Z)]}function i(z,K,te,x){const X=(0,M.$9j)(K.original,K.originalLowercase,te,z,z.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,M.$6j)(X)]:c}const r=Object.freeze({score:0}),n=1<<18,o=1<<17,t=65536;function h(z,K,te,x){const X=x.values?x.values:[x];return(0,d.$Vi)({[x.normalized]:{values:X.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:z,description:K,allowNonContiguousMatches:te}})}function s(z,K,te,x,X){if(!z||!K.normalized)return r;const Z=x.getItemLabel(z);if(!Z)return r;const ce=x.getItemDescription(z),_=h(Z,ce,te,K),ge=X[_];if(ge)return ge;const ne=f(Z,ce,x.getItemPath(z),K,te);return X[_]=ne,ne}e.$Zq=s;function f(z,K,te,x,X){const Z=!te||!x.containsPathSeparator;return te&&(A.$k?x.pathNormalized===te:(0,w.$af)(x.pathNormalized,te))?{score:n,labelMatch:[{start:0,end:z.length}],descriptionMatch:K?[{start:0,end:K.length}]:void 0}:x.values&&x.values.length>1?l(z,K,te,x.values,Z,X):u(z,K,te,x,Z,X)}function l(z,K,te,x,X,Z){let ce=0;const _=[],ge=[];for(const ne of x){const{score:J,labelMatch:W,descriptionMatch:re}=u(z,K,te,ne,X,Z);if(J===$)return r;ce+=J,W&&_.push(...W),re&&ge.push(...re)}return{score:ce,labelMatch:I(_),descriptionMatch:I(ge)}}function u(z,K,te,x,X,Z){if(X||!K){const[ce,_]=R(z,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(ce){const ge=(0,M.$Wj)(x.normalized,z);let ne;if(ge){ne=o;const J=Math.round(x.normalized.length/z.length*100);ne+=J}else ne=t;return{score:ne+ce,labelMatch:ge||v(_)}}}if(K){let ce=K;te&&(ce=`${K}${P.sep}`);const _=ce.length,ge=`${ce}${z}`,[ne,J]=R(ge,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(ne){const W=v(J),re=[],ye=[];return W.forEach(he=>{he.start<_&&he.end>_?(re.push({start:0,end:he.end-_}),ye.push({start:he.start,end:_})):he.start>=_?re.push({start:he.start-_,end:he.end-_}):ye.push(he)}),{score:ne,labelMatch:re,descriptionMatch:ye}}}return r}function v(z){const K=[];if(!z)return K;let te;for(const x of z)te&&te.end===x?te.end+=1:(te={start:x,end:x+1},K.push(te));return K}function I(z){const K=z.sort((X,Z)=>X.start-Z.start),te=[];let x;for(const X of K)!x||!b(x,X)?(x=X,te.push(X)):(x.start=Math.min(x.start,X.start),x.end=Math.max(x.end,X.end));return te}function b(z,K){return!(z.end<K.start||K.end<z.start)}function g(z,K,te,x,X,Z){const ce=s(z,te,x,X,Z),_=s(K,te,x,X,Z),ge=ce.score,ne=_.score;if((ge===n||ne===n)&&ge!==ne)return ge===n?-1:1;if(ge>t||ne>t){if(ge!==ne)return ge>ne?-1:1;if(ge<o&&ne<o){const ue=L(ce.labelMatch,_.labelMatch);if(ue!==0)return ue}const he=X.getItemLabel(z)||"",fe=X.getItemLabel(K)||"";if(he.length!==fe.length)return he.length-fe.length}if(ge!==ne)return ge>ne?-1:1;const J=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,W=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(J&&!W)return-1;if(W&&!J)return 1;const re=y(z,ce,X),ye=y(K,_,X);return re&&ye&&re!==ye?ye>re?-1:1:T(z,K,te,X)}e.$1q=g;function y(z,K,te){let x=-1,X=-1;if(K.descriptionMatch&&K.descriptionMatch.length?x=K.descriptionMatch[0].start:K.labelMatch&&K.labelMatch.length&&(x=K.labelMatch[0].start),K.labelMatch&&K.labelMatch.length){if(X=K.labelMatch[K.labelMatch.length-1].end,K.descriptionMatch&&K.descriptionMatch.length){const Z=te.getItemDescription(z);Z&&(X+=Z.length)}}else K.descriptionMatch&&K.descriptionMatch.length&&(X=K.descriptionMatch[K.descriptionMatch.length-1].end);return X-x}function L(z,K){if(!z&&!K||(!z||!z.length)&&(!K||!K.length))return 0;if(!K||!K.length)return-1;if(!z||!z.length)return 1;const te=z[0].start,X=z[z.length-1].end-te,Z=K[0].start,_=K[K.length-1].end-Z;return X===_?0:_<X?1:-1}function T(z,K,te,x){const X=x.getItemLabel(z)||"",Z=x.getItemLabel(K)||"",ce=x.getItemDescription(z),_=x.getItemDescription(K),ge=X.length+(ce?ce.length:0),ne=Z.length+(_?_.length:0);if(ge!==ne)return ge-ne;const J=x.getItemPath(z),W=x.getItemPath(K);return J&&W&&J.length!==W.length?J.length-W.length:X!==Z?(0,D.$Vq)(X,Z,te.normalized):ce&&_&&ce!==_?(0,D.$Vq)(ce,_,te.normalized):J&&W&&J!==W?(0,D.$Vq)(J,W,te.normalized):0}function U(z){return z.startsWith('"')&&z.endsWith('"')}const j=" ";function F(z){typeof z!="string"&&(z="");const K=z.toLowerCase(),{pathNormalized:te,normalized:x,normalizedLowercase:X}=N(z),Z=te.indexOf(P.sep)>=0,ce=U(z);let _;const ge=z.split(j);if(ge.length>1)for(const ne of ge){const J=U(ne),{pathNormalized:W,normalized:re,normalizedLowercase:ye}=N(ne);re&&(_||(_=[]),_.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:W,normalized:re,normalizedLowercase:ye,expectContiguousMatch:J}))}return{original:z,originalLowercase:K,pathNormalized:te,normalized:x,normalizedLowercase:X,values:_,containsPathSeparator:Z,expectContiguousMatch:ce}}e.$2q=F;function N(z){let K;A.$i?K=z.replace(/\//g,P.sep):K=z.replace(/\\/g,P.sep);const te=(0,w.$Xe)(K).replace(/\s|"/g,"");return{pathNormalized:K,normalized:te,normalizedLowercase:te.toLowerCase()}}function O(z){return Array.isArray(z)?F(z.map(K=>K.original).join(j)):F(z.original)}e.$3q=O}),define(ke[100],Se([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const C=(0,D.$oc)(R),p=M[C.toLowerCase()];return p!==void 0?p:A(R)}e.$is=P;function A(R){const C=(0,D.$oc)(R);return d[C.toLowerCase()]}e.$js=A;function w(R){for(const C in d)if(d[C]===R)return C}e.$ks=w;const $=/^(.+)\/(.+?)(;.+)?$/;function E(R,C){const p=$.exec(R);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:C?void 0:R}e.$ls=E}),define(ke[101],Se([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var M;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(M||(e.Source=M={}));var d;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function P(w,...$){const E=$.reduce((p,k)=>(p[k]=!0,p),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(p=>!E[p]).forEach(p=>{for(let k=0;k<R.length;k++)if(p.search(R[k])!==-1){delete w[p];break}})}e.$Tl=P;function A(w){w&&(delete w.DEBUG,D.$j&&delete w.DYLD_LIBRARY_PATH,D.$k&&delete w.LD_PRELOAD)}e.$Ul=A}),define(ke[2],Se([1,0,17,11]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,P=/^\//,A=/^\/\//;function w(f,l){if(!f.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!d.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!P.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(f,l){return!f&&!l?"file":f}function E(f,l){switch(f){case"https":case"http":case"file":l?l[0]!==C&&(l=C+l):l=C;break}return l}const R="",C="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(l){return l instanceof k?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,u,v,I,b,g=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=$(l,g),this.authority=u||R,this.path=E(this.scheme,v||R),this.query=I||R,this.fragment=b||R,w(this,g))}get fsPath(){return n(this,!1)}with(l){if(!l)return this;let{scheme:u,authority:v,path:I,query:b,fragment:g}=l;return u===void 0?u=this.scheme:u===null&&(u=R),v===void 0?v=this.authority:v===null&&(v=R),I===void 0?I=this.path:I===null&&(I=R),b===void 0?b=this.query:b===null&&(b=R),g===void 0?g=this.fragment:g===null&&(g=R),u===this.scheme&&v===this.authority&&I===this.path&&b===this.query&&g===this.fragment?this:new m(u,v,I,b,g)}static parse(l,u=!1){const v=p.exec(l);return v?new m(v[2]||R,s(v[4]||R),s(v[5]||R),s(v[7]||R),s(v[9]||R),u):new m(R,R,R,R,R)}static file(l){let u=R;if(M.$i&&(l=l.replace(/\\/g,C)),l[0]===C&&l[1]===C){const v=l.indexOf(C,2);v===-1?(u=l.substring(2),l=C):(u=l.substring(2,v),l=l.substring(v)||C)}return new m("file",u,l,R,R)}static from(l,u){return new m(l.scheme,l.authority,l.path,l.query,l.fragment,u)}static joinPath(l,...u){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return M.$i&&l.scheme==="file"?v=k.file(D.$fc.join(n(l,!0),...u)).path:v=D.$gc.join(l.path,...u),l.with({path:v})}toString(l=!1){return o(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof k)return l;{const u=new m(l);return u._formatted=l.external??null,u._fsPath=l._sep===c?l.fsPath??null:null,u}}else return l}}e.URI=k;function S(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}e.$vc=S;const c=M.$i?1:void 0;class m extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(l=!1){return l?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=c),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(f,l,u){let v,I=-1;for(let b=0;b<f.length;b++){const g=f.charCodeAt(b);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||l&&g===47||u&&g===91||u&&g===93||u&&g===58)I!==-1&&(v+=encodeURIComponent(f.substring(I,b)),I=-1),v!==void 0&&(v+=f.charAt(b));else{v===void 0&&(v=f.substr(0,b));const y=a[g];y!==void 0?(I!==-1&&(v+=encodeURIComponent(f.substring(I,b)),I=-1),v+=y):I===-1&&(I=b)}}return I!==-1&&(v+=encodeURIComponent(f.substring(I))),v!==void 0?v:f}function r(f){let l;for(let u=0;u<f.length;u++){const v=f.charCodeAt(u);v===35||v===63?(l===void 0&&(l=f.substr(0,u)),l+=a[v]):l!==void 0&&(l+=f[u])}return l!==void 0?l:f}function n(f,l){let u;return f.authority&&f.path.length>1&&f.scheme==="file"?u=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===47&&(f.path.charCodeAt(1)>=65&&f.path.charCodeAt(1)<=90||f.path.charCodeAt(1)>=97&&f.path.charCodeAt(1)<=122)&&f.path.charCodeAt(2)===58?l?u=f.path.substr(1):u=f.path[1].toLowerCase()+f.path.substr(2):u=f.path,M.$i&&(u=u.replace(/\//g,"\\")),u}e.$wc=n;function o(f,l){const u=l?r:i;let v="",{scheme:I,authority:b,path:g,query:y,fragment:L}=f;if(I&&(v+=I,v+=":"),(b||I==="file")&&(v+=C,v+=C),b){let T=b.indexOf("@");if(T!==-1){const U=b.substr(0,T);b=b.substr(T+1),T=U.lastIndexOf(":"),T===-1?v+=u(U,!1,!1):(v+=u(U.substr(0,T),!1,!1),v+=":",v+=u(U.substr(T+1),!1,!0)),v+="@"}b=b.toLowerCase(),T=b.lastIndexOf(":"),T===-1?v+=u(b,!1,!0):(v+=u(b.substr(0,T),!1,!0),v+=b.substr(T))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const T=g.charCodeAt(1);T>=65&&T<=90&&(g=`/${String.fromCharCode(T+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const T=g.charCodeAt(0);T>=65&&T<=90&&(g=`${String.fromCharCode(T+32)}:${g.substr(2)}`)}v+=u(g,!0,!1)}return y&&(v+="?",v+=u(y,!1,!1)),L&&(v+="#",v+=l?L:i(L,!1,!1)),v}function t(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+t(f.substr(3)):f}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(f){return f.match(h)?f.replace(h,l=>t(l)):f}}),define(ke[185],Se([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function M(E){const R=E;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$oq=M;function d(E){const R=[];let C;try{const p=JSON.parse(E.arguments),k=p[p.length-1];k&&k.__$stack&&(p.pop(),C=k.__$stack),R.push(...p)}catch{R.push("Unable to log remote console arguments",E.arguments)}return{args:R,stack:C}}e.$pq=d;function P(E){if(typeof E!="string")return P(d(E).stack);const R=E;if(R){const C=A(R),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$qq=P;function A(E){if(!E)return E;const R=E.indexOf(`
`);return R===-1?E:E.substring(0,R)}function w(E,R){const{args:C,stack:p}=d(E),k=typeof C[0]=="string"&&C.length===1;let S=A(p);S&&(S=`(${S.trim()})`);let c=[];if(typeof C[0]=="string"?S&&k?c=[`%c[${R}] %c${C[0]} %c${S}`,$("blue"),$(""),$("grey")]:c=[`%c[${R}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:c=[`%c[${R}]%`,$("blue"),...C],S&&!k&&c.push(S),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,c)}e.log=w;function $(E){return`color: ${E}`}}),define(ke[56],Se([1,0,21,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function d($){return JSON.stringify($,A)}e.$Ch=d;function P($){let E=JSON.parse($);return E=w(E),E}e.$Dh=P;function A($,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function w($,E=0){if(!$||E>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return M.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$ke||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let R=0;R<$.length;++R)$[R]=w($[R],E+1);else for(const R in $)Object.hasOwnProperty.call($,R)&&($[R]=w($[R],E+1))}return $}e.$Eh=w}),define(ke[15],Se([1,0,14,11,13,2]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var A;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function w(p,k){return P.URI.isUri(p)?(0,d.$af)(p.scheme,k):(0,d.$bf)(p,k+":")}e.$fg=w;function $(p,...k){return k.some(S=>w(p,S))}e.$gg=$,e.$hg="vscode-tkn",e.$ig="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${A.vscodeRemoteResource}`}set(k,S,c){this.a[k]=S,this.b[k]=c}setConnectionToken(k,S){this.c[k]=S}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)try{return this.e(k)}catch(r){return D.$1(r),k}const S=k.authority;let c=this.a[S];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const m=this.b[S],a=this.c[S];let i=`path=${encodeURIComponent(k.path)}`;return typeof a=="string"&&(i+=`&${e.$ig}=${encodeURIComponent(a)}`),P.URI.from({scheme:M.$o?this.d:A.vscodeRemoteResource,authority:`${c}:${m}`,path:this.f,query:i})}}e.$jg=new E,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class R{static{this.a=e.$og}asBrowserUri(k){const S=this.b(k,$e);return this.uriToBrowserUri(S)}uriToBrowserUri(k){return k.scheme===A.vscodeRemote?e.$jg.rewrite(k):k.scheme===A.file&&(M.$m||M.$q===`${A.vscodeFileResource}://${R.a}`)?k.with({scheme:A.vscodeFileResource,authority:k.authority||R.a,query:null,fragment:null}):k}asFileUri(k){const S=this.b(k,$e);return this.uriToFileUri(S)}uriToFileUri(k){return k.scheme===A.vscodeFileResource?k.with({scheme:A.file,authority:k.authority!==R.a?k.authority:null,query:null,fragment:null}):k}b(k,S){return P.URI.isUri(k)?k:P.URI.parse(S.toUrl(k))}}e.$pg=new R;var C;(function(p){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(k.get("3"));const S="vscode-coi";function c(a){let i;typeof a=="string"?i=new URL(a).searchParams:a instanceof URL?i=a.searchParams:P.URI.isUri(a)&&(i=new URL(a.toString(!0)).searchParams);const r=i?.get(S);if(r)return k.get(r)}p.getHeadersFromQuery=c;function m(a,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";a instanceof URLSearchParams?a.set(S,n):a[S]=n}p.addSearchParam=m})(C||(e.COI=C={}))}),define(ke[186],Se([1,0,157,15,11,2]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0;class A{constructor(p,k,S){this.id=p,this.dependencies=k,this.callback=S}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,k,S)=>{typeof p!="string"&&(S=k,k=p,p=null),(typeof k!="object"||!Array.isArray(k))&&(S=k,k=null),this.c.push(new A(p,k,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const k=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!k)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(p){return new Promise((k,S)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",a),c.removeEventListener("error",i)},a=r=>{m(),k(this.c.pop())},i=r=>{m(),S(r)};c.addEventListener("load",a),c.addEventListener("error",i),this.f&&(p=this.f.createScriptURL(p)),c.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(p){return new Promise((k,S)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),k(this.c.pop())}catch(c){S(c)}})}async j(p){try{const k=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=P.URI.parse(p).fsPath,a=k.readFileSync(m).toString(),i=c.wrap(a.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const $=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function R(C,p,k){if(D.$T){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[C]&&(C=E[C]);const S=`${C}/${p}`;if($.has(S))return $.get(S);let c;if(/^\w[\w\d+.-]*:\/\//.test(S))c=S;else{const r=`${k&&!d.$o?M.$mg:M.$lg}/${S}`;c=M.$pg.asBrowserUri(r).toString(!0)}const m=w.INSTANCE.load(c);return $.set(S,m),m}else return await new Promise((S,c)=>{$e([C],S,c)})}e.$jD=R}),define(ke[23],Se([1,0,34,15,17,11,13,2]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function $(k){return(0,w.$wc)(k,!0)}e.$wg=$;class E{constructor(S){this.a=S}compare(S,c,m=!1){return S===c?0:(0,A.$6e)(this.getComparisonKey(S,m),this.getComparisonKey(c,m))}isEqual(S,c,m=!1){return S===c?!0:!S||!c?!1:this.getComparisonKey(S,m)===this.getComparisonKey(c,m)}getComparisonKey(S,c=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,c,m=!1){if(S.scheme===c.scheme){if(S.scheme===M.Schemas.file)return D.$9f($(S),$(c),this.a(S))&&S.query===c.query&&(m||S.fragment===c.fragment);if((0,e.$Ng)(S.authority,c.authority))return D.$9f(S.path,c.path,this.a(S),"/")&&S.query===c.query&&(m||S.fragment===c.fragment)}return!1}joinPath(S,...c){return w.URI.joinPath(S,...c)}basenameOrAuthority(S){return(0,e.$Fg)(S)||S.authority}basename(S){return d.$gc.basename(S.path)}extname(S){return d.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let c;return S.scheme===M.Schemas.file?c=w.URI.file(d.$mc($(S))).path:(c=d.$gc.dirname(S.path),S.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),c="/")),S.with({path:c})}normalizePath(S){if(!S.path.length)return S;let c;return S.scheme===M.Schemas.file?c=w.URI.file(d.$hc($(S))).path:c=d.$gc.normalize(S.path),S.with({path:c})}relativePath(S,c){if(S.scheme!==c.scheme||!(0,e.$Ng)(S.authority,c.authority))return;if(S.scheme===M.Schemas.file){const i=d.$lc($(S),$(c));return P.$i?D.$3f(i):i}let m=S.path||"/";const a=c.path||"/";if(this.a(S)){let i=0;for(const r=Math.min(m.length,a.length);i<r&&!(m.charCodeAt(i)!==a.charCodeAt(i)&&m.charAt(i).toLowerCase()!==a.charAt(i).toLowerCase());i++);m=a.substr(0,i)+m.substr(i)}return d.$gc.relative(m,a)}resolvePath(S,c){if(S.scheme===M.Schemas.file){const m=w.URI.file(d.$kc($(S),c));return S.with({authority:m.authority,path:m.path})}return c=D.$4f(c),S.with({path:d.$gc.resolve(S.path,c)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,c){return S===c||S!==void 0&&c!==void 0&&(0,A.$af)(S,c)}hasTrailingPathSeparator(S,c=d.sep){if(S.scheme===M.Schemas.file){const m=$(S);return m.length>D.$5f(m).length&&m[m.length-1]===c}else{const m=S.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,c=d.sep){return(0,e.$Og)(S,c)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,c=d.sep){let m=!1;if(S.scheme===M.Schemas.file){const a=$(S);m=a!==void 0&&a.length===D.$5f(a).length&&a[a.length-1]===c}else{c="/";const a=S.path;m=a.length===1&&a.charCodeAt(a.length-1)===47}return!m&&!(0,e.$Og)(S,c)?S.with({path:S.path+"/"}):S}}e.$xg=E,e.$yg=new E(()=>!1),e.$zg=new E(k=>k.scheme===M.Schemas.file?!P.$k:!0),e.$Ag=new E(k=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function R(k,S){const c=[];for(let m=0;m<k.length;m++){const a=S(k[m]);k.some((i,r)=>r===m?!1:(0,e.$Cg)(a,S(i)))||c.push(k[m])}return c}e.$Rg=R;var C;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function S(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,o]=r.split(":");n&&o&&m.set(n,o)});const i=c.path.substring(0,c.path.indexOf(";"));return i&&m.set(k.META_DATA_MIME,i),m}k.parseMetaData=S})(C||(e.DataUri=C={}));function p(k,S,c){if(S){let m=k.path;return m&&m[0]!==d.$gc.sep&&(m=d.$gc.sep+m),k.with({scheme:c,authority:S,path:m})}return k.with({scheme:c})}e.$Sg=p}),define(ke[8],Se([1,0,22,14,4,3,23,11,163,43]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function R(me){return!!me&&typeof me.then=="function"}e.$Tg=R;function C(me){const V=new D.$7d,Y=me(V.token),de=new Promise((pe,Pe)=>{const ve=V.token.onCancellationRequested(()=>{ve.dispose(),Pe(new M.$5)});Promise.resolve(Y).then(Ce=>{ve.dispose(),V.dispose(),pe(Ce)},Ce=>{ve.dispose(),V.dispose(),Pe(Ce)})});return new class{cancel(){V.cancel(),V.dispose()}then(pe,Pe){return de.then(pe,Pe)}catch(pe){return this.then(void 0,pe)}finally(pe){return de.finally(pe)}}}e.$Ug=C;function p(me,V,Y){return new Promise((de,pe)=>{const Pe=V.onCancellationRequested(()=>{Pe.dispose(),de(Y)});me.then(de,pe).finally(()=>Pe.dispose())})}e.$Vg=p;function k(me,V){return new Promise((Y,de)=>{const pe=V.onCancellationRequested(()=>{pe.dispose(),de(new M.$5)});me.then(Y,de).finally(()=>pe.dispose())})}e.$Wg=k;async function S(me){let V=-1;const Y=me.map((de,pe)=>de.then(Pe=>(V=pe,Pe)));try{return await Promise.race(Y)}finally{me.forEach((de,pe)=>{pe!==V&&de.cancel()})}}e.$Xg=S;function c(me,V,Y){let de;const pe=setTimeout(()=>{de?.(void 0),Y?.()},V);return Promise.race([me.finally(()=>clearTimeout(pe)),new Promise(Pe=>de=Pe)])}e.$Yg=c;function m(me){return new Promise((V,Y)=>{const de=me();R(de)?de.then(V,Y):V(de)})}e.$Zg=m;function a(){let me,V;return{promise:new Promise((de,pe)=>{me=de,V=pe}),resolve:me,reject:V}}e.$1g=a;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const Y=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(Y,Y).then(de)})}return new Promise((Y,de)=>{this.b.then(Y,de)})}return this.a=V(),new Promise((Y,de)=>{this.a.then(pe=>{this.a=null,Y(pe)},pe=>{this.a=null,de(pe)})})}dispose(){this.f=!0}}e.$2g=i;class r{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$3g=r;class n{constructor(){this.a=new Map}queue(V,Y){const pe=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(V)===pe&&this.a.delete(V)});return this.a.set(V,pe),pe}}e.$4g=n;const o=(me,V)=>{let Y=!0;const de=setTimeout(()=>{Y=!1,V()},me);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(de),Y=!1}}},t=me=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,me())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class h{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,Y=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((pe,Pe)=>{this.d=pe,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=Y===$.$Td?t(de):o(Y,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=h;class s{constructor(V){this.a=new h(V),this.b=new i}trigger(V,Y){return this.a.trigger(()=>this.b.queue(V),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=s;class f{constructor(){this.a=!1,this.b=new Promise((V,Y)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=f;class l extends f{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$8g=l;function u(me,V){return V?new Promise((Y,de)=>{const pe=setTimeout(()=>{Pe.dispose(),Y()},me),Pe=V.onCancellationRequested(()=>{clearTimeout(pe),Pe.dispose(),de(new M.$5)})}):C(Y=>u(me,Y))}e.$9g=u;function v(me,V=0,Y){const de=setTimeout(()=>{me(),Y&&pe.dispose()},V),pe=(0,P.$Rc)(()=>{clearTimeout(de),Y?.deleteAndLeak(pe)});return Y?.add(pe),pe}e.$0g=v;function I(me){const V=[];let Y=0;const de=me.length;function pe(){return Y<de?me[Y++]():null}function Pe(ve){ve!=null&&V.push(ve);const Ce=pe();return Ce?Ce.then(Pe):Promise.resolve(V)}return Promise.resolve(null).then(Pe)}e.$$g=I;function b(me,V=de=>!!de,Y=null){let de=0;const pe=me.length,Pe=()=>{if(de>=pe)return Promise.resolve(Y);const ve=me[de++];return Promise.resolve(ve()).then(B=>V(B)?Promise.resolve(B):Pe())};return Pe()}e.$_g=b;function g(me,V=de=>!!de,Y=null){if(me.length===0)return Promise.resolve(Y);let de=me.length;const pe=()=>{de=-1;for(const Pe of me)Pe.cancel?.()};return new Promise((Pe,ve)=>{for(const Ce of me)Ce.then(B=>{--de>=0&&V(B)?(pe(),Pe(B)):de===0&&Pe(Y)}).catch(B=>{--de>=0&&(pe(),ve(B))})})}e.$ah=g;class y{constructor(V){this.a=0,this.b=!1,this.f=V,this.g=[],this.d=0,this.h=new d.$Wd}whenIdle(){return this.size>0?d.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(V){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,de)=>{this.g.push({factory:V,c:Y,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const V=this.g.shift();this.d++;const Y=V.factory();Y.then(V.c,V.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=y;class L extends y{constructor(){super(1)}}e.$ch=L;class T{constructor(){this.a=new Z,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$dh=T;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new ge;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueSize(V,Y=A.$yg){const de=Y.getComparisonKey(V);return this.a.get(de)?.size??0}queueFor(V,Y,de=A.$yg){const pe=de.getComparisonKey(V);let Pe=this.a.get(pe);if(!Pe){Pe=new L;const ve=this.f++,Ce=d.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$3c),this.d.set(ve,Ce),this.a.set(pe,Pe)}return Pe.queue(Y)}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=U;class j{constructor(V,Y){this.a=-1,typeof V=="function"&&typeof Y=="number"&&this.setIfNotSet(V,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},Y)}setIfNotSet(V,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},Y))}}e.$fh=j;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(V,Y,de=globalThis){this.cancel();const pe=de.setInterval(()=>{V()},Y);this.d=(0,P.$Rc)(()=>{de.clearInterval(pe),this.d=void 0})}dispose(){this.cancel()}}e.$gh=F;class N{constructor(V,Y){this.b=-1,this.a=V,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=N;class O{constructor(V,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=V,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=O;class z extends N{constructor(V,Y){super(V,Y),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$jh=z;class K extends P.$Tc{constructor(V,Y){super(),this.g=V,this.h=Y,this.a=[],this.b=this.B(new P.$Uc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of V)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(me,V)=>{(0,w.$B)(()=>{if(Y)return;const de=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$mh=(me,V,Y)=>{const de=me.requestIdleCallback(V,typeof Y=="number"?{timeout:Y}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,me.cancelIdleCallback(de))}}},e.$lh=me=>(0,e.$mh)(globalThis,me)}();class te{constructor(V,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$mh)(V,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=te;class x extends te{constructor(V){super(globalThis,V)}}e.$oh=x;async function X(me,V,Y){let de;for(let pe=0;pe<Y;pe++)try{return await me()}catch(Pe){de=Pe,await u(V)}throw de}e.$ph=X;class Z{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,Y,de){return this.a={taskId:V,cancel:()=>de?.(),promise:Y},Y.then(()=>this.d(V),()=>this.d(V)),Y}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{const{promise:Y,resolve:de,reject:pe}=a();this.b={run:V,promise:Y,promiseResolve:de,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=Z;class ce{constructor(V,Y=()=>Date.now()){this.d=V,this.f=Y,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$rh=ce;var _;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(_||(_={}));class ge{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,Y)=>{this.a=V,this.b=Y})}complete(V){return new Promise(Y=>{this.a(V),this.d={outcome:0,value:V},Y()})}error(V){return new Promise(Y=>{this.b(V),this.d={outcome:1,value:V},Y()})}cancel(){return this.error(new M.$5)}}e.$sh=ge;var ne;(function(me){async function V(de){let pe;const Pe=await Promise.all(de.map(ve=>ve.then(Ce=>Ce,Ce=>{pe||(pe=Ce)})));if(typeof pe<"u")throw pe;return Pe}me.settled=V;function Y(de){return new Promise(async(pe,Pe)=>{try{await de(pe,Pe)}catch(ve){Pe(ve)}})}me.withAsyncBody=Y})(ne||(e.Promises=ne={}));class J{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(V){this.a=void 0,this.b=void 0,this.d=!1,this.promise=V.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=J;class W{constructor(V){this.b=V,this.a=new E.$V(()=>new J(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=W;var re;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(re||(re={}));class ye{static fromArray(V){return new ye(Y=>{Y.emitMany(V)})}static fromPromise(V){return new ye(async Y=>{Y.emitMany(await V)})}static fromPromises(V){return new ye(async Y=>{await Promise.all(V.map(async de=>Y.emitOne(await de)))})}static merge(V){return new ye(async Y=>{await Promise.all(V.map(async de=>{for await(const pe of de)Y.emitOne(pe)}))})}static{this.EMPTY=ye.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new d.$Wd,queueMicrotask(async()=>{const Y={emitOne:de=>this.g(de),emitMany:de=>this.h(de),reject:de=>this.k(de)};try{await Promise.resolve(V(Y)),this.j()}catch(de){this.k(de)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await d.Event.toPromise(this.f.event)}while(!0)}}}static map(V,Y){return new ye(async de=>{for await(const pe of V)de.emitOne(Y(pe))})}map(V){return ye.map(this,V)}static filter(V,Y){return new ye(async de=>{for await(const pe of V)Y(pe)&&de.emitOne(pe)})}filter(V){return ye.filter(this,V)}static coalesce(V){return ye.filter(V,Y=>!!Y)}coalesce(){return ye.coalesce(this)}static async toPromise(V){const Y=[];for await(const de of V)Y.push(de);return Y}toPromise(){return ye.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$vh=ye;class he extends ye{constructor(V,Y){super(Y),this.l=V}cancel(){this.l.cancel()}}e.$wh=he;function fe(me){const V=new D.$7d,Y=me(V.token);return new he(V,async de=>{const pe=V.token.onCancellationRequested(()=>{pe.dispose(),V.dispose(),de.reject(new M.$5)});try{for await(const Pe of Y){if(V.token.isCancellationRequested)return;de.emitOne(Pe)}pe.dispose(),V.dispose()}catch(Pe){pe.dispose(),V.dispose(),de.reject(Pe)}})}e.$xh=fe;class ue{constructor(){this.a=new ge,this.b=new ye(de=>{if(V){de.reject(V);return}return Y&&de.emitMany(Y),this.d=pe=>de.reject(pe),this.f=pe=>de.emitOne(pe),this.a.p});let V,Y;this.f=de=>{Y||(Y=[]),Y.push(de)},this.d=de=>{V||(V=de)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(V){this.d(V),this.a.complete()}emitOne(V){this.f(V)}}e.$yh=ue}),define(ke[35],Se([1,0,19,8,34,28,17,11,13]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function E(){return Object.create(null)}e.$Jj=E,e.$Kj="**",e.$Lj="/";const R="[/\\\\]",C="[^/\\\\]",p=/\//g;function k(te,x){switch(te){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}${x?`|${R}${C}+`:""})*?`}}function S(te,x){if(!te)return[];const X=[];let Z=!1,ce=!1,_="";for(const ge of te){switch(ge){case x:if(!Z&&!ce){X.push(_),_="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}_+=ge}return _&&X.push(_),X}e.$Mj=S;function c(te){if(!te)return"";let x="";const X=S(te,e.$Lj);if(X.every(Z=>Z===e.$Kj))x=".*";else{let Z=!1;X.forEach((ce,_)=>{if(ce===e.$Kj){if(Z)return;x+=k(2,_===X.length-1)}else{let ge=!1,ne="",J=!1,W="";for(const re of ce){if(re!=="}"&&ge){ne+=re;continue}if(J&&(re!=="]"||!W)){let ye;re==="-"?ye=re:(re==="^"||re==="!")&&!W?ye="^":re===e.$Lj?ye="":ye=(0,$.$Pe)(re),W+=ye;continue}switch(re){case"{":ge=!0;continue;case"[":J=!0;continue;case"}":{const he=`(?:${S(ne,",").map(fe=>c(fe)).join("|")})`;x+=he,ge=!1,ne="";break}case"]":{x+="["+W+"]",J=!1,W="";break}case"?":x+=C;continue;case"*":x+=k(1);continue;default:x+=(0,$.$Pe)(re)}}_<X.length-1&&(X[_+1]!==e.$Kj||_+2<X.length)&&(x+=R)}Z=ce===e.$Kj})}return x}const m=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Dc(1e4),h=function(){return!1},s=function(){return null};function f(te,x){if(!te)return s;let X;typeof te!="string"?X=te.pattern:X=te,X=X.trim();const Z=`${X}_${!!x.trimForExclusions}`;let ce=t.get(Z);if(ce)return l(ce,te);let _;return m.test(X)?ce=v(X.substr(4),X):(_=a.exec(u(X,x)))?ce=I(_[1],X):(x.trimForExclusions?r:i).test(X)?ce=b(X,x):(_=n.exec(u(X,x)))?ce=g(_[1].substr(1),X,!0):(_=o.exec(u(X,x)))?ce=g(_[1],X,!1):ce=y(X),t.set(Z,ce),l(ce,te)}function l(te,x){if(typeof x=="string")return te;const X=function(Z,ce){return(0,d.$9f)(Z,x.base,!w.$k)?te((0,$.$Ue)(Z.substr(x.base.length),A.sep),ce):null};return X.allBasenames=te.allBasenames,X.allPaths=te.allPaths,X.basenames=te.basenames,X.patterns=te.patterns,X}function u(te,x){return x.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function v(te,x){return function(X,Z){return typeof X=="string"&&X.endsWith(te)?x:null}}function I(te,x){const X=`/${te}`,Z=`\\${te}`,ce=function(ge,ne){return typeof ge!="string"?null:ne?ne===te?x:null:ge===te||ge.endsWith(X)||ge.endsWith(Z)?x:null},_=[te];return ce.basenames=_,ce.patterns=[x],ce.allBasenames=_,ce}function b(te,x){const X=z(te.slice(1,-1).split(",").map(ne=>f(ne,x)).filter(ne=>ne!==s),te),Z=X.length;if(!Z)return s;if(Z===1)return X[0];const ce=function(ne,J){for(let W=0,re=X.length;W<re;W++)if(X[W](ne,J))return te;return null},_=X.find(ne=>!!ne.allBasenames);_&&(ce.allBasenames=_.allBasenames);const ge=X.reduce((ne,J)=>J.allPaths?ne.concat(J.allPaths):ne,[]);return ge.length&&(ce.allPaths=ge),ce}function g(te,x,X){const Z=A.sep===A.$gc.sep,ce=Z?te:te.replace(p,A.sep),_=A.sep+ce,ge=A.$gc.sep+te;let ne;return X?ne=function(J,W){return typeof J=="string"&&(J===ce||J.endsWith(_)||!Z&&(J===te||J.endsWith(ge)))?x:null}:ne=function(J,W){return typeof J=="string"&&(J===ce||!Z&&J===te)?x:null},ne.allPaths=[(X?"*/":"./")+te],ne}function y(te){try{const x=new RegExp(`^${c(te)}$`);return function(X){return x.lastIndex=0,typeof X=="string"&&x.test(X)?te:null}}catch{return s}}function L(te,x,X){return!te||typeof x!="string"?!1:T(te)(x,void 0,X)}e.$Nj=L;function T(te,x={}){if(!te)return h;if(typeof te=="string"||U(te)){const X=f(te,x);if(X===s)return h;const Z=function(ce,_){return!!X(ce,_)};return X.allBasenames&&(Z.allBasenames=X.allBasenames),X.allPaths&&(Z.allPaths=X.allPaths),Z}return N(te,x)}e.$Oj=T;function U(te){const x=te;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$Pj=U;function j(te){return te.allBasenames||[]}e.$Qj=j;function F(te){return te.allPaths||[]}e.$Rj=F;function N(te,x){const X=z(Object.getOwnPropertyNames(te).map(ne=>O(ne,te[ne],x)).filter(ne=>ne!==s)),Z=X.length;if(!Z)return s;if(!X.some(ne=>!!ne.requiresSiblings)){if(Z===1)return X[0];const ne=function(re,ye){let he;for(let fe=0,ue=X.length;fe<ue;fe++){const me=X[fe](re,ye);if(typeof me=="string")return me;(0,M.$Tg)(me)&&(he||(he=[]),he.push(me))}return he?(async()=>{for(const fe of he){const ue=await fe;if(typeof ue=="string")return ue}return null})():null},J=X.find(re=>!!re.allBasenames);J&&(ne.allBasenames=J.allBasenames);const W=X.reduce((re,ye)=>ye.allPaths?re.concat(ye.allPaths):re,[]);return W.length&&(ne.allPaths=W),ne}const ce=function(ne,J,W){let re,ye;for(let he=0,fe=X.length;he<fe;he++){const ue=X[he];ue.requiresSiblings&&W&&(J||(J=(0,A.$nc)(ne)),re||(re=J.substr(0,J.length-(0,A.$oc)(ne).length)));const me=ue(ne,J,re,W);if(typeof me=="string")return me;(0,M.$Tg)(me)&&(ye||(ye=[]),ye.push(me))}return ye?(async()=>{for(const he of ye){const fe=await he;if(typeof fe=="string")return fe}return null})():null},_=X.find(ne=>!!ne.allBasenames);_&&(ce.allBasenames=_.allBasenames);const ge=X.reduce((ne,J)=>J.allPaths?ne.concat(J.allPaths):ne,[]);return ge.length&&(ce.allPaths=ge),ce}function O(te,x,X){if(x===!1)return s;const Z=f(te,X);if(Z===s)return s;if(typeof x=="boolean")return Z;if(x){const ce=x.when;if(typeof ce=="string"){const _=(ge,ne,J,W)=>{if(!W||!Z(ge,ne))return null;const re=ce.replace("$(basename)",()=>J),ye=W(re);return(0,M.$Tg)(ye)?ye.then(he=>he?te:null):ye?te:null};return _.requiresSiblings=!0,_}}return Z}function z(te,x){const X=te.filter(ne=>!!ne.basenames);if(X.length<2)return te;const Z=X.reduce((ne,J)=>{const W=J.basenames;return W?ne.concat(W):ne},[]);let ce;if(x){ce=[];for(let ne=0,J=Z.length;ne<J;ne++)ce.push(x)}else ce=X.reduce((ne,J)=>{const W=J.patterns;return W?ne.concat(W):ne},[]);const _=function(ne,J){if(typeof ne!="string")return null;if(!J){let re;for(re=ne.length;re>0;re--){const ye=ne.charCodeAt(re-1);if(ye===47||ye===92)break}J=ne.substr(re)}const W=Z.indexOf(J);return W!==-1?ce[W]:null};_.basenames=Z,_.patterns=ce,_.allBasenames=Z;const ge=te.filter(ne=>!ne.basenames);return ge.push(_),ge}function K(te,x){return(0,D.$ub)(te,x,(X,Z)=>typeof X=="string"&&typeof Z=="string"?X===Z:typeof X!="string"&&typeof Z!="string"?X.base===Z.base&&X.pattern===Z.pattern:!1)}e.$Sj=K}),define(ke[63],Se([1,0,14,164,23,13,2]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class ${constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=p(this.supportThemeIcons?(0,M.$dk)(i):i).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${k(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,r){const n=new RegExp((0,P.$Pe)(r),"g");return i.replace(n,(o,t)=>i.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$jk=$;function E(a){return R(a)?!a.value:Array.isArray(a)?a.every(E):!0}e.$kk=E;function R(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.$lk=R;function C(a,i){return a===i?!0:!a||!i?!1:a.value===i.value&&a.isTrusted===i.isTrusted&&a.supportThemeIcons===i.supportThemeIcons&&a.supportHtml===i.supportHtml&&(a.baseUri===i.baseUri||!!a.baseUri&&!!i.baseUri&&(0,d.$Bg)(A.URI.from(a.baseUri),A.URI.from(i.baseUri)))}e.$mk=C;function p(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$nk=p;function k(a,i){const r=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,a,`${"`".repeat(n)}`].join(`
`)}e.$ok=k;function S(a){return a.replace(/"/g,"&quot;")}e.$pk=S;function c(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$qk=c;function m(a){const i=[],r=a.split("|").map(o=>o.trim());a=r[0];const n=r[1];if(n){const o=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),h=o?o[1]:"",s=t?t[1]:"",f=isFinite(parseInt(s)),l=isFinite(parseInt(h));f&&i.push(`width="${s}"`),l&&i.push(`height="${h}"`)}return{href:a,dimensions:i}}e.$rk=m}),define(ke[102],Se([1,0,19,34,17,11,23,13]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function $(f,l){const{os:u,tildify:v,relative:I}=l;if(I){const y=E(f,I,u);if(typeof y=="string")return y}let b=f.fsPath;if(u===1&&!P.$i?b=b.replace(/\//g,"\\"):u!==1&&P.$i&&(b=b.replace(/\\/g,"/")),u!==1&&v?.userHome){const y=v.userHome.fsPath;let L;f.scheme!==v.userHome.scheme&&f.path[0]===d.$gc.sep&&f.path[1]!==d.$gc.sep?L=v.userHome.with({path:f.path}).fsPath:L=b,b=p(L,y,u)}return(u===1?d.$fc:d.$gc).normalize(R(b,u===1))}e.$Xv=$;function E(f,l,u){const v=u===1?d.$fc:d.$gc,I=u===3?A.$yg:A.$Ag,b=l.getWorkspace(),g=(0,D.$Ob)(b.folders);if(!g)return;f.scheme!==g.uri.scheme&&f.path[0]===d.$gc.sep&&f.path[1]!==d.$gc.sep&&(f=g.uri.with({path:f.path}));const y=l.getWorkspaceFolder(f);if(!y)return;let L;if(I.isEqual(y.uri,f)?L="":L=I.relativePath(y.uri,f)??"",L&&(L=v.normalize(L)),b.folders.length>1&&!l.noPrefix){const T=y.name?y.name:I.basenameOrAuthority(y.uri);L=L?`${T} \u2022 ${L}`:T}return L}function R(f,l=P.$i){return(0,M.$ag)(f,l)?f.charAt(0).toUpperCase()+f.slice(1):f}e.$Yv=R;let C=Object.create(null);function p(f,l,u=P.OS){if(u===1||!f||!l)return f;let v=C.original===l?C.normalized:void 0;v||(v=l,P.$i&&(v=(0,M.$3f)(v)),v=`${(0,w.$Ve)(v,d.$gc.sep)}${d.$gc.sep}`,C={original:l,normalized:v});let I=f;return P.$i&&(I=(0,M.$3f)(I)),(u===3?I.startsWith(v):(0,w.$bf)(I,v))?`~/${I.substr(v.length)}`:f}e.$Zv=p;function k(f,l){return f.replace(/^~($|\/|\\)/,`${l}$1`)}e.$1v=k;const S="\u2026",c="\\\\",m="~";function a(f,l=d.sep){const u=new Array(f.length);let v=!1;for(let I=0;I<f.length;I++){const b=f[I];if(b===""){u[I]=`.${l}`;continue}if(!b){u[I]=b;continue}v=!0;let g="",y=b;y.indexOf(c)===0?(g=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(l)===0?(g=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(m)===0&&(g=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const L=y.split(l);for(let T=1;v&&T<=L.length;T++)for(let U=L.length-T;v&&U>=0;U--){v=!1;let j=L.slice(U,U+T).join(l);for(let F=0;!v&&F<f.length;F++)if(F!==I&&f[F]&&f[F].indexOf(j)>-1){const N=U+T===L.length,O=U>0&&f[F].indexOf(l)>-1?l+j:j,z=f[F].endsWith(O);v=!N||z}if(!v){let F="";(L[0].endsWith(":")||g!=="")&&(U===1&&(U=0,T++,j=L[0]+l+j),U>0&&(F=L[0]+l),F=g+F),U>0&&(F=F+S+l),F=F+j,U+T<L.length&&(F=F+l+S),u[I]=F}}v&&(u[I]=b)}return u}e.$2v=a;var i;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(f,l=Object.create(null)){const u=[];let v=!1,I="";for(const b of f)if(b==="$"||v&&b==="{")I&&u.push({value:I,type:i.TEXT}),I="",v=!0;else if(b==="}"&&v){const g=l[I];if(typeof g=="string")g.length&&u.push({value:g,type:i.VARIABLE});else if(g){const y=u[u.length-1];(!y||y.type!==i.SEPARATOR)&&u.push({value:g.label,type:i.SEPARATOR})}I="",v=!1}else I+=b;return I&&!v&&u.push({value:I,type:i.TEXT}),u.filter((b,g)=>{if(b.type===i.SEPARATOR){const y=u[g-1],L=u[g+1];return[y,L].every(T=>T&&(T.type===i.VARIABLE||T.type===i.TEXT)&&T.value.length>0)}return!0}).map(b=>b.value).join("")}e.$3v=r;function n(f,l){return P.$j||l?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):f.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.$4v=n;function o(f,l){return P.$j||l?f.replace(/\(&&\w\)|&&/g,""):P.$i?f.replace(/&&|&/g,u=>u==="&"?"&&":"&"):f.replace(/&&/g,"_")}e.$5v=o;function t(f){return f.replace(/&/g,"&&")}e.$6v=t;function h(f){if(f.endsWith("]")){const l=f.lastIndexOf(" [",f.length-2);if(l!==-1){const u=s(f.substring(0,l)),v=f.substring(l);return{name:u.name+v,parentPath:u.parentPath}}}return s(f)}e.$7v=h;function s(f){const l=f.indexOf("/")!==-1?d.$gc:d.$fc,u=l.basename(f),v=l.dirname(f);return u.length?{name:u,parentPath:v}:{name:v,parentPath:""}}}),define(ke[130],Se([1,0,21,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function d(C){return C.toJSON()}class P{constructor(p){this.a=p}transformIncoming(p){const k=this.a.transformIncoming(p);return k===p?p:d(M.URI.from(k))}transformOutgoing(p){const k=this.a.transformOutgoing(p);return k===p?p:d(M.URI.from(k))}transformOutgoingURI(p){const k=this.a.transformOutgoing(p);return k===p?p:M.URI.from(k)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$7m=P,e.$8m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,p,k){if(!C||k>200)return null;if(typeof C=="object"){if(C instanceof M.URI)return p.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const c=A(C[S],p,k+1);c!==null&&(C[S]=c)}}return null}function w(C,p){const k=A(C,p,0);return k===null?C:k}e.$9m=w;function $(C,p,k,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return k?M.URI.revive(p.transformIncoming(C)):p.transformIncoming(C);if(C instanceof D.$ke)return null;for(const c in C)if(Object.hasOwnProperty.call(C,c)){const m=$(C[c],p,k,S+1);m!==null&&(C[c]=m)}}return null}function E(C,p){const k=$(C,p,!1,0);return k===null?C:k}e.$0m=E;function R(C,p){const k=$(C,p,!0,0);return k===null?C:k}e.$$m=R}),define(ke[31],Se([1,0,57,64,386,8,34,77,17,11,23,2]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function k(O,z=p.UNLINK,K){if((0,A.$_f)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?c(O):S(O,K)}async function S(O,z=(0,A.$eg)((0,M.tmpdir)())){try{try{await D.promises.rename(O,z)}catch(K){return K.code==="ENOENT"?void 0:c(O)}c(z).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function c(O){return(0,d.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function m(O){if((0,A.$_f)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function a(O,z){return n(await(z?i(O):(0,d.promisify)(D.readdir)(O)))}async function i(O){try{return await(0,d.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const z=[],K=await a(O);for(const te of K){let x=!1,X=!1,Z=!1;try{const ce=await e.Promises.lstat((0,$.$jc)(O,te));x=ce.isFile(),X=ce.isDirectory(),Z=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}z.push({name:te,isFile:()=>x,isDirectory:()=>X,isSymbolicLink:()=>Z})}return z}function r(O){return n(D.readdirSync(O))}e.readdirSync=r;function n(O){return O.map(z=>typeof z=="string"?E.$j?(0,w.$Il)(z):z:(z.name=E.$j?(0,w.$Il)(z.name):z.name,z))}async function o(O){const z=await a(O),K=[];for(const te of z)await h.existsDirectory((0,$.$jc)(O,te))&&K.push(te);return K}function t(O,z=1e3){return new Promise(K=>{let te=!1;const x=setInterval(()=>{te||(te=!0,D.access(O,X=>{te=!1,X&&(clearInterval(x),K(void 0))}))},z)})}e.whenDeleted=t;var h;(function(O){async function z(x){let X;try{if(X=await e.Promises.lstat(x),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(E.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw ce}throw Z}}O.stat=z;async function K(x){try{const{stat:X,symbolicLink:Z}=await O.stat(x);return X.isFile()&&Z?.dangling!==!0}catch{}return!1}O.existsFile=K;async function te(x){try{const{stat:X,symbolicLink:Z}=await O.stat(x);return X.isDirectory()&&Z?.dangling!==!0}catch{}return!1}O.existsDirectory=te})(h||(e.SymlinkSupport=h={}));const s=new P.$eh;function f(O,z,K){return s.queueFor(C.URI.file(O),()=>{const te=b(K);return new Promise((x,X)=>v(O,z,te,Z=>Z?X(Z):x()))},R.$zg)}let l=!0;function u(O){l=O}e.configureFlushOnWrite=u;function v(O,z,K,te){if(!l)return D.writeFile(O,z,{mode:K.mode,flag:K.flag},te);D.open(O,K.flag,K.mode,(x,X)=>{if(x)return te(x);D.writeFile(X,z,Z=>{if(Z)return D.close(X,()=>te(Z));D.fdatasync(X,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),u(!1)),D.close(X,_=>te(_))))})})}function I(O,z,K){const te=b(K);if(!l)return D.writeFileSync(O,z,{mode:te.mode,flag:te.flag});const x=D.openSync(O,te.flag,te.mode);try{D.writeFileSync(x,z);try{D.fdatasyncSync(x)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),u(!1)}}finally{D.closeSync(x)}}e.writeFileSync=I;function b(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function g(O,z,K=6e4){if(O!==z)try{E.$i&&typeof K=="number"?await y(O,z,Date.now(),K):await(0,d.promisify)(D.rename)(O,z)}catch(te){if(O.toLowerCase()!==z.toLowerCase()&&te.code==="EXDEV"||O.endsWith("."))await L(O,z,{preserveSymlinks:!1}),await k(O,p.MOVE);else throw te}}async function y(O,z,K,te,x=0){try{return await(0,d.promisify)(D.rename)(O,z)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-K>=te)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${X}`),X;if(x===0){let Z=!1;try{const{stat:ce}=await h.stat(z);ce.isFile()||(Z=!0)}catch{}if(Z)throw X}return await(0,P.$9g)(Math.min(100,x*10)),y(O,z,K,te,x+1)}}async function L(O,z,K){return U(O,z,{root:{source:O,target:z},options:K,handledSourcePaths:new Set})}const T=511;async function U(O,z,K){if(K.handledSourcePaths.has(O))return;K.handledSourcePaths.add(O);const{stat:te,symbolicLink:x}=await h.stat(O);if(x){if(K.options.preserveSymlinks)try{return await N(O,z,K)}catch{}if(x.dangling)return}return te.isDirectory()?j(O,z,te.mode&T,K):F(O,z,te.mode&T)}async function j(O,z,K,te){await e.Promises.mkdir(z,{recursive:!0,mode:K});const x=await a(O);for(const X of x)await U((0,$.$jc)(O,X),(0,$.$jc)(z,X),te)}async function F(O,z,K){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,K)}async function N(O,z,K){let te=await e.Promises.readlink(O);(0,A.$9f)(te,K.root.source,!E.$k)&&(te=(0,$.$jc)(K.root.target,te.substr(K.root.source.length+1))),await e.Promises.symlink(te,z)}e.Promises=new class{get access(){return(0,d.promisify)(D.access)}get stat(){return(0,d.promisify)(D.stat)}get lstat(){return(0,d.promisify)(D.lstat)}get utimes(){return(0,d.promisify)(D.utimes)}get read(){return(O,z,K,te,x)=>new Promise((X,Z)=>{D.read(O,z,K,te,x,(ce,_,ge)=>ce?Z(ce):X({bytesRead:_,buffer:ge}))})}get readFile(){return(0,d.promisify)(D.readFile)}get write(){return(O,z,K,te,x)=>new Promise((X,Z)=>{D.write(O,z,K,te,x,(ce,_,ge)=>ce?Z(ce):X({bytesWritten:_,buffer:ge}))})}get appendFile(){return(0,d.promisify)(D.appendFile)}get fdatasync(){return(0,d.promisify)(D.fdatasync)}get truncate(){return(0,d.promisify)(D.truncate)}get copyFile(){return(0,d.promisify)(D.copyFile)}get open(){return(0,d.promisify)(D.open)}get close(){return(0,d.promisify)(D.close)}get symlink(){return(0,d.promisify)(D.symlink)}get readlink(){return(0,d.promisify)(D.readlink)}get chmod(){return(0,d.promisify)(D.chmod)}get mkdir(){return(0,d.promisify)(D.mkdir)}get unlink(){return(0,d.promisify)(D.unlink)}get rmdir(){return(0,d.promisify)(D.rmdir)}get realpath(){return(0,d.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return f}get rm(){return k}get rename(){return g}get copy(){return L}}}),define(ke[103],Se([1,0,57,17,11,13,31]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=void 0;function w(p){if(d.$k)return p;const k=(0,M.$mc)(p);if(p===k)return p;const S=((0,M.$nc)(p)||p).toLowerCase();try{const m=(0,A.readdirSync)(k).filter(a=>a.toLowerCase()===S);if(m.length===1){const a=w(k);if(a)return(0,M.$jc)(a,m[0])}else if(m.length>1){const a=m.indexOf(S);if(a>=0){const i=w(k);if(i)return(0,M.$jc)(i,m[a])}}}catch{}return null}e.$vq=w;async function $(p){if(d.$k)return p;const k=(0,M.$mc)(p);if(p===k)return p;const S=((0,M.$nc)(p)||p).toLowerCase();try{const m=(await A.Promises.readdir(k)).filter(a=>a.toLowerCase()===S);if(m.length===1){const a=await $(k);if(a)return(0,M.$jc)(a,m[0])}else if(m.length>1){const a=m.indexOf(S);if(a>=0){const i=await $(k);if(i)return(0,M.$jc)(i,m[a])}}}catch{}return null}e.$wq=$;async function E(p){try{return await A.Promises.realpath(p)}catch{const S=C(p);return await A.Promises.access(S,D.constants.R_OK),S}}e.$xq=E;function R(p){try{return D.realpathSync(p)}catch{const S=C(p);return D.accessSync(S,D.constants.R_OK),S}}e.$yq=R;function C(p){return(0,P.$Ve)((0,M.$hc)(p),M.sep)}}),define(ke[104],Se([1,0,17,11,49,101,18,31]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(C=d.env){return C.comspec||"cmd.exe"}e.$Vl=$;function E(C){let p=[],k=!1;const S=function(c){if(k){p.push(c);return}(!C.send(c,a=>{if(a&&console.error(a),k=!1,p.length>0){const i=p.slice(0);p=[],i.forEach(r=>S(r))}})||M.$i)&&(k=!0)};return{send:S}}e.$Wl=E;var R;(function(C){async function p(k,S,c){if(D.$ic(k))return k;if(S===void 0&&(S=d.cwd()),D.$mc(k)!=="."||(c===void 0&&A.$Jf(d.env.PATH)&&(c=d.env.PATH.split(D.$tc)),c===void 0||c.length===0))return D.$jc(S,k);async function a(i){if(await w.Promises.exists(i)){let r;try{r=await w.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await w.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of c){let r;if(D.$ic(i)?r=D.$jc(i,k):r=D.$jc(S,i,k),await a(r))return r;let n=r+".com";if(await a(n)||(n=r+".exe",await a(n)))return n}return D.$jc(S,k)}C.findExecutable=p})(R||(e.win32=R={}))});var Ge=this&&this.__decorate||function($e,e,D,M){var d=arguments.length,P=d<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,D):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate($e,e,D,M);else for(var w=$e.length-1;w>=0;w--)(A=$e[w])&&(P=(d<3?A(P):d>3?A(e,D,P):A(e,D))||P);return d>3&&P&&Object.defineProperty(e,D,P),P};define(ke[81],Se([1,0,19,8,21,22,52,14,4,3,56,13,18]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.ProxyChannel=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.RequestInitiator=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;var k;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(k||(k={}));function S(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(c||(c={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(a||(a={}));function i(x){let X=0;for(let Z=0;;Z+=7){const ce=x.read(1);if(X|=(ce.buffer[0]&127)<<Z,!(ce.buffer[0]&128))return X}}const r=s(0);function n(x,X){if(X===0){x.write(r);return}let Z=0;for(let _=X;_!==0;_=_>>>7)Z++;const ce=d.$ke.alloc(Z);for(let _=0;X!==0;_++)ce.buffer[_]=X&127,X=X>>>7,X>0&&(ce.buffer[_]|=128);x.write(ce)}class o{constructor(X){this.b=X,this.a=0}read(X){const Z=this.b.slice(this.a,this.a+X);return this.a+=Z.byteLength,Z}}e.$Fh=o;class t{constructor(){this.a=[]}get buffer(){return d.$ke.concat(this.a)}write(X){this.a.push(X)}}e.$Gh=t;var h;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(h||(h={}));function s(x){const X=d.$ke.alloc(1);return X.writeUInt8(x,0),X}const f={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object),Uint:s(h.Int)},l=typeof Buffer<"u";function u(x,X){if(typeof X>"u")x.write(f.Undefined);else if(typeof X=="string"){const Z=d.$ke.fromString(X);x.write(f.String),n(x,Z.byteLength),x.write(Z)}else if(l&&Buffer.isBuffer(X)){const Z=d.$ke.wrap(X);x.write(f.Buffer),n(x,Z.byteLength),x.write(Z)}else if(X instanceof d.$ke)x.write(f.VSBuffer),n(x,X.byteLength),x.write(X);else if(Array.isArray(X)){x.write(f.Array),n(x,X.length);for(const Z of X)u(x,Z)}else if(typeof X=="number"&&(X|0)===X)x.write(f.Uint),n(x,X);else{const Z=d.$ke.fromString(JSON.stringify(X));x.write(f.Object),n(x,Z.byteLength),x.write(Z)}}e.$Hh=u;function v(x){switch(x.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return x.read(i(x)).toString();case h.Buffer:return x.read(i(x)).buffer;case h.VSBuffer:return x.read(i(x));case h.Array:{const Z=i(x),ce=[];for(let _=0;_<Z;_++)ce.push(v(x));return ce}case h.Object:return JSON.parse(x.read(i(x)).toString());case h.Int:return i(x)}}e.$Ih=v;class I{constructor(X,Z,ce=null,_=1e3){this.h=X,this.j=Z,this.k=ce,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ge=>this.q(ge)),this.m({type:200})}registerChannel(X,Z){this.b.set(X,Z),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const Z=this.o([X.type]);this.k?.logOutgoing(Z,0,1,m(X.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([X.type,X.id],X.data);this.k?.logOutgoing(Z,X.id,1,m(X.type),X.data);return}}}o(X,Z=void 0){const ce=new t;return u(ce,X),u(ce,Z),this.p(ce.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const Z=new o(X),ce=v(Z),_=v(Z),ge=ce[0];switch(ge){case 100:return this.k?.logIncoming(X.byteLength,ce[1],1,`${S(ge)}: ${ce[2]}.${ce[3]}`,_),this.s({type:ge,id:ce[1],channelName:ce[2],name:ce[3],arg:_});case 102:return this.k?.logIncoming(X.byteLength,ce[1],1,`${S(ge)}: ${ce[2]}.${ce[3]}`,_),this.t({type:ge,id:ce[1],channelName:ce[2],name:ce[3],arg:_});case 101:return this.k?.logIncoming(X.byteLength,ce[1],1,`${S(ge)}`),this.u({type:ge,id:ce[1]});case 103:return this.k?.logIncoming(X.byteLength,ce[1],1,`${S(ge)}`),this.u({type:ge,id:ce[1]})}}s(X){const Z=this.b.get(X.channelName);if(!Z){this.v(X);return}const ce=new P.$7d;let _;try{_=Z.call(this.j,X.name,X.arg,ce.token)}catch(J){_=Promise.reject(J)}const ge=X.id;_.then(J=>{this.m({id:ge,data:J,type:201})},J=>{J instanceof Error?this.m({id:ge,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:ge,data:J,type:203})}).finally(()=>{ne.dispose(),this.d.delete(X.id)});const ne=(0,E.$Rc)(()=>ce.cancel());this.d.set(X.id,ne)}t(X){const Z=this.b.get(X.channelName);if(!Z){this.v(X);return}const ce=X.id,ge=Z.listen(this.j,X.name,X.arg)(ne=>this.m({id:ce,data:ne,type:204}));this.d.set(X.id,ge)}u(X){const Z=this.d.get(X.id);Z&&(Z.dispose(),this.d.delete(X.id))}v(X){let Z=this.g.get(X.channelName);Z||(Z=[],this.g.set(X.channelName,Z));const ce=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:X,timeoutTimer:ce})}w(X){const Z=this.g.get(X);if(Z){for(const ce of Z)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=I;var b;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class g{constructor(X,Z=null){this.l=X,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=Z}getChannel(X){const Z=this;return{call(ce,_,ge){return Z.a?Promise.reject(new w.$5):Z.m(X,ce,_,ge)},listen(ce,_){return Z.a?$.Event.None:Z.o(X,ce,_)}}}m(X,Z,ce,_=P.CancellationToken.None){const ge=this.g++,J={id:ge,type:100,channelName:X,name:Z,arg:ce};if(_.isCancellationRequested)return Promise.reject(new w.$5);let W;return new Promise((ye,he)=>{if(_.isCancellationRequested)return he(new w.$5);const fe=()=>{const Y=de=>{switch(de.type){case 201:this.f.delete(ge),ye(de.data);break;case 202:{this.f.delete(ge);const pe=new Error(de.data.message);pe.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,pe.name=de.data.name,he(pe);break}case 203:this.f.delete(ge),he(de.data);break}};this.f.set(ge,Y),this.p(J)};let ue=null;this.b===a.Idle?fe():(ue=(0,M.$Ug)(Y=>this.u()),ue.then(()=>{ue=null,fe()}));const me=()=>{ue?(ue.cancel(),ue=null):this.p({id:ge,type:101}),he(new w.$5)},V=_.onCancellationRequested(me);W=(0,E.$Qc)((0,E.$Rc)(me),V),this.d.add(W)}).finally(()=>{W.dispose(),this.d.delete(W)})}o(X,Z,ce){const _=this.g++,ne={id:_,type:102,channelName:X,name:Z,arg:ce};let J=null;const W=new $.$Wd({onWillAddFirstListener:()=>{J=(0,M.$Ug)(ye=>this.u()),J.then(()=>{J=null,this.d.add(W),this.p(ne)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(W),this.p({id:_,type:103}))}}),re=ye=>W.fire(ye.data);return this.f.set(_,re),W.event}p(X){switch(X.type){case 100:case 102:{const Z=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(Z,X.id,0,`${S(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const Z=this.q([X.type,X.id]);this.j?.logOutgoing(Z,X.id,0,S(X.type));return}}}q(X,Z=void 0){const ce=new t;return u(ce,X),u(ce,Z),this.r(ce.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const Z=new o(X),ce=v(Z),_=v(Z),ge=ce[0];switch(ge){case 200:return this.j?.logIncoming(X.byteLength,0,0,m(ge)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,ce[1],0,m(ge),_),this.t({type:ce[0],id:ce[1],data:_})}}t(X){if(X.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=g,Ge([A.$zh],g.prototype,"onDidInitializePromise",null);class y{get connections(){const X=[];return this.f.forEach(Z=>X.push(Z)),X}constructor(X){this.a=new Map,this.f=new Set,this.g=new $.$Wd,this.onDidAddConnection=this.g.event,this.h=new $.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new E.$Sc,this.j.add(X(({protocol:Z,onDidClientDisconnect:ce})=>{const _=$.Event.once(Z.onMessage);this.j.add(_(ge=>{const ne=new o(ge),J=v(ne),W=new I(Z,J),re=new g(Z);this.a.forEach((he,fe)=>W.registerChannel(fe,he));const ye={channelServer:W,channelClient:re,ctx:J};this.f.add(ye),this.g.fire(ye),this.j.add(ce(()=>{W.dispose(),re.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(X,Z){const ce=this;return{call(_,ge,ne){let J;if((0,p.$Xf)(Z)){const re=(0,D.$4b)(ce.connections.filter(Z));J=re?Promise.resolve(re):$.Event.toPromise($.Event.filter(ce.onDidAddConnection,Z))}else J=Z.routeCall(ce,_,ge);const W=J.then(re=>re.channelClient.getChannel(X));return T(W).call(_,ge,ne)},listen(_,ge){if((0,p.$Xf)(Z))return ce.k(X,Z,_,ge);const ne=Z.routeEvent(ce,_,ge).then(J=>J.channelClient.getChannel(X));return T(ne).listen(_,ge)}}}k(X,Z,ce,_){const ge=this;let ne;const J=new $.$Wd({onWillAddFirstListener:()=>{ne=new E.$Sc;const W=new $.$3d,re=new Map,ye=fe=>{const me=fe.channelClient.getChannel(X).listen(ce,_),V=W.add(me);re.set(fe,V)},he=fe=>{const ue=re.get(fe);ue&&(ue.dispose(),re.delete(fe))};ge.connections.filter(Z).forEach(ye),$.Event.filter(ge.onDidAddConnection,Z)(ye,void 0,ne),ge.onDidRemoveConnection(he,void 0,ne),W.event(J.fire,J,ne),ne.add(W)},onDidRemoveLastListener:()=>{ne?.dispose(),ne=void 0}});return J.event}registerChannel(X,Z){this.a.set(X,Z);for(const ce of this.f)ce.channelServer.registerChannel(X,Z)}dispose(){this.j.dispose();for(const X of this.f)X.channelClient.dispose(),X.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Lh=y;class L{constructor(X,Z,ce=null){const _=new t;u(_,Z),X.send(_.buffer),this.a=new g(X,ce),this.d=new I(X,Z,ce)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,Z){this.d.registerChannel(X,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Mh=L;function T(x){return{call(X,Z,ce){return x.then(_=>_.call(X,Z,ce))},listen(X,Z){const ce=new $.$6d;return x.then(_=>ce.input=_.listen(X,Z)),ce.event}}}e.$Nh=T;function U(x){let X=!1;return{call(Z,ce,_){return X?x.call(Z,ce,_):(0,M.$9g)(0).then(()=>X=!0).then(()=>x.call(Z,ce,_))},listen(Z,ce){if(X)return x.listen(Z,ce);const _=new $.$6d;return(0,M.$9g)(0).then(()=>X=!0).then(()=>_.input=x.listen(Z,ce)),_.event}}}e.$Oh=U;class j{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const Z of X.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await $.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.$Ph=j;var F;(function(x){function X(ge,ne,J){const W=ge,re=J&&J.disableMarshalling,ye=new Map;for(const he in W)ce(he)&&ye.set(he,$.Event.buffer(W[he],!0,void 0,ne));return new class{listen(he,fe,ue){const me=ye.get(fe);if(me)return me;if(_(fe)){const V=W[fe];if(typeof V=="function")return V.call(W,ue)}throw new w.$bb(`Event not found: ${fe}`)}call(he,fe,ue){const me=W[fe];if(typeof me=="function"){if(!re&&Array.isArray(ue))for(let Y=0;Y<ue.length;Y++)ue[Y]=(0,R.$Eh)(ue[Y]);let V=me.apply(W,ue);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new w.$bb(`Method not found: ${fe}`)}}}x.fromService=X;function Z(ge,ne){const J=ne&&ne.disableMarshalling;return new Proxy({},{get(W,re){if(typeof re=="string")return ne?.properties?.has(re)?ne.properties.get(re):_(re)?function(ye){return ge.listen(re,ye)}:ce(re)?ge.listen(re):async function(...ye){let he;ne&&!(0,p.$Sf)(ne.context)?he=[ne.context,...ye]:he=ye;const fe=await ge.call(re,he);return J?fe:(0,R.$Eh)(fe)};throw new w.$bb(`Property not found: ${String(re)}`)}})}x.toService=Z;function ce(ge){return ge[0]==="o"&&ge[1]==="n"&&C.$_e(ge.charCodeAt(2))}function _(ge){return/^onDynamic/.test(ge)&&C.$_e(ge.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const X=x.toString();if(X!=="[object Object]")return X}return x}function z(x){return Array.isArray(x)?x.map(O):O(x)}function K(x,X,Z,ce,_,ge,ne){ne=z(ne);const J=N[_],W=J[ce%J.length];let re=[`%c[${x}]%c[${String(X).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(ge)?(re=re.concat(ne),re.push(")")):re.push(ne),console.log.apply(console,re)}class te{constructor(X,Z){this.d=X,this.f=Z,this.a=0,this.b=0}logOutgoing(X,Z,ce,_,ge){this.b+=X,K(this.d,this.b,X,Z,ce,_,ge)}logIncoming(X,Z,ce,_,ge){this.a+=X,K(this.f,this.a,X,Z,ce,_,ge)}}e.$Qh=te}),define(ke[82],Se([1,0,21,4,3,81]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.ProtocolConstants=e.$Rh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(f){f.Created="created",f.Read="read",f.Write="write",f.Open="open",f.Error="error",f.Close="close",f.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",f.NodeEndReceived="nodeEndReceived",f.NodeEndSent="nodeEndSent",f.NodeDrainBegin="nodeDrainBegin",f.NodeDrainEnd="nodeDrainEnd",f.zlibInflateError="zlibInflateError",f.zlibInflateData="zlibInflateData",f.zlibInflateInitialWrite="zlibInflateInitialWrite",f.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",f.zlibInflateWrite="zlibInflateWrite",f.zlibInflateFlushFired="zlibInflateFlushFired",f.zlibDeflateError="zlibDeflateError",f.zlibDeflateData="zlibDeflateData",f.zlibDeflateWrite="zlibDeflateWrite",f.zlibDeflateFlushFired="zlibDeflateFlushFired",f.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",f.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",f.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",f.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",f.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",f.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",f.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",f.ProtocolHeaderRead="protocolHeaderRead",f.ProtocolMessageRead="protocolMessageRead",f.ProtocolHeaderWrite="protocolHeaderWrite",f.ProtocolMessageWrite="protocolMessageWrite",f.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var w;(function(f){f.enableDiagnostics=!1,f.records=[];const l=new WeakMap;let u=0;function v(b,g){if(!l.has(b)){const y=String(++u);l.set(b,y)}return l.get(b)}function I(b,g,y,L){if(!f.enableDiagnostics)return;const T=v(b,g);if(L instanceof D.$ke||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const U=D.$ke.alloc(L.byteLength);U.set(L),f.records.push({timestamp:Date.now(),id:T,label:g,type:y,buff:U})}else f.records.push({timestamp:Date.now(),id:T,label:g,type:y,data:L})}f.traceSocketEvent=I})(w||(e.SocketDiagnostics=w={}));var $;(function(f){f[f.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",f[f.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let E=null;function R(){return E||(E=D.$ke.alloc(0)),E}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,u){if(l===0)return R();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const g=this.a[0];return u&&(this.a.shift(),this.b-=l),g}if(this.a[0].byteLength>l){const g=this.a[0].slice(0,l);return u&&(this.a[0]=this.a[0].slice(l),this.b-=l),g}const v=D.$ke.alloc(l);let I=0,b=0;for(;l>0;){const g=this.a[b];if(g.byteLength>l){const y=g.slice(0,l);v.set(y,I),I+=l,u&&(this.a[b]=g.slice(l),this.b-=l),l-=l}else v.set(g,I),I+=g.byteLength,u?(this.a.shift(),this.b-=g.byteLength):b++,l-=g.byteLength}return v}}e.$Rh=C;var p;(function(f){f[f.None=0]="None",f[f.Regular=1]="Regular",f[f.Control=2]="Control",f[f.Ack=3]="Ack",f[f.Disconnect=5]="Disconnect",f[f.ReplayRequest=6]="ReplayRequest",f[f.Pause=7]="Pause",f[f.Resume=8]="Resume",f[f.KeepAlive=9]="KeepAlive"})(p||(p={}));function k(f){switch(f){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(f){f[f.HeaderLength=13]="HeaderLength",f[f.AcknowledgeTime=2e3]="AcknowledgeTime",f[f.TimeoutTime=2e4]="TimeoutTime",f[f.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",f[f.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class c{constructor(l,u,v,I){this.type=l,this.id=u,this.ack=v,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends d.$Tc{constructor(l){super(),this.f=this.B(new M.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new C,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,I=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new c(v,I,b,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=D.$ke.alloc(13);u.writeUInt8(l.type,0),u.writeUInt32BE(l.id,1),u.writeUInt32BE(l.ack,5),u.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(u,l.data)}g(l,u){const v=this.f===0;return this.d.push(l,u),this.f+=l.byteLength+u.byteLength,v}h(){const l=D.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,u){this.g(l,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends d.$Tc{constructor(l){super(),this.f=new M.$Wd,this.onMessage=this.f.event,this.g=new M.$Wd,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new a(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new c(1,0,0,l))}}e.$Sh=i;class r extends P.$Mh{static fromSocket(l,u){return new r(new i(l),u)}get onDidDispose(){return this.b.onDidDispose}constructor(l,u,v=null){super(l,u,v),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Th=r;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new M.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Uh=n;class o{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,u=this.a;for(;u;)u=u.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let u=0,v=this.a;for(;v;)l[u++]=v.data,v=v.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const u=new o(l);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class h{static{this.a=10}static{this.b=null}static getInstance(){return h.b||(h.b=new h),h.b}constructor(){this.c=[];const l=Date.now();for(let u=0;u<h.a;u++)this.c[u]=l-1e3*u;setInterval(()=>{for(let u=h.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),u=(1+h.a)*1e3;let v=0;for(let I=0;I<h.a;I++)l-this.c[I]<=u&&v++;return 1-v/h.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??h.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new d.$Sc,this.o=l.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new c(5,0,0,R());this.p.write(l),this.p.flush()}sendPause(){const l=new c(7,0,0,R());this.p.write(l)}sendResume(){const l=new c(8,0,0,R());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,u){this.a=!0,this.r.dispose(),this.r=new d.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new c(3,0,this.h,R());this.p.write(l);const u=this.b.toArray();for(let v=0,I=u.length;v<I;v++)this.p.write(u[v]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const u=this.b.peek();if(u&&u.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new c(6,0,0,R())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let v=0,I=u.length;v<I;v++)this.p.write(u[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const u=++this.c;this.h=this.g;const v=new c(1,u,this.h,l);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(l){const u=new c(2,0,0,l);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),u=Date.now()-l.writtenTime,v=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(u>=2e4&&v>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:v});return}const b=Math.max(2e4-u,2e4-v,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new c(3,0,this.h,R());this.p.write(l)}D(){this.h=this.g;const l=new c(9,0,this.h,R());this.p.write(l)}}e.$Vh=s}),define(ke[187],Se([1,0,50,8,21,22,185,14,4,3,24,104,101,81]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class S extends k.$Jh{constructor(a){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>d.$ke.wrap(Buffer.from(i,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$sq=S;class c{constructor(a,i){this.i=a,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Wd,this.onDidProcessExit=this.h.event;const r=i&&i.timeout?i.timeout:6e4;this.b=new M.$5g(r),this.d=null,this.f=null}getChannel(a){const i=this;return{call(r,n,o){return i.k(a,r,n,o)},listen(r,n){return i.l(a,r,n)}}}k(a,i,r,n=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(w.$6());this.b.cancel();const o=this.n(a),t=(0,M.$Ug)(f=>o.call(i,r,f)),h=n.onCancellationRequested(()=>t.cancel()),s=(0,E.$Rc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{h.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,i,r){if(!this.b)return $.Event.None;this.b.cancel();let n;const o=new $.$Wd({onWillAddFirstListener:()=>{n=this.n(a).listen(i,r)(o.fire,o),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$yn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,p.$Ul)(i.env),this.d=(0,D.fork)(this.i,a,i);const r=new $.$Wd;$.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,A.$oq)(l)){(0,A.log)(l,`IPC Library: ${this.j.serverName}`);return}r.fire(d.$ke.wrap(Buffer.from(l,"base64")))});const o=this.j.useQueue?(0,C.$Wl)(this.d):this.d,t=l=>this.d&&this.d.connected&&o.send(l.buffer.toString("base64")),h=r.event,s={send:t,onMessage:h};this.f=new k.$Kh(s);const f=()=>this.o();process.once("exit",f),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,u)=>{process.removeListener("exit",f),this.c.forEach(v=>(0,E.$Oc)(v)),this.c.clear(),l!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:u})})}return this.f}n(a){let i=this.g.get(a);return i||(i=this.m.getChannel(a),this.g.set(a,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=c}),define(ke[188],Se([1,0,8,4,3,56,18]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var w;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function $(p){const k=p;return k?.changed instanceof Map||k?.deleted instanceof Set}e.$rp=$;var E;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(E||(e.StorageState=E={}));class R extends d.$Tc{static{this.a=100}constructor(k,S=Object.create(null)){super(),this.r=k,this.s=S,this.b=this.B(new M.$Zd),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new D.$6g(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((S,c)=>this.w(c,S)),k.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(k,S){if(this.c===E.Closed)return;let c=!1;(0,A.$Sf)(S)?c=this.f.delete(k):this.f.get(k)!==S&&(this.f.set(k,S),c=!0),c&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,S){const c=this.f.get(k);return(0,A.$Sf)(c)?S:c}getBoolean(k,S){const c=this.get(k);return(0,A.$Sf)(c)?S:c==="true"}getNumber(k,S){const c=this.get(k);return(0,A.$Sf)(c)?S:parseInt(c,10)}getObject(k,S){const c=this.get(k);return(0,A.$Sf)(c)?S:(0,P.$Dh)(c)}async set(k,S,c=!1){if(this.c===E.Closed)return;if((0,A.$Sf)(S))return this.delete(k,c);const m=(0,A.$Lf)(S)||Array.isArray(S)?(0,P.$Ch)(S):String(S);if(this.f.get(k)!==m)return this.f.set(k,m),this.j.set(k,m),this.h.delete(k),this.b.fire({key:k,external:c}),this.D()}async delete(k,S=!1){if(!(this.c===E.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:S}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(this.z)return this.D(k)}async D(k){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$sp=R;class C{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((S,c)=>this.a.set(c,S)),k.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$tp=C}),define(ke[189],Se([1,0,13,11,21]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let P;function A(){return P||(P=new TextDecoder("UTF-16LE")),P}let w;function $(){return w||(w=new TextDecoder("UTF-16BE")),w}let E;function R(){return E||(E=M.$D()?A():$()),E}e.$ct=R;function C(S,c,m){const a=new Uint16Array(S.buffer,c,m);return m>0&&(a[0]===65279||a[0]===65534)?p(S,c,m):A().decode(a)}e.$dt=C;function p(S,c,m){const a=[];let i=0;for(let r=0;r<m;r++){const n=d.$me(S,c);c+=2,a[i++]=String.fromCharCode(n)}return a.join("")}class k{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return R().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const m=this.a-this.d;m<=1&&(m===0||D.$ef(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const m=c.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=c;return}for(let a=0;a<m;a++)this.b[this.d++]=c.charCodeAt(a)}}e.$et=k}),define(ke[190],Se([1,0,21,189]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;function d($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,R,C,p){this.oldPosition=E,this.oldText=R,this.newPosition=C,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${d(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${d(this.oldText)}")`:`(replace@${this.oldPosition} "${d(this.oldText)}" with "${d(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,R,C){const p=R.length;D.$pe(E,p,C),C+=4;for(let k=0;k<p;k++)D.$ne(E,R.charCodeAt(k),C),C+=2;return C}static d(E,R){const C=D.$oe(E,R);return R+=4,(0,M.$dt)(E,R,C)}writeSize(){return 8+P.a(this.oldText)+P.a(this.newText)}write(E,R){return D.$pe(E,this.oldPosition,R),R+=4,D.$pe(E,this.newPosition,R),R+=4,R=P.c(E,this.oldText,R),R=P.c(E,this.newText,R),R}static read(E,R,C){const p=D.$oe(E,R);R+=4;const k=D.$oe(E,R);R+=4;const S=P.d(E,R);R+=P.a(S);const c=P.d(E,R);return R+=P.a(c),C.push(new P(p,S,k,c)),R}}e.$ft=P;function A($,E){return $===null||$.length===0?E:new w($,E).compress()}e.$gt=A;class w{constructor(E,R){this.a=E,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,R=0,C=this.n(E),p=this.l(R);for(;E<this.f||R<this.h;){if(C===null){this.k(p),p=this.l(++R);continue}if(p===null){this.m(C),C=this.n(++E);continue}if(p.oldEnd<=C.newPosition){this.k(p),p=this.l(++R);continue}if(C.newEnd<=p.oldPosition){this.m(C),C=this.n(++E);continue}if(p.oldPosition<C.newPosition){const[a,i]=w.r(p,C.newPosition-p.oldPosition);this.k(a),p=i;continue}if(C.newPosition<p.oldPosition){const[a,i]=w.q(C,p.oldPosition-C.newPosition);this.m(a),C=i;continue}let c,m;if(p.oldEnd===C.newEnd)c=C,m=p,C=this.n(++E),p=this.l(++R);else if(p.oldEnd<C.newEnd){const[a,i]=w.q(C,p.oldLength);c=a,m=p,C=i,p=this.l(++R)}else{const[a,i]=w.r(p,C.newLength);c=C,m=a,C=this.n(++E),p=i}this.d[this.e++]=new P(c.oldPosition,c.oldText,m.newPosition,m.newText),this.g+=c.newLength-c.oldLength,this.j+=m.newLength-m.oldLength}const k=w.s(this.d);return w.t(k)}k(E){this.d[this.e++]=w.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=w.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,R){return new P(R.oldPosition-E,R.oldText,R.newPosition,R.newText)}static p(E,R){return new P(R.oldPosition,R.oldText,R.newPosition+E,R.newText)}static q(E,R){const C=E.newText.substr(0,R),p=E.newText.substr(R);return[new P(E.oldPosition,E.oldText,E.newPosition,C),new P(E.oldEnd,"",E.newPosition+R,p)]}static r(E,R){const C=E.oldText.substr(0,R),p=E.oldText.substr(R);return[new P(E.oldPosition,C,E.newPosition,E.newText),new P(E.oldPosition+R,p,E.newEnd,"")]}static s(E){if(E.length===0)return E;const R=[];let C=0,p=E[0];for(let k=1;k<E.length;k++){const S=E[k];p.oldEnd===S.oldPosition?p=new P(p.oldPosition,p.oldText+S.oldText,p.newPosition,p.newText+S.newText):(R[C++]=p,p=S)}return R[C++]=p,R}static t(E){if(E.length===0)return E;const R=[];let C=0;for(let p=0;p<E.length;p++){const k=E[p];k.oldText!==k.newText&&(R[C++]=k)}return R}}}),define(ke[191],Se([1,0,35,17]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=void 0;function d(P,A,w,$,E,R){if(Array.isArray(P)){let C=0;for(const p of P){const k=d(p,A,w,$,E,R);if(k===10)return k;k>C&&(C=k)}return C}else{if(typeof P=="string")return $?P==="*"?5:P===w?10:0:0;if(P){const{language:C,pattern:p,scheme:k,hasAccessToAllModels:S,notebookType:c}=P;if(!$&&!S)return 0;c&&E&&(A=E);let m=0;if(k)if(k===A.scheme)m=10;else if(k==="*")m=5;else return 0;if(C)if(C===w)m=10;else if(C==="*")m=Math.max(m,5);else return 0;if(c)if(c===R)m=10;else if(c==="*"&&R!==void 0)m=Math.max(m,5);else return 0;if(p){let a;if(typeof p=="string"?a=p:a={...p,base:(0,M.$hc)(p.base)},a===A.fsPath||(0,D.$Nj)(a,A.fsPath))m=10;else return 0}return m}else return 0}}e.$Dt=d}),define(ke[192],Se([1,0,4,13,29,80,127,167,190,3]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class R extends E.$Tc{constructor(p,k,S,c,m,a,i){super(),this.m=this.B(new D.$Wd),this.onDidChangeContent=this.m.event,this.f=k,this.j=!a,this.g=c,this.h=m,this.c=new A.$cC(p,S,i)}equals(p){return!(p instanceof R)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,k){return this.c.getOffsetAt(p,k)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,k){const S=p+k,c=this.getPositionAt(p),m=this.getPositionAt(S);return new d.$Ws(c.lineNumber,c.column,m.lineNumber,m.column)}getValueInRange(p,k=0){if(p.isEmpty())return"";const S=this.n(k);return this.c.getValueInRange(p,S)}getValueLengthInRange(p,k=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const S=this.getOffsetAt(p.startLineNumber,p.startColumn),c=this.getOffsetAt(p.endLineNumber,p.endColumn);let m=0;const a=this.n(k),i=this.getEOL();if(a.length!==i.length){const r=a.length-i.length,n=p.endLineNumber-p.startLineNumber;m=r*n}return c-S+m}getCharacterCountInRange(p,k=0){if(this.j){let S=0;const c=p.startLineNumber,m=p.endLineNumber;for(let a=c;a<=m;a++){const i=this.getLineContent(a),r=a===c?p.startColumn-1:0,n=a===m?p.endColumn-1:i.length;for(let o=r;o<n;o++)M.$ef(i.charCodeAt(o))?(S=S+1,o=o+1):S=S+1}return S+=this.n(k).length*(m-c),S}return this.getValueLengthInRange(p,k)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,k){return this.c.getLineCharCode(p,k)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const k=M.$2e(this.getLineContent(p));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(p){const k=M.$4e(this.getLineContent(p));return k===-1?0:k+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,k,S){let c=this.g,m=this.h,a=this.j,i=!0,r=[];for(let l=0;l<p.length;l++){const u=p[l];i&&u._isTracked&&(i=!1);const v=u.range;if(u.text){let L=!0;a||(L=!M.$pf(u.text),a=L),!c&&L&&(c=M.$of(u.text)),!m&&L&&(m=M.$rf(u.text))}let I="",b=0,g=0,y=0;if(u.text){let L;[b,g,y,L]=(0,w.$wt)(u.text);const T=this.getEOL();L===0||L===(T===`\r
`?2:1)?I=u.text:I=u.text.replace(/\r\n|\r|\n/g,T)}r[l]={sortIndex:l,identifier:u.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:I,eolCount:b,firstLineLength:g,lastLineLength:y,forceMoveMarkers:!!u.forceMoveMarkers,isAutoWhitespaceEdit:u.isAutoWhitespaceEdit||!1}}r.sort(R.u);let n=!1;for(let l=0,u=r.length-1;l<u;l++){const v=r[l].range.getEndPosition(),I=r[l+1].range.getStartPosition();if(I.isBeforeOrEqual(v)){if(I.isBefore(v))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this.s(r));const o=S||k?R._getInverseEditRanges(r):[],t=[];if(k)for(let l=0;l<r.length;l++){const u=r[l],v=o[l];if(u.isAutoWhitespaceEdit&&u.range.isEmpty())for(let I=v.startLineNumber;I<=v.endLineNumber;I++){let b="";I===v.startLineNumber&&(b=this.getLineContent(u.range.startLineNumber),M.$2e(b)!==-1)||t.push({lineNumber:I,oldContent:b})}}let h=null;if(S){let l=0;h=[];for(let u=0;u<r.length;u++){const v=r[u],I=o[u],b=this.getValueInRange(v.range),g=v.rangeOffset+l;l+=v.text.length-b.length,h[u]={sortIndex:v.sortIndex,identifier:v.identifier,range:I,text:b,textChange:new $.$ft(v.rangeOffset,b,g,v.text)}}n||h.sort((u,v)=>u.sortIndex-v.sortIndex)}this.g=c,this.h=m,this.j=a;const s=this.t(r);let f=null;if(k&&t.length>0){t.sort((l,u)=>u.lineNumber-l.lineNumber),f=[];for(let l=0,u=t.length;l<u;l++){const v=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===v)continue;const I=t[l].oldContent,b=this.getLineContent(v);b.length===0||b===I||M.$2e(b)!==-1||f.push(v)}}return this.m.fire(),new P.$gv(h,s,f)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let k=!1;const S=p[0].range,c=p[p.length-1].range,m=new d.$Ws(S.startLineNumber,S.startColumn,c.endLineNumber,c.endColumn);let a=S.startLineNumber,i=S.startColumn;const r=[];for(let s=0,f=p.length;s<f;s++){const l=p[s],u=l.range;k=k||l.forceMoveMarkers,r.push(this.getValueInRange(new d.$Ws(a,i,u.startLineNumber,u.startColumn))),l.text.length>0&&r.push(l.text),a=u.endLineNumber,i=u.endColumn}const n=r.join(""),[o,t,h]=(0,w.$wt)(n);return{sortIndex:0,identifier:p[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:n,eolCount:o,firstLineLength:t,lastLineLength:h,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(p){p.sort(R.w);const k=[];for(let S=0;S<p.length;S++){const c=p[S],m=c.range.startLineNumber,a=c.range.startColumn,i=c.range.endLineNumber,r=c.range.endColumn;if(m===i&&a===r&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const n=new d.$Ws(m,a,i,r);k.push({range:n,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return k}findMatchesLineByLine(p,k,S,c){return this.c.findMatchesLineByLine(p,k,S,c)}getPieceTree(){return this.c}static _getInverseEditRange(p,k){const S=p.startLineNumber,c=p.startColumn,[m,a,i]=(0,w.$wt)(k);let r;if(k.length>0){const n=m+1;n===1?r=new d.$Ws(S,c,S,c+a):r=new d.$Ws(S,c,S+n-1,i+1)}else r=new d.$Ws(S,c,S,c);return r}static _getInverseEditRanges(p){const k=[];let S=0,c=0,m=null;for(let a=0,i=p.length;a<i;a++){const r=p[a];let n,o;m?m.range.endLineNumber===r.range.startLineNumber?(n=S,o=c+(r.range.startColumn-m.range.endColumn)):(n=S+(r.range.startLineNumber-m.range.endLineNumber),o=r.range.startColumn):(n=r.range.startLineNumber,o=r.range.startColumn);let t;if(r.text.length>0){const h=r.eolCount+1;h===1?t=new d.$Ws(n,o,n,o+r.firstLineLength):t=new d.$Ws(n,o,n+h-1,r.lastLineLength+1)}else t=new d.$Ws(n,o,n,o);S=t.endLineNumber,c=t.endColumn,k.push(t),m=r}return k}static u(p,k){const S=d.$Ws.compareRangesUsingEnds(p.range,k.range);return S===0?p.sortIndex-k.sortIndex:S}static w(p,k){const S=d.$Ws.compareRangesUsingEnds(p.range,k.range);return S===0?k.sortIndex-p.sortIndex:-S}}e.$dC=R}),define(ke[193],Se([1,0,13,127,192]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class P{constructor($,E,R,C,p,k,S,c,m){this.a=$,this.b=E,this.c=R,this.d=C,this.e=p,this.f=k,this.g=S,this.h=c,this.j=m}k($){const E=this.c+this.d+this.e,R=this.c+this.e;return E===0?$===1?`
`:`\r
`:R>E/2?`\r
`:`
`}create($){const E=this.k($),R=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let p=0,k=R.length;p<k;p++){const S=R[p].buffer.replace(/\r\n|\r|\n/g,E),c=(0,M.$$B)(S);R[p]=new M.$bC(S,c)}const C=new d.$dC(R,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$xf($)&&(this.b=D.$wf,$=$.substr(1));const E=$.charCodeAt($.length-1);E===13||E>=55296&&E<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=E):(this.m($,!1),this.c=!1,this.d=E)}m($,E){!E&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const E=(0,M.$_B)(this.e,$);this.a.push(new M.$bC($,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=D.$of($)),this.k||(this.k=D.$rf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const E=(0,M.$$B)($.buffer);$.lineStarts=E,this.d===13&&this.f++}}}e.$eC=A}),define(ke[131],Se([1,0,21,11]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$=e.$O$=void 0;var d;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(d||(d={}));function P(C){for(let p=0,k=C.length;p<k;p+=4){const S=C[p+0],c=C[p+1],m=C[p+2],a=C[p+3];C[p+0]=a,C[p+1]=m,C[p+2]=c,C[p+3]=S}}function A(C){const p=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return M.$D()||P(p),D.$ke.wrap(p)}function w(C){const p=C.buffer;if(M.$D()||P(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const k=new Uint8Array(p.byteLength);return k.set(p),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function $(C){const p=new Uint32Array(E(C));let k=0;if(p[k++]=C.id,C.type==="full")p[k++]=1,p[k++]=C.data.length,p.set(C.data,k),k+=C.data.length;else{p[k++]=2,p[k++]=C.deltas.length;for(const S of C.deltas)p[k++]=S.start,p[k++]=S.deleteCount,S.data?(p[k++]=S.data.length,p.set(S.data,k),k+=S.data.length):p[k++]=0}return A(p)}e.$O$=$;function E(C){let p=0;if(p+=2,C.type==="full")p+=1+C.data.length;else{p+=1,p+=3*C.deltas.length;for(const k of C.deltas)k.data&&(p+=k.data.length)}return p}function R(C){const p=w(C);let k=0;const S=p[k++];if(p[k++]===1){const i=p[k++],r=p.subarray(k,k+i);return k+=i,{id:S,type:"full",data:r}}const m=p[k++],a=[];for(let i=0;i<m;i++){const r=p[k++],n=p[k++],o=p[k++];let t;o>0&&(t=p.subarray(k,k+o),k+=o),a[i]={start:r,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:a}}e.$P$=R}),define(ke[194],Se([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(ke[132],Se([1,0,19,24,11,170,126,194]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=E;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class C{constructor(se,Ie,qe,Ye){this.id=se,this.name=Ie,this.defaultValue=qe,this.schema=Ye}applyUpdate(se,Ie){return k(se,Ie)}compute(se,Ie,qe){return qe}}class p{constructor(se,Ie){this.newValue=se,this.didChange=Ie}}e.ApplyUpdateResult=p;function k(ie,se){if(typeof ie!="object"||typeof se!="object"||!ie||!se)return new p(se,ie!==se);if(Array.isArray(ie)||Array.isArray(se)){const qe=Array.isArray(ie)&&Array.isArray(se)&&D.$ub(ie,se);return new p(se,!qe)}let Ie=!1;for(const qe in se)if(se.hasOwnProperty(qe)){const Ye=k(ie[qe],se[qe]);Ye.didChange&&(ie[qe]=Ye.newValue,Ie=!0)}return new p(ie,Ie)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ie){return k(se,Ie)}validate(se){return this.defaultValue}}class c{constructor(se,Ie,qe,Ye){this.id=se,this.name=Ie,this.defaultValue=qe,this.schema=Ye}applyUpdate(se,Ie){return k(se,Ie)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ie,qe){return qe}}function m(ie,se){return typeof ie>"u"?se:ie==="false"?!1:!!ie}e.boolean=m;class a extends c{constructor(se,Ie,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=qe),super(se,Ie,qe,Ye)}validate(se){return m(se,this.defaultValue)}}function i(ie,se,Ie,qe){if(typeof ie>"u")return se;let Ye=parseInt(ie,10);return isNaN(Ye)?se:(Ye=Math.max(Ie,Ye),Ye=Math.min(qe,Ye),Ye|0)}e.clampedInt=i;class r extends c{static clampedInt(se,Ie,qe,Ye){return i(se,Ie,qe,Ye)}constructor(se,Ie,qe,Ye,it,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=qe,nt.minimum=Ye,nt.maximum=it),super(se,Ie,qe,nt),this.minimum=Ye,this.maximum=it}validate(se){return r.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function n(ie,se,Ie,qe){if(typeof ie>"u")return se;const Ye=o.float(ie,se);return o.clamp(Ye,Ie,qe)}e.clampedFloat=n;class o extends c{static clamp(se,Ie,qe){return se<Ie?Ie:se>qe?qe:se}static float(se,Ie){if(typeof se=="number")return se;if(typeof se>"u")return Ie;const qe=parseFloat(se);return isNaN(qe)?Ie:qe}constructor(se,Ie,qe,Ye,it){typeof it<"u"&&(it.type="number",it.default=qe),super(se,Ie,qe,it),this.validationFn=Ye}validate(se){return this.validationFn(o.float(se,this.defaultValue))}}class t extends c{static string(se,Ie){return typeof se!="string"?Ie:se}constructor(se,Ie,qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=qe),super(se,Ie,qe,Ye)}validate(se){return t.string(se,this.defaultValue)}}function h(ie,se,Ie,qe){return typeof ie!="string"?se:qe&&ie in qe?qe[ie]:Ie.indexOf(ie)===-1?se:ie}e.stringSet=h;class s extends c{constructor(se,Ie,qe,Ye,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Ye,it.default=qe),super(se,Ie,qe,it),this.c=Ye}validate(se){return h(se,this.defaultValue,this.c)}}class f extends C{constructor(se,Ie,qe,Ye,it,nt,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=it,Oe.default=Ye),super(se,Ie,qe,Oe),this.c=it,this.d=nt}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function l(ie){switch(ie){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ie,qe){return qe===0?se.accessibilitySupport:qe}}class v extends C{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:w.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertSpace:m(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function b(ie){switch(ie){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function y(ie){switch(ie){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function L(ie){switch(ie){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class T extends S{constructor(){super(140)}compute(se,Ie,qe){const Ye=["monaco-editor"];return Ie.get(39)&&Ye.push(Ie.get(39)),se.extraEditorClassName&&Ye.push(se.extraEditorClassName),Ie.get(73)==="default"?Ye.push("mouse-default"):Ie.get(73)==="copy"&&Ye.push("mouse-copy"),Ie.get(110)&&Ye.push("showUnused"),Ie.get(138)&&Ye.push("showDeprecated"),Ye.join(" ")}}class U extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(se,Ie,qe){return qe&&se.emptySelectionClipboard}}class j extends C{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:w.localize(16,null),included:d.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:w.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{cursorMoveOnType:m(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":h(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":h(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Ie.loop,this.defaultValue.loop)}}}class F extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?F.OFF:se==="true"?F.ON:se:se?F.ON:F.OFF}}e.EditorFontLigatures=F;class N extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?N.OFF:se==="true"?N.TRANSLATE:se:se?N.TRANSLATE:N.OFF}compute(se,Ie,qe){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class O extends S{constructor(){super(50)}compute(se,Ie,qe){return se.fontInfo}}class z extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(se){const Ie=o.float(se,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Ie,6,100)}compute(se,Ie,qe){return se.fontInfo.fontSize}}class K extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(r.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class te extends C{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:qe,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:qe,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:qe,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:qe,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:qe,description:w.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{multiple:h(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??h(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??h(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??h(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??h(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??h(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:w.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),delay:r.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:m(Ie.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Ie.above,this.defaultValue.above)}}}var X;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class Z extends S{constructor(){super(143)}compute(se,Ie,qe){return Z.computeLayout(Ie,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Ie=se.height/se.lineHeight,qe=Math.floor(se.paddingTop/se.lineHeight);let Ye=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Ye=Math.max(Ye,Ie-1));const it=(qe+se.viewLineCount+Ye)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/it);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ye,desiredRatio:it,minimapLineCount:nt}}static c(se,Ie){const qe=se.outerWidth,Ye=se.outerHeight,it=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const nt=Ie.stableMinimapLayoutInput,Oe=nt&&se.outerHeight===nt.outerHeight&&se.lineHeight===nt.lineHeight&&se.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&se.pixelRatio===nt.pixelRatio&&se.scrollBeyondLastLine===nt.scrollBeyondLastLine&&se.paddingTop===nt.paddingTop&&se.paddingBottom===nt.paddingBottom&&se.minimap.enabled===nt.minimap.enabled&&se.minimap.side===nt.minimap.side&&se.minimap.size===nt.minimap.size&&se.minimap.showSlider===nt.minimap.showSlider&&se.minimap.renderCharacters===nt.minimap.renderCharacters&&se.minimap.maxColumn===nt.minimap.maxColumn&&se.minimap.scale===nt.minimap.scale&&se.verticalScrollbarWidth===nt.verticalScrollbarWidth&&se.isViewportWrapping===nt.isViewportWrapping,yt=se.lineHeight,Dt=se.typicalHalfwidthCharacterWidth,Tt=se.scrollBeyondLastLine,Ft=se.minimap.renderCharacters;let Et=it>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Ht=se.minimap.maxColumn,Ot=se.minimap.size,Yt=se.minimap.side,Vt=se.verticalScrollbarWidth,Ut=se.viewLineCount,et=se.remainingWidth,Gt=se.isViewportWrapping,Kt=Ft?2:3;let ht=Math.floor(it*Ye);const $t=ht/it;let Bt=!1,Qt=!1,kt=Kt*Et,ft=Et/it,It=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Mt,extraLinesBeyondLastLine:Pt,desiredRatio:Wt,minimapLineCount:Ne}=Z.computeContainedMinimapLineCount({viewLineCount:Ut,scrollBeyondLastLine:Tt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Ye,lineHeight:yt,pixelRatio:it});if(Ut/Ne>1)Bt=!0,Qt=!0,Et=1,kt=1,ft=Et/it;else{let De=!1,ae=Et+1;if(Ot==="fit"){const Te=Math.ceil((Mt+Ut+Pt)*kt);Gt&&Oe&&et<=Ie.stableFitRemainingWidth?(De=!0,ae=Ie.stableFitMaxMinimapScale):De=Te>ht}if(Ot==="fill"||De){Bt=!0;const Te=Et;kt=Math.min(yt*it,Math.max(1,Math.floor(1/Wt))),Gt&&Oe&&et<=Ie.stableFitRemainingWidth&&(ae=Ie.stableFitMaxMinimapScale),Et=Math.min(ae,Math.max(1,Math.floor(kt/Kt))),Et>Te&&(It=Math.min(2,Et/Te)),ft=Et/it/It,ht=Math.ceil(Math.max(gt,Mt+Ut+Pt)*kt),Gt?(Ie.stableMinimapLayoutInput=se,Ie.stableFitRemainingWidth=et,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const _t=Math.floor(Ht*ft),At=Math.min(_t,Math.max(0,Math.floor((et-Vt-2)*ft/(Dt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Ke=Math.floor(it*At);const Nt=Ke/it;Ke=Math.floor(Ke*It);const jt=Ft?1:2,Zt=Yt==="left"?0:qe-At-Vt;return{renderMinimap:jt,minimapLeft:Zt,minimapWidth:At,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Qt,minimapScale:Et,minimapLineHeight:kt,minimapCanvasInnerWidth:Ke,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:$t}}static computeLayout(se,Ie){const qe=Ie.outerWidth|0,Ye=Ie.outerHeight|0,it=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,Oe=Ie.typicalHalfwidthCharacterWidth,yt=Ie.maxDigitWidth,Dt=Ie.pixelRatio,Tt=Ie.viewLineCount,Ft=se.get(135),Et=Ft==="inherit"?se.get(134):Ft,Ht=Et==="inherit"?se.get(130):Et,Ot=se.get(133),Yt=Ie.isDominatedByLongLines,Vt=se.get(57),Ut=se.get(67).renderType!==0,et=se.get(68),Gt=se.get(104),Kt=se.get(83),ht=se.get(72),$t=se.get(102),Bt=$t.verticalScrollbarSize,Qt=$t.verticalHasArrows,kt=$t.arrowSize,ft=$t.horizontalScrollbarSize,It=se.get(43),_t=se.get(109)!=="never";let At=se.get(65);It&&_t&&(At+=16);let Ke=0;if(Ut){const xe=Math.max(nt,et);Ke=Math.round(xe*yt)}let Nt=0;Vt&&(Nt=it*Ie.glyphMarginDecorationLaneCount);let jt=0,Zt=jt+Nt,gt=Zt+Ke,Mt=gt+At;const Pt=qe-Nt-Ke-At;let Wt=!1,Ne=!1,Fe=-1;Et==="inherit"&&Yt?(Wt=!0,Ne=!0):Ht==="on"||Ht==="bounded"?Ne=!0:Ht==="wordWrapColumn"&&(Fe=Ot);const De=Z.c({outerWidth:qe,outerHeight:Ye,lineHeight:it,typicalHalfwidthCharacterWidth:Oe,pixelRatio:Dt,scrollBeyondLastLine:Gt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:ht,verticalScrollbarWidth:Bt,viewLineCount:Tt,remainingWidth:Pt,isViewportWrapping:Ne},Ie.memory||new R);De.renderMinimap!==0&&De.minimapLeft===0&&(jt+=De.minimapWidth,Zt+=De.minimapWidth,gt+=De.minimapWidth,Mt+=De.minimapWidth);const ae=Pt-De.minimapWidth,Te=Math.max(1,Math.floor((ae-Bt-2)/Oe)),Be=Qt?kt:0;return Ne&&(Fe=Math.max(1,Te),Ht==="bounded"&&(Fe=Math.min(Fe,Ot))),{width:qe,height:Ye,glyphMarginLeft:jt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Zt,lineNumbersWidth:Ke,decorationsLeft:gt,decorationsWidth:At,contentLeft:Mt,contentWidth:ae,minimap:De,viewportColumn:Te,isWordWrapMinified:Wt,isViewportWrapping:Ne,wrappingColumn:Fe,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:ft,overviewRuler:{top:Be,width:Bt,height:Ye-2*Be,right:0}}}}e.EditorLayoutInfoComputer=Z;class ce extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(se){return h(se,"simple",["simple","advanced"])}compute(se,Ie,qe){return Ie.get(2)===2?"advanced":qe}}var _;(function(ie){ie.Off="off",ie.OnCode="onCode",ie.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class ge extends C{constructor(){const se={enabled:_.OnCode};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[_.Off,_.OnCode,_.On],default:se.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:h(se.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class ne extends C{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:w.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:h(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class J extends C{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,d.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,d.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:w.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:h(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:m(Ie.padding,this.defaultValue.padding)}}}class W extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):r.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Ie,qe){return qe<0?r.clampedInt(-qe*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class re extends o{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>o.clamp(se,0,150),{markdownDescription:w.localize(66,null)})}compute(se,Ie,qe){return se.fontInfo.lineHeight}}class ye extends C{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:se.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:w.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),autohide:m(Ie.autohide,this.defaultValue.autohide),size:h(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Ie.side,this.defaultValue.side,["right","left"]),showSlider:h(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Ie.scale,1,1,3),maxColumn:r.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(ie){return ie==="ctrlCmd"?d.$j?"metaKey":"ctrlKey":"altKey"}class fe extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{top:r.clampedInt(Ie.top,0,0,1e3),bottom:r.clampedInt(Ie.bottom,0,0,1e3)}}}class ue extends C{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:w.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:w.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),cycle:m(Ie.cycle,this.defaultValue.cycle)}}}class me extends S{constructor(){super(141)}compute(se,Ie,qe){return se.pixelRatio}}class V extends C{constructor(){const se={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(82,null),w.localize(83,null),w.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:se.strings,description:w.localize(85,null)},comments:{anyOf:Ie,default:se.comments,description:w.localize(86,null)},other:{anyOf:Ie,default:se.other,description:w.localize(87,null)}},default:se,markdownDescription:w.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Dt=se?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:Ye}=se,it=["on","inline","off"];let nt,Oe,yt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=h(Ie,this.defaultValue.other,it),typeof qe=="boolean"?Oe=qe?"on":"off":Oe=h(qe,this.defaultValue.comments,it),typeof Ye=="boolean"?yt=Ye?"on":"off":yt=h(Ye,this.defaultValue.strings,it),{other:nt,comments:Oe,strings:yt}}}var Y;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class de extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(89,null),w.localize(90,null),w.localize(91,null),w.localize(92,null)],default:"on",description:w.localize(93,null)})}validate(se){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ie=4,qe=se):se==="interval"?Ie=3:se==="relative"?Ie=2:se==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function pe(ie){const se=ie.get(97);return se==="editable"?ie.get(90):se!=="on"}e.filterValidationDecorations=pe;class Pe extends C{constructor(){const se=[],Ie={type:"number",description:w.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:w.localize(95,null),format:"color-hex"}}}]},default:se,description:w.localize(96,null)})}validate(se){if(Array.isArray(se)){const Ie=[];for(const qe of se)if(typeof qe=="number")Ie.push({column:r.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ye=qe;Ie.push({column:r.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Ie.sort((qe,Ye)=>qe.column-Ye.column),Ie}return this.defaultValue}}class ve extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Ce(ie,se){if(typeof ie!="string")return se;switch(ie){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends C{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(97,null),w.localize(98,null),w.localize(99,null)],default:"auto",description:w.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(101,null),w.localize(102,null),w.localize(103,null)],default:"auto",description:w.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:w.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:w.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:w.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:w.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se,qe=r.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=r.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(Ie.vertical,this.defaultValue.vertical),horizontal:Ce(Ie.horizontal,this.defaultValue.horizontal),useShadows:m(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:r.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:r.clampedInt(Ie.verticalSliderSize,Ye,0,1e3),scrollByPage:m(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends C{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:w.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:w.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:w.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:w.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:w.localize(115,null)}})}applyUpdate(se,Ie){let qe=!1;Ie.allowedCharacters&&se&&(M.$Cn(se.allowedCharacters,Ie.allowedCharacters)||(se={...se,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&se&&(M.$Cn(se.allowedLocales,Ie.allowedLocales)||(se={...se,allowedLocales:Ie.allowedLocales},qe=!0));const Ye=super.applyUpdate(se,Ie);return qe?new p(Ye.newValue,!0):Ye}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{nonBasicASCII:le(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:le(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:le(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,Ie){if(typeof se!="object"||!se)return Ie;const qe={};for(const[Ye,it]of Object.entries(se))it===!0&&(qe[Ye]=!0);return qe}}class ee extends C{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:w.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(117,null),w.localize(118,null),w.localize(119,null)],description:w.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:w.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:w.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),mode:h(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class H extends C{constructor(){const se={enabled:P.$us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:w.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:w.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class oe extends C{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(125,null),w.localize(126,null),w.localize(127,null)],default:se.bracketPairs,description:w.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(129,null),w.localize(130,null),w.localize(131,null)],default:se.bracketPairsHorizontal,description:w.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:w.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:w.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(135,null),w.localize(136,null),w.localize(137,null)],default:se.highlightActiveIndentation,description:w.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{bracketPairs:le(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:le(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function le(ie,se,Ie){const qe=Ie.indexOf(ie);return qe===-1?se:Ie[qe]}class Re extends C{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(139,null),w.localize(140,null)],default:se.insertMode,description:w.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:w.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:w.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:w.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(145,null),w.localize(146,null),w.localize(147,null),w.localize(148,null)],default:se.selectionMode,markdownDescription:w.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:w.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:w.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:w.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:w.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:w.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{insertMode:h(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:m(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:m(Ie.preview,this.defaultValue.preview),previewMode:h(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Ie.showMethods,this.defaultValue.showMethods),showFunctions:m(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Ie.showFields,this.defaultValue.showFields),showVariables:m(Ie.showVariables,this.defaultValue.showVariables),showClasses:m(Ie.showClasses,this.defaultValue.showClasses),showStructs:m(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:m(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Ie.showModules,this.defaultValue.showModules),showProperties:m(Ie.showProperties,this.defaultValue.showProperties),showEvents:m(Ie.showEvents,this.defaultValue.showEvents),showOperators:m(Ie.showOperators,this.defaultValue.showOperators),showUnits:m(Ie.showUnits,this.defaultValue.showUnits),showValues:m(Ie.showValues,this.defaultValue.showValues),showConstants:m(Ie.showConstants,this.defaultValue.showConstants),showEnums:m(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Ie.showKeywords,this.defaultValue.showKeywords),showWords:m(Ie.showWords,this.defaultValue.showWords),showColors:m(Ie.showColors,this.defaultValue.showColors),showFiles:m(Ie.showFiles,this.defaultValue.showFiles),showReferences:m(Ie.showReferences,this.defaultValue.showReferences),showFolders:m(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:m(Ie.showUsers,this.defaultValue.showUsers),showIssues:m(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(se.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Qe extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(189,null),w.localize(190,null),w.localize(191,null),w.localize(192,null)],description:w.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Ie,qe){return Ie.get(2)===2?0:qe}}class _e extends S{constructor(){super(144)}compute(se,Ie,qe){const Ye=Ie.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class at extends C{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:w.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(196,null),w.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showDropSelector:h(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:w.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(200,null),w.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ie=se;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showPasteSelector:h(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.$j?Le:d.$k?ze:rt,fontWeight:"normal",fontSize:d.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var Ze;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.ariaRequired=5]="ariaRequired",ie[ie.autoClosingBrackets=6]="autoClosingBrackets",ie[ie.autoClosingComments=7]="autoClosingComments",ie[ie.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ie[ie.autoClosingDelete=9]="autoClosingDelete",ie[ie.autoClosingOvertype=10]="autoClosingOvertype",ie[ie.autoClosingQuotes=11]="autoClosingQuotes",ie[ie.autoIndent=12]="autoIndent",ie[ie.automaticLayout=13]="automaticLayout",ie[ie.autoSurround=14]="autoSurround",ie[ie.bracketPairColorization=15]="bracketPairColorization",ie[ie.guides=16]="guides",ie[ie.codeLens=17]="codeLens",ie[ie.codeLensFontFamily=18]="codeLensFontFamily",ie[ie.codeLensFontSize=19]="codeLensFontSize",ie[ie.colorDecorators=20]="colorDecorators",ie[ie.colorDecoratorsLimit=21]="colorDecoratorsLimit",ie[ie.columnSelection=22]="columnSelection",ie[ie.comments=23]="comments",ie[ie.contextmenu=24]="contextmenu",ie[ie.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=26]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=28]="cursorStyle",ie[ie.cursorSurroundingLines=29]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=31]="cursorWidth",ie[ie.disableLayerHinting=32]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ie[ie.domReadOnly=34]="domReadOnly",ie[ie.dragAndDrop=35]="dragAndDrop",ie[ie.dropIntoEditor=36]="dropIntoEditor",ie[ie.emptySelectionClipboard=37]="emptySelectionClipboard",ie[ie.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ie[ie.extraEditorClassName=39]="extraEditorClassName",ie[ie.fastScrollSensitivity=40]="fastScrollSensitivity",ie[ie.find=41]="find",ie[ie.fixedOverflowWidgets=42]="fixedOverflowWidgets",ie[ie.folding=43]="folding",ie[ie.foldingStrategy=44]="foldingStrategy",ie[ie.foldingHighlight=45]="foldingHighlight",ie[ie.foldingImportsByDefault=46]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=47]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=49]="fontFamily",ie[ie.fontInfo=50]="fontInfo",ie[ie.fontLigatures=51]="fontLigatures",ie[ie.fontSize=52]="fontSize",ie[ie.fontWeight=53]="fontWeight",ie[ie.fontVariations=54]="fontVariations",ie[ie.formatOnPaste=55]="formatOnPaste",ie[ie.formatOnType=56]="formatOnType",ie[ie.glyphMargin=57]="glyphMargin",ie[ie.gotoLocation=58]="gotoLocation",ie[ie.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ie[ie.hover=60]="hover",ie[ie.inDiffEditor=61]="inDiffEditor",ie[ie.inlineSuggest=62]="inlineSuggest",ie[ie.letterSpacing=63]="letterSpacing",ie[ie.lightbulb=64]="lightbulb",ie[ie.lineDecorationsWidth=65]="lineDecorationsWidth",ie[ie.lineHeight=66]="lineHeight",ie[ie.lineNumbers=67]="lineNumbers",ie[ie.lineNumbersMinChars=68]="lineNumbersMinChars",ie[ie.linkedEditing=69]="linkedEditing",ie[ie.links=70]="links",ie[ie.matchBrackets=71]="matchBrackets",ie[ie.minimap=72]="minimap",ie[ie.mouseStyle=73]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=75]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=77]="multiCursorModifier",ie[ie.multiCursorPaste=78]="multiCursorPaste",ie[ie.multiCursorLimit=79]="multiCursorLimit",ie[ie.occurrencesHighlight=80]="occurrencesHighlight",ie[ie.overviewRulerBorder=81]="overviewRulerBorder",ie[ie.overviewRulerLanes=82]="overviewRulerLanes",ie[ie.padding=83]="padding",ie[ie.pasteAs=84]="pasteAs",ie[ie.parameterHints=85]="parameterHints",ie[ie.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ie[ie.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=88]="quickSuggestions",ie[ie.quickSuggestionsDelay=89]="quickSuggestionsDelay",ie[ie.readOnly=90]="readOnly",ie[ie.readOnlyMessage=91]="readOnlyMessage",ie[ie.renameOnType=92]="renameOnType",ie[ie.renderControlCharacters=93]="renderControlCharacters",ie[ie.renderFinalNewline=94]="renderFinalNewline",ie[ie.renderLineHighlight=95]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=97]="renderValidationDecorations",ie[ie.renderWhitespace=98]="renderWhitespace",ie[ie.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ie[ie.roundedSelection=100]="roundedSelection",ie[ie.rulers=101]="rulers",ie[ie.scrollbar=102]="scrollbar",ie[ie.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=104]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=105]="scrollPredominantAxis",ie[ie.selectionClipboard=106]="selectionClipboard",ie[ie.selectionHighlight=107]="selectionHighlight",ie[ie.selectOnLineNumbers=108]="selectOnLineNumbers",ie[ie.showFoldingControls=109]="showFoldingControls",ie[ie.showUnused=110]="showUnused",ie[ie.snippetSuggestions=111]="snippetSuggestions",ie[ie.smartSelect=112]="smartSelect",ie[ie.smoothScrolling=113]="smoothScrolling",ie[ie.stickyScroll=114]="stickyScroll",ie[ie.stickyTabStops=115]="stickyTabStops",ie[ie.stopRenderingLineAfter=116]="stopRenderingLineAfter",ie[ie.suggest=117]="suggest",ie[ie.suggestFontSize=118]="suggestFontSize",ie[ie.suggestLineHeight=119]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ie[ie.suggestSelection=121]="suggestSelection",ie[ie.tabCompletion=122]="tabCompletion",ie[ie.tabIndex=123]="tabIndex",ie[ie.unicodeHighlighting=124]="unicodeHighlighting",ie[ie.unusualLineTerminators=125]="unusualLineTerminators",ie[ie.useShadowDOM=126]="useShadowDOM",ie[ie.useTabStops=127]="useTabStops",ie[ie.wordBreak=128]="wordBreak",ie[ie.wordSeparators=129]="wordSeparators",ie[ie.wordWrap=130]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=133]="wordWrapColumn",ie[ie.wordWrapOverride1=134]="wordWrapOverride1",ie[ie.wordWrapOverride2=135]="wordWrapOverride2",ie[ie.wrappingIndent=136]="wrappingIndent",ie[ie.wrappingStrategy=137]="wrappingStrategy",ie[ie.showDeprecated=138]="showDeprecated",ie[ie.inlayHints=139]="inlayHints",ie[ie.editorClassName=140]="editorClassName",ie[ie.pixelRatio=141]="pixelRatio",ie[ie.tabFocusMode=142]="tabFocusMode",ie[ie.layoutInfo=143]="layoutInfo",ie[ie.wrappingInfo=144]="wrappingInfo",ie[ie.defaultColorDecorators=145]="defaultColorDecorators",ie[ie.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ie[ie.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(202,null)})),acceptSuggestionOnEnter:Ae(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(203,null),""],markdownDescription:w.localize(204,null)})),accessibilitySupport:Ae(new u),accessibilityPageSize:Ae(new r(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(205,null),tags:["accessibility"]})),ariaLabel:Ae(new t(4,"ariaLabel",w.localize(206,null))),ariaRequired:Ae(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(208,null),w.localize(209,null),""],description:w.localize(210,null)})),autoClosingComments:Ae(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(211,null),w.localize(212,null),""],description:w.localize(213,null)})),autoClosingDelete:Ae(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(214,null),""],description:w.localize(215,null)})),autoClosingOvertype:Ae(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(216,null),""],description:w.localize(217,null)})),autoClosingQuotes:Ae(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(218,null),w.localize(219,null),""],description:w.localize(220,null)})),autoIndent:Ae(new f(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[w.localize(221,null),w.localize(222,null),w.localize(223,null),w.localize(224,null),w.localize(225,null)],description:w.localize(226,null)})),automaticLayout:Ae(new a(13,"automaticLayout",!1)),autoSurround:Ae(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(227,null),w.localize(228,null),w.localize(229,null),""],description:w.localize(230,null)})),bracketPairColorization:Ae(new H),bracketPairGuides:Ae(new oe),stickyTabStops:Ae(new a(115,"stickyTabStops",!1,{description:w.localize(231,null)})),codeLens:Ae(new a(17,"codeLens",!0,{description:w.localize(232,null)})),codeLensFontFamily:Ae(new t(18,"codeLensFontFamily","",{description:w.localize(233,null)})),codeLensFontSize:Ae(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(234,null)})),colorDecorators:Ae(new a(20,"colorDecorators",!0,{description:w.localize(235,null)})),colorDecoratorActivatedOn:Ae(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(236,null),w.localize(237,null),w.localize(238,null)],description:w.localize(239,null)})),colorDecoratorsLimit:Ae(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(240,null)})),columnSelection:Ae(new a(22,"columnSelection",!1,{description:w.localize(241,null)})),comments:Ae(new v),contextmenu:Ae(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new a(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(242,null)})),cursorBlinking:Ae(new f(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:w.localize(243,null)})),cursorSmoothCaretAnimation:Ae(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(244,null),w.localize(245,null),w.localize(246,null)],description:w.localize(247,null)})),cursorStyle:Ae(new f(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:w.localize(248,null)})),cursorSurroundingLines:Ae(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(249,null)})),cursorSurroundingLinesStyle:Ae(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(250,null),w.localize(251,null)],markdownDescription:w.localize(252,null)})),cursorWidth:Ae(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(253,null)})),disableLayerHinting:Ae(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new a(34,"domReadOnly",!1)),dragAndDrop:Ae(new a(35,"dragAndDrop",!0,{description:w.localize(254,null)})),emptySelectionClipboard:Ae(new U),dropIntoEditor:Ae(new at),stickyScroll:Ae(new ne),experimentalWhitespaceRendering:Ae(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(255,null),w.localize(256,null),w.localize(257,null)],description:w.localize(258,null)})),extraEditorClassName:Ae(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ae(new o(40,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:w.localize(259,null)})),find:Ae(new j),fixedOverflowWidgets:Ae(new a(42,"fixedOverflowWidgets",!1)),folding:Ae(new a(43,"folding",!0,{description:w.localize(260,null)})),foldingStrategy:Ae(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(261,null),w.localize(262,null)],description:w.localize(263,null)})),foldingHighlight:Ae(new a(45,"foldingHighlight",!0,{description:w.localize(264,null)})),foldingImportsByDefault:Ae(new a(46,"foldingImportsByDefault",!1,{description:w.localize(265,null)})),foldingMaximumRegions:Ae(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ae(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(267,null)})),fontFamily:Ae(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(268,null)})),fontInfo:Ae(new O),fontLigatures2:Ae(new F),fontSize:Ae(new z),fontWeight:Ae(new K),fontVariations:Ae(new N),formatOnPaste:Ae(new a(55,"formatOnPaste",!1,{description:w.localize(269,null)})),formatOnType:Ae(new a(56,"formatOnType",!1,{description:w.localize(270,null)})),glyphMargin:Ae(new a(57,"glyphMargin",!0,{description:w.localize(271,null)})),gotoLocation:Ae(new te),hideCursorInOverviewRuler:Ae(new a(59,"hideCursorInOverviewRuler",!1,{description:w.localize(272,null)})),hover:Ae(new x),inDiffEditor:Ae(new a(61,"inDiffEditor",!1)),letterSpacing:Ae(new o(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>o.clamp(ie,-5,20),{description:w.localize(273,null)})),lightbulb:Ae(new ge),lineDecorationsWidth:Ae(new W),lineHeight:Ae(new re),lineNumbers:Ae(new de),lineNumbersMinChars:Ae(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new a(69,"linkedEditing",!1,{description:w.localize(274,null)})),links:Ae(new a(70,"links",!0,{description:w.localize(275,null)})),matchBrackets:Ae(new s(71,"matchBrackets","always",["always","near","never"],{description:w.localize(276,null)})),minimap:Ae(new ye),mouseStyle:Ae(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new o(74,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:w.localize(277,null)})),mouseWheelZoom:Ae(new a(75,"mouseWheelZoom",!1,{markdownDescription:d.$j?w.localize(278,null):w.localize(279,null)})),multiCursorMergeOverlapping:Ae(new a(76,"multiCursorMergeOverlapping",!0,{description:w.localize(280,null)})),multiCursorModifier:Ae(new f(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[w.localize(281,null),w.localize(282,null)],markdownDescription:w.localize(283,null)})),multiCursorPaste:Ae(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(284,null),w.localize(285,null)],markdownDescription:w.localize(286,null)})),multiCursorLimit:Ae(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(287,null)})),occurrencesHighlight:Ae(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(288,null),w.localize(289,null),w.localize(290,null)],markdownDescription:w.localize(291,null)})),overviewRulerBorder:Ae(new a(81,"overviewRulerBorder",!0,{description:w.localize(292,null)})),overviewRulerLanes:Ae(new r(82,"overviewRulerLanes",3,0,3)),padding:Ae(new fe),pasteAs:Ae(new st),parameterHints:Ae(new ue),peekWidgetDefaultFocus:Ae(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(293,null),w.localize(294,null)],description:w.localize(295,null)})),definitionLinkOpensInPeek:Ae(new a(87,"definitionLinkOpensInPeek",!1,{description:w.localize(296,null)})),quickSuggestions:Ae(new V),quickSuggestionsDelay:Ae(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(297,null)})),readOnly:Ae(new a(90,"readOnly",!1)),readOnlyMessage:Ae(new ve),renameOnType:Ae(new a(92,"renameOnType",!1,{description:w.localize(298,null),markdownDeprecationMessage:w.localize(299,null)})),renderControlCharacters:Ae(new a(93,"renderControlCharacters",!0,{description:w.localize(300,null),restricted:!0})),renderFinalNewline:Ae(new s(94,"renderFinalNewline",d.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(301,null)})),renderLineHighlight:Ae(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(302,null)],description:w.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Ae(new a(96,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(304,null)})),renderValidationDecorations:Ae(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(305,null),w.localize(306,null),w.localize(307,null),""],description:w.localize(308,null)})),revealHorizontalRightPadding:Ae(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new a(100,"roundedSelection",!0,{description:w.localize(309,null)})),rulers:Ae(new Pe),scrollbar:Ae(new B),scrollBeyondLastColumn:Ae(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(310,null)})),scrollBeyondLastLine:Ae(new a(104,"scrollBeyondLastLine",!0,{description:w.localize(311,null)})),scrollPredominantAxis:Ae(new a(105,"scrollPredominantAxis",!0,{description:w.localize(312,null)})),selectionClipboard:Ae(new a(106,"selectionClipboard",!0,{description:w.localize(313,null),included:d.$k})),selectionHighlight:Ae(new a(107,"selectionHighlight",!0,{description:w.localize(314,null)})),selectOnLineNumbers:Ae(new a(108,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(315,null),w.localize(316,null),w.localize(317,null)],description:w.localize(318,null)})),showUnused:Ae(new a(110,"showUnused",!0,{description:w.localize(319,null)})),showDeprecated:Ae(new a(138,"showDeprecated",!0,{description:w.localize(320,null)})),inlayHints:Ae(new J),snippetSuggestions:Ae(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(321,null),w.localize(322,null),w.localize(323,null),w.localize(324,null)],description:w.localize(325,null)})),smartSelect:Ae(new je),smoothScrolling:Ae(new a(113,"smoothScrolling",!1,{description:w.localize(326,null)})),stopRenderingLineAfter:Ae(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new Re),inlineSuggest:Ae(new ee),inlineCompletionsAccessibilityVerbose:Ae(new a(147,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(327,null)})),suggestFontSize:Ae(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new a(120,"suggestOnTriggerCharacters",!0,{description:w.localize(330,null)})),suggestSelection:Ae(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(331,null),w.localize(332,null),w.localize(333,null)],description:w.localize(334,null)})),tabCompletion:Ae(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(335,null),w.localize(336,null),w.localize(337,null)],description:w.localize(338,null)})),tabIndex:Ae(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new Q),unusualLineTerminators:Ae(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(339,null),w.localize(340,null),w.localize(341,null)],description:w.localize(342,null)})),useShadowDOM:Ae(new a(126,"useShadowDOM",!0)),useTabStops:Ae(new a(127,"useTabStops",!0,{description:w.localize(343,null)})),wordBreak:Ae(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(344,null),w.localize(345,null)],description:w.localize(346,null)})),wordSeparators:Ae(new t(129,"wordSeparators",A.$vs,{description:w.localize(347,null)})),wordWrap:Ae(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(348,null),w.localize(349,null),w.localize(350,null),w.localize(351,null)],description:w.localize(352,null)})),wordWrapBreakAfterCharacters:Ae(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(353,null)})),wordWrapOverride1:Ae(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new T),defaultColorDecorators:Ae(new a(145,"defaultColorDecorators",!1,{markdownDescription:w.localize(354,null)})),pixelRatio:Ae(new me),tabFocusMode:Ae(new a(142,"tabFocusMode",!1,{markdownDescription:w.localize(355,null)})),layoutInfo:Ae(new Z),wrappingInfo:Ae(new _e),wrappingIndent:Ae(new Qe),wrappingStrategy:Ae(new ce)}}),define(ke[195],Se([9,10]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,79,2,168,29,178,195]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Ot=e.$Nt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Mt=e.$Lt=e.SymbolKinds=e.SymbolTag=e.$Kt=e.$Jt=e.SymbolKind=e.$It=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ht=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Gt=e.$Ft=e.$Et=void 0;class ${constructor(F,N,O){this.offset=F,this.type=N,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Et=$;class E{constructor(F,N){this.tokens=F,this.endState=N,this._tokenizationResultBrand=void 0}}e.$Ft=E;class R{constructor(F,N){this.tokens=F,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$Gt=R;var C;(function(j){j[j.Method=0]="Method",j[j.Function=1]="Function",j[j.Constructor=2]="Constructor",j[j.Field=3]="Field",j[j.Variable=4]="Variable",j[j.Class=5]="Class",j[j.Struct=6]="Struct",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Event=10]="Event",j[j.Operator=11]="Operator",j[j.Unit=12]="Unit",j[j.Value=13]="Value",j[j.Constant=14]="Constant",j[j.Enum=15]="Enum",j[j.EnumMember=16]="EnumMember",j[j.Keyword=17]="Keyword",j[j.Text=18]="Text",j[j.Color=19]="Color",j[j.File=20]="File",j[j.Reference=21]="Reference",j[j.Customcolor=22]="Customcolor",j[j.Folder=23]="Folder",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue",j[j.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var p;(function(j){const F=new Map;F.set(0,D.$bk.symbolMethod),F.set(1,D.$bk.symbolFunction),F.set(2,D.$bk.symbolConstructor),F.set(3,D.$bk.symbolField),F.set(4,D.$bk.symbolVariable),F.set(5,D.$bk.symbolClass),F.set(6,D.$bk.symbolStruct),F.set(7,D.$bk.symbolInterface),F.set(8,D.$bk.symbolModule),F.set(9,D.$bk.symbolProperty),F.set(10,D.$bk.symbolEvent),F.set(11,D.$bk.symbolOperator),F.set(12,D.$bk.symbolUnit),F.set(13,D.$bk.symbolValue),F.set(15,D.$bk.symbolEnum),F.set(14,D.$bk.symbolConstant),F.set(15,D.$bk.symbolEnum),F.set(16,D.$bk.symbolEnumMember),F.set(17,D.$bk.symbolKeyword),F.set(27,D.$bk.symbolSnippet),F.set(18,D.$bk.symbolText),F.set(19,D.$bk.symbolColor),F.set(20,D.$bk.symbolFile),F.set(21,D.$bk.symbolReference),F.set(22,D.$bk.symbolCustomColor),F.set(23,D.$bk.symbolFolder),F.set(24,D.$bk.symbolTypeParameter),F.set(25,D.$bk.account),F.set(26,D.$bk.issues);function N(K){let te=F.get(K);return te||(console.info("No codicon found for CompletionItemKind "+K),te=D.$bk.symbolProperty),te}j.toIcon=N;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function z(K,te){let x=O.get(K);return typeof x>"u"&&!te&&(x=9),x}j.fromString=z})(p||(e.CompletionItemKinds=p={}));var k;(function(j){j[j.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var S;(function(j){j[j.None=0]="None",j[j.KeepWhitespace=1]="KeepWhitespace",j[j.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var c;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var m;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class a{constructor(F,N,O,z){this.range=F,this.text=N,this.completionKind=O,this.isSnippetText=z}equals(F){return P.$Ws.lift(this.range).equalsRange(F.range)&&this.text===F.text&&this.completionKind===F.completionKind&&this.isSnippetText===F.isSnippetText}}e.$Ht=a;var i;(function(j){j[j.Invoke=1]="Invoke",j[j.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function o(j){return j&&M.URI.isUri(j.uri)&&P.$Ws.isIRange(j.range)&&(P.$Ws.isIRange(j.originSelectionRange)||P.$Ws.isIRange(j.targetSelectionRange))}e.$It=o;var t;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Jt={17:(0,w.localize)(0,null),16:(0,w.localize)(1,null),4:(0,w.localize)(2,null),13:(0,w.localize)(3,null),8:(0,w.localize)(4,null),9:(0,w.localize)(5,null),21:(0,w.localize)(6,null),23:(0,w.localize)(7,null),7:(0,w.localize)(8,null),0:(0,w.localize)(9,null),11:(0,w.localize)(10,null),10:(0,w.localize)(11,null),19:(0,w.localize)(12,null),5:(0,w.localize)(13,null),1:(0,w.localize)(14,null),2:(0,w.localize)(15,null),20:(0,w.localize)(16,null),15:(0,w.localize)(17,null),18:(0,w.localize)(18,null),24:(0,w.localize)(19,null),3:(0,w.localize)(20,null),6:(0,w.localize)(21,null),14:(0,w.localize)(22,null),22:(0,w.localize)(23,null),25:(0,w.localize)(24,null),12:(0,w.localize)(25,null)};function h(j,F){return(0,w.localize)(26,null,j,e.$Jt[F])}e.$Kt=h;var s;(function(j){j[j.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var f;(function(j){const F=new Map;F.set(0,D.$bk.symbolFile),F.set(1,D.$bk.symbolModule),F.set(2,D.$bk.symbolNamespace),F.set(3,D.$bk.symbolPackage),F.set(4,D.$bk.symbolClass),F.set(5,D.$bk.symbolMethod),F.set(6,D.$bk.symbolProperty),F.set(7,D.$bk.symbolField),F.set(8,D.$bk.symbolConstructor),F.set(9,D.$bk.symbolEnum),F.set(10,D.$bk.symbolInterface),F.set(11,D.$bk.symbolFunction),F.set(12,D.$bk.symbolVariable),F.set(13,D.$bk.symbolConstant),F.set(14,D.$bk.symbolString),F.set(15,D.$bk.symbolNumber),F.set(16,D.$bk.symbolBoolean),F.set(17,D.$bk.symbolArray),F.set(18,D.$bk.symbolObject),F.set(19,D.$bk.symbolKey),F.set(20,D.$bk.symbolNull),F.set(21,D.$bk.symbolEnumMember),F.set(22,D.$bk.symbolStruct),F.set(23,D.$bk.symbolEvent),F.set(24,D.$bk.symbolOperator),F.set(25,D.$bk.symbolTypeParameter);function N(O){let z=F.get(O);return z||(console.info("No codicon found for SymbolKind "+O),z=D.$bk.symbolProperty),z}j.toIcon=N})(f||(e.SymbolKinds=f={}));class l{static asEditOperation(F){return d.$Xs.replace(P.$Ws.lift(F.range),F.text)}}e.$Lt=l;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(F){switch(F){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(F)}constructor(F){this.value=F}}e.$Mt=u;var v;(function(j){function F(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}j.is=F})(v||(e.Command=v={}));var I;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var b;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var g;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(g||(e.CommentMode=g={}));var y;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(y||(e.CommentState=y={}));var L;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class T{constructor(F){this.b=F,this.a=null}dispose(){this.a&&this.a.then(F=>{F&&F.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Nt=T,e.$Ot=new A.$vt;var U;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(U||(e.ExternalUriOpenerPriority=U={}))}),define(ke[196],Se([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([9,10]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([9,10]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(ke[204],Se([9,10]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(ke[205],Se([9,10]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([9,10]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[217],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[218],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[219],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[220],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[221],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[222],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[223],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/configuration",e)}),define(ke[224],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(ke[225],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(ke[226],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[227],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[228],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[229],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[230],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[231],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[232],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[233],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[234],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[235],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[236],Se([1,0,14,198]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var d;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(d||(e.TokenType=d={}));function P(...E){switch(E.length){case 1:return(0,M.localize)(0,null,E[0]);case 2:return(0,M.localize)(1,null,E[0],E[1]);case 3:return(0,M.localize)(2,null,E[0],E[1],E[2]);default:return}}const A=(0,M.localize)(3,null),w=(0,M.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const C=this.d,p=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:p};this.g.push({offset:C,lexeme:p,additionalInfo:R}),this.f.push(k)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const C=this.c.substring(this.d,this.e),p=$.b.get(C);p?this.k(p):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,C=!1,p=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(w);return}const S=this.c.charCodeAt(R);if(C)C=!1;else if(S===47&&!p){R++;break}else S===91?p=!0:S===92?C=!0:S===93&&(p=!1);R++}for(;R<this.c.length&&$.a.has(this.c.charCodeAt(R));)R++;this.e=R;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=$}),define(ke[237],Se([1,0,23,39,201,387]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||A.test(a)}e.$cp=$;function E(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=a.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$dp=E;function R(a){if(!a)return null;const i=a.majorBase,r=a.majorMustEqual,n=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let h=a.patchMustEqual;a.hasCaret&&(i===0||(o=!1),h=!1);let s=0;if(a.preRelease){const f=w.exec(a.preRelease);if(f){const[,l,u,v]=f;s=Date.UTC(Number(l),Number(u)-1,Number(v))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:o,patchBase:t,patchMustEqual:h,isMinimum:a.hasGreaterEquals,notBefore:s}}e.$ep=R;function C(a,i,r){let n;typeof a=="string"?n=R(E(a)):n=a;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let t;if(typeof r=="string"?t=R(E(r)):t=r,!n||!t)return!1;const h=n.majorBase,s=n.minorBase,f=n.patchBase;let l=t.majorBase,u=t.minorBase,v=t.patchBase;const I=t.notBefore;let b=t.majorMustEqual,g=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?h>l?!0:h<l?!1:s>u?!0:s<u||o&&o<I?!1:f>=v:(h===1&&l===0&&(!b||!g||!y)&&(l=1,u=0,v=0,b=!0,g=!1,y=!1),h<l?!1:h>l?!b:s<u?!1:s>u?!g:f<v?!1:f>v?!y:!(o&&o<I))}e.$fp=C;function p(a,i,r,n,o){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([M.default.Error,d.localize(0,null)]),t;if(typeof n.name!="string")return t.push([M.default.Error,d.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([M.default.Error,d.localize(2,null,"version")]),t;if(!n.engines)return t.push([M.default.Error,d.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([M.default.Error,d.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!m(n.extensionDependencies))return t.push([M.default.Error,d.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!m(n.activationEvents))return t.push([M.default.Error,d.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([M.default.Error,d.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([M.default.Warning,d.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([M.default.Error,d.localize(9,null,"main")]),t;{const f=(0,D.$Ig)(r,n.main);(0,D.$Cg)(f,r)||t.push([M.default.Warning,d.localize(10,null,f.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([M.default.Error,d.localize(11,null,"browser")]),t;{const f=(0,D.$Ig)(r,n.browser);(0,D.$Cg)(f,r)||t.push([M.default.Warning,d.localize(12,null,f.path,r.path)])}}if(!P.valid(n.version))return t.push([M.default.Error,d.localize(13,null)]),t;const h=[];if(!k(a,i,n,o,h))for(const f of h)t.push([M.default.Error,f]);return t}e.$gp=p;function k(a,i,r,n,o){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:c(a,i,r.engines.vscode,o)}e.$hp=k;function S(a,i,r){return a==="*"||c(i,r,a)}e.$ip=S;function c(a,i,r,n=[]){const o=R(E(r));if(!o)return n.push(d.localize(14,null,r)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return n.push(d.localize(15,null,r)),!1}else if(!o.majorMustEqual)return n.push(d.localize(16,null,r)),!1;return C(a,i,o)?!0:(n.push(d.localize(17,null,a,r)),!1)}function m(a){if(!Array.isArray(a))return!1;for(let i=0,r=a.length;i<r;i++)if(typeof a[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class D{constructor(d,P=[],A=!1){this.ctor=d,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.$5h=D}),define(ke[84],Se([1,0,105]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const M=[];var d;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function P(w,$,E){$ instanceof D.$5h||($=new D.$5h($,[],!!E)),M.push([w,$])}e.$1r=P;function A(){return M}e.$2r=A}),define(ke[238],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class D{constructor(P,A){this.key=P,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=D;class M{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const A of this.a.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const w=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(A);w.outgoing.set($.key,$),$.incoming.set(w.key,w)}removeNode(P){const A=this.b(P);this.a.delete(A);for(const w of this.a.values())w.outgoing.delete(A),w.incoming.delete(A)}lookupOrInsertNode(P){const A=this.b(P);let w=this.a.get(A);return w||(w=new D(A,P),this.a.set(A,w)),w}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[A,w]of this.a)P.push(`${A}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,A]of this.a){const w=new Set([P]),$=this.c(A,w);if($)return $}}c(P,A){for(const[w,$]of P.outgoing){if(A.has(w))return[...A,w].join(" -> ");A.add(w);const E=this.c($,A);if(E)return E;A.delete(w)}}}e.$Fq=M}),define(ke[5],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function w($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=w})(D||(e._util=D={})),e.$7h=d("instantiationService");function M(A,w,$){w[D.DI_TARGET]===w?w[D.DI_DEPENDENCIES].push({id:A,index:$}):(w[D.DI_DEPENDENCIES]=[{id:A,index:$}],w[D.DI_TARGET]=w)}function d(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const w=function($,E,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(w,$,R)};return w.toString=()=>A,D.serviceIds.set(A,w),w}e.$8h=d;function P(A){return A}e.$9h=P}),define(ke[51],Se([1,0,18,2,5]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,d.$8h)("configurationService");function P(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof M.URI)}e.$Ci=P;function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof M.URI)}e.$Di=A;var w;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function $(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=$;function E(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}e.$Fi=E;function R(a,i){const r=Object.create(null);for(const n in a)C(r,n,a[n],i);return r}e.$Gi=R;function C(a,i,r,n){const o=i.split("."),t=o.pop();let h=a;for(let s=0;s<o.length;s++){const f=o[s];let l=h[f];switch(typeof l){case"undefined":l=h[f]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${o.slice(0,s+1).join(".")} is ${JSON.stringify(l)}`);return}h=l}if(typeof h=="object"&&h!==null)try{h[t]=r}catch{n(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(h)}`)}else n(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(h)}`)}e.$Hi=C;function p(a,i){const r=i.split(".");k(a,r)}e.$Ii=p;function k(a,i){const r=i.shift();if(i.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const n=a[r];typeof n=="object"&&!Array.isArray(n)&&(k(n,i),Object.keys(n).length===0&&delete a[r])}}function S(a,i,r){function n(h,s){let f=h;for(const l of s){if(typeof f!="object"||f===null)return;f=f[l]}return f}const o=i.split("."),t=n(a,o);return typeof t>"u"?r:t}e.$Ji=S;function c(a,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in a?D.$Lf(a[n])&&D.$Lf(i[n])?c(a[n],i[n],r):r&&(a[n]=i[n]):a[n]=i[n])})}e.$Ki=c;function m(a){return a.replace(/[\[\]]/g,"")}e.$Li=m}),define(ke[45],Se([1,0,11,13,236,5,197,14]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function E(J,W){if($.get(J)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(J,W)}e.$4i=E;const R=Object.prototype.hasOwnProperty;var C;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const p={regexParsingWithErrorRecovery:!0},k=(0,A.localize)(0,null),S=(0,A.localize)(1,null),c=(0,A.localize)(2,null),m=(0,A.localize)(3,null),a=(0,A.localize)(4,null),i=(0,A.localize)(5,null),r=(0,A.localize)(6,null),n=(0,A.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=p){this.k=W,this.d=new d.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const ye=this.D(),he=ye.type===17?i:void 0;throw this.h.push({message:a,offset:ye.offset,lexeme:d.$3i.getLexeme(ye),additionalInfo:he}),o.c}return re}catch(re){if(re!==o.c)throw re;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const re=this.o();W.push(re)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const re=this.s();W.push(re)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const re=this.l();return this.A(1,m),re?.negate()}case 17:return this.z(),L.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const re=this.l();return this.A(1,m),re}case 17:{const re=W.lexeme;if(this.z(),this.y(9)){const he=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),he.type!==10)throw this.B("REGEX",he);const fe=he.lexeme,ue=fe.lastIndexOf("/"),me=ue===fe.length-1?void 0:this.w(fe.substring(ue+1));let V;try{V=new RegExp(fe.substring(1,ue),me)}catch{throw this.B("REGEX",he)}return O.create(re,V)}switch(he.type){case 10:case 19:{const fe=[he.lexeme];this.z();let ue=this.D(),me=0;for(let Pe=0;Pe<he.lexeme.length;Pe++)he.lexeme.charCodeAt(Pe)===40?me++:he.lexeme.charCodeAt(Pe)===41&&me--;for(;!this.E()&&ue.type!==15&&ue.type!==16;){switch(ue.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Pe=0;Pe<ue.lexeme.length;Pe++)ue.lexeme.charCodeAt(Pe)===40?me++:he.lexeme.charCodeAt(Pe)===41&&me--}if(me<0)break;fe.push(d.$3i.getLexeme(ue)),this.z(),ue=this.D()}const V=fe.join(""),Y=V.lastIndexOf("/"),de=Y===V.length-1?void 0:this.w(V.substring(Y+1));let pe;try{pe=new RegExp(V.substring(1,Y),de)}catch{throw this.B("REGEX",he)}return t.regex(re,pe)}case 18:{const fe=he.lexeme;this.z();let ue=null;if(!(0,M.$Ke)(fe)){const me=fe.indexOf("/"),V=fe.lastIndexOf("/");if(me!==V&&me>=0){const Y=fe.slice(me+1,V),de=fe[V+1]==="i"?"i":"";try{ue=new RegExp(Y,de)}catch{throw this.B("REGEX",he)}}}if(ue===null)throw this.B("REGEX",he);return O.create(re,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const he=this.u();return t.notIn(re,he)}switch(this.D().type){case 3:{this.z();const he=this.u();if(this.x().type===18)return t.equals(re,he);switch(he){case"true":return t.has(re);case"false":return t.not(re);default:return t.equals(re,he)}}case 4:{this.z();const he=this.u();if(this.x().type===18)return t.notEquals(re,he);switch(he){case"true":return t.not(re);case"false":return t.has(re);default:return t.notEquals(re,he)}}case 5:return this.z(),F.create(re,this.u());case 6:return this.z(),N.create(re,this.u());case 7:return this.z(),U.create(re,this.u());case 8:return this.z(),j.create(re,this.u());case 13:return this.z(),t.in(re,this.u());default:return t.has(re)}}case 20:throw this.h.push({message:r,offset:W.offset,lexeme:"",additionalInfo:n}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,re){if(this.C(W))return this.z();throw this.B(re,this.D())}B(W,re,ye){const he=(0,A.localize)(8,null,W,d.$3i.getLexeme(re)),fe=re.offset,ue=d.$3i.getLexeme(re);return this.h.push({message:he,offset:fe,lexeme:ue,additionalInfo:ye}),o.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=o;class t{static false(){return l.INSTANCE}static true(){return u.INSTANCE}static has(W){return v.create(W)}static equals(W,re){return I.create(W,re)}static notEquals(W,re){return y.create(W,re)}static regex(W,re){return O.create(W,re)}static in(W,re){return b.create(W,re)}static notIn(W,re){return g.create(W,re)}static not(W){return L.create(W)}static and(...W){return te.create(W,null,!0)}static or(...W){return x.create(W,null,!0)}static greater(W,re){return U.create(W,re)}static greaterEquals(W,re){return j.create(W,re)}static smaller(W,re){return F.create(W,re)}static smallerEquals(W,re){return N.create(W,re)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$6i=t;function h(J){const W=new o({regexParsingWithErrorRecovery:!1});return J.map(re=>(W.parse(re),W.lexingErrors.length>0?W.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,A.localize)(9,null,ye.additionalInfo):(0,A.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$7i=h;function s(J,W){const re=J?J.substituteConstants():void 0,ye=W?W.substituteConstants():void 0;return!re&&!ye?!0:!re||!ye?!1:re.equals(ye)}e.$8i=s;function f(J,W){return J.cmp(W)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return u.INSTANCE}}e.$9i=l;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return l.INSTANCE}}e.$0i=u;class v{static create(W,re=null){const ye=$.get(W);return typeof ye=="boolean"?ye?u.INSTANCE:l.INSTANCE:new v(W,re)}constructor(W,re){this.key=W,this.c=re,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:Z(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=$.get(this.key);return typeof W=="boolean"?W?u.INSTANCE:l.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$$i=v;class I{static create(W,re,ye=null){if(typeof re=="boolean")return re?v.create(W,ye):L.create(W,ye);const he=$.get(W);return typeof he=="boolean"?re===(he?"true":"false")?u.INSTANCE:l.INSTANCE:new I(W,re,ye)}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?u.INSTANCE:l.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$_i=I;class b{static create(W,re){return new b(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.f),ye=W.getValue(this.d);return Array.isArray(re)?re.includes(ye):typeof ye=="string"&&typeof re=="object"&&re!==null?R.call(re,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$aj=b;class g{static create(W,re){return new g(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=11,this.c=b.create(W,re)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=g;class y{static create(W,re,ye=null){if(typeof re=="boolean")return re?L.create(W,ye):v.create(W,ye);const he=$.get(W);return typeof he=="boolean"?re===(he?"true":"false")?l.INSTANCE:u.INSTANCE:new y(W,re,ye)}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?l.INSTANCE:u.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$cj=y;class L{static create(W,re=null){const ye=$.get(W);return typeof ye=="boolean"?ye?l.INSTANCE:u.INSTANCE:new L(W,re)}constructor(W,re){this.c=W,this.d=re,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:Z(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=$.get(this.c);return typeof W=="boolean"?W?l.INSTANCE:u.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$dj=L;function T(J,W){if(typeof J=="string"){const re=parseFloat(J);isNaN(re)||(J=re)}return typeof J=="string"||typeof J=="number"?W(J):l.INSTANCE}class U{static create(W,re,ye=null){return T(re,he=>new U(W,he,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$ej=U;class j{static create(W,re,ye=null){return T(re,he=>new j(W,he,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$fj=j;class F{static create(W,re,ye=null){return T(re,he=>new F(W,he,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$gj=F;class N{static create(W,re,ye=null){return T(re,he=>new N(W,he,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ce(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$hj=N;class O{static create(W,re){return new O(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const re=this.f?this.f.source:"",ye=W.f?W.f.source:"";return re<ye?-1:re>ye?1:0}equals(W){if(W.type===this.type){const re=this.f?this.f.source:"",ye=W.f?W.f.source:"";return this.d===W.d&&re===ye}return!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$ij=O;class z{static create(W){return new z(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new z(this.c.map(W))}negate(){return this.c}}e.$jj=z;function K(J){let W=null;for(let re=0,ye=J.length;re<ye;re++){const he=J[re].substituteConstants();if(J[re]!==he&&W===null){W=[];for(let fe=0;fe<re;fe++)W[fe]=J[fe]}W!==null&&(W[re]=he)}return W===null?J:W}class te{static create(W,re,ye){return te.d(W,re,ye)}constructor(W,re){this.expr=W,this.c=re,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const he=f(this.expr[re],W.expr[re]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=K(this.expr);return W===this.expr?this:te.create(W,this.c,!1)}evaluate(W){for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].evaluate(W))return!1;return!0}static d(W,re,ye){const he=[];let fe=!1;for(const ue of W)if(ue){if(ue.type===1){fe=!0;continue}if(ue.type===0)return l.INSTANCE;if(ue.type===6){he.push(...ue.expr);continue}he.push(ue)}if(he.length===0&&fe)return u.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(f);for(let ue=1;ue<he.length;ue++)he[ue-1].equals(he[ue])&&(he.splice(ue,1),ue--);if(he.length===1)return he[0];for(;he.length>1;){const ue=he[he.length-1];if(ue.type!==9)break;he.pop();const me=he.pop(),V=he.length===0,Y=x.create(ue.expr.map(de=>te.create([de,me],null,ye)),null,V);Y&&(he.push(Y),he.sort(f))}if(he.length===1)return he[0];if(ye){for(let ue=0;ue<he.length;ue++)for(let me=ue+1;me<he.length;me++)if(he[ue].negate().equals(he[me]))return l.INSTANCE;if(he.length===1)return he[0]}return new te(he,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new te(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());this.c=x.create(W,this,!0)}return this.c}}e.$kj=te;class x{static create(W,re,ye){return x.d(W,re,ye)}constructor(W,re){this.expr=W,this.c=re,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const he=f(this.expr[re],W.expr[re]);if(he!==0)return he}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=K(this.expr);return W===this.expr?this:x.create(W,this.c,!1)}evaluate(W){for(let re=0,ye=this.expr.length;re<ye;re++)if(this.expr[re].evaluate(W))return!0;return!1}static d(W,re,ye){let he=[],fe=!1;if(W){for(let ue=0,me=W.length;ue<me;ue++){const V=W[ue];if(V){if(V.type===0){fe=!0;continue}if(V.type===1)return u.INSTANCE;if(V.type===9){he=he.concat(V.expr);continue}he.push(V)}}if(he.length===0&&fe)return l.INSTANCE;he.sort(f)}if(he.length!==0){if(he.length===1)return he[0];for(let ue=1;ue<he.length;ue++)he[ue-1].equals(he[ue])&&(he.splice(ue,1),ue--);if(he.length===1)return he[0];if(ye){for(let ue=0;ue<he.length;ue++)for(let me=ue+1;me<he.length;me++)if(he[ue].negate().equals(he[me]))return u.INSTANCE;if(he.length===1)return he[0]}return new x(he,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new x(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());for(;W.length>1;){const re=W.shift(),ye=W.shift(),he=[];for(const fe of ne(re))for(const ue of ne(ye))he.push(te.create([fe,ue],null,!1));W.unshift(x.create(he,null,!1))}this.c=x.create(W,this,!0)}return this.c}}e.$lj=x;class X extends v{static{this.d=[]}static all(){return X.d.values()}constructor(W,re,ye){super(W,null),this.f=re,typeof ye=="object"?X.d.push({...ye,key:W}):ye!==!0&&X.d.push({key:W,description:ye,type:re!=null?typeof re:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return I.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$mj=X,e.$nj=(0,P.$8h)("contextKeyService");function Z(J,W){return J<W?-1:J>W?1:0}function ce(J,W,re,ye){return J<re?-1:J>re?1:W<ye?-1:W>ye?1:0}function _(J,W){if(J.type===0||W.type===1)return!0;if(J.type===9)return W.type===9?ge(J.expr,W.expr):!1;if(W.type===9){for(const re of W.expr)if(_(J,re))return!0;return!1}if(J.type===6){if(W.type===6)return ge(W.expr,J.expr);for(const re of J.expr)if(_(re,W))return!0;return!1}return J.equals(W)}e.$oj=_;function ge(J,W){let re=0,ye=0;for(;re<J.length&&ye<W.length;){const he=J[re].cmp(W[ye]);if(he<0)return!1;he===0&&re++,ye++}return re===J.length}function ne(J){return J.type===9?J.expr:[J]}}),define(ke[239],Se([1,0,23,39,199,5,102,11,24]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_v=e.$$v=e.ConfirmResult=e.$0v=e.$9v=e.$8v=void 0,e.$8v=(0,P.$8h)("dialogService");var E;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(E||(E={}));class R{a(m){return this.d(m,E.Confirmation)}b(m){return this.d(m,E.Prompt)}c(m){return this.d(m,E.Input)}d(m,a){const i=[];switch(a){case E.Confirmation:{const r=m;r.primaryButton?i.push(r.primaryButton):i.push((0,d.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,d.localize)(1,null));break}case E.Prompt:{const r=m;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,d.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,d.localize)(3,null))),i.length===0&&i.push((0,d.localize)(4,null));break}case E.Input:{const r=m;r.primaryButton?i.push(r.primaryButton):i.push((0,d.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,d.localize)(6,null));break}}return i}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===M.default.Info?"info":m===M.default.Error?"error":m===M.default.Warning?"warning":"none"}f(m,a,i){const r=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&r.push(m.cancelButton);let n=r[a]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$9v=R,e.$0v=(0,P.$8h)("fileDialogService");var C;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const p=10;function k(c){const m=[];return m.push(...c.slice(0,p).map(a=>typeof a=="string"?a:(0,D.$Fg)(a))),c.length>p&&(c.length-p===1?m.push((0,d.localize)(7,null)):m.push((0,d.localize)(8,null,c.length-p))),m.push(""),m.join(`
`)}e.$$v=k;function S(c,m){const a=(0,$.$yn)(c);let i=(a.buttons??[]).map(t=>(0,A.$5v)(t)),r=(c.buttons||[]).map((t,h)=>h),n=0,o=a.cancelId??i.length-1;if(i.length>1){const t=typeof o=="number"?i[o]:void 0;if(w.$k||w.$j){if(typeof t=="string"&&i.length>1&&o!==1){i.splice(o,1),i.splice(1,0,t);const h=r[o];r.splice(o,1),r.splice(1,0,h),o=1}w.$k&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(o=n-1))}else if(w.$i&&typeof t=="string"&&i.length>1&&o!==i.length-1){i.splice(o,1),i.push(t);const h=r[o];r.splice(o,1),r.push(h),o=i.length-1}}return a.buttons=i,a.defaultId=n,a.cancelId=o,a.noLink=!0,a.title=a.title||m.nameLong,{options:a,buttonIndeces:r}}e.$_v=S}),define(ke[133],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,D.$8h)("environmentService"),e.$di=(0,D.$9h)(e.$ci)}),define(ke[134],Se([1,0,200,5]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function d(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=d;function P(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=P;function A(r,n){switch(r){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=A;function w(r,n){return n==="web"&&!r.includes("web")}e.$yo=w;function $(r,n,o){return w(n,o)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===o}e.$zo=$;function E(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$Ao=E;var R;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var C;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var p;(function(r){r.Install="install",r.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var k;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(k||(e.InstallOperation=k={})),e.$Bo=(0,M.$8h)("extensionGalleryService");var S;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var c;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$Co=m;var a;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class i extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$Do=i,e.$Eo=(0,M.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,M.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,M.$8h)("IExtensionTipsService"),e.$Jo=(0,D.localize2)(0,"Extensions"),e.$Ko=(0,D.localize2)(1,"Preferences")}),define(ke[240],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O2b=e.$N2b=void 0,e.$N2b=(0,D.$8h)("externalTerminal"),e.$O2b="Terminal.app"}),define(ke[241],Se([1,0,50,52,15,17,11,101,31,104,202,240]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.$L0b=e.$K0b=void 0;const p=R.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends k{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(D,o,E.$Vl(),t)}spawnTerminal(o,t,h,s){const f=t.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const l=P.$nc(f,".exe").toLowerCase();if(l==="cmder")return o.spawn(f,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return f.indexOf(" ")>=0&&u.push('""'),u.push(f),l==="wt"&&u.push("-d ."),new Promise((v,I)=>{const b=a(process),g=o.spawn(h,u,{cwd:s,env:b,detached:!0});g.on("error",I),g.on("exit",()=>v())})}async runInTerminal(o,t,h,s,f){const l="windowsExec"in f&&f.windowsExec?f.windowsExec:S.getDefaultTerminalWindows(),u=await S.f();return new Promise((v,I)=>{const b=`"${t} - ${p}"`,g=`""${h.join('" "')}" & pause"`,y=Object.assign({},a(process),s);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const L={cwd:t,env:y,windowsVerbatimArguments:!0};let T,U;P.$nc(l,".exe")==="wt"?(T=l,U=["-d",".",S.b,"/c",g]):u?(T=u,U=["-d",t,l,"/c",g]):(T=S.b,U=["/c","start",b,"/wait",l,"/c",g]),D.spawn(T,U,L).on("error",F=>{I(i(F))}),v(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const o=await E.win32.findExecutable("wt");return await $.Promises.exists(o)?o:void 0}catch{return}}}e.$K0b=S,Ge([M.$zh],S,"f",null);class c extends k{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(D,o,t)}runInTerminal(o,t,h,s,f){const l=f.osxExec||C.$O2b;return new Promise((u,v)=>{if(l===C.$O2b||l==="iTerm.app"){const I=l===C.$O2b?"TerminalHelper":"iTermHelper",g=[d.$pg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",o||p,"-w",t];for(const T of h)g.push("-a"),g.push(T);if(s){const T=Object.assign({},a(process),s);for(const U in T){const j=T[U];j===null?(g.push("-u"),g.push(U)):(g.push("-e"),g.push(`${U}=${j}`))}}let y="";const L=D.spawn(c.b,g);L.on("error",T=>{v(i(T))}),L.stderr.on("data",T=>{y+=T.toString()}),L.on("exit",T=>{if(T===0)u(void 0);else if(y){const U=y.split(`
`,1);v(new Error(U[0]))}else v(new Error(R.localize(1,null,I,T)))})}else v(new Error(R.localize(2,null,l)))})}spawnTerminal(o,t,h){const s=t.osxExec||C.$O2b;return new Promise((f,l)=>{const u=["-a",s];h&&u.push(h);const v=a(process),I=o.spawn("/usr/bin/open",u,{cwd:h,env:v});I.on("error",l),I.on("exit",()=>f())})}}e.$L0b=c;class m extends k{static{this.b=R.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(D,o,t)}runInTerminal(o,t,h,s,f){const l=f.linuxExec?Promise.resolve(f.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,v)=>{const I=[];l.then(b=>{b.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const g=`${r(h)}; echo; read -p "${m.b}" -n1;`;I.push(`''${g}''`);const y=Object.assign({},a(process),s);Object.keys(y).filter(j=>y[j]===null).forEach(j=>delete y[j]);const L={cwd:t,env:y};let T="";const U=D.spawn(b,I,L);U.on("error",j=>{v(i(j))}),U.stderr.on("data",j=>{T+=j.toString()}),U.on("exit",j=>{if(j===0)u(void 0);else if(T){const F=T.split(`
`,1);v(new Error(F[0]))}else v(new Error(R.localize(4,null,b,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!A.$k)m.d=Promise.resolve("xterm");else{const o=await $.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(o,t,h){const s=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((f,l)=>{s.then(u=>{const v=a(process),I=o.spawn(u,[],{cwd:h,env:v});I.on("error",l),I.on("exit",()=>f())})})}}e.$M0b=m;function a(n){const o={...n.env};return(0,w.$Tl)(o),o}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(R.localize(5,null,n.path)):n}function r(n){let o="";for(const t of n)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ke[32],Se([1,0,78,17,13,18,2,203,5,11,15,43]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,$.$8h)("fileService");function p(_){return _.create===!0}e.$tk=p;var k;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var S;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function c(_){const ge=_;return!!ge&&typeof ge.onDidChange=="function"}e.$uk=c;var m;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function a(_){return!!(_.capabilities&2)}e.$vk=a;function i(_){return!!(_.capabilities&8)}e.$wk=i;function r(_){return!!(_.capabilities&131072)}e.$xk=r;function n(_){return!!(_.capabilities&4)}e.$yk=n;function o(_){return!!(_.capabilities&16)}e.$zk=o;function t(_){return a(_)?!!(_.capabilities&16384):!1}e.$Ak=t;function h(_){return a(_)?!!(_.capabilities&32768):!1}e.$Bk=h;function s(_){return!!(_.capabilities&65536)}e.$Ck=s;function f(_){return!!(_.capabilities&2048)}e.$Dk=f;var l;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class u extends Error{static create(ge,ne){const J=new u(ge.toString(),ne);return b(J,ne),J}constructor(ge,ne){super(ge),this.code=ne}}e.$Ek=u;function v(_,ge){return u.create(_,ge)}e.$Fk=v;function I(_){return _||v((0,w.localize)(0,null),l.Unknown)}e.$Gk=I;function b(_,ge){return _.name=ge?`${ge} (FileSystemError)`:"FileSystemError",_}e.$Hk=b;function g(_){if(!_)return l.Unknown;if(_ instanceof u)return _.code;const ge=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ge)return l.Unknown;switch(ge[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$Ik=g;function y(_){if(_ instanceof N)return _.fileOperationResult;switch(g(_)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$Jk=y;var L;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class T{constructor(ge,ne,J){this.resource=ge,this.operation=ne,this.target=J}isOperation(ge){return this.operation===ge}}e.$Kk=T;var U;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class j{static{this.a=null}constructor(ge,ne){this.c=ne,this.b=void 0,this.d=new C.$V(()=>{const J=D.$bi.forUris(()=>this.c);return J.fill(this.rawAdded.map(W=>[W,!0])),J}),this.f=new C.$V(()=>{const J=D.$bi.forUris(()=>this.c);return J.fill(this.rawUpdated.map(W=>[W,!0])),J}),this.g=new C.$V(()=>{const J=D.$bi.forUris(()=>this.c);return J.fill(this.rawDeleted.map(W=>[W,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of ge){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.b!==j.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(ge,...ne){return this.h(ge,{includeChildren:!1},...ne)}affects(ge,...ne){return this.h(ge,{includeChildren:!0},...ne)}h(ge,ne,...J){if(!ge)return!1;const W=J.length>0;return!!((!W||J.includes(1))&&(this.d.value.get(ge)||ne.includeChildren&&this.d.value.findSuperstr(ge))||(!W||J.includes(0))&&(this.f.value.get(ge)||ne.includeChildren&&this.f.value.findSuperstr(ge))||(!W||J.includes(2))&&(this.g.value.findSubstr(ge)||ne.includeChildren&&this.g.value.findSuperstr(ge)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ge){return this.b===ge}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=j;function F(_,ge,ne){return!_||!ge||_===ge||ge.length>_.length?!1:(ge.charAt(ge.length-1)!==M.sep&&(ge+=M.sep),ne?(0,d.$bf)(_,ge):_.indexOf(ge)===0)}e.$Mk=F;class N extends Error{constructor(ge,ne,J){super(ge),this.fileOperationResult=ne,this.options=J}}e.$Nk=N;class O extends N{constructor(ge,ne,J,W){super(ge,ne,W),this.fileOperationResult=ne,this.size=J}}e.$Ok=O;class z extends N{constructor(ge,ne,J){super(ge,2,J),this.stat=ne}}e.$Pk=z;var K;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var te;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$Xk="";function x(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Yk=x;async function X(_,ge){if(!ge.hasProvider(A.URI.from({scheme:_.scheme})))return new Promise(ne=>{const J=ge.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===_.scheme&&W.added&&(J.dispose(),ne())})})}e.$Zk=X;class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(ge){return(0,P.$Nf)(ge)||(ge=0),ge<Z.KB?(0,w.localize)(1,null,ge.toFixed(0)):ge<Z.MB?(0,w.localize)(2,null,(ge/Z.KB).toFixed(2)):ge<Z.GB?(0,w.localize)(3,null,(ge/Z.MB).toFixed(2)):ge<Z.TB?(0,w.localize)(4,null,(ge/Z.GB).toFixed(2)):(0,w.localize)(5,null,(ge/Z.TB).toFixed(2))}}e.$1k=Z;function ce(_){const ge=typeof _=="string"||_?.scheme===R.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===R.Schemas.file?1024*Z.MB:ge?10*Z.MB:E.$o?50*Z.MB:1024*Z.MB}e.$2k=ce}),define(ke[242],Se([1,0,21,14,204,32]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function A(R,C,p,k,S,c){let m;try{await w(R,C,p,k,S,c)}catch(a){m=a}finally{m&&S.errorTransformer&&(m=S.errorTransformer(m)),typeof m<"u"&&p.error(m),p.end()}}e.$dq=A;async function w(R,C,p,k,S,c){$(c);const m=await R.open(C,{create:!1});try{$(c);let a=0,i=0,r=S&&typeof S.length=="number"?S.length:void 0,n=D.$ke.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),o=S&&typeof S.position=="number"?S.position:0,t=0;do i=await R.read(m,o,n.buffer,t,n.byteLength-t),o+=i,t+=i,a+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await p.write(k(n)),n=D.$ke.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&$(c)&&E(a,S));if(t>0){let h=t;typeof r=="number"&&(h=Math.min(t,r)),p.write(k(n.slice(0,h)))}}catch(a){throw(0,P.$Gk)(a)}finally{await R.close(m)}}function $(R){if(R.isCancellationRequested)throw(0,M.$6)();return!0}function E(R,C){if(typeof C?.limits?.size=="number"&&R>C.limits.size)throw(0,P.$Fk)((0,d.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[85],Se([1,0,35,3,17,11,2,32]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;function $(a){return a.recursive===!0}e.$fq=$;class E extends M.$Tc{static{this.a=5}constructor(i,r,n,o){super(),this.h=i,this.j=r,this.m=n,this.n=o,this.c=this.B(new M.$Uc),this.f=void 0,this.g=0}s(){const i=new M.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$gq=E;class R extends E{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.$hq=R;class C extends E{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.$iq=C;function p(a){return a.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.$jq=p;function k(a){const i=new m;for(const r of a)i.processEvent(r);return i.coalesce()}e.$kq=k;function S(a,i){return typeof i=="string"&&!i.startsWith(D.$Kj)&&!(0,d.$ic)(i)?{base:a,pattern:i}:i}e.$lq=S;function c(a,i){const r=[];for(const n of i)r.push((0,D.$Oj)(S(a,n)));return r}e.$mq=c;class m{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let n=!1;if(r){const o=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:o===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(r)):o===2&&t===1?r.type=0:o===1&&t===0||(r.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,o)=>n.resource.fsPath.length-o.resource.fsPath.length).filter(n=>r.some(o=>(0,w.$Mk)(n.resource.fsPath,o,!P.$k))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(ke[243],Se([1,0,57,8,22,34,3,77,17,11,23,2,103,31,85]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class c extends A.$Tc{static{this.a=100}static{this.b=75}constructor(i,r,n,o){super(),this.m=i,this.n=r,this.r=n,this.s=o,this.c=this.B(new M.$kh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new M.$jh(t=>this.z(t),c.b)),this.g=(0,S.$mq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$mq)(this.m.path,this.m.includes):void 0,this.j=new d.$7d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await k.Promises.stat(i);this.B(await this.w(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let r=i.path;try{r=await k.Promises.realpath(i.path),i.path===r&&(r=await(0,p.$wq)(i.path)??i.path),i.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async w(i,r){if(E.$j&&(0,P.$9f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const n=new d.$7d(this.j.token),o=new A.$Sc;try{const t=C.URI.file(this.m.path),h=(0,$.$nc)(i),s=(0,D.watch)(i);o.add((0,A.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${i}'`);const f=new Set;if(r)try{for(const u of await k.Promises.readdir(i))f.add(u)}catch(u){this.D(u)}const l=new Map;o.add((0,A.$Rc)(()=>{for(const[,u]of l)u.dispose();l.clear()})),s.on("error",(u,v)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${u}, ${v})`),this.dispose()}),s.on("change",(u,v)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${u}"] ${v}`);let I="";if(v&&(I=v.toString(),E.$j&&(I=(0,w.$Il)(I))),!(!I||u!=="change"&&u!=="rename"))if(r)if(u==="rename"){l.get(I)?.dispose();const b=setTimeout(async()=>{if(l.delete(I),I===h&&!await k.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.C((0,$.$jc)(i,I));if(n.token.isCancellationRequested)return;let y;g?f.has(I)?y=0:(y=1,f.add(I)):(f.delete(I),y=2),this.y({resource:(0,R.$Ig)(t,I),type:y,cId:this.m.correlationId})},c.a);l.set(I,(0,A.$Rc)(()=>clearTimeout(b)))}else{let b;f.has(I)?b=0:(b=1,f.add(I)),this.y({resource:(0,R.$Ig)(t,I),type:b,cId:this.m.correlationId})}else if(u==="rename"||I!==h){const b=setTimeout(async()=>{const g=await k.Promises.exists(i);n.token.isCancellationRequested||(g?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),o.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);o.clear(),o.add((0,A.$Rc)(()=>clearTimeout(b)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await k.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{n.dispose(!0),o.dispose()})}y(i,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const r=(0,S.$kq)(i);if(r.length>0){if(this.s)for(const o of r)this.G(` >> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(E.$k)return k.Promises.exists(i);try{const r=(0,$.$nc)(i);return(await k.Promises.readdir((0,$.$mc)(i))).some(o=>o===r)}catch(r){return this.G(r),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$zq=c;async function m(a,i,r,n,o=512){const t=await k.Promises.open(a,"r"),h=Buffer.allocUnsafe(o),s=new d.$7d(n);let f,l=!1;const u={path:a,excludes:[],recursive:!1},v=new c(u,I=>{(async()=>{for(const{type:b}of I)if(b===0){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:g}=await k.Promises.read(t,h,0,o,null);if(!g||s.token.isCancellationRequested)break;i(h.slice(0,g))}}catch(g){f=new Error(g),s.dispose(!0)}finally{l=!1}}})()});return await v.ready,r(),new Promise((I,b)=>{s.token.onCancellationRequested(async()=>{v.dispose();try{await k.Promises.close(t)}catch(g){f=new Error(g)}f?b(f):I()})})}e.$Aq=m}),define(ke[244],Se([1,0,4,35,3,11,243]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class w extends d.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(E){const R=this.j(E),C=R.filter(k=>{const S=this.c.get(k.path);return S?!(0,M.$Sj)(S.request.excludes,k.excludes)||!(0,M.$Sj)(S.request.includes,k.includes):!0}),p=Array.from(this.c.values()).filter(({request:k})=>!R.find(S=>S.path===k.path&&(0,M.$Sj)(S.excludes,k.excludes)&&(0,M.$Sj)(S.includes,k.includes))).map(({request:k})=>k.path);C.length&&this.m(`Request to start watching: ${C.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"}, correlationId: ${typeof k.correlationId=="number"?k.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const k of p)this.h(k);for(const k of C)this.g(k)}g(E){const R=new A.$zq(E,p=>this.a.fire(p),p=>this.b.fire(p),this.f),C={request:E,instance:R};this.c.set(E.path,C)}async stop(){for(const[E]of this.c)this.h(E);this.c.clear()}h(E){const R=this.c.get(E);R&&(this.c.delete(E),R.instance.dispose())}j(E){const R=new Map;for(const C of E){const p=P.$k?C.path:C.path.toLowerCase();let k=R.get(C.correlationId);k||(k=new Map,R.set(C.correlationId,k)),k.set(p,C)}return Array.from(R.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(E){this.f=E;for(const[,R]of this.c)R.instance.setVerboseLogging(E)}m(E){this.f&&this.b.fire({type:"trace",message:this.n(E)})}n(E,R){return R?`[File Watcher (node.js)] ${E} (path: ${R.request.path})`:`[File Watcher (node.js)] ${E}`}}e.$Bq=w}),define(ke[245],Se([1,0,85,244]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class d extends D.$hq{constructor(A,w,$){super(A,w,$),this.s()}r(A){return A.add(new M.$Bq)}}e.$Cq=d}),define(ke[246],Se([1,0,15,81,187,85]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class A extends P.$iq{constructor($,E,R){super($,E,R),this.s()}r($){const E=$.add(new d.$tq(D.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(E.onDidProcessExit(({code:R,signal:C})=>this.t(`terminated by itself with code ${R}, signal: ${C}`))),M.ProxyChannel.toService((0,M.$Oh)(E.getChannel("watcher")))}}e.$uq=A}),define(ke[106],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class D{constructor(...d){this.a=new Map;for(const[P,A]of d)this.set(P,A)}set(d,P){const A=this.a.get(d);return this.a.set(d,P),A}has(d){return this.a.has(d)}get(d){return this.a.get(d)}}e.$6h=D}),define(ke[247],Se([1,0,8,14,3,105,238,5,106,76]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const R=!1;class C extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class p{constructor(m=new $.$6h,a=!1,i,r=R){this.f=m,this.g=a,this.h=i,this.i=r,this.o=new Set,this.f.set(w.$7h,this),this._globalGraph=r?i?._globalGraph??new A.$Fq(n=>n):void 0}createChild(m){return new p(m,this.g,this,this.i)}invokeFunction(m,...a){const i=S.traceInvocation(this.i,m);let r=!1;try{return m({get:o=>{if(r)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(o,i);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{r=!0,i.stop()}}createInstance(m,...a){let i,r;return m instanceof P.$5h?(i=S.traceCreation(this.i,m.ctor),r=this.j(m.ctor,m.staticArguments.concat(a),i)):(i=S.traceCreation(this.i,m),r=this.j(m,a,i)),i.stop(),r}j(m,a=[],i){const r=w._util.getServiceDependencies(m).sort((t,h)=>t.index-h.index),n=[];for(const t of r){const h=this.m(t.id,i);h||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(h)}const o=r.length>0?r[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${m.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(m,a.concat(n))}k(m,a){if(this.f.get(m)instanceof P.$5h)this.f.set(m,a);else if(this.h)this.h.k(m,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const a=this.f.get(m);return!a&&this.h?this.h.l(m):a}m(m,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const i=this.l(m);return i instanceof P.$5h?this.q(m,i,a.branch(m,!0)):(a.branch(m,!1),i)}q(m,a,i){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,a,i)}finally{this.o.delete(m)}}r(m,a,i){const r=new A.$Fq(t=>t.id.toString());let n=0;const o=[{id:m,desc:a,_trace:i}];for(;o.length;){const t=o.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new C(r);for(const h of w._util.getServiceDependencies(t.desc.ctor)){const s=this.l(h.id);if(s||this.u(`[createInstance] ${m} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),s instanceof P.$5h){const f={id:h.id,desc:s,_trace:t._trace.branch(h.id,!0)};r.insertEdge(t,f),o.push(f)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new C(r);break}for(const{data:h}of t){if(this.l(h.id)instanceof P.$5h){const f=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,f)}r.removeNode(h)}}return this.l(m)}s(m,a,i=[],r,n){if(this.f.get(m)instanceof P.$5h)return this.t(m,a,i,r,n);if(this.h)return this.h.s(m,a,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(m,a,i=[],r,n){if(r){const o=new p(void 0,this.g,this,this.i);o.c=String(m);const t=new Map,h=new D.$oh(()=>{const s=o.j(a,i,n);for(const[f,l]of t){const u=s[f];if(typeof u=="function")for(const v of l)v.disposable=u.apply(s,v.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,f){if(!h.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let v=t.get(f);return v||(v=new E.$4c,t.set(f,v)),(b,g,y)=>{if(h.isInitialized)return h.value[f](b,g,y);{const L={listener:[b,g,y],disposable:void 0},T=v.push(L);return(0,d.$Rc)(()=>{T(),L.disposable?.dispose()})}}}if(f in s)return s[f];const l=h.value;let u=l[f];return typeof u!="function"||(u=u.bind(l),s[f]=u),u},set(s,f,l){return h.value[f]=l,!0},getPrototypeOf(s){return a.prototype}})}else return this.j(a,i,n)}u(m,a){if(a&&console.warn(m),this.g)throw new Error(m)}}e.$Gq=p;var k;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(k||(k={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,a){return m?new S(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(m,a){return m?new S(1,a.name):S.c}static{this.f=0}constructor(m,a){this.type=m,this.name=a,this.g=Date.now(),this.h=[]}branch(m,a){const i=new S(3,m.toString());return this.h.push([m,a,i]),i}stop(){const m=Date.now()-this.g;S.f+=m;let a=!1;function i(n,o){const t=[],h=new Array(n+1).join("	");for(const[s,f,l]of o.h)if(f&&l){a=!0,t.push(`${h}CREATES -> ${s}`);const u=i(n+1,l);u&&t.push(u)}else t.push(`${h}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(m>2||a)&&S.all.add(r.join(`
`))}}e.$Hq=S}),define(ke[12],Se([1,0,44,4,54,3,28,11,23,18,2,45,5]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,p.$8h)("logService"),e.$qj=(0,p.$8h)("loggerService");function k(){return new Date().toISOString()}function S(b){return(0,E.$Nf)(b)}e.$rj=S;var c;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$sj=c.Info;function m(b,g,y){switch(g){case c.Trace:b.trace(y);break;case c.Debug:b.debug(y);break;case c.Info:b.info(y);break;case c.Warning:b.warn(y);break;case c.Error:b.error(y);break;case c.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=m;function a(b,g=!1){let y="";for(let L=0;L<b.length;L++){let T=b[L];if(T instanceof Error&&(T=(0,D.$Si)(T,g)),typeof T=="object")try{T=JSON.stringify(T)}catch{}y+=(L>0?" ":"")+T}return y}class i extends P.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new M.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==c.Off&&this.b<=g}}e.$uj=i;class r extends i{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...y){this.f(c.Trace)&&this.g(c.Trace,a([g,...y],!0))}debug(g,...y){this.f(c.Debug)&&this.g(c.Debug,a([g,...y]))}info(g,...y){this.f(c.Info)&&this.g(c.Info,a([g,...y]))}warn(g,...y){this.f(c.Warning)&&this.g(c.Warning,a([g,...y]))}error(g,...y){if(this.f(c.Error))if(g instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=g.stack,this.g(c.Error,a(L))}else this.g(c.Error,a([g,...y]))}flush(){}}e.$vj=r;class n extends i{constructor(g=e.$sj){super(),this.setLevel(g),this.g=!w.$i}trace(g,...y){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,g,...y):console.log(`[main ${k()}]`,g,...y))}debug(g,...y){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,g,...y):console.log(`[main ${k()}]`,g,...y))}info(g,...y){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,g,...y):console.log(`[main ${k()}]`,g,...y))}warn(g,...y){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,g,...y):console.warn(`[main ${k()}]`,g,...y))}error(g,...y){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,g,...y):console.error(`[main ${k()}]`,g,...y))}flush(){}}e.$wj=n;class o extends i{constructor(g=e.$sj,y=!0){super(),this.g=y,this.setLevel(g)}trace(g,...y){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...y):console.log(g,...y))}debug(g,...y){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...y):console.log(g,...y))}info(g,...y){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...y):console.log(g,...y))}warn(g,...y){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...y):console.log(g,...y))}error(g,...y){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...y):console.error(g,...y))}flush(){}}e.$xj=o;class t extends i{constructor(g,y=e.$sj){super(),this.g=g,this.setLevel(y)}trace(g,...y){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(g),...y])}debug(g,...y){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(g),...y])}info(g,...y){this.f(c.Info)&&this.g.log(c.Info,[this.h(g),...y])}warn(g,...y){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(g),...y])}error(g,...y){this.f(c.Error)&&this.g.log(c.Error,[this.h(g),...y])}h(g){return typeof g=="string"?g:(0,D.$Si)(g,this.f(c.Trace))}flush(){}}e.$yj=t;class h extends i{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const y of this.g)y.setLevel(g);super.setLevel(g)}trace(g,...y){for(const L of this.g)L.trace(g,...y)}debug(g,...y){for(const L of this.g)L.debug(g,...y)}info(g,...y){for(const L of this.g)L.info(g,...y)}warn(g,...y){for(const L of this.g)L.warn(g,...y)}error(g,...y){for(const L of this.g)L.error(g,...y)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose();super.dispose()}}e.$zj=h;class s extends P.$Tc{constructor(g,y,L){if(super(),this.h=g,this.j=y,this.b=new A.$Ac,this.c=this.B(new M.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Wd),this.onDidChangeVisibility=this.g.event,L)for(const T of L)this.b.set(T.resource,{logger:void 0,info:T})}m(g){return(0,E.$Jf)(g)?[...this.b.values()].find(y=>y.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,y){const L=this.n(g),T=(0,E.$Jf)(g)?g:y?.id??(0,d.$Vi)(L.toString()).toString(16);let U=this.b.get(L)?.logger;const j=y?.logLevel==="always"?c.Trace:y?.logLevel;U||(U=this.s(L,j??this.getLogLevel(L)??this.h,{...y,id:T}));const F={logger:U,info:{resource:L,id:T,logLevel:j,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(F.info),this.b.set(L,F),U}n(g){return(0,E.$Jf)(g)?(0,$.$Ig)(this.j,`${g}.log`):g}setLogLevel(g,y){if(R.URI.isUri(g)){const L=g,T=y,U=this.b.get(L);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([L,T]))}else{this.h=g;for(const[L,T]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,y){const L=this.m(g);L&&y!==!L.info.hidden&&(L.info.hidden=!y,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,y]))}getLogLevel(g){let y;return g&&(y=this.b.get(g)?.info.logLevel),y??this.h}registerLogger(g){const y=this.b.get(g.resource);y?y.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const y=this.b.get(g);y&&(y.logger&&y.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=s;class f{constructor(){this.onDidChangeLogLevel=new M.$Wd().event}setLevel(g){}getLevel(){return c.Info}trace(g,...y){}debug(g,...y){}info(g,...y){}warn(g,...y){}error(g,...y){}critical(g,...y){}dispose(){}flush(){}}e.$Bj=f;class l extends f{}e.$Cj=l;function u(b){if(b.verbose)return c.Trace;if(typeof b.logLevel=="string"){const g=I(b.logLevel.toLowerCase());if(g!==void 0)return g}return e.$sj}e.$Dj=u;function v(b){switch(b){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$Ej=v;function I(b){switch(b){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$Fj=I,e.$Gj=new C.$mj("logLevel",v(c.Info))}),define(ke[248],Se([1,0,19,8,14,4,3,17,85,12]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class R extends A.$Tc{constructor(p,k){super(),this.a=p,this.b=k,this.c=this.B(new P.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new M.$6g(0)),this.w=[],this.y=this.B(new M.$6g(0))}watch(p,k){return k.recursive||this.b?.watcher?.forceUniversal?this.n(p,k):this.z(p,k)}n(p,k){const S={path:this.H(p),excludes:k.excludes,includes:k.includes,recursive:k.recursive,correlationId:k.correlationId},c=(0,D.$Ub)(this.j,S);return this.r(),(0,A.$Rc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,d.$1)(p))}s(){this.h||(this.h=this.B(this.t(k=>this.c.fire((0,$.$jq)(k)),k=>this.G(k),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const k of this.j)(0,$.$fq)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const k of this.j)(0,$.$fq)(k)&&p.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,k){const S={path:this.H(p),excludes:k.excludes,includes:k.includes,recursive:!1,correlationId:k.correlationId},c=(0,D.$Ub)(this.w,S);return this.C(),(0,A.$Rc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,d.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,$.$jq)(p)),p=>this.G(p),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,w.$hc)(p.fsPath)}}e.$nq=R}),define(ke[249],Se([1,0,57,388,8,28,21,4,34,3,17,11,23,98,31,205,32,242,248,44,246,245]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,M.gracefulify)(D)}catch(h){console.error(`Error enabling graceful-fs: ${(0,r.$Si)(h)}`)}})();class t extends i.$nq{static{this.I=!1}constructor(s,f){super(s,f),this.onDidChangeCapabilities=w.Event.None,this.N=new P.$Ac(l=>p.$zg.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:f,symbolicLink:l}=await S.SymlinkSupport.stat(this.H(s));return{type:this.M(f,l),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size,permissions:f.mode&128?void 0:m.FilePermission.Locked}}catch(f){throw this.fb(f)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const f=await S.Promises.readdir(this.H(s),{withFileTypes:!0}),l=[];return await Promise.all(f.map(async u=>{try{let v;u.isSymbolicLink()?v=(await this.stat((0,p.$Ig)(s,u.name))).type:v=this.M(u),l.push([u.name,v])}catch(v){this.a.trace(v)}})),l}catch(f){throw this.fb(f)}}M(s,f){let l;return f?.dangling?l=m.FileType.Unknown:s.isFile()?l=m.FileType.File:s.isDirectory()?l=m.FileType.Directory:l=m.FileType.Unknown,f&&(l|=m.FileType.SymbolicLink),l}async O(s){const f=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${f})`);let l;for(;l=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${f})`),await l.wait();const u=new d.$7g;return this.N.set(s,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${f})`),(0,E.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${f})`),this.N.get(s)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${f})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${f})`),u.open()})}async readFile(s,f){let l;try{f?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),l=await this.O(s));const u=this.H(s);return await S.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{l?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,f,l){const u=(0,k.$$d)(v=>A.$ke.concat(v.map(I=>A.$ke.wrap(I))).buffer);return(0,a.$dq)(this,s,u,v=>v.buffer,{...f,bufferSize:256*1024},l),u}async writeFile(s,f,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,p.$Ig)((0,p.$Hg)(s),`${(0,p.$Fg)(s)}${l.atomic.postfix}`),f,l):this.S(s,f,l)}async Q(s){try{const f=this.H(s),{symbolicLink:l}=await S.SymlinkSupport.stat(f);if(l)return!1}catch{}return!0}async R(s,f,l,u){const v=new E.$Sc;try{v.add(await this.O(s)),v.add(await this.O(f)),await this.S(f,l,u,!0);try{await this.rename(f,s,{overwrite:!0})}catch(I){try{await this.delete(f,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{v.dispose()}}async S(s,f,l,u){let v;try{const I=this.H(s);if(!l.create||!l.overwrite){if(await S.Promises.exists(I)){if(!l.overwrite)throw(0,m.$Fk)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,m.$Fk)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(s,{create:!0,unlock:l.unlock},u),await this.write(v,0,f,0,f.byteLength)}catch(I){throw await this.gb(s,I)}finally{typeof v=="number"&&await this.close(v)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,f,l){const u=this.H(s);let v;(0,m.$tk)(f)&&!l&&(v=await this.O(s));let I;try{if((0,m.$tk)(f)&&f.unlock)try{const{stat:g}=await S.SymlinkSupport.stat(u);g.mode&128||await S.Promises.chmod(u,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let b;if((0,m.$tk)(f)){if(C.$i)try{await S.Promises.truncate(u,0),b="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}b||(b="w")}else b="r";I=await S.Promises.open(u,b)}catch(b){throw v?.dispose(),(0,m.$tk)(f)?await this.gb(s,b):this.fb(b)}if(this.U.set(I,0),(0,m.$tk)(f)&&this.X.set(I,s),v){const b=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${u})`),this.W.set(I,v),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${u})`),b.dispose())}return I}async close(s){const f=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await S.Promises.fdatasync(s)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await S.Promises.close(s)}catch(l){throw this.fb(l)}finally{f&&(this.W.get(s)===f&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),f.dispose())}}async read(s,f,l,u,v){const I=this.Z(s,f);let b=null;try{b=(await S.Promises.read(s,l,u,v,I)).bytesRead}catch(g){throw this.fb(g)}finally{this.$(s,I,b)}return b}Z(s,f){return f===this.U.get(s)?null:f}$(s,f,l){const u=this.U.get(s);typeof u=="number"&&(typeof f=="number"||(typeof l=="number"?this.U.set(s,u+l):this.U.delete(s)))}async write(s,f,l,u,v){return(0,d.$ph)(()=>this.ab(s,f,l,u,v),100,3)}async ab(s,f,l,u,v){const I=this.Z(s,f);let b=null;try{b=(await S.Promises.write(s,l,u,v,I)).bytesWritten}catch(g){throw await this.gb(this.X.get(s),g)}finally{this.$(s,I,b)}return b}async mkdir(s){try{await S.Promises.mkdir(this.H(s))}catch(f){throw this.fb(f)}}async delete(s,f){try{const l=this.H(s);if(f.recursive){let u;f?.atomic!==!1&&f.atomic.postfix&&(u=(0,R.$jc)((0,R.$mc)(l),`${(0,R.$nc)(l)}${f.atomic.postfix}`)),await S.Promises.rm(l,S.RimRafMode.MOVE,u)}else try{await S.Promises.unlink(l)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let v=!1;try{const{stat:I,symbolicLink:b}=await S.SymlinkSupport.stat(l);v=I.isDirectory()&&!b}catch{}if(v)await S.Promises.rmdir(l);else throw u}else throw u}}catch(l){throw this.fb(l)}}async rename(s,f,l){const u=this.H(s),v=this.H(f);if(u!==v)try{await this.bb(s,f,"move",l.overwrite),await S.Promises.rename(u,v)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,c.localize)(2,null,(0,R.$nc)(u),(0,R.$nc)((0,R.$mc)(v)),I.toString()))),this.fb(I)}}async copy(s,f,l){const u=this.H(s),v=this.H(f);if(u!==v)try{await this.bb(s,f,"copy",l.overwrite),await S.Promises.copy(u,v,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,c.localize)(3,null,(0,R.$nc)(u),(0,R.$nc)((0,R.$mc)(v)),I.toString()))),this.fb(I)}}async bb(s,f,l,u){const v=this.H(s),I=this.H(f);let b=!1;if(!!(this.capabilities&1024)||(b=(0,$.$8f)(v,I,!0)),b){if(l==="copy")throw(0,m.$Fk)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const y=await this.L(s);if(!y)throw(0,m.$Fk)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(f);if(L){if(!u)throw(0,m.$Fk)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&L.type&m.FileType.File||await this.delete(f,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,f){return this.cb(s,f,!1)}async cb(s,f,l){const u=this.H(s),v=this.H(f),I=!!(this.capabilities&1024);if((0,$.$8f)(u,v,!I))return;const b=new E.$Sc;try{b.add(await this.O(s)),b.add(await this.O(f)),l&&await S.Promises.mkdir((0,R.$mc)(v),{recursive:!0}),await S.Promises.copyFile(u,v)}catch(g){if(g.code==="ENOENT"&&!l)return this.cb(s,f,!0);throw this.fb(g)}finally{b.dispose()}}t(s,f,l){return new n.$uq(u=>s(u),u=>f(u),l)}F(s,f,l){return new o.$Cq(u=>s(u),u=>f(u),l)}fb(s){if(s instanceof m.$Ek)return s;let f=s,l;switch(s.code){case"ENOENT":l=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":f=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=m.FileSystemProviderErrorCode.Unknown;break;default:l=m.FileSystemProviderErrorCode.Unknown}return(0,m.$Fk)(f,l)}async gb(s,f){let l=this.fb(f);if(s&&l.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await S.SymlinkSupport.stat(this.H(s));u.mode&128||(l=(0,m.$Fk)(f,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return l}}e.$Dq=t}),define(ke[250],Se([1,0,3,12]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=void 0;class d extends D.$Tc{constructor(A,w=[]){super(),this.a=new M.$zj([A,...w]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...w){this.a.trace(A,...w)}debug(A,...w){this.a.debug(A,...w)}info(A,...w){this.a.info(A,...w)}warn(A,...w){this.a.warn(A,...w)}error(A,...w){this.a.error(A,...w)}flush(){this.a.flush()}}e.$MO=d}),define(ke[251],Se([1,0,32,12]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;var d;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(d||(d={}));async function P(E,R,C,p,k){try{const S=await new Promise((m,a)=>{$e(["@vscode/spdlog"],m,a)});S.setFlushOn(d.Trace);const c=await S.createAsyncRotatingLogger(E,R,C,p);return k?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(S){console.error(S)}return null}function A(E,R,C){switch(R){case M.LogLevel.Trace:E.trace(C);break;case M.LogLevel.Debug:E.debug(C);break;case M.LogLevel.Info:E.info(C);break;case M.LogLevel.Warning:E.warn(C);break;case M.LogLevel.Error:E.error(C);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function w(E,R){switch(R){case M.LogLevel.Trace:E.setLevel(d.Trace);break;case M.LogLevel.Debug:E.setLevel(d.Debug);break;case M.LogLevel.Info:E.setLevel(d.Info);break;case M.LogLevel.Warning:E.setLevel(d.Warning);break;case M.LogLevel.Error:E.setLevel(d.Error);break;case M.LogLevel.Off:E.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class $ extends M.$vj{constructor(R,C,p,k,S){super(),this.m=[],this.setLevel(S),this.n=this.s(R,C,p,k),this.B(this.onDidChangeLogLevel(c=>{this.r&&w(this.r,c)}))}async s(R,C,p,k){const S=p?6:1,c=30/S*D.$1k.MB,m=await P(R,C,c,S,k);if(m){this.r=m,w(this.r,this.getLevel());for(const{level:a,message:i}of this.m)A(this.r,a,i);this.m=[]}}g(R,C){this.r?A(this.r,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$BO=$}),define(ke[135],Se([1,0,39,206,5]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function E(S,c){return c-S}$.compare=E;const R=Object.create(null);R[$.Error]=(0,M.localize)(0,null),R[$.Warning]=(0,M.localize)(1,null),R[$.Info]=(0,M.localize)(2,null);function C(S){return R[S]||""}$.toString=C;function p(S){switch(S){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=p;function k(S){switch(S){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=k}(A||(e.MarkerSeverity=A={}));var w;(function($){const E="";function R(p){return C(p,!0)}$.makeKey=R;function C(p,k){const S=[E];return p.source?S.push(p.source.replace("\xA6","\\\xA6")):S.push(E),p.code?typeof p.code=="string"?S.push(p.code.replace("\xA6","\\\xA6")):S.push(p.code.value.replace("\xA6","\\\xA6")):S.push(E),p.severity!==void 0&&p.severity!==null?S.push(A.toString(p.severity)):S.push(E),p.message&&k?S.push(p.message.replace("\xA6","\\\xA6")):S.push(E),p.startLineNumber!==void 0&&p.startLineNumber!==null?S.push(p.startLineNumber.toString()):S.push(E),p.startColumn!==void 0&&p.startColumn!==null?S.push(p.startColumn.toString()):S.push(E),p.endLineNumber!==void 0&&p.endLineNumber!==null?S.push(p.endLineNumber.toString()):S.push(E),p.endColumn!==void 0&&p.endColumn!==null?S.push(p.endColumn.toString()):S.push(E),S.push(E),S.join("\xA6")}$.makeKeyOptionalMessage=C})(w||(e.IMarkerData=w={})),e.$Ct=(0,d.$8h)("markerService")}),define(ke[252],Se([1,0,4,39,5]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.NotificationsFilter=e.$sv=e.NeverShowAgainScope=e.NotificationPriority=e.$rv=e.Severity=void 0,e.Severity=M.default,e.$rv=(0,d.$8h)("notificationService");var P;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function w(C){if(C){const p=C;return typeof p.id=="string"&&typeof p.label=="string"}return!1}e.$sv=w;var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new R,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$tv=E;class R{infinite(){}done(){}total(p){}worked(p){}}e.$uv=R}),define(ke[253],Se([1,0,49]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;const d=globalThis.vscode;if(typeof d<"u"&&typeof d.context<"u"){const P=d.context.configuration();if(P)M=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(M=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),!M.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(M,{version:P.version})}}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(ke[136],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,D.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function($e,e){return function(D,M){e(D,M,$e)}};define(ke[107],Se([1,0,8,22,3,5]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.ProgressLocation=e.$vv=void 0,e.$vv=(0,P.$8h)("progressService");var A;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$wv=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$xv=w;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const k=this.d;this.d=()=>{k?.(),p()}}):Promise.resolve()}}e.$yv=$;let E=class extends d.$Tc{constructor(p,k){super(),this.a=new D.$sh,k.withProgress(p,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,d.$Rc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$zv=E,e.$zv=E=Ge([Ve(1,e.$vv)],E);class R extends d.$Tc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new d.$Sc)}start(p){this.stop();const k=++this.a,S=new M.$7d;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,d.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,d.$Rc)(()=>S.cancel())),this.b.add((0,d.$Rc)(()=>this.c?this.c.done():void 0)),{id:k,token:S.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$Av=R,e.$Bv=(0,P.$8h)("editorProgressService")}),define(ke[37],Se([1,0,61,18]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class d{constructor(){this.a=new Map}add(A,w){D.ok(M.$Jf(A)),D.ok(M.$Lf(w)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,w)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Kn=new d}),define(ke[108],Se([1,0,4,37]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function d(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class P{constructor(){this.b=new D.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,E){this.a[d($)]=E,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new P;M.$Kn.add(e.$Ln.JSONContribution,A)}),define(ke[86],Se([1,0,19,4,18,196,51,108,37]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var E;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$Pn={Configuration:"base.contributions.configuration"};var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const C=$.$Kn.as(w.$Ln.JSONContribution);class p{constructor(){this.h=new Set,this.i=new M.$Wd,this.onDidSchemaChange=this.i.event,this.j=new M.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const s=new Set;this.n(t,h,s),C.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const h=new Set;this.o(t,h),C.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:t,remove:h}){const s=new Set;this.o(h,s),this.n(t,!1,s),C.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const h=new Set;this.k(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(t,h){const s=[];for(const{overrides:f,source:l}of t)for(const u in f)if(h.add(u),e.$Zn.test(u)){const v=this.a.get(u),I=v?.valuesSources??new Map;if(l)for(const L of Object.keys(f[u]))I.set(L,l);const b={...v?.value||{},...f[u]};this.a.set(u,{source:l,value:b,valuesSources:I});const g=(0,A.$Li)(u),y={type:"object",default:b,description:P.localize(1,null,g),$ref:e.$Wn,defaultDefaultValue:b,source:d.$Jf(l)?void 0:l,defaultValueSource:l};s.push(...c(u)),this.d[u]=y,this.b.properties[u]=y}else{this.a.set(u,{value:f[u],source:l});const v=this.d[u];v&&(this.w(u,v),this.r(u,v))}this.m(s)}deregisterDefaultConfigurations(t){const h=new Set;this.l(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(t,h){for(const{overrides:s,source:f}of t)for(const l in s){const u=this.a.get(l),v=d.$Jf(f)?f:f?.id,I=d.$Jf(u?.source)?u?.source:u?.source?.id;if(v===I)if(h.add(l),this.a.delete(l),e.$Zn.test(l))delete this.d[l],delete this.b.properties[l];else{const b=this.d[l];b&&(this.w(l,b),this.r(l,b))}}this.u()}deltaConfiguration(t){let h=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),h=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),h=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const h of t)this.h.add(h);this.u()}n(t,h,s){t.forEach(f=>{this.p(f,h,f.extensionInfo,f.restrictedProperties,void 0,s),this.c.push(f),this.q(f)})}o(t,h){const s=f=>{if(f.properties)for(const l in f.properties){h.add(l);const u=this.d[l];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[l],this.s(l,f.properties[l])}f.allOf?.forEach(l=>s(l))};for(const f of t){s(f);const l=this.c.indexOf(f);l!==-1&&this.c.splice(l,1)}}p(t,h=!0,s,f,l=3,u){l=d.$Sf(t.scope)?l:t.scope;const v=t.properties;if(v)for(const b in v){const g=v[b];if(h&&r(b,g)){delete v[b];continue}if(g.source=s,g.defaultDefaultValue=v[b].default,this.w(b,g),e.$Zn.test(b)?g.scope=void 0:(g.scope=d.$Sf(g.scope)?l:g.scope,g.restricted=d.$Sf(g.restricted)?!!f?.includes(b):g.restricted),v[b].hasOwnProperty("included")&&!v[b].included){this.f[b]=v[b],delete v[b];continue}else this.d[b]=v[b],v[b].policy?.name&&this.e.set(v[b].policy.name,b);!v[b].deprecationMessage&&v[b].markdownDeprecationMessage&&(v[b].deprecationMessage=v[b].markdownDeprecationMessage),u.add(b)}const I=t.allOf;if(I)for(const b of I)this.p(b,h,s,f,l,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const h=s=>{const f=s.properties;if(f)for(const u in f)this.r(u,f[u]);s.allOf?.forEach(h)};h(t)}r(t,h){switch(e.$Qn.properties[t]=h,h.scope){case 1:e.$Rn.properties[t]=h;break;case 2:e.$Sn.properties[t]=h;break;case 6:e.$Tn.properties[t]=h;break;case 3:e.$Un.properties[t]=h;break;case 4:e.$Vn.properties[t]=h;break;case 5:e.$Vn.properties[t]=h,this.g.properties[t]=h;break}}s(t,h){switch(delete e.$Qn.properties[t],h.scope){case 1:delete e.$Rn.properties[t];break;case 2:delete e.$Sn.properties[t];break;case 6:delete e.$Tn.properties[t];break;case 3:delete e.$Un.properties[t];break;case 4:case 5:delete e.$Vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const h=`[${t}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Wn};this.w(h,s),e.$Qn.properties[h]=s,e.$Rn.properties[h]=s,e.$Sn.properties[h]=s,e.$Tn.properties[h]=s,e.$Un.properties[h]=s,e.$Vn.properties[h]=s}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=t,e.$Rn.patternProperties[e.$Yn]=t,e.$Sn.patternProperties[e.$Yn]=t,e.$Tn.patternProperties[e.$Yn]=t,e.$Un.patternProperties[e.$Yn]=t,e.$Vn.patternProperties[e.$Yn]=t,this.i.fire()}w(t,h){const s=this.a.get(t);let f=s?.value,l=s?.source;d.$Qf(f)&&(f=h.defaultDefaultValue,l=void 0),d.$Qf(f)&&(f=a(h.type)),h.default=f,h.defaultValueSource=l}}const k="\\[([^\\]]+)\\]",S=new RegExp(k,"g");e.$Yn=`^(${k})+$`,e.$Zn=new RegExp(e.$Yn);function c(o){const t=[];if(e.$Zn.test(o)){let h=S.exec(o);for(;h?.length;){const s=h[1].trim();s&&t.push(s),h=S.exec(o)}}return(0,D.$Mb)(t)}e.$1n=c;function m(o){return o.reduce((t,h)=>`${t}[${h}]`,"")}e.$2n=m;function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=a;const i=new p;$.$Kn.add(e.$Pn.Configuration,i);function r(o,t){return o.trim()?e.$Zn.test(o)?P.localize(7,null,o):i.getConfigurationProperties()[o]!==void 0?P.localize(8,null,o):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,o,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$4n=r;function n(){const o=[],t=i.getConfigurationProperties();for(const h of Object.keys(t))o.push([h,t[h].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.$5n=n}),define(ke[254],Se([1,0,19,4,159,3,28,24,18,2,51,86,37]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function k(h){return Object.isFrozen(h)?h:w.$zn(h)}class S{constructor(s={},f=[],l=[],u){this.b=s,this.c=f,this.d=l,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(f=>{if(f instanceof S)return f;const l=new c("");return l.parseRaw(f),l.configurationModel});this.f=s.reduce((f,l)=>l===f?l:f.merge(l),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$Ji)(this.contents,s):this.contents}inspect(s,f){const l=this;return{get value(){return k(l.rawConfiguration.getValue(s))},get override(){return f?k(l.rawConfiguration.getOverrideValue(s,f)):void 0},get merged(){return k(f?l.rawConfiguration.override(f).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const u=[];for(const{contents:v,identifiers:I,keys:b}of l.rawConfiguration.overrides){const g=new S(v,b).getValue(s);g!==void 0&&u.push({identifiers:I,value:g})}return u.length?k(u):void 0}}}getOverrideValue(s,f){const l=this.i(f);return l?s?(0,R.$Ji)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const f=[];for(const l of this.overrides)l.identifiers.includes(s)&&f.push(...l.keys);return D.$Mb(f)}getAllOverrideIdentifiers(){const s=[];for(const f of this.overrides)s.push(...f.identifiers);return D.$Mb(s)}override(s){let f=this.a.get(s);return f||(f=this.g(s),this.a.set(s,f)),f}merge(...s){const f=w.$yn(this.contents),l=w.$yn(this.overrides),u=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const I of s)if(v.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(f,I.contents);for(const b of I.overrides){const[g]=l.filter(y=>D.$ub(y.identifiers,b.identifiers));g?(this.h(g.contents,b.contents),g.keys.push(...b.keys),g.keys=D.$Mb(g.keys)):l.push(w.$yn(b))}for(const b of I.keys)u.indexOf(b)===-1&&u.push(b)}return new S(f,u,l,v.every(I=>I instanceof S)?void 0:v)}g(s){const f=this.i(s);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const l={};for(const u of D.$Mb([...Object.keys(this.contents),...Object.keys(f)])){let v=this.contents[u];const I=f[u];I&&(typeof v=="object"&&typeof I=="object"?(v=w.$yn(v),this.h(v,I)):v=I),l[u]=v}return new S(l,this.keys,this.overrides)}h(s,f){for(const l of Object.keys(f)){if(l in s&&$.$Lf(s[l])&&$.$Lf(f[l])){this.h(s[l],f[l]);continue}s[l]=w.$yn(f[l])}}i(s){let f=null,l=null;const u=v=>{v&&(l?this.h(l,v):l=w.$yn(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===s?f=v.contents:v.identifiers.includes(s)&&u(v.contents);return u(f),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,f){this.j(s,f,!0)}setValue(s,f){this.j(s,f,!1)}removeValue(s){const f=this.keys.indexOf(s);f!==-1&&(this.keys.splice(f,1),(0,R.$Ii)(this.contents,s),C.$Zn.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>D.$ub(l.identifiers,(0,C.$1n)(s))),1))}j(s,f,l){(0,R.$Hi)(this.contents,s,f,u=>console.error(u)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),C.$Zn.test(s)&&this.overrides.push({identifiers:(0,C.$1n)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$Gi)(this.contents[s],u=>console.error(u))})}}e.$6n=S;class c{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,f){if(!$.$Sf(s)){const l=this.g(s);this.parseRaw(l,f)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,f){this.a=s;const{contents:l,keys:u,overrides:v,restricted:I,hasExcludedProperties:b}=this.h(s,f);this.b=new S(l,u,v,b?[s]:void 0),this.c=I||[]}g(s){let f={},l=null,u=[];const v=[],I=[];function b(y){Array.isArray(u)?u.push(y):l!==null&&(u[l]=y)}const g={onObjectBegin:()=>{const y={};b(y),v.push(u),u=y,l=null},onObjectProperty:y=>{l=y},onObjectEnd:()=>{u=v.pop()},onArrayBegin:()=>{const y=[];b(y),v.push(u),u=y,l=null},onArrayEnd:()=>{u=v.pop()},onLiteralValue:b,onError:(y,L,T)=>{I.push({error:y,offset:L,length:T})}};if(s)try{d.$mn(s,g),f=u[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return f}h(s,f){const l=p.$Kn.as(C.$Pn.Configuration).getConfigurationProperties(),u=this.i(s,l,!0,f);s=u.raw;const v=(0,R.$Gi)(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),I=Object.keys(s),b=this.j(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:v,keys:I,overrides:b,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(s,f,l,u){let v=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:v};const I={},b=[];for(const g in s)if(C.$Zn.test(g)&&l){const y=this.i(s[g],f,!1,u);I[g]=y.raw,v=v||y.hasExcludedProperties,b.push(...y.restricted)}else{const y=f[g],L=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&b.push(g),!u.exclude?.includes(g)&&(u.include?.includes(g)||(L===void 0||u.scopes===void 0||u.scopes.includes(L))&&!(u.skipRestricted&&y?.restricted))?I[g]=s[g]:v=!0}return{raw:I,restricted:b,hasExcludedProperties:v}}j(s,f){const l=[];for(const u of Object.keys(s))if(C.$Zn.test(u)){const v={};for(const I in s[u])v[I]=s[u][I];l.push({identifiers:(0,C.$1n)(u),keys:Object.keys(v),contents:(0,R.$Gi)(v,f)})}return l}}e.$7n=c;class m extends P.$Tc{constructor(s,f,l,u){super(),this.c=s,this.f=f,this.g=u,this.b=this.B(new M.$Wd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&l.isEqual(v.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=m;class a{constructor(s,f,l,u,v,I,b,g,y,L,T,U,j){this.a=s,this.b=f,this.c=l,this.overrideIdentifiers=u,this.d=v,this.f=I,this.g=b,this.h=g,this.i=y,this.j=L,this.k=T,this.l=U,this.m=j}get value(){return k(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(s,f,l,u,v=new S,I=new S,b=new A.$Ac,g=new S,y=new A.$Ac){this.c=s,this.d=f,this.f=l,this.g=u,this.h=v,this.i=I,this.j=b,this.l=g,this.m=y,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,f,l){return this.p(s,f,l).getValue(s)}updateValue(s,f,l={}){let u;l.resource?(u=this.m.get(l.resource),u||(u=new S,this.m.set(l.resource,u))):u=this.l,f===void 0?u.removeValue(s):u.setValue(s,f),l.resource||(this.a=null)}inspect(s,f,l){const u=this.p(s,f,l),v=this.t(f.resource,l),I=f.resource?this.m.get(f.resource)||this.l:this.l,b=new Set;for(const g of u.overrides)for(const y of g.identifiers)u.getOverrideValue(s,y)!==void 0&&b.add(y);return new a(s,f,u.getValue(s),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,v||void 0,I)}keys(s){const f=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,f){this.j.set(s,f),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,f){const l=[];if(!f){const{added:u,updated:v,removed:I}=o(this.c,s);f=[...u,...v,...I]}for(const u of f)for(const v of(0,C.$1n)(u)){const I=this.c.getKeysForOverrideIdentifier(v),b=s.getKeysForOverrideIdentifier(v),g=[...b.filter(y=>I.indexOf(y)===-1),...I.filter(y=>b.indexOf(y)===-1),...I.filter(y=>!w.$Cn(this.c.override(v).getValue(y),s.override(v).getValue(y)))];l.push([v,g])}return this.updateDefaultConfiguration(s),{keys:f,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:f,updated:l,removed:u}=o(this.d,s),v=[...f,...l,...u];return v.length&&this.updatePolicyConfiguration(s),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:f,updated:l,removed:u,overrides:v}=o(this.applicationConfiguration,s),I=[...f,...l,...u];return I.length&&this.updateApplicationConfiguration(s),{keys:I,overrides:v}}compareAndUpdateLocalUserConfiguration(s){const{added:f,updated:l,removed:u,overrides:v}=o(this.localUserConfiguration,s),I=[...f,...l,...u];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:v}}compareAndUpdateRemoteUserConfiguration(s){const{added:f,updated:l,removed:u,overrides:v}=o(this.remoteUserConfiguration,s),I=[...f,...l,...u];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:v}}compareAndUpdateWorkspaceConfiguration(s){const{added:f,updated:l,removed:u,overrides:v}=o(this.workspaceConfiguration,s),I=[...f,...l,...u];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:v}}compareAndUpdateFolderConfiguration(s,f){const l=this.folderConfigurations.get(s),{added:u,updated:v,removed:I,overrides:b}=o(l,f),g=[...u,...v,...I];return(g.length||!l)&&this.updateFolderConfiguration(s,f),{keys:g,overrides:b}}compareAndDeleteFolderConfiguration(s){const f=this.folderConfigurations.get(s);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:u,removed:v,overrides:I}=o(f,void 0);return{keys:[...l,...u,...v],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,f,l){let u=this.q(f,l);return f.overrideIdentifier&&(u=u.override(f.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(u=u.merge(this.d)),u}q({resource:s},f){let l=this.r();if(f&&s){const u=f.getFolder(s);u&&(l=this.s(u.uri)||l);const v=this.m.get(s);v&&(l=l.merge(v))}return l}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let f=this.b.get(s);if(!f){const l=this.r(),u=this.j.get(s);u?(f=l.merge(u),this.b.set(s,f)):f=l}return f}t(s,f){if(f&&s){const l=f.getFolder(s);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,f)=>{const{contents:l,overrides:u,keys:v}=this.j.get(f);return s.push([f,{contents:l,overrides:u,keys:v}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(f=>s.add(f)),this.userConfiguration.keys.forEach(f=>s.add(f)),this.i.keys.forEach(f=>s.add(f)),this.j.forEach(f=>f.keys.forEach(l=>s.add(l))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(f=>s.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>s.add(f)),this.i.getAllOverrideIdentifiers().forEach(f=>s.add(f)),this.j.forEach(f=>f.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}v(s){const f=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(l=>f.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>f.add(l)),this.i.getKeysForOverrideIdentifier(s).forEach(l=>f.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(u=>f.add(u))),[...f.values()]}static parse(s){const f=this.w(s.defaults),l=this.w(s.policy),u=this.w(s.application),v=this.w(s.user),I=this.w(s.workspace),b=s.folders.reduce((g,y)=>(g.set(E.URI.revive(y[0]),this.w(y[1])),g),new A.$Ac);return new i(f,l,u,v,new S,I,b,new S,new A.$Ac)}static w(s){return new S(s.contents,s.keys,s.overrides)}}e.$9n=i;function r(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const s=new Set,f=new Map;for(const u of h)u.keys.forEach(v=>s.add(v)),u.overrides.forEach(([v,I])=>{const b=(0,A.$xc)(f,v,new Set);I.forEach(g=>b.add(g))});const l=[];return f.forEach((u,v)=>l.push([v,[...u.values()]])),{keys:[...s.values()],overrides:l}}e.$0n=r;class n{constructor(s,f,l,u){this.change=s,this.f=f,this.g=l,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const v of s.keys)this.affectedKeys.add(v);for(const[,v]of s.overrides)for(const I of v)this.affectedKeys.add(I);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(s,f){const l=this.a+s,u=this.d.indexOf(l);if(u<0)return!1;const v=u+l.length;if(v>=this.d.length)return!1;const I=this.d.charCodeAt(v);if(I!==this.b&&I!==this.c)return!1;if(f){const b=this.previousConfiguration?this.previousConfiguration.getValue(s,f,this.f?.workspace):void 0,g=this.g.getValue(s,f,this.h);return!w.$Cn(b,g)}return!0}}e.$$n=n;function o(h,s){const{added:f,removed:l,updated:u}=t(s?.rawConfiguration,h?.rawConfiguration),v=[],I=h?.getAllOverrideIdentifiers()||[],b=s?.getAllOverrideIdentifiers()||[];if(s){const g=b.filter(y=>!I.includes(y));for(const y of g)v.push([y,s.getKeysForOverrideIdentifier(y)])}if(h){const g=I.filter(y=>!b.includes(y));for(const y of g)v.push([y,h.getKeysForOverrideIdentifier(y)])}if(s&&h){for(const g of I)if(b.includes(g)){const y=t({contents:h.getOverrideValue(void 0,g)||{},keys:h.getKeysForOverrideIdentifier(g)},{contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)});v.push([g,[...y.added,...y.removed,...y.updated]])}}return{added:f,removed:l,updated:u,overrides:v}}function t(h,s){const f=h?s?h.keys.filter(v=>s.keys.indexOf(v)===-1):[...h.keys]:[],l=s?h?s.keys.filter(v=>h.keys.indexOf(v)===-1):[...s.keys]:[],u=[];if(h&&s){for(const v of s.keys)if(h.keys.indexOf(v)!==-1){const I=(0,R.$Ji)(s.contents,v),b=(0,R.$Ji)(h.contents,v);w.$Cn(I,b)||u.push(v)}}return{added:f,removed:l,updated:u}}}),define(ke[255],Se([1,0,21,4,3,82]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsb=e.$gsb=e.$fsb=e.$esb=void 0;const A=(E,R,C)=>{const p=new Uint8Array(16);for(let c=0;c<16;c++)p[c]=Math.round(Math.random()*256);const k=(0,D.$Ee)(D.$ke.wrap(p));return[`GET ws://localhost${E}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$esb=A,e.$fsb=D.$ke.fromString(`\r
\r
`);async function w(E,R,C,p,k){E.write(D.$ke.fromString((0,e.$esb)(R,C,p)));const S=new d.$Sc;try{return await new Promise((c,m)=>{let a;S.add(E.onData(i=>{a?a=D.$ke.concat([a,i],a.byteLength+i.byteLength):a=i;const r=a.indexOf(e.$fsb);if(r===-1)return;c(E),E.pauseData();const n=a.slice(r+e.$fsb.byteLength);n.byteLength&&k.onData.fire(n)})),S.add(E.onClose(i=>m(i??new Error("socket closed")))),S.add(E.onEnd(()=>m(new Error("socket ended"))))})}catch(c){throw E.dispose(),c}finally{S.dispose()}}e.$gsb=w;class $ extends d.$Tc{constructor(R,C){super(),this.g=R,this.a=this.B(new M.$Zd),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new M.$Wd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(p=>this.a.fire(p))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,C){P.SocketDiagnostics.traceSocketEvent(this,this.g,R,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$hsb=$}),define(ke[65],Se([1,0,14,5]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,M.$8h)("remoteAuthorityResolverService");var d;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class P{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=P;class A{constructor(C,p){this.host=C,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=A;var w;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===w.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===w.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===w.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===w.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,p=w.Unknown,k){super(C),this._message=C,this._code=p,this._detail=k,this.isHandled=p===w.NotAvailable&&k===!0,Object.setPrototypeOf(this,$.prototype)}}e.$al=$;function E(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.$bl=E}),define(ke[66],Se([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function M(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.$cl=M;function d(E){if(!E)return;const R=E.indexOf("+");return R<0?E:E.substr(0,R)}e.$dl=d;function P(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.$el=P;function A(E){const{host:R,port:C}=$(E);if(typeof C>"u")throw new Error(`Invalid remote authority: ${E}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:C}}e.$fl=A;function w(E,R){let{host:C,port:p}=$(E);return typeof p>"u"&&(p=R),{host:C,port:p}}e.$gl=w;function $(E){const R=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const C=E.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const p=E.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:E,port:void 0}}}),define(ke[25],Se([1,0,13,5,66]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$lm=P,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var w;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class ${constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,a){if(typeof m>"u"||m===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){const i=typeof m=="string"?m:m.value,r=typeof a=="string"?a:a.value;return D.$af(i,r)}return m._lower===a._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$nm=$;class E{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const a of m)this.add(a)}add(m){this.c.add($.toKey(m))}delete(m){return this.c.delete($.toKey(m))}has(m){return this.c.has($.toKey(m))}}e.$om=E;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete($.toKey(m))}get(m){return this.c.get($.toKey(m))}has(m){return this.c.has($.toKey(m))}set(m,a){this.c.set($.toKey(m),a)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=R;function C(c){return p(c)}e.$qm=C;function p(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$rm=p;function k(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$sm=k;function S(c,m){if(m){const a=`onResolveRemoteAuthority:${(0,d.$dl)(m)}`;return!!c.activationEvents?.includes(a)}return!1}e.$tm=S,e.$um=(0,M.$8h)("IBuiltinExtensionsScannerService")}),define(ke[137],Se([1,0,14,25]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class d{constructor(){this.a=new Map,this.b=new WeakMap}register(A,w){this.a.set(A,w)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const w=Object.create(null);for(const $ of A){const E=this.readActivationEvents($);E.length>0&&(w[M.$nm.toKey($.identifier)]=E)}return w}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const w=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<w.length;$++)w[$]==="onUri"&&(w[$]=`onUri:${M.$nm.toKey(A.identifier)}`);if(!A.contributes)return w;for(const $ in A.contributes){const E=this.a.get($);if(!E)continue;const R=A.contributes[$],C=Array.isArray(R)?R:[R];try{E(C,w)}catch(p){(0,D.$1)(p)}}return w}}e.$pF=d,e.$qF=new d}),define(ke[256],Se([1,0,8,21,22,14,4,3,58,38,30,82,65,66]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.PersistentConnectionEventType=e.$nl=e.$ml=e.$ll=e.ConnectionType=void 0;const S=30*1e3;var c;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(J){const W=new d.$7d;return setTimeout(()=>W.cancel(),J),W.token}function i(J,W){if(J.isCancellationRequested||W.isCancellationRequested)return d.CancellationToken.Cancelled;const re=new d.$7d;return J.onCancellationRequested(()=>re.cancel()),W.onCancellationRequested(()=>re.cancel()),re.token}class r{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new w.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,D.$1g)(),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function n(J,W){const re=new r(W);return re.registerDisposable(J.onControlMessage(ye=>{const he=JSON.parse(ye.toString()),fe=X(he);fe?re.reject(fe):re.resolve(he)})),re.promise}function o(J,W,re,ye,he,fe,ue,me){const V=new r(me),Y=E.$Sd.create(!1);return J.info(`Creating a socket (${ue})...`),$.mark(`code/willCreateSocket/${fe}`),W.connect(re,ye,he,ue).then(de=>{V.didTimeout?($.mark(`code/didCreateSocketError/${fe}`),J.info(`Creating a socket (${ue}) finished after ${Y.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):($.mark(`code/didCreateSocketOK/${fe}`),J.info(`Creating a socket (${ue}) was successful after ${Y.elapsed()} ms.`),V.resolve(de))},de=>{$.mark(`code/didCreateSocketError/${fe}`),J.info(`Creating a socket (${ue}) returned an error after ${Y.elapsed()} ms.`),J.error(de),V.reject(de)}),V.promise}function t(J,W){const re=new r(W);return J.then(ye=>{re.didTimeout||re.resolve(ye)},ye=>{re.didTimeout||re.reject(ye)}),re.promise}async function h(J,W,re,ye){const he=ge(J,W);J.logService.trace(`${he} 1/6. invoking socketFactory.connect().`);let fe;try{fe=await o(J.logService,J.remoteSocketFactoryService,J.connectTo,(0,k.$el)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,m(W),`renderer-${m(W)}-${J.reconnectionToken}`,ye)}catch(de){throw J.logService.error(`${he} socketFactory.connect() failed or timed out. Error:`),J.logService.error(de),de}J.logService.trace(`${he} 2/6. socketFactory.connect() was successful.`);let ue,me;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(fe,null),ue=J.reconnectionProtocol,me=!1):(ue=new C.$Vh({socket:fe}),me=!0),J.logService.trace(`${he} 3/6. sending AuthRequest control message.`);const V=await t(J.signService.createNewMessage((0,R.$rg)()),ye),Y={type:"auth",auth:J.connectionToken||"00000000000000000000",data:V.data};ue.sendControl(M.$ke.fromString(JSON.stringify(Y)));try{const de=await n(ue,i(ye,a(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(J.logService.trace(`${he} 4/6. received SignRequest control message.`),!await t(J.signService.validate(V,de.signedData),ye)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const Pe=await t(J.signService.sign(de.data),ye),ve={type:"connectionType",commit:J.commit,signedData:Pe,desiredConnectionType:W};return re&&(ve.args=re),J.logService.trace(`${he} 5/6. sending ConnectionTypeRequest control message.`),ue.sendControl(M.$ke.fromString(JSON.stringify(ve))),{protocol:ue,ownsProtocol:me}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(J.logService.error(`${he} the handshake timed out. Error:`),J.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${he} received error control message when negotiating connection. Error:`),J.logService.error(de)),me&&x(ue),de}}async function s(J,W,re,ye){const he=Date.now(),fe=ge(J,W),{protocol:ue,ownsProtocol:me}=await h(J,W,re,ye),V=new r(ye);return V.registerDisposable(ue.onControlMessage(Y=>{const de=JSON.parse(Y.toString()),pe=X(de);pe?(J.logService.error(`${fe} received error control message when negotiating connection. Error:`),J.logService.error(pe),me&&x(ue),V.reject(pe)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${fe} 6/6. handshake finished, connection is up and running after ${ne(he)}!`),V.resolve({protocol:ue,firstMessage:de}))})),V.promise}async function f(J,W){const{protocol:re}=await s(J,1,void 0,W);return{protocol:re}}async function l(J,W,re){const{protocol:ye,firstMessage:he}=await s(J,2,W,re),fe=he&&he.debugPort;return{protocol:ye,debugPort:fe}}async function u(J,W,re){const ye=Date.now(),he=ge(J,3),{protocol:fe}=await h(J,3,W,re);return J.logService.trace(`${he} 6/6. handshake finished, connection is up and running after ${ne(ye)}!`),fe}async function v(J,W,re){const{connectTo:ye,connectionToken:he}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:ye,connectionToken:he,reconnectionToken:W,reconnectionProtocol:re,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function I(J,W,re){return g(J,async ye=>{const{protocol:he}=await f(ye,d.CancellationToken.None);return new K(J,W,re,ye.reconnectionToken,he)})}e.$ll=I;async function b(J,W){return g(J,async re=>{const{protocol:ye,debugPort:he}=await l(re,W,d.CancellationToken.None);return new te(J,W,re.reconnectionToken,ye,he)})}e.$ml=b;async function g(J,W){for(let ye=1;;ye++)try{const he=(0,R.$rg)(),fe=await v(J,he,null);return await W(fe)}catch(he){if(ye<5)J.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(he);else throw J.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(he),z.triggerPermanentFailure(0,0,p.$al.isHandled(he)),he}}async function y(J,W,re){const ye=await v(J,(0,R.$rg)(),null);return await u(ye,{host:W,port:re},d.CancellationToken.None)}e.$nl=y;function L(J){return(0,D.$Ug)(W=>new Promise((re,ye)=>{const he=setTimeout(re,J*1e3);W.onCancellationRequested(()=>{clearTimeout(he),re()})}))}var T;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(W,re){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.type=0}}e.$ol=U;class j{constructor(W,re,ye,he){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.durationSeconds=ye,this.c=he,this.type=1}skipWait(){this.c.cancel()}}e.$pl=j;class F{constructor(W,re,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=2}}e.$ql=F;class N{constructor(W,re,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=4}}e.$rl=N;class O{constructor(W,re,ye,he){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.handled=he,this.type=3}}e.$sl=O;class z extends w.$Tc{static triggerPermanentFailure(W,re,ye){this._permanentFailure=!0,this.f=W,this.g=re,this.h=ye,this.j.forEach(he=>he.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(W=>W.y())}static debugPauseSocketWriting(){this.j.forEach(W=>W.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||z._permanentFailure}constructor(W,re,ye,he,fe){super(),this.t=W,this.u=re,this.reconnectionToken=ye,this.protocol=he,this.w=fe,this.m=this.B(new A.$Wd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(he.onSocketClose(ue=>{const me=_(this.t,this.reconnectionToken,!0);ue?ue.type===0?(this.u.logService.info(`${me} received socket close event (hadError: ${ue.hadError}).`),ue.error&&this.u.logService.error(ue.error)):(this.u.logService.info(`${me} received socket close event (wasClean: ${ue.wasClean}, code: ${ue.code}, reason: ${ue.reason}).`),ue.event&&this.u.logService.error(ue.event)):this.u.logService.info(`${me} received socket close event.`),this.y()})),this.B(he.onSocketTimeout(ue=>{const me=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${me} received socket timeout event (unacknowledgedMsgCount: ${ue.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ue.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ue.timeSinceLastReceivedSomeData}).`),this.y()})),z.j.push(this),this.B((0,w.$Rc)(()=>{const ue=z.j.indexOf(this);ue>=0&&z.j.splice(ue,1)})),this.n&&this.D(z.f,z.g,z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const W=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const re=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const he=ye<re.length?re[ye]:re[re.length-1];try{if(he>0){const ue=L(he);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he,ue)),this.u.logService.info(`${W} waiting for ${he} seconds before reconnecting...`);try{await ue}catch{}}if(this.n){this.u.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${W} resolving connection...`);const fe=await v(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${W} connecting to ${fe.connectTo}...`),await this.G(fe,a(S)),this.u.logService.info(`${W} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(fe){if(fe.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(p.$al.isTemporarilyNotAvailable(fe)){this.u.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if((fe.code==="ETIMEDOUT"||fe.code==="ENETUNREACH"||fe.code==="ECONNREFUSED"||fe.code==="ECONNRESET")&&fe.syscall==="connect"){this.u.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if((0,P.$4)(fe)){this.u.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if(fe instanceof p.$al){this.u.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,p.$al.isHandled(fe));break}this.u.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(W,re,ye){this.w?z.triggerPermanentFailure(W,re,ye):this.D(W,re,ye)}D(W,re,ye){this.m.fire(new O(this.reconnectionToken,W,re,ye)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$tl=z;class K extends z{constructor(W,re,ye,he,fe){super(1,W,he,fe,!0),this.client=this.B(new C.$Th(fe,{remoteAuthority:re,clientId:ye},W.ipcLogger))}async G(W,re){await f(W,re)}}e.$ul=K;class te extends z{constructor(W,re,ye,he,fe){super(2,W,ye,he,!1),this.H=re,this.debugPort=fe}async G(W,re){await l(W,this.H,re)}}e.$vl=te;function x(J){try{J.acceptDisconnect();const W=J.getSocket();J.dispose(),W.dispose()}catch(W){(0,P.$1)(W)}}function X(J){if(J&&J.type==="error"){const W=new Error(`Connection error: ${J.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Z(J,W){for(;J.length<W;)J+=" ";return J}function ce(J,W){return`[remote-connection][${Z(m(J),13)}][${W.substr(0,5)}\u2026]`}function _(J,W,re){return`${ce(J,W)}[${re?"reconnect":"initial"}]`}function ge(J,W){return`${_(W,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function ne(J){return`${Date.now()-J} ms`}}),define(ke[257],Se([1,0,3,5]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl=(0,M.$8h)("remoteSocketFactoryService");class d{constructor(){this.a={}}register(A,w){return this.a[A]??=[],this.a[A].push(w),(0,D.$Rc)(()=>{const $=this.a[A]?.indexOf(w);typeof $=="number"&&$>=0&&this.a[A]?.splice($,1)})}b(A){return(this.a[A.type]||[]).find($=>$.supports(A))}connect(A,w,$,E){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,w,$,E)}}e.$il=d}),define(ke[258],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(d){try{const P=await this.c();if(P){const A=String(D.a++);return this.b.set(A,P),{id:A,data:P.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,P){if(!d.id)return!0;const A=this.b.get(d.id);if(!A)return!1;this.b.delete(d.id);try{return A.validate(P)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(d){try{return await this.d(d)}catch{}return d}}e.$76b=D}),define(ke[109],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=void 0,e.$jl="signService",e.$kl=(0,D.$8h)(e.$jl)}),define(ke[138],Se([1,0,258]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=void 0;class M extends D.$76b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(A=>new A.signer().sign(P))}h(){return new Promise((P,A)=>$e(["vsda"],P,A))}}e.$1$b=M}),define(ke[259],Se([1,0,11,49,30]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function P($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,E,R,C,p,k,S,c,m){const a=Object.create(null);a["common.machineId"]=k,a["common.sqmId"]=S,a.sessionID=(0,d.$rg)()+Date.now(),a.commitHash=C,a.version=p,a["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,D.$h)(D.$u),a["common.nodePlatform"]=M.$dc,a["common.nodeArch"]=R,a["common.product"]=m||"desktop",c&&(a["common.msftInternal"]=c);let i=0;const r=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(a["common.snap"]="true");const n=P(E);return n&&(a["common.platformDetail"]=n),a}e.$Lo=A;function w($){const E=M.env.USERDNSDOMAIN;if(!E)return!1;const R=E.toLowerCase();return $.some(C=>R===C)}e.$Mo=w}),define(ke[260],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,D.$8h)("telemetryService"),e.$xl=(0,D.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var M;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var d;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(ke[87],Se([1,0,24,18,66,259,260]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class w{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.$No=w;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=$,e.$Po=new $;class E{async publicLog(h,s,f){}async publicLogError(h,s,f){}}e.$Qo=E,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!t.enableTelemetry)}e.$Uo=R;function C(t,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=C;function p(t){const h=t.getValue(A.$El),s=t.getValue(A.$Fl);if(t.getValue(A.$Gl)===!1||s===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=p;function k(t){const h={},s={},f={};m(t,f);for(let l in f){l=l.length>150?l.substr(l.length-149):l;const u=f[l];typeof u=="number"?s[l]=u:typeof u=="boolean"?s[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),h[l]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(h[l]=u)}return{properties:h,measurements:s}}e.$Xo=k;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const h=(0,d.$dl)(t);return S.has(h)?h:"other"}e.$Yo=c;function m(t,h,s=0,f){if(t)for(const l of Object.getOwnPropertyNames(t)){const u=t[l],v=f?f+l:l;Array.isArray(u)?h[v]=(0,D.$Dn)(u):u instanceof Date?h[v]=u.toISOString():(0,M.$Lf)(u)?s<2?m(u,h,s+1,v+"."):h[v]=(0,D.$Dn)(u):h[v]=u}}function a(t,h){const s=t.msftInternalDomains||[],f=h.getValue("telemetry.internalTesting");return(0,P.$Mo)(s)||f}e.$Zo=a;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=i;function r(t,h){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const f=[];for(const I of h)for(;;){const b=I.exec(t);if(!b)break;f.push([b.index,I.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(s="";;){const I=u.exec(t);if(!I)break;const b=f.some(([g,y])=>I.index<y&&g<u.lastIndex);!l.test(I[0])&&!b&&(s+=t.substring(v,I.index)+"<REDACTED: user-file-path>",v=u.lastIndex)}return v<t.length&&(s+=t.substr(v)),s}function n(t){if(!t)return t;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of h)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function o(t,h){return(0,D.$An)(t,s=>{if(s instanceof w||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let f=s.replaceAll("%20"," ");f=r(f,h);for(const l of h)f=f.replace(l,"");return f=n(f),f}})}e.$2o=o}),define(ke[261],Se([1,0,13,134,25,11,2,14,49,87]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function R(s,f){return s.uuid&&f.uuid?s.uuid===f.uuid:s.id===f.id?!0:(0,D.$8e)(s.id,f.id)===0}e.$3o=R;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(f){const l=f.manifest?f.manifest.version:f.version,u=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new p(f.identifier,l,u)}static parse(f){const l=C.exec(f);return l&&l[1]&&l[2]?new p({id:l[1]},l[2],l[4]||void 0):null}constructor(f,l,u="undefined"){this.version=l,this.targetPlatform=u,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof p?R(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$4o=p;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const f=k.exec(s);return f&&f[1]?[m(f[1]),f[2]]:[m(s),void 0]}e.$5o=S;function c(s,f){return`${s}.${f}`}e.$6o=c;function m(s){return s.toLowerCase()}e.$7o=m;function a(s,f){return m(c(s??d.$jm,f))}e.$8o=a;function i(s,f){const l=[],u=v=>{for(const I of l)if(I.some(b=>R(f(b),f(v))))return I;return null};for(const v of s){const I=u(v);I?I.push(v):l.push([v])}return l}e.$9o=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$0o=r;function n(s){return{id:new E.$No(s.identifier.id),name:new E.$No(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$$o=n,e.$_o=new d.$nm("pprice.better-merge");function o(s,f){const l=[],u=f.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const v=u.shift();if(v&&l.every(I=>!R(I.identifier,{id:v}))){const I=s.filter(b=>R(b.identifier,{id:v}));I.length===1&&(l.push(I[0]),u.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$ap=o;async function t(s,f){if(!P.$k)return!1;let l;try{l=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){f.debug("Error while getting the os-release file.",(0,w.$0)(v))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(s,f){const l=await t(s,f),u=(0,M.$xo)(l?"alpine":P.$u,$.$ec);return f.debug("ComputeTargetPlatform:",u),u}e.$bp=h}),define(ke[262],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function D($){return[...$.entries()]}e.$Or=D;function M($){return $?[...$.entries()]:[]}e.$Pr=M;function d($){return new Map($)}e.$Qr=d;function P($){return new Map($??[])}e.$Rr=P;function A($){return Array.from($.entries()).map(E=>[E[0],D(E[1].map),M(E[1].descriptionMap)])}e.$Sr=A;function w($){return new Map($.map(E=>[E[0],{map:d(E[1]),descriptionMap:P(E[2])}]))}e.$Tr=w}),define(ke[263],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ysb=void 0;class D{constructor(d){this.b=d,this.a=new Map}dispose(){for(const d of this.a.values())d.dispose()}startBuffering(d,P,A=5){const w=P($=>{const E=typeof $=="string"?$:$.data;let R=this.a.get(d);if(R){R.data.push(E);return}const C=setTimeout(()=>this.flushBuffer(d),A);R={data:[E],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(d),w.dispose()}},this.a.set(d,R)});return w}stopBuffering(d){this.a.get(d)?.dispose()}flushBuffer(d){const P=this.a.get(d);P&&(this.a.delete(d),this.b(d,P.data.join("")))}}e.$ysb=D}),define(ke[264],Se([1,0,8,79,55,4,18,2,207,108,37]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var C;(function(n){function o(t,h){let s=t.defaults;for(;d.ThemeIcon.isThemeIcon(s);){const f=S.getIcon(s.id);if(!f)return;s=f.defaults}return s}n.getDefinition=o})(C||(e.IconContribution=C={}));var p;(function(n){function o(h){return{weight:h.weight,style:h.style,src:h.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=o;function t(h){const s=f=>(0,A.$Jf)(f)?f:void 0;if(h&&Array.isArray(h.src)&&h.src.every(f=>(0,A.$Jf)(f.format)&&(0,A.$Jf)(f.location)))return{weight:s(h.weight),style:s(h.style),src:h.src.map(f=>({format:f.format,location:w.URI.parse(f.location)}))}}n.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class k{constructor(){this.a=new P.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,t,h,s){const f=this.b[o];if(f){if(h&&!f.description){f.description=h,this.d.properties[o].markdownDescription=`${h} $(${o})`;const v=this.e.enum.indexOf(o);v!==-1&&(this.e.enumDescriptions[v]=h),this.a.fire()}return f}const l={id:o,description:h,defaults:t,deprecationMessage:s};this.b[o]=l;const u={$ref:"#/definitions/icons"};return s&&(u.deprecationMessage=s),h&&(u.markdownDescription=`${h}: $(${o})`),this.d.properties[o]=u,this.e.enum.push(o),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const t=this.e.enum.indexOf(o);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,t){const h=this.f[o];return h||(this.f[o]=t,this.a.fire(),t)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(f,l)=>f.id.localeCompare(l.id),t=f=>{for(;d.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(f=>this.b[f]);for(const f of s.filter(l=>!!l.description).sort(o))h.push(`|<i class="${t(f)}"></i>|${f.id}|${d.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const f of s.filter(l=>!d.ThemeIcon.isThemeIcon(l.defaults)).sort(o))h.push(`|<i class="${t(f)}"></i>|${f.id}|`);return h.join(`
`)}}const S=new k;R.$Kn.add(e.$yw.IconContribution,S);function c(n,o,t,h){return S.registerIcon(n,o,t,h)}e.$zw=c;function m(){return S}e.$Aw=m;function a(){const n=(0,M.$_j)();for(const o in n){const t="\\"+n[o].toString(16);S.registerIcon(o,{fontCharacter:t})}}a(),e.$Bw="vscode://schemas/icons";const i=R.$Kn.as(E.$Ln.JSONContribution);i.registerSchema(e.$Bw,S.getIconSchema());const r=new D.$hh(()=>i.notifySchemaChanged(e.$Bw),200);S.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Cw=c("widget-close",M.$bk.close,(0,$.localize)(2,null)),e.$Dw=c("goto-previous-location",M.$bk.arrowUp,(0,$.localize)(3,null)),e.$Ew=c("goto-next-location",M.$bk.arrowDown,(0,$.localize)(4,null)),e.$Fw=d.ThemeIcon.modify(M.$bk.sync,"spin"),e.$Gw=d.ThemeIcon.modify(M.$bk.loading,"spin")}),define(ke[88],Se([1,0,4,51,5,12]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,d.$8h)("tunnelService"),e.$Dv=(0,d.$8h)("sharedTunnelsService");var A;(function(m){m.Http="http",m.Https="https"})(A||(e.TunnelProtocol=A={}));var w;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(w||(e.TunnelPrivacyId=w={}));function $(m){return!!m.forwardPort}e.$Ev=$;var E;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function R(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(a)return{address:a[1],port:+a[2]}}e.$Fv=R,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(m){return e.$Gv.indexOf(m)>=0}e.$Hv=C,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(m){return e.$Iv.indexOf(m)>=0}e.$Jv=p;function k(m,a,i,r){if(i===1)return!1;if(i===2&&p(a)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(n?.length===4&&parseInt(n[1])>=18)return!1}return m<1024}e.$Kv=k;class S{constructor(a,i,r){this.remoteAddress=a,this.localAddress=i,this.b=r,this.a=new D.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=S;let c=class{constructor(a,i){this.k=a,this.l=i,this.a=new D.$Wd,this.onTunnelOpened=this.a.event,this.b=new D.$Wd,this.onTunnelClosed=this.b.event,this.c=new D.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const a=this.l.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.f=a,a?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.g=a.elevation,this.i=a.privacyOptions,this.h=a.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const a=[],i=Array.from(this.e.values());for(const r of i){const n=Array.from(r.values());for(const o of n){const t=await o.value;t&&typeof t!="string"&&a.push(t)}}return a}async dispose(){for(const a of this.e.values()){for(const{value:i}of a.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);a.clear()}this.e.clear()}setEnvironmentTunnel(a,i,r,n,o){this.q(a,i,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:i,localAddress:r,privacy:n,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,i){(p(a)||C(a))&&(a=e.$Gv[0]);const r=this.s(a,i);if(r)return++r.refcount,r.value}openTunnel(a,i,r,n,o,t=!1,h,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${o}.`);const f=this.f??a;if(!f)return;if(i||(i="localhost"),n||(n=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(f,i,r,n,o,t,h,s);return l?l.then(u=>{if(u){if(typeof u=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,r),u}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.o(u);return(u.tunnelRemoteHost!==i||u.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&u.privacy!==h&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const i=this.e.get(a.tunnelRemoteHost);if(i){const r=i.get(a.tunnelRemotePort);r&&(r.refcount--,await this.p(a.tunnelRemoteHost,a.tunnelRemotePort,r))}}}}async p(a,i,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${i}.`);const n=r.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(a)&&this.e.get(a).delete(i),n}}async closeTunnel(a,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${i} `);const r=this.e.get(a);if(r&&r.has(i)){const n=r.get(i);n.refcount=0,await this.p(a,i,n)}}q(a,i,r){this.e.has(a)||this.e.set(a,new Map),this.e.get(a).set(i,{refcount:1,value:r})}async r(a,i){const r=this.e.get(a);if(r){const n=r.get(i),o=n?await n.value:void 0;(!o||typeof o=="string")&&r.delete(i),r.size===0&&this.e.delete(a)}}s(a,i){const r=[a];C(a)?(r.push(...e.$Gv),r.push(...e.$Iv)):p(a)&&r.push(...e.$Iv);const n=r.map(o=>this.e.get(o));for(const o of n){const t=o?.get(i);if(t)return t}}canTunnel(a){return!!R(a)}u(a,i,r,n,o,t,h){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${n}.`);const s=r;this.j.add(s);const f=n===void 0?r:n,l={elevationRequired:o?this.isPortPrivileged(f):!1},u={remoteAddress:{host:i,port:r},localAddressPort:n,privacy:t,public:t?t!==w.Private:void 0,protocol:h},v=a.forwardPort(u,l);return v?(this.q(i,r,v),v.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),v}};e.$Mv=c,e.$Mv=c=Ge([Ve(0,P.$pj),Ve(1,M.$Bi)],c)}),define(ke[265],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=void 0,e.$3k=(0,D.$8h)("IUriIdentityService")}),define(ke[266],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nv=void 0,e.$Nv=(0,D.$8h)("editSessionIdentityService");var M;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(ke[267],Se([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=void 0;function M($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$TK=M;function d($){if($.folders.length)return $.folders.every(E=>M(E.uri))?$.folders[0].uri:void 0;if($.configuration&&M($.configuration))return $.configuration}e.$UK=d;function P($){return d($)?.scheme}e.$VK=P;function A($){return d($)?.authority}e.$WK=A;function w($){return d($)!==void 0}e.$XK=w}),define(ke[40],Se([1,0,209,17,78,23,2,5,15]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,w.$8h)("contextService");function E(f){const l=f;return typeof l?.id=="string"&&A.URI.isUri(l.uri)}e.$fi=E;function R(f){return typeof f?.id=="string"&&!E(f)&&!p(f)}e.$gi=R,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function C(f,l){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,M.$nc)(f)}:l?e.$hi:e.$ii;const u=f;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.$ji=C;function p(f){const l=f;return typeof l?.id=="string"&&A.URI.isUri(l.configPath)}e.$ki=p;function k(f){const l=f;if(l?.uri)return{id:l.id,uri:A.URI.revive(l.uri)};const u=f;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(f?.id)return{id:f.id}}e.$li=k;var S;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function c(f){const l=f;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$mi=c;function m(f){const l=f;return!!(l&&typeof l=="object"&&A.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$ni=m;class a{constructor(l,u,v,I,b){this.h=l,this.j=v,this.k=I,this.l=b,this.c=d.$bi.forUris(this.l,()=>!0),this.folders=u}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=d.$bi.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=a;class i{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,P.$Ig)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=i;function r(f){return new i({uri:f,index:0,name:(0,P.$Eg)(f)},{uri:f.toString()})}e.$qi=r,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,D.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function n(f,l){return P.$zg.isEqualOrParent(f,l.untitledWorkspacesHome)}e.$vi=n;function o(f){let l;return A.URI.isUri(f)?l=f:l=f.configuration,l?.scheme===$.Schemas.tmp}e.$wi=o,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(f){return f.id===e.$xi}e.$yi=t;function h(f,l){return!n(f,l)&&!o(f)}e.$zi=h;function s(f){return(typeof f=="string"?(0,M.$oc)(f):(0,P.$Gg)(f))===e.$si}e.$Ai=s}),define(ke[268],Se([1,0,54,4,3,23,2,208,133,32,5,12,40,28,265,8,30,13,18]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.ProfileResourceType=void 0;var r;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(f){const l=f;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&A.URI.isUri(l.location)&&A.URI.isUri(l.globalStorageHome)&&A.URI.isUri(l.settingsResource)&&A.URI.isUri(l.keybindingsResource)&&A.URI.isUri(l.tasksResource)&&A.URI.isUri(l.snippetsHome)&&A.URI.isUri(l.extensionsResource))}e.$4k=n,e.$5k=(0,R.$8h)("IUserDataProfilesService");function o(f,l){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:A.URI.revive(f.location).with({scheme:l}),globalStorageHome:A.URI.revive(f.globalStorageHome).with({scheme:l}),settingsResource:A.URI.revive(f.settingsResource).with({scheme:l}),keybindingsResource:A.URI.revive(f.keybindingsResource).with({scheme:l}),tasksResource:A.URI.revive(f.tasksResource).with({scheme:l}),snippetsHome:A.URI.revive(f.snippetsHome).with({scheme:l}),extensionsResource:A.URI.revive(f.extensionsResource).with({scheme:l}),cacheHome:A.URI.revive(f.cacheHome).with({scheme:l}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}e.$6k=o;function t(f,l,u,v,I,b){return{id:f,name:l,location:u,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:b&&I?.useDefaultFlags?.globalState?b.globalStorageHome:(0,P.$Ig)(u,"globalStorage"),settingsResource:b&&I?.useDefaultFlags?.settings?b.settingsResource:(0,P.$Ig)(u,"settings.json"),keybindingsResource:b&&I?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,P.$Ig)(u,"keybindings.json"),tasksResource:b&&I?.useDefaultFlags?.tasks?b.tasksResource:(0,P.$Ig)(u,"tasks.json"),snippetsHome:b&&I?.useDefaultFlags?.snippets?b.snippetsHome:(0,P.$Ig)(u,"snippets"),extensionsResource:b&&I?.useDefaultFlags?.extensions?b.extensionsResource:(0,P.$Ig)(u,"extensions.json"),cacheHome:(0,P.$Ig)(v,f),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$7k=t;let h=class extends d.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,u,v,I){super(),this.t=l,this.u=u,this.w=v,this.y=I,this.f=!0,this.h=this.B(new M.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new M.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new M.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new M.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new k.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),u=[l];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,i.$Jf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}u.push(t((0,P.$Fg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},l))}}catch(b){this.y.error(b)}const v=new k.$Ac,I=new Map;if(u.length)try{const b=this.Q();if(b.workspaces)for(const[g,y]of Object.entries(b.workspaces)){const L=A.URI.parse(g),T=u.find(U=>U.id===y);T&&v.set(L,T)}if(b.emptyWindows)for(const[g,y]of Object.entries(b.emptyWindows)){const L=u.find(T=>T.id===y);L&&I.set(g,L)}}catch(b){this.y.error(b)}this.z={profiles:u,workspaces:v,emptyWindows:I}}return this.z}D(){const l=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const u="Temp",v=new RegExp(`${(0,a.$Pe)(u)}\\s(\\d+)`);let I=0;for(const g of this.profiles){const y=v.exec(g.name),L=y?parseInt(y[1]):0;I=L>I?L:I}const b=`${u} ${I+1}`;return this.createProfile((0,D.$Vi)((0,m.$rg)()).toString(16),b,{transient:!0},l)}async createNamedProfile(l,u,v){return this.createProfile((0,D.$Vi)((0,m.$rg)()).toString(16),l,u,v)}async createProfile(l,u,v,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(l,u,v);return I&&await this.setProfileForWorkspace(I,b),b}async F(l,u,v){if(!(0,i.$Jf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(u);return I||(I=(async()=>{try{const b=this.profiles.find(L=>L.name===u||L.id===l);if(b)return b;const g=t(l,u,(0,P.$Ig)(this.profilesHome,l),this.g,v,this.defaultProfile);await this.u.createFolder(g.location);const y=[];return this.j.fire({profile:g,join(L){y.push(L)}}),await c.Promises.settled(y),this.I([g],[],[]),g}finally{this.r.delete(u)}})(),this.r.set(u,I)),I}async updateProfile(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(I=>I.id===l.id);if(!v)throw new Error(`Profile '${l.name}' does not exist`);return v=t(v.id,u.name??v.name,v.location,this.g,{shortName:u.shortName??v.shortName,icon:u.icon===null?void 0:u.icon??v.icon,transient:u.transient??v.isTransient,useDefaultFlags:u.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(I=>I.id===l.id);if(!u)throw new Error(`Profile '${l.name}' does not exist`);const v=[];this.m.fire({profile:u,join(I){v.push(I)}});try{await Promise.allSettled(v)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(I){(0,E.$Jk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(I=>I.id===u.id);if(!v)throw new Error(`Profile '${u.name}' does not exist`);this.L(l,v)}unsetWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(u=>u.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(l.map(u=>this.removeProfile(u)))}getProfileForWorkspace(l){const u=this.G(l);return A.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(l){return(0,p.$fi)(l)?l.uri:(0,p.$ki)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location)))}I(l,u,v){const I=[...this.profiles,...l],b=[];this.s.profiles=[];for(let g of I)g.isDefault||u.some(y=>g.id===y.id)||(g=v.find(y=>g.id===y.id)??g,g.isTransient?this.s.profiles.push(g):b.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.P(b),this.z=void 0,this.J(l,u,v)}J(l,u,v){this.h.fire({added:l,removed:u,updated:v,all:this.profiles})}L(l,u,v){v=u?.isTransient?!0:v,v||this.L(l,void 0,!0);const I=this.G(l),b=v?this.s:this.C;A.URI.isUri(I)?(b.workspaces.delete(I),u&&b.workspaces.set(I,u)):(b.emptyWindows.delete(I),u&&b.emptyWindows.set(I,u)),v||this.M()}M(){const l={};for(const[v,I]of this.C.workspaces.entries())l[v.toString()]=I.id;const u={};for(const[v,I]of this.C.emptyWindows.entries())u[v.toString()]=I.id;this.R({workspaces:l,emptyWindows:u}),this.z=void 0}N(l){const u={},v=this.D();if(l.workspaces)for(const[b,g]of Object.entries(l.workspaces)){const y=A.URI.parse(g);u[b]=this.w.extUri.isEqual(y,v.location)?v.id:this.w.extUri.basename(y)}const I={};if(l.emptyWindows)for(const[b,g]of Object.entries(l.emptyWindows)){const y=A.URI.parse(g);I[b]=this.w.extUri.isEqual(y,v.location)?v.id:this.w.extUri.basename(y)}return{workspaces:u,emptyWindows:I}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$8k=h,e.$8k=h=Ge([Ve(0,$.$ci),Ve(1,E.$sk),Ve(2,S.$3k),Ve(3,C.$pj)],h);class s extends h{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$9k=s}),define(ke[269],Se([1,0,8,4,3,58,18,188,5,268]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,$.$8h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var p;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function k(i){const r=i.get(e.$vp);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.$xp=k;class S extends d.$Tc{static{this.a=60*1e3}constructor(r={flushInterval:S.a}){super(),this.m=r,this.b=this.B(new M.$Zd),this.c=this.B(new M.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new d.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(r,n,o){return M.Event.filter(this.b.event,t=>t.scope===r&&(n===void 0||t.key===n),o)}n(){this.j.value=(0,D.$lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,d.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(r,n){const{key:o,external:t}=n;if(o===e.$vp){switch(r){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:r})}else this.b.fire({scope:r,key:o,target:this.J(r)[o],external:t})}w(r){this.f.fire({reason:r})}get(r,n,o){return this.P(n)?.get(r,o)}getBoolean(r,n,o){return this.P(n)?.getBoolean(r,o)}getNumber(r,n,o){return this.P(n)?.getNumber(r,o)}getObject(r,n,o){return this.P(n)?.getObject(r,o)}storeAll(r,n){this.y(()=>{for(const o of r)this.store(o.key,o.value,o.scope,o.target,n)})}store(r,n,o,t,h=!1){if((0,A.$Sf)(n)){this.remove(r,o,h);return}this.y(()=>{this.z(r,o,t),this.P(o)?.set(r,n,h)})}remove(r,n,o=!1){this.y(()=>{this.z(r,n,void 0),this.P(n)?.delete(r,o)})}y(r){this.b.pause(),this.c.pause();try{r()}finally{this.b.resume(),this.c.resume()}}keys(r,n){const o=[],t=this.J(r);for(const h of Object.keys(t))t[h]===n&&o.push(h);return o}z(r,n,o,t=!1){const h=this.J(n);typeof o=="number"?h[r]!==o&&(h[r]=o,this.P(n)?.set(e.$vp,JSON.stringify(h),t)):typeof h[r]=="number"&&(delete h[r],this.P(n)?.set(e.$vp,JSON.stringify(h),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(r){switch(r){case-1:return this.I;case 0:return this.G;default:return this.D}}L(r){const n=this.P(r);return n?k(n):Object.create(null)}isNew(r){return this.getBoolean(e.$up,r)===!0}async flush(r=R.NONE){this.f.fire({reason:r});const n=this.P(-1),o=this.P(0),t=this.P(1);switch(r){case R.NONE:await D.Promises.settled([n?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([n?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(r,n,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(r){return await this.flush(),this.P(r)?.optimize()}async switch(r,n){return this.w(R.NONE),(0,E.$4k)(r)?this.R(r,n):this.S(r,n)}M(r,n){return!(r.id===n.id||c(n)&&c(r))}N(r,n,o){this.y(()=>{const t=new Set;for(const[h,s]of r)t.add(h),n.get(h)!==s&&this.u(o,{key:h,external:!0});for(const[h]of n.items)t.has(h)||this.u(o,{key:h,external:!0})})}}e.$yp=S;function c(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$zp=c;class m extends S{constructor(){super(),this.U=this.B(new w.$sp(new w.$tp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$sp(new w.$tp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$sp(new w.$tp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(r=>this.u(1,r))),this.B(this.W.onDidChangeStorage(r=>this.u(0,r))),this.B(this.U.onDidChangeStorage(r=>this.u(-1,r)))}P(r){switch(r){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(r){return!1}}e.$Ap=m;async function a(i,r,n,o,t,h){const s=L=>{try{return JSON.parse(L)}catch{return L}},f=new Map,l=new Map;i.forEach((L,T)=>{f.set(T,L),l.set(T,s(L))});const u=new Map,v=new Map;r.forEach((L,T)=>{u.set(T,L),v.set(T,s(L))});const I=new Map,b=new Map;n.forEach((L,T)=>{I.set(T,L),b.set(T,s(L))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const g=[];if(f.forEach((L,T)=>{g.push({key:T,value:L})}),console.table(g),console.groupEnd(),console.log(l),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];u.forEach((T,U)=>{L.push({key:U,value:T})}),console.table(L),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${h})`);const y=[];I.forEach((L,T)=>{y.push({key:T,value:L})}),console.table(y),console.groupEnd(),console.log(b)}e.$Bp=a}),define(ke[110],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;class D{static{this.a=!1}constructor(d){this.d=d,this.b=new Map,this.c=1}add(d){const P=this.c++;return this.b.set(P,d),this.e(),P}get(d,P){return this.b.has(d)?this.b.get(d)[P]:void 0}delete(d){this.b.delete(d),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$2fc=D}),define(ke[59],Se([1,0,15,23,5]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=void 0;class P{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new M.$xg(w=>{const $=this.b.get(w.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(w,$){$===null?this.b.delete(w.scheme):this.b.set(w.scheme,$)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$5fc=P,e.$6fc=(0,d.$8h)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=void 0,e.$FN=(0,D.$8h)("IExtHostInitDataService")}),define(ke[270],Se([1,0,214,12,250,27]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;let A=class extends d.$MO{constructor($,E,R){const C=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=R.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(E.createLogger(C,{name:p}))}};e.$_hc=A,e.$_hc=A=Ge([Ve(1,M.$qj),Ve(2,P.$FN)],A)}),define(ke[271],Se([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;class M{constructor(A,w,$){this.h=new Map,this.a=A,this.b=w,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new D.$hh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of E.values())R.complete()}catch(R){for(const C of E.values())C.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,w){let $=this.f[A];return typeof $>"u"&&($=w),$}update(A,w){this.f[A]=w;const $=this.h.get(A);if($!==void 0)return $.p;const E=new D.$sh;return this.h.set(A,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Ngc=M;class d extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,w){super(A.identifier.value,!0,w),this.j=A}}e.$Ogc=d}),define(ke[272],Se([1,0,4,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class d{constructor(A){this.c=A,this.a=new D.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,w,$,E){const C=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(w.value,$,E);this.b.fire(C)}$acceptDirtyStateChanged(A,w){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(w)}$acceptModelSaved(A){const w=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(w.apiNotebook)}}e.$Bhc=d}),define(ke[20],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=void 0,e.$pN=(0,D.$8h)("IExtHostRpcService");class M{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$qN=M}),define(ke[273],Se([1,0,25,4]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class d{#e;constructor(A,w){this.b=new M.$Wd,this.onDidChange=this.b.event,this.a=D.$nm.toKey(A.identifier),this.#e=w,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,w){return this.#e.store(this.a,A,w)}delete(A){return this.#e.delete(this.a,A)}}e.$Vgc=d}),define(ke[67],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=e.$lgc=void 0,e.$lgc=(0,D.$8h)("IURITransformerService");class M{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$mgc=M}),define(ke[274],Se([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glb=e.$Flb=void 0;class M{constructor(){this.buffers=[]}add($){let E=this.buffers.indexOf($);return E<0&&(E=this.buffers.length,this.buffers.push($)),E}}function d(w,$){if($.serializeBuffersForPostMessage){const E=new M,C=JSON.stringify(w,(k,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(S)};if(ArrayBuffer.isView(S)){const c=P(S);if(c)return{$$vscode_array_buffer_reference$$:!0,index:E.add(S.buffer),view:{type:c,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),p=E.buffers.map(k=>{const S=new Uint8Array(k);return D.$ke.wrap(S)});return{message:C,buffers:p}}else return{message:JSON.stringify(w),buffers:[]}}e.$Flb=d;function P(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(w,$){const E=$.map(p=>{const k=new ArrayBuffer(p.byteLength);return new Uint8Array(k).set(p.buffer),k}),R=$.length?(p,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const S=k,{index:c}=S,m=E[c];if(S.view)switch(S.view.type){case 1:return new Int8Array(m,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return k}:void 0;return{message:JSON.parse(w,R),arrayBuffers:E}}e.$Glb=A}),define(ke[275],Se([1,0,276,389,390,62,2,12,391]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;const E=!1;function R(r,n,o,t,h,s){const f=s.environment.useHostProxy,l=typeof f=="boolean"?f:!s.remote.isRemote,u={resolveProxy:b=>r.resolveProxy(b),lookupProxyAuthorization:m.bind(void 0,t,h,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(n),addCertificatesV2:()=>k(n),log:t,getLogLevel:()=>{const b=t.getLevel();switch(b){case w.LogLevel.Trace:return $.LogLevel.Trace;case w.LogLevel.Debug:return $.LogLevel.Debug;case w.LogLevel.Info:return $.LogLevel.Info;case w.LogLevel.Warning:return $.LogLevel.Warning;case w.LogLevel.Error:return $.LogLevel.Error;case w.LogLevel.Off:return $.LogLevel.Off;default:return g(b)}function g(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,loadAdditionalCertificates:async()=>{const b=[];if(s.remote.isRemote&&b.push((0,$.loadSystemCertificates)({log:t})),l){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const g=r.loadCertificates();g.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),b.push(g)}return(await Promise.all(b)).flat()},env:process.env},v=(0,$.createProxyResolver)(u),I=C(u,v);return c(o,I)}e.$Hic=R;function C(r,n){return{http:Object.assign(D,(0,$.createHttpPatch)(r,D,n)),https:Object.assign(M,(0,$.createHttpPatch)(r,M,n)),net:Object.assign(P,(0,$.createNetPatch)(r,P)),tls:Object.assign(d,(0,$.createTlsPatch)(r,d))}}function p(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",E)&&!!n.get("systemCertificates")}function k(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",E)&&!!n.get("systemCertificates")}const S=new Map;function c(r,n){return r.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,h=t._load;t._load=function(f,l,u){if(f==="net")return n.net;if(f==="tls")return n.tls;if(f!=="http"&&f!=="https")return h.apply(this,arguments);const v=o.findSubstr(A.URI.file(l.filename));let I=S.get(v);if(I||S.set(v,I={}),!I[f]){const b=n[f];I[f]={...b}}return I[f]}})}async function m(r,n,o,t,h,s,f,l){const u=t[s];f&&(t[s]=f),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${f}`,`proxyAuthenticateCache:${u}`);const v=f||u,I=Array.isArray(v)?v:typeof v=="string"?[v]:[];if(i(n,I,h),I.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const b=await new Promise((U,j)=>{$e(["kerberos"],U,j)}),g=new URL(s),y=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${y}`),"Negotiate "+await(await b.initializeClient(y)).step("")}catch(b){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let a=!1;function i(r,n,o){a||!n.length||(a=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(ke[277],Se([1,0,130]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;function M(P){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:P,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function d(P){return new D.$7m(M(P))}e.$5r=d}),define(ke[139],Se([1,0,224,18,2,3,5,37,32,15,44,180,39]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var k;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var S;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function c(ne){const J=ne;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.$ME=c;function m(ne,J,W){for(const re of W.visibleEditorPanes)if(re.group.id===J&&ne.matches(re.input))return re.getViewState()}e.$NE=m;function a(ne){if(v(ne))return!1;const J=ne;return d.URI.isUri(J?.resource)}e.$OE=a;function i(ne){if(v(ne))return!1;const J=ne;return J?.original!==void 0&&J.modified!==void 0}e.$PE=i;function r(ne){if(v(ne))return!1;const J=ne;return!J||J.resources&&!Array.isArray(J.resources)?!1:!!J.resources||!!J.multiDiffSource}e.$QE=r;function n(ne){if(v(ne)||i(ne))return!1;const J=ne;return J?.primary!==void 0&&J.secondary!==void 0}e.$RE=n;function o(ne){if(v(ne))return!1;const J=ne;return J?J.resource===void 0||J.resource.scheme===E.Schemas.untitled||J.forceUntitled===!0:!1}e.$SE=o;function t(ne){if(v(ne))return!1;const J=ne;return d.URI.isUri(J?.base?.resource)&&d.URI.isUri(J?.input1?.resource)&&d.URI.isUri(J?.input2?.resource)&&d.URI.isUri(J?.result?.resource)}e.$TE=t;var h;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var s;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class f{constructor(){this.a=new Map}registerSource(J,W){let re=this.a.get(J);return re||(re={source:J,label:W},this.a.set(J,re)),re.source}getSourceLabel(J){return this.a.get(J)?.label??J}}e.$UE=new f;var l;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad",ne[ne.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class u extends P.$Tc{}e.$VE=u;function v(ne){return ne instanceof u}e.$WE=v;function I(ne){const J=ne;return d.URI.isUri(J?.preferredResource)}function b(ne){const J=ne;return v(J?.primary)&&v(J?.secondary)}e.$XE=b;function g(ne){const J=ne;return v(J?.modified)&&v(J?.original)}e.$YE=g;function y(ne,J,W,re,ye){return ge(re,[(0,C.$Ri)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const he={...W,limits:{size:Number.MAX_VALUE}};ne.openEditor(J,he)}}),(0,C.$Ri)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$ZE=y;function L(ne){return v(ne?.editor)}e.$1E=L;function T(ne){const J=ne;return L(ne)&&J?.group!==void 0}e.$2E=T;function U(ne){const J=ne;return typeof J?.groupId=="number"&&v(J.editor)}e.$3E=U;var j;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var F;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_STICKY=11]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=12]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var N;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class O{getOriginalUri(J,W){if(!J)return;if(t(J))return e.$5E.getOriginalUri(J.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:he}=this.a(J);if(ye&&he){if(W?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(he,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===N.ANY)return this.getOriginalUri(ye,{filterByScheme:W.filterByScheme})??this.getOriginalUri(he,{filterByScheme:W.filterByScheme});J=W.supportSideBySide===N.PRIMARY?ye:he}}if(i(J)||r(J)||n(J)||t(J))return;const re=I(J)?J.preferredResource:J.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}a(J){return b(J)||n(J)?{primary:J.primary,secondary:J.secondary}:g(J)||i(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,W){if(!J)return;if(t(J))return e.$5E.getCanonicalUri(J.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:he}=this.a(J);if(ye&&he){if(W?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(he,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===N.ANY)return this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(he,{filterByScheme:W.filterByScheme});J=W.supportSideBySide===N.PRIMARY?ye:he}}if(i(J)||r(J)||n(J)||t(J))return;const re=J.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}b(J,W){if(Array.isArray(W)){if(W.some(re=>J.scheme===re))return J}else if(W===J.scheme)return J}}var z;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function K(ne,J,W,re){if(!ne.isSticky(J))return!1;switch(re.preventPinnedEditorClose){case"keyboardAndMouse":return W===z.MOUSE||W===z.KEYBOARD;case"mouse":return W===z.MOUSE;case"keyboard":return W===z.KEYBOARD}return!1}e.$4E=K,e.$5E=new O;var te;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(te||(e.CloseDirection=te={}));class x{constructor(){this.c=new Map,this.d=new Map}start(J){const W=this.a=J.get(A.$7h);for(const[re,ye]of this.c)this.e(re,ye,W);this.c.clear()}e(J,W,re){const ye=re.createInstance(W);this.d.set(J,ye)}registerFileEditorFactory(J){if(this.b)throw new Error("Can only register one file editor factory.");this.b=J}getFileEditorFactory(){return(0,M.$Uf)(this.b)}registerEditorSerializer(J,W){if(this.c.has(J)||this.d.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.a?this.e(J,W,this.a):this.c.set(J,W),(0,P.$Rc)(()=>{this.c.delete(J),this.d.delete(J)})}getEditorSerializer(J){return this.d.get(typeof J=="string"?J:J.typeId)}}w.$Kn.add(e.$HE.EditorFactory,new x);async function X(ne,J,W){return!ne||!ne.length?[]:await Promise.all(ne.map(async re=>{const ye=d.URI.revive(re.fileUri);if(!ye){W.info("Cannot resolve the path because it is not valid.",re);return}if(!await J.canHandleResource(ye)){W.info("Cannot resolve the path because it cannot be handled",re);return}let fe=re.exists,ue=re.type;if(typeof fe!="boolean"||typeof ue!="number")try{ue=(await J.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,fe=!0}catch(V){W.error(V),fe=!1}if(!fe&&re.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",re);return}if(ue===$.FileType.Directory){W.info("Cannot resolve the path because it is a directory",re);return}const me={...re.options,pinned:!0};return fe?{resource:ye,options:me}:{resource:ye,options:me,forceUntitled:!0}}))}e.$6E=X;var Z;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function ce(ne){const J=ne;if(!J)return!1;const W=J;if(W.modified)return ce(W.modified);const re=J;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.$7E=ce;function _(ne){return(0,R.$Ti)(ne)}e.$8E=_;function ge(ne,J,W){const re=(0,R.$Ui)(ne,J);return re.forceMessage=W?.forceMessage,re.forceSeverity=W?.forceSeverity,re.allowDialog=W?.allowDialog,re}e.$9E=ge}),define(ke[278],Se([1,0,4,225,5,3,28,37,19,24,79,264]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cF=e.ViewContentGroups=e.$bF=e.$aF=e.ViewContainerLocation=e.Extensions=e.$_E=e.$$E=e.$0E=void 0,e.$0E="views",e.$$E=(0,M.localize)(0,null),e.$_E=(0,C.$zw)("default-view-icon",R.$bk.window,(0,M.localize)(1,null));var p;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var k;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel",h[h.AuxiliaryBar=2]="AuxiliaryBar"})(k||(e.ViewContainerLocation=k={})),e.$aF=[0,1,2];function S(h){switch(h){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bF=S;class c extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(s,f,l){const u=this.get(s.id);if(u)return u;const v=s;return v.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:v.openCommandActionDescriptor??{id:v.id},(0,A.$xc)(this.g,f,[]).push(v),l?.isDefault&&this.h.push(v),this.c.fire({viewContainer:v,viewContainerLocation:f}),v}deregisterViewContainer(s){for(const f of this.g.keys()){const l=this.g.get(f),u=l?.indexOf(s);if(u!==-1){l?.splice(u,1),l.length===0&&this.g.delete(f),this.f.fire({viewContainer:s,viewContainerLocation:f});return}}}get(s){return this.all.filter(f=>f.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(l=>l?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(f=>this.getViewContainerLocation(f)===s)}}w.$Kn.add(p.ViewContainersRegistry,new c);var m;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(m||(e.ViewContentGroups=m={}));function a(h,s){const f=h.group??m.More,l=s.group??m.More;return f!==l?f.localeCompare(l):(h.order??5)-(s.order??5)}class i extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,f){this.registerViews2([{views:s,viewContainer:f}])}registerViews2(s){s.forEach(({views:f,viewContainer:l})=>this.r(f,l)),this.c.fire(s)}deregisterViews(s,f){const l=this.s(s,f);l.length&&this.f.fire({views:l,viewContainer:f})}moveViews(s,f){for(const l of this.m.keys())if(l!==f){const u=this.s(s,l);u.length&&(this.r(u,f),this.g.fire({views:u,from:l,to:f}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const f of this.j){const l=(this.m.get(f)||[]).filter(u=>u.id===s)[0];if(l)return l}return null}getViewContainer(s){for(const f of this.j)if((this.m.get(f)||[]).filter(u=>u.id===s)[0])return f;return null}registerViewWelcomeContent(s,f){return this.n.add(s,f),this.h.fire(s),(0,P.$Rc)(()=>{this.n.delete(s,f),this.h.fire(s)})}registerViewWelcomeContent2(s,f){const l=new Map;for(const[u,v]of f)this.n.add(s,v),l.set(u,(0,P.$Rc)(()=>{this.n.delete(s,v),this.h.fire(s)}));return this.h.fire(s),l}getViewWelcomeContent(s){const f=[];return this.n.forEach(s,l=>f.push(l)),f.sort(a)}r(s,f){let l=this.m.get(f);l||(l=[],this.m.set(f,l),this.j.push(f));for(const u of s){if(this.getView(u.id)!==null)throw new Error((0,M.localize)(2,null,u.id));l.push(u)}}s(s,f){const l=this.m.get(f);if(!l)return[];const u=[],v=[];for(const I of l)s.includes(I)?u.push(I):v.push(I);return u.length&&(v.length?this.m.set(f,v):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),u}}w.$Kn.add(p.ViewsRegistry,new i),e.$cF=(0,d.$8h)("viewDescriptorService");var r;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,f){this.c=!1,this.d=!1,(0,E.$Bn)(this,s),this.d=!!f,this.resolve=async l=>{if(f&&!this.c){const u=await f(l);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dF=o;class t extends Error{constructor(s){super((0,M.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$eF=t}),define(ke[279],Se([1,0,2,29,5]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$mF=e.$lF=void 0;function P(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof D.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(M.$Ws.isIRange)}e.$lF=P;function A(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(P)}e.$mF=A;var w;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var $;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$nF=(0,d.$8h)("IChatService"),e.$oF="accessibility.voice.keywordActivation"}),define(ke[140],Se([1,0,4,8,226]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lb=void 0;class P{constructor(){this.f=new Map,this.k=[],this.m=new D.$Wd,this.n=new D.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(w){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=w}onEvent(w){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=w}onRequest(w){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.s("response",w)}sendRequest(w,$,E,R){const C={command:w};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const k=this.f.get(C.seq);if(k){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:w,message:(0,d.localize)(0,null,R,w)};k(S)}},R)}return E&&this.f.set(C.seq,E),C.seq}acceptMessage(w){this.j?this.j(w):(this.k.push(w),this.k.length===1&&this.q())}o(w,$){return w.type!=="event"||$.type!=="event"}async q(){let w;for(;this.k.length;){if((!w||this.o(this.k[0],w))&&await(0,M.$9g)(0),w=this.k.shift(),!w)return;switch(w.type){case"event":this.i?.(w);break;case"request":this.g?.(w);break;case"response":{const $=w,E=this.f.get($.request_seq);E&&(this.f.delete($.request_seq),E($));break}}}}s(w,$){$.type=w,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach(($,E)=>w.set(E,$)),await(0,M.$9g)(500),w.forEach(($,E)=>{$({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$_lb=P}),define(ke[280],Se([1,0,2,227,45,5]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$VH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$UH=e.MemoryRangeType=e.$TH=e.State=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=void 0,e.$NG="workbench.view.debug",e.$OG="workbench.debug.variablesView",e.$PG="workbench.debug.watchExpressionsView",e.$QG="workbench.debug.callStackView",e.$RG="workbench.debug.loadedScriptsView",e.$SG="workbench.debug.breakPointsView",e.$TG="workbench.debug.disassemblyView",e.$UG="workbench.panel.repl",e.$VG="workbench.panel.repl.view",e.$WG=new d.$mj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$XG=new d.$mj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$YG=new d.$mj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$ZG="debugUx",e.$1G=new d.$mj(e.$ZG,"default",{type:"string",description:M.localize(3,null)}),e.$2G=new d.$mj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$3G=new d.$mj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$4G=new d.$mj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$5G=new d.$mj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$6G=new d.$mj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$7G=new d.$mj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$8G=new d.$mj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$9G=new d.$mj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$0G=new d.$mj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$$G=new d.$mj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$_G=new d.$mj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$aH=new d.$mj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$bH=new d.$mj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$cH=new d.$mj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$dH=new d.$mj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$eH=new d.$mj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$fH=new d.$mj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$gH=new d.$mj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$hH=new d.$mj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(22,null)}),e.$iH=new d.$mj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(23,null)}),e.$jH=new d.$mj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(24,null)}),e.$kH=new d.$mj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(25,null)}),e.$lH=new d.$mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(26,null)}),e.$mH=new d.$mj("stepBackSupported",!1,{type:"boolean",description:M.localize(27,null)}),e.$nH=new d.$mj("restartFrameSupported",!1,{type:"boolean",description:M.localize(28,null)}),e.$oH=new d.$mj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(29,null)}),e.$pH=new d.$mj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$qH=new d.$mj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(31,null)}),e.$rH=new d.$mj("breakpointsExist",!1,{type:"boolean",description:M.localize(32,null)}),e.$sH=new d.$mj("debuggersAvailable",!1,{type:"boolean",description:M.localize(33,null)}),e.$tH=new d.$mj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(34,null)}),e.$uH=new d.$mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(35,null)}),e.$vH=new d.$mj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(36,null)}),e.$wH=new d.$mj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(37,null)}),e.$xH=new d.$mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$yH=new d.$mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$zH=new d.$mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$AH=new d.$mj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$BH=new d.$mj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$CH=new d.$mj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(43,null)}),e.$DH=new d.$mj("variableIsReadonly",!1,{type:"boolean",description:M.localize(44,null)}),e.$EH=new d.$mj("variableValue",!1,{type:"string",description:M.localize(45,null)}),e.$FH=new d.$mj("variableType",!1,{type:"string",description:M.localize(46,null)}),e.$GH=new d.$mj("variableName",!1,{type:"string",description:M.localize(47,null)}),e.$HH=new d.$mj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(48,null)}),e.$IH=new d.$mj("multiSessionRepl",!1,{type:"boolean",description:M.localize(49,null)}),e.$JH=new d.$mj("multiSessionDebug",!1,{type:"boolean",description:M.localize(50,null)}),e.$KH=new d.$mj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(51,null)}),e.$LH=new d.$mj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(52,null)}),e.$MH=new d.$mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(53,null)}),e.$NH=new d.$mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(54,null)});const A=c=>M.localize(55,null,c);e.$OH=A,e.$PH="editor.contrib.debug",e.$QH="editor.contrib.breakpoint",e.$RH="debug",e.$SH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(56,null)};var w;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(w||(e.State=w={}));function $(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$TH=$;var E;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$UH="vscode-debug-memory";var R;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var C;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$VH=(0,P.$8h)("debugService");var p;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE",c[c.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var k;(function(c){c[c.Command=0]="Command",c[c.Tree=1]="Tree"})(k||(e.DebugVisualizationType=k={}));var S;(function(c){c.deserialize=m=>({id:m.id,name:m.name,iconPath:m.iconPath&&{light:D.URI.revive(m.iconPath.light),dark:D.URI.revive(m.iconPath.dark)},iconClass:m.iconClass,visualization:m.visualization}),c.serialize=m=>m})(S||(e.IDebugVisualization=S={}))}),define(ke[281],Se([1,0,13,2,17,24,15,29,22,19]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0;const R=/{([^}]+)}/g;function C(I,b,g){return I.replace(R,function(y,L){return b&&L.length>0&&L[0]!=="_"?y:g&&g.hasOwnProperty(L)?g[L]:y})}e.$cG=C;function p(I){const b={};for(const g of Object.keys(I))g.startsWith("!")||(b[g]=I[g]);return b}e.$dG=p;function k(I){return I.configuration.request==="attach"&&!S(I)&&(!I.parentSession||k(I.parentSession))}e.$eG=k;function S(I){let b=I.configuration.type;if(b)return b==="vslsShare"&&(b=I.configuration.adapterProxy.configuration.type),(0,D.$af)(b,"extensionhost")||(0,D.$af)(b,"pwa-extensionhost")?I:I.parentSession?S(I.parentSession):void 0}e.$fG=S;function c(I){return I.type&&(I.label||I.program||I.runtime)}e.$gG=c;function m(I,b,g){let y,L=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=T.exec(I);){const j=U.index+1,F=j+U[0].length;if(j<=b&&F>=g){y=U[0],L=j;break}}if(y){const j=/\w+/g;let F=null;for(;(F=j.exec(y))&&!(F.index+1+L+F[0].length>=g););F&&(y=y.substring(0,j.lastIndex))}return y?{start:L,end:L+y.length-1}:{start:0,end:0}}e.$hG=m;async function a(I,b,g,y){if(I.evaluatableExpressionProvider.has(b)){const L=I.evaluatableExpressionProvider.ordered(b),T=(0,E.$Hb)(await Promise.all(L.map(async U=>{try{return await U.provideEvaluatableExpression(b,g,y??$.CancellationToken.None)}catch{return}})));if(T.length>0){let U=T[0].expression;const j=T[0].range;return U||(U=b.getLineContent(g.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:U}}}else{const L=b.getLineContent(g.lineNumber),{start:T,end:U}=m(L,g.column,g.column),j=L.substring(T-1,U);return{matchingExpression:j,range:new w.$Ws(g.lineNumber,T,g.lineNumber,T+j.length)}}return null}e.$iG=a;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(I){return!!(I&&I.match(i))}e.$jG=r;function n(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(r(I.path))return M.URI.parse(I.path);if((0,d.$ic)(I.path))return M.URI.file(I.path)}return I.path}function o(I){if(typeof I.path=="object"){const b=M.URI.revive(I.path);if(b)return b.scheme===A.Schemas.file?b.fsPath:b.toString()}return I.path}function t(I,b){const g=b?n:o,y=(0,P.$yn)(I);return s(y,(L,T)=>{L&&T&&(T.path=g(T))}),y}e.$kG=t;function h(I,b){const g=b?n:o,y=(0,P.$yn)(I);return s(y,(L,T)=>{!L&&T&&(T.path=g(T))}),y}e.$lG=h;function s(I,b){switch(I.type){case"event":{const g=I;switch(g.event){case"output":b(!1,g.body.source);break;case"loadedSource":b(!1,g.body.source);break;case"breakpoint":b(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=I;switch(g.command){case"setBreakpoints":b(!0,g.arguments.source);break;case"breakpointLocations":b(!0,g.arguments.source);break;case"source":b(!0,g.arguments.source);break;case"gotoTargets":b(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(y=>b(!1,y));break;default:break}break}case"response":{const g=I;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(y=>b(!1,y.source));break;case"loadedSources":g.body.sources.forEach(y=>b(!1,y));break;case"scopes":g.body.scopes.forEach(y=>b(!1,y.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(y=>b(!1,y.source));break;case"setBreakpoints":g.body.breakpoints.forEach(y=>b(!1,y.source));break;case"disassemble":g.body?.instructions.forEach(L=>b(!1,L.location));break;default:break}break}}}function f(I){return I.filter(b=>!b.presentation?.hidden).sort((b,g)=>b.presentation?g.presentation?b.presentation.group?g.presentation.group?b.presentation.group!==g.presentation.group?b.presentation.group.localeCompare(g.presentation.group):l(b.presentation.order,g.presentation.order):-1:g.presentation.group?1:l(b.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$mG=f;function l(I,b){return typeof I!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:I-b}async function u(I,b){const g=I.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(g!=="none"&&(await b.saveAll(),g==="allEditorsInActiveGroup")){const y=b.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await b.save({editor:y.input,groupId:y.group.id})}await I.reloadConfiguration()}e.$nG=u;const v=(I,b)=>!I||!b?I===b:I.name===b.name&&I.path===b.path&&I.sourceReference===b.sourceReference;e.$oG=v}),define(ke[282],Se([1,0,50,62,24,17,11,13,31,228,140]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=e.$hic=e.$gic=e.$fic=void 0;class C extends R.$_lb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(a,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,a.on("data",r=>this.w(r))}sendMessage(a){if(this.p){const i=JSON.stringify(a);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(a){for(this.r=Buffer.concat([this.r,a]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this.m.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(C.b);for(const o of n){const t=o.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$fic=C;class p extends C{startSession(){return new Promise((a,i)=>{let r=!1;this.x=this.y(()=>{this.v(this.x,this.x),a(),r=!0}),this.x.on("close",()=>{r?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{r?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$gic=p;class k extends p{constructor(a){super(),this.z=a}y(a){return M.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$hic=k;class S extends p{constructor(a){super(),this.z=a}y(a){return M.createConnection(this.z.path,a)}}e.$iic=S;class c extends C{constructor(a,i){super(),this.y=a,this.z=i}async startSession(){const a=this.y.command,i=this.y.args,r=this.y.options||{};try{if(a)if(P.$ic(a)){if(!await $.Promises.exists(a))throw new Error(E.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=d.$Bn(d.$yn(process.env),r.env)),a==="node")if(Array.isArray(i)&&i.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const h=D.fork(i[0],i.slice(1),t);if(!h.pid)throw new Error(E.localize(2,null,i[0]));this.x=h}else throw new Error(E.localize(3,null));else{const o={env:n};r.cwd&&(o.cwd=r.cwd),this.x=D.spawn(a,i,o)}this.x.on("error",o=>{this.m.fire(o)}),this.x.on("exit",(o,t)=>{this.n.fire(o)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.m.fire(o)}),this.x.stdin.on("error",o=>{this.m.fire(o)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((a,i)=>{const r=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,o,t){if(n)return i(n)});r.on("exit",a),r.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,i){if(!a)return;const r=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?r.runtime=P.$jc(i,a.runtime):r.runtime=a.runtime),a.runtimeArgs&&(r.runtimeArgs=a.runtimeArgs),a.program&&(P.$ic(a.program)?r.program=a.program:r.program=P.$jc(i,a.program)),a.args&&(r.args=a.args);const n=a;return n.win&&(r.win=c.A(n.win,i)),n.winx86&&(r.winx86=c.A(n.winx86,i)),n.windows&&(r.windows=c.A(n.windows,i)),n.osx&&(r.osx=c.A(n.osx,i)),n.linux&&(r.linux=c.A(n.linux,i)),r}static platformAdapterExecutable(a,i){let r=Object.create(null);i=i.toLowerCase();for(const f of a)if(f.contributes){const l=f.contributes.debuggers;l&&l.length>0&&l.filter(u=>typeof u.type=="string"&&w.$af(u.type,i)).forEach(u=>{const v=c.A(u,f.extensionLocation.fsPath);r=d.$Bn(r,v,f.isBuiltin)})}let n;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:A.$i?n=r.win||r.windows:A.$j?n=r.osx:A.$k&&(n=r.linux),n=n||r;const o=n.program||r.program,t=n.args||r.args,h=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(h)return{type:"executable",command:h,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$jic=c}),define(ke[283],Se([1,0,50,34,11]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=e.$kic=void 0;function P(E,R){return new Promise((C,p)=>{let k="";const S=D.spawn(E,R);S.pid&&S.stdout.on("data",c=>{k+=c.toString()}),S.on("error",c=>{p(c)}),S.on("close",c=>{C(k)})})}async function A(E){if(E)if(d.$i){const R=await new Promise((C,p)=>{$e(["@vscode/windows-process-tree"],C,p)});return new Promise(C=>{R.getProcessTree(E,p=>{C(!!p&&p.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(E)]).then(R=>{const C=R.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$kic=A;var w;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(w||(w={}));function $(E,R,C,p,k){E=E.trim().toLowerCase();let S;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?S=1:E.indexOf("cmd.exe")>=0?S=0:E.indexOf("bash")>=0?S=2:d.$i?S=0:S=2;let c,m=" ";switch(S){case 1:if(c=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),p){const a=(0,M.$bg)(p);a&&(m+=`${a}:; `),m+=`cd ${c(p)}; `}if(k)for(const a in k){const i=k[a];i===null?m+=`Remove-Item env:${a}; `:m+=`\${env:${a}}='${i}'; `}if(R.length>0){const a=R.shift(),i=C?a:c(a);m+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of R)m+=r==="<"||r===">"||C?r:c(r),m+=" "}break;case 0:if(c=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>a.includes(i))||a.length===0?`"${a}"`:a),p){const a=(0,M.$bg)(p);a&&(m+=`${a}: && `),m+=`cd ${c(p)} && `}if(k){m+='cmd /C "';for(const a in k){let i=k[a];i===null?m+=`set "${a}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),m+=`set "${a}=${i}" && `)}}for(const a of R)m+=a==="<"||a===">"||C?a:c(a),m+=" ";k&&(m+='"');break;case 2:{c=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const a=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(p&&(m+=`cd ${c(p)} ; `),k){m+="/usr/bin/env";for(const i in k){const r=k[i];r===null?m+=` -u ${a(i)}`:m+=` ${a(`${i}=${r}`)}`}m+=" "}for(const i of R)m+=i==="<"||i===">"||C?i:c(i),m+=" ";break}}return m}e.$lic=$}),define(ke[284],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.CellExecutionUpdateType=void 0;var M;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$rJ=(0,D.$8h)("INotebookExecutionService")}),define(ke[285],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffb=e.$Efb=e.ProxyKernelState=e.$Dfb=void 0,e.$Dfb=100;var M;(function(d){d[d.Disconnected=1]="Disconnected",d[d.Connected=2]="Connected",d[d.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$Efb=(0,D.$8h)("INotebookKernelService"),e.$Ffb=(0,D.$8h)("INotebookKernelHistoryService")}),define(ke[286],Se([1,0,3,29,193,99]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GRb=void 0;class A extends D.$Tc{constructor($,E,R){super(),this._source=$,this.b=E,this.c=R,this.a=void 0}f($){const E=$.getLineCount();return new M.$Ws(1,1,E,this.g($,E))}g($,E){if(E<1||E>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const $=new d.$eC;$.acceptChunk(this._source);const E=$.finish(!0),{textBuffer:R,disposable:C}=E.create(1);this.b=R,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const E=new d.$eC;E.acceptChunk($);const R=E.finish(!0),{textBuffer:C,disposable:p}=R.create(1);return this.B(p),C})),this.a}findInInputs($){const R=new P.$5B($,!1,!1,null).parseSearchRequest();if(!R)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,R,!0,5e3)}findInOutputs($){const R=new P.$5B($,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(C=>{const p=C.findMatchesLineByLine(this.f(C),R,!0,5e3);if(p.length!==0)return{textBuffer:C,matches:p}}).filter(C=>!!C):[]}}e.$GRb=A}),define(ke[68],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(P){P.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var M;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class d{static fromExtHostTestItem(A,w,$=A.parent){if(A._isRoot)return new d([w]);const E=[A.id];for(let R=$;R&&R.id!==w;R=R.parent)E.push(R.id);return E.push(w),new d(E.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const w=A.indexOf("\0");return w===-1?A:A.slice(0,w)}static fromString(A){return new d(A.split("\0"))}static join(A,w){return new d([...A.path,w])}static joinToString(A,w){return A.toString()+"\0"+w}static parentId(A){const w=A.lastIndexOf("\0");return w===-1?void 0:A.slice(0,w)}static localId(A){const w=A.lastIndexOf("\0");return w===-1?A:A.slice(w+1)}static isChild(A,w){return w.startsWith(A)&&w[A.length]==="\0"}static compare(A,w){return A===w?0:d.isChild(A,w)?2:d.isChild(w,A)?3:1}constructor(A,w=A.length){if(this.path=A,this.d=w,A.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.d>1?new d(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new d(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new d(this.path,A)}compare(A){if(typeof A=="string")return d.compare(this.toString(),A);for(let w=0;w<A.d&&w<this.d;w++)if(A.path[w]!==this.path[w])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$cK=d}),define(ke[89],Se([1,0,2,48,29,68]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$jK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$iK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$hK=e.$gK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$fK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$eK=e.$dK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var w;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var $;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$dK=[2,4,8,16,32,64];const E=N=>"runId"in N;e.$eK=E;var R;(function(N){N.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),N.deserialize=(O,z)=>({range:d.$Ws.lift(z.range),uri:O.asCanonicalUri(D.URI.revive(z.uri))})})(R||(e.IRichLocation=R={}));var C;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(C||(e.TestMessageType=C={}));var p;(function(N){N.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&R.serialize(O.location)}),N.deserialize=(O,z)=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&R.deserialize(O,z.location)})})(p||(e.ITestErrorMessage=p={}));const k=(N,O)=>`${O?"s":"e"}${N}`;e.$fK=k;var S;(function(N){N.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&R.serialize(O.location)}),N.deserialize=(O,z)=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&R.deserialize(O,z.location)})})(S||(e.ITestOutputMessage=S={}));var c;(function(N){N.serialize=O=>O.type===0?p.serialize(O):S.serialize(O),N.deserialize=(O,z)=>z.type===0?p.deserialize(O,z):S.deserialize(O,z)})(c||(e.ITestMessage=c={}));var m;(function(N){N.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),N.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(c.serialize)}),N.deserialize=(O,z)=>({state:z.state,duration:z.duration,messages:z.messages.map(K=>c.deserialize(O,K))})})(m||(e.ITestTaskState=m={}));const a="\0",i=(N,O)=>N+a+O;e.$gK=i;const r=N=>{const O=N.indexOf(a);return{ctrlId:N.slice(0,O),tagId:N.slice(O+1)}};e.$hK=r;var n;(function(N){N.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),N.deserialize=(O,z)=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?O.asCanonicalUri(D.URI.revive(z.uri)):void 0,range:z.range?d.$Ws.lift(z.range):null,description:z.description,error:z.error,sortText:z.sortText})})(n||(e.ITestItem=n={}));var o;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(N){N.serialize=O=>({expand:O.expand,item:n.serialize(O.item)}),N.deserialize=(O,z)=>({controllerId:P.$cK.root(z.item.extId),expand:z.expand,item:n.deserialize(O,z.item)})})(t||(e.InternalTestItem=t={}));var h;(function(N){N.serialize=O=>{let z;return O.item&&(z={},O.item.label!==void 0&&(z.label=O.item.label),O.item.tags!==void 0&&(z.tags=O.item.tags),O.item.busy!==void 0&&(z.busy=O.item.busy),O.item.uri!==void 0&&(z.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(z.range=O.item.range?.toJSON()),O.item.description!==void 0&&(z.description=O.item.description),O.item.error!==void 0&&(z.error=O.item.error),O.item.sortText!==void 0&&(z.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:z}},N.deserialize=O=>{let z;return O.item&&(z={},O.item.label!==void 0&&(z.label=O.item.label),O.item.tags!==void 0&&(z.tags=O.item.tags),O.item.busy!==void 0&&(z.busy=O.item.busy),O.item.range!==void 0&&(z.range=O.item.range?d.$Ws.lift(O.item.range):null),O.item.description!==void 0&&(z.description=O.item.description),O.item.error!==void 0&&(z.error=O.item.error),O.item.sortText!==void 0&&(z.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:z}}})(h||(e.ITestItemUpdate=h={}));const s=(N,O)=>{O.expand!==void 0&&(N.expand=O.expand),O.item!==void 0&&(N.item=N.item?Object.assign(N.item,O.item):O.item)};e.$iK=s;var f;(function(N){N.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(m.serializeWithoutMessages)}),N.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(m.serialize)}),N.deserialize=(O,z)=>({...t.deserialize(O,z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(K=>m.deserialize(O,K)),retired:!0})})(f||(e.TestResultItem=f={}));var l;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(O,z)=>{O.covered+=z.covered,O.total+=z.total}})(l||(e.ICoveredCount=l={}));var u;(function(N){N.serialize=O=>({statement:O.statement,branch:O.branch,function:O.function,details:O.details?.map(g.serialize),uri:O.uri.toJSON()}),N.deserialize=(O,z)=>({statement:z.statement,branch:z.branch,function:z.function,details:z.details?.map(g.deserialize),uri:O.asCanonicalUri(D.URI.revive(z.uri))})})(u||(e.IFileCoverage=u={}));function v(N){return{...N,location:N.location?.toJSON()}}function I(N){return N.location=N.location?M.$Vs.isIPosition(N.location)?M.$Vs.lift(N.location):d.$Ws.lift(N.location):void 0,N}e.$jK=3;var b;(function(N){N[N.Function=0]="Function",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(b||(e.DetailType=b={}));var g;(function(N){N.serialize=O=>O.type===0?L.serialize(O):T.serialize(O),N.deserialize=O=>O.type===0?L.deserialize(O):T.deserialize(O)})(g||(e.CoverageDetails=g={}));var y;(function(N){N.serialize=v,N.deserialize=I})(y||(e.IBranchCoverage=y={}));var L;(function(N){N.serialize=v,N.deserialize=I})(L||(e.IFunctionCoverage=L={}));var T;(function(N){N.serialize=O=>({...v(O),branches:O.branches?.map(y.serialize)}),N.deserialize=O=>({...I(O),branches:O.branches?.map(y.deserialize)})})(T||(e.IStatementCoverage=T={}));var U;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var j;(function(N){N.deserialize=(O,z)=>z.op===0?{op:z.op,item:t.deserialize(O,z.item)}:z.op===1?{op:z.op,item:h.deserialize(z.item)}:z.op===2?{op:z.op,uri:O.asCanonicalUri(D.URI.revive(z.uri)),docv:z.docv}:z,N.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:h.serialize(O.item)}:O})(j||(e.TestsDiffOp=j={}));class F{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const z=this.v();for(const K of O)switch(K.op){case 0:this.l(t.deserialize(this.k,K.item),z);break;case 1:this.o(h.deserialize(K.item),z);break;case 3:this.p(K.itemId,z);break;case 5:this.q(K.itemId);break;case 4:this.updatePendingRoots(K.amount);break;case 6:this.c.set(K.tag.id,K.tag);break;case 7:this.c.delete(K.id);break}z.complete?.()}l(O,z){const K=P.$cK.parentId(O.item.extId)?.toString();let te;if(!K)te=this.w(O),this.g.add(te),this.f.set(O.item.extId,te);else if(this.f.has(K)){const x=this.f.get(K);x.children.add(O.item.extId),te=this.w(O,x),this.f.set(O.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return z.add?.(te),O.expand===2&&this.h++,te}o(O,z){const K=this.f.get(O.extId);if(K)return O.expand!==void 0&&(K.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$iK)(K,O),z.update?.(K),K}p(O,z){const K=this.f.get(O);if(!K)return;const te=P.$cK.parentId(K.item.extId)?.toString();te?this.f.get(te).children.delete(K.item.extId):this.g.delete(K);const x=[[O]];for(;x.length;)for(const X of x.pop()){const Z=this.f.get(X);Z&&(x.push(Z.children),this.f.delete(X),z.remove?.(Z,Z!==K),Z.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$kK=F}),define(ke[111],Se([1,0,8,4,3,61,89,68]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const E=(i,r)=>i===r,C=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),p=(i,r)=>{let n;for(const[o,t]of C)t(i[o],r[o])||(n?n[o]=r[o]:n={[o]:r[o]});return n};class k extends d.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new D.$hh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,A.$iK)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,A.$iK)(n.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,n){const o=this.tree.get(r);if(o){if((o.expandLevels===void 0||n>o.expandLevels)&&(o.expandLevels=n),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,n-1):t.wait().then(()=>this.L(o,n-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,n-1)):this.L(o,n-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,n){switch(n.op){case 3:this.O(w.$cK.joinToString(r.fullId,n.id));break;case 0:this.z(n.item,r);break;case 5:for(const o of n.ops)this.w(r,o);break;case 1:this.C(n.new,n.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.y(r.actual.uri);break;default:(0,P.$6c)(n)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,n){const o=w.$cK.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(r.id);let h=this.tree.get(o.toString());if(!h){h={fullId:o,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(h.fullId.toString(),h),this.G(r,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:h.expand,item:this.s.toITestItem(r)}}),this.I(r,h,n);return}if(h.actual===r){this.H(r,h,n);return}if(h.actual.uri?.toString()!==r.uri?.toString())return this.O(o.toString()),this.z(r,n);const s=this.s.getChildren(h.actual),f=h.actual,l=p(this.s.toITestItem(f),this.s.toITestItem(r));this.s.getApiFor(f).listener=void 0,h.actual=r,h.expand=0,l&&(l.hasOwnProperty("tags")&&(this.C(r.tags,f.tags,o.toString()),delete l.tags),this.w(h,{op:4,update:l})),this.I(r,h,n);for(const[u,v]of s)this.s.getChildren(r).get(v.id)||this.O(w.$cK.joinToString(o,v.id));this.y(h.actual.uri)}C(r,n,o){const t=new Set(n.map(h=>h.id));for(const h of r)t.delete(h.id)||this.D(h);this.pushDiff({op:1,item:{extId:o,item:{tags:r.map(h=>(0,A.$gK)(this.s.controllerId,h.id))}}}),t.forEach(this.F,this)}D(r){const n=this.j.get(r.id);n?n.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$gK)(this.s.controllerId,r.id)}}))}F(r){const n=this.j.get(r);n&&!--n.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,A.$gK)(this.s.controllerId,r)}))}G(r,n){this.s.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}H(r,n,o){this.G(r,o);const t=this.s.getApiFor(r);t.parent=o?.actual,t.listener=h=>this.w(n,h),this.J(n)}I(r,n,o){this.H(r,n,o);for(const[t,h]of this.s.getChildren(r))this.z(h,n)}J(r){let n;this.h?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.M(r))}L(r,n){if(n<0)return;const o=[];for(const[t,h]of this.s.getChildren(r.actual)){const s=this.expand(w.$cK.joinToString(r.fullId,h.id),n);(0,D.$Tg)(s)&&o.push(s)}if(o.length)return Promise.all(o).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const h=new D.$7g;return h.open(),h}r.expand=2,this.N(r);const n=r.resolveBarrier=new D.$7g,o=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,h)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(h){o(h)}return(0,D.$Tg)(t)?t.catch(o).then(()=>{n.open(),this.J(r)}):(n.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const o=[n];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.F(h.id);this.tree.delete(t.fullId.toString());for(const[h,s]of this.s.getChildren(t.actual))o.push(this.tree.get(w.$cK.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$fN=k;class S extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$gN=S;class c extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$hN=c;class m extends Error{constructor(r,n,o){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${o}".`)}}e.$iN=m;const a=(i,r,n)=>{let o=new Map;return{get size(){return o.size},forEach(t,h){for(const s of o.values())t.call(h,s,this)},[Symbol.iterator](){return o.entries()},replace(t){const h=new Map,s=new Set(o.keys()),f={op:5,ops:[]};for(const l of t){if(!(l instanceof n))throw new c(l.id);const u=r(l).controllerId;if(u!==i.controllerId)throw new m(l.id,u,i.controllerId);if(h.has(l.id))throw new S(l.id);h.set(l.id,l),s.delete(l.id),f.ops.push({op:0,item:l})}for(const l of s.keys())f.ops.push({op:3,id:l});i.listener?.(f),o=h},add(t){if(!(t instanceof n))throw new c(t.id);o.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){o.delete(t)&&i.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$jN=a}),define(ke[141],Se([1,0,111]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=void 0;const M=new WeakMap,d=(A,w)=>{const $={controllerId:w};return M.set(A,$),$};e.$kN=d;const P=A=>{const w=M.get(A);if(!w)throw new D.$hN(A?.id||"<unknown>");return w};e.$lN=P}),define(ke[112],Se([1,0,15,2]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pwb=e.$owb=e.$nwb=e.$mwb=e.$lwb=void 0,e.$lwb="vscode-cdn.net",e.$mwb=`vscode-resource.${e.$lwb}`,e.$nwb=`'self' https://*.${e.$lwb}`;function d(w,$){return w.scheme===D.Schemas.http||w.scheme===D.Schemas.https?w:($&&$.authority&&$.isRemote&&w.scheme===D.Schemas.file&&(w=M.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:w.path})),M.URI.from({scheme:D.Schemas.https,authority:`${w.scheme}+${P(w.authority)}.${e.$mwb}`,path:w.path,fragment:w.fragment,query:w.query}))}e.$owb=d;function P(w){return w.replace(/./g,$=>{const E=$.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?$:"-"+E.toString(16).padStart(4,"0")})}function A(w){return w.replace(/-([0-9a-f]{4})/g,($,E)=>String.fromCharCode(parseInt(E,16)))}e.$pwb=A}),define(ke[287],Se([1,0,4,3,112]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class P{constructor(w,$,E){this.d=w,this.e=$,this.f=E,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const C of this.c.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,$,E,R,C){let p;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===w){p=r;break}if(!p)throw new Error("not a visible editor");const k=this,S=this.a++,c=new D.$Wd,m=new D.$Wd,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,d.$owb)(r,k.f)}get cspSource(){return d.$nwb}set options(r){this.b=r,k.d.$setOptions(S,r)}get options(){return this.b}set html(r){this.a=r,k.d.$setHtml(S,r)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(r){return k.d.$postMessage(S,r)}},i=new class{constructor(){this.editor=w,this.line=$,this.height=E,this.webview=a,this.onDidDispose=m.event}dispose(){k.c.has(S)&&(k.c.delete(S),k.d.$disposeEditorInset(S),m.fire(),m.dispose(),c.dispose())}};return this.d.$createEditorInset(S,p.id,p.value.document.uri,$+1,E,R||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:w,inset:i,onDidReceiveMessage:c}),i}$onDidDispose(w){const $=this.c.get(w);$&&$.inset.dispose()}$onDidReceiveMessage(w,$){this.c.get(w)?.onDidReceiveMessage.fire($)}}e.$jgc=P}),define(ke[288],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=e.VariableKind=e.$bO=void 0,e.$bO=(0,D.$8h)("configurationResolverService");var M;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class d extends Error{constructor(A,w){super(w),this.variable=A}}e.$cO=d}),define(ke[289],Se([1,0,17,49,18,24,11,102,231,288,13]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,S,c,m){this.h=new Map,this.a=k,this.b=S,this.g=c,m&&(this.c=m.then(a=>this.i(a)))}i(k){if(A.$i){const S=Object.create(null);return Object.keys(k).forEach(c=>{S[c.toLowerCase()]=k[c]}),S}return k}resolveWithEnvironment(k,S,c){return this.l({env:this.i(k),userHome:void 0},S?S.uri:void 0,c)}async resolveAsync(k,S){const c={env:await this.c,userHome:await this.g};return this.l(c,k?k.uri:void 0,S)}async j(k,S,c,m){const a=P.$yn(S);A.$i&&a.windows?Object.keys(a.windows).forEach(r=>a[r]=a.windows[r]):A.$j&&a.osx?Object.keys(a.osx).forEach(r=>a[r]=a.osx[r]):A.$k&&a.linux&&Object.keys(a.linux).forEach(r=>a[r]=a.linux[r]),delete a.windows,delete a.osx,delete a.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,k?k.uri:void 0,a,c,m)}async resolveAnyAsync(k,S,c){return this.j(k,S,c)}async resolveAnyMap(k,S,c){const m=new Map;return{newConfig:await this.j(k,S,c,m),resolvedVariables:m}}resolveWithInteractionReplace(k,S,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,S,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,S){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,S)}async l(k,S,c,m,a){if(d.$Jf(c))return this.m(k,S,c,m,a);if(Array.isArray(c))return Promise.all(c.map(i=>this.l(k,S,i,m,a)));if(d.$Lf(c)){const i=Object.create(null),r=await Promise.all(Object.keys(c).map(async n=>[await this.m(k,S,n,m,a),await this.l(k,S,c[n],m,a)]));for(const[n,o]of r)i[n]=o;return i}return c}m(k,S,c,m,a){return(0,R.$5e)(c,C.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(C.VARIABLE_LHS))return i;let n=await this.o(k,i,r,S,m);return a?.set(r,n),n!==i&&d.$Jf(n)&&n.match(C.VARIABLE_REGEXP)&&(n=await this.m(k,S,n,m,a)),n})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,S,c,m,a){let i;const r=c.split(":");r.length>1&&(c=r[0],i=r[1]);const n=h=>{const s=this.a.getFilePath();if(s)return(0,w.$Yv)(s);throw new E.$cO(h,(0,$.localize)(0,null,S))},o=h=>{const s=n(h);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,w.$Yv)(f)}throw new E.$cO(h,(0,$.localize)(1,null,S,D.$nc(s)))},t=h=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new E.$cO(h,(0,$.localize)(2,null,S,i))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new E.$cO(h,(0,$.localize)(3,null,S)):new E.$cO(h,(0,$.localize)(4,null,S))};switch(c){case"env":if(i){if(k.env){const h=k.env[A.$i?i.toLowerCase():i];if(d.$Jf(h))return h}return""}throw new E.$cO(E.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const h=this.a.getConfigurationValue(m,i);if(d.$Sf(h))throw new E.$cO(E.VariableKind.Config,(0,$.localize)(6,null,S,i));if(d.$Lf(h))throw new E.$cO(E.VariableKind.Config,(0,$.localize)(7,null,S,i));return h}throw new E.$cO(E.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(E.VariableKind.Command,S,i,a,"command");case"input":return this.p(E.VariableKind.Input,S,i,a,"input");case"extensionInstallFolder":if(i){const h=await this.a.getExtension(i);if(!h)throw new E.$cO(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(h.extensionLocation)}throw new E.$cO(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,w.$Yv)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,w.$Yv)(this.n(t(E.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$Yv)(D.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new E.$cO(E.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new E.$cO(E.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new E.$cO(E.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return n(E.VariableKind.File);case"fileWorkspaceFolder":return o(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(o(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?D.$lc(this.n(t(E.VariableKind.RelativeFile)),n(E.VariableKind.RelativeFile)):n(E.VariableKind.RelativeFile);case"relativeFileDirname":{const h=D.$mc(n(E.VariableKind.RelativeFileDirname));if(m||i){const s=D.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),h);return s.length===0?".":s}return h}case"fileDirname":return D.$mc(n(E.VariableKind.FileDirname));case"fileExtname":return D.$oc(n(E.VariableKind.FileExtname));case"fileBasename":return D.$nc(n(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=D.$nc(n(E.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-D.$oc(h).length)}case"fileDirnameBasename":return D.$nc(D.$mc(n(E.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||S}case"execInstallFolder":{const h=this.a.getAppRoot();return h||S}case"pathSeparator":case"/":return D.sep;default:try{const h=i?`${c}:${i}`:c;return this.p(E.VariableKind.Unknown,S,h,a,void 0)}catch{return S}}}}p(k,S,c,m,a){if(c&&m){const i=a===void 0?m[c]:m[a+":"+c];if(typeof i=="string")return i;throw new E.$cO(k,(0,$.localize)(14,null,S))}return S}}e.$qO=C}),define(ke[142],Se([1,0,5,139]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,D.$8h)("editorGroupsService");var d;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var P;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var A;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var w;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function E(S){const c=S;return(0,M.$WE)(c?.editor)&&(0,M.$WE)(c?.replacement)}e.$bD=E;var R;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function p(S){const c=S;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$cD=p;function k(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=k}),define(ke[290],Se([1,0,5,142]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,D.$8h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function d(P){const A=P;return typeof P=="number"||(0,M.$cD)(A)}e.$iD=d}),define(ke[143],Se([1,0,5,133]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=void 0,e.$HK=(0,D.$9h)(M.$ci)}),define(ke[144],Se([1,0,25,4,17,3,8]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=e.$97b=e.$87b=e.$77b=e.$67b=void 0;class w{constructor(i,r){this.versionId=i,this.removedDueToLooping=r}}e.$67b=w;class ${static isHostExtension(i,r,n){if(r.getExtensionDescription(i))return!1;const o=n.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,r){this.j=i,this.c=new M.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(c),this.f=new D.$pm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const r=this.j.readActivationEvents(i);for(const n of r)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,r){this.e=m(this.e,r),this.e=this.e.concat(i);const n=$.l(this.e);return this.e=m(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new w(this.d,n)}static l(i){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,f){this.addNode(s),this.addNode(f),this.c.has(s)?this.c.get(s).push(f):this.c.set(s,[f])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,f){const l=r.getArcs(s);for(let u=0;u<l.length;u++)if(!f.has(l[u]))return!1;return!0}getNodes(){return this.e}},n=new D.$pm;for(const s of i)if(n.set(s.identifier,s),s.extensionDependencies)for(const f of s.extensionDependencies)r.addArc(D.$nm.toKey(s.identifier),D.$nm.toKey(f));const o=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>o.add(s));const t=r.getNodes().filter(s=>!o.has(s));let h;do{h=!1;for(let s=0;s<t.length;s++){const f=t[s];r.hasOnlyGoodArcs(f,o)&&(t.splice(s,1),s--,o.add(f),h=!0)}}while(h);return t.map(s=>n.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const r=this.h.get(i);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const r=this.f.get(i);return r||void 0}getExtensionDescriptionByUUID(i){for(const r of this.g)if(r.uuid===i)return r}getExtensionDescriptionByIdOrUUID(i,r){return this.getExtensionDescription(i)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$77b=$;class E{constructor(i,r){this.versionId=i,this.extensions=r}}e.$87b=E;class R{constructor(i){this.d=new k,this.c=new $(i,[])}async acquireLock(i){const r=await this.d.acquire(i);return new C(this,r)}deltaExtensions(i,r,n){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,n)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,r){return this.c.getExtensionDescriptionByIdOrUUID(i,r)}}e.$97b=R;class C extends P.$Tc{constructor(i,r){super(),this.f=i,this.c=!1,this.B(r)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$07b=C;class p{constructor(i){this.name=i;const r=(0,A.$1g)();this.promise=r.promise,this.c=r.resolve}resolve(i){this.c(i)}}class k{constructor(){this.c=[],this.d=!1}async acquire(i){const r=new p(i);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let r=!0;const n=setTimeout(()=>{r&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{r&&(clearTimeout(n),r=!1,this.d=!1,this.e())};i.resolve((0,P.$Rc)(o))}}var S;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(S||(S={}));function c(a,i){const r=a.isBuiltin?0:a.isUnderDevelopment?2:1,n=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(r!==n)return r-n;const o=d.$gc.basename(a.extensionLocation.path),t=d.$gc.basename(i.extensionLocation.path);return o<t?-1:o>t?1:0}function m(a,i){const r=new D.$om(i);return a.filter(n=>!r.has(n.identifier))}}),define(ke[291],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.ExtHostConnectionType=void 0;var D;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class M{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[M.ENV_KEY]=this.pipeName}}e.$Sm=M;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[d.ENV_KEY]="1"}}e.$Tm=d;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[P.ENV_KEY]="1"}}e.$Um=P;function A(R){delete R[M.ENV_KEY],delete R[d.ENV_KEY],delete R[P.ENV_KEY]}function w(R,C){A(C),R.serialize(C)}e.$Vm=w;function $(R){if(R[M.ENV_KEY])return E(R,new M(R[M.ENV_KEY]));if(R[d.ENV_KEY])return E(R,new d);if(R[P.ENV_KEY])return E(R,new P);throw new Error("No connection information defined in environment!")}e.$Wm=$;function E(R,C){return A(R),C}}),define(ke[113],Se([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(M||(e.UIKind=M={}));var d;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var P;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function A(E){const R=D.$ke.alloc(1);switch(E){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$vm=A;function w(E,R){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$wm=w;var $;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Se([1,0,5,4,12,27,113,66,87,24,2,3,217]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=e.$IN=e.$HN=e.$GN=void 0;let k=class extends C.$Tc{constructor(a,i){super(),this.s=a,this.t=i,this.a=this.B(new M.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$So,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,d.$rj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,i,r){const n=this.getTelemetryDetails(),o=new S(i,r,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,i,r){this.f=a,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const i=Object.create(null);switch(i["common.extname"]=`${a.publisher}.${a.name}`,i["common.extversion"]=a.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$dl)((0,$.$Yo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const i=this.getTelemetryDetails();this.r.forEach((r,n)=>{const o=r.filter(t=>!t.isDisposed);o.length===0?this.r.delete(n):this.r.set(n,o)}),this.r.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,i){const n=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(a.value),!1;let o=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),o=!0);return o}};e.$GN=k,e.$GN=k=Ge([Ve(0,P.$FN),Ve(1,d.$qj)],k);class S{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,i,r,n,o,t,h){this.g=r,this.h=n,this.i=o,this.j=t,this.a=new M.$Wd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(a,i){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let i="properties"in a?a.properties??{}:a;return i=(0,$.$2o)(i,[]),this.c&&(i=(0,E.$Bn)(i,this.c)),this.b||(i=(0,E.$Bn)(i,this.j)),"properties"in a?a.properties=i:a=i,a}k(a,i){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(a,i),this.h.trace(a,i))}logUsage(a,i){this.d.isUsageEnabled&&this.k(a,i)}logError(a,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,i);else{const r={name:a.name,message:a.message,stack:a.stack,cause:a.cause},n=(0,$.$2o)(r,[]),o=new Error(n.message,{cause:n.cause});o.stack=n.stack,o.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const a=this,i={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$HN=S;function c(m){const a=Date.now()-new Date(m).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$IN=c,e.$JN=(0,D.$8h)("IExtHostTelemetry")}),define(ke[26],Se([1,0,4,2,261,137,25,5]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new A.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,w.$8h)("extensionService");class ${constructor(o){this.dependency=o}}e.$IF=$;var E;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,h){this.c=o,this.d=t.slice(0),this.e=h.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$qF.createActivationEventsMap(this.d)}}set(o,t,h){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const s=[],f=[],l=[],u=[],v=C(this.d),I=C(t),b=(U,j)=>U.extensionLocation.toString()===j.extensionLocation.toString()||U.isBuiltin===j.isBuiltin||U.isUserBuiltin===j.isUserBuiltin||U.isUnderDevelopment===j.isUnderDevelopment;for(const U of this.d){const j=I.get(U.identifier);if(!j){s.push(U.identifier),v.delete(U.identifier);continue}if(!b(U,j)){s.push(U.identifier),v.delete(U.identifier);continue}}for(const U of t){const j=v.get(U.identifier);if(!j){f.push(U);continue}if(!b(j,U)){s.push(j.identifier),v.delete(j.identifier);continue}}const g=new A.$om(this.e),y=new A.$om(h);for(const U of this.e)y.has(U)||l.push(U);for(const U of h)g.has(U)||u.push(U);const L=P.$qF.createActivationEventsMap(f),T={versionId:o,toRemove:s,toAdd:f,addActivationEvents:L,myToRemove:l,myToAdd:u};return this.delta(T),T}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:h,myToRemove:s,myToAdd:f}=o,l=new A.$om(t),u=new A.$om(s);for(let v=0;v<this.d.length;v++)l.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)u.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of h)this.d.push(v);for(const v of f)this.e.push(v);return this.f=null,o}containsExtension(o){for(const t of this.e)if(A.$nm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const h=P.$qF.readActivationEvents(t);for(const s of h)o.add(s)}return o}}e.$JF=R;function C(n){const o=new A.$pm;for(const t of n)o.set(t.identifier,t);return o}function p(n,o){return n.enabledApiProposals?n.enabledApiProposals.includes(o):!1}e.$KF=p;function k(n,o){if(!p(n,o))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$LF=k;class S{constructor(o,t,h,s){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=s}}e.$MF=S;class c{constructor(o,t){this.description=o,this.value=t}}e.$NF=c;var m;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function a(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,d.$8o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$OF=a;function i(n,o){return{identifier:new A.$nm((0,d.$6o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!o,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$PF=i;class r{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=r}),define(ke[292],Se([1,0,14,144,25,26,12,8]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=e.$Ggc=e.$Fgc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,i,r,n){this.startup=a,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.$Fgc=$;class E{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,i){return a===-1||i===-1?-1:i-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ggc=E;class R{constructor(a,i,r,n,o,t){this.activationFailed=a,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=o,this.subscriptions=t}}e.$Hgc=R;class C extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Igc=C;class p extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jgc=p;class k extends R{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(a,i,r,n){this.g=n,this.a=a,this.b=i,this.c=r,this.d=new d.$pm,this.f=Object.create(null)}dispose(){for(const[a,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const a=[];for(const[i,r]of this.d)a.push(r.wait());await Promise.all(a)}isActivated(a){const i=this.d.get(a);return!!(i&&i.value)}getActivatedExtension(a){const i=this.d.get(a);if(!i||!i.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return i.value}async activateByEvent(a,i){if(this.f[a])return;const r=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,i){const r=this.a.getExtensionDescription(a);if(!r)throw new Error(`Extension '${a}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(a){const i=a.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const i=this.a.getExtensionDescription(a.id);if(!i){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new k(o));return this.c.onExtensionActivationError(a.id,o,new P.$IF(a.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of n){if(this.m(o))continue;const t=this.d.get(o);if(t){r.push(t);continue}if(this.l(o)){r.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const h=this.a.getExtensionDescription(o);if(h){if(!h.main&&!h.browser)continue;r.push(this.j({id:h.identifier,reason:a.reason}));continue}const s=i.displayName||i.identifier.value,f=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${o}'`),l=this.k(a,i.displayName,[],new k(f));return this.c.onExtensionActivationError(i.identifier,f,new P.$IF(o)),l}return this.k(a,i.displayName,r,null)}k(a,i,r,n){const o=new c(a.id,i,a.reason,r,n,this.c,this.g);return this.d.set(a.id,o),o}l(a){return M.$77b.isHostExtension(a,this.a,this.b)}m(a){const i=this.b.getExtensionDescription(a);return i?!i.main&&!i.browser:!1}};e.$Kgc=S,e.$Kgc=S=Ge([Ve(3,A.$pj)],S);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,i,r,n,o,t,h){this.c=a,this.d=i,this.f=r,this.g=n,this.h=o,this.j=t,this.k=h,this.a=new w.$7g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const i=this.g[a];if(i.value&&!i.value.activationFailed){this.g.splice(a,1),a--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new k(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const i=new Error;if(a&&a.name&&(i.name=a.name),a&&a.message?i.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(i.stack=a.stack),this.h=new k(i),this.b&&D.$4(a))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};c=Ge([Ve(6,A.$pj)],c)}),define(ke[293],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[294],Se([1,0,233,14,39,134,108,37,25,293,136,137]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0;const p=w.$Kn.as(A.$Ln.JSONContribution);class k{constructor(o,t,h){this.a=o,this.b=t,this.c=h}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(d.default.Error,o)}warn(o){this.d(d.default.Warning,o)}info(o){this.d(d.default.Info,o)}}e.$zF=k;class S{static a(o){const t=new $.$om;for(let h=0,s=o.length;h<s;h++)t.add(o[h].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new S(t,[]);if(!t||!t.length)return new S([],o);const h=this.a(o),s=this.a(t),f=t.filter(u=>!h.has(u.description.identifier)),l=o.filter(u=>!s.has(u.description.identifier));return new S(f,l)}constructor(o,t){this.added=o,this.removed=t}}e.$AF=S;class c{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=S.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,M.$1)(o)}}}e.$BF=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$CF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$mm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$po}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$po}},extensionKind:{description:D.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new c(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&C.$qF.register(o.extensionPoint,o.activationEventsGenerator),e.$CF.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,p.registerSchema(a,e.$CF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DF=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};w.$Kn.add(r.ExtensionsRegistry,new i),e.$EF=w.$Kn.as(r.ExtensionsRegistry),p.registerSchema(a,e.$CF),p.registerSchema(R.$Ij,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[295],Se([1,0,229,18,24,294,45,4]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var E;(function(p){function k(S,c,m){if(!S)return;const a=M.$Jf(S.type)?S.type:void 0;if(!a||a.length===0){m.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const r of S.required)M.$Jf(r)&&i.push(r);return{extensionId:c.value,taskType:a,required:i,properties:S.properties?d.$yn(S.properties):{},when:S.when?A.$6i.deserialize(S.when):void 0}}p.from=k})(E||(E={}));const R=P.$EF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,k)=>{for(const S of p)S.type&&k.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new w.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,S)=>{R.setHandler((c,m)=>{this.c=void 0;try{for(const a of m.removed){const i=a.value;for(const r of i)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const a of m.added){const i=a.value;for(const r of i){const n=E.from(r,a.description.identifier,a.collector);n&&(this.a[n.taskType]=n)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const S of this.all()){const c={type:"object",additionalProperties:!1};S.required.length>0&&(c.required=S.required.slice(0)),S.properties!==void 0?c.properties=d.$yn(S.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[S.taskType]},k.push(c)}this.c={oneOf:k}}return this.c}}e.$CG=new C}),define(ke[296],Se([1,0,230,18,23,24,45,295]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MG=e.JsonSchemaVersion=e.ExecutionEngine=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GG=e.ShellQuoting=e.$FG=e.$EG=e.$DG=void 0,e.$DG="settings",e.$EG=new A.$mj("taskRunning",!1,D.localize(0,null)),e.$FG=D.localize2(2,"Tasks");var $;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$GG="$customized",function(N){function O(z){if(!z)return N.Strong;switch(z.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=O}($||(e.ShellQuoting=$={}));var E;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R||(e.RevealKind=R={})),function(N){function O(z){switch(z.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=O}(R||(e.RevealKind=R={}));var C;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(N){function O(z){switch(z.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=O}(C||(e.RevealProblemKind=C={}));var p;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(p||(e.PanelKind=p={})),function(N){function O(z){switch(z.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=O}(p||(e.PanelKind=p={}));var k;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:C.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(N){function O(K){switch(K.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=O;function z(K){switch(K){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=z}(S||(e.RuntimeType=S={}));var c;(function(N){function O(z){return M.$Jf(z)?z:z.value}N.value=O})(c||(e.CommandString=c={}));var m;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function O(K){return K===N.Clean._id||K===N.Build._id||K===N.Rebuild._id||K===N.Test._id}N.is=O;function z(K){if(K!==void 0)return M.$Jf(K)?O(K)?{_id:K,isDefault:!1}:void 0:K}N.from=z})(m||(e.TaskGroup=m={}));var a;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function O(z){switch(z){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var r;(function(N){N.parallel="parallel",N.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var o;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(O,z,K,te,x,X){this._label="",this._id=O,z&&(this._label=z),K&&(this.type=K),this.runOptions=te,this.configurationProperties=x,this._source=X}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,z=!1){if(O===void 0)return!1;if(M.$Jf(O))return O===this._label||O===this.configurationProperties.identifier||z&&O===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$HG=t;class h extends t{constructor(O,z,K,te,x,X,Z,ce){super(O,K,void 0,Z,ce,z),this.command={},this._source=z,this.hasDefinedMatchers=X,x&&(this.command=x)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case S.Shell:z="shell";break;case S.Process:z="process";break;case S.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(O){return O instanceof h}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const K={type:e.$GG,folder:O,id:z};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new h(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$IG=h;class s extends t{constructor(O,z,K,te,x,X,Z){super(O,K,te,X,Z,z),this._source=z,this.configures=x}static is(O){return O instanceof s}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const K={type:e.$GG,folder:O,id:z};return JSON.stringify(K)}}e.$JG=s;class f extends t{constructor(O,z,K,te,x,X,Z,ce,_){super(O,K,te,ce,_,z),this.defines=x,this.hasDefinedMatchers=Z,this.command=X,this.icon=_.icon,this.hide=_.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof f}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new f(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$KG=f;class l extends t{constructor(O,z,K,te,x,X){super(O,K,te,x,X,z),this._source=z}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new l(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$LG=l;var u;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(N){N._default=N.Terminal}(u||(e.ExecutionEngine=u={}));var v;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class I{constructor(O){this.c=new Map;for(let z=0;z<O.length;z++)this.c.set(O[z].uri.toString(),z)}compare(O,z){const K=O.getWorkspaceFolder(),te=z.getWorkspaceFolder();if(K&&te){let x=this.c.get(K.uri.toString());x=x===void 0?0:x+1;let X=this.c.get(te.uri.toString());return X=X===void 0?0:X+1,x===X?O._label.localeCompare(z._label):x-X}else return!K&&te?-1:K&&!te?1:0}}e.$MG=I;var b;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(b||(e.TaskEventKind=b={}));var g;(function(N){N.SingleRun="singleRun",N.Background="background"})(g||(e.TaskRunType=g={}));var y;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var L;(function(N){function O(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function z(ce,_,ge){return{...O(ce),kind:"start",terminalId:_,resolvedVariables:ge}}N.start=z;function K(ce,_,ge){return{...O(ce),kind:"processStarted",terminalId:_,processId:ge}}N.processStarted=K;function te(ce,_,ge){return{...O(ce),kind:"processEnded",terminalId:_,exitCode:ge}}N.processEnded=te;function x(ce,_,ge){return{...O(ce),kind:"terminated",exitReason:ge,terminalId:_}}N.terminated=x;function X(ce,_,ge){return{...O(_),kind:ce,terminalId:ge}}N.general=X;function Z(){return{kind:"changed"}}N.changed=Z})(L||(e.TaskEvent=L={}));var T;(function(N){function O(K){const te=Object.keys(K).sort();let x="";for(const X of te){let Z=K[X];Z instanceof Object?Z=O(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),x+=X+","+Z+","}return x}function z(K){const x={_key:O(K),type:K.taskType};return Object.assign(x,K),x}N.create=z})(T||(e.KeyedTaskIdentifier=T={}));var U;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var j;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var F;(function(N){function O(z,K){const te=w.$CG.get(z.type);if(te===void 0){const ce=P.$yn(z);return delete ce._key,T.create(ce)}const x=Object.create(null);x.type=te.taskType;const X=new Set;te.required.forEach(ce=>X.add(ce));const Z=te.properties;for(const ce of Object.keys(Z)){const _=z[ce];if(_!=null)x[ce]=_;else if(X.has(ce)){const ge=Z[ce];if(ge.default!==void 0)x[ce]=P.$yn(ge.default);else switch(ge.type){case"boolean":x[ce]=!1;break;case"number":case"integer":x[ce]=0;break;case"string":x[ce]="";break;default:K.error(D.localize(1,null,JSON.stringify(z,void 0,0),ce));return}}}return T.create(x)}N.createTaskIdentifier=O})(F||(e.TaskDefinition=F={}))}),define(ke[297],Se([1,0,14]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=e.$$7b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,w)=>{this.b=A,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,D.$1)(A))}then(A,w){return this.j().then(A,w)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$$7b=M;class d extends M{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$_7b=d}),define(ke[69],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Sv=D;const M=[];function d(w){const $=new D(w);return M[$.nid]=$,$}e.$Tv=d;function P(w){return M[w].sid}e.$Uv=P;class A{constructor($){this.value=$}}e.$Vv=A}),define(ke[6],Se([1,0,69]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=e.$kL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$jL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var d;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(d||(e.TabInputKind=d={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var A;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var w;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var E;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var R;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class C{static{this.a=0}static mixin(m){return m._id=C.a++,m}}e.$jL=C;var p;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var k;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var S;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$kL={MainThreadAuthentication:(0,D.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Tv)("MainThreadCommands"),MainThreadComments:(0,D.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Tv)("MainThreadSCM"),MainThreadSearch:(0,D.$Tv)("MainThreadSearch"),MainThreadShare:(0,D.$Tv)("MainThreadShare"),MainThreadTask:(0,D.$Tv)("MainThreadTask"),MainThreadWindow:(0,D.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Tv)("MainThreadInteractive"),MainThreadChat:(0,D.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Tv)("MainThreadIssueReporter")},e.$lL={ExtHostCommands:(0,D.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Tv)("ExtHostSCM"),ExtHostSearch:(0,D.$Tv)("ExtHostSearch"),ExtHostTask:(0,D.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Tv)("ExtHostProgress"),ExtHostComments:(0,D.$Tv)("ExtHostComments"),ExtHostSecretState:(0,D.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Tv)("ExtHostStorage"),ExtHostUrls:(0,D.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Tv)("ExtHostIssueReporter")}}),define(ke[91],Se([1,0,5,12,6,20]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=e.$9fc=void 0,e.$9fc=(0,D.$8h)("IExtHostApiDeprecationService");let A=class{constructor($,E){this.c=E,this.a=new Set,this.b=$.getProxy(d.$kL.MainThreadTelemetry)}report($,E,R){const C=this.d($,E);this.a.has(C)||(this.a.add(C),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:$}))}d($,E){return`${$}-${E.identifier.value}`}};e.$0fc=A,e.$0fc=A=Ge([Ve(0,P.$pN),Ve(1,M.$pj)],A),e.$$fc=Object.freeze(new class{report(w,$,E){}})}),define(ke[298],Se([1,0,53,3,6]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class P{static{this.a=0}constructor($,E){this.extension=$,this.provider=E,this.handle=P.a++}}class A{static{this.a=0}constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(d.$kL.MainThreadChat)}registerChatProvider($,E,R){const C=new P($,R);return this.b.set(C.handle,C),this.d.$registerChatProvider(C.handle,E),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(C.handle),this.b.delete(C.handle)})}transferChatSession($,E){const R=D.Iterable.find(this.c.keys(),C=>this.c.get(C)===$)??0;typeof R=="number"&&this.d.$transferChatSession(R,E)}sendInteractiveRequestToProvider($,E){this.d.$sendRequestToProvider($,E)}async $prepareChat($,E){const R=this.b.get($);if(!R)return;const C=await R.provider.prepareSession(E);if(!C)return;const p=A.a++;return this.c.set(p,C),{id:p,requesterUsername:C.requester?.name,requesterAvatarIconUri:C.requester?.icon,responderUsername:C.responder?.name,responderAvatarIconUri:C.responder?.icon,inputPlaceholder:C.inputPlaceholder}}$releaseSession($){this.c.delete($)}}e.$dgc=A}),define(ke[299],Se([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class M{constructor(P){const A=P.getProxy(D.$kL.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(w){return A.$writeText(w)}})}}e.$hgc=M}),define(ke[300],Se([1,0,24,6,27,20]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;let A=class{constructor(R,C){this.a=R.getProxy(M.$kL.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,C){const p=this,k=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){p.e(R,C,k,arguments)}})}e(R,C,p,k){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(k,this.b)}),this.c&&this.f(R,p,k)}};e.$$hc=A,e.$$hc=A=Ge([Ve(0,P.$pN),Ve(1,d.$FN)],A);const w=1e5;function $(E,R){const C=[];if(E.length)for(let p=0;p<E.length;p++){let k=E[p];if(typeof k>"u")k="undefined";else if(k instanceof Error){const S=k;S.stack?k=S.stack:k=S.toString()}C.push(k)}if(R){const p=new Error().stack;p&&C.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,D.$Dn)(C);return p.length>w?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(ke[301],Se([1,0,2,6,26]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class P{constructor(w){this.a=w.getProxy(M.$kL.MainThreadDialogs)}showOpenDialog(w,$){return $?.allowUIResources&&(0,d.$LF)(w,"showLocal"),this.a.$showOpenDialog($).then(E=>E?E.map(R=>D.URI.revive(R)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then($=>$?D.URI.revive($):void 0)}}e.$chc=P}),define(ke[302],Se([1,0,3,6]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class d{constructor(A){this.b=0,this.a=A.getProxy(M.$kL.MainThreadLabelService)}$registerResourceLabelFormatter(A){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,A),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$xhc=d}),define(ke[114],Se([1,0,11,13,2,5,12,6,27,20]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0;let R=class{constructor(p,k,S){this.f=S,this.d=new Map,this.a=k.getProxy(w.$kL.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===D.$g}getMessage(p,k){const{message:S,args:c,comment:m}=k;if(this.c)return(0,M.$Me)(S,c??{});let a=S;m&&m.length>0&&(a+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.d.get(p)?.contents[a];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,M.$Me)(i??S,c??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let k;const S=await this.g(p);if(!S){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(S),m=JSON.parse(c);k=p.isBuiltin?m.contents?.bundle:m}catch(c){this.f.error(`Failed to load translations for ${p.identifier.value} from ${S}: ${c.message}`);return}k&&this.d.set(p.identifier.value,{contents:k,uri:S})}async g(p){if(p.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return d.URI.revive(k)}return p.l10n?d.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Wgc=R,e.$Wgc=R=Ge([Ve(0,$.$FN),Ve(1,E.$pN),Ve(2,A.$pj)],R),e.$Xgc=(0,P.$8h)("IExtHostLocalizationService")}),define(ke[145],Se([1,0,12,6,27,20,2,56]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;let $=class extends D.$Aj{constructor(C,p){super(p.logLevel,p.logsLocation,p.loggers.map(k=>(0,w.$Eh)(k))),this.r=C.getProxy(M.$kL.MainThreadLogger)}$setLogLevel(C,p){p?this.setLogLevel(A.URI.revive(p),C):this.setLogLevel(C)}setVisibility(C,p){super.setVisibility(C,p),this.r.$setVisibility(C,p)}s(C,p,k){return new E(this.r,C,p,k)}};e.$0hc=$,e.$0hc=$=Ge([Ve(0,P.$pN),Ve(1,d.$FN)],$);class E extends D.$vj{constructor(C,p,k,S){super(S?.logLevel==="always"),this.r=C,this.s=p,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(p,S).then(()=>{this.u(this.n),this.m=!0})}g(C,p){const k=[[C,p]];this.m?this.u(k):this.n.push(...k)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[115],Se([1,0,6,5,3,20,21]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0,e.$Ygc=(0,M.$8h)("IExtHostManagedSockets");let w=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$kL.MainThreadManagedSockets)}setFactory(C,p){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const p=++this.b,k=await this.c.makeConnection(),S=new d.$Sc;return this.d.set(p,new E(p,k,S)),S.add((0,d.$Rc)(()=>this.d.delete(p))),S.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),S.dispose()})),S.add(k.onDidClose(c=>{this.a.$onDidManagedSocketClose(p,c?.stack??c?.message),S.dispose()})),S.add(k.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(p,A.$ke.wrap(c)))),p}$remoteSocketWrite(C,p){this.d.get(C)?.actual.send(p.buffer)}$remoteSocketEnd(C){const p=this.d.get(C);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Zgc=w,e.$Zgc=w=Ge([Ve(0,P.$pN)],w);class ${constructor(C,p){this.socketFactoryId=C,this.makeConnection=p}}class E extends d.$Tc{constructor(C,p,k){super(),this.socketId=C,this.actual=p,this.B(k)}}}),define(ke[303],Se([1,0,6,12,26]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;function P(w){return w&&w.title}let A=class{constructor($,E){this.b=E,this.a=$.getProxy(D.$kL.MainThreadMessageService)}showMessage($,E,R,C,p){const k={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof C=="string"||P(C)?S=[C,...p]:(k.modal=C?.modal,k.useCustom=C?.useCustom,k.detail=C?.detail,S=p),k.useCustom&&(0,d.$LF)($,"resolvers");const c=[];let m=!1;for(let a=0;a<S.length;a++){const i=S[a];if(typeof i=="string")c.push({title:i,handle:a,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;c.push({title:r,isCloseAffordance:!!n,handle:a}),n&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,R,k,c).then(a=>{if(typeof a=="number")return S[a]})}};e.$zhc=A,e.$zhc=A=Ge([Ve(1,M.$pj)],A)}),define(ke[304],Se([1,0,3,18,2,26,6]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class w{constructor(E){this.b=new Map,this.a=E.getProxy(A.$kL.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,R,C){if((0,P.$LF)(E,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,C),this.a.$registerProfileContentHandler(R,C.name,C.description,E.identifier.value),(0,D.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(E,R,C,p){const k=this.b.get(E);if(!k)throw new Error(`Unknown handler with id: ${E}`);return k.saveProfile(R,C,p)}async $readProfile(E,R,C){const p=this.b.get(E);if(!p)throw new Error(`Unknown handler with id: ${E}`);return p.readProfile((0,M.$Jf)(R)?R:d.URI.revive(R),C)}}e.$Ihc=w}),define(ke[116],Se([1,0,6,4,5]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=void 0;class P{constructor(w){this.b=new M.$Wd,this.onDidChangePassword=this.b.event,this.a=w.getProxy(D.$kL.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,$){return this.a.$getPassword(w,$)}store(w,$,E){return this.a.$setPassword(w,$,E)}delete(w,$){return this.a.$deletePassword(w,$)}}e.$Tgc=P,e.$Ugc=(0,d.$8h)("IExtHostSecretState")}),define(ke[305],Se([1,0,22,3,6]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class P{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(d.$kL.MainThreadSpeech)}async $createSpeechToTextSession(w,$){const E=this.c.get(w);if(!E)return;const R=new M.$Sc,C=new D.$7d;this.d.set($,C);const p=R.add(E.provideSpeechToTextSession(C.token));R.add(p.onDidChange(k=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,k)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createKeywordRecognitionSession(w,$){const E=this.c.get(w);if(!E)return;const R=new M.$Sc,C=new D.$7d;this.d.set($,C);const p=R.add(E.provideKeywordRecognitionSession(C.token));R.add(p.onDidChange(k=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,k)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,$,E){const R=P.a++;return this.c.set(R,E),this.b.$registerProvider(R,$,{extension:w,displayName:w.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Phc=P}),define(ke[117],Se([1,0,6,4,5]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=void 0;class P{constructor(w,$){this.c=$,this.b=new M.$Wd,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(D.$kL.MainThreadStorage)}registerExtensionStorageKeysToSync(w,$){this.a.$registerExtensionStorageKeysToSync(w,$)}async initializeExtensionStorage(w,$,E){const R=await this.a.$initializeExtensionStorage(w,$);let C;return R&&(C=this.d(w,$,R)),C||E}setValue(w,$,E){return this.a.$setValue(w,$,E)}$acceptValue(w,$,E){const R=this.d(w,$,E);R&&this.b.fire({shared:w,key:$,value:R})}d(w,$,E){try{return JSON.parse(E)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${w}): ${R}`)}}}e.$Lgc=P,e.$Mgc=(0,d.$8h)("IExtHostStorage")}),define(ke[306],Se([1,0,3,15,2,6]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$kL.MainThreadUriOpeners)}registerExternalUriOpener($,E,R,C){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const p=C.schemes.find(k=>!A.a.has(k));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(E,R),this.b.$registerUriOpener(E,C.schemes,$,C.label),(0,D.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri($,E,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const p=d.URI.revive(E);return C.canOpenExternalUri(p,R)}async $openUri($,E,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(d.URI.revive(E.resolvedUri),{sourceUri:d.URI.revive(E.sourceUri)},R)}}e.$4hc=A}),define(ke[307],Se([1,0,6,2,3,14,25]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class w{static{this.a=0}constructor(E){this.c=new A.$om,this.d=new Map,this.b=E.getProxy(D.$kL.MainThreadUrls)}registerUriHandler(E,R){const C=E.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const p=w.a++;return this.c.add(C),this.d.set(p,R),this.b.$registerUriHandler(p,C,E.displayName||E.name),(0,d.$Rc)(()=>{this.c.delete(C),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(E,R){const C=this.d.get(E);if(!C)return Promise.resolve(void 0);try{C.handleUri(M.URI.revive(R))}catch(p){(0,P.$1)(p)}return Promise.resolve(void 0)}async createAppUri(E){return M.URI.revive(await this.b.$createAppUri(E))}}e.$5hc=w}),define(ke[92],Se([1,0,4,3,15,24,2,237,274,112,6]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=e.$zgc=e.$ygc=e.$xgc=e.$wgc=void 0;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(n,o,t,h,s,f,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Wd,this._onDidDispose=this.#h.event,this.#e=n,this.#t=o,this.#o=t,this.#n=h,this.#s=s,this.#r=f,this.#l=p(f),this.#d=k(f),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#u=!0,(0,E.$owb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===d.Schemas.https||n.scheme===d.Schemas.http){let o=n.toString();return o.endsWith("/")||(o+="/"),o+" "+E.$nwb}return E.$nwb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),P.$Cn(this.#o,n)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const o=(0,$.$Flb)(n,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const o=this.#r.extensionLocation?.scheme===d.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===d.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,f,l,u,v)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(u)}),b=(0,E.$owb)(I,{isRemote:o,authority:t}).toString();return`${s}${b}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,f,l,u,v)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(u)}),b=(0,E.$owb)(I,{isRemote:o,authority:t}).toString();return`${s}${b}${v}`})}}e.$wgc=C;function p(r){try{const n=(0,w.$ep)((0,w.$dp)(r.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.$xgc=p;function k(r){try{const n=(0,w.$ep)((0,w.$dp)(r.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class S extends M.$Tc{constructor(n,o,t,h,s){super(),this.c=o,this.f=t,this.g=h,this.h=s,this.b=new Map,this.a=n.getProxy(R.$kL.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,o,t){const h=this.j(n);if(h){const{message:s}=(0,$.$Glb)(o,t.value);h._onMessageEmitter.fire(s)}}$onMissingCsp(n,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,o,t){const h=new C(n,this.a,a(o),this.c,this.f,t,this.h);this.b.set(n,h);const s=h._onDidDispose(()=>{s.dispose(),this.deleteWebview(n)});return h}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$ygc=S;function c(r){return{id:r.identifier,location:r.extensionLocation}}e.$zgc=c;function m(r,n,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||i(r,n)}}e.$Agc=m;function a(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(n=>A.URI.from(n))}}function i(r,n){return[...(n?.getWorkspaceFolders()||[]).map(o=>o.uri),r.extensionLocation]}}),define(ke[146],Se([1,0,4,6,2,15,13,5,20,26]),function($e,e,D,M,d,P,A,w,$,E){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=e.$7hc=void 0;let C=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(k){const S=this.d;return{get focused(){return S.focused},get active(){return(0,E.$LF)(k,"windowActivity"),S.active}}}constructor(k){this.c=new D.$Wd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=k.getProxy(M.$kL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:c})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,S){S!==this.d[k]&&(this.d={...this.d,[k]:S},this.c.fire(this.d))}openUri(k,S){let c;if(typeof k=="string"){c=k;try{k=d.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,A.$Ke)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,c,S)}async asExternalUri(k,S){if((0,A.$Ke)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(k,S);return d.URI.from(c)}};e.$7hc=C,e.$7hc=C=R=Ge([Ve(0,$.$pN)],C),e.$8hc=(0,w.$8h)("IExtHostWindow")}),define(ke[308],Se([1,0,300,27,20]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;const P=1024*1024;let A=class extends D.$$hc{constructor($,E){super($,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,E,R){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),E.apply(console,R),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,E){const R=process[$],C=R.write;let p="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(k,S,c)=>{if(!this.g){p+=k.toString(S);const m=p.length>P?p.length:p.lastIndexOf(`
`);m!==-1&&(console[E](p.slice(0,m)),p=p.slice(m+1))}C.call(R,k,S,c)}})}};e.$Jic=A,e.$Jic=A=Ge([Ve(0,d.$pN),Ve(1,M.$FN)],A)}),define(ke[309],Se([1,0,145,15,251,30]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;class A extends D.$0hc{s($,E,R){return $.scheme===M.Schemas.file?new d.$BO(R?.name||(0,P.$rg)(),$.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,E):super.s($,E,R)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Vic=A}),define(ke[310],Se([1,0,8,21,22,14,4,3,130,297,69]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=e.ResponsiveState=e.RequestInitiator=e.$b8b=e.$a8b=void 0;function p(y,L){try{return JSON.stringify(y,L)}catch{return"null"}}const k="$$ref$$",S={[k]:-1};class c{constructor(L,T){this.jsonString=L,this.referencedBuffers=T}}function m(y,L=null,T=!1){const U=[];return{jsonString:(T?p:JSON.stringify)(y,(F,N)=>{if(typeof N>"u")return S;if(typeof N=="object"){if(N instanceof M.$ke){const O=U.push(N)-1;return{[k]:O}}if(L)return L(F,N)}return N}),referencedBuffers:U}}e.$a8b=m;function a(y,L,T){return JSON.parse(y,(U,j)=>{if(j){const F=j[k];if(typeof F=="number")return L[F];if(T&&j.$mid===1)return T.transformIncoming(j)}return j})}e.$b8b=a;function i(y,L){return JSON.stringify(y,L)}function r(y){return y?(L,T)=>T&&T.$mid===1?y.transformOutgoing(T):T:null}var n;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var o;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},h=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class f extends w.$Tc{static{C=h}static{this.a=3*1e3}constructor(L,T=null,U=null){super(),this[C]=!0,this.b=this.B(new A.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=T,this.g=U,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,F=R.$Sv.count;j<F;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$hh(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const T=this.w[L];delete this.w[L],T.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+f.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+f.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,$.$0m)(L,this.g):L}getProxy(L){const{nid:T,sid:U}=L;return this.s[T]||(this.s[T]=this.J(T,U)),this.s[T]}J(L,T){const U={get:(j,F)=>(typeof F=="string"&&!j[F]&&F.charCodeAt(0)===36&&(j[F]=(...N)=>this.U(L,F,N)),F===s?T:j[F])};return new Proxy(Object.create(null),U)}set(L,T){return this.m[L.nid]=T,T}assertRegistered(L){for(let T=0,U=L.length;T<U;T++){const j=L[T];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(L){if(this.j)return;const T=L.byteLength,U=u.read(L,0),j=U.readUInt8(),F=U.readUInt32();switch(j){case 1:case 2:{let{rpcId:N,method:O,args:z}=I.deserializeRequestJSONArgs(U);this.g&&(z=(0,$.$0m)(z,this.g)),this.M(T,F,N,O,z,j===2);break}case 3:case 4:{let{rpcId:N,method:O,args:z}=I.deserializeRequestMixedArgs(U);this.g&&(z=(0,$.$0m)(z,this.g)),this.M(T,F,N,O,z,j===4);break}case 5:{this.f?.logIncoming(T,F,0,"ack"),this.G(F);break}case 6:{this.N(T,F);break}case 7:{this.O(T,F,void 0);break}case 9:{let N=I.deserializeReplyOKJSON(U);this.g&&(N=(0,$.$0m)(N,this.g)),this.O(T,F,N);break}case 10:{const N=I.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(T,F,N);break}case 8:{const N=I.deserializeReplyOKVSBuffer(U);this.O(T,F,N);break}case 11:{let N=I.deserializeReplyErrError(U);this.g&&(N=(0,$.$0m)(N,this.g)),this.P(T,F,N);break}case 12:{this.P(T,F,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,T,U,j,F,N){this.f?.logIncoming(L,T,1,`receiveRequest ${(0,R.$Uv)(U)}.${j}(`,F);const O=String(T);let z,K;if(N){const x=new d.$7d;F.push(x.token),z=this.Q(U,j,F),K=()=>x.cancel()}else z=this.Q(U,j,F),K=t;this.u[O]=K;const te=I.serializeAcknowledged(T);this.f?.logOutgoing(te.byteLength,T,1,"ack"),this.c.send(te),z.then(x=>{delete this.u[O];const X=I.serializeReplyOK(T,x,this.h);this.f?.logOutgoing(X.byteLength,T,1,"reply:",x),this.c.send(X)},x=>{delete this.u[O];const X=I.serializeReplyErr(T,x);this.f?.logOutgoing(X.byteLength,T,1,"replyErr:",x),this.c.send(X)})}N(L,T){this.f?.logIncoming(L,T,1,"receiveCancel");const U=String(T);this.u[U]?.()}O(L,T,U){this.f?.logIncoming(L,T,0,"receiveReply:",U);const j=String(T);if(!this.w.hasOwnProperty(j))return;const F=this.w[j];delete this.w[j],F.resolveOk(U)}P(L,T,U){this.f?.logIncoming(L,T,0,"receiveReplyErr:",U);const j=String(T);if(!this.w.hasOwnProperty(j))return;const F=this.w[j];delete this.w[j];let N;U&&(U.$isError?(N=new Error,N.name=U.name,N.message=U.message,N.stack=U.stack):N=U),F.resolveErr(N)}Q(L,T,U){try{return Promise.resolve(this.S(L,T,U))}catch(j){return Promise.reject(j)}}S(L,T,U){const j=this.m[L];if(!j)throw new Error("Unknown actor "+(0,R.$Uv)(L));const F=j[T];if(typeof F!="function")throw new Error("Unknown method "+T+" on actor "+(0,R.$Uv)(L));return F.apply(j,U)}U(L,T,U){if(this.j)return new E.$_7b;let j=null;if(U.length>0&&d.CancellationToken.isCancellationToken(U[U.length-1])&&(j=U.pop()),j&&j.isCancellationRequested)return Promise.reject(P.$6());const F=I.serializeRequestArguments(U,this.h),N=++this.t,O=String(N),z=new E.$$7b,K=new w.$Sc;j&&K.add(j.onCancellationRequested(()=>{const x=I.serializeCancel(N);this.f?.logOutgoing(x.byteLength,N,0,"cancel"),this.c.send(I.serializeCancel(N))})),this.w[O]=new l(z,K),this.F(N);const te=I.serializeRequest(N,L,T,F,!!j);return this.f?.logOutgoing(te.byteLength,N,0,`request: ${(0,R.$Uv)(L)}.${T}(`,U),this.c.send(te),z}}e.$c8b=f;class l{constructor(L,T){this.a=L,this.b=T}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class u{static alloc(L,T,U){const j=new u(M.$ke.alloc(U+1+4),0);return j.writeUInt8(L),j.writeUInt32(T),j}static read(L,T){return new u(L,T)}get buffer(){return this.a}constructor(L,T){this.a=L,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+L).toString();return this.b+=L,U}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+L).toString();return this.b+=L,U}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+L);return this.b+=L,T}static sizeMixedArray(L){let T=0;T+=1;for(let U=0,j=L.length;U<j;U++){const F=L[U];switch(T+=1,F.type){case 1:T+=this.sizeLongString(F.value);break;case 2:T+=this.sizeVSBuffer(F.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(F.value);for(let N=0;N<F.buffers.length;++N)T+=this.sizeVSBuffer(F.buffers[N]);break;case 4:break}}return T}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let T=0,U=L.length;T<U;T++){const j=L[T];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let F=0;F<j.buffers.length;++F)this.writeBuffer(j.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const T=new Array(L);for(let U=0;U<L;U++)switch(this.readUInt8()){case 1:T[U]=this.readLongString();break;case 2:T[U]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),N=this.readLongString(),O=[];for(let z=0;z<F;++z)O.push(this.readVSBuffer());T[U]=new R.$Vv(a(N,O,null));break}case 4:T[U]=void 0;break}return T}}var v;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(v||(v={}));class I{static a(L){for(let T=0,U=L.length;T<U;T++)if(L[T]instanceof M.$ke||L[T]instanceof R.$Vv||typeof L[T]>"u")return!0;return!1}static serializeRequestArguments(L,T){if(this.a(L)){const U=[];for(let j=0,F=L.length;j<F;j++){const N=L[j];if(N instanceof M.$ke)U[j]={type:2,value:N};else if(typeof N>"u")U[j]={type:4};else if(N instanceof R.$Vv){const{jsonString:O,referencedBuffers:z}=m(N.value,T);U[j]={type:3,value:M.$ke.fromString(O),buffers:z}}else U[j]={type:1,value:M.$ke.fromString(i(N,T))}}return{type:1,args:U}}return{type:0,args:i(L,T)}}static serializeRequest(L,T,U,j,F){switch(j.type){case 0:return this.b(L,T,U,j.args,F);case 1:return this.c(L,T,U,j.args,F)}}static b(L,T,U,j,F){const N=M.$ke.fromString(U),O=M.$ke.fromString(j);let z=0;z+=u.sizeUInt8(),z+=u.sizeShortString(N),z+=u.sizeLongString(O);const K=u.alloc(F?2:1,L,z);return K.writeUInt8(T),K.writeShortString(N),K.writeLongString(O),K.buffer}static deserializeRequestJSONArgs(L){const T=L.readUInt8(),U=L.readShortString(),j=L.readLongString();return{rpcId:T,method:U,args:JSON.parse(j)}}static c(L,T,U,j,F){const N=M.$ke.fromString(U);let O=0;O+=u.sizeUInt8(),O+=u.sizeShortString(N),O+=u.sizeMixedArray(j);const z=u.alloc(F?4:3,L,O);return z.writeUInt8(T),z.writeShortString(N),z.writeMixedArray(j),z.buffer}static deserializeRequestMixedArgs(L){const T=L.readUInt8(),U=L.readShortString(),j=L.readMixedArray(),F=new Array(j.length);for(let N=0,O=j.length;N<O;N++){const z=j[N];typeof z=="string"?F[N]=JSON.parse(z):F[N]=z}return{rpcId:T,method:U,args:F}}static serializeAcknowledged(L){return u.alloc(5,L,0).buffer}static serializeCancel(L){return u.alloc(6,L,0).buffer}static serializeReplyOK(L,T,U){if(typeof T>"u")return this.d(L);if(T instanceof M.$ke)return this.e(L,T);if(T instanceof R.$Vv){const{jsonString:j,referencedBuffers:F}=m(T.value,U,!0);return this.g(L,j,F)}else return this.f(L,p(T,U))}static d(L){return u.alloc(7,L,0).buffer}static e(L,T){let U=0;U+=u.sizeVSBuffer(T);const j=u.alloc(8,L,U);return j.writeVSBuffer(T),j.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,T){const U=M.$ke.fromString(T);let j=0;j+=u.sizeLongString(U);const F=u.alloc(9,L,j);return F.writeLongString(U),F.buffer}static g(L,T,U){const j=M.$ke.fromString(T);let F=0;F+=u.sizeUInt32,F+=u.sizeLongString(j);for(const O of U)F+=u.sizeVSBuffer(O);const N=u.alloc(10,L,F);N.writeUInt32(U.length),N.writeLongString(j);for(const O of U)N.writeBuffer(O);return N.buffer}static deserializeReplyOKJSON(L){const T=L.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(L,T){const U=L.readUInt32(),j=L.readLongString(),F=[];for(let N=0;N<U;++N)F.push(L.readVSBuffer());return new R.$Vv(a(j,F,T))}static serializeReplyErr(L,T){const U=T?p(P.$3(T),null):void 0;if(typeof U!="string")return this.h(L);const j=M.$ke.fromString(U);let F=0;F+=u.sizeLongString(j);const N=u.alloc(11,L,F);return N.writeLongString(j),N.buffer}static deserializeReplyErrError(L){const T=L.readLongString();return JSON.parse(T)}static h(L){return u.alloc(12,L,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var g;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(g||(g={}))}),define(ke[311],Se([1,0,21,28,15,84,5]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=e.$9I=e.$8I=e.$7I=void 0,e.$7I=(0,A.$8h)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${w.join("")}]+`),E=7;function R(k){if(k.scheme!==d.Schemas.vscodeNotebookCell)return;const S=k.fragment.indexOf("s");if(S<0)return;const c=parseInt(k.fragment.substring(0,S).replace($,""),E),m=(0,D.$De)(k.fragment.substring(S+1)).toString();if(!isNaN(c))return{handle:c,notebook:k.with({scheme:m,fragment:null})}}e.$8I=R;function C(k,S){const c=S.toString(E),a=`${c.length<w.length?w[c.length-1]:"z"}${c}s${(0,D.$Ee)(D.$ke.fromString(k.scheme),!0,!0)}`;return k.with({scheme:d.Schemas.vscodeNotebookCell,fragment:a})}e.$9I=C;class p{constructor(){this.a=new M.$Ac}getNotebook(S){if(S.scheme===d.Schemas.vscodeNotebookCell){const c=R(S);if(c){const m=this.a.get(c.notebook);if(m)return m}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$0I=p,(0,P.$1r)(e.$7I,p,1)}),define(ke[118],Se([1,0,21,35,53,100,15,17,11,45,311]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.CellStatusbarAlignment=e.$lJ=e.$kJ=e.$jJ=e.NotebookEditorPriority=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.CellKind=e.$aJ=e.$_I=e.$$I=void 0,e.$$I="workbench.editor.notebook",e.$_I="workbench.editor.notebookTextDiffEditor",e.$aJ="workbench.editor.interactive";var C;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(C||(e.CellKind=C={})),e.$bJ=["application/json","application/javascript","text/html","image/svg+xml",P.$hs.latex,P.$hs.markdown,"image/png","image/jpeg",P.$hs.text],e.$cJ=[P.$hs.latex,P.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$hs.text],e.$dJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$eJ="_notAvailable";var p;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var k;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var S;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var c;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var a;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var n;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;function K(_,ge){return(0,R.$9I)(_,ge)}z.generate=K;function te(_){return(0,R.$8I)(_)}z.parse=te;function x(_,ge){return _.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${_.scheme!==A.Schemas.file?_.scheme:""}`})}z.generateCellOutputUri=x;function X(_){if(_.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!ge)return;const ne=ge[1]&&ge[1]!==""?ge[1]:void 0,J=ge[2];return{outputId:ne,notebook:_.with({scheme:J||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=X;function Z(_,ge,ne){return z.generate(_,ge).with({scheme:ne})}z.generateCellPropertyUri=Z;function ce(_,ge){if(_.scheme===ge)return z.parse(_.with({scheme:z.scheme}))}z.parseCellPropertyUri=ce})(n||(e.CellUri=n={}));const o=z=>$.$i?z.replace(/\//g,"\\"):z;class t{constructor(K=[],te=e.$bJ){this.e=te,this.d=[...new Set(K)].map(x=>({pattern:x,matches:M.$Oj(o(x))}))}sort(K){const te=new Map(d.Iterable.map(K,X=>[X,o(X)]));let x=[];for(const{matches:X}of this.d)for(const[Z,ce]of te)if(X(ce)){x.push(Z),te.delete(Z);break}return te.size&&(x=x.concat([...te.keys()].sort((X,Z)=>this.e.indexOf(X)-this.e.indexOf(Z)))),x}prioritize(K,te){const x=this.f(K);if(x===-1){this.d.unshift({pattern:K,matches:M.$Oj(o(K))});return}const X=new Set(te.map(ce=>this.f(ce,x)));X.delete(-1);const Z=Array.from(X).sort();this.d.splice(x+1,0,...Z.map(ce=>this.d[ce]));for(let ce=Z.length-1;ce>=0;ce--)this.d.splice(Z[ce],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,te=this.d.length){const x=o(K);for(let X=0;X<te;X++)if(this.d[X].matches(x))return X;return-1}}e.$fJ=t;function h(z,K,te,x=(X,Z)=>X===Z){const X=[];function Z(ge,ne,J){if(ne===0&&J.length===0)return;const W=X[X.length-1];W&&W.start+W.deleteCount===ge?(W.deleteCount+=ne,W.toInsert.push(...J)):X.push({start:ge,deleteCount:ne,toInsert:J})}let ce=0,_=0;for(;;){if(ce===z.length){Z(ce,0,K.slice(_));break}if(_===K.length){Z(ce,z.length-ce,[]);break}const ge=z[ce],ne=K[_];if(x(ge,ne)){ce+=1,_+=1;continue}te(ne)?(Z(ce,1,[]),ce+=1):(Z(ce,0,[ne]),_+=1)}return X}e.$gJ=h,e.$hJ=new E.$mj("notebookEditorCursorAtBoundary","none"),e.$iJ=new E.$mj("notebookEditorCursorAtLineBoundary","none");var s;(function(z){z.default="default",z.option="option"})(s||(e.NotebookEditorPriority=s={}));function f(z){const K=z;return!!((typeof K.include=="string"||M.$Pj(K.include))&&(typeof K.exclude=="string"||M.$Pj(K.exclude)))}e.$jJ=f;function l(z,K,te){if(Array.isArray(z.viewType)&&z.viewType.indexOf(K)>=0||z.viewType===K)return!0;if(z.filenamePattern){const x=f(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,X=f(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(M.$Nj(x,(0,w.$nc)(te.fsPath).toLowerCase()))return!(X&&M.$Nj(X,(0,w.$nc)(te.fsPath).toLowerCase()))}return!1}e.$kJ=l,e.$lJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var u;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class v{static{this.d="notebook/"}static create(K){return`${v.d}${K}`}static parse(K){if(K.startsWith(v.d))return K.substring(v.d.length)}}e.$mJ=v;function I(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$nJ=I;const b=new TextDecoder;function g(z){const K=[];let te=!1;for(const ce of z)(K.length===0||te)&&(K.push(ce),te=!0);let x=T(K);const X=D.$ke.concat(K.map(ce=>D.$ke.wrap(ce))),Z=O(X);return x=x||Z.byteLength!==X.byteLength,{data:Z,didCompression:x}}e.$oJ=g,e.$pJ="\x1B[A";const y=e.$pJ.split("").map(z=>z.charCodeAt(0)),L=10;function T(z){let K=!1;return z.forEach((te,x)=>{if(x===0||te.length<e.$pJ.length)return;const X=z[x-1],Z=te.subarray(0,e.$pJ.length);if(Z[0]===y[0]&&Z[1]===y[1]&&Z[2]===y[2]){const ce=X.lastIndexOf(L);if(ce===-1)return;K=!0,z[x-1]=X.subarray(0,ce),z[x]=te.subarray(e.$pJ.length)}}),K}function U(z){let K=z;do z=K,K=z.replace(/[^\n]\x08/gm,"");while(K.length<z.length);return z}function j(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const K=z.match(/^(.*)\r+/m)[1];let te=z.match(/\r+(.*)$/m)[1];te=te+K.slice(te.length,K.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return z}const F=8,N=13;function O(z){return!z.buffer.includes(F)&&!z.buffer.includes(N)?z:D.$ke.fromString(j(U(b.decode(z.buffer))))}}),define(ke[7],Se([1,0,19,14,63,28,100,13,18,2,30,25,32,65,118]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S){"use strict";var c,m,a,i,r,n,o,t,h,s,f,l,u,v,I,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$eN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$dN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.TestRunProfileKind=e.TestResultState=e.$VM=e.$UM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$TM=e.NotebookVariablesRequestKind=e.$SM=e.$RM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$QM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.ColorThemeKind=e.$KM=e.$JM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$IM=e.$HM=e.DebugConsoleMode=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$BM=e.$AM=e.FileChangeType=e.$zM=e.$yM=e.$xM=e.$wM=e.InlineCompletionTriggerKind=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.ConfigurationTarget=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$_L=e.ViewBadge=e.ProgressLocation=e.$$L=e.$0L=e.TaskScope=e.ShellQuoting=e.$9L=e.$8L=e.$7L=e.TaskPanelKind=e.TaskRevealKind=e.$6L=e.TerminalLocation=e.$5L=e.$4L=e.$3L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$2L=e.$1L=e.$ZL=e.$YL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$XL=e.StatusBarAlignment=e.ViewColumn=e.$WL=e.$VL=e.$UL=e.$TL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$SL=e.$RL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.LanguageStatusSeverity=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.CodeActionTriggerKind=e.$FL=e.$EL=e.SymbolTag=e.SymbolKind=e.$DL=e.$CL=e.DocumentHighlightKind=e.$BL=e.$AL=e.$zL=e.$yL=e.DiagnosticSeverity=e.DiagnosticTag=e.$xL=e.$wL=e.FileEditType=e.$vL=e.$uL=e.$tL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(G){return Object.assign(G,{apply:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const Me=we.length===1?[]:we[1];return Reflect.construct(G,Me,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const[Me,...Xe]=we;return Reflect.construct(G,Xe,Me.constructor)}}})}var L;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(L||(e.TerminalOutputAnchor=L={}));var T;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let U=c=class{static from(...q){let we=q;return new c(function(){if(we){for(const Me of we)Me&&typeof Me.dispose=="function"&&Me.dispose();we=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$mL=U,e.$mL=U=c=Ge([y],U);let j=m=class{static Min(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Me=1;Me<q.length;Me++){const Xe=q[Me];Xe.isBefore(we)&&(we=Xe)}return we}static Max(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Me=1;Me<q.length;Me++){const Xe=q[Me];Xe.isAfter(we)&&(we=Xe)}return we}static isPosition(q){if(!q)return!1;if(q instanceof m)return!0;const{line:we,character:Me}=q;return typeof we=="number"&&typeof Me=="number"}static of(q){if(q instanceof m)return q;if(this.isPosition(q))return new m(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,we){if(q<0)throw(0,M.$7)("line must be non-negative");if(we<0)throw(0,M.$7)("character must be non-negative");this.c=q,this.e=we}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,we=0){if(q===null||we===null)throw(0,M.$7)();let Me;return typeof q>"u"?Me=0:typeof q=="number"?Me=q:(Me=typeof q.lineDelta=="number"?q.lineDelta:0,we=typeof q.characterDelta=="number"?q.characterDelta:0),Me===0&&we===0?this:new m(this.line+Me,this.character+we)}with(q,we=this.character){if(q===null||we===null)throw(0,M.$7)();let Me;return typeof q>"u"?Me=this.line:typeof q=="number"?Me=q:(Me=typeof q.line=="number"?q.line:this.line,we=typeof q.character=="number"?q.character:this.character),Me===this.line&&we===this.character?this:new m(Me,we)}toJSON(){return{line:this.line,character:this.character}}};e.$nL=j,e.$nL=j=m=Ge([y],j);let F=a=class{static isRange(q){return q instanceof a?!0:q?j.isPosition(q.start)&&j.isPosition(q.end):!1}static of(q){if(q instanceof a)return q;if(this.isRange(q))return new a(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,we,Me,Xe){let tt,lt;if(typeof q=="number"&&typeof we=="number"&&typeof Me=="number"&&typeof Xe=="number"?(tt=new j(q,we),lt=new j(Me,Xe)):j.isPosition(q)&&j.isPosition(we)&&(tt=j.of(q),lt=j.of(we)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(q){return a.isRange(q)?this.contains(q.start)&&this.contains(q.end):j.isPosition(q)?!(j.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const we=j.Max(q.start,this.c),Me=j.Min(q.end,this.e);if(!we.isAfter(Me))return new a(we,Me)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const we=j.Min(q.start,this.c),Me=j.Max(q.end,this.end);return new a(we,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,we=this.end){if(q===null||we===null)throw(0,M.$7)();let Me;return q?j.isPosition(q)?Me=q:(Me=q.start||this.start,we=q.end||this.end):Me=this.start,Me.isEqual(this.c)&&we.isEqual(this.end)?this:new a(Me,we)}toJSON(){return[this.start,this.end]}};e.$oL=F,e.$oL=F=a=Ge([y],F);let N=i=class extends F{static isSelection(q){return q instanceof i?!0:q?F.isRange(q)&&j.isPosition(q.anchor)&&j.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,we,Me,Xe){let tt,lt;if(typeof q=="number"&&typeof we=="number"&&typeof Me=="number"&&typeof Xe=="number"?(tt=new j(q,we),lt=new j(Me,Xe)):j.isPosition(q)&&j.isPosition(we)&&(tt=j.of(q),lt=j.of(we)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$pL=N,e.$pL=N=i=Ge([y],N);const O=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,M.$7)("connectionToken")};class z{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we,Me){if(typeof q!="string"||q.length===0)throw(0,M.$7)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,M.$7)("port");typeof Me<"u"&&O(Me),this.host=q,this.port=Math.round(we),this.connectionToken=Me}}e.$qL=z;class K{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we){this.makeConnection=q,this.connectionToken=we,typeof we<"u"&&O(we)}}e.$rL=K;class te extends Error{static NotAvailable(q,we){return new te(q,k.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(q){return new te(q,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,we=k.RemoteAuthorityResolverErrorCode.Unknown,Me){super(q),this._message=q,this._code=we,this._detail=Me,Object.setPrototypeOf(this,te.prototype)}}e.$sL=te;var x;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var X;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let Z=r=class{static isTextEdit(q){return q instanceof r?!0:q?F.isRange(q)&&typeof q.newText=="string":!1}static replace(q,we){return new r(q,we)}static insert(q,we){return r.replace(new F(q,q),we)}static delete(q){return r.replace(q,"")}static setEndOfLine(q){const we=new r(new F(new j(0,0),new j(0,0)),"");return we.newEol=q,we}get range(){return this.c}set range(q){if(q&&!F.isRange(q))throw(0,M.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,M.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,M.$7)("newEol");this.f=q}constructor(q,we){this.c=q,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$tL=Z,e.$tL=Z=r=Ge([y],Z);let ce=n=class{static isNotebookCellEdit(q){return q instanceof n?!0:q?ni.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,we){return new n(q,we)}static insertCells(q,we){return new n(new ni(q,q),we)}static deleteCells(q){return new n(q,[])}static updateCellMetadata(q,we){const Me=new n(new ni(q,q),[]);return Me.newCellMetadata=we,Me}static updateNotebookMetadata(q){const we=new n(new ni(0,0),[]);return we.newNotebookMetadata=q,we}constructor(q,we){this.range=q,this.newCells=we}};e.$uL=ce,e.$uL=ce=n=Ge([y],ce);class _{static isSnippetTextEdit(q){return q instanceof _?!0:q?F.isRange(q.range)&&J.isSnippetString(q.snippet):!1}static replace(q,we){return new _(q,we)}static insert(q,we){return _.replace(new F(q,q),we)}constructor(q,we){this.range=q,this.snippet=we}}e.$vL=_;var ge;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,we,Me,Xe){this.c.push({_type:1,from:q,to:we,options:Me,metadata:Xe})}createFile(q,we,Me){this.c.push({_type:1,from:void 0,to:q,options:we,metadata:Me})}deleteFile(q,we,Me){this.c.push({_type:1,from:q,to:void 0,options:we,metadata:Me})}e(q,we,Me){this.c.push({_type:3,metadata:Me,uri:q,edit:{editType:5,metadata:we},notebookMetadata:we})}f(q,we,Me,Xe){const tt=we.start,lt=we.end;(tt!==lt||Me.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:lt-tt,cells:Me,metadata:Xe})}g(q,we,Me,Xe){this.c.push({_type:3,metadata:Xe,uri:q,edit:{editType:3,index:we,metadata:Me}})}replace(q,we,Me,Xe){this.c.push({_type:2,uri:q,edit:new Z(we,Me),metadata:Xe})}insert(q,we,Me,Xe){this.replace(q,new F(we,we),Me,Xe)}delete(q,we,Me){this.replace(q,we,"",Me)}has(q){return this.c.some(we=>we._type===2&&we.uri.toString()===q.toString())}set(q,we){if(we)for(const Me of we){if(!Me)continue;let Xe,tt;Array.isArray(Me)?(Xe=Me[0],tt=Me[1]):Xe=Me,ce.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(q,Xe.range.start,Xe.newCellMetadata,tt):Xe.newNotebookMetadata?this.e(q,Xe.newNotebookMetadata,tt):this.f(q,Xe.range,Xe.newCells,tt):_.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:q,range:Xe.range,edit:Xe.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Xe,metadata:tt})}else{for(let Me=0;Me<this.c.length;Me++){const Xe=this.c[Me];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===q.toString()&&(this.c[Me]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const we=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===q.toString()&&we.push(Me.edit);return we}entries(){const q=new P.$Ac;for(const we of this.c)if(we._type===2){let Me=q.get(we.uri);Me||(Me=[we.uri,[]],q.set(we.uri,Me)),Me[1].push(we.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$wL=ne,e.$wL=ne=Ge([y],ne);let J=o=class{static isSnippetString(q){return q instanceof o?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=o.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,we=this.e++){if(typeof q=="function"){const Me=new o;Me.e=this.e,q(Me),this.e=Me.e,q=Me.value}else q=o.c(q);return this.value+="${",this.value+=we,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,we=this.e++){const Me=q.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(q,we){if(typeof we=="function"){const Me=new o;Me.e=this.e,we(Me),this.e=Me.e,we=Me.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$xL=J,e.$xL=J=o=Ge([y],J);var W;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var re;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?F.isRange(q.range)&&E.URI.isUri(q.uri):!1}constructor(q,we){if(this.uri=q,we)if(F.isRange(we))this.range=F.of(we);else if(j.isPosition(we))this.range=new F(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$yL=ye,e.$yL=ye=t=Ge([y],ye);let he=class{static is(q){return q?typeof q.message=="string"&&q.location&&F.isRange(q.location.range)&&E.URI.isUri(q.location.uri):!1}constructor(q,we){this.location=q,this.message=we}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.location.range.isEqual(we.location.range)&&q.location.uri.toString()===we.location.uri.toString()}};e.$zL=he,e.$zL=he=Ge([y],he);let fe=class{constructor(q,we,Me=re.Error){if(!F.isRange(q))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=q,this.message=we,this.severity=Me}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.severity===we.severity&&q.code===we.code&&q.severity===we.severity&&q.source===we.source&&q.range.isEqual(we.range)&&(0,D.$ub)(q.tags,we.tags)&&(0,D.$ub)(q.relatedInformation,we.relatedInformation,he.isEqual)}};e.$AL=fe,e.$AL=fe=Ge([y],fe);let ue=class{constructor(q,we){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=we}};e.$BL=ue,e.$BL=ue=Ge([y],ue);var me;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let V=class{constructor(q,we=me.Text){this.range=q,this.kind=we}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.$CL=V,e.$CL=V=Ge([y],V);let Y=class{constructor(q,we){this.uri=q,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$DL=Y,e.$DL=Y=Ge([y],Y);var de;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(de||(e.SymbolKind=de={}));var pe;(function(G){G[G.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Pe=h=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,we,Me,Xe,tt){this.name=q,this.kind=we,this.containerName=tt,typeof Me=="string"&&(this.containerName=Me),Xe instanceof ye?this.location=Xe:Me instanceof F&&(this.location=new ye(Xe,Me)),h.validate(this)}toJSON(){return{name:this.name,kind:de[this.kind],location:this.location,containerName:this.containerName}}};e.$EL=Pe,e.$EL=Pe=h=Ge([y],Pe);let ve=s=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(s.validate)}constructor(q,we,Me,Xe,tt){this.name=q,this.detail=we,this.kind=Me,this.range=Xe,this.selectionRange=tt,this.children=[],s.validate(this)}};e.$FL=ve,e.$FL=ve=s=Ge([y],ve);var Ce;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let B=class{constructor(q,we){this.title=q,this.kind=we}};e.$GL=B,e.$GL=B=Ge([y],B);let Q=class{static{f=this}static{this.c="."}constructor(q){this.value=q}append(q){return new f(this.value?this.value+f.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+f.c)}};e.$HL=Q,e.$HL=Q=f=Ge([y],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let ee=class{constructor(q,we){if(this.range=q,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$IL=ee,e.$IL=ee=Ge([y],ee);class H{constructor(q,we,Me,Xe,tt,lt){this.kind=q,this.name=we,this.detail=Me,this.uri=Xe,this.range=tt,this.selectionRange=lt}}e.$JL=H;class oe{constructor(q,we){this.fromRanges=we,this.from=q}}e.$KL=oe;class le{constructor(q,we){this.fromRanges=we,this.to=q}}e.$LL=le;var Re;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let je=class{constructor(q,we){this.range=q,this.command=we}get isResolved(){return!!this.command}};e.$ML=je,e.$ML=je=Ge([y],je);let He=l=class{#e;static isMarkdownString(q){return q instanceof l?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,we=!1){this.#e=new d.$jk(q,{supportThemeIcons:we})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,we){return this.#e.appendCodeblock(we??"",q),this}};e.$NL=He,e.$NL=He=l=Ge([y],He);let Qe=class{constructor(q,we){this.label=q,this.documentation=we}};e.$OL=Qe,e.$OL=Qe=Ge([y],Qe);let _e=class{constructor(q,we){this.label=q,this.documentation=we,this.parameters=[]}};e.$PL=_e,e.$PL=_e=Ge([y],_e);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$QL=at,e.$QL=at=Ge([y],at);var st;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var rt;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Le=class{constructor(q){this.value=q}};e.$RL=Le,e.$RL=Le=Ge([y],Le);let ze=class{constructor(q,we,Me){this.position=q,this.label=we,this.kind=Me}};e.$SL=ze,e.$SL=ze=Ge([y],ze);var Ae;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae||(e.CompletionTriggerKind=Ae={}));var Ze;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ze||(e.CompletionItemKind=Ze={}));var ie;(function(G){G[G.Deprecated=1]="Deprecated"})(ie||(e.CompletionItemTag=ie={}));let se=class{constructor(q,we){this.label=q,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&Ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$TL=se,e.$TL=se=Ge([y],se);let Ie=class{constructor(q=[],we=!1){this.items=q,this.isIncomplete=we}};e.$UL=Ie,e.$UL=Ie=Ge([y],Ie);let qe=class{constructor(q,we,Me){this.insertText=q,this.range=we,this.command=Me}};e.$VL=qe,e.$VL=qe=Ge([y],qe);let Ye=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$WL=Ye,e.$WL=Ye=Ge([y],Ye);var it;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var nt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Oe(G,q){return`${C.$nm.toKey(G)}.${q}`}e.$XL=Oe;var yt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Dt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Tt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var Ft;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Et;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Ht;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(G){function q(we){switch(we){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=q}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Ot;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(G){function q(we){switch(we){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=q}(Ot||(e.SyntaxTokenType=Ot={}));let Yt=class{constructor(q,we){if(we&&!E.URI.isUri(we))throw(0,M.$7)("target");if(!F.isRange(q)||q.isEmpty)throw(0,M.$7)("range");this.range=q,this.target=we}};e.$YL=Yt,e.$YL=Yt=Ge([y],Yt);let Vt=class{constructor(q,we,Me,Xe){this.red=q,this.green=we,this.blue=Me,this.alpha=Xe}};e.$ZL=Vt,e.$ZL=Vt=Ge([y],Vt);let Ut=class{constructor(q,we){if(we&&!(we instanceof Vt))throw(0,M.$7)("color");if(!F.isRange(q)||q.isEmpty)throw(0,M.$7)("range");this.range=q,this.color=we}};e.$1L=Ut,e.$1L=Ut=Ge([y],Ut);let et=class{constructor(q){if(!q||typeof q!="string")throw(0,M.$7)("label");this.label=q}};e.$2L=et,e.$2L=et=Ge([y],et);var Gt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Kt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var ht;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class $t{constructor(q,we,Me){if(this.startIndex=q,this.length=we,this.tooltip=Me,typeof q!="number"||q<0)throw(0,M.$7)("startIndex");if(typeof we!="number"||we<1)throw(0,M.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,M.$7)("tooltip")}}e.$3L=$t;class Bt{constructor(q){this.uri=q}}e.$4L=Bt;class Qt{constructor(q){this.terminalCommand=q}}e.$5L=Qt;var kt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,M.$7)("options")}}e.$6L=ft;var It;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var _t;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let At=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(q){switch(q){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(q,we){if(this.label=we,typeof q!="string"||typeof we!="string")throw(0,M.$7)("name");this.c=q}get id(){return this.c}};e.$7L=At,e.$7L=At=u=Ge([y],At);function Ke(G){let q="";for(let we=0;we<G.length;we++)q+=G[we].replace(/,/g,",,")+",";return q}let Nt=class{constructor(q,we,Me){if(typeof q!="string")throw(0,M.$7)("process");this.e=[],this.c=q,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Me):this.f=we)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,M.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const we of this.e)q.push(we);return Ke(q)}};e.$8L=Nt,e.$8L=Nt=Ge([y],Nt);let jt=class{constructor(q,we,Me){if(this.f=[],Array.isArray(we)){if(!q)throw(0,M.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,M.$7)("command");this.e=q,this.f=we,this.g=Me}else{if(typeof q!="string")throw(0,M.$7)("commandLine");this.c=q,this.g=we}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,M.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,M.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)q.push(typeof we=="string"?we:we.value);return Ke(q)}};e.$9L=jt,e.$9L=jt=Ge([y],jt);var Zt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Zt||(e.ShellQuoting=Zt={}));var gt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Mt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$rg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$0L=Mt;let Pt=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,we,Me,Xe,tt,lt){this.k=!1,this.l=this.definition=q;let mt;typeof we=="string"?(this.o=this.name=we,this.w=this.source=Me,this.execution=Xe,mt=tt,this.k=!0):we===gt.Global||we===gt.Workspace?(this.target=we,this.o=this.name=Me,this.w=this.source=Xe,this.execution=tt,mt=lt):(this.target=we,this.o=this.name=Me,this.w=this.source=Xe,this.execution=tt,mt=lt),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof jt?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,R.$rg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,M.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const we=this.l.type;(v.g===we||v.e===we||v.f===we||v.c===we)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$$L=Pt,e.$$L=Pt=v=Ge([y],Pt);var Wt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Wt||(e.ProgressLocation=Wt={}));var Ne;(function(G){function q(we){const Me=we;return(0,$.$Nf)(Me.value)?Me.tooltip&&!(0,$.$Jf)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}G.isViewBadge=q})(Ne||(e.ViewBadge=Ne={}));let Fe=I=class{static isTreeItem(q,we){const Me=q;if(Me.checkboxState!==void 0){const Xe=(0,$.$Nf)(Me.checkboxState)?Me.checkboxState:(0,$.$Lf)(Me.checkboxState)&&(0,$.$Nf)(Me.checkboxState.state)?Me.checkboxState.state:void 0,tt=!(0,$.$Nf)(Me.checkboxState)&&(0,$.$Lf)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==ae.Checked&&Xe!==ae.Unchecked||tt!==void 0&&!(0,$.$Jf)(tt))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(q instanceof I)return!0;if(Me.label!==void 0&&!(0,$.$Jf)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,$.$Jf)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,$.$Jf)(Me.iconPath)&&!E.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,$.$Jf)(Me.iconPath.id))){const Xe=Me.iconPath;if(!Xe||!(0,$.$Jf)(Xe.light)&&!E.URI.isUri(Xe.light)&&!(0,$.$Jf)(Xe.dark)&&!E.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,$.$Jf)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!E.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,$.$Jf)(Me.tooltip)&&!(Me.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<De.None&&Me.collapsibleState>De.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,$.$Jf)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(q,we=De.None){this.collapsibleState=we,E.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$_L=Fe,e.$_L=Fe=I=Ge([y],Fe);var De;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(De||(e.TreeItemCollapsibleState=De={}));var ae;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(ae||(e.TreeItemCheckboxState=ae={}));let Te=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$aM=Te,e.$aM=Te=Ge([y],Te);class Be extends Te{}e.$bM=Be;class xe extends Be{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$cM=xe;class Je{constructor(q,we,Me,Xe){this.name=q,this.uri=we,this._itemId=Me,this.c=Xe}data(){return this.c()}}e.$dM=Je;let ut=class{#e=new Map;constructor(q){for(const[we,Me]of q??[]){const Xe=this.#e.get(this.#t(we));Xe?Xe.push(Me):this.#e.set(this.#t(we),[Me])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,we){this.#e.set(this.#t(q),[we])}forEach(q,we){for(const[Me,Xe]of this.#e)for(const tt of Xe)q.call(we,tt,Me,this)}*[Symbol.iterator](){for(const[q,we]of this.#e)for(const Me of we)yield[q,Me]}#t(q){return q.toLowerCase()}};e.$eM=ut,e.$eM=ut=Ge([y],ut);let vt=class{constructor(q){this.insertText=q}};e.$fM=vt,e.$fM=vt=Ge([y],vt);let Jt=class{constructor(q,we){this.label=we,this.insertText=q}};e.$gM=Jt,e.$gM=Jt=Ge([y],Jt);let St=class{constructor(q,we){this.id=q,this.color=we}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$hM=St,e.$hM=St=Ge([y],St),St.File=new St("file"),St.Folder=new St("folder");let Ct=class{constructor(q){this.id=q}};e.$iM=Ct,e.$iM=Ct=Ge([y],Ct);var wt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(wt||(e.ConfigurationTarget=wt={}));let Si=class{get base(){return this.c}set base(q){this.c=q,this.e=E.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,we){if(typeof q!="string"&&(!q||!E.URI.isUri(q)&&!E.URI.isUri(q.uri)))throw(0,M.$7)("base");if(typeof we!="string")throw(0,M.$7)("pattern");typeof q=="string"?this.baseUri=E.URI.file(q):E.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$jM=Si,e.$jM=Si=Ge([y],Si);const Ki=new WeakMap;function Lt(G,q){Ki.set(G,q)}e.$kM=Lt;let si=class{constructor(q,we,Me,Xe){this.enabled=typeof q=="boolean"?q:!0,typeof we=="string"&&(this.condition=we),typeof Me=="string"&&(this.hitCondition=Me),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this.c||(this.c=Ki.get(this)??(0,R.$rg)()),this.c}};e.$lM=si,e.$lM=si=Ge([y],si);let mi=class extends si{constructor(q,we,Me,Xe,tt){if(super(we,Me,Xe,tt),q===null)throw(0,M.$7)("location");this.location=q}};e.$mM=mi,e.$mM=mi=Ge([y],mi);let ui=class extends si{constructor(q,we,Me,Xe,tt){super(we,Me,Xe,tt),this.functionName=q}};e.$nM=ui,e.$nM=ui=Ge([y],ui);let Di=class extends si{constructor(q,we,Me,Xe,tt,lt,mt){if(super(Xe,tt,lt,mt),!we)throw(0,M.$7)("dataId");this.label=q,this.dataId=we,this.canPersist=Me}};e.$oM=Di,e.$oM=Di=Ge([y],Di);let Ci=class{constructor(q,we,Me){this.command=q,this.args=we||[],this.options=Me}};e.$pM=Ci,e.$pM=Ci=Ge([y],Ci);let zt=class{constructor(q,we){this.port=q,this.host=we}};e.$qM=zt,e.$qM=zt=Ge([y],zt);let $i=class{constructor(q){this.path=q}};e.$rM=$i,e.$rM=$i=Ge([y],$i);let Ii=class{constructor(q){this.implementation=q}};e.$sM=Ii,e.$sM=Ii=Ge([y],Ii);let li=class{constructor(q,we,Me){this.session=q,this.threadId=we,this.frameId=Me}};e.$tM=li,e.$tM=li=Ge([y],li);let hi=class{constructor(q,we){this.session=q,this.threadId=we}};e.$uM=hi,e.$uM=hi=Ge([y],hi);let dt=class{constructor(q,we){this.range=q,this.expression=we}};e.$vM=dt,e.$vM=dt=Ge([y],dt);var Qi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Qi||(e.InlineCompletionTriggerKind=Qi={}));let ei=class{constructor(q,we){this.range=q,this.text=we}};e.$wM=ei,e.$wM=ei=Ge([y],ei);let oi=class{constructor(q,we,Me=!0){this.range=q,this.variableName=we,this.caseSensitiveLookup=Me}};e.$xM=oi,e.$xM=oi=Ge([y],oi);let bi=class{constructor(q,we){this.range=q,this.expression=we}};e.$yM=bi,e.$yM=bi=Ge([y],bi);let Pi=class{constructor(q,we){this.frameId=q,this.stoppedLocation=we}};e.$zM=Pi,e.$zM=Pi=Ge([y],Pi);var Zi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Li=b=class extends Error{static FileExists(q){return new b(q,p.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(q){return new b(q,p.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(q){return new b(q,p.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(q){return new b(q,p.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(q){return new b(q,p.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(q){return new b(q,p.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(q,we=p.FileSystemProviderErrorCode.Unknown,Me){super(E.URI.isUri(q)?q.toString(!0):q),this.code=Me?.name??"Unknown",(0,p.$Hk)(this,we),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$AM=Li,e.$AM=Li=b=Ge([y],Li);let pi=class{constructor(q,we,Me){this.start=q,this.end=we,this.kind=Me}};e.$BM=pi,e.$BM=pi=Ge([y],pi);var Yi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Ai;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var di;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(di||(e.CommentMode=di={}));var Xi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var wi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(q,we=[]){this.tokenTypes=q,this.tokenModifiers=we}}e.$CM=Ri;function ln(G){return typeof G>"u"||(0,$.$Kf)(G)}class Ni{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let we=0,Me=q.tokenTypes.length;we<Me;we++)this.k.set(q.tokenTypes[we],we);for(let we=0,Me=q.tokenModifiers.length;we<Me;we++)this.l.set(q.tokenModifiers[we],we)}}push(q,we,Me,Xe,tt){if(typeof q=="number"&&typeof we=="number"&&typeof Me=="number"&&typeof Xe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.q(q,we,Me,Xe,tt);if(F.isRange(q)&&typeof we=="string"&&ln(Me))return this.o(q,we,Me);throw(0,M.$7)()}o(q,we,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const Xe=q.start.line,tt=q.start.character,lt=q.end.character-q.start.character,mt=this.k.get(we);let qt=0;if(Me)for(const xt of Me){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(xt);qt|=1<<ii>>>0}this.q(Xe,tt,lt,mt,qt)}q(q,we,Me,Xe,tt){if(this.f&&(q<this.c||q===this.c&&we<this.e)){this.f=!1;const qt=this.g.length/5|0;let xt=0,ii=0;for(let ri=0;ri<qt;ri++){let ci=this.g[5*ri],Gi=this.g[5*ri+1];ci===0?(ci=xt,Gi+=ii):ci+=xt,this.g[5*ri]=ci,this.g[5*ri+1]=Gi,xt=ci,ii=Gi}}let lt=q,mt=we;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Me,this.g[this.j++]=Xe,this.g[this.j++]=tt,this.c=q,this.e=we}static r(q){const we=[],Me=q.length/5|0;for(let mt=0;mt<Me;mt++)we[mt]=mt;we.sort((mt,qt)=>{const xt=q[5*mt],ii=q[5*qt];if(xt===ii){const ri=q[5*mt+1],ci=q[5*qt+1];return ri-ci}return xt-ii});const Xe=new Uint32Array(q.length);let tt=0,lt=0;for(let mt=0;mt<Me;mt++){const qt=5*we[mt],xt=q[qt+0],ii=q[qt+1],ri=q[qt+2],ci=q[qt+3],Gi=q[qt+4],In=xt-tt,Un=In===0?ii-lt:ii,Ji=5*mt;Xe[Ji+0]=In,Xe[Ji+1]=Un,Xe[Ji+2]=ri,Xe[Ji+3]=ci,Xe[Ji+4]=Gi,tt=xt,lt=ii}return Xe}build(q){return this.f?new ai(new Uint32Array(this.g),q):new ai(Ni.r(this.g),q)}}e.$DM=Ni;class ai{constructor(q,we){this.resultId=we,this.data=q}}e.$EM=ai;class hn{constructor(q,we,Me){this.start=q,this.deleteCount=we,this.data=Me}}e.$FM=hn;class dn{constructor(q,we){this.resultId=we,this.edits=q}}e.$GM=dn;var xi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(xi||(e.DebugConsoleMode=xi={}));class Mi{constructor(q){this.name=q}}e.$HM=Mi;let Ti=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$IM=Ti,e.$IM=Ti=Ge([y],Ti);var _i;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(_i||(e.QuickPickItemKind=_i={}));var vi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(vi||(e.InputBoxValidationSeverity=vi={}));var Fi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Fi||(e.ExtensionKind=Fi={}));class fn{static validate(q){if(typeof q.badge=="string"){let we=(0,w.$kf)(q.badge,0);if(we<q.badge.length&&(we+=(0,w.$kf)(q.badge,we)),q.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!St.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,we,Me){this.badge=q,this.tooltip=we,this.color=Me}}e.$JM=fn;let yi=class{constructor(q){this.kind=q}};e.$KM=yi,e.$KM=yi=Ge([y],yi);var Oi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Oi||(e.ColorThemeKind=Oi={}));class ni{static isNotebookRange(q){return q instanceof ni?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,we){if(q<0)throw(0,M.$7)("start must be positive");if(we<0)throw(0,M.$7)("end must be positive");q<=we?(this.c=q,this.e=we):(this.c=we,this.e=q)}with(q){let we=this.c,Me=this.e;return q.start!==void 0&&(we=q.start),q.end!==void 0&&(Me=q.end),we===this.c&&Me===this.e?this:new ni(we,Me)}}e.$LM=ni;class Ei{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(we=>Ei.isNotebookCellData(we))}static isNotebookCellData(q){return!0}constructor(q,we,Me,Xe,tt,lt,mt){this.kind=q,this.value=we,this.languageId=Me,this.mime=Xe,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,Ei.validate(this)}}e.$MM=Ei;class gn{constructor(q){this.cells=q}}e.$NM=gn;class Xt{static isNotebookCellOutputItem(q){return q instanceof Xt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const we={name:q.name,message:q.message,stack:q.stack};return Xt.json(we,"application/vnd.code.notebook.error")}static stdout(q){return Xt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Xt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,we="application/octet-stream"){return new Xt(q,we)}static#e=new TextEncoder;static text(q,we=A.$hs.text){const Me=Xt.#e.encode(String(q));return new Xt(Me,we)}static json(q,we="text/x-json"){const Me=JSON.stringify(q,void 0,"	");return Xt.text(Me,we)}constructor(q,we){this.data=q,this.mime=we;const Me=(0,A.$ls)(we,!0);if(!Me)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$OM=Xt;class fi{static isNotebookCellOutput(q){return q instanceof fi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,we=!1){const Me=new Set,Xe=new Set;for(let tt=0;tt<q.length;tt++){const lt=q[tt],mt=(0,A.$ls)(lt.mime);if(!Me.has(mt)||(0,S.$nJ)(mt)){Me.add(mt);continue}Xe.add(tt),we&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Xe.size===0?q:q.filter((tt,lt)=>!Xe.has(lt))}constructor(q,we,Me){this.items=fi.ensureUniqueMimeTypes(q,!0),typeof we=="string"?(this.id=we,this.metadata=Me):(this.id=(0,R.$rg)(),this.metadata=we??Me)}}e.$PM=fi;var ji;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(ji||(e.NotebookCellKind=ji={}));var We;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(We||(e.NotebookCellExecutionState=We={}));var ti;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var zi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(zi||(e.NotebookEditorRevealType=zi={}));class ot{constructor(q,we){this.text=q,this.alignment=we}}e.$QM=ot;var bt;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(bt||(e.NotebookControllerAffinity=bt={}));var en;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class mn{constructor(q,we=[]){this.uri=q,this.provides=(0,D.$3b)(we)}}e.$RM=mn;class tn{constructor(q){this.label=q}}e.$SM=tn;var nn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let gi=class{constructor(q,we){this.label=q,this.timestamp=we}};e.$TM=gi,e.$TM=gi=Ge([y],gi);var rn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(q,we){this.ranges=q,this.wordPattern=we}}e.$UM=an;class $n{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$VM=$n;var cn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Ui=class{constructor(q=void 0,we=void 0,Me=void 0,Xe=!1){this.include=q,this.exclude=we,this.profile=Me,this.continuous=Xe}};e.$WM=Ui,e.$WM=Ui=Ge([y],Ui);let Bi=g=class{static diff(q,we,Me){const Xe=new g(q);return Xe.expectedOutput=we,Xe.actualOutput=Me,Xe}constructor(q){this.message=q}};e.$XM=Bi,e.$XM=Bi=g=Ge([y],Bi);let Wi=class{constructor(q){this.id=q}};e.$YM=Wi,e.$YM=Wi=Ge([y],Wi);class ki{constructor(q,we){this.covered=q,this.total=we}}e.$ZM=ki;const Vi=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class qi{static fromDetails(q,we){const Me=new ki(0,0),Xe=new ki(0,0),tt=new ki(0,0);for(const mt of we)if("branches"in mt){Me.total+=1,Me.covered+=mt.executed?1:0;for(const qt of mt.branches)Xe.total+=1,Xe.covered+=qt.executed?1:0}else tt.total+=1,tt.covered+=mt.executed?1:0;const lt=new qi(q,Me,Xe.total>0?Xe:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=we,lt}constructor(q,we,Me,Xe){this.uri=q,this.statementCoverage=we,this.branchCoverage=Me,this.functionCoverage=Xe,Vi(we),Vi(Me),Vi(Xe)}}e.$1M=qi;class bn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Me=[]){this.executed=q,this.location=we,this.branches=Me}}e.$2M=bn;class be{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Me){this.executed=q,this.location=we,this.label=Me}}e.$3M=be;class Ee{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Me){this.name=q,this.executed=we,this.location=Me}}e.$4M=Ee;var Ue;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(Ue||(e.ExternalUriOpenerPriority=Ue={}));var ct;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(ct||(e.WorkspaceTrustState=ct={}));var pt;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(pt||(e.PortAutoForwardAction=pt={}));class Rt{constructor(q,we,Me,Xe,tt,lt){this.kind=q,this.name=we,this.detail=Me,this.uri=Xe,this.range=tt,this.selectionRange=lt}}e.$5M=Rt;class Hi{constructor(q){this.uri=q}}e.$6M=Hi;class Pn{constructor(q,we){this.original=q,this.modified=we}}e.$7M=Pn;class Ln{constructor(q,we,Me,Xe){this.base=q,this.input1=we,this.input2=Me,this.result=Xe}}e.$8M=Ln;class An{constructor(q,we){this.uri=q,this.viewType=we}}e.$9M=An;class Rn{constructor(q){this.viewType=q}}e.$0M=Rn;class Nn{constructor(q,we){this.uri=q,this.notebookType=we}}e.$$M=Nn;class Mn{constructor(q,we,Me){this.original=q,this.modified=we,this.notebookType=Me}}e.$_M=Mn;class Tn{constructor(){}}e.$aN=Tn;class Fn{constructor(q,we){this.uri=q,this.inputBoxUri=we}}e.$bN=Fn;class On{constructor(q){this.providerId=q}}e.$cN=On;var pn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var wn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(wn||(e.ChatAgentCopyKind=wn={}));var vn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class jn{constructor(q,we){this.label=q,this.values=we}}e.$dN=jn;var yn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(G){G[G.System=0]="System",G[G.User=1]="User",G[G.Assistant=2]="Assistant",G[G.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class zn{constructor(q,we){this.role=q,this.content=we}}e.$eN=zn;var kn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var Cn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}))}),define(ke[312],Se([1,0,6,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$kL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,w,$){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(A);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(w,$)??[]}getRelatedInformation(A,w,$){return this.c.$getAiRelatedInformation(w,$)}registerRelatedInformationProvider(A,w,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiRelatedInformationProvider(E,w),new M.$mL(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$3fc=d}),define(ke[313],Se([1,0,4,6,7,25]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class A{constructor(E){this.b=new Map,this.c=new D.$Wd,this.onDidChangeSessions=this.c.event,this.d=new w,this.f=new w,this.a=E.getProxy(M.$kL.MainThreadAuthentication)}async getSession(E,R,C,p={}){const k=P.$nm.toKey(E.identifier),S=[...C].sort().join(" ");return await this.d.getOrCreate(`${k} ${R} ${S}`,async()=>{await this.a.$ensureProvider(R);const c=E.displayName||E.name;return this.a.$getSession(R,C,k,c,p)})}async getSessions(E,R,C){const p=P.$nm.toKey(E.identifier),k=[...C].sort().join(" ");return await this.f.getOrCreate(`${p} ${k}`,async()=>{await this.a.$ensureProvider(R);const S=E.displayName||E.name;return this.a.$getSessions(R,C,p,S)})}async removeSession(E,R){const C=this.b.get(E);return C?C.provider.removeSession(R):this.a.$removeSession(E,R)}registerAuthenticationProvider(E,R,C,p){if(this.b.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this.b.set(E,{label:R,provider:C,options:p??{supportsMultipleAccounts:!1}});const k=C.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(E,S));return this.a.$registerAuthenticationProvider(E,R,p?.supportsMultipleAccounts??!1),new d.$mL(()=>{k.dispose(),this.b.delete(E),this.a.$unregisterAuthenticationProvider(E)})}$createSession(E,R,C){const p=this.b.get(E);if(p)return Promise.resolve(p.provider.createSession(R,C));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,R){const C=this.b.get(E);if(C)return Promise.resolve(C.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,R){const C=this.b.get(E);if(C)return Promise.resolve(C.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,R){return this.c.fire({provider:{id:E,label:R}}),Promise.resolve()}}e.$bgc=A;class w{constructor(){this.a=new Map}getOrCreate(E,R){const C=this.a.get(E);if(C)return C;const p=R().finally(()=>this.a.delete(E));return this.a.set(E,p),p}}}),define(ke[147],Se([1,0,2,6,7,5,20,12,19,13,17,26]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=void 0;let k=class{static{p=this}static{this.c=0}static{this.d=250}constructor(c,m){this.h=m,this.f=new Map,this.g=c.getProxy(M.$kL.MainThreadDecorations)}registerFileDecorationProvider(c,m){const a=p.c++;this.f.set(a,{provider:c,extensionDescription:m}),this.g.$registerDecorationProvider(a,m.identifier.value);const i=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(a,null);return}const n=(0,$.$3b)(r);if(n.length<=p.d){this.g.$onDidChange(a,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,n.length);const o=n.map(s=>({uri:s,rank:(0,E.$Qe)(s.path,"/")})),t=(0,$.$zb)(o,(s,f)=>s.rank-f.rank||(0,E.$6e)(s.uri.path,f.uri.path)),h=[];e:for(const s of t){let f;for(const l of s){const u=(0,R.$mc)(l.uri.path);if(f!==u&&(f=u,h.push(l.uri)>=p.d))break e}}this.g.$onDidChange(a,h)});return new d.$mL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(c,m,a){if(!this.f.has(c))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this.f.get(c);return await Promise.all(m.map(async o=>{try{const{uri:t,id:h}=o,s=await Promise.resolve(r.provideFileDecoration(D.URI.revive(t),a));if(!s)return;try{d.$JM.validate(s),s.badge&&typeof s.badge!="string"&&(0,C.$LF)(n,"codiconDecoration"),i[h]=[s.propagate,s.tooltip,s.badge,s.color]}catch(f){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${f}`)}}catch(t){this.h.error(t)}})),i}};e.$ahc=k,e.$ahc=k=p=Ge([Ve(0,A.$pN),Ve(1,w.$pj)],k),e.$bhc=(0,P.$8h)("IExtHostDecorations")}),define(ke[314],Se([1,0,14,2,7,6,15,22,13]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class E{static{this.a=0}constructor(C,p,k){this.d=p,this.e=k,this.b=new Map,this.c=C.getProxy(P.$kL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,p){if(Object.keys(A.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const k=E.a++;this.b.set(k,p),this.c.$registerTextContentProvider(k,C);let S;if(typeof p.onDidChange=="function"){let c;S=p.onDidChange(async m=>{if(m.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;c&&await c;const a=this.$provideTextDocumentContent(k,m).then(async i=>{if(!i&&typeof i!="string")return;const r=this.d.getDocument(m);if(!r)return;const n=(0,$.$1e)(i);if(!r.equalLines(n))return this.c.$onVirtualDocumentChange(m,i)}).catch(D.$1).finally(()=>{c===a&&(c=void 0)});c=a})}return new d.$mL(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,p){const k=this.b.get(C);return k?Promise.resolve(k.provideTextDocumentContent(M.URI.revive(p),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$dhc=E}),define(ke[148],Se([1,0,61,15,13,176,126,7,19]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.$rN=void 0;const E=new Map;function R(S,c){c?E.set(S,c):E.delete(S)}e.$rN=R;function C(S){return E.get(S)}class p extends P.$nv{constructor(c,m,a,i,r,n,o,t){super(m,a,i,r),this.c=c,this.m=n,this.q=o,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===M.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(m){return m?c.s(m):c.getText()},get eol(){return c.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(m){return c.t(m)},offsetAt(m){return c.u(m)},positionAt(m){return c.v(m)},validateRange(m){return c.w(m)},validatePosition(m){return c.x(m)},getWordRangeAtPosition(m,a){return c.y(m,a)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,D.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,D.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const m=this.w(c);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const a=this.g,i=m.start.line,r=m.end.line,n=[];n.push(this.f[i].substring(m.start.character));for(let o=i+1;o<r;o++)n.push(this.f[o]);return n.push(this.f[r].substring(0,m.end.character)),n.join(a)}t(c){let m;if(c instanceof w.$nL?m=c.line:typeof c=="number"&&(m=c),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new k(m,this.f[m],m===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const m=this.j.getIndexOf(c),a=this.f[m.index].length;return new w.$nL(m.index,Math.min(m.remainder,a))}w(c){if(!(c instanceof w.$oL))throw new Error("Invalid argument");const m=this.x(c.start),a=this.x(c.end);return m===c.start&&a===c.end?c:new w.$oL(m.line,m.character,a.line,a.character)}x(c){if(!(c instanceof w.$nL))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:m,character:a}=c,i=!1;if(m<0)m=0,a=0,i=!0;else if(m>=this.f.length)m=this.f.length-1,a=this.f[m].length,i=!0;else{const r=this.f[m].length;a<0?(a=0,i=!0):a>r&&(a=r,i=!0)}return i?new w.$nL(m,a):c}y(c,m){const a=this.x(c);if(!m)m=C(this.m);else if((0,d.$Ze)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,A.$zs)(a.character+1,(0,A.$xs)(m),this.f[a.line],0);if(i)return new w.$oL(a.line,i.startColumn-1,a.line,i.endColumn-1)}}e.$sN=p;class k{constructor(c,m,a){this.a=c,this.b=m,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$oL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$oL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$tN=k}),define(ke[315],Se([1,0,6,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$kL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,w,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(A);if(!E)throw new Error("Embedding vector provider not found");const R=await E.provideEmbeddingVector(w,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,w,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiEmbeddingVectorProvider(w,E),new M.$mL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$fhc=d}),define(ke[70],Se([1,0,6,32,7,21,5,20,59,3,8,23,15]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0;let S=k=class{constructor(m,a){this.b=new Map,this.c=new R.$eh,this.a=m.getProxy(D.$kL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const o=i.b.get(r.scheme);return o?(await i.a.$ensureActivation(r.scheme),n=await o.impl.stat(r)):n=await i.a.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===M.FilePermission.Readonly?1:void 0}}catch(n){k.e(n)}},async readDirectory(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i.a.$readdir(r)}catch(n){return k.e(n)}},async createDirectory(r){try{const n=i.b.get(r.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(n.impl,n.extUri,r)):await i.a.$mkdir(r)}catch(n){return k.e(n)}},async readFile(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i.a.$readFile(r)).buffer}catch(n){return k.e(n)}},async writeFile(r,n){try{const o=i.b.get(r.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(o.impl,o.extUri,o.extUri.dirname(r)),await i.c.queueFor(r,()=>Promise.resolve(o.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(r,P.$ke.wrap(n))}catch(o){return k.e(o)}},async delete(r,n){try{const o=i.b.get(r.scheme);return o&&!o.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(r.scheme),await o.impl.delete(r,{recursive:!1,...n})):await i.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(o){return k.e(o)}},async rename(r,n,o){try{return await i.a.$rename(r,n,{overwrite:!1,...o})}catch(t){return k.e(t)}},async copy(r,n,o){try{return await i.a.$copy(r,n,{overwrite:!1,...o})}catch(t){return k.e(t)}},isWritableFileSystem(r){const n=a.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async d(m,a,i){const r=[];for(;!a.isEqual(i,a.dirname(i));)try{if(!((await m.stat(i)).type&M.FileType.Directory))throw d.$AM.FileExists(`Unable to create folder '${i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(M.$Ik(n)!==M.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(a.basename(i)),i=a.dirname(i)}for(let n=r.length-1;n>=0;n--){i=a.joinPath(i,r[n]);try{await m.createDirectory(i)}catch(o){if(M.$Ik(o)!==M.FileSystemProviderErrorCode.FileExists)throw o}}}static e(m){if(m instanceof d.$AM)throw m;if(m instanceof M.$Ek)switch(m.code){case M.FileSystemProviderErrorCode.FileExists:throw d.$AM.FileExists(m.message);case M.FileSystemProviderErrorCode.FileNotFound:throw d.$AM.FileNotFound(m.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw d.$AM.FileNotADirectory(m.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw d.$AM.FileIsADirectory(m.message);case M.FileSystemProviderErrorCode.NoPermissions:throw d.$AM.NoPermissions(m.message);case M.FileSystemProviderErrorCode.Unavailable:throw d.$AM.Unavailable(m.message);default:throw new d.$AM(m.message,m.name)}if(!(m instanceof Error))throw new d.$AM(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw d.$AM.Unavailable(m.message);switch(m.name){case M.FileSystemProviderErrorCode.FileExists:throw d.$AM.FileExists(m.message);case M.FileSystemProviderErrorCode.FileNotFound:throw d.$AM.FileNotFound(m.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw d.$AM.FileNotADirectory(m.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw d.$AM.FileIsADirectory(m.message);case M.FileSystemProviderErrorCode.NoPermissions:throw d.$AM.NoPermissions(m.message);case M.FileSystemProviderErrorCode.Unavailable:throw d.$AM.Unavailable(m.message);default:throw new d.$AM(m.message,m.name)}}addFileSystemProvider(m,a,i){return this.b.set(m,{impl:a,extUri:i?.isCaseSensitive?C.$yg:C.$Ag,isReadonly:!!i?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??C.$yg}};e.$sgc=S,e.$sgc=S=k=Ge([Ve(0,w.$pN),Ve(1,$.$6fc)],S),e.$tgc=(0,A.$8h)("IExtHostConsumerFileSystem")}),define(ke[316],Se([1,0,6,7]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class d{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(D.$kL.MainThreadIssueReporter)}async $getIssueReporterUri(A,w){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(A);if(!$)throw new Error("Issue request handler not found");const E=await $.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(A,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const E=await $.provideIssueData(w);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(A,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const E=await $.provideIssueTemplate(w);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(A,w){const $=A.identifier.value;return this.a.set($,w),this.c.$registerIssueUriRequestHandler($),new M.$mL(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(A,w){const $=A.identifier.value;return this.b.set($,w),this.c.$registerIssueDataProvider($),new M.$mL(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$whc=d}),define(ke[93],Se([1,0,5,27,12,70,2]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,e.$ugc=(0,D.$8h)("IExtensionStoragePaths");let w=class{constructor(E,R,C){this.d=R,this.f=C,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(E){return A.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,R=await this.g(E);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(E){if(this.c)return A.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return A.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$vgc=w,e.$vgc=w=Ge([Ve(0,M.$FN),Ve(1,d.$pj),Ve(2,P.$tgc)],w)}),define(ke[317],Se([1,0,7,20,4]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;let P=class{constructor(w){this.a=new D.$KM(D.ColorThemeKind.Dark),this.b=new d.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(w){let $;switch(w){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$KM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Zhc=P,e.$Zhc=P=Ge([Ve(0,M.$pN)],P)}),define(ke[71],Se([1,0,22,4,3,220,5,12,88,6,27,20,7]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$izb=e.$hzb=e.TunnelDtoConverter=void 0;class k extends $.$Lv{}var S;(function(m){function a(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:r.protocol}}m.fromApiTunnel=a;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==$.TunnelPrivacyId.ConstantPrivate&&r.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}m.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$hzb=(0,A.$8h)("IExtHostTunnelService");let c=class extends d.$Tc{constructor(a,i,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(E.$kL.MainThreadTunnelService)}async openTunnel(a,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this.a.$openTunnel(i,a.displayName);if(r){const n=new k(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,i){const r=this.u();return this.r.set(r,{selector:a,provider:i}),this.a.$registerPortsAttributesProvider(a,r),new p.$mL(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(a,i,r,n,o){const t=[];for(const s of a){const f=this.r.get(s);if(!f)return[];t.push(...await Promise.all(i.map(async l=>{let u;try{u=await f.provider.providePortAttributes({port:l,pid:r,commandLine:n},o)}catch{u=await f.provider.providePortAttributes(l,r,n,o)}return{providedAttributes:u,port:l}})))}const h=t.filter(s=>!!s.providedAttributes);return h.length>0?h.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,o)=>await a.provideTunnel(n,o,new D.$7d().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,d.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,i){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const r=a.tunnelFactory??(i?this.w(i):void 0);if(r){this.b=r;let n=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,d.$Rc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,i){if(this.g.has(a.host)){const r=this.g.get(a.host);r.has(a.port)&&(i&&r.get(a.port).disposeListener.dispose(),await r.get(a.port).tunnel.dispose(),r.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(a,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:n,disposeListener:o}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(a){const i=await Promise.all(a.map(n=>this.f(n.host,n.port,n.detail??""))),r=a.filter((n,o)=>i[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.$izb=c,e.$izb=c=Ge([Ve(0,C.$pN),Ve(1,R.$FN),Ve(2,w.$pj)],c)}),define(ke[16],Se([1,0,19,21,165,75,63,28,160,56,100,24,18,2,29,83,135,141,139,118,68,89,290,26,7]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$oN=e.$nN=e.MarkdownString=e.$mN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var f;(function(Ne){function Fe(ae){const{selectionStartLineNumber:Te,selectionStartColumn:Be,positionLineNumber:xe,positionColumn:Je}=ae,ut=new s.$nL(Te-1,Be-1),vt=new s.$nL(xe-1,Je-1);return new s.$pL(ut,vt)}Ne.to=Fe;function De(ae){const{anchor:Te,active:Be}=ae;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ne.from=De})(f||(e.Selection=f={}));var l;(function(Ne){function Fe(ae){if(!ae)return;const{start:Te,end:Be}=ae;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ne.from=Fe;function De(ae){if(!ae)return;const{startLineNumber:Te,startColumn:Be,endLineNumber:xe,endColumn:Je}=ae;return new s.$oL(Te-1,Be-1,xe-1,Je-1)}Ne.to=De})(l||(e.Range=l={}));var u;(function(Ne){function Fe(ae){return{uri:ae.uri,range:l.from(ae.range)}}Ne.from=Fe;function De(ae){return new s.$yL(k.URI.revive(ae.uri),l.to(ae.range))}Ne.to=De})(u||(e.Location=u={}));var v;(function(Ne){function Fe(De){switch(De){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ne.to=Fe})(v||(e.TokenType=v={}));var I;(function(Ne){function Fe(ae){return new s.$nL(ae.lineNumber-1,ae.column-1)}Ne.to=Fe;function De(ae){return{lineNumber:ae.line+1,column:ae.character+1}}Ne.from=De})(I||(e.Position=I={}));var b;(function(Ne){function Fe(Te,Be,xe){return(0,D.$Hb)((0,D.$3b)(Te).map(Je=>De(Je,Be,xe)))}Ne.from=Fe;function De(Te,Be,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:ae(Te.scheme,Be),pattern:se.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function ae(Te,Be){return Be&&typeof Te=="string"?Be.transformOutgoingScheme(Te):Te}})(b||(e.DocumentSelector=b={}));var g;(function(Ne){function Fe(ae){switch(ae){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ne.from=Fe;function De(ae){switch(ae){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ne.to=De})(g||(e.DiagnosticTag=g={}));var y;(function(Ne){function Fe(ae){let Te;return ae.code&&((0,p.$Jf)(ae.code)||(0,p.$Nf)(ae.code)?Te=String(ae.code):Te={value:String(ae.code.value),target:ae.code.target}),{...l.from(ae.range),message:ae.message,source:ae.source,code:Te,severity:T.from(ae.severity),relatedInformation:ae.relatedInformation&&ae.relatedInformation.map(L.from),tags:Array.isArray(ae.tags)?(0,D.$Hb)(ae.tags.map(g.from)):void 0}}Ne.from=Fe;function De(ae){const Te=new s.$AL(l.to(ae),ae.message,T.to(ae.severity));return Te.source=ae.source,Te.code=(0,p.$Jf)(ae.code)?ae.code:ae.code?.value,Te.relatedInformation=ae.relatedInformation&&ae.relatedInformation.map(L.to),Te.tags=ae.tags&&(0,D.$Hb)(ae.tags.map(g.to)),Te}Ne.to=De})(y||(e.Diagnostic=y={}));var L;(function(Ne){function Fe(ae){return{...l.from(ae.location.range),message:ae.message,resource:ae.location.uri}}Ne.from=Fe;function De(ae){return new s.$zL(new s.$yL(ae.resource,l.to(ae)),ae.message)}Ne.to=De})(L||(e.DiagnosticRelatedInformation=L={}));var T;(function(Ne){function Fe(ae){switch(ae){case s.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Ne.from=Fe;function De(ae){switch(ae){case m.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ne.to=De})(T||(e.DiagnosticSeverity=T={}));var U;(function(Ne){function Fe(ae){return typeof ae=="number"&&ae>=s.ViewColumn.One?ae-1:ae===s.ViewColumn.Beside?t.$gD:t.$fD}Ne.from=Fe;function De(ae){if(typeof ae=="number"&&ae>=0)return ae+1;throw new Error("invalid 'EditorGroupColumn'")}Ne.to=De})(U||(e.ViewColumn=U={}));function j(Ne){return typeof Ne.range<"u"}function F(Ne){return Ne.length===0?!0:!!j(Ne[0])}e.$mN=F;var N;(function(Ne){function Fe(Je){return Je.map(Ne.from)}Ne.fromMany=Fe;function De(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ae(Je){let ut;if(De(Je)){const{language:Ct,value:wt}=Je;ut={value:"```"+Ct+`
`+wt+"\n```\n"}}else s.$NL.isMarkdownString(Je)?ut={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ut={value:Je}:ut={value:""};const vt=Object.create(null);ut.uris=vt;const Jt=Ct=>{try{let wt=k.URI.parse(Ct,!0);wt=wt.with({query:Te(wt.query,vt)}),vt[Ct]=wt}catch{}return""},St=new $.marked.Renderer;return St.link=Jt,St.image=Ct=>typeof Ct=="string"?Jt(A.$rk(Ct).href):"",(0,$.marked)(ut.value,{renderer:St}),ut}Ne.from=ae;function Te(Je,ut){if(!Je)return Je;let vt;try{vt=(0,E.$Dh)(Je)}catch{}if(!vt)return Je;let Jt=!1;return vt=(0,C.$An)(vt,St=>{if(k.URI.isUri(St)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ct]=St,Jt=!0,Ct}else return}),Jt?JSON.stringify(vt):Je}function Be(Je){const ut=new s.$NL(Je.value,Je.supportThemeIcons);return ut.isTrusted=Je.isTrusted,ut.supportHtml=Je.supportHtml,ut.baseUri=Je.baseUri?k.URI.from(Je.baseUri):void 0,ut}Ne.to=Be;function xe(Je){if(Je)return typeof Je=="string"?Je:Ne.from(Je)}Ne.fromStrict=xe})(N||(e.MarkdownString=N={}));function O(Ne){return F(Ne)?Ne.map(Fe=>({range:l.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?N.fromMany(Fe.hoverMessage):Fe.hoverMessage?N.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ne.map(Fe=>({range:l.from(Fe)}))}e.$nN=O;function z(Ne){return typeof Ne>"u"?Ne:typeof Ne=="string"?k.URI.file(Ne):Ne}e.$oN=z;var K;(function(Ne){function Fe(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?z(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Ne.from=Fe})(K||(e.ThemableDecorationAttachmentRenderOptions=K={}));var te;(function(Ne){function Fe(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?z(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?K.from(De.before):void 0,after:De.after?K.from(De.after):void 0}}Ne.from=Fe})(te||(e.ThemableDecorationRenderOptions=te={}));var x;(function(Ne){function Fe(De){if(typeof De>"u")return De;switch(De){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ne.from=Fe})(x||(e.DecorationRangeBehavior=x={}));var X;(function(Ne){function Fe(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?x.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?te.from(De.light):void 0,dark:De.dark?te.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?z(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?K.from(De.before):void 0,after:De.after?K.from(De.after):void 0}}Ne.from=Fe})(X||(e.DecorationRenderOptions=X={}));var Z;(function(Ne){function Fe(ae){return{text:ae.newText,eol:ae.newEol&&Le.from(ae.newEol),range:l.from(ae.range)}}Ne.from=Fe;function De(ae){const Te=new s.$tL(l.to(ae.range),ae.text);return Te.newEol=typeof ae.eol>"u"?void 0:Le.to(ae.eol),Te}Ne.to=De})(Z||(e.TextEdit=Z={}));var ce;(function(Ne){function Fe(ae,Te){const Be={edits:[]};if(ae instanceof s.$wL){const xe=new w.$Bc;for(const Je of ae._allEntries())Je._type===1&&k.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of ae._allEntries())if(Je._type===1){let ut;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ut={type:"base64",value:(0,M.$Ee)(M.$ke.wrap(Je.options.contents))}:ut={type:"dataTransferItem",id:Je.options.contents._itemId}),Be.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ut},metadata:Je.metadata})}else Je._type===2?Be.edits.push({resource:Je.uri,textEdit:Z.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Be.edits.push({resource:Je.uri,textEdit:{range:l.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Be.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Be.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Dt.from)}})}return Be}Ne.from=Fe;function De(ae){const Te=new s.$wL,Be=new w.$Ac;for(const xe of ae.edits)if(xe.textEdit){const Je=xe,ut=k.URI.revive(Je.resource),vt=l.to(Je.textEdit.range),Jt=Je.textEdit.text,St=Je.textEdit.insertAsSnippet;let Ct;St?Ct=s.$vL.replace(vt,new s.$xL(Jt)):Ct=s.$tL.replace(vt,Jt);const wt=Be.get(ut);wt?wt.push(Ct):Be.set(ut,[Ct])}else Te.renameFile(k.URI.revive(xe.oldResource),k.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of Be)Te.set(xe,Je);return Te}Ne.to=De})(ce||(e.WorkspaceEdit=ce={}));var _;(function(Ne){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function De(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Ne.from=De;function ae(Te){for(const Be in Fe)if(Fe[Be]===Te)return Number(Be);return s.SymbolKind.Property}Ne.to=ae})(_||(e.SymbolKind=_={}));var ge;(function(Ne){function Fe(ae){switch(ae){case s.SymbolTag.Deprecated:return 1}}Ne.from=Fe;function De(ae){switch(ae){case 1:return s.SymbolTag.Deprecated}}Ne.to=De})(ge||(e.SymbolTag=ge={}));var ne;(function(Ne){function Fe(ae){return{name:ae.name,kind:_.from(ae.kind),tags:ae.tags&&ae.tags.map(ge.from),containerName:ae.containerName,location:he.from(ae.location)}}Ne.from=Fe;function De(ae){const Te=new s.$EL(ae.name,_.to(ae.kind),ae.containerName,he.to(ae.location));return Te.tags=ae.tags&&ae.tags.map(ge.to),Te}Ne.to=De})(ne||(e.WorkspaceSymbol=ne={}));var J;(function(Ne){function Fe(ae){const Te={name:ae.name||"!!MISSING: name!!",detail:ae.detail,range:l.from(ae.range),selectionRange:l.from(ae.selectionRange),kind:_.from(ae.kind),tags:ae.tags?.map(ge.from)??[]};return ae.children&&(Te.children=ae.children.map(Fe)),Te}Ne.from=Fe;function De(ae){const Te=new s.$FL(ae.name,ae.detail,_.to(ae.kind),l.to(ae.range),l.to(ae.selectionRange));return(0,D.$Lb)(ae.tags)&&(Te.tags=ae.tags.map(ge.to)),ae.children&&(Te.children=ae.children.map(De)),Te}Ne.to=De})(J||(e.DocumentSymbol=J={}));var W;(function(Ne){function Fe(ae){const Te=new s.$JL(_.to(ae.kind),ae.name,ae.detail||"",k.URI.revive(ae.uri),l.to(ae.range),l.to(ae.selectionRange));return Te._sessionId=ae._sessionId,Te._itemId=ae._itemId,Te}Ne.to=Fe;function De(ae,Te,Be){if(Te=Te??ae._sessionId,Be=Be??ae._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,name:ae.name,detail:ae.detail,kind:_.from(ae.kind),uri:ae.uri,range:l.from(ae.range),selectionRange:l.from(ae.selectionRange),tags:ae.tags?.map(ge.from)}}Ne.from=De})(W||(e.CallHierarchyItem=W={}));var re;(function(Ne){function Fe(De){return new s.$KL(W.to(De.from),De.fromRanges.map(ae=>l.to(ae)))}Ne.to=Fe})(re||(e.CallHierarchyIncomingCall=re={}));var ye;(function(Ne){function Fe(De){return new s.$LL(W.to(De.to),De.fromRanges.map(ae=>l.to(ae)))}Ne.to=Fe})(ye||(e.CallHierarchyOutgoingCall=ye={}));var he;(function(Ne){function Fe(ae){return{range:ae.range&&l.from(ae.range),uri:ae.uri}}Ne.from=Fe;function De(ae){return new s.$yL(k.URI.revive(ae.uri),l.to(ae.range))}Ne.to=De})(he||(e.location=he={}));var fe;(function(Ne){function Fe(ae){const Te=ae,Be=ae;return{originSelectionRange:Te.originSelectionRange?l.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Be.uri,range:l.from(Te.targetRange?Te.targetRange:Be.range),targetSelectionRange:Te.targetSelectionRange?l.from(Te.targetSelectionRange):void 0}}Ne.from=Fe;function De(ae){return{targetUri:k.URI.revive(ae.uri),targetRange:l.to(ae.range),targetSelectionRange:ae.targetSelectionRange?l.to(ae.targetSelectionRange):void 0,originSelectionRange:ae.originSelectionRange?l.to(ae.originSelectionRange):void 0}}Ne.to=De})(fe||(e.DefinitionLink=fe={}));var ue;(function(Ne){function Fe(ae){return{range:l.from(ae.range),contents:N.fromMany(ae.contents)}}Ne.from=Fe;function De(ae){return new s.$BL(ae.contents.map(N.to),l.to(ae.range))}Ne.to=De})(ue||(e.Hover=ue={}));var me;(function(Ne){function Fe(ae){return{range:l.from(ae.range),expression:ae.expression}}Ne.from=Fe;function De(ae){return new s.$vM(l.to(ae.range),ae.expression)}Ne.to=De})(me||(e.EvaluatableExpression=me={}));var V;(function(Ne){function Fe(ae){if(ae instanceof s.$wM)return{type:"text",range:l.from(ae.range),text:ae.text};if(ae instanceof s.$xM)return{type:"variable",range:l.from(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};if(ae instanceof s.$yM)return{type:"expression",range:l.from(ae.range),expression:ae.expression};throw new Error("Unknown 'InlineValue' type")}Ne.from=Fe;function De(ae){switch(ae.type){case"text":return{range:l.to(ae.range),text:ae.text};case"variable":return{range:l.to(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};case"expression":return{range:l.to(ae.range),expression:ae.expression}}}Ne.to=De})(V||(e.InlineValue=V={}));var Y;(function(Ne){function Fe(ae){return{frameId:ae.frameId,stoppedLocation:l.from(ae.stoppedLocation)}}Ne.from=Fe;function De(ae){return new s.$zM(ae.frameId,l.to(ae.stoppedLocation))}Ne.to=De})(Y||(e.InlineValueContext=Y={}));var de;(function(Ne){function Fe(ae){return{range:l.from(ae.range),kind:ae.kind}}Ne.from=Fe;function De(ae){return new s.$CL(l.to(ae.range),ae.kind)}Ne.to=De})(de||(e.DocumentHighlight=de={}));var pe;(function(Ne){function Fe(ae){return{uri:ae.uri,highlights:ae.highlights.map(de.from)}}Ne.from=Fe;function De(ae){return new s.$DL(k.URI.revive(ae.uri),ae.highlights.map(de.to))}Ne.to=De})(pe||(e.MultiDocumentHighlight=pe={}));var Pe;(function(Ne){function Fe(De){switch(De){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ne.to=Fe})(Pe||(e.CompletionTriggerKind=Pe={}));var ve;(function(Ne){function Fe(De){return{triggerKind:Pe.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Ne.to=Fe})(ve||(e.CompletionContext=ve={}));var Ce;(function(Ne){function Fe(ae){switch(ae){case s.CompletionItemTag.Deprecated:return 1}}Ne.from=Fe;function De(ae){switch(ae){case 1:return s.CompletionItemTag.Deprecated}}Ne.to=De})(Ce||(e.CompletionItemTag=Ce={}));var B;(function(Ne){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function De(Be){return Fe.get(Be)??9}Ne.from=De;const ae=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(Be){return ae.get(Be)??s.CompletionItemKind.Property}Ne.to=Te})(B||(e.CompletionItemKind=B={}));var Q;(function(Ne){function Fe(De,ae){const Te=new s.$TL(De.label);return Te.insertText=De.insertText,Te.kind=B.to(De.kind),Te.tags=De.tags?.map(Ce.to),Te.detail=De.detail,Te.documentation=A.$lk(De.documentation)?N.to(De.documentation):De.documentation,Te.sortText=De.sortText,Te.filterText=De.filterText,Te.preselect=De.preselect,Te.commitCharacters=De.commitCharacters,S.$Ws.isIRange(De.range)?Te.range=l.to(De.range):typeof De.range=="object"&&(Te.range={inserting:l.to(De.range.insert),replacing:l.to(De.range.replace)}),Te.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Te.insertText=new s.$xL(De.insertText):(Te.insertText=De.insertText,Te.textEdit=Te.range instanceof s.$oL?new s.$tL(Te.range,Te.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Te.additionalTextEdits=De.additionalTextEdits.map(Be=>Z.to(Be))),Te.command=ae&&De.command?ae.fromInternal(De.command):void 0,Te}Ne.to=Fe})(Q||(e.CompletionItem=Q={}));var ee;(function(Ne){function Fe(ae){if(typeof ae.label!="string"&&!Array.isArray(ae.label))throw new TypeError("Invalid label");return{label:ae.label,documentation:N.fromStrict(ae.documentation)}}Ne.from=Fe;function De(ae){return{label:ae.label,documentation:A.$lk(ae.documentation)?N.to(ae.documentation):ae.documentation}}Ne.to=De})(ee||(e.ParameterInformation=ee={}));var H;(function(Ne){function Fe(ae){return{label:ae.label,documentation:N.fromStrict(ae.documentation),parameters:Array.isArray(ae.parameters)?ae.parameters.map(ee.from):[],activeParameter:ae.activeParameter}}Ne.from=Fe;function De(ae){return{label:ae.label,documentation:A.$lk(ae.documentation)?N.to(ae.documentation):ae.documentation,parameters:Array.isArray(ae.parameters)?ae.parameters.map(ee.to):[],activeParameter:ae.activeParameter}}Ne.to=De})(H||(e.SignatureInformation=H={}));var oe;(function(Ne){function Fe(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(H.from):[]}}Ne.from=Fe;function De(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(H.to):[]}}Ne.to=De})(oe||(e.SignatureHelp=oe={}));var le;(function(Ne){function Fe(De,ae){const Te=new s.$SL(I.to(ae.position),typeof ae.label=="string"?ae.label:ae.label.map(Re.to.bind(void 0,De)),ae.kind&&je.to(ae.kind));return Te.textEdits=ae.textEdits&&ae.textEdits.map(Z.to),Te.tooltip=A.$lk(ae.tooltip)?N.to(ae.tooltip):ae.tooltip,Te.paddingLeft=ae.paddingLeft,Te.paddingRight=ae.paddingRight,Te}Ne.to=Fe})(le||(e.InlayHint=le={}));var Re;(function(Ne){function Fe(De,ae){const Te=new s.$RL(ae.label);return Te.tooltip=A.$lk(ae.tooltip)?N.to(ae.tooltip):ae.tooltip,c.Command.is(ae.command)&&(Te.command=De.fromInternal(ae.command)),ae.location&&(Te.location=he.to(ae.location)),Te}Ne.to=Fe})(Re||(e.InlayHintLabelPart=Re={}));var je;(function(Ne){function Fe(ae){return ae}Ne.from=Fe;function De(ae){return ae}Ne.to=De})(je||(e.InlayHintKind=je={}));var He;(function(Ne){function Fe(ae){return{range:l.from(ae.range),url:ae.target,tooltip:ae.tooltip}}Ne.from=Fe;function De(ae){let Te;if(ae.url)try{Te=typeof ae.url=="string"?k.URI.parse(ae.url,!0):k.URI.revive(ae.url)}catch{}return new s.$YL(l.to(ae.range),Te)}Ne.to=De})(He||(e.DocumentLink=He={}));var Qe;(function(Ne){function Fe(ae){const Te=new s.$2L(ae.label);return ae.textEdit&&(Te.textEdit=Z.to(ae.textEdit)),ae.additionalTextEdits&&(Te.additionalTextEdits=ae.additionalTextEdits.map(Be=>Z.to(Be))),Te}Ne.to=Fe;function De(ae){return{label:ae.label,textEdit:ae.textEdit?Z.from(ae.textEdit):void 0,additionalTextEdits:ae.additionalTextEdits?ae.additionalTextEdits.map(Te=>Z.from(Te)):void 0}}Ne.from=De})(Qe||(e.ColorPresentation=Qe={}));var _e;(function(Ne){function Fe(ae){return new s.$ZL(ae[0],ae[1],ae[2],ae[3])}Ne.to=Fe;function De(ae){return[ae.red,ae.green,ae.blue,ae.alpha]}Ne.from=De})(_e||(e.Color=_e={}));var at;(function(Ne){function Fe(ae){return{range:l.from(ae.range)}}Ne.from=Fe;function De(ae){return new s.$IL(l.to(ae.range))}Ne.to=De})(at||(e.SelectionRange=at={}));var st;(function(Ne){function Fe(De){switch(De){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ne.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var rt;(function(Ne){function Fe(ae){switch(ae){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ne.from=Fe;function De(ae){switch(ae){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ne.to=De})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Le;(function(Ne){function Fe(ae){if(ae===s.EndOfLine.CRLF)return 1;if(ae===s.EndOfLine.LF)return 0}Ne.from=Fe;function De(ae){if(ae===1)return s.EndOfLine.CRLF;if(ae===0)return s.EndOfLine.LF}Ne.to=De})(Le||(e.EndOfLine=Le={}));var ze;(function(Ne){function Fe(De){if(typeof De=="object")return De.viewId;switch(De){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ne.from=Fe})(ze||(e.ProgressLocation=ze={}));var Ae;(function(Ne){function Fe(ae){const Te={start:ae.start+1,end:ae.end+1};return ae.kind&&(Te.kind=Ze.from(ae.kind)),Te}Ne.from=Fe;function De(ae){const Te={start:ae.start-1,end:ae.end-1};return ae.kind&&(Te.kind=Ze.to(ae.kind)),Te}Ne.to=De})(Ae||(e.FoldingRange=Ae={}));var Ze;(function(Ne){function Fe(ae){if(ae)switch(ae){case s.FoldingRangeKind.Comment:return c.$Mt.Comment;case s.FoldingRangeKind.Imports:return c.$Mt.Imports;case s.FoldingRangeKind.Region:return c.$Mt.Region}}Ne.from=Fe;function De(ae){if(ae)switch(ae.value){case c.$Mt.Comment.value:return s.FoldingRangeKind.Comment;case c.$Mt.Imports.value:return s.FoldingRangeKind.Imports;case c.$Mt.Region.value:return s.FoldingRangeKind.Region}}Ne.to=De})(Ze||(e.FoldingRangeKind=Ze={}));var ie;(function(Ne){function Fe(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?l.from(De.selection):void 0,override:typeof De.override=="boolean"?i.$IE.id:void 0}}Ne.from=Fe})(ie||(e.TextEditorOpenOptions=ie={}));var se;(function(Ne){function Fe(Be){return Be instanceof s.$jM?Be.toJSON():typeof Be=="string"?Be:De(Be)||ae(Be)?new s.$jM(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ne.from=Fe;function De(Be){const xe=Be;return xe?k.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ae(Be){const xe=Be;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(Be){return typeof Be=="string"?Be:new s.$jM(k.URI.revive(Be.baseUri),Be.pattern)}Ne.to=Te})(se||(e.GlobPattern=se={}));var Ie;(function(Ne){function Fe(De){if(De){if(Array.isArray(De))return De.map(Fe);if(typeof De=="string")return De;{const ae=De;return{language:ae.language,scheme:ae.scheme,pattern:se.from(ae.pattern),exclusive:ae.exclusive,notebookType:ae.notebookType}}}else return}Ne.from=Fe})(Ie||(e.LanguageSelector=Ie={}));var qe;(function(Ne){function Fe(ae){return!!ae&&typeof ae=="object"&&"documents"in ae&&Array.isArray(ae.documents)&&ae.documents.every(Te=>Array.isArray(Te)&&Te.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&k.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(xe=>xe instanceof s.$oL)))}Ne.is=Fe;function De(ae){return{documents:ae.documents.map(Te=>Te.map(Be=>({uri:k.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>l.from(xe))})))}}Ne.from=De})(qe||(e.MappedEditsContext=qe={}));var Ye;(function(Ne){function Fe(ae){return{start:ae.start,end:ae.end}}Ne.from=Fe;function De(ae){return new s.$LM(ae.start,ae.end)}Ne.to=De})(Ye||(e.NotebookRange=Ye={}));var it;(function(Ne){function Fe(ae){return{timing:typeof ae.runStartTime=="number"&&typeof ae.runEndTime=="number"?{startTime:ae.runStartTime,endTime:ae.runEndTime}:void 0,executionOrder:ae.executionOrder,success:ae.lastRunSuccess}}Ne.to=Fe;function De(ae){return{lastRunSuccess:ae.success,runStartTime:ae.timing?.startTime,runEndTime:ae.timing?.endTime,executionOrder:ae.executionOrder}}Ne.from=De})(it||(e.NotebookCellExecutionSummary=it={}));var nt;(function(Ne){function Fe(De){if(De===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(De===r.NotebookCellExecutionState.Pending)return;if(De===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Ne.to=Fe})(nt||(e.NotebookCellExecutionState=nt={}));var Oe;(function(Ne){function Fe(ae){switch(ae){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Ne.from=Fe;function De(ae){switch(ae){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Ne.to=De})(Oe||(e.NotebookCellKind=Oe={}));var yt;(function(Ne){function Fe(ae){const Te={metadata:ae.metadata??Object.create(null),cells:[]};for(const Be of ae.cells)s.$MM.validate(Be),Te.cells.push(Dt.from(Be));return Te}Ne.from=Fe;function De(ae){const Te=new s.$NM(ae.cells.map(Dt.to));return(0,p.$Wf)(ae.metadata)||(Te.metadata=ae.metadata),Te}Ne.to=De})(yt||(e.NotebookData=yt={}));var Dt;(function(Ne){function Fe(ae){return{cellKind:Oe.from(ae.kind),language:ae.languageId,mime:ae.mime,source:ae.value,metadata:ae.metadata,internalMetadata:it.from(ae.executionSummary??{}),outputs:ae.outputs?ae.outputs.map(Ft.from):[]}}Ne.from=Fe;function De(ae){return new s.$MM(Oe.to(ae.cellKind),ae.source,ae.language,ae.mime,ae.outputs?ae.outputs.map(Ft.to):void 0,ae.metadata,ae.internalMetadata?it.to(ae.internalMetadata):void 0)}Ne.to=De})(Dt||(e.NotebookCellData=Dt={}));var Tt;(function(Ne){function Fe(ae){return{mime:ae.mime,valueBytes:M.$ke.wrap(ae.data)}}Ne.from=Fe;function De(ae){return new s.$OM(ae.valueBytes.buffer,ae.mime)}Ne.to=De})(Tt||(e.NotebookCellOutputItem=Tt={}));var Ft;(function(Ne){function Fe(ae){return{outputId:ae.id,items:ae.items.map(Tt.from),metadata:ae.metadata}}Ne.from=Fe;function De(ae){const Te=ae.items.map(Tt.to);return new s.$PM(Te,ae.outputId,ae.metadata)}Ne.to=De})(Ft||(e.NotebookCellOutput=Ft={}));var Et;(function(Ne){function Fe(Te){return ae(Te)?{include:se.from(Te.include)??void 0,exclude:se.from(Te.exclude)??void 0}:se.from(Te)??void 0}Ne.from=Fe;function De(Te){return ae(Te)?{include:se.to(Te.include),exclude:se.to(Te.exclude)}:se.to(Te)}Ne.to=De;function ae(Te){const Be=Te;return Be?!(0,p.$Sf)(Be.include)&&!(0,p.$Sf)(Be.exclude):!1}})(Et||(e.NotebookExclusiveDocumentPattern=Et={}));var Ht;(function(Ne){function Fe(De,ae,Te){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ae.toInternal(Be,Te),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Ne.from=Fe})(Ht||(e.NotebookStatusBarItem=Ht={}));var Ot;(function(Ne){function Fe(De,ae,Te){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:ae.toInternal(Be,Te),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Ne.from=Fe})(Ot||(e.NotebookKernelSourceAction=Ot={}));var Yt;(function(Ne){function Fe(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Ne.from=Fe})(Yt||(e.NotebookDocumentContentOptions=Yt={}));var Vt;(function(Ne){function Fe(ae){return{uri:ae.uri,provides:ae.provides}}Ne.from=Fe;function De(ae){return new s.$RM(k.URI.revive(ae.uri),ae.provides)}Ne.to=De})(Vt||(e.NotebookRendererScript=Vt={}));var Ut;(function(Ne){function Fe(ae){return{message:N.fromStrict(ae.message)||"",type:0,expected:ae.expectedOutput,actual:ae.actualOutput,contextValue:ae.contextValue,location:ae.location&&{range:l.from(ae.location.range),uri:ae.location.uri}}}Ne.from=Fe;function De(ae){const Te=new s.$XM(typeof ae.message=="string"?ae.message:N.to(ae.message));return Te.actualOutput=ae.actual,Te.expectedOutput=ae.expected,Te.contextValue=ae.contextValue,Te.location=ae.location?he.to(ae.location):void 0,Te}Ne.to=De})(Ut||(e.TestMessage=Ut={}));var et;(function(Ne){Ne.namespace=o.$gK,Ne.denamespace=o.$hK})(et||(e.TestTag=et={}));var Gt;(function(Ne){function Fe(ae){const Te=(0,a.$lN)(ae).controllerId;return{extId:n.$cK.fromExtHostTestItem(ae,Te).toString(),label:ae.label,uri:k.URI.revive(ae.uri),busy:ae.busy,tags:ae.tags.map(Be=>et.namespace(Te,Be.id)),range:S.$Ws.lift(l.from(ae.range)),description:ae.description||null,sortText:ae.sortText||null,error:ae.error&&N.fromStrict(ae.error)||null}}Ne.from=Fe;function De(ae){return{parent:void 0,error:void 0,id:n.$cK.fromString(ae.extId).localId,label:ae.label,uri:k.URI.revive(ae.uri),tags:(ae.tags||[]).map(Te=>{const{tagId:Be}=et.denamespace(Te);return new s.$YM(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ae.range||void 0),canResolveChildren:!1,busy:ae.busy,description:ae.description||void 0,sortText:ae.sortText||void 0}}Ne.toPlain=De})(Gt||(e.TestItem=Gt={})),function(Ne){function Fe(ae){return{id:ae.id}}Ne.from=Fe;function De(ae){return new s.$YM(ae.id)}Ne.to=De}(et||(e.TestTag=et={}));var Kt;(function(Ne){const Fe=(ae,Te)=>{const Be=[];for(const[Je,ut]of Te)n.$cK.compare(ut.item.extId,Je)===2&&(Te.delete(Je),Be.push(ut));const xe={...Gt.toPlain(ae.item),parent:void 0,taskStates:ae.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ut=>ut.type===0).map(Ut.to)})),children:Be.map(Je=>Fe(Je,Te))};for(const Je of xe.children)Je.parent=xe;return xe};function De(ae){const Te=[],Be=new Map;for(const xe of ae.items){Be.set(xe.item.extId,xe);const Je=n.$cK.root(xe.item.extId);ae.request.targets.some(ut=>ut.controllerId===Je&&ut.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:ae.completedAt,results:Te.map(xe=>Fe(xe,Be))}}Ne.to=De})(Kt||(e.TestResults=Kt={}));var ht;(function(Ne){function Fe(Be){return{covered:Be.covered,total:Be.total}}function De(Be){return"line"in Be?I.from(Be):l.from(Be)}function ae(Be){return"branches"in Be?{count:Be.executed,location:De(Be.location),type:1,branches:Be.branches.length?Be.branches.map(xe=>({count:xe.executed,location:xe.location&&De(xe.location),label:xe.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:De(Be.location)}}Ne.fromDetailed=ae;function Te(Be){return{uri:Be.uri,statement:Fe(Be.statementCoverage),branch:Be.branchCoverage&&Fe(Be.branchCoverage),function:Be.functionCoverage&&Fe(Be.functionCoverage),details:Be.detailedCoverage?.map(ae)}}Ne.fromFile=Te})(ht||(e.TestCoverage=ht={}));var $t;(function(Ne){function Fe(De){switch(De){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ne.to=Fe})($t||(e.CodeActionTriggerKind=$t={}));var Bt;(function(Ne){function Fe(ae){const Te=new s.$5M(_.to(ae.kind),ae.name,ae.detail||"",k.URI.revive(ae.uri),l.to(ae.range),l.to(ae.selectionRange));return Te._sessionId=ae._sessionId,Te._itemId=ae._itemId,Te}Ne.to=Fe;function De(ae,Te,Be){if(Te=Te??ae._sessionId,Be=Be??ae._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,kind:_.from(ae.kind),name:ae.name,detail:ae.detail??"",uri:ae.uri,range:l.from(ae.range),selectionRange:l.from(ae.selectionRange),tags:ae.tags?.map(ge.from)}}Ne.from=De})(Bt||(e.TypeHierarchyItem=Bt={}));var Qt;(function(Ne){function Fe(De){if(De)return{value:De.value,tooltip:De.tooltip}}Ne.from=Fe})(Qt||(e.ViewBadge=Qt={}));var kt;(function(Ne){function Fe(Be,xe,Je){const ut=xe.fileData;return ut?new s.$cM(new s.$dM(ut.name,k.URI.revive(ut.uri),ut.id,(0,P.$db)(()=>Je(ut.id)))):Be===R.$hs.uriList&&xe.uriListData?new s.$bM(Te(xe.uriListData)):new s.$bM(xe.asString)}Ne.to=Fe;async function De(Be,xe){const Je=await xe.asString();if(Be===R.$hs.uriList)return{asString:Je,fileData:void 0,uriListData:ae(Je)};const ut=xe.asFile();return{asString:Je,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}Ne.from=De;function ae(Be){return d.$tt.split(Be).map(xe=>{if(xe.startsWith("#"))return xe;try{return k.URI.parse(xe)}catch{}return xe})}function Te(Be){return d.$tt.create(Be.map(xe=>typeof xe=="string"?xe:k.URI.revive(xe)))}})(kt||(e.DataTransferItem=kt={}));var ft;(function(Ne){function Fe(ae,Te){const Be=ae.items.map(([xe,Je])=>[xe,kt.to(xe,Je,Te)]);return new s.$eM(Be)}Ne.toDataTransfer=Fe;async function De(ae){const Te={items:[]},Be=[];for(const[xe,Je]of ae)Be.push((async()=>{Te.items.push([xe,await kt.from(xe,Je)])})());return await Promise.all(Be),Te}Ne.from=De})(ft||(e.DataTransfer=ft={}));var It;(function(Ne){function Fe(De){return{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Ne.from=Fe})(It||(e.ChatReplyFollowup=It={}));var _t;(function(Ne){function Fe(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:It.from(De)}Ne.from=Fe})(_t||(e.ChatFollowup=_t={}));var At;(function(Ne){function Fe(ae){const Te=new s.$eN(Ke.to(ae.role),ae.content);return Te.name=ae.name,Te}Ne.to=Fe;function De(ae){return{role:Ke.from(ae.role),content:ae.content,name:ae.name}}Ne.from=De})(At||(e.ChatMessage=At={}));var Ke;(function(Ne){function Fe(ae){switch(ae){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ne.to=Fe;function De(ae){switch(ae){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ne.from=De})(Ke||(e.ChatMessageRole=Ke={}));var Nt;(function(Ne){function Fe(Te){const Be={};for(const xe of Object.keys(Te))Be[xe]=Te[xe].map(Ne.to);return Be}Ne.objectTo=Fe;function De(Te){return{level:jt.to(Te.level),kind:Te.kind,value:(0,k.$vc)(Te.value)?k.URI.revive(Te.value):Te.value,description:Te.description}}Ne.to=De;function ae(Te){return{level:jt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Ne.from=ae})(Nt||(e.ChatVariable=Nt={}));var jt;(function(Ne){function Fe(ae){switch(ae){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ne.to=Fe;function De(ae){switch(ae){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ne.from=De})(jt||(e.ChatVariableLevel=jt={}));var Zt;(function(Ne){function Fe(De){switch(De){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ne.to=Fe})(Zt||(e.InteractiveEditorResponseFeedbackKind=Zt={}));var gt;(function(Ne){function Fe(Te,Be){return"markdownContent"in Be?((0,h.$LF)(Te,"chatAgents2Additions"),{content:N.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,h.$LF)(Te,"chatAgents2Additions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,h.$LF)(Te,"chatAgents2Additions"),{content:N.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Je=>l.from(Je))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:l.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:l.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"agentName"in Be?((0,h.$LF)(Te,"chatAgents2Additions"),{agentName:Be.agentName,command:Be.command,kind:"agentDetection"}):"treeData"in Be?{treeData:Be.treeData,kind:"treeData"}:"message"in Be?{content:N.from(Be.message),kind:"progressMessage"}:void 0}Ne.from=Fe;function De(Te){switch(Te.kind){case"markdownContent":case"inlineReference":case"treeData":return Ne.to(Te);case"content":return{content:Te.content};case"usedContext":return{documents:Te.documents.map(Be=>({uri:k.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>l.to(xe))}))};case"reference":return{reference:(0,k.$vc)(Te.reference)?k.URI.revive(Te.reference):u.to(Te.reference)};case"agentDetection":return;case"progressMessage":return{message:Te.content.value};case"vulnerability":return{content:Te.content,vulnerabilities:Te.vulnerabilities};default:return}}Ne.to=De;function ae(Te){switch(Te.kind){case"markdownContent":return{content:Te.content.value};case"inlineReference":return{inlineReference:(0,k.$vc)(Te.inlineReference)?k.URI.revive(Te.inlineReference):u.to(Te.inlineReference),title:Te.name};case"treeData":return{treeData:(0,E.$Eh)(Te.treeData)};default:return}}Ne.toProgressContent=ae})(gt||(e.ChatResponseProgress=gt={}));var Mt;(function(Ne){function Fe(De){return{prompt:De.message,variables:Nt.objectTo(De.variables),subCommand:De.command,agentId:De.agentId}}Ne.to=Fe})(Mt||(e.ChatAgentRequest=Mt={}));var Pt;(function(Ne){function Fe(De){return{label:De.label,values:De.values.map(Nt.from),insertText:De.insertText,detail:De.detail,documentation:De.documentation}}Ne.from=Fe})(Pt||(e.ChatAgentCompletionItem=Pt={}));var Wt;(function(Ne){function Fe(De,ae,Te){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:ae.toInternal(De,Te)}Ne.from=Fe})(Wt||(e.TerminalQuickFix=Wt={}))}),define(ke[318],Se([1,0,6,20,16]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;let P=class{constructor(w,$){this.a=w.getProxy(D.$kL.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>$.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,$,E){const R=d.WorkspaceEdit.from(w,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,E?.isRefactoring??!1)}};e.$cgc=P,e.$cgc=P=Ge([Ve(0,M.$pN)],P)}),define(ke[319],Se([1,0,19,8,44,4,63,38,2,210,12,6,16,7,279,26]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;let m=class{constructor(n,o,t,h){this.i=n,this.j=o,this.k=t,this.l=h,this.a=w.$Sd.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let o=function(h){if(n.b){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,h),s}};const n=this;this.a.reset();const t=h=>{typeof this.d>"u"&&"content"in h&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,h)};this.g={markdown(h,s){return o(this.markdown),t({kind:"markdownContent",content:p.MarkdownString.from(h)}),this},text(h,s){return o(this.text),this.markdown(new A.$jk().appendText(h),s),this},files(h,s){return o(this.files),t({kind:"treeData",treeData:h}),this},anchor(h,s){return o(this.anchor),t({kind:"inlineReference",name:s?.title,inlineReference:$.URI.isUri(h)?h:p.Location.from(h)}),this},progress(h){return o(this.progress),t({kind:"progressMessage",content:new A.$jk(h)}),this},reference(h){return o(this.reference),t({kind:"reference",reference:$.URI.isUri(h)?h:p.Location.from(h)}),this},report(h){if(o(this.report),"placeholder"in h&&"resolvedContent"in h)return;const s=p.ChatResponseProgress.from(n.i,h);if(!s){n.l.error("Unknown progress type: "+JSON.stringify(h));return}return t(s),this}}}return this.g}};m=Ge([Ve(3,R.$pj)],m);class a{static{this.a=0}constructor(n,o,t){this.j=o,this.k=t,this.b=new Map,this.g=new Map,this.i=new Map,this.d=n.getProxy(C.$kL.MainThreadChatAgents2)}createChatAgent(n,o,t){const h=a.a++,s=new i(n,o,this.d,h,t);return this.b.set(h,s),this.d.$registerAgent(h,o,{}),s.apiAgent}async $invokeAgent(n,o,t,h){this.g.delete(o.sessionId);const s=this.b.get(n);if(!s)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);const f=new M.$sh;h.onCancellationRequested(()=>f.complete()),this.j.allowListExtensionWhile(s.extension.identifier,f.p);const l=new m(s.extension,o,this.d,this.k);try{const u=await this.l(s,o,t),v=s.invoke(p.ChatAgentRequest.to(o),{history:u},l.apiObject,h);return await(0,M.$Vg)(Promise.resolve(v).then(I=>{if(I){this.g.set(o.sessionId,I);let b=this.i.get(o.sessionId);return b||(b=new Map,this.i.set(o.sessionId,b)),b.set(o.requestId,I),{errorDetails:I.errorDetails,timings:l.timings}}else this.g.delete(o.sessionId)}),h)}catch(u){return this.k.error(u,s.extension),{errorDetails:{message:(0,E.localize)(0,null,(0,d.$Si)(u)),responseIsIncomplete:!0}}}finally{l.close(),f.complete()}}async l(n,o,t){return(0,D.$Hb)(await Promise.all(t.history.map(async h=>{const s=o.agentId===h.request.agentId&&this.i.get(o.sessionId)?.get(h.request.requestId)||h.result;return{request:p.ChatAgentRequest.to(h.request),response:(0,D.$Hb)(h.response.map(f=>p.ChatResponseProgress.toProgressContent(f))),result:s}})))}$releaseSession(n){this.g.delete(n),this.i.delete(n)}async $provideSlashCommands(n,o){const t=this.b.get(n);return t?t.provideSlashCommands(o):[]}$provideFollowups(n,o,t){const h=this.b.get(n);if(!h)return Promise.resolve([]);const s=this.g.get(o);return s?h.provideFollowups(s,t):Promise.resolve([])}$acceptFeedback(n,o,t,h,s){const f=this.b.get(n);if(!f)return;const l=this.i.get(o)?.get(t);if(!l)return;let u;switch(h){case S.InteractiveSessionVoteDirection.Down:u=k.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:u=k.ChatAgentResultFeedbackKind.Helpful;break}f.acceptFeedback(Object.freeze(s?{result:l,kind:u,reportIssue:s}:{result:l,kind:u}))}$acceptAction(n,o,t,h){const s=this.b.get(n);if(!s)return;const f=this.i.get(o)?.get(t);f&&h.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:h.action,result:f}))}async $invokeCompletionProvider(n,o,t){const h=this.b.get(n);return h?(await h.invokeCompletionProvider(o,t)).map(p.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(n,o){const t=this.b.get(n);if(t)return await t.provideWelcomeMessage(o)}async $provideSampleQuestions(n,o){const t=this.b.get(n);if(t)return await t.provideSampleQuestions(o)}}e.$fgc=a;class i{constructor(n,o,t,h,s){this.extension=n,this.id=o,this.w=t,this.x=h,this.y=s,this.o=new P.$Wd,this.q=new P.$Wd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async invokeCompletionProvider(n,o){return this.t?await this.t.provider.provideCompletionItems(n,o)??[]:[]}async provideSlashCommands(n){if(!this.a)return[];const o=await this.a.provideSubCommands(n);return o?o.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest})):[]}async provideFollowups(n,o){if(!this.b)return[];const t=await this.b.provideFollowups(n,o);return t?t.map(h=>p.ChatFollowup.from(h)):[]}async provideWelcomeMessage(n){if(!this.u)return[];const o=await this.u.provideWelcomeMessage(n);return o?o.map(t=>typeof t=="string"?t:p.MarkdownString.from(t)):[]}async provideSampleQuestions(n){if(!this.u||!this.u.provideSampleQuestions)return[];const o=await this.u.provideSampleQuestions(n);return o?o?.map(t=>p.ChatReplyFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const t=()=>{n||o||(o=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof k.$hM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:p.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:p.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.s}),o=!1}))},h=this;return{get name(){return h.id},get description(){return h.d??""},set description(s){h.d=s,t()},get fullName(){return h.g??h.extension.displayName??h.extension.name},set fullName(s){h.g=s,t()},get iconPath(){return h.i},set iconPath(s){h.i=s,t()},get subCommandProvider(){return h.a},set subCommandProvider(s){h.a=s,t()},get followupProvider(){return h.b},set followupProvider(s){h.b=s,t()},get isDefault(){return(0,c.$LF)(h.extension,"defaultChatAgent"),h.j},set isDefault(s){(0,c.$LF)(h.extension,"defaultChatAgent"),h.j=s,t()},get helpTextPrefix(){return(0,c.$LF)(h.extension,"defaultChatAgent"),h.k},set helpTextPrefix(s){if((0,c.$LF)(h.extension,"defaultChatAgent"),!h.j)throw new Error("helpTextPrefix is only available on the default chat agent");h.k=s,t()},get helpTextPostfix(){return(0,c.$LF)(h.extension,"defaultChatAgent"),h.l},set helpTextPostfix(s){if((0,c.$LF)(h.extension,"defaultChatAgent"),!h.j)throw new Error("helpTextPostfix is only available on the default chat agent");h.l=s,t()},get isSecondary(){return(0,c.$LF)(h.extension,"defaultChatAgent"),h.n},set isSecondary(s){(0,c.$LF)(h.extension,"defaultChatAgent"),h.n=s,t()},get sampleRequest(){return h.m},set sampleRequest(s){h.m=s,t()},get supportIssueReporting(){return(0,c.$LF)(h.extension,"chatAgents2Additions"),h.s},set supportIssueReporting(s){(0,c.$LF)(h.extension,"chatAgents2Additions"),h.s=s,t()},get onDidReceiveFeedback(){return h.o.event},set agentVariableProvider(s){if(h.t=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,s.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x)},get agentVariableProvider(){return h.t},set welcomeMessageProvider(s){h.u=s,t()},get welcomeMessageProvider(){return h.u},onDidPerformAction:(0,c.$KF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,h.a=void 0,h.b=void 0,h.o.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(n,o,t,h){return this.y(n,o,t,h)}}}),define(ke[320],Se([1,0,22,3,6,16,107,25,8,4]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class R{constructor(S,c){this.stream=new $.$yh,this.stream=c??new $.$yh;const m=this;this.apiObj={option:S,response:m.stream.asyncIterable}}}class C{constructor(S,c){this.a=new E.$Wd,this.b=new Map,this.c=new $.$yh,this.d=!1;const m=this;this.apiObject={result:S,response:m.c.asyncIterable,onDidStartResponseStream:m.a.event,cancel(){c.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,a]of this.b)a.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let c=this.b.get(S.index);c||(this.b.size===0?c=new R(S.index,this.c):c=new R(S.index),this.b.set(S.index,c),this.a.fire(c.apiObj)),c.stream.emitOne(S.part)}}class p{static{this.a=1}constructor(S,c){this.d=c,this.c=new Map,this.e=new Map,this.f=new w.$pm,this.b=S.getProxy(d.$kL.MainThreadChatProvider)}registerProvider(S,c,m,a){const i=p.a++;return this.c.set(i,{extension:S,provider:m}),this.b.$registerProvider(i,c,{extension:S,model:a.name??""}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,c,m,a,i){const r=this.c.get(S);if(!r)return;const n=new A.$xv(async o=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${r.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(c,{index:o.index,part:o.part})});return r.provider.provideChatResponse(m.map(P.ChatMessage.to),a,n,i)}allowListExtensionWhile(S,c){this.f.set(S,c),c.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,c){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const m=await this.b.$prepareChatAccess(c);if(!m)throw new Error(`ChatAccess '${c}' NOT found`);const a=this;return{get model(){return m.model},get isRevoked(){return!a.f.has(S)},makeRequest(i,r,n){if(!a.f.has(S))throw new Error("Access to chat has been revoked");const o=new D.$7d(n),t=Math.random()*1e6|0,h=a.b.$fetchResponse(S,c,t,i.map(P.ChatMessage.from),r??{},o.token),s=new C(h,o);return a.e.set(t,{res:s}),h.finally(()=>{a.e.delete(t)}),s.apiObject}}}async $handleResponseFragment(S,c){const m=this.e.get(S);m&&m.res.handleFragment(c)}}e.$egc=p}),define(ke[321],Se([1,0,3,6,14,16]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class A{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(M.$kL.MainThreadChatVariables)}async $resolveVariable($,E,R){const C=this.b.get($);if(C)try{const p=await C.resolver.resolve(C.data.name,{prompt:E},R);if(p)return p.map(P.ChatVariable.from)}catch(p){(0,d.$2)(p)}}registerVariableResolver($,E,R,C){const p=A.a++;return this.b.set(p,{extension:$.identifier,data:{name:E,description:R},resolver:C}),this.c.$registerVariable(p,{name:E,description:R}),(0,D.$Rc)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$ggc=A}),define(ke[322],Se([1,0,8,52,4,3,2,83,25,16,7,6,26]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;function k(S,c,m){const a=S.getProxy(C.$kL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$pm,c.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const v=this.b.get(u.handle);return v?v.value:u}else if(u&&u.$mid===7){const v=this.b.get(u.commentControlHandle);if(!v)return u;const I=v.getCommentThread(u.commentThreadHandle);return I?I.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const v=this.b.get(u.thread.commentControlHandle);if(!v)return u;const I=v.getCommentThread(u.thread.commentThreadHandle);return I?u.$mid===8?I.value:{thread:I.value,text:u.text}:u}else if(u&&u.$mid===10){const v=this.b.get(u.thread.commentControlHandle);if(!v)return u;const I=v.getCommentThread(u.thread.commentThreadHandle);if(!I)return u;const b=u.commentUniqueId,g=I.getCommentByUniqueId(b);return g||u}else if(u&&u.$mid===11){const v=this.b.get(u.thread.commentControlHandle);if(!v)return u;const I=v.getCommentThread(u.thread.commentThreadHandle);if(!I)return u;const b=u.text,g=u.commentUniqueId,y=I.getCommentByUniqueId(g);return y?(typeof y.body=="string"?y.body=b:y.body=new R.$NL(b),y):u}return u}})}createCommentController(u,v,I){const b=i.a++,g=new n(u,b,v,I);this.b.set(g.handle,g);const y=this.c.get(u.identifier)||[];return y.push(g),this.c.set(u.identifier,y),g.value}async $createCommentThreadTemplate(u,v,I){const b=this.b.get(u);b&&b.$createCommentThreadTemplate(v,I)}async $updateCommentThreadTemplate(u,v,I){const b=this.b.get(u);b&&b.$updateCommentThreadTemplate(v,I)}$deleteCommentThread(u,v){this.b.get(u)?.$deleteCommentThread(v)}$provideCommentingRanges(u,v,I){const b=this.b.get(u);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const g=m.getDocument(A.URI.revive(v));return(0,D.$Zg)(async()=>{const y=await b.commentingRangeProvider.provideCommentingRanges(g,I);let L;return Array.isArray(y)?L={ranges:y,fileComments:!1}:y?L={ranges:y.ranges||[],fileComments:y.fileComments||!1}:L=y??void 0,L}).then(y=>{let L;return y&&(L={ranges:y.ranges.map(T=>E.Range.from(T)),fileComments:y.fileComments}),L})}$toggleReaction(u,v,I,b,g){const y=this.b.get(u);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,D.$Zg)(()=>{const L=y.getCommentThread(v);if(L){const T=L.getCommentByUniqueId(b.uniqueIdInThread);if(y!==void 0&&T&&y.reactionHandler)return y.reactionHandler(T,h(g))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,v,I,b,g,y,L,T){this.m=v,this.n=I,this.o=b,this.p=g,this.q=y,this.extensionDescription=L,this.r=T,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new d.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Uc,this.l.value=new P.$Sc,this.n===void 0&&(this.n=`${u}.${this.handle}`),a.$createCommentThread(v,this.handle,this.n,this.o,E.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{a.$deleteCommentThread(v,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(j){U.range=j},get comments(){return U.comments},set comments(j){U.comments=j},get collapsibleState(){return U.collapsibleState},set collapsibleState(j){U.collapsibleState=j},get canReply(){return U.canReply},set canReply(j){U.canReply=j},get contextValue(){return U.contextValue},set contextValue(j){U.contextValue=j},get label(){return U.label},set label(j){U.label=j},get state(){return U.state},set state(j){U.state=j},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Sc);const u=I=>Object.prototype.hasOwnProperty.call(this.b,I),v={};u("range")&&(v.range=E.Range.from(this.p)),u("label")&&(v.label=this.label),u("contextValue")&&(v.contextValue=this.contextValue??null),u("comments")&&(v.comments=this.q.map(I=>o(this,I,this.k,this.extensionDescription))),u("collapsibleState")&&(v.collapseState=s(this.g)),u("canReply")&&(v.canReply=this.canReply),u("state")&&(v.state=f(this.h)),u("isTemplate")&&(v.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(u){for(const v of this.k){const I=v[0],b=v[1];if(u===b)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}Ge([(0,M.$Ah)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,v,I,b){this.f=u,this.g=v,this.h=I,this.i=b,this.a=new Map,a.$registerCommentController(this.handle,I,b,this.f.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(y){g.options=y},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(y){g.commentingRangeProvider=y},get reactionHandler(){return g.reactionHandler},set reactionHandler(y){g.reactionHandler=y},createCommentThread(y,L,T){return g.createCommentThread(y,L,T).value},dispose:()=>{g.dispose()}}),this.e=[],this.e.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(u,v,I){v===void 0&&(0,p.$LF)(this.f,"fileComments");const b=new r(this.id,this.handle,void 0,u,v,I,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(u,v){const I=new r(this.id,this.handle,void 0,A.URI.revive(u),E.Range.to(v),[],this.f,!0);return I.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(u,v){const I=this.a.get(u);I&&(I.range=E.Range.to(v))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function o(l,u,v,I){let b=v.get(u);return b||(b=++l.commentHandle,v.set(u,b)),u.state!==void 0&&(0,p.$LF)(I,"commentsDraftState"),u.reactions?.some(g=>g.reactors!==void 0)&&(0,p.$LF)(I,"commentReactor"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:b,body:typeof u.body=="string"?u.body:E.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(g=>t(g)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?E.$oN(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted,reactors:l.reactors&&l.reactors.length>0&&typeof l.reactors[0]!="string"?l.reactors.map(u=>u.name):l.reactors}}function h(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?A.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1,reactors:l.reactors?.map(u=>({name:u}))}}function s(l){if(l!==void 0)switch(l){case R.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function f(l){if(l!==void 0)switch(l){case R.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}return new i}e.$kgc=k}),define(ke[323],Se([1,0,22,54,3,15,23,2,16,92,110,6,7]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;class k{constructor(h,s){this.document=h,this.b=s,this.a=1,this.c=new R.$2fc("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,s){await this.f(h).undo(),s||this.disposeBackup()}async redo(h,s){await this.f(h).redo(),s||this.disposeBackup()}disposeEdits(h){for(const s of h)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=o(this.document.uri)+this.a++;return(0,A.$Ig)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const s=this.c.get(h,0);if(!s)throw new Error("No edit found");return s}}class S{constructor(){this.a=new Map}get(h,s){return this.a.get(this.b(h,s))}add(h,s,f){const l=this.b(h,s.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${h} resource:${s.uri}`);const u=new k(s,f);return this.a.set(l,u),u}delete(h,s){const f=this.b(h,s.uri);this.a.delete(f)}b(h,s){return`${h}@@@${s}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class m{constructor(){this.a=new Map}addTextProvider(h,s,f){return this.b(0,h,s,f)}addCustomProvider(h,s,f){return this.b(1,h,s,f)}get(h){return this.a.get(h)}b(h,s,f,l){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:h,extension:f,provider:l}),new p.$mL(()=>this.a.delete(s))}}class a{constructor(h,s,f,l,u){this.d=s,this.f=f,this.g=l,this.h=u,this.b=new m,this.c=new S,this.a=h.getProxy(C.$kL.MainThreadCustomEditors)}registerCustomEditorProvider(h,s,f,l){const u=new d.$Sc;return r(f)?(u.add(this.b.addTextProvider(s,h,f)),this.a.$registerTextEditorProvider((0,E.$zgc)(h),s,l.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,E.$xgc)(h))):(u.add(this.b.addCustomProvider(s,h,f)),i(f)&&u.add(f.onDidChangeCustomDocument(v=>{const I=this.i(s,v.document.uri);if(n(v)){const b=I.addEdit(v);this.a.$onDidEdit(v.document.uri,s,b,v.label)}else this.a.$onContentChange(v.document.uri,s)})),this.a.$registerCustomEditorProvider((0,E.$zgc)(h),s,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,E.$xgc)(h))),p.$mL.from(u,new p.$mL(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(h,s,f,l,u){const v=this.b.get(s);if(!v)throw new Error(`No provider found for '${s}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${s}'`);const I=w.URI.revive(h),b=await v.provider.openCustomDocument(I,{backupId:f,untitledDocumentData:l?.buffer},u);let g;return i(v.provider)&&this.f&&(g=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(s,b,g),{editable:i(v.provider)}}async $disposeCustomDocument(h,s){const f=this.b.get(s);if(!f)throw new Error(`No provider found for '${s}'`);if(f.type!==1)throw new Error(`Invalid provider type for '${s}'`);const l=w.URI.revive(h),{document:u}=this.i(s,l);this.c.delete(s,u),u.dispose()}async $resolveCustomEditor(h,s,f,l,u,v){const I=this.b.get(f);if(!I)throw new Error(`No provider found for '${f}'`);const b=$.ViewColumn.to(u),g=this.g.createNewWebview(s,l.contentOptions,I.extension),y=this.h.createNewWebviewPanel(s,f,l.title,b,l.options,g,l.active),L=w.URI.revive(h);switch(I.type){case 1:{const{document:T}=this.i(f,L);return I.provider.resolveCustomEditor(T,y,v)}case 0:{const T=this.d.getDocument(L);return I.provider.resolveCustomTextEditor(T,y,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,s,f){this.i(s,h).disposeEdits(f)}async $onMoveCustomEditor(h,s,f){const l=this.b.get(f);if(!l)throw new Error(`No provider found for '${f}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const u=this.h.getWebviewPanel(h);if(!u)throw new Error("No webview found");const v=w.URI.revive(s),I=this.d.getDocument(v);await l.provider.moveCustomTextEditor(I,u,D.CancellationToken.None)}async $undo(h,s,f,l){return this.i(s,h).undo(f,l)}async $redo(h,s,f,l){return this.i(s,h).redo(f,l)}async $revert(h,s,f){const l=this.i(s,h);await this.j(s).revertCustomDocument(l.document,f),l.disposeBackup()}async $onSave(h,s,f){const l=this.i(s,h);await this.j(s).saveCustomDocument(l.document,f),l.disposeBackup()}async $onSaveAs(h,s,f,l){const u=this.i(s,h);return this.j(s).saveCustomDocumentAs(u.document,w.URI.revive(f),l)}async $backup(h,s,f){const l=this.i(s,h),v=await this.j(s).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},f);return l.updateBackup(v),v.id}i(h,s){const f=this.c.get(h,w.URI.revive(s));if(!f)throw new Error("No custom document found");return f}j(h){const f=this.b.get(h)?.provider;if(!f||!i(f))throw new Error("Custom document is not editable");return f}}e.$Cgc=a;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const h=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,M.$Vi)(h)+""}}),define(ke[324],Se([1,0,211,135,2,6,7,16,4,12,28,59]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=void 0;class k{#e;#t;#i;constructor(m,a,i,r,n,o,t,h){this.d=m,this.e=a,this.f=i,this.g=r,this.h=n,this.c=!1,this.f=Math.max(r,i),this.#i=new R.$Ac(s=>o.getComparisonKey(s)),this.#e=t,this.#t=h}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,a){if(!m){this.clear();return}this.j();let i=[];if(d.URI.isUri(m)){if(!a){this.delete(m);return}this.#i.set(m,a.slice()),i=[m]}else if(Array.isArray(m)){i=[];let o;m=[...m].sort(k.k);for(const t of m){const[h,s]=t;if((!o||h.toString()!==o.toString())&&(o&&this.#i.get(o).length===0&&this.#i.delete(o),o=h,i.push(h),this.#i.set(h,[])),s)this.#i.get(h)?.push(...s);else{const f=this.#i.get(h);f&&(f.length=0)}}}if(this.#t.fire(i),!this.#e)return;const r=[];let n=0;for(const o of i){let t=[];const h=this.#i.get(o);if(h)if(h.length>this.g){t=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const l of h)if(l.severity===s[f]&&t.push({...w.Diagnostic.from(l),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,D.localize)(0,null,h.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=h.map(s=>({...w.Diagnostic.from(s),modelVersionId:this.h(o)}));if(r.push([o,t]),n+=t.length,n>this.f)break}this.#e.$changeMany(this.e,r)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,a){this.j();for(const[i,r]of this)m.call(a,i,r,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const a=this.#i.get(m);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,a){return m[0].toString()<a[0].toString()?-1:m[0].toString()>a[0].toString()?1:0}}e.$7fc=k;let S=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(m){const a=new R.$Ac;for(const i of m)a.set(i,i);return{uris:Object.freeze(Array.from(a.values()))}}constructor(m,a,i,r){this.j=a,this.k=i,this.l=r,this.g=new Map,this.h=new $.$1d({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=m.getProxy(P.$kL.MainThreadDiagnostics)}createDiagnosticCollection(m,a){const{g:i,f:r,h:n,j:o,k:t,l:h}=this,s=new class{$changeMany(u,v){r.$changeMany(u,v),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,u,v.length===0?"CLEARING":v)}$clear(u){r.$clear(u),o.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,u)}dispose(){r.dispose()}};let f;if(!a)a="_generated_diagnostic_collection_name_#"+p.c++,f=a;else if(!i.has(a))f=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do f=a+p.c++;while(i.has(f))}return new class extends k{constructor(){super(a,f,p.e,p.d,u=>h.getDocument(u)?.version,t.extUri,s,n),i.set(f,this)}dispose(){super.dispose(),i.delete(f)}}}getDiagnostics(m){if(m)return this.m(m);{const a=new Map,i=[];for(const r of this.g.values())r.forEach((n,o)=>{let t=a.get(n.toString());typeof t>"u"&&(t=i.length,a.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...o)});return i}}m(m){let a=[];for(const i of this.g.values())i.has(m)&&(a=a.concat(i.get(m)));return a}$acceptMarkersChange(m){if(!this.n){const a="_generated_mirror",i=new k(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(a,i),this.n=i}for(const[a,i]of m)this.n.set(d.URI.revive(a),i.map(w.Diagnostic.to))}};e.$8fc=S,e.$8fc=S=p=Ge([Ve(1,E.$pj),Ve(2,C.$6fc)],S)}),define(ke[325],Se([1,0,2,14,7,16,76]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class w{constructor(E,R,C,p={timeout:1500,errors:3}){this.c=E,this.d=R,this.f=C,this.g=p,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(R,C,p)=>{const S={dispose:this.a.push([R,C,E])};return Array.isArray(p)&&p.push(S),S}}async $participateInSave(E,R){const C=D.URI.revive(E);let p=!1;const k=setTimeout(()=>p=!0,this.g.timeout),S=[];try{for(const c of[...this.a]){if(p)break;const m=this.d.getDocument(C),a=await this.h(c,{document:m,reason:P.TextDocumentSaveReason.to(R)});S.push(a)}}finally{clearTimeout(k)}return S}h([E,R,C],p){const k=this.b.get(E);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(C,E,R,p).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const c=this.b.get(E);this.b.set(E,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,R,C,p){const k=[],S=Date.now(),{document:c,reason:m}=p,{version:a}=c,i=Object.freeze({document:c,reason:m,waitUntil(r){if(Object.isFrozen(k))throw(0,M.$8)("waitUntil can not be called async");k.push(Promise.resolve(r))}});try{R.apply(C,[i])}catch(r){return Promise.reject(r)}return Object.freeze(k),new Promise((r,n)=>{const o=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(o),r(t)}).catch(t=>{clearTimeout(o),n(t)})}).then(r=>{const n={edits:[]};for(const o of r)if(Array.isArray(o)&&o.every(t=>t instanceof d.$tL))for(const{newText:t,newEol:h,range:s}of o)n.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:t,eol:h&&P.EndOfLine.from(h)}});if(n.edits.length!==0)return a===c.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$ehc=w}),define(ke[326],Se([1,0,4,3,2,6,148,16,18,24,7]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class C{constructor(k,S){this.a=new D.$Wd,this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=k.getProxy(P.$kL.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(c=>{for(const m of c)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const m of c)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const S=this.g.getDocument(k);if(S)return S}getDocument(k){const S=this.getDocumentData(k);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return S.document}ensureDocumentData(k){const S=this.g.getDocument(k);if(S)return Promise.resolve(S);let c=this.h.get(k.toString());return c||(c=this.f.$tryOpenDocument(k).then(m=>{this.h.delete(k.toString());const a=d.URI.revive(m);return(0,$.$Uf)(this.g.getDocument(a))},m=>(this.h.delete(k.toString()),Promise.reject(m))),this.h.set(k.toString(),c)),c}createDocumentData(k){return this.f.$tryCreateDocument(k).then(S=>d.URI.revive(S))}$acceptModelLanguageChanged(k,S){const c=d.URI.revive(k),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(S),this.a.fire(m.document)}$acceptModelSaved(k){const S=d.URI.revive(k),c=this.g.getDocument(S);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(k,S){const c=d.URI.revive(k),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(S),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,S,c){const m=d.URI.revive(k),a=this.g.getDocument(m);if(!a)throw new Error("unknown document");a._acceptIsDirty(c),a.onEvents(S);let i;S.isUndoing?i=R.TextDocumentChangeReason.Undo:S.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this.c.fire((0,E.$zn)({document:a.document,contentChanges:S.changes.map(r=>({range:w.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(k,S){(0,A.$rN)(k,S)}}e.$4fc=C}),define(ke[72],Se([1,0,74,4,18,2,5,6,20,16,7]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=void 0,e.$Dgc=(0,A.$8h)("IExtHostEditorTabs");class C{constructor(m,a,i){this.e=i,this.d=a,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$6M(P.URI.revive(this.b.input.uri));case 2:return new R.$7M(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new R.$8M(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new R.$9M(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$0M(this.b.input.viewType);case 4:return new R.$$M(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$_M(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$aN;case 9:return new R.$bN(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$cN(this.b.input.providerId);default:return}}}class p{constructor(m,a){this.c=[],this.d="",this.b=m,this.e=a;for(const i of m.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return E.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(i=>i.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(i=>i.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const i=new C(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,i),m.tabDto.isActive&&(this.d=i.tabId),i}else if(m.kind===1){const i=this.c.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,i),i}const a=this.c.find(i=>i.tabId===m.tabDto.id);if(!a)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(m.tabDto),a}activeTabId(){return this.d}}let k=class{constructor(m){this.b=new M.$Wd,this.c=new M.$Wd,this.e=[],this.a=m.getProxy(w.$kL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,a={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(i=>i.apiObject))},get activeTabGroup(){const i=m.d;return(0,d.$Uf)(m.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,r):this.i(n,r):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(m){const a=new Set(this.e.map(s=>s.groupId)),i=new Set(m.map(s=>s.groupId)),r=(0,D.$L)(a,i),n=this.e.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),o=[],t=[];this.e=m.map(s=>{const f=new p(s,()=>this.d);return r.added.includes(f.groupId)?o.push(f.apiObject):t.push(f.apiObject),f});const h=(0,d.$Uf)(m.find(s=>s.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:o,closed:n,changed:t}))}$acceptTabGroupUpdate(m){const a=this.e.find(i=>i.groupId===m.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const a=this.e.find(r=>r.groupId===m.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const i=a.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(m){for(const a of this.e)for(const i of a.tabs)if(i.apiObject===m)return i}h(m){return this.e.find(a=>a.apiObject===m)}async i(m,a){const i=[];for(const r of m){const n=this.g(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,a)}async j(m,a){const i=[];for(const r of m){const n=this.h(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,a)}};e.$Egc=k,e.$Egc=k=Ge([Ve(0,$.$pN)],k);function S(c){return c.tabs!==void 0}}),define(ke[327],Se([1,0,2,6,3,7,16,173,13,21,26,63]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class p{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const m=this.a.indexOf(c);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),m=[];let a,i,r=14,n=14;for(const o of c){let t=a?(0,$.$cf)(a,o):0;for(t===0?i=1:i=n;t<o.length;t++)t+1===o.length?(r=n,n=9):n+=1,m.push([i,o.toUpperCase().charCodeAt(t),n]),m.push([i,o.toLowerCase().charCodeAt(t),n]),i=n;a=o,n=r}m.push([9,58,10]),m.push([10,47,12]),this.b=new w.$NZ(m)}}provideDocumentLinks(c){this.c();const m=[],a=w.$OZ.computeLinks({getLineContent(i){return c.lineAt(i-1).text},getLineCount(){return c.lineCount}},this.b);for(const i of a){const r=A.DocumentLink.to(i);r.target&&m.push(r)}return m}}class k{constructor(c,m){this.i=m,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(M.$kL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,m,a,i={}){if(k.j(a),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const r=this.h++;this.b.add(m),this.d.add(m),this.c.set(r,a);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof a.copy=="function"&&(n+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,R.$LF)(c,"fsChunks"),n+=4);let o;i.isReadonly&&(0,C.$lk)(i.isReadonly)&&i.isReadonly.value!==""&&(o={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(r,m,n,o).catch(h=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${m}`),console.error(h)});const t=a.onDidChangeFile(h=>{const s=[];for(const f of h){const{uri:l,type:u}=f;if(l.scheme!==m)continue;let v;switch(u){case P.FileChangeType.Changed:v=0;break;case P.FileChangeType.Created:v=1;break;case P.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:l,type:v})}this.a.$onFileSystemChange(r,s)});return(0,d.$Rc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:m,ctime:a,mtime:i,size:r,permissions:n}=c;return{type:m,ctime:a,mtime:i,size:r,permissions:n}}$stat(c,m){return Promise.resolve(this.l(c).stat(D.URI.revive(m))).then(a=>k.k(a))}$readdir(c,m){return Promise.resolve(this.l(c).readDirectory(D.URI.revive(m)))}$readFile(c,m){return Promise.resolve(this.l(c).readFile(D.URI.revive(m))).then(a=>E.$ke.wrap(a))}$writeFile(c,m,a,i){return Promise.resolve(this.l(c).writeFile(D.URI.revive(m),a.buffer,i))}$delete(c,m,a){return Promise.resolve(this.l(c).delete(D.URI.revive(m),a))}$rename(c,m,a,i){return Promise.resolve(this.l(c).rename(D.URI.revive(m),D.URI.revive(a),i))}$copy(c,m,a,i){const r=this.l(c);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(D.URI.revive(m),D.URI.revive(a),i))}$mkdir(c,m){return Promise.resolve(this.l(c).createDirectory(D.URI.revive(m)))}$watch(c,m,a,i){const r=this.l(c).watch(D.URI.revive(a),i);this.f.set(m,r)}$unwatch(c,m){const a=this.f.get(m);a&&(a.dispose(),this.f.delete(m))}$open(c,m,a){const i=this.l(c);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(m),a))}$close(c,m){const a=this.l(c);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(m))}$read(c,m,a,i){const r=this.l(c);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=E.$ke.alloc(i);return Promise.resolve(r.read(m,a,n.buffer,0,i)).then(o=>n.slice(0,o))}$write(c,m,a,i){const r=this.l(c);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(m,a,i.buffer,0,i.byteLength))}l(c){const m=this.c.get(c);if(!m){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return m}}e.$ghc=k}),define(ke[328],Se([1,0,4,35,2,6,16,7,43]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(k,S,c,m,a,i){this.a=Math.random(),this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,M.$Oj)(a),n=typeof a=="string",o=i?.correlate,t=m(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(o&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const s of h.created){const f=d.URI.revive(s);r(f.fsPath)&&(!n||S.getWorkspaceFolder(f))&&this.b.fire(f)}if(!i?.ignoreChangeEvents)for(const s of h.changed){const f=d.URI.revive(s);r(f.fsPath)&&(!n||S.getWorkspaceFolder(f))&&this.c.fire(f)}if(!i?.ignoreDeleteEvents)for(const s of h.deleted){const f=d.URI.revive(s);r(f.fsPath)&&(!n||S.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=w.$mL.from(this.i(k,c,a,i,i?.correlate),this.b,this.c,this.d,t)}i(k,S,c,m,a){const i=w.$mL.from();if(typeof c=="string")return i;const r=k.getProxy(P.$kL.MainThreadFileSystemEventService);let n=!1;return(c.pattern.includes(M.$Kj)||c.pattern.includes(M.$Lj))&&(n=!0),r.$watch(S.identifier.value,this.a,c.baseUri,{recursive:n,excludes:m?.excludes??[]},!!a),w.$mL.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(k){this.a=k,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(d.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(d.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(d.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(k,S,c){this.j=k,this.k=S,this.l=c,this.a=new D.$Wd,this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.g=new D.$Yd,this.h=new D.$Yd,this.i=new D.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,S,c,m){return new E(this.j,k,S,this.a.event,A.GlobPattern.from(c),m)}$onFileEvent(k){this.a.fire(new R(k))}$onDidRunFileOperation(k,S){switch(k){case 2:this.b.fire(Object.freeze({files:S.map(c=>({oldUri:d.URI.revive(c.source),newUri:d.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(c=>d.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(c=>d.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,S){return(c,m,a)=>{const i=function(n){c.call(m,n)};return i.extension=k,S.event(i,void 0,a)}}async $onWillRunFileOperation(k,S,c,m){switch(k){case 2:return await this.n(this.g,{files:S.map(a=>({oldUri:d.URI.revive(a.source),newUri:d.URI.revive(a.target)}))},c,m);case 1:return await this.n(this.i,{files:S.map(a=>d.URI.revive(a.target))},c,m);case 0:case 3:return await this.n(this.h,{files:S.map(a=>d.URI.revive(a.target))},c,m)}}async n(k,S,c,m){const a=new Set,i=[];if(await k.fireAsync(S,m,async(n,o)=>{const t=Date.now(),h=await Promise.resolve(n);h instanceof w.$wL&&(i.push([o.extension,h]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",o.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:o}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(o)}return{edit:r,extensionNames:Array.from(a)}}}e.$hhc=C}),define(ke[329],Se([1,0,2,24,16,7,83,6,13,29,19,18,169,22,25,3,131,121,110,38,14,8,26,213]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class s{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const ee=this.d.getDocument(B),H=await this.e.provideDocumentSymbols(ee,Q);if(!(0,R.$Kb)(H))return H[0]instanceof P.$FL?H.map(d.DocumentSymbol.from):s.f(H)}static f(B){B=B.slice(0).sort((H,oe)=>{let le=H.location.range.start.compareTo(oe.location.range.start);return le===0&&(le=oe.location.range.end.compareTo(H.location.range.end)),le});const Q=[],ee=[];for(const H of B){const oe={name:H.name||"!!MISSING: name!!",kind:d.SymbolKind.from(H.kind),tags:H.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:d.Range.from(H.location.range),selectionRange:d.Range.from(H.location.range),children:[]};for(;;){if(ee.length===0){ee.push(oe),Q.push(oe);break}const le=ee[ee.length-1];if(E.$Ws.containsRange(le.range,oe.range)&&!E.$Ws.equalsRange(le.range,oe.range)){le.children?.push(oe),ee.push(oe);break}ee.pop()}}return Q}}class f{constructor(B,Q,ee,H,oe,le){this.f=B,this.g=Q,this.h=ee,this.j=H,this.k=oe,this.l=le,this.d=new i.$2fc("CodeLens"),this.e=new Map}async provideCodeLenses(B,Q){const ee=this.f.getDocument(B),H=await this.h.provideCodeLenses(ee,Q);if(!H||Q.isCancellationRequested)return;const oe=this.d.add(H),le=new c.$Sc;this.e.set(oe,le);const Re={cacheId:oe,lenses:[]};for(let je=0;je<H.length;je++)Re.lenses.push({cacheId:[oe,je],range:d.Range.from(H[je].range),command:this.g.toInternal(H[je].command,le)});return Re}async resolveCodeLens(B,Q){const ee=B.cacheId&&this.d.get(...B.cacheId);if(!ee)return;let H;if(typeof this.h.resolveCodeLens!="function"||ee.isResolved?H=ee:H=await this.h.resolveCodeLens(ee,Q),H||(H=ee),Q.isCancellationRequested)return;const oe=B.cacheId&&this.e.get(B.cacheId[0]);if(oe){if(!H.command){const le=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,le),this.l.error(le);return}return B.command=this.g.toInternal(H.command,oe),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function l(Ce){return Array.isArray(Ce)?Ce.map(d.DefinitionLink.from):Ce?[d.DefinitionLink.from(Ce)]:[]}class u{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,ee){const H=this.d.getDocument(B),oe=d.Position.to(Q),le=await this.e.provideDefinition(H,oe,ee);return l(le)}}class v{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,ee){const H=this.d.getDocument(B),oe=d.Position.to(Q),le=await this.e.provideDeclaration(H,oe,ee);return l(le)}}class I{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,ee){const H=this.d.getDocument(B),oe=d.Position.to(Q),le=await this.e.provideImplementation(H,oe,ee);return l(le)}}class b{constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,ee){const H=this.d.getDocument(B),oe=d.Position.to(Q),le=await this.e.provideTypeDefinition(H,oe,ee);return l(le)}}class g{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,ee){const H=this.d.getDocument(B),oe=d.Position.to(Q),le=await this.e.provideHover(H,oe,ee);if(!(!le||(0,R.$Kb)(le.contents)))return le.range||(le.range=H.getWordRangeAtPosition(oe)),le.range||(le.range=new P.$oL(oe,oe)),d.Hover.from(le)}}class y{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,ee){const H=this.d.getDocument(B),oe=d.Position.to(Q),le=await this.e.provideEvaluatableExpression(H,oe,ee);if(le)return d.EvaluatableExpression.from(le)}}class L{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,ee,H){const oe=this.d.getDocument(B),le=await this.e.provideInlineValues(oe,d.Range.to(Q),d.InlineValueContext.to(ee),H);if(Array.isArray(le))return le.map(Re=>d.InlineValue.from(Re))}}class T{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,ee){const H=this.d.getDocument(B),oe=d.Position.to(Q),le=await this.e.provideDocumentHighlights(H,oe,ee);if(Array.isArray(le))return le.map(d.DocumentHighlight.from)}}class U{constructor(B,Q){this.d=B,this.e=Q}async provideMultiDocumentHighlights(B,Q,ee,H){const oe=this.d.getDocument(B),le=ee.map(He=>this.d.getDocument(He)),Re=d.Position.to(Q),je=await this.e.provideMultiDocumentHighlights(oe,Re,le,H);if(Array.isArray(je))return je.map(d.MultiDocumentHighlight.from)}}class j{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,ee){const H=this.d.getDocument(B),oe=d.Position.to(Q),le=await this.e.provideLinkedEditingRanges(H,oe,ee);if(le&&Array.isArray(le.ranges))return{ranges:(0,R.$Hb)(le.ranges.map(d.Range.from)),wordPattern:le.wordPattern}}}class F{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,ee,H){const oe=this.d.getDocument(B),le=d.Position.to(Q),Re=await this.e.provideReferences(oe,le,ee,H);if(Array.isArray(Re))return Re.map(d.location.from)}}class N{static{this.d=1e3}constructor(B,Q,ee,H,oe,le,Re){this.g=B,this.h=Q,this.j=ee,this.k=H,this.l=oe,this.m=le,this.n=Re,this.e=new i.$2fc("CodeAction"),this.f=new Map}async provideCodeActions(B,Q,ee,H){const oe=this.g.getDocument(B),le=p.$Ys.isISelection(Q)?d.Selection.to(Q):d.Range.to(Q),Re=[];for(const st of this.j.getDiagnostics(B))if(le.intersection(st.range)&&Re.push(st)>N.d)break;const je={diagnostics:Re,only:ee.only?new P.$HL(ee.only):void 0,triggerKind:d.CodeActionTriggerKind.to(ee.trigger)},He=await this.k.provideCodeActions(oe,le,je,H);if(!(0,R.$Lb)(He)||H.isCancellationRequested)return;const Qe=this.e.add(He),_e=new c.$Sc;this.f.set(Qe,_e);const at=[];for(let st=0;st<He.length;st++){const rt=He[st];if(rt)if(N.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)});else{je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Le=rt.ranges??[];at.push({cacheId:[Qe,st],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(d.Diagnostic.from),edit:rt.edit&&d.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$KF)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$KF)(this.m,"codeActionRanges")?(0,R.$Hb)(Le.map(d.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:Qe,actions:at}}async resolveCodeAction(B,Q){const[ee,H]=B,oe=this.e.get(ee,H);if(!oe||N.o(oe))return{};if(!this.k.resolveCodeAction)return{};const le=await this.k.resolveCodeAction(oe,Q)??oe;let Re;le.edit&&(Re=d.WorkspaceEdit.from(le.edit,void 0));let je;if(le.command){const He=this.f.get(ee);He&&(je=this.h.toInternal(le.command,He))}return{edit:Re,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class O{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ee,H,oe){this.d=B,this.e=Q,this.f=ee,this.g=H,this.h=oe}async prepareDocumentPaste(B,Q,ee,H){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(B),le=Q.map(He=>d.Range.to(He)),Re=d.DataTransfer.toDataTransfer(ee,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(oe,le,Re,H),H.isCancellationRequested)return;const je=Array.from(Re).filter(([,He])=>!(He instanceof P.$bM));return d.DataTransfer.from(je)}async providePasteEdits(B,Q,ee,H,oe){if(!this.f.provideDocumentPasteEdits)return;const le=this.e.getDocument(Q),Re=ee.map(Qe=>d.Range.to(Qe)),je=d.DataTransfer.toDataTransfer(H,async Qe=>(await this.d.$resolvePasteFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentPasteEdits(le,Re,je,oe);if(He)return{label:He.label??(0,h.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?d.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class z{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,ee){const H=this.d.getDocument(B),oe=await this.e.provideDocumentFormattingEdits(H,Q,ee);if(Array.isArray(oe))return oe.map(d.TextEdit.from)}}class K{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,ee,H){const oe=this.d.getDocument(B),le=d.Range.to(Q),Re=await this.e.provideDocumentRangeFormattingEdits(oe,le,ee,H);if(Array.isArray(Re))return Re.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,ee,H){(0,C.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(B),le=Q.map(d.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(oe,le,ee,H);if(Array.isArray(Re))return Re.map(d.TextEdit.from)}}class te{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,ee,H,oe){const le=this.d.getDocument(B),Re=d.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(le,Re,ee,H,oe);if(Array.isArray(je))return je.map(d.TextEdit.from)}}class x{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$2fc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const ee=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,R.$Lb)(ee))return{symbols:[]};const H=this.d.add(ee),oe={cacheId:H,symbols:[]};for(let le=0;le<ee.length;le++){const Re=ee[le];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}oe.symbols.push({...d.WorkspaceSymbol.from(Re),cacheId:[H,le]})}return oe}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ee=this.d.get(...B.cacheId);if(ee){const H=await this.e.resolveWorkspaceSymbol(ee,Q);return H&&(0,M.$Bn)(B,d.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class X{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,ee){this.d=B,this.e=Q,this.f=ee}async provideRenameEdits(B,Q,ee,H){const oe=this.d.getDocument(B),le=d.Position.to(Q);try{const Re=await this.e.provideRenameEdits(oe,le,ee,H);return Re?d.WorkspaceEdit.from(Re):void 0}catch(Re){const je=X.g(Re);return je?{rejectReason:je,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(B,Q,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(B),oe=d.Position.to(Q);try{const le=await this.e.prepareRename(H,oe,ee);let Re,je;if(P.$oL.isRange(le)?(Re=le,je=H.getText(le)):(0,C.$Lf)(le)&&(Re=le.range,je=le.placeholder),!Re||!je)return;if(Re.start.line>oe.line||Re.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(Re),text:je}}catch(le){const Re=X.g(le);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(le)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,Q){this.resultId=B,this.tokens=Q}}class ce{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,ee){const H=this.f.getDocument(B),oe=Q!==0?this.d.get(Q):null;let le=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,oe.resultId,ee):await this.g.provideDocumentSemanticTokens(H,ee);return oe&&this.d.delete(Q),le?(le=ce.h(le),this.o(ce.n(oe,le),le)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ce.j(B)?ce.k(B)?B:new P.$EM(new Uint32Array(B.data),B.resultId):ce.l(B)?ce.m(B)?B:new P.$GM(B.edits.map(Q=>new P.$FM(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!ce.j(Q)||!B||!B.tokens)return Q;const ee=B.tokens,H=ee.length,oe=Q.data,le=oe.length;let Re=0;const je=Math.min(H,le);for(;Re<je&&ee[Re]===oe[Re];)Re++;if(Re===H&&Re===le)return new P.$GM([],Q.resultId);let He=0;const Qe=je-Re;for(;He<Qe&&ee[H-He-1]===oe[le-He-1];)He++;return new P.$GM([{start:Re,deleteCount:H-Re-He,data:oe.subarray(Re,le-He)}],Q.resultId)}o(B,Q){if(ce.j(B)){const ee=this.e++;return this.d.set(ee,new Z(B.resultId,B.data)),(0,m.$O$)({id:ee,type:"full",data:B.data})}if(ce.l(B)){const ee=this.e++;return ce.j(Q)?this.d.set(ee,new Z(Q.resultId,Q.data)):this.d.set(ee,new Z(B.resultId)),(0,m.$O$)({id:ee,type:"delta",deltas:(B.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class _{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,ee){const H=this.d.getDocument(B),oe=await this.e.provideDocumentRangeSemanticTokens(H,d.Range.to(Q),ee);return oe?this.f(oe):null}f(B){return(0,m.$O$)({id:0,type:"full",data:B.data})}}class ge{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,ee,H,oe){this.f=B,this.g=Q,this.h=ee,this.j=H,this.k=oe,this.d=new i.$2fc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,ee,H){const oe=this.f.getDocument(B),le=d.Position.to(Q),Re=oe.getWordRangeAtPosition(le)||new P.$oL(le,le),je=Re.with({end:le}),He=new r.$Sd,Qe=await this.h.provideCompletionItems(oe,le,H,d.CompletionContext.to(ee));if(!Qe||H.isCancellationRequested)return;const _e=Array.isArray(Qe)?new P.$UL(Qe):Qe,at=ge.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),st=new c.$Sc;this.e.set(at,st);const rt=[],Le={x:at,b:rt,a:{replace:d.Range.from(Re),insert:d.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let ze=0;ze<_e.items.length;ze++){const Ae=_e.items[ze],Ze=this.l(Ae,[at,ze],je,Re);rt.push(Ze)}return Le}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...B);if(!ee)return;const H=this.l(ee,B),oe=await this.h.resolveCompletionItem(ee,Q);if(!oe)return;const le=this.l(oe,B);return(H.h!==le.h||H.i!==le.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==le.n||H.o!==le.o||!(0,M.$Cn)(H.p,le.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:le.d,c:le.c,l:le.l,h:le.h,i:le.i,n:le.n,o:le.o,p:le.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,ee,H){const oe=this.e.get(Q[0]);if(!oe)throw Error("DisposableStore is missing...");const le=this.g.toInternal(B.command,oe),Re={x:Q,a:B.label,b:B.kind!==void 0?d.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(d.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:d.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(d.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=B.textEdit.newText):typeof B.insertText=="string"?Re.h=B.insertText:B.insertText instanceof P.$xL&&(Re.h=B.insertText.value,Re.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),P.$oL.isRange(je)?Re.j=d.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!H?.isEqual(je.replacing))&&(Re.j={insert:d.Range.from(je.inserting),replace:d.Range.from(je.replacing)}),Re}}class ne{async provideInlineCompletions(B,Q,ee,H){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,ee){}handlePartialAccept(B,Q,ee){}}class J extends ne{constructor(B,Q,ee,H){super(),this.f=B,this.g=Q,this.h=ee,this.j=H,this.d=new W,this.e=(0,t.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,ee,H){const oe=this.g.getDocument(B),le=d.Position.to(Q),Re=await this.h.provideInlineCompletionItems(oe,le,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:d.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},H);if(!Re||H.isCancellationRequested)return;const je=Array.isArray(Re)?Re:Re.items,He=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Qe=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((st,rt)=>{let Le;st.command&&(_e||(_e=new c.$Sc),Le=this.j.toInternal(st.command,_e));const ze=st.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:st.filterText,range:st.range?d.Range.from(st.range):void 0,command:Le,idx:rt,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:He.map(st=>(_e||(_e=new c.$Sc),this.j.toInternal(st,_e))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,ee){const H=this.d.get(B)?.items[Q];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,ee)}handlePartialAccept(B,Q,ee){const H=this.d.get(B)?.items[Q];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,ee)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class re{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$2fc("SignatureHelp")}async provideSignatureHelp(B,Q,ee,H){const oe=this.e.getDocument(B),le=d.Position.to(Q),Re=this.g(ee),je=await this.f.provideSignatureHelp(oe,le,H,Re);if(je){const He=this.d.add([je]);return{...d.SignatureHelp.from(je),id:He}}}g(B){let Q;if(B.activeSignatureHelp){const ee=d.SignatureHelp.to(B.activeSignatureHelp),H=this.d.get(B.activeSignatureHelp.id,0);H?(Q=H,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class ye{constructor(B,Q,ee,H,oe){this.f=B,this.g=Q,this.h=ee,this.j=H,this.k=oe,this.d=new i.$2fc("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,ee){const H=this.f.getDocument(B),oe=d.Range.to(Q),le=await this.h.provideInlayHints(H,oe,ee);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(ee.isCancellationRequested)return;const Re=this.d.add(le);this.e.set(Re,new c.$Sc);const je={hints:[],cacheId:Re};for(let He=0;He<le.length;He++)this.l(le[He],oe)&&je.hints.push(this.m(le[He],[Re,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),je}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...B);if(!ee)return;const H=await this.h.resolveInlayHint(ee,Q);if(H&&this.l(H))return this.m(H,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const ee=this.e.get(Q[0]);if(!ee)throw Error("DisposableStore is missing...");const H={label:"",cacheId:Q,tooltip:d.MarkdownString.fromStrict(B.tooltip),position:d.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(d.TextEdit.from),kind:B.kind&&d.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")H.label=B.label;else{const oe=[];H.label=oe;for(const le of B.label){if(!le.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:le.value,tooltip:d.MarkdownString.fromStrict(le.tooltip)};P.$yL.isLocation(le.location)&&(Re.location=d.location.from(le.location)),le.command&&(Re.command=this.g.toInternal(le.command,ee)),oe.push(Re)}}return H}}class he{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$2fc("DocumentLink")}async provideLinks(B,Q){const ee=this.e.getDocument(B),H=await this.f.provideDocumentLinks(ee,Q);if(!(!Array.isArray(H)||H.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(he.g).map(d.DocumentLink.from)};{const oe=this.d.add(H),le={links:[],cacheId:oe};for(let Re=0;Re<H.length;Re++){if(!he.g(H[Re]))continue;const je=d.DocumentLink.from(H[Re]);je.cacheId=[oe,Re],le.links.push(je)}return le}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...B);if(!ee)return;const H=await this.f.resolveDocumentLink(ee,Q);if(!(!H||!he.g(H)))return d.DocumentLink.from(H)}releaseLinks(B){this.d.delete(B)}}class fe{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const ee=this.d.getDocument(B),H=await this.e.provideDocumentColors(ee,Q);return Array.isArray(H)?H.map(le=>({color:d.Color.from(le.color),range:d.Range.from(le.range)})):[]}async provideColorPresentations(B,Q,ee){const H=this.d.getDocument(B),oe=d.Range.to(Q.range),le=d.Color.to(Q.color),Re=await this.e.provideColorPresentations(le,{document:H,range:oe},ee);if(Array.isArray(Re))return Re.map(d.ColorPresentation.from)}}class ue{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,ee){const H=this.d.getDocument(B),oe=await this.e.provideFoldingRanges(H,Q,ee);if(Array.isArray(oe))return oe.map(d.FoldingRange.from)}}class me{constructor(B,Q,ee){this.d=B,this.e=Q,this.f=ee}async provideSelectionRanges(B,Q,ee){const H=this.d.getDocument(B),oe=Q.map(d.Position.to),le=await this.e.provideSelectionRanges(H,oe,ee);if(!(0,R.$Lb)(le))return[];if(le.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let je=0;je<oe.length;je++){const He=[];Re.push(He);let Qe=oe[je],_e=le[je];for(;;){if(!_e.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(He.push(d.SelectionRange.from(_e)),!_e.parent)break;Qe=_e.range,_e=_e.parent}}return Re}}class V{constructor(B,Q){this.f=B,this.g=Q,this.d=new a.$uN(""),this.e=new Map}async prepareSession(B,Q,ee){const H=this.f.getDocument(B),oe=d.Position.to(Q),le=await this.g.prepareCallHierarchy(H,oe,ee);if(!le)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(le)?le.map(je=>this.h(Re,je)):[this.h(Re,le)]}async provideCallsTo(B,Q,ee){const H=this.j(B,Q);if(!H)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(H,ee);if(oe)return oe.map(le=>({from:this.h(B,le.from),fromRanges:le.fromRanges.map(Re=>d.Range.from(Re))}))}async provideCallsFrom(B,Q,ee){const H=this.j(B,Q);if(!H)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(H,ee);if(oe)return oe.map(le=>({to:this.h(B,le.to),fromRanges:le.fromRanges.map(Re=>d.Range.from(Re))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const ee=this.e.get(B),H=d.CallHierarchyItem.from(Q,B,ee.size.toString(36));return ee.set(H._itemId,Q),H}j(B,Q){return this.e.get(B)?.get(Q)}}class Y{constructor(B,Q){this.f=B,this.g=Q,this.d=new a.$uN(""),this.e=new Map}async prepareSession(B,Q,ee){const H=this.f.getDocument(B),oe=d.Position.to(Q),le=await this.g.prepareTypeHierarchy(H,oe,ee);if(!le)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(le)?le.map(je=>this.h(Re,je)):[this.h(Re,le)]}async provideSupertypes(B,Q,ee){const H=this.j(B,Q);if(!H)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(H,ee);if(oe)return oe.map(le=>this.h(B,le))}async provideSubtypes(B,Q,ee){const H=this.j(B,Q);if(!H)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(H,ee);if(oe)return oe.map(le=>this.h(B,le))}releaseSession(B){this.e.delete(B)}h(B,Q){const ee=this.e.get(B),H=d.TypeHierarchyItem.from(Q,B,ee.size.toString(36));return ee.set(H._itemId,Q),H}j(B,Q){return this.e.get(B)?.get(Q)}}class de{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ee,H,oe){this.d=B,this.e=Q,this.f=ee,this.g=H,this.h=oe}async provideDocumentOnDropEdits(B,Q,ee,H,oe){const le=this.e.getDocument(Q),Re=d.Position.to(ee),je=d.DataTransfer.toDataTransfer(H,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentDropEdits(le,Re,je,oe);if(He)return{label:He.label??(0,h.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:de.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?d.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class pe{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,ee,H){const oe=D.URI.revive(B),le=this.d.getDocument(oe),Re=ee.documents.map(Qe=>Qe.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>d.Range.to(at))}))),je={documents:Re,selections:Re[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(le,Q,je,H);return He?d.WorkspaceEdit.from(He):null}}class Pe{constructor(B,Q){this.adapter=B,this.extension=Q}}class ve{static{this.d=0}constructor(B,Q,ee,H,oe,le,Re,je){this.g=Q,this.h=ee,this.j=H,this.k=oe,this.l=le,this.m=Re,this.n=je,this.f=new Map,this.e=B.getProxy(w.$kL.MainThreadLanguageFeatures)}o(B,Q){return d.DocumentSelector.from(B,this.g,Q)}p(B){return new P.$mL(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return ve.d++}async s(B,Q,ee,H,oe,le=!1){const Re=this.f.get(B);if(!Re||!(Re.adapter instanceof Q))return H;const je=Date.now();le||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const He=ee(Re.adapter,Re.extension);return Promise.resolve(He).catch(Qe=>{(0,n.$4)(Qe)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Re.extension.identifier,Qe))}).finally(()=>{le||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),k.CancellationToken.isCancellationToken(oe)?(0,o.$Wg)(He,oe):He}t(B,Q){const ee=this.q();return this.f.set(ee,new Pe(B,Q)),ee}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,ee,H){const oe=this.t(new s(this.h,ee),B),le=H&&H.label||ve.u(B);return this.e.$registerDocumentSymbolProvider(oe,this.o(Q,B),le),this.p(oe)}$provideDocumentSymbols(B,Q,ee){return this.s(B,s,H=>H.provideDocumentSymbols(D.URI.revive(Q),ee),void 0,ee)}registerCodeLensProvider(B,Q,ee){const H=this.q(),oe=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Pe(new f(this.h,this.j.converter,ee,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(H,this.o(Q,B),oe);let le=this.p(H);if(oe!==void 0){const Re=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(oe));le=P.$mL.from(le,Re)}return le}$provideCodeLenses(B,Q,ee){return this.s(B,f,H=>H.provideCodeLenses(D.URI.revive(Q),ee),void 0,ee)}$resolveCodeLens(B,Q,ee){return this.s(B,f,H=>H.resolveCodeLens(Q,ee),void 0,void 0)}$releaseCodeLenses(B,Q){this.s(B,f,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,ee){const H=this.t(new u(this.h,ee),B);return this.e.$registerDefinitionSupport(H,this.o(Q,B)),this.p(H)}$provideDefinition(B,Q,ee,H){return this.s(B,u,oe=>oe.provideDefinition(D.URI.revive(Q),ee,H),[],H)}registerDeclarationProvider(B,Q,ee){const H=this.t(new v(this.h,ee),B);return this.e.$registerDeclarationSupport(H,this.o(Q,B)),this.p(H)}$provideDeclaration(B,Q,ee,H){return this.s(B,v,oe=>oe.provideDeclaration(D.URI.revive(Q),ee,H),[],H)}registerImplementationProvider(B,Q,ee){const H=this.t(new I(this.h,ee),B);return this.e.$registerImplementationSupport(H,this.o(Q,B)),this.p(H)}$provideImplementation(B,Q,ee,H){return this.s(B,I,oe=>oe.provideImplementation(D.URI.revive(Q),ee,H),[],H)}registerTypeDefinitionProvider(B,Q,ee){const H=this.t(new b(this.h,ee),B);return this.e.$registerTypeDefinitionSupport(H,this.o(Q,B)),this.p(H)}$provideTypeDefinition(B,Q,ee,H){return this.s(B,b,oe=>oe.provideTypeDefinition(D.URI.revive(Q),ee,H),[],H)}registerHoverProvider(B,Q,ee,H){const oe=this.t(new g(this.h,ee),B);return this.e.$registerHoverProvider(oe,this.o(Q,B)),this.p(oe)}$provideHover(B,Q,ee,H){return this.s(B,g,oe=>oe.provideHover(D.URI.revive(Q),ee,H),void 0,H)}registerEvaluatableExpressionProvider(B,Q,ee,H){const oe=this.t(new y(this.h,ee),B);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(Q,B)),this.p(oe)}$provideEvaluatableExpression(B,Q,ee,H){return this.s(B,y,oe=>oe.provideEvaluatableExpression(D.URI.revive(Q),ee,H),void 0,H)}registerInlineValuesProvider(B,Q,ee,H){const oe=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new L(this.h,ee),B);this.e.$registerInlineValuesProvider(le,this.o(Q,B),oe);let Re=this.p(le);if(oe!==void 0){const je=ee.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(oe));Re=P.$mL.from(Re,je)}return Re}$provideInlineValues(B,Q,ee,H,oe){return this.s(B,L,le=>le.provideInlineValues(D.URI.revive(Q),ee,H,oe),void 0,oe)}registerDocumentHighlightProvider(B,Q,ee){const H=this.t(new T(this.h,ee),B);return this.e.$registerDocumentHighlightProvider(H,this.o(Q,B)),this.p(H)}registerMultiDocumentHighlightProvider(B,Q,ee){const H=this.t(new U(this.h,ee),B);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(Q,B)),this.p(H)}$provideDocumentHighlights(B,Q,ee,H){return this.s(B,T,oe=>oe.provideDocumentHighlights(D.URI.revive(Q),ee,H),void 0,H)}$provideMultiDocumentHighlights(B,Q,ee,H,oe){return this.s(B,U,le=>le.provideMultiDocumentHighlights(D.URI.revive(Q),ee,H.map(Re=>D.URI.revive(Re)),oe),void 0,oe)}registerLinkedEditingRangeProvider(B,Q,ee){const H=this.t(new j(this.h,ee),B);return this.e.$registerLinkedEditingRangeProvider(H,this.o(Q,B)),this.p(H)}$provideLinkedEditingRanges(B,Q,ee,H){return this.s(B,j,async oe=>{const le=await oe.provideLinkedEditingRanges(D.URI.revive(Q),ee,H);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?ve.w(le.wordPattern):void 0}},void 0,H)}registerReferenceProvider(B,Q,ee){const H=this.t(new F(this.h,ee),B);return this.e.$registerReferenceSupport(H,this.o(Q,B)),this.p(H)}$provideReferences(B,Q,ee,H,oe){return this.s(B,F,le=>le.provideReferences(D.URI.revive(Q),ee,H,oe),void 0,oe)}registerCodeActionProvider(B,Q,ee,H){const oe=new c.$Sc,le=this.t(new N(this.h,this.j.converter,this.k,ee,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(le,this.o(Q,B),{providedKinds:H?.providedCodeActionKinds?.map(Re=>Re.value),documentation:H?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,oe)}))},ve.u(B),!!ee.resolveCodeAction),oe.add(this.p(le)),oe}$provideCodeActions(B,Q,ee,H,oe){return this.s(B,N,le=>le.provideCodeActions(D.URI.revive(Q),ee,H,oe),void 0,oe)}$resolveCodeAction(B,Q,ee){return this.s(B,N,H=>H.resolveCodeAction(Q,ee),{},void 0)}$releaseCodeActions(B,Q){this.s(B,N,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,ee){const H=this.t(new z(this.h,ee),B);return this.e.$registerDocumentFormattingSupport(H,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(H)}$provideDocumentFormattingEdits(B,Q,ee,H){return this.s(B,z,oe=>oe.provideDocumentFormattingEdits(D.URI.revive(Q),ee,H),void 0,H)}registerDocumentRangeFormattingEditProvider(B,Q,ee){const H=typeof ee.provideDocumentRangesFormattingEdits=="function",oe=this.t(new K(this.h,ee),B);return this.e.$registerRangeFormattingSupport(oe,this.o(Q,B),B.identifier,B.displayName||B.name,H),this.p(oe)}$provideDocumentRangeFormattingEdits(B,Q,ee,H,oe){return this.s(B,K,le=>le.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ee,H,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(B,Q,ee,H,oe){return this.s(B,K,le=>le.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ee,H,oe),void 0,oe)}registerOnTypeFormattingEditProvider(B,Q,ee,H){const oe=this.t(new te(this.h,ee),B);return this.e.$registerOnTypeFormattingSupport(oe,this.o(Q,B),H,B.identifier),this.p(oe)}$provideOnTypeFormattingEdits(B,Q,ee,H,oe,le){return this.s(B,te,Re=>Re.provideOnTypeFormattingEdits(D.URI.revive(Q),ee,H,oe,le),void 0,le)}registerWorkspaceSymbolProvider(B,Q){const ee=this.t(new x(Q,this.l),B);return this.e.$registerNavigateTypeSupport(ee,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(B,Q,ee){return this.s(B,x,H=>H.provideWorkspaceSymbols(Q,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(B,Q,ee){return this.s(B,x,H=>H.resolveWorkspaceSymbol(Q,ee),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.s(B,x,ee=>ee.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,ee){const H=this.t(new X(this.h,ee,this.l),B);return this.e.$registerRenameSupport(H,this.o(Q,B),X.supportsResolving(ee)),this.p(H)}$provideRenameEdits(B,Q,ee,H,oe){return this.s(B,X,le=>le.provideRenameEdits(D.URI.revive(Q),ee,H,oe),void 0,oe)}$resolveRenameLocation(B,Q,ee,H){return this.s(B,X,oe=>oe.resolveRenameLocation(D.URI.revive(Q),ee,H),void 0,H)}registerDocumentSemanticTokensProvider(B,Q,ee,H){const oe=this.t(new ce(this.h,ee),B),le=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(Q,B),H,le);let Re=this.p(oe);if(le){const je=ee.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(le));Re=P.$mL.from(Re,je)}return Re}$provideDocumentSemanticTokens(B,Q,ee,H){return this.s(B,ce,oe=>oe.provideDocumentSemanticTokens(D.URI.revive(Q),ee,H),null,H)}$releaseDocumentSemanticTokens(B,Q){this.s(B,ce,ee=>ee.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,ee,H){const oe=this.t(new _(this.h,ee),B);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(Q,B),H),this.p(oe)}$provideDocumentRangeSemanticTokens(B,Q,ee,H){return this.s(B,_,oe=>oe.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ee,H),null,H)}registerCompletionItemProvider(B,Q,ee,H){const oe=this.t(new ge(this.h,this.j.converter,ee,this.m,B),B);return this.e.$registerCompletionsProvider(oe,this.o(Q,B),H,ge.supportsResolving(ee),B.identifier),this.p(oe)}$provideCompletionItems(B,Q,ee,H,oe){return this.s(B,ge,le=>le.provideCompletionItems(D.URI.revive(Q),ee,H,oe),void 0,oe)}$resolveCompletionItem(B,Q,ee){return this.s(B,ge,H=>H.resolveCompletionItem(Q,ee),void 0,ee)}$releaseCompletionItems(B,Q){this.s(B,ge,ee=>ee.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,ee,H){const oe=new J(B,this.h,ee,this.j.converter),le=this.t(oe,B);return this.e.$registerInlineCompletionsSupport(le,this.o(Q,B),oe.supportsHandleEvents,S.$nm.toKey(B.identifier.value),H?.yieldTo?.map(Re=>S.$nm.toKey(Re))||[]),this.p(le)}$provideInlineCompletions(B,Q,ee,H,oe){return this.s(B,ne,le=>le.provideInlineCompletions(D.URI.revive(Q),ee,H,oe),void 0,oe)}$handleInlineCompletionDidShow(B,Q,ee,H){this.s(B,ne,async oe=>{oe.handleDidShowCompletionItem(Q,ee,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,ee,H){this.s(B,ne,async oe=>{oe.handlePartialAccept(Q,ee,H)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.s(B,ne,async ee=>{ee.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,ee,H){const oe=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,le=this.t(new re(this.h,ee),B);return this.e.$registerSignatureHelpProvider(le,this.o(Q,B),oe),this.p(le)}$provideSignatureHelp(B,Q,ee,H,oe){return this.s(B,re,le=>le.provideSignatureHelp(D.URI.revive(Q),ee,H,oe),void 0,oe)}$releaseSignatureHelp(B,Q){this.s(B,re,ee=>ee.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,ee){const H=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new ye(this.h,this.j.converter,ee,this.l,B),B);this.e.$registerInlayHintsProvider(oe,this.o(Q,B),typeof ee.resolveInlayHint=="function",H,ve.u(B));let le=this.p(oe);if(H!==void 0){const Re=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(H));le=P.$mL.from(le,Re)}return le}$provideInlayHints(B,Q,ee,H){return this.s(B,ye,oe=>oe.provideInlayHints(D.URI.revive(Q),ee,H),void 0,H)}$resolveInlayHint(B,Q,ee){return this.s(B,ye,H=>H.resolveInlayHint(Q,ee),void 0,ee)}$releaseInlayHints(B,Q){this.s(B,ye,ee=>ee.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,ee){const H=this.t(new he(this.h,ee),B);return this.e.$registerDocumentLinkProvider(H,this.o(Q,B),typeof ee.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(B,Q,ee){return this.s(B,he,H=>H.provideLinks(D.URI.revive(Q),ee),void 0,ee,Q.scheme==="output")}$resolveDocumentLink(B,Q,ee){return this.s(B,he,H=>H.resolveLink(Q,ee),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.s(B,he,ee=>ee.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,ee){const H=this.t(new fe(this.h,ee),B);return this.e.$registerDocumentColorProvider(H,this.o(Q,B)),this.p(H)}$provideDocumentColors(B,Q,ee){return this.s(B,fe,H=>H.provideColors(D.URI.revive(Q),ee),[],ee)}$provideColorPresentations(B,Q,ee,H){return this.s(B,fe,oe=>oe.provideColorPresentations(D.URI.revive(Q),ee,H),void 0,H)}registerFoldingRangeProvider(B,Q,ee){const H=this.q(),oe=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Pe(new ue(this.h,ee),B)),this.e.$registerFoldingRangeProvider(H,this.o(Q,B),B.identifier,oe);let le=this.p(H);if(oe!==void 0){const Re=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));le=P.$mL.from(le,Re)}return le}$provideFoldingRanges(B,Q,ee,H){return this.s(B,ue,oe=>oe.provideFoldingRanges(D.URI.revive(Q),ee,H),void 0,H)}registerSelectionRangeProvider(B,Q,ee){const H=this.t(new me(this.h,ee,this.l),B);return this.e.$registerSelectionRangeProvider(H,this.o(Q,B)),this.p(H)}$provideSelectionRanges(B,Q,ee,H){return this.s(B,me,oe=>oe.provideSelectionRanges(D.URI.revive(Q),ee,H),[],H)}registerCallHierarchyProvider(B,Q,ee){const H=this.t(new V(this.h,ee),B);return this.e.$registerCallHierarchyProvider(H,this.o(Q,B)),this.p(H)}$prepareCallHierarchy(B,Q,ee,H){return this.s(B,V,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,H)),void 0,H)}$provideCallHierarchyIncomingCalls(B,Q,ee,H){return this.s(B,V,oe=>oe.provideCallsTo(Q,ee,H),void 0,H)}$provideCallHierarchyOutgoingCalls(B,Q,ee,H){return this.s(B,V,oe=>oe.provideCallsFrom(Q,ee,H),void 0,H)}$releaseCallHierarchy(B,Q){this.s(B,V,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,ee){const H=this.t(new Y(this.h,ee),B);return this.e.$registerTypeHierarchyProvider(H,this.o(Q,B)),this.p(H)}$prepareTypeHierarchy(B,Q,ee,H){return this.s(B,Y,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,H)),void 0,H)}$provideTypeHierarchySupertypes(B,Q,ee,H){return this.s(B,Y,oe=>oe.provideSupertypes(Q,ee,H),void 0,H)}$provideTypeHierarchySubtypes(B,Q,ee,H){return this.s(B,Y,oe=>oe.provideSubtypes(Q,ee,H),void 0,H)}$releaseTypeHierarchy(B,Q){this.s(B,Y,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,ee,H){const oe=this.q();this.f.set(oe,new Pe(new de(this.e,this.h,ee,oe,B),B));const le=(0,t.$KF)(B,"dropMetadata")&&H?de.toInternalProviderId(B.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(Q,B),le,(0,t.$KF)(B,"dropMetadata")?H:void 0),this.p(oe)}$provideDocumentOnDropEdits(B,Q,ee,H,oe,le){return this.s(B,de,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(Q,D.URI.revive(ee),H,oe,le)),void 0,void 0)}registerMappedEditsProvider(B,Q,ee){const H=this.t(new pe(this.h,ee),B);return this.e.$registerMappedEditsProvider(H,this.o(Q,B)),this.p(H)}$provideMappedEdits(B,Q,ee,H,oe){return this.s(B,pe,le=>Promise.resolve(le.provideMappedEdits(Q,ee,H,oe)),null,oe)}registerDocumentPasteEditProvider(B,Q,ee,H){const oe=this.q();this.f.set(oe,new Pe(new O(this.e,this.h,ee,oe,B),B));const le=O.toInternalProviderId(B.identifier.value,H.id);return this.e.$registerPasteEditProvider(oe,this.o(Q,B),le,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(B,Q,ee,H,oe){return this.s(B,O,le=>le.prepareDocumentPaste(D.URI.revive(Q),ee,H,oe),void 0,oe)}$providePasteEdits(B,Q,ee,H,oe,le){return this.s(B,O,Re=>Re.providePasteEdits(Q,D.URI.revive(ee),H,oe,le),void 0,le)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:ve.w(B.decreaseIndentPattern),increaseIndentPattern:ve.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ve.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ve.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:ve.w(B.beforeText),afterText:B.afterText?ve.w(B.afterText):void 0,previousLineText:B.previousLineText?ve.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(ve.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Q=>P.SyntaxTokenType.toString(Q)):void 0}}static D(B){return B.map(ve.C)}setLanguageConfiguration(B,Q,ee){const{wordPattern:H}=ee;if(H&&(0,$.$Ze)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(Q,H):this.h.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const oe=this.q(),le={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ve.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ve.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ve.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?ve.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,Q,le),this.p(oe)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$_fc=ve}),define(ke[330],Se([1,0,6,16,7,39,8,3,26]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class E{constructor(C,p,k,S){this.c=p,this.d=k,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$kL.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,p){await this.a.$changeLanguage(C,p);const k=this.c.getDocumentData(C);if(!k)throw new Error(`document '${C.toString()}' NOT found`);return k.document}async tokenAtPosition(C,p){const k=C.version,S=M.Position.from(p),c=await this.a.$tokensAtPosition(C.uri,S),m={type:d.StandardTokenType.Other,range:C.getWordRangeAtPosition(p)??new d.$oL(p.line,p.character,p.line,p.character)};if(!c)return m;const a={range:M.Range.to(c.range),type:M.TokenType.to(c.type)};return!a.range.contains(p)||k!==C.version?m:a}createLanguageStatusItem(C,p,k){const S=this.f++,c=this.a,m=this.g,a=`${C.identifier.value}/${p}`;if(m.has(a))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);m.add(a);const i={selector:k,id:p,name:C.displayName??C.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new w.$Sc,o=()=>{if(r?.dispose(),!m.has(a)){console.warn(`LanguageStatusItem (${p}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,A.$0g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:a,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===d.LanguageStatusSeverity.Error?P.default.Error:i.severity===d.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),c.$removeLanguageStatus(S),m.delete(a)},get id(){return i.id},get name(){return i.name},set name(h){i.name=h,o()},get selector(){return i.selector},set selector(h){i.selector=h,o()},get text(){return i.text},set text(h){i.text=h,o()},set text2(h){(0,$.$LF)(C,"languageStatusText"),i.text=h,o()},get text2(){return(0,$.$LF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(h){i.detail=h,o()},get severity(){return i.severity},set severity(h){i.severity=h,o()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(h){i.accessibilityInformation=h,o()},get command(){return i.command},set command(h){i.command=h,o()},get busy(){return i.busy},set busy(h){i.busy=h,o()}};return o(),t}}e.$yhc=E}),define(ke[331],Se([1,0,15,2,16,7,118]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=void 0;class w{constructor(C,p,k,S){this.start=C,this.deletedCount=p,this.deletedItems=k,this.items=S}asApiEvent(){return{range:new P.$LM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,p,k){this.notebook=C,this.h=p,this.j=k,this.handle=k.handle,this.uri=M.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(d.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(d.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:d.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(k)}return this.f}setOutputs(C){this.a=C.map(d.NotebookCellOutput.to)}setOutputItems(C,p,k){const S=k.map(d.NotebookCellOutputItem.to),c=this.a.find(m=>m.id===C);if(c&&(p||(c.items.length=0),c.items.push(...S),c.items.length>1&&c.items.every(m=>A.$nJ(m.mime)))){const m=new Map,a=[];c.items.forEach(i=>{let r;m.has(i.mime)?r=m.get(i.mime):(r=[],m.set(i.mime,r),a.push(i.mime)),r.push(i.data)}),c.items.length=0,a.forEach(i=>{const r=A.$oJ(m.get(i));c.items.push({mime:i,data:r.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(d.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$jhc=$;class E{static{this.a=0}constructor(C,p,k,S,c){this.k=C,this.l=p,this.m=k,this.uri=S,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,p={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(k){return k=C.n(k),C.b[k].apiCell},getCells(k){return(k?C.p(k):C.b).map(c=>c.apiCell)},save(){return C.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,p,k){this.g=C.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:k});const S={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},c=[];for(const a of C.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,S.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,S.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),c.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),c.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const m=new Map;for(let a=0;a<c.length;a++){const i=c[a],r=m.get(i.cell);if(r===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,n-1)}else S.cellChanges[r]={...S.cellChanges[r],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let p=C.start|0,k=C.end|0;return p<0&&(p=0),k>this.b.length&&(k=this.b.length),C.with({start:p,end:k})}p(C){C=this.o(C);const p=[];for(let k=C.start;k<C.end;k++)p.push(this.b[k]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,p,k){if(this.j)return;const S=[],c=[],m=[];if(C.reverse().forEach(a=>{const r=a[2].map(t=>{const h=new $(this,this.l,t);return p||c.push($.asModelAddData(this.apiNotebook,t)),h}),n=new w(a[0],a[1],[],r),o=this.b.splice(a[0],a[1],...r);for(const t of o)m.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:m}),k)for(const a of S)k.push(a.asApiEvent())}s(C,p,k,S){const c=this.b.splice(C,p);this.b.splice(k,0,...c);const m=[new w(C,p,c.map(a=>a.apiCell),[]),new w(k,0,[],c)];for(const a of m)S.push(a.asApiEvent())}t(C,p){this.b[C].setOutputs(p)}u(C,p,k,S){this.b[C].setOutputItems(p,k,S)}v(C,p){const k=this.b[C];k.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(k.uri,p)}w(C,p){const k=this.b[C];k.apiCell.mime=p}x(C,p){this.b[C].setMetadata(p)}y(C,p){this.b[C].setInternalMetadata(p)}getCellFromApiCell(C){return this.b.find(p=>p.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(p=>p.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$khc=E}),define(ke[332],Se([1,0,4,2,16,7]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class A{constructor($,E,R,C={timeout:1500,errors:3}){this.b=$,this.c=E,this.d=R,this.f=C,this.a=new D.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(E,R,C)=>{const p=function(S){E.call(R,S)};return p.extension=$,this.a.event(p,void 0,C)}}async $participateInSave($,E,R){const C=M.URI.revive($),p=this.c.getNotebookDocument(C);if(!p)throw new Error("Unable to resolve notebook document");const k=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:d.TextDocumentSaveReason.to(E)},R,async(c,m)=>{const a=Date.now(),i=await await Promise.resolve(c);Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof P.$wL?k.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(k.length===0)return!0;const S={edits:[]};for(const c of k){const{edits:m}=d.WorkspaceEdit.from(c);S.edits=S.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Ahc=A}),define(ke[149],Se([1,0,14,16,7]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,$,E,R,C,p){this.id=w,this.f=$,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=R,this.c=p}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection($){this.selections=[$]},get selections(){return w.a},set selections($){if(!Array.isArray($)||!$.every(d.$LM.isNotebookRange))throw(0,D.$7)("selections");w.a=$,w.g($)},get visibleRanges(){return w.b},revealRange($,E){w.f.$tryRevealRange(w.id,M.NotebookRange.from($),E??d.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(M.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$lhc=P}),define(ke[333],Se([1,0,4,12,16]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;let P=class{constructor(w,$){this.c=w,this.d=$,this.a=new D.$Wd,this.b=new D.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,$);const E=this.d.getEditorById(w);$.visibleRanges&&E._acceptVisibleRanges($.visibleRanges.ranges.map(d.NotebookRange.to)),$.selections&&E._acceptSelections($.selections.selections.map(d.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const $ in w)this.d.getEditorById($)._acceptViewColumn(d.ViewColumn.to(w[$]))}};e.$Chc=P,e.$Chc=P=Ge([Ve(0,M.$pj)],P)}),define(ke[334],Se([1,0,4,6,149]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class P{constructor(w,$){this.c=$,this.a=new Map,this.b=w.getProxy(M.$kL.MainThreadNotebookRenderers)}$postRendererMessage(w,$,E){const R=this.c.getEditorById(w);this.a.get($)?.fire({editor:R.apiEditor,message:E})}createRendererMessaging(w,$){if(!w.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,C,p)=>this.d($).event(R,C,p),postMessage:(R,C)=>{d.$lhc.apiEditorsToExtHost.has(R)&&([R,C]=[C,R]);const p=C&&d.$lhc.apiEditorsToExtHost.get(C);return this.b.$postMessage(p?.id,$,R)}}}d(w){let $=this.a.get(w);return $||($=new D.$Wd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(w)}}),this.a.set(w,$),$)}}e.$Fhc=P}),define(ke[335],Se([1,0,16,107,22,52,14]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class w{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,p,k){const S=this.b++,{title:c,location:m,cancellable:a}=p,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(S,{location:D.ProgressLocation.from(m),title:c,source:i,cancellable:a},C.isUnderDevelopment?void 0:C.identifier.value).catch(A.$2),this.d(S,k,!!a)}d(C,p,k){let S;k&&(S=new d.$7d,this.c.set(C,S));const c=a=>{this.a.$progressEnd(a),this.c.delete(a),S?.dispose()};let m;try{m=p(new E(this.a,C),k&&S?S.token:d.CancellationToken.None)}catch(a){throw c(C),a}return m.then(a=>c(C),a=>c(C)),m}$acceptProgressCanceled(C){const p=this.c.get(C);p&&(p.cancel(),this.c.delete(C))}}e.$Jhc=w;function $(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class E extends M.$xv{constructor(C,p){super(k=>this.throttledReport(k)),this.c=C,this.d=p}throttledReport(C){this.c.$progressReport(this.d,C)}}Ge([(0,P.$Bh)(100,(R,C)=>$(R,C),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[336],Se([1,0,2,6,8,16]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;class A{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(M.$kL.MainThreadQuickDiff)}$provideOriginalResource($,E,R){const C=D.URI.revive(E),p=this.c.get($);return p?(0,d.$Zg)(()=>p.provideOriginalResource(C,R)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider($,E,R,C){const p=A.a++;return this.c.set(p,E),this.b.$registerQuickDiffProvider(p,P.DocumentSelector.from($,this.d),R,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Khc=A}),define(ke[337],Se([1,0,22,4,3,6,2,7,14,19,39,55,26,16]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;function S(c,m,a){const i=c.getProxy(P.$kL.MainThreadQuickOpen);class r{constructor(v,I){this.e=new Map,this.f=0,this.a=v,this.b=I}showQuickPick(v,I,b,g=D.CancellationToken.None){this.c=void 0;const y=Promise.resolve(I),L=++this.f,T=i.$show(L,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},g),U={},j=T.then(()=>U);return Promise.race([j,y]).then(F=>{if(F===U)return;const N=(0,p.$KF)(v,"quickPickItemTooltip");return y.then(O=>{const z=[];for(let K=0;K<O.length;K++){const te=O[K];if(typeof te=="string")z.push({label:te,handle:K});else if(te.kind===w.QuickPickItemKind.Separator)z.push({type:"separator",label:te.label});else{te.tooltip&&!N&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const x=te.iconPath?s(te.iconPath):void 0;z.push({label:te.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:te.description,detail:te.detail,picked:te.picked,alwaysShow:te.alwaysShow,tooltip:N?k.MarkdownString.fromStrict(te.tooltip):void 0,handle:K})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=K=>{b.onDidSelectItem(O[K])}),i.$setItems(L,z),T.then(K=>{if(typeof K=="number")return O[K];if(Array.isArray(K))return K.map(te=>O[te])})})}).then(void 0,F=>{if(!(0,$.$4)(F))return i.$setError(L,F),Promise.reject(F)})}$onItemSelected(v){this.c?.(v)}showInput(v,I=D.CancellationToken.None){return this.d=v?.validateInput,i.$input(v,typeof this.d=="function",I).then(void 0,b=>{if(!(0,$.$4)(b))return Promise.reject(b)})}async $validateInput(v){if(!this.d)return;const I=await this.d(v);if(!I||typeof I=="string")return I;let b;switch(I.severity){case w.InputBoxValidationSeverity.Info:b=R.default.Info;break;case w.InputBoxValidationSeverity.Warning:b=R.default.Warning;break;case w.InputBoxValidationSeverity.Error:b=R.default.Error;break;default:b=I.message?R.default.Error:R.default.Ignore;break}return{content:I.message,severity:b}}async showWorkspaceFolderPick(v,I=D.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!b)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick(v){const I=new f(v,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(v){const I=new l(v,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(v,I){this.e.get(v)?._fireDidChangeValue(I)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,I){const b=this.e.get(v);b instanceof f&&b._fireDidChangeActive(I)}$onDidChangeSelection(v,I){const b=this.e.get(v);b instanceof f&&b._fireDidChangeSelection(I)}$onDidTriggerButton(v,I){this.e.get(v)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(v,I,b){const g=this.e.get(v);g instanceof f&&g._fireDidTriggerItemButton(I,b)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class n{static{this.a=1}constructor(v,I){this.x=v,this.y=I,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Wd,this.q=new M.$Wd,this.r=new M.$Wd,this.s=new M.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((I,b)=>{const g=I===w.$IM.Back?-1:b;this.o.set(g,I)}),this.z({buttons:v.map((I,b)=>({...s(I.iconPath),tooltip:I.tooltip,handle:I===w.$IM.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const I=this.o.get(v);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,d.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(v){if(!this.v){for(const I of Object.keys(v)){const b=v[I];this.u[I]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function o(u){if(u instanceof w.$hM)return{id:u.id};const v=h(u),I=t(u);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof I=="string"?A.URI.file(I):I}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function h(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const v=o(u);let I,b;return"id"in v?b=C.ThemeIcon.asClassName(v):I=v,{iconPath:I,iconClass:b}}class f extends n{constructor(v,I){super(v.identifier,I),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Wd,this.L=[],this.M=new M.$Wd,this.N=new M.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((g,y)=>{this.C.set(y,g),this.D.set(g,y)});const I=(0,p.$KF)(this.O,"quickPickItemTooltip"),b=[];for(let g=0;g<v.length;g++){const y=v[g];if(y.kind===w.QuickPickItemKind.Separator)b.push({type:"separator",label:y.label});else{y.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=y.iconPath?s(y.iconPath):void 0;b.push({handle:g,label:y.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:I?k.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((T,U)=>({...s(T.iconPath),tooltip:T.tooltip,handle:U}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(v){const I=(0,E.$Hb)(v.map(b=>this.C.get(b)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(v){const I=(0,E.$Hb)(v.map(b=>this.C.get(b)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(v,I){const b=this.C.get(v);if(!b||!b.buttons||!b.buttons.length)return;const g=b.buttons[I];g&&this.N.fire({button:g,item:b})}}class l extends n{constructor(v,I){super(v.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:R.default.Error}):this.z({validationMessage:v.message,severity:v.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new r(m,a)}e.$Lhc=S}),define(ke[338],Se([1,0,2,4,52,3,8,6,19,128,12,25,55,16,26,15,11]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=void 0;function i(L){return L instanceof D.URI}function r(L,T){return L.scheme===c.Schemas.file&&T.scheme===c.Schemas.file&&m.$k?L.toString()===T.toString():L.toString().toLowerCase()===T.toString().toLowerCase()}function n(L){if(L)return typeof L.iconPath=="string"?D.URI.file(L.iconPath):D.URI.isUri(L.iconPath)||p.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function o(L){if(L.icon){if(D.URI.isUri(L.icon))return L.icon;if(p.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const T=L.icon;return{light:T.light,dark:T.dark}}}else return}function t(L,T){if(!L.iconPath&&!T.iconPath)return 0;if(L.iconPath){if(!T.iconPath)return 1}else return-1;const U=typeof L.iconPath=="string"?L.iconPath:D.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,j=typeof T.iconPath=="string"?T.iconPath:D.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,E.$Uq)(U,j)}function h(L,T){let U=0;if(L.strikeThrough!==T.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==T.faded)return L.faded?1:-1;if(L.tooltip!==T.tooltip)return(L.tooltip||"").localeCompare(T.tooltip||"");if(U=t(L,T),U!==0)return U;if(L.light&&T.light)U=t(L.light,T.light);else{if(L.light)return 1;if(T.light)return-1}if(U!==0)return U;if(L.dark&&T.dark)U=t(L.dark,T.dark);else{if(L.dark)return 1;if(T.dark)return-1}return U}function s(L,T){if(L.command!==T.command)return L.command<T.command?-1:1;if(L.title!==T.title)return L.title<T.title?-1:1;if(L.tooltip!==T.tooltip){if(L.tooltip!==void 0&&T.tooltip!==void 0)return L.tooltip<T.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(L.arguments===T.arguments)return 0;if(L.arguments)if(T.arguments){if(L.arguments.length!==T.arguments.length)return L.arguments.length-T.arguments.length}else return 1;else return-1;for(let U=0;U<L.arguments.length;U++){const j=L.arguments[U],F=T.arguments[U];if(j!==F&&!(i(j)&&i(F)&&r(j,F)))return j<F?-1:1}return 0}function f(L,T){let U=(0,E.$Uq)(L.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(U!==0)return U;if(L.command&&T.command)U=s(L.command,T.command);else{if(L.command)return 1;if(T.command)return-1}if(U!==0)return U;if(L.decorations&&T.decorations)U=h(L.decorations,T.decorations);else{if(L.decorations)return 1;if(T.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)U=(0,E.$Uq)(L.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)U=(0,E.$Uq)(L.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return U}function l(L,T){for(let U=0;U<L.length;U++)if(L[U]!==T[U])return!1;return!0}function u(L,T){return L.command===T.command&&L.title===T.title&&L.tooltip===T.tooltip&&(L.arguments&&T.arguments?l(L.arguments,T.arguments):L.arguments===T.arguments)}function v(L,T){return(0,$.$ub)(L,T,u)}class I{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,S.$LF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,S.$LF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,S.$LF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,U,j,F,N){this.k=T,this.l=F,this.m=N,this.d="",this.e=new M.$Wd,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=j}showValidationMessage(T,U){(0,S.$LF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,U)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$Mhc=I;class b{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,U,j,F,N,O,z){this.q=T,this.s=U,this.t=j,this.u=F,this.v=N,this.multiDiffEditorEnableViewChanges=O,this.w=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,U){const j=this.h.get(T);return j?(0,A.$Zg)(()=>this.s.executeCommand(j.command,...j.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(f),j=(0,$.$Db)(this.o,T,f).map(O=>{const z=O.toInsert.map(K=>{const te=this.e++;this.g.set(te,K);const x=K.resourceUri;let X;if(K.command)if(K.command.command==="vscode.open"||K.command.command==="vscode.diff"||K.command.command==="vscode.changes"){const me=new P.$Sc;X=this.s.converter.toInternal(K.command,me),this.j.set(te,me)}else this.h.set(te,K.command);const Z=(0,S.$KF)(this.w,"scmMultiDiffEditor"),ce=Z?K.multiDiffEditorOriginalUri:void 0,_=Z?K.multiFileDiffEditorModifiedUri:void 0,ge=n(K.decorations),ne=K.decorations&&n(K.decorations.light)||ge,J=K.decorations&&n(K.decorations.dark)||ge,W=[ne,J],re=K.decorations&&K.decorations.tooltip||"",ye=K.decorations&&!!K.decorations.strikeThrough,he=K.decorations&&!!K.decorations.faded,fe=K.contextValue||"";return{rawResource:[te,x,W,re,ye,he,fe,X,ce,_],handle:te}});return{start:O.start,deleteCount:O.deleteCount,toInsert:z}}),F=j.map(({start:O,deleteCount:z,toInsert:K})=>[O,z,K.map(te=>te.rawResource)]),N=j.reverse();for(const{start:O,deleteCount:z,toInsert:K}of N){const te=K.map(X=>X.handle),x=this.n.splice(O,z,...te);for(const X of x)this.g.delete(X),this.h.delete(X),this.j.get(X)?.dispose(),this.j.delete(X)}return this.o=T,F}dispose(){this.l=!0,this.m.fire()}}class g{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let U;(0,S.$KF)(this.x,"quickDiffProvider")&&(U=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:U})}get historyProvider(){return(0,S.$LF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,S.$LF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new P.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new P.$Sc,this.o=T;const U=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,S.$LF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,S.$LF)(this.x,"scmActionButton"),this.p.value=new P.$Sc,this.q=T;const U=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(j=>j.map(F=>this.y.converter.toInternal(F,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&v(this.t,T))return;this.s.value=new P.$Sc,this.t=T;const U=(T||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(T,U,j,F,N,O,z){this.x=T,this.y=F,this.z=N,this.A=O,this.B=z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Uc,this.m=void 0,this.n=new P.$Uc,this.o=void 0,this.p=new P.$Uc,this.s=new P.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Wd,this.onDidChangeSelection=this.v.event,this.w=g.d++,this.C=new Map,this.D=new Set,this.#e=j;const K=D.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new I(T,U,this.#e,this.w,K),this.#e.$registerSourceControl(this.w,N,O,z,K)}createResourceGroup(T,U,j){const F=(0,S.$KF)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,N=new b(this.#e,this.y,this.w,T,U,F,this.x),O=M.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,O),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const T=[],U=[];for(const[j,F]of this.C){F.dispose();const N=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});M.Event.once(j.onDidDispose)(()=>{this.D.delete(j),N.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),T.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const O=j._takeResourceStateSnapshot();O.length>0&&U.push([j.handle,O]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,T,U),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(U=>{const j=U._takeResourceStateSnapshot();j.length!==0&&T.push([U.handle,j])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,d.$Ah)(100)],g.prototype,"eventuallyAddResourceGroups",null),Ge([(0,d.$Ah)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,U,j,F){this.l=U,this.m=j,this.n=F,this.g=new Map,this.h=new C.$pm,this.j=new M.$Wd,this.e=T.getProxy(w.$kL.MainThreadSCM),this.f=T.getProxy(w.$kL.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const O=this.g.get(N.sourceControlHandle);if(!O)return N;const z=O.getResourceGroup(N.groupHandle);return z?z.getResourceState(N.handle):N}else if(N&&N.$mid===4){const O=this.g.get(N.sourceControlHandle);return O?O.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const O=this.g.get(N.handle);return O||N}return N}})}createSourceControl(T,U,j,F){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,U,j,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const N=a.d++,O=new g(T,this.m,this.e,this.l,U,j,F);this.g.set(N,O);const z=this.h.get(T.identifier)||[];return z.push(O),this.h.set(T.identifier,z),O}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const U=this.h.get(T.identifier),j=U&&U[U.length-1];return j&&j.inputBox}$provideOriginalResource(T,U,j){const F=D.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",T,F.toString());const N=this.g.get(T);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Zg)(()=>N.quickDiffProvider.provideOriginalResource(F,j)).then(O=>O||null)}$onInputBoxValueChange(T,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const j=this.g.get(T);return j&&j.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(T,U,j,F){this.n.trace("ExtHostSCM#$executeResourceCommand",T,U,j);const N=this.g.get(T);if(!N)return Promise.resolve(void 0);const O=N.getResourceGroup(U);return O?O.$executeResourceCommand(j,F):Promise.resolve(void 0)}$validateInput(T,U,j){this.n.trace("ExtHostSCM#$validateInput",T);const F=this.g.get(T);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Zg)(()=>F.inputBox.validateInput(U,j)).then(N=>{if(!N)return Promise.resolve(void 0);const O=k.MarkdownString.fromStrict(N.message);return O?Promise.resolve([O,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,U,j,F){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,j,F)??void 0}async $provideHistoryItems(T,U,j,F){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(U,j,F))?.map(z=>({...z,icon:o(z)}))??void 0}async $provideHistoryItemSummary(T,U,j,F){const N=this.g.get(T)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const O=await N.provideHistoryItemSummary(U,j,F);return O?{...O,icon:o(O)}:void 0}async $provideHistoryItemChanges(T,U,j,F){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(U,j,F)??void 0}};e.$Nhc=y,e.$Nhc=y=a=Ge([Ve(3,R.$pj)],y)}),define(ke[339],Se([1,0,6,16,2]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class P{static{this.a=0}constructor(w,$){this.d=$,this.c=new Map,this.b=w.getProxy(D.$kL.MainThreadShare)}async $provideShare(w,$,E){return await this.c.get(w)?.provideShare({selection:M.Range.to($.selection),resourceUri:d.URI.revive($.resourceUri)},E)??void 0}registerShareProvider(w,$){const E=P.a++;return this.c.set(E,$),this.b.$registerShareProvider(E,M.DocumentSelector.from(w,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Ohc=P}),define(ke[340],Se([1,0,7,6,216,3,16,18]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$iM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$iM("statusBarItem.warningForeground")]])}#e;#t;constructor(p,k,S,c,m,a=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new P.$Sc,this.#e=p,this.#t=k,m&&c){this.c=(0,D.$XL)(c.identifier,m);const r=S.get(this.c);r&&(a=r.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=m,this.g=a,this.h=this.u(i)}u(p){if((0,w.$Nf)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new P.$Sc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let k;this.m?k=this.m:k=(0,d.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const c=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,k,this.k,c,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Qhc=$;class E{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,d.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const k={message:p};return this.b.unshift(k),this.c(),new D.$mL(()=>{const S=this.b.indexOf(k);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(p,k){this.e=new Map,this.a=p.getProxy(M.$kL.MainThreadStatusBar),this.b=k,this.c=new E(this)}$acceptStaticEntries(p){for(const k of p)this.e.set(k.entryId,k)}createStatusBarEntry(p,k,S,c){return new $(this.a,this.b,this.e,p,k,S,c)}setStatusBarMessage(p,k){const S=this.c.setMessage(p);let c;return typeof k=="number"?c=setTimeout(()=>S.dispose(),k):typeof k<"u"&&k.then(()=>S.dispose(),()=>S.dispose()),new D.$mL(()=>{S.dispose(),clearTimeout(c)})}}e.$Rhc=R}),define(ke[150],Se([1,0,29,141,68,111,89,16,2]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.$CN=e.$BN=void 0;const E=(r,n,o,t)=>{let h=n;return{enumerable:!0,configurable:!1,get(){return h},set(s){if(!o(h,s)){const f=h;h=s,r.listener?.(t(s,f))}}}},R=(r,n)=>r===n,C={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(r,n)=>!(r.length!==n.length||r.some(o=>!n.find(t=>o.id===t.id)))},p=r=>n=>({op:4,update:r(n)}),k=(r,n)=>({range:(()=>{let o;const t=p(h=>({range:D.$Ws.lift(w.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return o},set(h){r.listener?.({op:6}),C.range(o,h)||(o=h,r.listener?.(t(h)))}}})(),label:E(r,n,C.label,p(o=>({label:o}))),description:E(r,void 0,C.description,p(o=>({description:o}))),sortText:E(r,void 0,C.sortText,p(o=>({sortText:o}))),canResolveChildren:E(r,!1,C.canResolveChildren,o=>({op:2,state:o})),busy:E(r,!1,C.busy,p(o=>({busy:o}))),error:E(r,void 0,C.error,p(o=>({error:w.MarkdownString.fromStrict(o)||null}))),tags:E(r,[],C.tags,(o,t)=>({op:1,new:o.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),S=r=>{const n=d.$cK.fromString(r.extId),o=new m(n.controllerId,n.localId,r.label,$.URI.revive(r.uri)||void 0);return o.range=w.Range.to(r.range||void 0),o.description=r.description||void 0,o.sortText=r.sortText||void 0,o.tags=r.tags.map(t=>w.TestTag.to({id:(0,A.$hK)(t).tagId})),o},c=r=>{let n;for(const o of r.tests){const t=S(o.item);(0,M.$lN)(t).parent=n,n=t}return n};e.$BN=c;class m{constructor(n,o,t,h){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const s=(0,M.$kN)(this,n);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,P.$jN)(s,M.$lN,m),enumerable:!0,writable:!1},...k(s,t)})}}e.$CN=m;class a extends m{constructor(n,o){super(n,n,o,void 0),this._isRoot=!0}}e.$DN=a;class i extends P.$fN{constructor(n,o,t){super({controllerId:n,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:M.$lN,getChildren:h=>h.children,root:new a(n,o),toITestItem:w.TestItem.from})}}e.$EN=i}),define(ke[33],Se([1,0,18,7,16,24,6,19,12,56,29,48,2,3,5,20,150,21,69,44,38,87,90,30]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=void 0;let s=class{#e;#t;#i;constructor(b,g,y){this.b=new Map,this.c=new Map,this.#e=b.getProxy(A.$kL.MainThreadCommands),this.d=g,this.#i=y,this.#t=b.getProxy(A.$kL.MainThreadTelemetry),this.converter=new f(this,L=>{const T=this.c.get(L);return T?.result===u.Void?T:void 0},g),this.f=[{processArgument(L){return(0,E.$Eh)(L)}},{processArgument(L){return(0,P.$An)(L,function(T){if(R.$Ws.isIRange(T))return d.Range.to(T);if(C.$Vs.isIPosition(T))return d.Position.to(T);if(R.$Ws.isIRange(T.range)&&p.URI.isUri(T.uri))return d.location.to(T);if(T instanceof a.$ke)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const g=this.registerCommand(!1,b.id,async(...y)=>{const L=b.args.map((U,j)=>{if(!U.validate(y[j]))throw new Error(`Invalid argument '${U.name}' when running '${b.id}', received: ${typeof y[j]=="object"?JSON.stringify(y[j],null,"	"):y[j]} `);return U.convert(y[j])}),T=await this.executeCommand(b.internalId,...L);return b.result.convert(T,y,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new M.$mL(()=>{g.dispose(),this.c.delete(b.id)})}registerCommand(b,g,y,L,T,U){if(this.d.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this.b.has(g))throw new Error(`command '${g}' already exists`);return this.b.set(g,{callback:y,thisArg:L,metadata:T,extension:U}),b&&this.#e.$registerCommand(g),new M.$mL(()=>{this.b.delete(g)&&b&&this.#e.$unregisterCommand(g)})}executeCommand(b,...g){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,g,!0)}async g(b,g,y){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,g,!1);{let L=!1;const T=(0,P.$An)(g,function(U){if(U instanceof M.$nL)return d.Position.from(U);if(U instanceof M.$oL)return d.Range.from(U);if(U instanceof M.$yL)return d.location.from(U);if(M.$LM.isNotebookRange(U))return d.NotebookRange.from(U);if(U instanceof ArrayBuffer)return L=!0,a.$ke.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return L=!0,a.$ke.wrap(U);if(U instanceof a.$ke)return L=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(b,L?new i.$Vv(T):T,y);return(0,E.$Eh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(b,g,!1);throw U}}}async h(b,g,y){const L=this.b.get(b);if(!L)throw new Error("Unknown command");const{callback:T,thisArg:U,metadata:j}=L;if(j?.args)for(let N=0;N<j.args.length;N++)try{(0,D.$1f)(g[N],j.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${j.args[N].name}' - ${j.args[N].description}`)}const F=n.$Sd.create();try{return await T.apply(U,g)}catch(N){if(b===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...g);O&&(b=O.command)}if(this.d.error(N,b,L.extension?.identifier),!y)throw N;if(L.extension?.identifier){const O=this.#i.onExtensionError(L.extension.identifier,N);this.d.trace("forwarded error to extension?",O,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$Si)(N)),this.id=b,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,b,F.elapsed())}}j(b,g,y){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new o.$No(g),duration:y})}$executeContributedCommand(b,...g){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const y=this.b.get(b);return y?(g=g.map(L=>this.f.reduce((T,U)=>U.processArgument(T,y.extension?.identifier),L)),this.h(b,g,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(g=>(b&&(g=g.filter(y=>y[0]!=="_")),g))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[g,y]of this.b){const{metadata:L}=y;L&&(b[g]=L)}return Promise.resolve(b)}};e.$KN=s,e.$KN=s=Ge([Ve(0,c.$pN),Ve(1,$.$pj),Ve(2,t.$JN)],s),e.$LN=(0,S.$8h)("IExtHostCommands");class f{constructor(b,g,y){this.d=b,this.f=g,this.g=y,this.delegatingCommandId=`__vsc${(0,h.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,g){if(!b)return;const y={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return y;const L=this.f(b.command);if(L)y.id=L.internalId,y.arguments=L.args.map((T,U)=>T.convert(b.arguments&&b.arguments[U]));else if((0,w.$Lb)(b.arguments)){const T=`${b.command} /${++this.c}`;this.b.set(T,b),g.add((0,k.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),y.$ident=T,y.id=this.delegatingCommandId,y.arguments=[T],this.g.trace("CommandsConverter#CREATE",b.command,T)}return y}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const g=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],g?g.command:"MISSING"),g?this.d.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$MN=f;class l{static{this.Uri=new l("uri","Uri of a text document",b=>p.URI.isUri(b),b=>b)}static{this.Position=new l("position","A position in a text document",b=>M.$nL.isPosition(b),d.Position.from)}static{this.Range=new l("range","A range in a text document",b=>M.$oL.isRange(b),d.Range.from)}static{this.Selection=new l("selection","A selection in a text document",b=>M.$pL.isSelection(b),d.Selection.from)}static{this.Number=new l("number","",b=>typeof b=="number",b=>b)}static{this.String=new l("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=l.Arr(l.String)}static Arr(b){return new l(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,g=>Array.isArray(g)&&g.every(y=>b.validate(y)),g=>g.map(y=>b.convert(y)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",b=>b instanceof M.$JL,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",b=>b instanceof M.$5M,d.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VS Code TestItem",b=>b instanceof m.$CN,d.TestItem.from)}constructor(b,g,y,L){this.name=b,this.description=g,this.validate=y,this.convert=L}optional(){return new l(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,g){return new l(b??this.name,g??this.description,this.validate,this.convert)}}e.$NN=l;class u{static{this.Void=new u("no result",b=>b)}constructor(b,g){this.description=b,this.convert=g}}e.$ON=u;class v{constructor(b,g,y,L,T){this.id=b,this.internalId=g,this.description=y,this.args=L,this.result=T}}e.$PN=v}),define(ke[341],Se([1,0,19,15,2,83,131,45,33,16,7]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;const C=[new $.$PN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of DocumentHighlight-instances.",k(E.DocumentHighlight.to))),new $.$PN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$NN.Uri],new $.$ON("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,D.$Kb)(c))return;class a extends R.$EL{static to(r){const n=new a(r.name,E.SymbolKind.to(r.kind),r.containerName||"",new R.$yL(m[0],E.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=E.Range.to(r.selectionRange),n.children=r.children?r.children.map(a.to):[],n}}return c.map(a.to)})),new $.$PN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$NN.Uri,new $.$NN("options","Formatting options",c=>!0,c=>c)],new $.$ON("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new $.$PN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$NN.Uri,$.$NN.Range,new $.$NN("options","Formatting options",c=>!0,c=>c)],new $.$ON("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new $.$PN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$NN.Uri,$.$NN.Position,new $.$NN("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$NN("options","Formatting options",c=>!0,c=>c)],new $.$ON("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new $.$PN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$PN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$PN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$PN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$PN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of Location-instances.",k(E.location.to))),new $.$PN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of Hover-instances.",k(E.Hover.to))),new $.$PN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$NN.Uri,new $.$NN("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>R.$nL.isPosition(m)),c=>c.map(E.Position.from))],new $.$ON("A promise that resolves to an array of ranges.",c=>c.map(m=>{let a;for(const i of m.reverse())a=new R.$IL(E.Range.to(i),a);return a}))),new $.$PN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$NN.String.with("query","Search string")],new $.$ON("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(E.WorkspaceSymbol.to))),new $.$PN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(E.CallHierarchyItem.to))),new $.$PN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$NN.CallHierarchyItem],new $.$ON("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(E.CallHierarchyIncomingCall.to))),new $.$PN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$NN.CallHierarchyItem],new $.$ON("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(E.CallHierarchyOutgoingCall.to))),new $.$PN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:E.Range.to(c.range),placeholder:c.text}})),new $.$PN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$NN.Uri,$.$NN.Position,$.$NN.String.with("newName","The new symbol name")],new $.$ON("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return E.WorkspaceEdit.to(c)}})),new $.$PN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$NN.Uri,$.$NN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$ON("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(E.DocumentLink.to))),new $.$PN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$NN.Uri],new $.$ON("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$CM(c.tokenTypes,c.tokenModifiers)})),new $.$PN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$NN.Uri],new $.$ON("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.$P$)(c);if(m.type==="full")return new R.$EM(m.data,void 0)})),new $.$PN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$NN.Uri,$.$NN.Range.optional()],new $.$ON("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$CM(c.tokenTypes,c.tokenModifiers)})),new $.$PN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$NN.Uri,$.$NN.Range],new $.$ON("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.$P$)(c);if(m.type==="full")return new R.$EM(m.data,void 0)})),new $.$PN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$NN.Uri,$.$NN.Position,$.$NN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$NN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$ON("A promise that resolves to a CompletionList-instance.",(c,m,a)=>{if(!c)return new R.$UL([]);const i=c.suggestions.map(r=>E.CompletionItem.to(r,a));return new R.$UL(i,c.incomplete)})),new $.$PN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$NN.Uri,$.$NN.Position,$.$NN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$ON("A promise that resolves to SignatureHelp.",c=>{if(c)return E.SignatureHelp.to(c)})),new $.$PN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$NN.Uri,$.$NN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$ON("A promise that resolves to an array of CodeLens-instances.",(c,m,a)=>k(i=>new R.$ML(E.Range.to(i.range),i.command&&a.fromInternal(i.command)))(c))),new $.$PN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$NN.Uri,new $.$NN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.$oL.isRange(c),c=>R.$pL.isSelection(c)?E.Selection.from(c):E.Range.from(c)),$.$NN.String.with("kind","Code action kind to return code actions for").optional(),$.$NN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$ON("A promise that resolves to an array of Command-instances.",(c,m,a)=>k(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(i.command)}else{const r=new R.$GL(i.title,i.kind?new R.$HL(i.kind):void 0);return i.edit&&(r.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(r.command=a.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(c))),new $.$PN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$NN.Uri],new $.$ON("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new R.$1L(E.Range.to(m.range),E.Color.to(m.color))):[])),new $.$PN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$NN("color","The color to show and insert",c=>c instanceof R.$ZL,E.Color.from),new $.$NN("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:E.Range.from(c.range)}))],new $.$ON("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(E.ColorPresentation.to):[])),new $.$PN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$NN.Uri,$.$NN.Range],new $.$ON("A promise that resolves to an array of Inlay objects",(c,m,a)=>c.map(E.InlayHint.to.bind(void 0,a)))),new $.$PN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$NN.Uri],new $.$ON("A promise that resolves to an array of FoldingRange objects",(c,m)=>{if(c)return c.map(E.FoldingRange.to)})),new $.$PN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$ON("A promise that resolves to an array of NotebookContentProvider static info objects.",k(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>E.NotebookExclusiveDocumentPattern.to(m))})))),new $.$PN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$NN.Uri,$.$NN.Range,new $.$NN("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof R.$oL,c=>E.InlineValueContext.from(c))],new $.$ON("A promise that resolves to an array of InlineValue objects",c=>c.map(E.InlineValue.to))),new $.$PN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$NN("uriOrString","Uri-instance or string (only http/https)",c=>d.URI.isUri(c)||typeof c=="string"&&(0,M.$gg)(c,M.Schemas.http,M.Schemas.https),c=>c),new $.$NN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[E.ViewColumn.from(c),void 0]:[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)])).optional(),$.$NN.String.with("label","").optional()],$.$ON.Void),new $.$PN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$NN.Uri.with("resource","Resource to open"),$.$NN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$NN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[E.ViewColumn.from(c),void 0]:[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)])).optional()],$.$ON.Void),new $.$PN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$NN.Uri.with("left","Left-hand side resource of the diff editor"),$.$NN.Uri.with("right","Right-hand side resource of the diff editor"),$.$NN.String.with("title","Human readable title for the diff editor").optional(),new $.$NN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)]).optional()],$.$ON.Void),new $.$PN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$NN.String.with("title","Human readable title for the changes editor"),new $.$NN("resourceList","List of resources to compare",c=>{for(const m of c){if(m.length!==3)return!1;const[a,i,r]=m;if(!d.URI.isUri(a)||!d.URI.isUri(i)&&i!==void 0&&i!==null||!d.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},c=>c)],$.$ON.Void),new $.$PN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$NN.Uri,$.$NN.Position],new $.$ON("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$PN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$NN.TypeHierarchyItem],new $.$ON("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$PN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$NN.TypeHierarchyItem],new $.$ON("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$PN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$NN.TestItem],$.$ON.Void),new $.$PN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$NN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$ON.Void),new $.$PN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$NN.String.with("name","The context key name"),new $.$NN("value","The context key value",()=>!0,c=>c)],$.$ON.Void),new $.$PN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$NN.Uri,$.$NN.StringArray,new $.$NN("MappedEditsContext","Mapped Edits Context",c=>E.MappedEditsContext.is(c),c=>E.MappedEditsContext.from(c))],new $.$ON("A promise that resolves to a workspace edit or null",c=>c?E.WorkspaceEdit.to(c):null))];class p{static register(m){C.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",w.$7i)}}e.$agc=p;function k(c){return m=>{if(Array.isArray(m))return m.map(c)}}function S(c){if(!Array.isArray(c))return;const m=[];for(const a of c)P.$It(a)?m.push(E.DefinitionLink.to(a)):m.push(E.location.to(a));return m}}),define(ke[342],Se([1,0,3,2,6,16,7,33,8]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class E{static{this.a=0}constructor(k,S){this.extension=k,this.provider=S,this.handle=E.a++}}class R{constructor(k){this.session=k,this.responses=[]}}class C{static{this.a=0}constructor(k,S,c,m){this.f=c,this.g=m,this.b=new Map,this.d=new Map,this.e=k.getProxy(d.$kL.MainThreadInlineChat),S.registerApiCommand(new w.$PN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new w.$NN("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?P.Range.from(a.initialRange):void 0,initialSelection:A.$pL.isSelection(a.initialSelection)?P.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?P.Position.from(a.position):void 0}})],w.$ON.Void))}registerProvider(k,S,c){const m=new E(k,S);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,c?.label??k.displayName??k.name,k.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",c?.supportReportIssue??!1),(0,D.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(k,S,c,m){const a=this.b.get(k);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(M.URI.revive(S)),r=P.Selection.to(c),n=await a.provider.prepareInteractiveEditorSession({document:i,selection:r},m);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=C.a++;return this.d.set(o,new R(n)),{id:o,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:P.Range.from(n.wholeRange),message:n.message}}async $provideResponse(k,S,c,m){const a=this.b.get(k);if(!a)return;const i=this.d.get(S.id);if(!i)return;const r={prompt:c.prompt,selection:P.Selection.to(c.selection),wholeRange:P.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,previewDocument:this.f.getDocument(M.URI.revive(c.previewDocument)),withIntentDetection:c.withIntentDetection};let n=!1;const o={report:async I=>{if(!c.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||m.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:I.message,edits:I.edits?.map(P.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:A.$NL.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(i.session,r,o,m));let h;try{h=await(0,$.$Vg)(t,m)}finally{n=!0}if(!h)return;const s=i.responses.push(h)-1,f={wholeRange:P.Range.from(h.wholeRange),placeholder:h.placeholder};if(!C.h(h))return{...f,id:s,type:"editorEdit",message:P.MarkdownString.from(h.contents),edits:[]};const{edits:l,contents:u}=h,v=u!==void 0?P.MarkdownString.from(u):void 0;return l instanceof A.$wL?{...f,id:s,type:"bulkEdit",edits:P.WorkspaceEdit.from(l),message:v}:{...f,id:s,type:"editorEdit",edits:l.map(P.TextEdit.from),message:v}}async $provideFollowups(k,S,c,m){const a=this.b.get(k),i=this.d.get(S),r=i?.responses[c];if(a&&r&&a.provider.provideFollowups){const n=Promise.resolve(a.provider.provideFollowups(i.session,r,m));return(await(0,$.$Vg)(n,m))?.map(P.ChatFollowup.from)}}$handleFeedback(k,S,c,m){const a=this.b.get(k),i=this.d.get(S),r=i?.responses[c];if(a&&r){const n=P.InteractiveEditorResponseFeedbackKind.to(m);a.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(k,S){}static h(k){return typeof k=="object"&&typeof k.edits=="object"}}e.$ihc=C}),define(ke[343],Se([1,0,2,33]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class d{constructor(A,w,$,E,R){this.a=w,this.b=$,this.c=E;const C=new M.$PN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$NN("showOptions","Show Options",p=>!0,p=>p),new M.$NN("resource","Interactive resource Uri",p=>!0,p=>p),new M.$NN("controllerId","Notebook controller Id",p=>!0,p=>p),new M.$NN("title","Interactive editor title",p=>!0,p=>p)],new M.$ON("Notebook and input URI",p=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const k=this.a.getEditorById(p.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:D.URI.revive(p.notebookUri),inputUri:D.URI.revive(p.inputUri),notebookEditor:k.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:D.URI.revive(p.notebookUri),inputUri:D.URI.revive(p.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(A,w,$,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(E))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$vhc=d}),define(ke[344],Se([1,0,19,8,22,4,3,28,2,25,12,6,33,16,7,112,284,26,69,285]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=void 0;let n=class{constructor(v,I,b,g,y){this.m=I,this.n=b,this.o=g,this.q=y,this.b=new w.$Ac,this.c=new w.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(C.$kL.MainThreadNotebookKernels);const L=new p.$PN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$NN("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const U=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:U}}else if(T&&"notebookEditor"in T){const U=this.n.getIdByEditor(T.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return T})],p.$ON.Void);this.o.registerApiCommand(L)}createNotebookController(v,I,b,g,y,L){for(const ge of this.j.values())if(ge.controller.id===I&&E.$nm.equals(v.identifier,ge.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const T=this.k++,U=this;this.q.trace(`NotebookController[${T}], CREATED by ${v.identifier.value}, ${I}`);const j=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${v.identifier}'`);let F=!1;const N=new P.$Wd,O=new P.$Wd,z={id:l(v.identifier,I),notebookType:b,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:g||v.identifier.value,preloads:L?L.map(k.NotebookRendererScript.from):[]};let K=y??j,te,x;this.a.$addKernel(T,z).catch(ge=>{console.log(ge),F=!0});let X=0;const Z=()=>{if(F)return;const ge=++X;Promise.resolve().then(()=>{ge===X&&this.a.$updateKernel(T,z)})},ce=new w.$Ac,_={get id(){return I},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return z.label},set label(ge){z.label=ge??v.displayName??v.name,Z()},get detail(){return z.detail??""},set detail(ge){z.detail=ge,Z()},get description(){return z.description??""},set description(ge){z.description=ge,Z()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ge){z.supportedLanguages=ge,Z()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){z.supportsExecutionOrder=ge,Z()},get rendererScripts(){return z.preloads?z.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(ge){K=ge??j},get interruptHandler(){return te},set interruptHandler(ge){te=ge,z.supportsInterrupt=!!ge,Z()},set variableProvider(ge){(0,a.$LF)(v,"notebookVariableProvider"),x=ge,z.hasVariableProvider=!!ge,ge?.onDidChangeVariables(ne=>U.a.$variablesUpdated(ne.uri)),Z()},get variableProvider(){return x},createNotebookCellExecution(ge){if(F)throw new Error("notebook controller is DISPOSED");if(!ce.has(ge.notebook.uri))throw U.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return U._createNotebookCellExecution(ge,l(v.identifier,this.id))},createNotebookExecution(ge){if((0,a.$LF)(v,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!ce.has(ge.uri))throw U.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return U._createNotebookExecution(ge,l(v.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${T}], DISPOSED`),F=!0,this.j.delete(T),N.dispose(),O.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(ge,ne){ne===S.NotebookControllerAffinity2.Hidden&&(0,a.$LF)(v,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(T,ge.uri,ne)},onDidReceiveMessage:O.event,postMessage(ge,ne){return(0,a.$LF)(v,"notebookMessaging"),U.a.$postMessage(T,ne&&U.n.getIdByEditor(ne),ge)},asWebviewUri(ge){return(0,a.$LF)(v,"notebookMessaging"),(0,c.$owb)(ge,U.m.remote)}};return this.j.set(T,{extensionId:v.identifier,controller:_,onDidReceiveMessage:O,onDidChangeSelection:N,associatedNotebooks:ce}),_}getIdByController(v){for(const[I,b]of this.j)if(b.controller===v)return l(b.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,I){const b=this.g++,g=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(b,I);const y={dispose:()=>{this.f.delete(b),g.a.$removeKernelDetectionTask(b)}};return this.f.set(b,y),y}registerKernelSourceActionProvider(v,I,b){const g=this.i++,y=typeof b.onDidChangeNotebookKernelSourceActions=="function"?g:void 0,L=this;this.h.set(g,b),this.q.trace(`NotebookKernelSourceActionProvider[${g}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(g,g,I);let T;return y!==void 0&&(T=b.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(g),L.a.$removeKernelSourceActionProvider(g,g),T?.dispose()}}}async $provideKernelSourceActions(v,I){const b=this.h.get(v);if(b){const g=new A.$Sc;return(await b.provideNotebookKernelSourceActions(I)??[]).map(L=>k.NotebookKernelSourceAction.from(L,this.o.converter,g))}return[]}$acceptNotebookAssociation(v,I,b){const g=this.j.get(v);if(g){const y=this.n.getNotebookDocument($.URI.revive(I));b?g.associatedNotebooks.set(y.uri,!0):g.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,y.uri.toString(),b),g.onDidChangeSelection.fire({selected:b,notebook:y.apiNotebook})}}async $executeCells(v,I,b){const g=this.j.get(v);if(!g)return;const y=this.n.getNotebookDocument($.URI.revive(I)),L=[];for(const T of b){const U=y.getCell(T);U&&L.push(U.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,y.uri.toString(),L.length),await g.controller.executeHandler.call(g.controller,L,y.apiNotebook,g.controller)}catch(T){this.q.error(`NotebookController[${v}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(v,I,b){const g=this.j.get(v);if(!g)return;const y=this.n.getNotebookDocument($.URI.revive(I));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,y.apiNotebook);else for(const L of b){const T=y.getCell(L);T&&this.b.get(T.uri)?.cancel()}if(g.controller.interruptHandler){const L=this.c.get(y.uri);b.length&&Array.isArray(L)&&L.length&&L.forEach(T=>T.dispose())}}async $provideVariables(v,I,b,g,y,L,T){const U=this.j.get(v);if(!U)return;const j=this.n.getNotebookDocument($.URI.revive(b)),F=U.controller.variableProvider;if(!F)return;let N;if(g!==void 0){if(N=this.s[g],!N)return}else this.s={};const O=y==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,z=F.provideVariables(j.apiNotebook,N,O,L,T);let K=0;for await(const te of z){if(T.isCancellationRequested)return;const x={id:this.r++,name:te.variable.name,value:te.variable.value,type:te.variable.type,hasNamedChildren:te.hasNamedChildren,indexedChildrenCount:te.indexedChildrenCount};if(this.s[x.id]=te.variable,this.a.$receiveVariable(I,x),K++>=r.$Dfb)return}}$acceptKernelMessageFromRenderer(v,I,b){const g=this.j.get(v);if(!g)return;const y=this.n.getEditorById(I);g.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:b}))}$cellExecutionChanged(v,I,b){const y=this.n.getNotebookDocument($.URI.revive(v)).getCell(I);if(y){const L=b?k.NotebookCellExecutionState.to(b):S.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:y.apiCell,state:L})}}_createNotebookCellExecution(v,I){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const g=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!g)throw new Error("invalid cell");if(this.b.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const y=new t(I,g,this.a);this.b.set(g.uri,y);const L=y.onDidChangeState(()=>{y.state===o.Resolved&&(y.dispose(),L.dispose(),this.b.delete(g.uri))});return y.asApiObject()}_createNotebookExecution(v,I){const b=this.n.getNotebookDocument(v.uri),g=v.getCells().find(T=>{const U=b.getCellFromApiCell(T);return U&&this.b.has(U.uri)});if(g)throw new Error(`duplicate cell execution for ${g.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const y=new s(I,b,this.a),L=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),L.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[y,L]),y.asApiObject()}};e.$Dhc=n,e.$Dhc=n=Ge([Ve(4,R.$pj)],n);var o;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(o||(o={}));class t extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(v,I,b){super(),this.m=I,this.n=b,this.b=t.a++,this.c=new P.$Wd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new d.$7d),this.h=new f(10,g=>this.s(g)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const I=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new i.$Vv(I))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let I=this.m;if(v&&(I=this.m.notebook.getCellFromApiCell(v)),!I)throw new Error("INVALID cell");return I.handle}y(v){return v.map(I=>{const b=S.$PM.ensureUniqueMimeTypes(I.items,!0);return b===I.items?k.NotebookCellOutput.from(I):k.NotebookCellOutput.from({items:b,id:I.id,metadata:I.metadata})})}async z(v,I,b){const g=this.w(I),y=this.y((0,D.$3b)(v));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:g,append:b,outputs:y})}async C(v,I,b){return v=S.$PM.ensureUniqueMimeTypes((0,D.$3b)(v),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:v.map(k.NotebookCellOutputItem.from),outputId:I.id,append:b})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(b){v.j=b,v.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(b){if(v.f===o.Resolved||v.f===o.Started)throw new Error("Cannot call start again");v.f=o.Started,v.c.fire(),v.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,g){if(v.f===o.Resolved)throw new Error("Cannot call resolve twice");v.f=o.Resolved,v.c.fire(),v.h.flush(),v.n.$completeExecution(v.b,new i.$Vv({runEndTime:g,lastRunSuccess:b}))},clearOutput(b){return v.t(),v.z([],b,!1)},appendOutput(b,g){return v.t(),v.z(b,g,!0)},replaceOutput(b,g){return v.t(),v.z(b,g,!1)},appendOutputItems(b,g){return v.t(),v.C(b,g,!0)},replaceOutputItems(b,g){return v.t(),v.C(b,g,!1)}})}}var h;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(h||(h={}));class s extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(v,I,b){super(),this.h=I,this.j=b,this.b=s.a++,this.c=new P.$Wd,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new d.$7d),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class f{constructor(v,I){this.f=v,this.g=I,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new M.$sh,this.b=Date.now(),(0,M.$9g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>v.complete())}}function l(u,v){return`${u.value}/${v}`}e.$Ehc=l}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,218,14,262,22,30,263,55,8,16,33]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=e.$Qgc=e.$Pgc=void 0,e.$Pgc=(0,d.$8h)("IExtHostTerminalService");class r{constructor(b,g,y,L){this.l=b,this._id=g,this.m=y,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(U,j=!0){T.q(),T.l.$sendText(T._id,U,j)},show(U){T.q(),T.l.$show(T._id,U)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(b,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??g?.cwd??void 0,env:b.env??void 0,icon:l(b.iconPath)??void 0,color:c.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o(b.location,g?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,g,y,L,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:L,color:c.ThemeColor.isThemeColor(T)?T.id:void 0,location:g?.location||this.o(b,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,g){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in b?{viewColumn:a.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,g){this.h=Object.freeze({code:b,reason:g})}setDimensions(b,g){return b===this.d&&g===this.g||b===0||g===0?!1:(this.d=b,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(g=>{g!==b&&(this.b=Promise.resolve(b))})}}e.$Qgc=r;class n{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new D.$Wd,this.onProcessData=this.a.event,this.b=new D.$Wd,this.d=new D.$Wd,this.onDidChangeProperty=this.d.event,this.f=new D.$Wd,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,g){this.g.setDimensions?.({columns:b,rows:g})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends w.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,g,y){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Wd,this.onDidChangeShell=this.N.event,this.O=new D.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(M.$kL.MainThreadTerminalService),this.y=new S.$ysb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:L=>{const T=U=>{const j=U;return this.W(j.instanceId)?.value};switch(L?.$mid){case 15:return T(L);default:{if(Array.isArray(L))for(let U=0;U<L.length&&L[U].$mid===15;U++)L[U]=T(L[U]);return L}}}}),this.B({dispose:()=>{for(const[L,T]of this.g)T.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,g){const y=new r(this.a,(0,k.$rg)(),b,b.name),L=new n(b.pty);return y.createExtensionTerminal(b.location,g,this.R(b,g).resolvedExtHostIdentifier,l(b.iconPath),u(b.color)).then(T=>{const U=this.S(T,L);this.h[T]=U}),this.f.push(y),y.value}R(b,g){if(g=g||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const y=b.location.parentTerminal;if(y){const L=this.f.find(T=>T.value===y);L&&(g.resolvedExtHostIdentifier=L._id)}}else b.location&&typeof b.location!="object"?g.location=b.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(b,g){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const L=new n(g),T=this.S(b,L);this.h[b]=T}async $acceptActiveTerminalChanged(b){const g=this.b;if(b===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const y=this.W(b);y&&(this.b=y,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,g){const y=this.W(b);y&&this.O.fire({terminal:y.value,data:g})}async $acceptTerminalDimensions(b,g,y){const L=this.W(b);L&&L.setDimensions(g,y)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(b,g){const y=this.W(b);y&&this.P.fire({terminal:y.value,...g})}async $acceptTerminalMaximumDimensions(b,g,y){this.g.get(b)?.resize(g,y)}async $acceptTerminalTitleChange(b,g){const y=this.W(b);y&&(y.name=g)}async $acceptTerminalClosed(b,g,y){const L=this.Y(this.f,b);if(L!==null){const T=this.f.splice(L,1)[0];T.setExitStatus(g,y),this.H.fire(T.value)}}$acceptTerminalOpened(b,g,y,L){if(g){const j=this.Y(this.f,g);if(j!==null){this.f[j]._id=b,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const T={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:P.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},U=new r(this.a,b,T,y);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(b,g){this.W(b)?._setProcessId(g)}async $startExtensionTerminal(b,g){const y=this.W(b);if(!y)return{message:(0,E.localize)(0,null,b)};y.isOpen||await new Promise(T=>{const U=this.onDidOpenTerminal(async j=>{j===y.value&&(U.dispose(),T())})});const L=this.g.get(b);L?L.startSendingEvents(g):this.j[b]={initialDimensions:g}}S(b,g){const y=new w.$Sc;y.add(g.onProcessReady(T=>this.a.$sendProcessReady(b,T.pid,T.cwd,T.windowsPty))),y.add(g.onDidChangeProperty(T=>this.a.$sendProcessProperty(b,T))),this.y.startBuffering(b,g.onProcessData),y.add(g.onProcessExit(T=>this.U(b,T))),this.g.set(b,g);const L=this.j[b];return L&&g instanceof n&&(g.startSendingEvents(L.initialDimensions),delete this.j[b]),y}$acceptProcessAckDataEvent(b,g){this.g.get(b)?.acknowledgeDataEvent(g)}$acceptProcessInput(b,g){this.g.get(b)?.input(g)}$acceptTerminalInteraction(b){const g=this.W(b);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection(b,g){this.W(b)?.setSelection(g)}$acceptProcessResize(b,g,y){try{this.g.get(b)?.resize(g,y)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(b,g){this.g.get(b)?.shutdown(g)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(g=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(g=>this.a.$sendProcessProperty(b,{type:"cwd",value:g}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$mL(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,g,y){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,y),this.a.$registerProfileProvider(g,b.identifier.value),new $.$mL(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider(b,g,y){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,y),this.a.$registerQuickFixProvider(b,g),new $.$mL(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,g){const y=new p.$7d().token;if(y.isCancellationRequested)return;const L=this.D.get(b);if(!L)return;const T=await L.provideTerminalQuickFixes(g,y);if(T===null||Array.isArray(T)&&T.length===0)return;const U=new w.$Sc;if(this.w.value=U,!Array.isArray(T))return T?a.TerminalQuickFix.from(T,this.Q.converter,U):void 0;const j=[];for(const F of T){const N=a.TerminalQuickFix.from(F,this.Q.converter,U);N&&j.push(N)}return j}async $createContributedProfileTerminal(b,g){const y=new p.$7d().token;let L=await this.C.get(b)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,g);return}this.createTerminalFromOptions(L.options,g)}}async $provideLinks(b,g){const y=this.W(b);if(!y)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const T=new p.$7d;this.G.set(b,T);const U=[],j={terminal:y.value,line:g},F=[];for(const z of this.z)F.push(m.Promises.withAsyncBody(async K=>{T.token.onCancellationRequested(()=>K({provider:z,links:[]}));const te=await z.provideTerminalLinks(j,T.token)||[];T.token.isCancellationRequested||K({provider:z,links:te})}));const N=await Promise.all(F);if(T.token.isCancellationRequested)return[];const O=new Map;for(const z of N)z&&z.links.length>0&&U.push(...z.links.map(K=>{const te={id:o++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return O.set(te.id,{provider:z.provider,link:K}),te}));return this.F.set(b,O),U}$activateLink(b,g){const y=this.F.get(b)?.get(g);y&&y.provider.handleTerminalLink(y.link)}U(b,g){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const y=this.h[b];y&&(y.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,g)}W(b){return this.X(this.f,b)}X(b,g){const y=this.Y(b,g);return y!==null?b[y]:null}Y(b,g){const y=b.findIndex(L=>L._id===g);return y===-1?null:y}getEnvironmentVariableCollection(b){let g=this.n.get(b.identifier.value);return g||(g=new h,this.$(b.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z(b,g){const y=(0,C.$Or)(g.map),L=(0,C.$Pr)(g.descriptionMap);this.a.$setEnvironmentVariableCollection(b,g.persistent,y.length===0?void 0:y,L)}$initEnvironmentVariableCollections(b){b.forEach(g=>{const y=g[0],L=new h(g[1]);this.$(y,L)})}$acceptDefaultProfile(b,g){const y=this.s;this.s=b,this.u=g,y?.path!==b.path&&this.N.fire(b.path)}$(b,g){this.n.set(b,g),g.onDidChangeCollection(()=>{this.Z(b,g)})}};e.$Rgc=t,e.$Rgc=t=Ge([Ve(1,i.$LN),Ve(2,A.$pN)],t);class h{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Wd,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const g=this.h(b);let y=this.a.get(g);return y||(y=new s(this,b),this.a.set(g,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(b,g,y,L){this.f(b,{value:g,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:L})}append(b,g,y,L){this.f(b,{value:g,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:L})}prepend(b,g,y,L){this.f(b,{value:g,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:L})}f(b,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(b,g.scope),L=this.map.get(y),T=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==g.value||L.type!==g.type||L.options?.applyAtProcessCreation!==T.applyAtProcessCreation||L.options?.applyAtShellIntegration!==T.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const U=this.g(b,g.scope),j={variable:b,...g,options:T};this.map.set(U,j),this.d.fire()}}get(b,g){const y=this.g(b,g),L=this.map.get(y);return L?v(L):void 0}g(b,g){const y=this.h(g);return y.length?`${b}:::${y}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const g=new Map;for(const[y,L]of this.map)this.h(L.scope)===this.h(b)&&g.set(L.variable,v(L));return g}delete(b,g){const y=this.g(b,g);this.map.delete(y),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[g,y]of this.map)y.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(g);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,g){const y=this.h(g),L=this.descriptionMap.get(y);if(!L||L.description!==b){let T;typeof b=="string"?T=b:T=b?.value.split(`

`)[0];const U={description:T,scope:g};this.descriptionMap.set(y,U),this.d.fire()}}getDescription(b){const g=this.h(b);return this.descriptionMap.get(g)?.description}k(b){const g=this.h(b);this.descriptionMap.delete(g)}}class s{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,g){this.b=b,this.d=g,this.a=new D.$Wd}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,g,y){this.b.replace(b,g,y,this.d)}append(b,g,y){this.b.append(b,g,y,this.d)}prepend(b,g,y){this.b.prepend(b,g,y,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,g){this.b.getVariableMap(this.d).forEach((y,L)=>b.call(g,L,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let f=class extends t{constructor(b,g){super(!1,b,g)}createTerminal(b,g,y){throw new R.$_}createTerminalFromOptions(b,g){throw new R.$_}};e.$Sgc=f,e.$Sgc=f=Ge([Ve(0,i.$LN),Ve(1,A.$pN)],f);function l(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function u(I){return c.ThemeColor.isThemeColor(I)?I:void 0}function v(I){const b={...I};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(ke[345],Se([1,0,8,21,22,4,75,54,3,24,18,30,12,6,20,150,16,7,68,111,89,26]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=e.$Whc=e.$Vhc=void 0;let t=class extends $.$Tc{constructor(F,N,O,z){super(),this.w=z,this.f=this.B(new P.$Wd),this.g=new Map,this.s=this.B(new P.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(k.$kL.MainThreadTesting),this.m=new y(this.h),this.j=new l(this.h,N),O.registerArgumentProcessor({processArgument:K=>{switch(K?.$mid){case 16:{const te=K,x=te.tests[te.tests.length-1].item.extId;return this.g.get(i.$cK.root(x))?.collection.tree.get(x)?.actual??(0,c.$BN)(K)}case 18:{const{extId:te,message:x}=K;return{test:this.g.get(i.$cK.root(te))?.collection.tree.get(te)?.actual,message:m.TestMessage.to(x)}}default:return K}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const K=await O.executeCommand("_testing.getExplorerSelection"),te=x=>{const X=this.g.get(i.$cK.root(x));if(X)return i.$cK.isRoot(x)?X.controller:X.collection.tree.get(x)?.actual};return{include:K?.include.map(te).filter(R.$Rf)||[],exclude:K?.exclude.map(te).filter(R.$Rf)||[]}})}createTestController(F,N,O,z){if(this.g.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const K=new $.$Sc,te=K.add(new c.$EN(N,O,this.w));te.root.label=O;const x=new Map,X=new Set,Z=this.h,ce={items:te.root.children,get label(){return O},set label(ge){O=ge,te.root.label=ge,Z.$updateController(N,{label:O})},get refreshHandler(){return z},set refreshHandler(ge){z=ge,Z.$updateController(N,{canRefresh:!!ge})},get id(){return N},createRunProfile:(ge,ne,J,W,re,ye)=>{let he=(0,w.$Vi)(ge);for(;x.has(he);)he++;return new T(this.h,x,X,this.s.event,N,he,ge,ne,J,W,re,ye)},createTestItem(ge,ne,J){return new c.$CN(N,ge,ne,J)},createTestRun:(ge,ne,J=!0)=>this.j.createTestRun(F,N,te,ge,ne,J),invalidateTestResults:ge=>{if(ge===void 0)this.h.$markTestRetired(void 0);else{const ne=ge instanceof Array?ge:[ge];this.h.$markTestRetired(ne.map(J=>i.$cK.fromExtHostTestItem(J,N).toString()))}},set resolveHandler(ge){te.resolveHandler=ge},get resolveHandler(){return te.resolveHandler},dispose:()=>{K.dispose()}};Z.$registerTestController(N,O,!!z),K.add((0,$.$Rc)(()=>Z.$unregisterTestController(N)));const _={controller:ce,collection:te,profiles:x,extension:F,activeProfiles:X};return this.g.set(N,_),K.add((0,$.$Rc)(()=>this.g.delete(N))),K.add(te.onDidGenerateDiff(ge=>Z.$publishDiff(N,ge.map(n.TestsDiffOp.serialize)))),ce}createTestObserver(){return this.m.checkout()}async runTests(F,N=d.CancellationToken.None){const O=u(F);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(O.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(K=>i.$cK.fromExtHostTestItem(K,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:U[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:F.exclude?.map(K=>K.id)},N)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $provideFileCoverage(F,N,O){return await this.j.getCoverageReport(F,N)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(F,N,O,z){return await this.j.getCoverageReport(F,N)?.resolveFileCoverage(O,z)??[]}$configureRunProfile(F,N){this.g.get(F)?.profiles.get(N)?.configureHandler?.()}$setDefaultRunProfiles(F){const N=new Map;for(const[O,z]of Object.entries(F)){const K=this.g.get(O);if(!K)continue;const te=new Map,x=z.filter(Z=>!K.activeProfiles.has(Z)),X=[...K.activeProfiles].filter(Z=>!z.includes(Z));for(const Z of x)te.set(Z,!0),K.activeProfiles.add(Z);for(const Z of X)te.set(Z,!1),K.activeProfiles.delete(Z);te.size&&N.set(O,te)}this.s.fire(N)}async $refreshTests(F,N){await this.g.get(F)?.controller.refreshHandler?.(N)}$publishTestResults(F){this.results=Object.freeze(F.map(N=>(0,E.$zn)(m.TestResults.to(N))).concat(this.results).sort((N,O)=>O.completedAt-N.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,N){const O=this.g.get(i.$cK.fromString(F).controllerId)?.collection;O&&(await O.expand(F,N<0?1/0:N),O.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(N=>n.TestsDiffOp.deserialize({asCanonicalUri:O=>O},N)))}async $runControllerTests(F,N){return Promise.all(F.map(O=>this.y(O,!1,N)))}async $startContinuousRun(F,N){const O=new d.$7d(N),z=await Promise.all(F.map(K=>this.y(K,!0,O.token)));return!N.isCancellationRequested&&!z.some(K=>K.error)&&await new Promise(K=>N.onCancellationRequested(K)),O.dispose(!0),z}async y(F,N,O){const z=this.g.get(F.controllerId);if(!z)return{};const{collection:K,profiles:te,extension:x}=z,X=te.get(F.profileId);if(!X)return{};const Z=F.testIds.map(ne=>K.tree.get(ne)).filter(R.$Rf),ce=F.excludeExtIds.map(ne=>z.collection.tree.get(ne)).filter(R.$Rf).filter(ne=>Z.some(J=>J.fullId.compare(ne.fullId)===2));if(!Z.length)return{};const _=new a.$WM(Z.some(ne=>ne.actual instanceof c.$DN)?void 0:Z.map(ne=>ne.actual),ce.map(ne=>ne.actual),X,N),ge=(0,n.$eK)(F)&&this.j.prepareForMainThreadTestRun(_,v.fromInternal(F,z.collection),x,O);try{return await X.runHandler(_,O),{}}catch(ne){return{error:String(ne)}}finally{ge&&(ge.hasRunningTasks&&!O.isCancellationRequested&&await P.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$Vhc=t,e.$Vhc=t=Ge([Ve(0,S.$pN),Ve(1,p.$pj)],t);const h=1e4;var s;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(s||(s={}));class f extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(F,N,O,z,K){super(),this.s=F,this.w=N,this.y=O,this.z=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Wd),this.m=this.B(new P.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new d.$7d(K));const te=this.B(new D.$hh(()=>this.C(),h));this.B(this.h.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(F){const N=this.s.id,O=this.s.controllerId,z=(0,C.$rg)(),K=this.y,te=this.m;let x;const X=ge=>(ne,...J)=>{if(ce){this.z.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ne)&&(this.F(ne),ge(ne,...J))},Z=(ge,ne)=>{const J=ne instanceof Array?ne.map(m.TestMessage.from):[m.TestMessage.from(ne)];if(ge.uri&&ge.range){const W={range:m.Range.from(ge.range),uri:ge.uri};for(const re of J)re.location=re.location||W}this.w.$appendTestMessagesInRun(N,z,i.$cK.fromExtHostTestItem(ge,O).toString(),J)};let ce=!1;const _={isPersisted:this.s.isPersisted,token:this.h.token,name:F,get coverageProvider(){return x?.provider},set coverageProvider(ge){(0,o.$LF)(K,"testCoverage"),x=ge&&new I(ge),te.fire({taskId:z,runId:N,coverage:x})},enqueued:X(ge=>{this.w.$updateTestStateInRun(N,z,i.$cK.fromExtHostTestItem(ge,O).toString(),1)}),skipped:X(ge=>{this.w.$updateTestStateInRun(N,z,i.$cK.fromExtHostTestItem(ge,O).toString(),5)}),started:X(ge=>{this.w.$updateTestStateInRun(N,z,i.$cK.fromExtHostTestItem(ge,O).toString(),2)}),errored:X((ge,ne,J)=>{Z(ge,ne),this.w.$updateTestStateInRun(N,z,i.$cK.fromExtHostTestItem(ge,O).toString(),6,J)}),failed:X((ge,ne,J)=>{Z(ge,ne),this.w.$updateTestStateInRun(N,z,i.$cK.fromExtHostTestItem(ge,O).toString(),4,J)}),passed:X((ge,ne)=>{this.w.$updateTestStateInRun(N,z,i.$cK.fromExtHostTestItem(ge,this.s.controllerId).toString(),3,ne)}),appendOutput:(ge,ne,J)=>{ce||(J&&(this.s.isIncluded(J)?this.F(J):J=void 0),this.w.$appendOutputToRun(N,z,M.$ke.fromString(ge),ne&&m.location.from(ne),J&&i.$cK.fromExtHostTestItem(J,O).toString()))},end:()=>{ce||(ce=!0,this.w.$finishedTestRunTask(N,z),this.f.delete(z),this.f.size||this.D())}};return this.f.set(z,{run:_}),this.w.$startedTestRunTask(N,{id:z,name:F,running:!0}),_}C(){for(const{run:F}of this.f.values())F.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(F){if(!(F instanceof c.$CN))throw new r.$hN(F.id);if(this.g.has(i.$cK.fromExtHostTestItem(F,this.s.controllerId).toString()))return;const N=[],O=this.s.colllection.root;for(;;){const z=m.TestItem.from(F);if(N.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),F===O))break;F=F.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,N)}dispose(){this.D(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(F,N){this.g=F,this.h=N,this.c=new Map,this.f=[]}getCoverageReport(F,N){return this.f.find(O=>O.runId===F)?.coverage.get(N)}prepareForMainThreadTestRun(F,N,O,z){return this.j(F,N,O,z)}cancelRunById(F){for(const N of this.c.values())if(N.id===F){N.cancel();return}}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,N,O,z,K,te){const x=this.c.get(z);if(x)return x.createRun(K);const X=v.fromPublic(N,O,z,te),Z=u(z);this.g.$startedExtensionTestRun({controllerId:N,continuous:!!z.continuous,profile:Z&&{group:U[Z.kind],id:Z.profileId},exclude:z.exclude?.map(_=>i.$cK.fromExtHostTestItem(_,O.root.id).toString())??[],id:X.id,include:z.include?.map(_=>i.$cK.fromExtHostTestItem(_,O.root.id).toString())??[O.root.id],persist:te});const ce=this.j(z,X,F);return P.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(X.id),ce.dispose()}),ce.createRun(K)}j(F,N,O,z){const K=new f(N,this.g,O,this.h,z);this.c.set(F,K);let te;const x=K.onDidCoverage(({runId:X,taskId:Z,coverage:ce})=>{te||(te={runId:X,coverage:new Map},this.f.unshift(te),this.f.length>n.$jK&&this.f.pop()),te.coverage.set(Z,ce),this.g.$signalCoverageAvailable(X,Z,!!ce)});return P.Event.once(K.onEnd)(()=>{this.c.delete(F),x.dispose()}),K}}e.$Whc=l;const u=j=>{if(j.profile){if(!(j.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class v{static fromPublic(F,N,O,z){return new v(F,(0,C.$rg)(),O.include?.map(K=>i.$cK.fromExtHostTestItem(K,F).toString())??[F],O.exclude?.map(K=>i.$cK.fromExtHostTestItem(K,F).toString())??[],z,N)}static fromInternal(F,N){return new v(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,N)}constructor(F,N,O,z,K,te){this.controllerId=F,this.id=N,this.isPersisted=K,this.colllection=te,this.c=O.map(x=>x+"\0"),this.f=z.map(x=>x+"\0")}isIncluded(F){const N=i.$cK.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const O of this.f)if(N===O||N.startsWith(O))return!1;for(const O of this.c)if(N===O||N.startsWith(O))return!0;return!1}}e.$Xhc=v;class I{constructor(F){this.provider=F}async provideFileCoverage(F){this.c||(this.c=(async()=>this.provider.provideFileCoverage(F))());try{return(await this.c)?.map(m.TestCoverage.fromFile)??[]}catch(N){throw this.c=void 0,N}}async resolveFileCoverage(F,N){const O=await this.c;let z=O?.[F];return!this.provider||!O||!z?[]:(z.detailedCoverage||(z=O[F]=await this.provider.resolveFileCoverage?.(z,N)??z),z.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,m.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const N=i.$cK.parentId(F.item.extId);if(N&&this.h.has(N.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:N,g:O}=this;return{get added(){return[...F].map(z=>z.revived)},get updated(){return[...N].map(z=>z.revived)},get removed(){return[...O].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends n.$kK{constructor(){super(...arguments),this.s=new P.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}w(F,N){return{...F,revived:m.TestItem.toPlain(F.item),depth:N?N.depth+1:0,children:new Set}}v(){return new b(this.s)}}class y{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(N=>N.revived)},dispose:(0,A.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new g({asCanonicalUri:N=>N});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const L=(j,F,N,O)=>{N?Object.assign(N,O):F.$updateTestRunConfig(j.controllerId,j.profileId,O)};class T{#e;#t;#i;#n;#s;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,L(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,L(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),L(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,L(this,this.#e,this.#n,{tag:F?m.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,L(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return P.Event.chain(this.#i,F=>F.map(N=>N.get(this.controllerId)?.get(this.profileId)).filter(R.$Rf))}constructor(F,N,O,z,K,te,x,X,Z,ce=!1,_=void 0,ge=!1){this.controllerId=K,this.profileId=te,this.f=x,this.kind=X,this.runHandler=Z,this._tag=_,this.g=ge,this.#e=F,this.#s=N,this.#t=O,this.#i=z,N.set(te,this);const ne=U[X];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);ce&&O.add(te),this.#n={profileId:te,controllerId:K,tag:_?m.TestTag.namespace(this.controllerId,_.id):null,label:x,group:ne,isDefault:ce,hasConfigurationHandler:!1,supportsContinuousRun:ge},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Yhc=T;const U={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(ke[151],Se([1,0,61,14,121,16,7]),function($e,e,D,M,d,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=e.$xN=e.$wN=void 0;class w{static{this.c=new d.$uN("TextEditorDecorationType")}constructor(p,k,S){const c=w.c.nextId();p.$registerTextEditorDecorationType(k.identifier,c,P.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:c,dispose(){p.$removeTextEditorDecorationType(c)}})}}e.$wN=w;class ${constructor(p,k){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,k){this.k();let S=null;if(p instanceof A.$nL)S=new A.$oL(p,p);else if(p instanceof A.$oL)S=p;else throw new Error("Unrecognized location");this.l(S,k,!1)}insert(p,k){this.k(),this.l(new A.$oL(p,p),k,!0)}delete(p){this.k();let k=null;if(p instanceof A.$oL)k=p;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(p,k,S){const c=this.c.validateRange(p);this.g.push({range:c,text:k,forceMoveMarkers:S})}setEndOfLine(p){if(this.k(),p!==A.EndOfLine.LF&&p!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=p}}class E{constructor(p,k,S,c){this.c=p,this.d=k,this._accept(S),this.e=c;const m=this;this.value={get tabSize(){return m.f},set tabSize(a){m.n(a)},get indentSize(){return m.g},set indentSize(a){m.p(a)},get insertSpaces(){return m.j},set insertSpaces(a){m.s(a)},get cursorStyle(){return m.k},set cursorStyle(a){m.t(a)},get lineNumbers(){return m.l},set lineNumbers(a){m.u(a)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const k=Math.floor(p);return k>0?k:null}if(typeof p=="string"){const k=parseInt(p,10);return isNaN(k)?null:k>0?k:null}return null}n(p){const k=this.m(p);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const k=Math.floor(p);return k>0?k:null}if(typeof p=="string"){const k=parseInt(p,10);return isNaN(k)?null:k>0?k:null}return null}p(p){const k=this.o(p);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const k=this.q(p);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(p)})))}assign(p){const k={};let S=!1;if(typeof p.tabSize<"u"){const c=this.m(p.tabSize);c==="auto"?(S=!0,k.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,S=!0,k.tabSize=c)}if(typeof p.indentSize<"u"){const c=this.o(p.indentSize);c==="tabSize"?(S=!0,k.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,S=!0,k.indentSize=c)}if(typeof p.insertSpaces<"u"){const c=this.q(p.insertSpaces);c==="auto"?(S=!0,k.insertSpaces=c):this.j!==c&&(this.j=c,S=!0,k.insertSpaces=c)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,S=!0,k.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,S=!0,k.lineNumbers=P.TextEditorLineNumbersStyle.from(p.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(p,k){k.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(S)})}}e.$xN=E;class R{constructor(p,k,S,c,m,a,i,r){this.id=p,this.j=k,this.k=S,this.g=!1,this.h=new Set,this.c=m,this.d=new E(this.j,this.id,a,S),this.e=i,this.f=r;const n=this;this.value=Object.freeze({get document(){return c.value},set document(o){throw new M.$9("document")},get selection(){return n.c&&n.c[0]},set selection(o){if(!(o instanceof A.$pL))throw(0,M.$7)("selection");n.c=[o],n.l()},get selections(){return n.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof A.$pL)))throw(0,M.$7)("selections");n.c=o,n.l()},get visibleRanges(){return n.e},set visibleRanges(o){throw new M.$9("visibleRanges")},get options(){return n.d.value},set options(o){n.g||n.d.assign(o)},get viewColumn(){return n.f},set viewColumn(o){throw new M.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new $(c.value,t);return o(h),n.m(h)},insertSnippet(o,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n.c.map(f=>P.Range.from(f));else if(t instanceof A.$nL){const{lineNumber:f,column:l}=P.Position.from(t);s=[{startLineNumber:f,startColumn:l,endLineNumber:f,endColumn:l}]}else if(t instanceof A.$oL)s=[P.Range.from(t)];else{s=[];for(const f of t)if(f instanceof A.$oL)s.push(P.Range.from(f));else{const{lineNumber:l,column:u}=P.Position.from(f);s.push({startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u})}}return k.$tryInsertSnippet(p,c.value.version,o.value,s,h)},setDecorations(o,t){const h=t.length===0;h&&!n.h.has(o.key)||(h?n.h.delete(o.key):n.h.add(o.key),n.n(()=>{if(P.$mN(t))return k.$trySetDecorations(p,o.key,P.$nN(t));{const s=new Array(4*t.length);for(let f=0,l=t.length;f<l;f++){const u=t[f];s[4*f]=u.start.line+1,s[4*f+1]=u.start.character+1,s[4*f+2]=u.end.line+1,s[4*f+3]=u.end.character+1}return k.$trySetDecorationsFast(p,o.key,s)}}))},revealRange(o,t){n.n(()=>k.$tryRevealRange(p,P.Range.from(o),t||A.TextEditorRevealType.Default))},show(o){k.$tryShowEditor(p,P.ViewColumn.from(o))},hide(){k.$tryHideEditor(p)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,D.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,D.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,D.ok)(!this.g),this.f=p}_acceptSelections(p){(0,D.ok)(!this.g),this.c=p}async l(){const p=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const k=p.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const S=k.edits.map(m=>m.range);S.sort((m,a)=>m.end.line===a.end.line?m.end.character===a.end.character?m.start.line===a.start.line?m.start.character-a.start.character:m.start.line-a.start.line:m.end.character-a.end.character:m.end.line-a.end.line);for(let m=0,a=S.length-1;m<a;m++){const i=S[m].end;if(S[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=k.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,c,{setEndOfLine:typeof k.setEndOfLine=="number"?P.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$yN=R}),define(ke[73],Se([1,0,61,4,3,2,5,6,148,20,151,16,12,28,15,53,43]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=void 0;class a{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,o){this.h=n,this.i=o,this.a=null,this.b=new Map,this.c=new k.$Ac,this.d=new M.$Wd,this.e=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const o=[],t=[],h=[];if(n.removedDocuments)for(const s of n.removedDocuments){const f=P.URI.revive(s),l=this.c.get(f);l?.unref()&&(this.c.delete(f),o.push(l.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const f=P.URI.revive(s.uri);let l=this.c.get(f);if(l&&f.scheme!==S.Schemas.vscodeNotebookCell&&f.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);l||(l=new a(new $.$sN(this.h.getProxy(w.$kL.MainThreadDocuments),f,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(f,l),t.push(l.value)),l.ref()}if(n.removedEditors)for(const s of n.removedEditors){const f=this.b.get(s);this.b.delete(s),f&&h.push(f)}if(n.addedEditors)for(const s of n.addedEditors){const f=P.URI.revive(s.documentUri);D.ok(this.c.has(f),`document '${f}' does not exist`),D.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const l=this.c.get(f).value,u=new R.$yN(s.id,this.h.getProxy(w.$kL.MainThreadTextEditors),this.i,new m.$V(()=>l.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(v=>C.Range.to(v)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,u)}n.newActiveEditor!==void 0&&(D.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,d.$Oc)(o),(0,d.$Oc)(h),n.removedDocuments&&this.e.fire(o),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return c.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const o=this.b.get(this.a);return n?o:o?.value}allEditors(){return[...this.b.values()]}};e.$zN=i,e.$zN=i=Ge([Ve(0,E.$pN),Ve(1,p.$pj)],i),e.$AN=(0,A.$8h)("IExtHostDocumentsAndEditors")}),define(ke[346],Se([1,0,19,4,6,151,16,7]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class ${constructor(R,C){this.i=C,this.a=new M.$Wd,this.b=new M.$Wd,this.c=new M.$Wd,this.d=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(d.$kL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const C=this.i.allEditors();return R?C:C.map(p=>p.value)}async showTextDocument(R,C,p){let k;typeof C=="number"?k={position:A.ViewColumn.from(C),preserveFocus:p}:typeof C=="object"?k={position:A.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?A.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:k={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(R.uri,k),c=S&&this.i.getEditor(S);if(c)return c.value;throw S?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,C){return new P.$wN(this.h,R,C).value}$acceptEditorPropertiesChanged(R,C){const p=this.i.getEditor(R);if(!p)throw new Error("unknown text editor");if(C.options&&p._acceptOptions(C.options),C.selections){const k=C.selections.selections.map(A.Selection.to);p._acceptSelections(k)}if(C.visibleRanges){const k=D.$Hb(C.visibleRanges.map(A.Range.to));p._acceptVisibleRanges(k)}if(C.options&&this.b.fire({textEditor:p.value,options:{...C.options,lineNumbers:A.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const k=w.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(A.Selection.to);this.a.fire({textEditor:p.value,selections:S,kind:k})}if(C.visibleRanges){const k=D.$Hb(C.visibleRanges.map(A.Range.to));this.c.fire({textEditor:p.value,visibleRanges:k})}}$acceptEditorPositionData(R){for(const C in R){const p=this.i.getEditor(C);if(!p)throw new Error("Unknown text editor");const k=A.ViewColumn.to(R[C]);p.value.viewColumn!==k&&(p._acceptViewColumn(k),this.d.fire({textEditor:p.value,viewColumn:k}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$igc=$}),define(ke[347],Se([1,0,2,5,6,3,7,16,25,18]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=e.$1hc=void 0,e.$1hc=(0,M.$8h)("IExtHostTimeline");class R{constructor(k,S){this.b=new Map,this.c=new Map,this.a=k.getProxy(d.$kL.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(c,m)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&$.$nm.equals(m,this.b.get(c.source)?.extension)){const a=c.uri===void 0?void 0:D.URI.revive(c.uri);return this.c.get(c.source)?.get(C(a))?.get(c.handle)}else return;return c}})}async $getTimeline(k,S,c,m){return this.b.get(k)?.provider.provideTimeline(D.URI.revive(S),c,m)}registerTimelineProvider(k,S,c,m){const a=new P.$Sc,i=this.d(S.id,m,a).bind(this);let r;S.onDidChange&&(r=S.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:S.id}),this));const n=this.c;return this.f({...S,scheme:k,onDidChange:void 0,async provideTimeline(o,t,h){t?.resetCache&&(a.clear(),n.get(S.id)?.clear());const s=await S.provideTimeline(o,t,h);if(s==null)return;const f=i(o,t);return{...s,source:S.id,items:s.items.map(f)}},dispose(){for(const o of n.values())o.get(S.id)?.clear();r?.dispose(),a.dispose()}},c)}d(k,S,c){return(m,a)=>{let i;if(a?.cacheResults){let r=this.c.get(k);r===void 0&&(r=new Map,this.c.set(k,r));const n=C(m);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...o}=r,t=`${k}|${r.id??r.timestamp}`;i?.set(t,r);let h,s,f;r.iconPath&&(n instanceof A.$hM?f={id:n.id,color:n.color}:D.URI.isUri(n)?(h=n,s=n):{light:h,dark:s}=n);let l;return A.$NL.isMarkdownString(o.tooltip)?l=w.MarkdownString.from(o.tooltip):(0,E.$Jf)(o.tooltip)?l=o.tooltip:A.$NL.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=w.MarkdownString.from(o.detail)):(0,E.$Jf)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=o.detail),{...o,id:o.id??void 0,handle:t,source:k,command:r.command?S.toInternal(r.command,c):void 0,icon:h,iconDark:s,themeIcon:f,tooltip:l,accessibilityInformation:r.accessibilityInformation}}}}f(k,S){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:S}),(0,P.$Rc)(()=>{for(const m of this.c.values())m.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$2hc=R;function C(p){return p?.toString()}}),define(ke[348],Se([1,0,219,23,2,4,3,278,8,7,18,19,16,63,22,177,26]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;function a(n,o){if((0,R.$Jf)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends A.$Tc{constructor(o,t,h){super(),this.f=o,this.g=t,this.h=h,this.a=new Map,this.b=new c.$F8;function s(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:f=>s(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(l=>s(l)?this.r(l):l):f})}registerTreeDataProvider(o,t,h){const s=this.createTreeView(o,{treeDataProvider:t},h);return{dispose:()=>s.dispose()}}createTreeView(o,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],f=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,v=this.m(o,t,h),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:f,hasHandleDrag:l,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(o,I),g={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,m.$LF)(h,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,m.$LF)(h,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(y){(0,k.$lk)(y)&&(0,m.$LF)(h,"treeViewMarkdownMessage"),v.message=y},get title(){return v.title},set title(y){v.title=y},get description(){return v.description},set description(y){v.description=y},get badge(){return v.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?v.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(v.badge=void 0)},reveal:(y,L)=>v.reveal(y,L),dispose:async()=>{await b,this.a.delete(o),v.dispose()}};return this.B(g),g}$getChildren(o,t){const h=this.a.get(o);return h?h.getChildren(t):Promise.reject(new w.$eF(o))}async $handleDrop(o,t,h,s,f,l,u,v){const I=this.a.get(o);if(!I)return Promise.reject(new w.$eF(o));const b=p.DataTransfer.toDataTransfer(h,async g=>(await this.f.$resolveDropFileData(o,t,g)).buffer);return u===o&&v&&await this.j(b,I,v,f,l),I.onDrop(b,s,f)}async j(o,t,h,s,f){const l=this.b.removeDragOperationTransfer(f);if(l)(await l)?.forEach((u,v)=>{u&&o.set(v,u)});else if(f&&t.handleDrag){const u=t.handleDrag(h,o,s);this.b.addDragOperationTransfer(f,u),await u}return o}async $handleDrag(o,t,h,s){const f=this.a.get(o);if(!f)return Promise.reject(new w.$eF(o));const l=await this.j(new E.$eM,f,t,s,h);if(!(!l||s.isCancellationRequested))return p.DataTransfer.from(l)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new w.$eF(o);return t.hasResolve}$resolve(o,t,h){const s=this.a.get(o);if(!s)throw new w.$eF(o);return s.resolveTreeItem(t,h)}$setExpanded(o,t,h){const s=this.a.get(o);if(!s)throw new w.$eF(o);s.setExpanded(t,h)}$setSelectionAndFocus(o,t,h){const s=this.a.get(o);if(!s)throw new w.$eF(o);s.setSelectionAndFocus(t,h)}$setVisible(o,t){const h=this.a.get(o);if(!h){if(!t)return;throw new w.$eF(o)}h.setVisible(t)}$changeCheckboxState(o,t){const h=this.a.get(o);if(!h)throw new w.$eF(o);h.setCheckboxState(t)}m(o,t,h){const s=this.B(new r(o,t,this.f,this.g.converter,this.h,h));return this.a.set(o,s),s}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$3hc=i;class r extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,R.$Sf)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,h,s,f,l){if(super(),this.I=o,this.J=h,this.L=s,this.M=f,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$7d,l.contributes&&l.contributes.views)for(const b in l.contributes.views)for(const g of l.contributes.views[b])g.id===o&&(this.P=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let u,v;const I=P.Event.debounce(this.F.event,(b,g)=>(b||(b={message:!1,elements:[]}),g.element!==!1&&(u||(u=new Promise(y=>v=y),this.G=this.G.then(()=>u)),Array.isArray(g.element)?b.elements.push(...g.element):b.elements.push(g.element)),g.message&&(b.message=!0),b),200,!0);this.B(I(({message:b,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const y=v;return u=null,this.$(g).then(()=>y())})),b&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let h=this.X(o);return h||(h=await this.Y(t)),h?h.map(s=>s.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const h=(0,R.$Sf)(t.select)?!0:t.select,s=(0,R.$Sf)(t.focus)?!1:t.focus,f=(0,R.$Sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(l=>this.W(o,l[l.length-1]).then(u=>this.J.$reveal(this.I,{item:u.item,parentChain:l.map(v=>v.item)},{select:h,focus:s,expand:f})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:h,focus:s,expand:f})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=p.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const h=this.getExtensionElement(o);h&&(t?this.u.fire(Object.freeze({element:h})):this.w.fire(Object.freeze({element:h})))}setSelectionAndFocus(o,t){const h=!(0,C.$ub)(this.s,o);this.s=o;const s=this.t!==t;this.t=t,h&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async h=>{const s=this.getExtensionElement(h.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:h.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(o,t,h){const s=[];for(const f of o){const l=this.getExtensionElement(f);l&&s.push(l)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,h),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,h){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(s,o,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const h=this.j.get(o);if(h){const s=this.m.get(h);if(s){const f=await this.f.resolveTreeItem(s.extensionItem,h,t)??s.extensionItem;return this.hb(f),s.item.tooltip=this.eb(f.tooltip),s.item.command=this.fb(s.disposableStore,f.command),s.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(h=>this.W(t,h[h.length-1]).then(s=>(h.push(s),h))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Zg)(()=>this.f.getParent(o))}W(o,t){const h=this.m.get(o);return h?Promise.resolve(h):(0,$.$Zg)(()=>this.f.getTreeItem(o)).then(s=>this.kb(o,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const f=this.getExtensionElement(s);if(f){const l=this.m.get(f);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const h=this.getExtensionElement(o);t=h?this.m.get(h):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new S.$7d(this.Z.token);try{const h=o?this.m.get(o):void 0,s=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const f=(0,C.$Hb)(s||[]),l=await Promise.all((0,C.$Hb)(f).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const u=l.map((v,I)=>v?this.db(f[I],v,h):null);return(0,C.$Hb)(u)}finally{t.dispose()}}$(o){if(o.some(h=>!h))return this.Z.dispose(!0),this.Z=new S.$7d,this.tb(),this.J.$refresh(this.I);{const h=this.ab(o);if(h.length)return this.bb(h)}return Promise.resolve(void 0)}ab(o){const t=new Set,h=o.map(f=>this.m.get(f));for(const f of h)if(f&&!t.has(f.item.handle)){let l=f;for(;l&&l.parent&&h.findIndex(u=>l&&l.parent&&u&&u.item.handle===l.parent.item.handle)===-1;){const u=this.j.get(l.parent.item.handle);l=u?this.m.get(u):void 0}l&&!l.parent&&t.add(f.item.handle)}const s=[];return t.forEach(f=>{const l=this.j.get(f);if(l){const u=this.m.get(l);u&&(!u.parent||!t.has(u.parent.item.handle))&&s.push(f)}}),s}bb(o){const t={};return Promise.all(o.map(h=>this.cb(h).then(s=>{s&&(t[h]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const h=this.m.get(t);if(h)return this.rb(t),(0,$.$Zg)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const f=this.ib(t,s,h.parent);return this.pb(t,f,h,h.parent),h.dispose(),f}return null})}return Promise.resolve(null)}db(o,t,h){const s=this.ib(o,t,h);if(t.id&&this.j.has(s.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(o,s),this.qb(s,h),s}eb(o){return E.$NL.isMarkdownString(o)?p.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,h,s;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,h=o.checkboxState.tooltip,s=o.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:h,accessibilityInformation:s}}hb(o){if(!E.$_L.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,h){this.hb(t);const s=this.B(new A.$Sc),f=this.kb(o,t,h),l=this.lb(t);return{item:{handle:f,parentHandle:h?h.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,R.$Sf)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:h,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(o){return o.iconPath instanceof E.$hM?o.iconPath:void 0}kb(o,{id:t,label:h,resourceUri:s},f,l){if(t)return`${r.b}/${t}`;const u=a(h,this.N),v=f?f.item.handle:r.a;let I=u?u.label:s?(0,M.$Fg)(s):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const b=this.m.has(o)?this.m.get(o).item.handle:void 0,g=this.X(f)||[];let y,L=0;do{if(y=`${v}/${L}:${I}`,l||!this.j.has(y)||b===y)break;L++}while(L<=g.length);return y}lb(o){if(o.iconPath&&!(o.iconPath instanceof E.$hM))return typeof o.iconPath=="string"||d.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof E.$hM)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return d.URI.isUri(o)?o:d.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,h,s){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==h.item.handle&&this.j.delete(h.item.handle),this.ob(o,t);const f=this.X(s)||[],l=f.filter(u=>u.item.handle===h.item.handle)[0];l&&f.splice(f.indexOf(l),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[349],Se([1,0,4,3,2,30,16,92,6,7]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class R extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(S,c,m,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Wd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Wd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=c,this.#n=m,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,d.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#o=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:A.ViewColumn.from(S),preserveFocus:!!c})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends M.$Tc{static c(){return(0,P.$rg)()}constructor(S,c,m){super(),this.j=c,this.m=m,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$kL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,c,m,a,i={}){const r=typeof a=="object"?a.viewColumn:a,n={viewColumn:A.ViewColumn.from(r),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,w.$xgc)(S),t=C.c();this.f.$createWebviewPanel((0,w.$zgc)(S),t,c,{title:m,panelOptions:p(i),webviewOptions:(0,w.$Agc)(S,this.m,i),serializeBuffersForPostMessage:o},n);const h=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,c,m,r,i,h,!0)}$onDidChangeWebviewPanelViewStates(S){const c=Object.keys(S);c.sort((m,a)=>{const i=S[m],r=S[a];return i.active?1:r.active?-1:+i.visible-+r.visible});for(const m of c){const a=this.getWebviewPanel(m);if(!a)continue;const i=S[m];a._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,c,m){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:m,extension:S}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,w.$xgc)(S)}),new E.$mL(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(S,c,m,a){const i=this.h.get(c);if(!i)throw new Error(`No serializer found for '${c}'`);const{serializer:r,extension:n}=i,o=this.j.createNewWebview(S,m.webviewOptions,n),t=this.createNewWebviewPanel(S,c,m.title,a,m.panelOptions,o,m.active);await r.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(S,c,m,a,i,r,n){const o=new R(S,this.f,r,{viewType:c,title:m,viewColumn:a,panelOptions:i,active:n});return this.g.set(S,o),o}getWebviewPanel(S){return this.g.get(S)}}e.$Bgc=C;function p(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(ke[350],Se([1,0,4,3,92,16,6,7]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class $ extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,p,k,S,c,m){super(),this.#s=!1,this.#u=this.B(new D.$Wd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Wd),this.onDidDispose=this.#l.event,this.#i=k,this.#a=S,this.#e=C,this.#t=p,this.#n=c,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(C,p){this.d=p,this.b=new Map,this.c=new Map,this.a=C.getProxy(A.$kL.MainThreadWebviewViews)}registerWebviewViewProvider(C,p,k,S){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:k,extension:C}),this.a.$registerWebviewViewProvider((0,d.$zgc)(C),p,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.$xgc)(C)}),new w.$mL(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(C,p,k,S,c){const m=this.b.get(p);if(!m)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:i}=m,r=this.d.createNewWebview(C,{},i),n=new $(C,this.a,p,k,r,!0);this.c.set(C,n),await a.resolveWebviewView(n,{state:S},c)}async $onDidChangeWebviewViewVisibility(C,p){this.e(C)._setVisible(p)}async $disposeWebviewView(C){const p=this.e(C);this.c.delete(C),p.dispose(),this.d.deleteWebview(C)}e(C){const p=this.c.get(C);if(!p)throw new Error("No webview found");return p}}e.$6hc=E}),define(ke[351],Se([1,0,70,15,12,249,32,11]),function($e,e,D,M,d,P,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;let $=class{constructor(C,p){C.addFileSystemProvider(M.Schemas.file,new E(p),{isCaseSensitive:w.$k})}};e.$Kic=$,e.$Kic=$=Ge([Ve(0,D.$tgc),Ve(1,d.$pj)],$);class E{constructor(C){this.b=C,this.a=new P.$Dq(this.b)}async stat(C){const p=await this.a.stat(C);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,p,k){return this.a.writeFile(C,p,{...k,unlock:!1,atomic:!1})}delete(C,p){return this.a.delete(C,{...p,useTrash:!1,atomic:!1})}rename(C,p,k){return this.a.rename(C,p,k)}copy(C,p,k){return this.a.copy(C,p,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,p){throw new Error("Method not implemented.")}}}),define(ke[352],Se([1,0,17,64,30,33,3,6,2,20]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;let R=class extends A.$Tc{constructor(p,k){super();const S=p.getProxy(w.$kL.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async c=>{const m=$.URI.file((0,D.$jc)((0,M.tmpdir)(),(0,d.$rg)()));return await S.$download(c,m),m})}};e.$Iic=R,e.$Iic=R=Ge([Ve(0,E.$pN),Ve(1,P.$LN)],R)}),define(ke[353],Se([1,0,57,17,2,93,3,15,8,31]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;class R extends P.$vgc{constructor(){super(...arguments),this.i=null}async g(t){const h=await super.g(t);if(h.scheme!==w.Schemas.file)return h;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const s=h.fsPath;let f=0;do{let l;f===0?l=s:l=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${f}`:`${s}-${f}`,await C(l);const u=M.$jc(l,"vscode.lock"),v=await c(this.d,u,!1);if(v)return this.i=v,process.on("exit",()=>{v.dispose()}),d.URI.file(l);f++}while(f<10);return h}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Uic=R;async function C(o){try{await E.Promises.stat(o);return}catch{}try{await E.Promises.mkdir(o,{recursive:!0})}catch{}}const p=1e3,k=10*60*1e3;class S extends A.$Tc{constructor(t,h){super(),this.b=t,this.c=h,this.a=this.B(new $.$gh),this.a.cancelAndSet(async()=>{const s=await m(t,h);(!s||s.pid!==process.pid)&&(t.info(`Lock '${h}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(h,new Date,new Date)}catch(f){t.error(f),t.info(`Lock '${h}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(h),{flag:"w"})}catch(h){this.b.error(h)}}}async function c(o,t,h){try{const f={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(f),{flag:"wx"})}catch(f){o.error(f)}const s=await m(o,t);return!s||s.pid!==process.pid?h?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new S(o,t))}async function m(o,t){let h;try{h=await E.Promises.readFile(t)}catch(s){return o.error(s),null}try{return JSON.parse(String(h))}catch(s){return o.error(s),null}}async function a(o,t){let h;try{h=await E.Promises.stat(t)}catch(s){return o.error(s),0}return h.mtime.getTime()}function i(o){try{return process.kill(o,0),!0}catch{return!1}}async function r(o,t){const h=await m(o,t);if(!h)return o.info(`Lock '${t}': Could not read pid of lock holder.`),n(o,t);if(h.willReleaseAt){let v=h.willReleaseAt-Date.now();if(v<5e3){for(v>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${v} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);v>0;){if(await(0,$.$9g)(Math.min(100,v)),await a(o,t)===0)return n(o,t);v=h.willReleaseAt-Date.now()}return n(o,t)}}if(!i(h.pid))return o.info(`Lock '${t}': The pid ${h.pid} appears to be gone.`),n(o,t);const s=await a(o,t),f=Date.now()-s;if(f<=k)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${f} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$9g)(2e3);const l=await a(o,t),u=Date.now()-l;return u<=k?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(o,t))}async function n(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return c(o,t,!0)}}),define(ke[354],Se([1,0,30,20,46,33]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;let A=class extends d.$Rgc{constructor($,E){super(!0,$,E)}createTerminal($,E,R){return this.createTerminalFromOptions({name:$,shellPath:E,shellArgs:R})}createTerminalFromOptions($,E){const R=new d.$Qgc(this.a,(0,D.$rg)(),$,$.name);return this.f.push(R),R.create($,this.R($,E)),R.value}};e.$dic=A,e.$dic=A=Ge([Ve(0,P.$LN),Ve(1,M.$pN)],A)}),define(ke[355],Se([1,0,4,37,45,5]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.$FK=e.OutputChannelUpdateMode=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=void 0,e.$vK="text/x-code-output",e.$wK="output",e.$xK="Log",e.$yK="text/x-code-log-output",e.$zK="log",e.$AK="workbench.panel.output",e.$BK=new d.$mj("inOutput",!1),e.$CK=new d.$mj("activeLogOutput",!1),e.$DK=new d.$mj("outputView.scrollLock",!1),e.$EK=(0,P.$8h)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$FK={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new D.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(R=>E.push(R)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}M.$Kn.add(e.$FK.OutputChannels,new w),e.$GK=new d.$mj("activeOutputChannel","")}),define(ke[152],Se([1,0,6,5,20,25,12,355,70,27,59,182,21,18,32,4,3]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=void 0;class a extends A.$vj{get disposed(){return this.n}constructor(o,t,h,s,f){super(),this.id=o,this.name=t,this.r=h,this.s=s,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=p.$ke.fromString(t).byteLength,(0,A.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends a{appendLine(o){this.append(o)}}let r=class{constructor(o,t,h,s,f,l){this.i=t,this.j=h,this.k=s,this.l=f,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(D.$kL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,h]of this.g)h.visible=t===this.h}createOutputChannel(o,t,h){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,f=(0,k.$Jf)(t)?t:void 0;if((0,k.$Jf)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const u=this.i.environment.extensionLogLevel?.find(([I])=>P.$nm.equals(h.identifier,I))?.[1];u&&(l=(0,A.$Fj)(u));const v=s?this.o(o,l,h):this.n(o,f,h);return v.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),s?this.r(o,l??this.m.getLevel(),v):this.q(o,v)}async n(o,t,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,f=this.k.extUri.joinPath(s,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.a.$register(o,f,t,h.identifier.value);return new a(u,o,l,this.a,h)}async o(o,t,h){const s=await this.p(h),f=o.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(s,`${f}.log`),u=`${h.identifier.value}.${f}`,v=this.l.createLogger(l,{id:u,name:o,logLevel:t,extensionId:h.identifier.value});return new i(u,o,v,this.a,h)}p(o){let t=this.d.get(o.identifier.value);if(!t){const h=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(h)}catch(s){if((0,S.$Ik)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}return h})())}return t}q(o,t){let h=!1;const s=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return o},append(f){s(),t.then(l=>l.append(f))},appendLine(f){s(),t.then(l=>l.appendLine(f))},clear(){s(),t.then(f=>f.clear())},replace(f){s(),t.then(l=>l.replace(f))},show(f,l){s(),t.then(u=>u.show(f,l))},hide(){s(),t.then(f=>f.hide())},dispose(){h=!0,t.then(f=>f.dispose())}}}r(o,t,h){const s=new m.$Sc,f=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},l=s.add(new c.$Wd);function u(v){t=v,l.fire(v)}return h.then(v=>{s.add(v),v.logLevel!==t&&u(v.logLevel),s.add(v.onDidChangeLogLevel(I=>u(I)))}),{...this.q(o,h),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(v,...I){f(),h.then(b=>b.trace(v,...I))},debug(v,...I){f(),h.then(b=>b.debug(v,...I))},info(v,...I){f(),h.then(b=>b.info(v,...I))},warn(v,...I){f(),h.then(b=>b.warn(v,...I))},error(v,...I){f(),h.then(b=>b.error(v,...I))},dispose(){s.dispose()}}}};e.$Ghc=r,e.$Ghc=r=Ge([Ve(0,d.$pN),Ve(1,E.$FN),Ve(2,$.$tgc),Ve(3,R.$6fc),Ve(4,A.$qj),Ve(5,A.$pj)],r),e.$Hhc=(0,M.$8h)("IExtHostOutputService")}),define(ke[153],Se([1,0,5,8]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=(0,D.$8h)("remoteAgentService"),e.$Pm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let P=1/0;for(let w=0;w<this.maxSampleCount;w++){const $=await d.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,M.$9g)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(P):A=this.initial.reduce((w,$)=>w+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:P,average:this.average.reduce((w,$)=>w+$,0)/this.average.length,high:typeof A>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[356],Se([1,0,223,86,37,40,51,3,4,153,11,24,8]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=void 0,e.$4H=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$5H=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$6H=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$7H=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$8H={ConfigurationMigration:"base.contributions.configuration.migration"};class k{constructor(){this.migrations=[],this.a=new $.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const S=new k;d.$Kn.add(e.$8H.ConfigurationMigration,S);let c=class extends w.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,r){super(),this.a=i,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.f(o,S.migrations)})),this.c(S.migrations),this.B(S.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(i){await this.f(void 0,i);for(const r of this.b.getWorkspace().folders)await this.f(r,i)}async f(i,r){await Promise.all([r.map(n=>this.g(n,i?.uri))])}async g(i,r){const n=this.a.inspect(i.key,{resource:r}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,h]of o){const s=n[t];if(!s)continue;const f=[];if(s.value!==void 0){const l=await this.h(i,t,s.value,r,void 0);for(const u of l??[])f.push([u,[]])}for(const{identifiers:l,value:u}of s.overrides??[])if(u!==void 0){const v=await this.h(i,t,u,r,l);for(const I of v??[])f.push([I,l])}f.length&&await Promise.allSettled(f.map(async([[l,u],v])=>this.a.updateValue(l,u.value,{resource:r,overrideIdentifiers:v},h)))}}async h(i,r,n,o,t){const h=f=>{const u=this.a.inspect(f,{resource:o})[r];if(u)return t?u.overrides?.find(({identifiers:v})=>(0,C.$Cn)(v,t))?.value:u.value},s=await i.migrateFn(n,h);return Array.isArray(s)?s:[[i.key,s]]}};e.$9H=c,e.$9H=c=Ge([Ve(0,A.$Bi),Ve(1,P.$ei)],c);let m=class extends w.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new p.$sh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==1)return;d.$Kn.as(M.$Pn.Configuration).registerConfiguration({...e.$6H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})}};e.$0H=m,e.$0H=m=Ge([Ve(0,E.$Om)],m)}),define(ke[357],Se([1,0,35,15,17,23,232,356,86,5,37]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdb=e.$Gdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Fdb=e.$Edb=void 0,e.$Edb=(0,E.$8h)("editorResolverService"),e.$Fdb="workbench.editorAssociations";const C=R.$Kn.as($.$Pn.Configuration),p={...w.$5H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(p);var k;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(k||(e.RegisteredEditorPriority=k={}));var S;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function c(a){switch(a){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}e.$Gdb=c;function m(a,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const o=typeof a=="string"&&a.indexOf(d.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,P.$Fg)(i);return D.$Nj(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}e.$Hdb=m}),define(ke[358],Se([1,0,34,15,17,11,23,2,5,267,40,143,153]),function($e,e,D,M,d,P,A,w,$,E,R,C,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$YK=void 0,e.$YK=(0,$.$8h)("pathService");let S=k=class{constructor(m,a,i,r){this.d=m,this.e=a,this.f=i,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??m})()}hasValidBasename(m,a,i){return typeof a=="string"||typeof a>"u"?this.a.then(r=>this.h(m,r,a)):this.h(m,a,i)}h(m,a,i){return m.scheme===M.Schemas.file||m.scheme===M.Schemas.vscodeRemote?(0,D.$7f)(i??(0,A.$Fg)(m),a===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,a){if(m.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,E.$VK)(a.getWorkspace());if(i)return i;const r=a.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=a.getWorkspace().configuration;return n?n.scheme:M.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?d.$fc:d.$gc)}async fileURI(m){let a="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const r=m.indexOf("/",2);r===-1?(a=m.substring(2),m="/"):(a=m.substring(2,r),m=m.substring(r)||"/")}return w.URI.from({scheme:M.Schemas.file,authority:a,path:m,query:"",fragment:""})}};e.$ZK=S,e.$ZK=S=k=Ge([Ve(1,p.$Om),Ve(2,C.$HK),Ve(3,R.$ei)],S)}),define(ke[359],Se([1,0,234,19,52,4,54,3,2,51,239,12,65,269,88,40,143,26,22,18,24,45]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SK=e.$RK=e.$QK=e.OnPortForward=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.TunnelSource=e.TunnelCloseReason=e.$KK=e.$JK=e.$IK=void 0;const t=10*1e3,h="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",f=1e3*60*60*24*14;e.$IK="onTunnel",e.$JK=new o.$mj("forwardedPortsViewEnabled",!1,D.localize(0,null));function l(j){const F=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}e.$KK=l;var u;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var v;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(v||(e.TunnelSource=v={})),e.$LK={source:v.User,description:D.localize(1,null)},e.$MK={source:v.Auto,description:D.localize(2,null)};function I(j,F,N){const O=j.get(g(F,N));if(O)return O;if((0,S.$Hv)(F))for(const z of S.$Gv){const K=g(z,N);if(j.has(K))return j.get(K)}else if((0,S.$Jv)(F))for(const z of S.$Iv){const K=g(z,N);if(j.has(K))return j.get(K)}}e.$NK=I;function b(j,F,N){const O=I(j,F,N);if(O)return O;const z=(0,S.$Jv)(F)?"localhost":(0,S.$Hv)(F)?"0.0.0.0":void 0;if(z)return I(j,z,N)}e.$OK=b;function g(j,F){return j+":"+F}e.$PK=g;var y;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(y||(e.OnPortForward=y={}));function L(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}e.$QK=L;class T extends w.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new P.$Wd,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(N=>{(N.affectsConfiguration(T.c)||N.affectsConfiguration(T.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,N,O){let z=this.w(F,N,O,this.j,0);const K={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const te=this.j[z];te.key===F?(K.onAutoForward=te.onAutoForward??K.onAutoForward,K.elevateIfNeeded=te.elevateIfNeeded!==void 0?te.elevateIfNeeded:K.elevateIfNeeded,K.label=te.label??K.label,K.requireLocalPort=te.requireLocalPort,K.protocol=te.protocol):(K.onAutoForward=K.onAutoForward??te.onAutoForward,K.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:te.elevateIfNeeded,K.label=K.label??te.label,K.requireLocalPort=K.requireLocalPort!==void 0?K.requireLocalPort:void 0,K.protocol=K.protocol??te.protocol),z=this.w(F,N,O,this.j,z+1)}return K.onAutoForward!==void 0||K.elevateIfNeeded!==void 0||K.label!==void 0||K.requireLocalPort!==void 0||K.protocol!==void 0?K:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,r.$Jf)(F.host)&&(0,r.$Nf)(F.port)}w(F,N,O,z,K){if(K>=z.length)return-1;const te=!(0,S.$Hv)(N)&&!(0,S.$Jv)(N),X=z.slice(K).findIndex(Z=>(0,r.$Nf)(Z.key)?te?!1:Z.key===F:this.t(Z.key)?te?!1:F>=Z.key.start&&F<=Z.key.end:this.u(Z.key)?F===Z.key.port&&N===Z.key.host:O?Z.key.test(O):!1);return X>=0?X+K:-1}y(){const F=this.r.getValue(T.c);if(!F||!(0,r.$Lf)(F))return[];const N=[];for(const z in F){if(z===void 0)continue;const K=F[z];let te;if(Number(z))te=Number(z);else if((0,r.$Jf)(z))if(T.g.test(z)){const x=z.match(T.g);te={start:Number(x[1]),end:Number(x[2])}}else if(T.h.test(z)){const x=z.match(T.h);te={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(z)}catch{}x&&(te=x)}te&&N.push({key:te,elevateIfNeeded:K.elevateIfNeeded,onAutoForward:K.onAutoForward,label:K.label,requireLocalPort:K.requireLocalPort,protocol:K.protocol})}const O=this.r.getValue(T.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(N)}z(F){function N(O,z){return(0,r.$Nf)(O.key)?O.key:z.t(O.key)?O.key.start:z.u(O.key)?O.key.port:Number.MAX_VALUE}return F.sort((O,z)=>N(O,this)-N(z,this))}C(){return this.m}static providedActionToAction(F){switch(F){case S.ProvidedOnAutoForward.Notify:return y.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case S.ProvidedOnAutoForward.Silent:return y.Silent;case S.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(F,N,O){const K=this.r.inspect(T.c).userRemoteValue;let te;!K||!(0,r.$Lf)(K)?te={}:te=(0,n.$yn)(K),te[`${F}`]||(te[`${F}`]={});for(const x in N)te[`${F}`][x]=N[x];return this.r.updateValue(T.c,te,O)}}e.$RK=T;let U=class extends w.$Tc{constructor(F,N,O,z,K,te,x,X,Z,ce){super(),this.H=F,this.I=N,this.J=O,this.L=z,this.M=K,this.N=te,this.O=x,this.P=X,this.Q=Z,this.R=ce,this.c=new Map,this.g=new P.$Wd,this.onForwardPort=this.g.event,this.h=new P.$Wd,this.onClosePort=this.h.event,this.j=new P.$Wd,this.onPortName=this.j.event,this.n=new P.$Wd,this.onCandidatesChanged=this.n.event,this.t=new P.$Wd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$Wd,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new T(O),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ge=await this.getAttributes(_.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of _)if(ne.localAddress){const J=g(ne.tunnelRemoteHost,ne.tunnelRemotePort),W=b(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(J,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ge?.get(ne.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ge?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:W?.detail,hasRunningProcess:!!W,pid:W?.pid,privacy:ne.privacy,source:e.$LK}),this.f.set(J,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ge=g(_.tunnelRemoteHost,_.tunnelRemotePort);if(!b(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!b(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!b(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const ne=b(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),J=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ge,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:J?.protocol??S.TunnelProtocol.Http,localUri:await this.X(_.localAddress,J),localPort:_.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:_.privacy,source:e.$LK})}await this.cb(),this.f.set(ge,_),this.g.fire(this.forwarded.get(ge))})),this.B(this.H.onTunnelClosed(_=>this.W(_,u.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$IK))?(this.R.createKey(e.$JK.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,N){const O=g(F.host,F.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.cb(),this.h.fire(F))}X(F,N){if(F.startsWith("http"))return $.URI.parse(F);const O=N?.protocol??"http";return $.URI.parse(`${O}://${F}`)}async Y(F){const N=this.N.getWorkspace(),O=N.configuration?(0,A.$Vi)(N.configuration.path):N.folders.length>0?(0,A.$Vi)(N.folders[0].uri.path):void 0;if(O===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.L.remoteAuthority}.${O}`}async Z(){return this.Y(h)}async $(){return this.Y(s)}async ab(){const F=this.I.get(h,1);if(F)return this.I.remove(h,1),await this.cb(),F;const N=await this.Z();if(N)return this.I.get(N,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const N=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(O=>O.remotePort).join(", ")}`);for(const O of N){const z=b(this.detected,O.remoteHost,O.remotePort);O.source.source!==v.Extension&&!z||O.source.source===v.Extension&&z?await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,elevateIfNeeded:!0,source:O.source}):O.source.source===v.Extension&&!z&&this.D.set(g(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Z();this.w=this.B(new w.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async N=>{N.key===F&&(this.s=Promise.resolve(this.I.get(F,0)),await this.restoreForwarded())}))}}bb(){const F=this.I.keys(0,0).filter(N=>N.startsWith(s));for(const N of F){const O=this.I.getNumber(N,0);if(O&&O<Date.now()){this.s=Promise.resolve(void 0);const z=N.replace(s,h);this.I.remove(N,0),this.I.remove(z,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),N=F.map(te=>({remoteHost:te.remoteHost,remotePort:te.remotePort,localPort:te.localPort,name:te.name,localAddress:te.localAddress,localUri:te.localUri,protocol:te.protocol,source:te.source}));let O;F.length>0&&(O=JSON.stringify(N));const z=await this.Z(),K=await this.$();!O&&z&&K?(this.I.remove(z,0),this.I.remove(K,0)):O!==this.y&&z&&K&&(this.I.store(z,O,0,0),this.I.store(K,Date.now()+f,0,0)),this.y=O}}async eb(F,N,O){if(!F.tunnelLocalPort||!O?.requireLocalPort||F.tunnelLocalPort===N)return;const z=new Date;if(this.db.getTime()+t>z.getTime())return;this.db=z;const K=D.localize(3,null,N,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(K)}async forward(F,N){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(F,N)}async fb(F,N){await this.Q.activateByEvent(e.$IK);const O=b(this.forwarded,F.remote.host,F.remote.port);N=N??(N!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const z=F.local!==void 0?F.local:F.remote.port;let K;if(O)return this.hb(O,F,N);{const te=this.L.remoteAuthority,x=te?{getAddress:async()=>(await this.M.resolveAuthority(te)).authority}:void 0,X=g(F.remote.host,F.remote.port);this.c.set(X,!0),F=this.gb(X,F);const Z=await this.H.openTunnel(x,F.remote.host,F.remote.port,void 0,z,F.elevateIfNeeded?F.elevateIfNeeded:N?.elevateIfNeeded,F.privacy,N?.protocol);if(typeof Z=="string")K=Z;else if(Z&&Z.localAddress){const ce=b(this.m??new Map,F.remote.host,F.remote.port),_=Z.protocol?Z.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:N?.protocol??S.TunnelProtocol.Http,ge={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:N?.label??F.name,closeable:!0,localAddress:Z.localAddress,protocol:_,localUri:await this.X(Z.localAddress,N),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:F.source??e.$LK,privacy:Z.privacy};return this.forwarded.set(X,ge),this.f.set(X,Z),this.c.delete(X),await this.cb(),await this.eb(Z,z,N),this.g.fire(ge),Z}this.c.delete(X)}return K}gb(F,N){const O=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(O){const z=O.get(F);O.delete(F),z&&(N.name=z.name??N.name,N.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??N.local,N.privacy=N.privacy)}return N}async hb(F,N,O){const z=O?.label??N.name;let K;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(K||(K={}));let te=K.None;switch(z!==F.name&&(F.name=z,te=K.Fire),(O?.protocol||F.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==F.protocol&&(N.source=F.source,te=K.Reopen),N.privacy&&F.privacy!==N.privacy&&(te=K.Reopen),te){case K.Fire:{this.g.fire();break}case K.Reopen:await this.close(F.remoteHost,F.remotePort,u.User),await this.fb(N,O)}return b(this.f,N.remote.host,N.remote.port)}async name(F,N,O){const z=b(this.forwarded,F,N),K=g(F,N);if(z){z.name=O,await this.cb(),this.j.fire({host:F,port:N});return}else this.detected.has(K)&&(this.detected.get(K).name=O,this.j.fire({host:F,port:N}))}async close(F,N,O){const z=g(F,N),K=this.forwarded.get(z);return O===u.AutoForwardEnd&&K&&K.source.source===v.Auto&&this.F.set(z,{local:K.localPort,name:K.name,privacy:K.privacy}),await this.H.closeTunnel(F,N),this.W({host:F,port:N},O)}address(F,N){const O=g(F,N);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const N of F){const O=b(this.m??new Map,N.remoteAddress.host,N.remoteAddress.port),z=typeof N.localAddress=="string"?N.localAddress:g(N.localAddress.host,N.localAddress.port);this.detected.set(g(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:z,protocol:S.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:v.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,z,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let N=F;this.r&&(N=await this.r(F));const O=this.ib(N);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(z=>z.port).join(", ")}`),this.n.fire(O)}ib(F){const N=this.m??new Map,O=new Map;return this.m=O,F.forEach(z=>{const K=g(z.host,z.port);O.set(K,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),N.has(K)&&N.delete(K);const te=b(this.forwarded,z.host,z.port);te&&(te.runningProcess=z.detail,te.hasRunningProcess=!0,te.pid=z.pid)}),N.forEach((z,K)=>{const te=l(K);if(!te)return;const x=b(this.forwarded,te.host,te.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const X=b(this.detected,te.host,te.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0)}),N}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const F=Array.from(this.forwarded.values()),N=await this.getAttributes(F.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(N)for(const O of F){const z=N.get(O.remotePort);(z?.protocol||O.protocol!==S.TunnelProtocol.Http)&&z?.protocol!==O.protocol&&await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},z),z&&z.label&&z.label!==O.name&&await this.name(O.remoteHost,O.remotePort,z.label)}}async getAttributes(F,N=!0){const O=new Map,z=new Map;F.forEach(Z=>{const ce=b(this.m??new Map,S.$Gv[0],Z.port)??Z;if(ce){O.set(Z.port,ce);const _=L(ce)?ce.pid:void 0;z.has(_)||z.set(_,[]),z.get(_)?.push(Z.port)}});const K=new Map;if(F.forEach(Z=>{const ce=this.configPortsAttributes.getAttributes(Z.port,Z.host,O.get(Z.port)?.detail);ce&&K.set(Z.port,ce)}),this.G.length===0||!N)return K.size>0?K:void 0;const te=await Promise.all((0,M.$Rb)(this.G.map(Z=>Array.from(z.entries()).map(ce=>{const _=ce[1],ge=O.get(_[0]);return Z.providePortAttributes(_,ge?.pid,ge?.detail,new i.$7d().token)})))),x=new Map;if(te.forEach(Z=>Z.forEach(ce=>{ce&&x.set(ce.port,ce)})),!K&&!x)return;const X=new Map;return F.forEach(Z=>{const ce=K.get(Z.port),_=x.get(Z.port);X.set(Z.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??T.providedActionToAction(_?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),X}addAttributesProvider(F){this.G.push(F)}};e.$SK=U,Ge([(0,d.$Ah)(1e3)],U.prototype,"cb",null),e.$SK=U=Ge([Ve(0,S.$Cv),Ve(1,k.$wp),Ve(2,E.$Bi),Ve(3,m.$HK),Ve(4,p.$0k),Ve(5,c.$ei),Ve(6,C.$pj),Ve(7,R.$8v),Ve(8,a.$HF),Ve(9,o.$nj)],U)}),define(ke[94],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$AJ=e.$zJ=void 0;class D{constructor(A,w){this.line=A,this.character=w}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,w){return new D(0,0)}with(A){return new D(0,0)}}e.$zJ=D;class M{constructor(A,w,$,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(A,w),this.end=new D($,E)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$AJ=M;var d;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(ke[36],Se([1,0,19,35,24,34,13,5,17,14,94,8]),function($e,e,D,M,d,P,A,w,$,E,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.SearchErrorCode=e.$PJ=e.$OJ=e.SearchSortOrder=e.ViewMode=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.SearchCompletionExitCode=e.$JJ=e.$IJ=e.$HJ=e.QueryType=e.SearchProviderType=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$BJ="workbench.view.search",e.$CJ="workbench.panel.search",e.$DJ="workbench.view.search",e.$EJ="search-result",e.$FJ="search.exclude";const p="\u27EA ",k=" characters skipped \u27EB",S=(p.length+k.length+5)*2;e.$GJ=(0,w.$8h)("searchService");var c;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(c||(e.SearchProviderType=c={}));var m;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(m||(e.QueryType=m={}));function a(Z){return!!Z.preview}e.$HJ=a;function i(Z){return!!Z.resource}e.$IJ=i;function r(Z){return!!Z.message}e.$JJ=r;var n;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class o{constructor(ce){this.resource=ce,this.results=[]}}e.$KJ=o;class t{constructor(ce,_,ge,ne){this.ranges=_,this.webviewIndex=ne;const J=Array.isArray(_)?_:[_];if(ge&&ge.matchLines===1&&h(J)){ce=(0,A.$Cf)(ce,ge.matchLines);let W="",re=0,ye=0;const he=Math.floor(ge.charsPerLine/5),fe=[];for(const ue of J){const me=Math.max(ue.startColumn-he,0),V=ue.startColumn+ge.charsPerLine;if(me>ye+he+S){const Y=p+(me-ye)+k;W+=Y+ce.slice(me,V),re+=me-(ye+Y.length)}else W+=ce.slice(ye,V);fe.push(new f(0,ue.startColumn-re,ue.endColumn-re)),ye=V}this.preview={text:W,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const W=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:ce,matches:(0,D.$2b)(_,re=>new s(re.startLineNumber-W,re.startColumn,re.endLineNumber-W,re.endColumn))}}}}e.$LJ=t;function h(Z){const ce=Z[0].startLineNumber;for(const _ of Z)if(_.startLineNumber!==ce||_.endLineNumber!==ce)return!1;return!0}class s{constructor(ce,_,ge,ne){this.startLineNumber=ce,this.startColumn=_,this.endLineNumber=ge,this.endColumn=ne}}e.$MJ=s;class f extends s{constructor(ce,_,ge){super(ce,_,ce,ge)}}e.$NJ=f;var l;(function(Z){Z.List="list",Z.Tree="tree"})(l||(e.ViewMode=l={}));var u;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function v(Z,ce=!0){const _=Z&&Z.files&&Z.files.exclude,ge=ce&&Z&&Z.search&&Z.search.exclude;if(!_&&!ge)return;if(!_||!ge)return _||ge;let ne=Object.create(null);return ne=d.$Bn(ne,d.$yn(_)),ne=d.$Bn(ne,d.$yn(ge),!0),ne}e.$OJ=v;function I(Z,ce){return Z.excludePattern&&M.$Nj(Z.excludePattern,ce)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&M.$Nj(Z.includePattern,ce)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(_=>{const ge=_.folder.fsPath;if(P.$9f(ce,ge)){const ne=$.$lc(ge,ce);return!_.includePattern||!!M.$Nj(_.includePattern,ne)}else return!1}):!1:!0}e.$PJ=I;var b;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class g extends Error{constructor(ce,_){super(ce),this.code=_}}e.$QJ=g;function y(Z){const ce=Z.message;if((0,E.$4)(Z))return new g(ce,b.canceled);try{const _=JSON.parse(ce);return new g(_.message,_.code)}catch{return new g(ce,b.other)}}e.$RJ=y;function L(Z){const ce={message:Z.message,code:Z.code};return new Error(JSON.stringify(ce))}e.$SJ=L;function T(Z){return Z.type==="error"?!0:Z.type==="success"}e.$TJ=T;function U(Z){return Z.type==="success"}e.$UJ=U;function j(Z){return!!Z.path}e.$VJ=j;function F(Z,ce){const _=Z.searchPath?Z.searchPath:Z.relativePath;return(0,A.$zf)(_,ce)}e.$WJ=F;class N{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$XJ=N;function O(Z,ce){const _={...Z||{},...ce||{}};return Object.keys(_).filter(ge=>{const ne=_[ge];return typeof ne=="boolean"&&ne})}e.$YJ=O;class z{constructor(ce,_){this.c=null,this.a={...ce.excludePattern||{},..._.excludePattern||{}},this.b=M.$Oj(this.a);let ge=ce.includePattern;_.includePattern&&(ge?ge={...ge,..._.includePattern}:ge=_.includePattern),ge&&(this.c=M.$Oj(ge))}matchesExcludesSync(ce,_,ge){return!!(this.b&&this.b(ce,_,ge))}includedInQuerySync(ce,_,ge){return!(this.b&&this.b(ce,_,ge)||this.c&&!this.c(ce,_,ge))}includedInQuery(ce,_,ge){const ne=this.b(ce,_,ge),J=()=>this.c?!!this.c(ce,_,ge):!0;return(0,C.$Tg)(ne)?ne.then(W=>W?!1:J()):J()}hasSiblingExcludeClauses(){return K(this.a)}}e.$ZJ=z;function K(Z){for(const ce in Z)if(typeof Z[ce]!="boolean")return!0;return!1}function te(Z){if(!Z)return;let ce;return _=>(ce||(ce=(Z()||Promise.resolve([])).then(ge=>ge?X(ge):{})),ce.then(ge=>!!ge[_]))}e.$1J=te;function x(Z){if(!Z)return;let ce;return _=>{if(!ce){const ge=Z();ce=ge?X(ge):{}}return!!ce[_]}}e.$2J=x;function X(Z){const ce={};for(const _ of Z)ce[_]=!0;return ce}}),define(ke[41],Se([1,0,19,8,22,4,3,78,15,122,23,13,2,221,5,12,252,40,59,27,20,16,7,67,36,6,56]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h,s,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=void 0;function u(U,j,F){return new R.$xg(N=>g(N,F)).isEqual(U,j)}function v(U,j,F){return u(U.uri,j.uri,F)?0:(0,C.$6e)(U.uri.toString(),j.uri.toString())}function I(U,j,F){return U.index!==j.index?U.index<j.index?-1:1:u(U.uri,j.uri,F)?(0,C.$6e)(U.name,j.name):(0,C.$6e)(U.uri.toString(),j.uri.toString())}function b(U,j,F,N){const O=U.slice(0).sort((K,te)=>F(K,te,N)),z=j.slice(0).sort((K,te)=>F(K,te,N));return(0,D.$Eb)(O,z,(K,te)=>F(K,te,N))}function g(U,j){const F=j.getCapabilities(U.scheme);return!(F&&F&1024)}class y extends a.$oi{static toExtHostWorkspace(j,F,N,O){if(!j)return{workspace:null,added:[],removed:[]};const{id:z,name:K,folders:te,configuration:x,transient:X,isUntitled:Z}=j,ce=[],_=F;F?te.forEach((W,re)=>{const ye=p.URI.revive(W.uri),he=y.o(N||F,ye,O);he?(he.name=W.name,he.index=W.index,ce.push(he)):ce.push({uri:ye,name:W.name,index:re})}):ce.push(...te.map(({uri:W,name:re,index:ye})=>({uri:p.URI.revive(W),name:re,index:ye}))),ce.sort((W,re)=>W.index<re.index?-1:1);const ge=new y(z,K,ce,!!X,x?p.URI.revive(x):null,!!Z,W=>g(W,O)),{added:ne,removed:J}=b(_?_.workspaceFolders:[],ge.workspaceFolders,v,O);return{workspace:ge,added:ne,removed:J}}static o(j,F,N){for(let O=0;O<j.folders.length;O++){const z=j.workspaceFolders[O];if(u(z.uri,F,N))return z}}constructor(j,F,N,O,z,K,te){super(j,N.map(x=>new a.$pi(x)),O,z,te),this.t=F,this.u=K,this.q=[],this.s=w.$bi.forUris(te),N.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,F){return F&&this.s.get(j)&&(j=(0,R.$Hg)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let L=class{constructor(j,F,N,O,z){this.c=new P.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new P.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new P.$Yd,this.B=new Map,this.h=O,this.s=N,this.t=z,this.j=new E.$$l,this.k=new M.$7g,this.o=j.getProxy(f.$kL.MainThreadWorkspace),this.q=j.getProxy(f.$kL.MainThreadMessageService);const K=F.workspace;this.l=K?new y(K.id,K.name,[],!!K.transient,K.configuration?p.URI.revive(K.configuration):null,!!K.isUntitled,te=>g(te,N)):void 0}$initializeWorkspace(j,F){this.v=F,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,R.$Fg)((0,R.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,F,N,...O){const z=[];if(Array.isArray(O)&&O.forEach(Z=>{p.URI.isUri(Z.uri)&&!z.some(ce=>u(ce.uri,Z.uri,this.s))&&z.push({uri:Z.uri,name:Z.name||(0,R.$Eg)(Z.uri)})}),this.n||[F,N].some(Z=>typeof Z!="number"||Z<0)||N===0&&z.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(F+N>K.length)return!1;const te=K.slice(0);te.splice(F,N,...z.map(Z=>({uri:Z.uri,name:Z.name||(0,R.$Eg)(Z.uri),index:void 0})));for(let Z=0;Z<te.length;Z++){const ce=te[Z];if(te.some((_,ge)=>ge!==Z&&u(ce.uri,_.uri,this.s)))return!1}te.forEach((Z,ce)=>Z.index=ce);const{added:x,removed:X}=b(K,te,I,this.s);if(x.length===0&&X.length===0)return!1;if(this.o){const Z=j.displayName||j.name;this.o.$updateWorkspaceFolders(Z,F,N,z).then(void 0,ce=>{this.n=void 0;const _={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(m.Severity.Error,(0,k.localize)(0,null,Z,ce.toString()),_,[])})}return this.y(te),!0}getWorkspaceFolder(j,F){if(this.x)return this.x.getWorkspaceFolder(j,F)}async getWorkspaceFolder2(j,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,F)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,F){let N,O="";if(typeof j=="string"?(N=p.URI.file(j),O=j):typeof j<"u"&&(N=j,O=j.fsPath),!N)return O;const z=this.getWorkspaceFolder(N,!0);if(!z)return O;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let K=(0,R.$Kg)(z.uri,N);return F&&z.name&&(K=`${z.name}/${K}`),K}y(j){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:F,added:N,removed:O}=y.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:O}))}findFiles(j,F,N,O,z=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let K;if(F===null?K=!1:F&&(typeof F=="string"?K=F:K=F.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:te,folder:x}=T(o.GlobPattern.from(j));return this.o.$startFileSearch(te??null,x??null,K??null,N??null,z).then(X=>Array.isArray(X)?X.map(Z=>p.URI.revive(Z)):[])}async findTextInFiles(j,F,N,O,z=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),te=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:x,folder:X}=T(o.GlobPattern.from(F.include)),Z=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ce={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:te,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:x,excludePattern:Z},_=!1;if(this.u[K]=ge=>{if(_)return;const ne=p.URI.revive(ge.resource);ge.results.forEach(J=>{const W=(0,l.$Eh)(J);(0,s.$HJ)(W)?N({uri:ne,preview:{text:W.preview.text,matches:(0,D.$2b)(W.preview.matches,re=>new t.$oL(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,D.$2b)(W.ranges,re=>new t.$oL(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):N({uri:ne,text:W.text,lineNumber:W.lineNumber})})},z.isCancellationRequested)return{};try{const ge=await this.o.$startTextSearch(j,X??null,ce,K,z);return delete this.u[K],ge||{}}catch(ge){throw delete this.u[K],ge}}$handleTextSearchResult(j,F){this.u[F]?.(j)}async save(j){const F=await this.o.$save(j,{saveAs:!1});return p.URI.revive(F)}async saveAs(j){const F=await this.o.$save(j,{saveAs:!0});return p.URI.revive(F)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,F){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,F);const N=this.t.transformOutgoingScheme(j),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,N),(0,A.$Rc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(j,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const N=await this.resolveWorkspaceFolder(p.URI.revive(j));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const O=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!O),!O)return;const z=await O.provideEditSessionIdentity(N,F);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(j,F,N,O){this.h.info("Getting edit session identifier for workspaceFolder",j);const z=await this.resolveWorkspaceFolder(p.URI.revive(j));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const K=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!K),!K)return;const te=await K.provideEditSessionIdentityMatch?.(F,N,O);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(j){return(F,N,O)=>{const z=function(te){F.call(N,te)};return z.extension=j,this.A.event(z,void 0,O)}}async $onWillCreateEditSessionIdentity(j,F,N){const O=await this.resolveWorkspaceFolder(p.URI.revive(j));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},F,async(z,K)=>{const te=Date.now();await Promise.resolve(z),Date.now()-te>N&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(j,F){if(this.B.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.B.set(j,F);const N=this.t.transformOutgoingScheme(j),O=this.z++;return this.o.$registerCanonicalUriProvider(O,N),(0,A.$Rc)(()=>{this.B.delete(j),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(j,F,N){const O=this.B.get(j.scheme);if(!O)return;const z=await O.provideCanonicalUri?.(p.URI.revive(j),F,N);if(z)return z}async $provideCanonicalUri(j,F,N){return this.provideCanonicalUri(p.URI.revive(j),{targetScheme:F},N)}};e.$ngc=L,e.$ngc=L=Ge([Ve(0,n.$pN),Ve(1,r.$FN),Ve(2,i.$6fc),Ve(3,c.$pj),Ve(4,h.$lgc)],L),e.$ogc=(0,S.$8h)("IExtHostWorkspace");function T(U){let j,F;return U&&(typeof U=="string"?j=U:(j=U.pattern,F=p.URI.revive(U.baseUri))),{includePattern:j,folder:F}}}),define(ke[42],Se([1,0,24,4,41,6,7,254,86,18,8,5,20,12,2]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=e.$qgc=e.$pgc=void 0;function c(h,s){if(s){const f=s.split(".");let l=h;for(let u=0;l&&u<f.length;u++)l=l[f[u]];return l}}function m(h){return h instanceof S.URI}function a(h){return h&&h.uri instanceof S.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function r(h){return h&&h.uri instanceof S.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function n(h){if(m(h))return{resource:h};if(a(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(r(h))return{resource:h.uri};if(h===null)return{resource:null}}let o=class{constructor(s,f,l){this.a=s.getProxy(P.$kL.MainThreadConfiguration),this.c=f,this.b=l,this.d=new R.$7g,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,f){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,f))}};e.$pgc=o,e.$pgc=o=Ge([Ve(0,p.$pN),Ve(1,d.$ogc),Ve(2,k.$pj)],o);class t{constructor(s,f,l,u){this.a=new M.$Wd,this.b=s,this.f=u,this.c=f,this.e=w.$9n.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,f){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$9n.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(f,l))}getConfiguration(s,f,l){const u=n(f)||{},v=this.g(s?c(this.e.getValue(void 0,u,this.c.workspace),s):this.e.getValue(void 0,u,this.c.workspace));s&&this.h(s,u,l?.identifier);function I(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(g){return typeof c(v,g)<"u"},get:(g,y)=>{this.h(s?`${s}.${g}`:g,u,l?.identifier);let L=c(v,g);if(typeof L>"u")L=y;else{let T;const U=(j,F)=>{if((0,E.$Lf)(j)){let N;const O=()=>{T=T||(0,D.$yn)(v),N=N||c(T,F)};return new Proxy(j,{get:(z,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return O(),()=>N;if(T)return N=N||c(T,F),N[K];const te=z[K];return typeof K=="string"?U(te,`${F}.${K}`):te},set:(z,K,te)=>(O(),N&&(N[K]=te),!0),deleteProperty:(z,K)=>(O(),N&&delete N[K],!0),defineProperty:(z,K,te)=>(O(),N&&Object.defineProperty(N,K,te),!0)})}return Array.isArray(j)?(0,D.$yn)(j):j};L=U(L,g)}return L},update:(g,y,L,T)=>{g=s?`${s}.${g}`:g;const U=I(L);return y!==void 0?this.b.$updateConfigurationOption(U,g,y,u,T):this.b.$removeConfigurationOption(U,g,u,T)},inspect:g=>{g=s?`${s}.${g}`:g;const y=this.e.inspect(g,u,this.c.workspace);if(y)return{key:g,defaultValue:(0,D.$yn)(y.policy?.value??y.default?.value),globalValue:(0,D.$yn)(y.user?.value??y.application?.value),workspaceValue:(0,D.$yn)(y.workspace?.value),workspaceFolderValue:(0,D.$yn)(y.workspaceFolder?.value),defaultLanguageValue:(0,D.$yn)(y.default?.override),globalLanguageValue:(0,D.$yn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,D.$yn)(y.workspace?.override),workspaceFolderLanguageValue:(0,D.$yn)(y.workspaceFolder?.override),languageIds:(0,D.$yn)(y.overrideIdentifiers)}}};return typeof v=="object"&&(0,D.$Bn)(b,v,!1),Object.freeze(b)}g(s){const f=l=>(0,E.$Lf)(l)?new Proxy(l,{get:(u,v)=>f(u[v]),set:(u,v,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(u,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(u,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return f(s)}h(s,f,l){const u=$.$Zn.test(s)?4:this.d.get(s),v=l?`[${l.value}] `:"";if(u===4){typeof f?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){f?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,f){const l=new w.$$n(s,f,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,v)=>l.affectsConfiguration(u,n(v))})}k(s){return s.reduce((f,l)=>(f.set(l[0],l[1]),f),new Map)}}e.$qgc=t,e.$rgc=(0,C.$8h)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,8,4,6,7,41,73,42,22,46,20,27,5,15,11,12,91,296,14]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=e.$Thc=e.$Shc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(U){function j(N){if(N!=null)return N}U.from=j;function F(N){if(N!=null)return N}U.to=F})(o||(o={}));var t;(function(U){function j(N){if(N!=null)return N}U.from=j;function F(N){if(N!=null)return N}U.to=F})(t||(t={}));var h;(function(U){function j(N){if(N!=null)return N}U.from=j;function F(N){if(N!=null)return N}U.to=F})(h||(h={}));var s;(function(U){function j(O){if(O){const z=O;return z&&!!z.process}else return!1}U.is=j;function F(O){if(O==null)return;const z={process:O.process,args:O.args};return O.options&&(z.options=h.from(O.options)),z}U.from=F;function N(O){if(O!=null)return new A.$8L(O.process,O.args,O.options)}U.to=N})(s||(s={}));var f;(function(U){function j(N){if(N!=null)return N}U.from=j;function F(N){if(N!=null)return N}U.to=F})(f||(f={}));var l;(function(U){function j(O){if(O){const z=O;return z&&(!!z.commandLine||!!z.command)}else return!1}U.is=j;function F(O){if(O==null)return;const z={};return O.commandLine!==void 0?z.commandLine=O.commandLine:(z.command=O.command,z.args=O.args),O.options&&(z.options=f.from(O.options)),z}U.from=F;function N(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$9L(O.commandLine,O.options):new A.$9L(O.command,O.args?O.args:[],O.options)}U.to=N})(l||(l={}));var u;(function(U){function j(O){if(O){const z=O;return z&&z.customExecution==="customExecution"}else return!1}U.is=j;function F(O){return{customExecution:"customExecution"}}U.from=F;function N(O,z){return z.get(O)}U.to=N})(u||(e.CustomExecutionDTO=u={}));var v;(function(U){function j(F,N){let O;return F.scope!==void 0&&typeof F.scope!="number"?O=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?O=N.workspaceFile:O=r.$DG),{id:F._id,workspaceFolder:O}}U.from=j})(v||(e.TaskHandleDTO=v={}));var I;(function(U){function j(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}U.from=j})(I||(I={}));var b;(function(U){function j(O,z){if(O==null)return[];const K=[];for(const te of O){const x=F(te,z);x&&K.push(x)}return K}U.fromMany=j;function F(O,z){if(O==null)return;let K;O.execution instanceof A.$8L?K=s.from(O.execution):O.execution instanceof A.$9L?K=l.from(O.execution):O.execution&&O.execution instanceof A.$0L&&(K=u.from(O.execution));const te=o.from(O.definition);let x;return O.scope?typeof O.scope=="number"?x=O.scope:x=O.scope.uri:x=A.TaskScope.Workspace,!te||!x?void 0:{_id:O._id,definition:te,name:O.name,source:{extensionId:z.identifier.value,label:O.source,scope:x},execution:K,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}U.from=F;async function N(O,z,K){if(O==null)return;let te;s.is(O.execution)?te=s.to(O.execution):l.is(O.execution)?te=l.to(O.execution):u.is(O.execution)&&(te=u.to(O._id,K));const x=o.to(O.definition);let X;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?X=O.source.scope:X=await z.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):X=A.TaskScope.Workspace),!x||!X)return;const Z=new A.$$L(x,X,O.name,O.source.label,te,O.problemMatchers);return O.isBackground!==void 0&&(Z.isBackground=O.isBackground),O.group!==void 0&&(Z.group=A.$7L.from(O.group._id),Z.group&&O.group.isDefault&&(Z.group=new A.$7L(Z.group.id,Z.group.label),O.group.isDefault===!0&&(Z.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Z.presentationOptions=t.to(O.presentationOptions)),O._id&&(Z._id=O._id),O.detail&&(Z.detail=O.detail),Z}U.to=N})(b||(e.TaskDTO=b={}));var g;(function(U){function j(N){return N}U.from=j;function F(N){if(N)return Object.assign(Object.create(null),N)}U.to=F})(g||(g={}));class y{#e;constructor(j,F,N){this._id=F,this.a=N,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let L=class{constructor(j,F,N,O,z,K,te,x){this.q=new d.$Wd,this.r=new d.$Wd,this.s=new d.$Wd,this.u=new d.$Wd,this.a=j.getProxy(P.$kL.MainThreadTask),this.b=N,this.c=O,this.d=z,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=te,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,F,N){if(!N)return new A.$mL(()=>{});const O=this.x();return this.j.set(O,{type:F,provider:N,extension:j}),this.a.$registerTaskProvider(O,F),new A.$mL(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(j,F){this.a.$registerTaskSystem(j,F)}fetchTasks(j){return this.a.$fetchTasks(g.from(j)).then(async F=>{const N=[];for(const O of F){const z=await b.to(O,this.b,this.m);z&&N.push(z)}return N})}get taskExecutions(){const j=[];return this.k.forEach(F=>j.push(F)),j}terminateTask(j){if(!(j instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,F,N){const O=this.m.get(j.id);O&&(this.o.set(j.id,O),this.e.attachPtyToTerminal(F,await O.callback(N))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const F=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const F=await this.z(j.id);this.s.fire({execution:F,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const F=await this.z(j.id);this.u.fire({execution:F,exitCode:j.exitCode})}$provideTasks(j,F){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));const O=[],z=(0,M.$Zg)(()=>N.provider.provideTasks(R.CancellationToken.None)).then(K=>this.v(F,O,N,K));return new Promise(K=>{z.then(te=>{Promise.all(O).then(()=>{K(te)})})})}async $resolveTask(j,F){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));if(F.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${N.type}].`);const O=await b.to(F,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const z=await N.provider.resolveTask(O,R.CancellationToken.None);if(!z)return;this.A(z,N);const K=b.from(z,N.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(K.execution)&&await this.y(K,z,!0),await this.w(K)}x(){return this.h++}async y(j,F,N){const O=await this.a.$createTaskId(j);!N&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,F.execution)),this.m.set(O,F.execution)}async z(j,F){if(typeof j=="string"){const z=this.l.get(j);if(!z)throw new n.$bb("Unexpected: The specified task is missing an execution");return z}const N=this.l.get(j.id);if(N)return N;let O;return F?O=Promise.resolve(new y(this,j.id,F)):O=b.to(j.task,this.b,this.m).then(z=>{if(!z)throw new n.$bb("Unexpected: Task does not exist.");return new y(this,j.id,z)}),this.l.set(j.id,O),O.then(z=>(this.k.set(j.id,z),z))}A(j,F){j._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const N=this.n.values();let O=N.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=N.next()}};e.$Shc=L,e.$Shc=L=Ge([Ve(0,p.$pN),Ve(1,k.$FN),Ve(2,w.$ogc),Ve(3,$.$AN),Ve(4,E.$rgc),Ve(5,C.$Pgc),Ve(6,a.$pj),Ve(7,i.$9fc)],L);let T=class extends L{constructor(j,F,N,O,z,K,te,x){super(j,F,N,O,z,K,te,x),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(j,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const N=b.from(F,j);if(N===void 0)throw new Error("Task is not valid");if(u.is(N.execution))await this.y(N,F,!1);else throw new n.$_;const O=await this.z(await this.a.$getTaskExecution(N),F);return this.a.$executeTask(N).catch(z=>{throw new Error(z)}),O}v(j,F,N,O){const z=[];if(O)for(const K of O){if(this.A(K,N),!K.definition||!j[K.definition.type]){const x=K.source?K.source:"No task source";this.f.warn(`The task [${x}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`)}const te=b.from(K,N.extension);te&&u.is(te.execution)?(z.push(te),F.push(this.y(te,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:N.extension}}async w(j){if(u.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,F,N){}};e.$Thc=T,e.$Thc=T=Ge([Ve(0,p.$pN),Ve(1,k.$FN),Ve(2,w.$ogc),Ve(3,$.$AN),Ve(4,E.$rgc),Ve(5,C.$Pgc),Ve(6,a.$pj),Ve(7,i.$9fc)],T),e.$Uhc=(0,S.$8h)("IExtHostTask")}),define(ke[360],Se([1,0,36,29]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.$8J=void 0;function d(A){return"cellResults"in A}e.$8J=d,e.$9J="rawCell#";function P(A,w){let $=-1;const E=[];let R=[];return A.forEach(p=>{p.range.startLineNumber!==$&&R.length>0&&(E.push([...R]),R=[]),R.push(p),$=p.range.endLineNumber}),R.length>0&&E.push([...R]),E.map(p=>{const k=[],S=p[0].range.startLineNumber,c=p[p.length-1].range.endLineNumber;for(let m=S;m<=c;m++)k.push(w.getLineContent(m));return new D.$LJ(k.join(`
`)+`
`,p.map(m=>new M.$Ws(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}e.$0J=P}),define(ke[361],Se([1,0,215,21,4,3,28,13,18,2,32,110,6,33,16,7,69,331,149,24,15,286,360,357]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,u,v,I,b,g){this.q=v,this.r=I,this.s=b,this.t=g,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new d.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new d.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new d.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new d.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$2fc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(p.$kL.MainThreadNotebook),this.c=l.getProxy(p.$kL.MainThreadNotebookDocuments),this.d=l.getProxy(p.$kL.MainThreadNotebookEditors),this.i=u.converter,u.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const L=y.notebookEditor?.notebookUri,T=y.cell.handle,j=this.g.get(L)?.getCell(T);if(j)return j.apiCell}if(y&&y.$mid===14){const L=y.uri,T=this.g.get(L);if(T)return T.apiNotebook}return y}}),s.B(u)}getEditorById(l){const u=this.h.get(l);if(!u)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return u}getIdByEditor(l){for(const[u,v]of this.h)if(v.apiEditor===l)return u}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,u){const v=this.g.get(l);if(!v&&!u)throw new Error(`NO notebook document for '${l}'`);return v}static u(l,u){if(!u)return;const v=u.filenamePattern.map(I=>S.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(u.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:u.displayName,filenamePattern:v,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,u,v){const I=s.a++,b=typeof v.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(I,v),this.b.$registerNotebookCellStatusBarItemProvider(I,b,u);let g;return b!==void 0&&(g=v.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(b))),new c.$mL(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,b),g?.dispose()})}async createNotebookDocument(l){const u=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&S.NotebookData.from(l.content)});return E.URI.revive(u)}async openNotebookDocument(l){const u=this.g.get(l);if(u)return u.apiNotebook;const v=await this.c.$tryOpenNotebook(l),I=this.g.get(E.URI.revive(v));return(0,$.$Uf)(I?.apiNotebook)}async showNotebookDocument(l,u){E.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let v;typeof u=="object"?v={position:S.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(S.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:v={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,v),b=I&&this.h.get(I)?.apiEditor;if(b)return b;throw I?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,u,v,I){const b=this.f.get(l),g=E.URI.revive(u),y=this.g.get(g);if(!y||!b)return;const L=y.getCellFromIndex(v);if(!L)return;const T=await b.provideCellStatusBarItems(L.apiCell,I);if(!T)return;const U=new P.$Sc,j=this.p.add([U]),N=(Array.isArray(T)?T:[T]).map(O=>S.NotebookStatusBarItem.from(O,this.i,U));return{cacheId:j,items:N}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,u,v,I,b){if((0,w.$Ke)(u))throw new Error("viewType cannot be empty or just whitespace");const g=this.w++;return this.x.set(g,{viewType:u,serializer:v,options:I}),this.b.$registerNotebookSerializer(g,{id:l.identifier,location:l.extensionLocation},u,S.NotebookDocumentContentOptions.from(I),s.u(l,b)),(0,P.$Rc)(()=>{this.b.$unregisterNotebookSerializer(g)})}async $dataToNotebook(l,u,v){const I=this.x.get(l);if(!I)throw new Error("NO serializer found");const b=await I.serializer.deserializeNotebook(u.buffer,v);return new m.$Vv(S.NotebookData.from(b))}async $notebookToData(l,u,v){const I=this.x.get(l);if(!I)throw new Error("NO serializer found");const b=await I.serializer.serializeNotebook(S.NotebookData.to(u.value),v);return M.$ke.wrap(b)}async $saveNotebook(l,u,v,I,b){const g=E.URI.revive(u),y=this.x.get(l);if(!y)throw new Error("NO serializer found");const L=this.g.get(g);if(!L)throw new Error("Document NOT found");if(L.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(g.scheme))throw new R.$Nk((0,D.localize)(0,null,this.z(g)),6);await this.y(g,I);const T={metadata:(0,r.$Gn)(L.apiNotebook.metadata,O=>!(y.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of L.apiNotebook.getCells()){const z=new c.$MM(O.kind,O.document.getText(),O.document.languageId,O.mime,y.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);z.metadata=(0,r.$Gn)(O.metadata,K=>!(y.options?.transientCellMetadata??{})[K]),T.cells.push(z)}const U=await y.serializer.serializeNotebook(T,b);await this.s.value.writeFile(g,U);const j=this.s.getFileSystemProviderExtUri(g.scheme),F=await this.s.value.stat(g);return{name:j.basename(g),isFile:(F.type&R.FileType.File)!==0,isDirectory:(F.type&R.FileType.Directory)!==0,isSymbolicLink:(F.type&R.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(g.scheme),locked:!!((F.permissions??0)&R.FilePermission.Locked),etag:R.$Yk({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(l,u,v,I,b){const g=this.x.get(l)?.serializer;if(!g)return{limitHit:!1,results:[]};const y=new A.$Bc;await(async(F,N,O)=>{await Promise.all(F.map(async z=>await Promise.all(z.filenamePatterns.map(K=>{const te={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:K};return this.t.doInternalFileSearchWithCustomCallback(te,N,x=>{x.forEach(X=>{y.has(X)||I.some(ce=>z.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(_=>(0,h.$Hdb)(_,X)))||y.add(X)})})}))))})(v,b,u);const T=new A.$Ac;let U=!1;const j=Array.from(y).map(async F=>{const N=[];try{if(b.isCancellationRequested)return;if(u.maxResults&&[...T.values()].reduce((te,x)=>te+x.cellResults.length,0)>u.maxResults){U=!0;return}const O=[],z=this.g.get(F);if(z)z.apiNotebook.getCells().forEach(x=>O.push({input:x.document.getText(),outputs:x.outputs.flatMap(X=>X.items.map(Z=>Z.data.toString()))}));else{const te=await this.s.value.readFile(F),x=M.$ke.fromString(te.toString()),X=await g.deserializeNotebook(x.buffer,b);if(b.isCancellationRequested)return;S.NotebookData.from(X).cells.forEach(ce=>O.push({input:ce.source,outputs:ce.outputs.flatMap(_=>_.items.map(ge=>ge.valueBytes.toString()))}))}if(b.isCancellationRequested)return;O.forEach((te,x)=>{const X=u.contentPattern.pattern,Z=new o.$GRb(te.input,void 0,te.outputs),ce=Z.findInInputs(X),_=Z.findInOutputs(X),ge=_.flatMap(ne=>(0,t.$0J)(ne.matches,ne.textBuffer)).map((ne,J)=>(ne.webviewIndex=J,ne));if(ce.length>0||_.length>0){const ne={index:x,contentResults:(0,t.$0J)(ce,Z.inputTextBuffer),webviewResults:ge};N.push(ne)}});const K={resource:F,cellResults:N};T.set(F,K);return}catch{return}});return await Promise.all(j),{limitHit:U,results:[...T.values()]}}async y(l,u){const v=await this.s.value.stat(l);if(typeof u?.mtime=="number"&&typeof u.etag=="string"&&u.etag!==R.$Xk&&typeof v.mtime=="number"&&typeof v.size=="number"&&u.mtime<v.mtime&&u.etag!==R.$Yk({mtime:u.mtime,size:v.size}))throw new R.$Nk((0,D.localize)(1,null),3,u)}z(l){return l.scheme===n.Schemas.file?l.fsPath:l.toString()}A(l,u,v){if(this.h.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const I=new i.$lhc(u,this.d,l,v.visibleRanges.map(S.NotebookRange.to),v.selections.map(S.NotebookRange.to),typeof v.viewColumn=="number"?S.ViewColumn.to(v.viewColumn):void 0);this.h.set(u,I)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const v of l.value.removedDocuments){const I=E.URI.revive(v),b=this.g.get(I);b&&(b.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(g=>g.document.uri)}),this.n.fire(b.apiNotebook));for(const g of this.h.values())g.notebookData.uri.toString()===I.toString()&&this.h.delete(g.id)}if(l.value.addedDocuments){const v=[];for(const I of l.value.addedDocuments){const b=E.URI.revive(I.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const g=new a.$khc(this.c,this.q,this.r,b,I);v.push(...I.cells.map(y=>a.$jhc.asModelAddData(g.apiNotebook,y))),this.g.get(b)?.dispose(),this.g.set(b,g),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(g.apiNotebook)}}if(l.value.addedEditors)for(const v of l.value.addedEditors){if(this.h.has(v.id))return;const I=E.URI.revive(v.documentUri),b=this.g.get(I);b&&this.A(b,v.id,v)}const u=[];if(l.value.removedEditors)for(const v of l.value.removedEditors){const I=this.h.get(v);I&&(this.h.delete(v),this.k?.id===I.id&&(this.k=void 0),u.push(I))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const v=new Set;this.l.forEach(I=>v.add(I.id));for(const I of this.h.values()){const b=v.has(I.id);I._acceptVisibility(b)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const u=k.$NN.String.with("notebookType","A notebook type"),v=new k.$PN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[u,new k.$NN("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>M.$ke.wrap(b))],new k.$ON("Notebook Data",b=>S.NotebookData.to(b.value))),I=new k.$PN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[u,new k.$NN("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new m.$Vv(S.NotebookData.from(b)))],new k.$ON("Bytes",b=>b.buffer));l.registerApiCommand(v),l.registerApiCommand(I)}}e.$uhc=s}),define(ke[362],Se([1,0,17,22,44,35,23,38,36]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;class E{constructor(p,k,S){this.k=p,this.l=k,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&P.$Oj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&P.$Oj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const k=this.k.folderQueries||[];return new Promise((S,c)=>{const m=a=>{this.f++,p(a)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const i=a.toString(),r=D.$nc(i);this.j&&this.j(i,r)||this.v(m,{base:a,basename:r})}),Promise.all(k.map(a=>this.p(a,m))).then(a=>{S({limitHit:this.e,stats:a[0]||void 0})},a=>{c(new Error((0,d.$Si)(a)))})})}async p(p,k){const S=new M.$7d,c=this.q(p),m=this.r(),a=new $.$ZJ(this.k,p),i=!a.hasSiblingExcludeClauses();let r;try{this.h.add(S),r=w.$Sd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,S.token),o=r.elapsed(),t=w.$Sd.create();return this.g&&!this.e||(n&&n.forEach(h=>{const s=D.$gc.relative(p.folder.path,h.path);if(i){const f=D.$nc(h.path);this.v(k,{base:p.folder,relativePath:s,basename:f});return}this.s(m,p.folder,s,k)}),this.g&&!this.e)?null:(this.u(m,a,k),{providerTime:o,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(p){const k=(0,$.$YJ)(this.k.includePattern,p.includePattern),S=(0,$.$YJ)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:S,includes:k,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},k,S,c){if(S===this.a){const a=D.$nc(this.a);this.v(c,{base:k,relativePath:this.a,basename:a})}function m(a){const i=D.$nc(a),r=D.$mc(a);let n=p[r];n||(n=p[r]=[],m(r)),n.push({base:k,relativePath:a,basename:i})}m(S)}u({rootEntries:p,pathToEntries:k},S,c){const m=this,a=this.a;function i(r){const n=(0,$.$2J)(()=>r.map(o=>o.basename));for(let o=0,t=r.length;o<t;o++){const h=r[o],{relativePath:s,basename:f}=h;if(S.matchesExcludesSync(s,f,a!==f?n:void 0))continue;const l=k[s];if(l)i(l);else{if(s===a)continue;m.v(c,h)}if(m.e)break}}i(p)}v(p,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(k))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,k,S,c){const m=this.c(p.cacheKey),a=new E(p,k,m&&m.token);let i=0;const r=n=>{i+=n.length,S(n.map(o=>this.d(o)))};return this.e(a,R.a,r,c).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new M.$7d),this.b.get(p)}d(p){return p.relativePath?{resource:A.$Ig(p.base,p.relativePath)}:{resource:p.base}}e(p,k,S,c){const m=c.onCancellationRequested(()=>{p.cancel()}),a=r=>{r&&(i.push(r),k>0&&i.length>=k&&(S(i),i=[]))};let i=[];return p.search(a).then(r=>(i.length&&S(i),m.dispose(),r),r=>(i.length&&S(i),m.dispose(),Promise.reject(r)))}}e.$mhc=R}),define(ke[363],Se([1,0,19,74,35,102,28,15,17,23,13,18,2,99,235,51,12,40,142,358,36]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$1K=void 0;let o=class{constructor(g,y,L,T,U){this.a=g,this.b=y,this.c=L,this.d=T,this.e=U}text(g,y,L={}){g=this.f(g,L);const T=this.a.getValue(),U=y&&y.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(y?.map(a.$qi),L),type:2,contentPattern:g,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:T.search.usePCRE2||U||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(g,y){const L=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const T={...g,wordSeparators:L.editor.wordSeparators};return this.j(g,y)&&(T.isCaseSensitive=!0),this.k(g)&&(T.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),T}file(g,y={}){return{...this.h(g,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(g,y){return g?(g=Array.isArray(g)?g.map(l):l(g),y?this.parseSearchPaths(g):{pattern:h(...Array.isArray(g)?g:[g])}):{}}h(g=[],y={}){const L=this.g(y.includePattern,y.expandPatterns),T=this.g(y.excludePattern,y.expandPatterns),U=g.length>1,j=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(O=>this.q(O,y,T)):g.map(O=>this.r(O,y,T,U))).filter(O=>!!O),F={_reason:y._reason,folderQueries:j,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:T.pattern,includePattern:L.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const O=D.$Hb(D.$Rb(this.c.groups.map(te=>te.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const z=O.filter(te=>(0,n.$PJ)(F,te.fsPath)),K=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...F,...K}}const N=y.extraFileResources&&y.extraFileResources.filter(O=>(0,n.$PJ)(F,O.fsPath));return F.extraFileResources=N&&N.length?N:void 0,F}i(g){const y=[],L=new A.$Ac,T={};let U=!1;return g.forEach(j=>{if(j.scheme===w.Schemas.walkThrough)return;if((0,E.$Mg)(j)){const N=this.b.getWorkspaceFolder(j)?.uri??j.with({path:$.$mc(j.fsPath)});let O=L.get(N);O||(U=!0,O={folder:N,includePattern:{}},y.push(O),L.set(N,O));const z=$.$lc(N.fsPath,j.fsPath);(0,C.$Uf)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else j.fsPath&&(U=!0,T[j.fsPath]=!0)}),{folderQueries:y,includePattern:T,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(g,y){if(y.isSmartCase){if(g.isRegExp){if(R.$Af(g.pattern,!0))return!0}else if(R.$Af(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,k.$6B)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const y=K=>$.$ic(K)||/^\.\.?([\/\\]|$)/.test(K),T=(Array.isArray(g)?g:s(g)).map(K=>{const te=this.e.resolvedUserHome;return te?(0,P.$1v)(K,te.scheme===w.Schemas.file?te.fsPath:te.path):K}),U=M.$K(T,K=>y(K)?"searchPaths":"exprSegments"),j=(U.exprSegments||[]).map(K=>R.$Ve(K,"/")).map(K=>R.$Ve(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),f(K))),F={},N=this.m(U.searchPaths||[]);N&&N.length&&(F.searchPaths=N);const O=D.$Rb(j),z=h(...O);return z&&(F.pattern=z),F}l(g,y){return y.disregardExcludeSettings?void 0:(0,n.$OJ)(g,!y.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const y=g.flatMap(T=>{let{pathPortion:U,globPortion:j}=t(T);return j&&(j=u(j)),this.n(U).flatMap(N=>this.o(N,j))}),L=new Map;return y.forEach(T=>{const U=T.searchPath.toString(),j=L.get(U);j?T.pattern&&(j.pattern=j.pattern||{},j.pattern[T.pattern]=!0):L.set(U,{searchPath:T.searchPath,pattern:T.pattern?h(T.pattern):void 0})}),Array.from(L.values())}n(g){if($.$ic(g)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==w.Schemas.file?[{searchPath:y[0].uri.with({path:g})}]:[{searchPath:p.URI.file($.$hc(g))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(g=l(g),g.startsWith("../")||g===".."){const T=$.$gc.resolve(y.path,g);return[{searchPath:y.with({path:T})}]}const L=u(g);return[{searchPath:y,pattern:L}]}else{if(g==="./"||g===".\\")return[];{const y=g.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(U=>{const j=y.match(new RegExp(`^${R.$Pe(U.name)}(?:/(.*)|$)`));return j?{match:j,folder:U}:null}).filter(C.$Rf);if(T.length)return T.map(U=>{const j=U.match[1];return{searchPath:U.folder.uri,pattern:j&&u(j)}});{const U=g.match(/\.[\/\\](.+)[\/\\]?/),j=U?U[1]:g,F=S.localize(0,null,j);throw new Error(F)}}}}o(g,y){const L=g.pattern&&y?`${g.pattern}/${y}`:g.pattern||y,T=[{searchPath:g.searchPath,pattern:L}];return L&&!L.endsWith("**")&&T.push({searchPath:g.searchPath,pattern:L+"/**"}),T}q(g,y,L){const T=this.r((0,a.$qi)(g.searchPath),y,L,!1);return T?{...T,includePattern:g.pattern}:null}r(g,y,L,T){let U;const j=p.URI.isUri(g)?g:g.uri;if(L.searchPaths){const K=L.searchPaths.filter(te=>(0,E.$Bg)(te.searchPath,j))[0];if(K&&!K.pattern)return null;K&&(U=K.pattern)}const F=this.a.getValue({resource:j}),O={...this.l(F,y)||{},...U||{}},z=p.URI.isUri(g)?(0,E.$Fg)(g):g.name;return{folder:j,folderName:T?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!F.search.followSymlinks}}};e.$1K=o,e.$1K=o=Ge([Ve(0,c.$Bi),Ve(1,a.$ei),Ve(2,i.$aD),Ve(3,m.$pj),Ve(4,r.$YK)],o);function t(b){const g=b.match(/[\*\{\}\(\)\[\]\?]/);if(g){const y=g.index,L=b.substr(0,y).match(/[/|\\][^/\\]*$/);if(L){let T=b.substr(0,L.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:b.substr((L.index||0)+1)}}}return{pathPortion:b}}function h(...b){return b.length?b.reduce((g,y)=>(g[y]=!0,g),Object.create(null)):void 0}function s(b){return d.$Mj(b,",").map(g=>g.trim()).filter(g=>!!g.length)}function f(b){return[`**/${b}/**`,`**/${b}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function l(b){return b.replace(/\\/g,"/")}function u(b){return l(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(b){return b.replace(/([?*[\]])/g,"[$1]")}function I(b,g){b=D.$Mb(b,T=>T.toString());const y=[],L=g.getWorkspace();return b&&b.forEach(T=>{let U;if(g.getWorkbenchState()===2)U=(0,E.$Kg)(L.folders[0].uri,T),U&&U!=="."&&(U="./"+U);else{const j=g.getWorkspaceFolder(T);if(j){const F=j.name;if(L.folders.filter(O=>O.name===F).length===1){const O=(0,E.$Kg)(j.uri,T);O===""?U=`./${j.name}`:U=`./${j.name}/${O}`}else U=T.fsPath}}U&&y.push(v(U))}),y}e.$2K=I}),define(ke[364],Se([1,0,23,2,22,14,5,363,36,40,8]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ftb=e.$etb=void 0;const C=7e3;function p(m,a){const i=a.activationEvents;if(!i)return Promise.resolve(void 0);const r=[],n=[];for(const l of i)if(/^workspaceContains:/.test(l)){const u=l.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||m.forceUsingSearch?n.push(u):r.push(u)}if(r.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,R.$1g)(),h=l=>t({activationEvent:l}),s=Promise.all(r.map(l=>k(m,l,h))).then(()=>{}),f=S(m,a.identifier,n,h);return Promise.all([s,f]).then(()=>{t(void 0)}),o}e.$etb=p;async function k(m,a,i){for(const r of m.folders)if(await m.exists(D.$Ig(M.URI.revive(r),a))){i(`workspaceContains:${a}`);return}}async function S(m,a,i,r){if(i.length===0)return Promise.resolve(void 0);const n=new d.$7d,o=m.checkExists(m.folders,i,n.token),t=setTimeout(async()=>{n.cancel(),m.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let h=!1;try{h=await o}catch(s){P.$4(s)||P.$1(s)}n.dispose(),clearTimeout(t),h&&r(`workspaceContains:${i.join(",")}`)}function c(m,a,i,r){const n=m.get(A.$7h),o=m.get($.$GJ),h=n.createInstance(w.$1K).file(a.map(s=>(0,E.$qi)(M.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(h,r).then(s=>!!s.limitHit,s=>P.$4(s)?!1:Promise.reject(s))}e.$ftb=c}),define(ke[47],Se([1,0,212,17,58,23,8,3,78,2,12,6,42,292,117,41,26,144,14,25,21,271,7,65,5,27,93,20,106,71,46,4,364,116,273,15,114,38,11,115]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h,s,f,l,u,v,I,b,g,y,L,T,U,j,F,N,O){"use strict";var z;Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0,e.$1gc=(0,s.$8h)("IHostUtils");let K=z=class extends w.$Tc{constructor(J,W,re,ye,he,fe,ue,me,V,Y,de,pe){super(),this.X=pe,this.a=this.B(new g.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=re,this.f=ue,this.j=ye,this.m=he,this.s=fe,this.t=V,this.u=Y,this.w=de,this.y=this.g.getProxy(C.$kL.MainThreadWorkspace),this.z=this.g.getProxy(C.$kL.MainThreadTelemetry),this.C=this.g.getProxy(C.$kL.MainThreadExtensionService),this.D=new A.$7g,this.F=new A.$7g,this.G=new A.$7g,this.H=new A.$7g,this.I=new ge(this.f.extensions.activationEvents),this.L=new a.$77b(this.I,this.f.extensions.allExtensions);const Pe=new r.$om(this.f.extensions.myExtensions);this.J=new a.$77b(this.I,ce(this.L,Pe)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${X(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${X(this.J)}`)),this.M=new S.$Lgc(this.g,this.s),this.N=new L.$Tgc(this.g),this.O=me,this.h=J.createChild(new v.$6h([S.$Mgc,this.M],[L.$Ugc,this.N])),this.P=this.B(new k.$Kgc(this.J,this.L,{onExtensionActivationError:(ve,Ce,B)=>{this.C.$onExtensionActivationError(ve,i.$3(Ce),B)},actualActivateExtension:async(ve,Ce)=>{if(a.$77b.isHostExtension(ve,this.J,this.L))return await this.C.$activateExtension(ve,Ce),new k.$Jgc;const B=this.J.getExtensionDescription(ve);return this.db(B,Ce)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),d.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(J){i.$1(J)}}async Y(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.cb(he))}catch{}await Promise.all(J)}terminate(J,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const re=this.Y();Promise.race([(0,A.$9g)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const W=await this.C.$getExtension(J);return W&&{...W,identifier:new r.$nm(W.identifier.value),extensionLocation:E.URI.revive(W.extensionLocation)}}Z(J,W){return this.P.activateByEvent(J,W)}$(J,W){return this.P.activateById(J,W)}activateByIdWithErrors(J,W){return this.$(J,W).then(()=>{const re=this.P.getActivatedExtension(J);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async ab(J){if(J.scheme===U.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(J.fsPath);return E.URI.file(W)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(J=>new _(J))),this.Q}async bb(J){const W=$.$bi.forUris(re=>P.$zg.ignorePathCasing(re));return await Promise.all(J.map(async re=>{if(this.ub(re)){const ye=await this.ab(re.extensionLocation);W.set(ye,re)}})),W}cb(J){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return W;const re=this.P.getActivatedExtension(J);if(!re)return W;try{typeof re.module.deactivate=="function"&&(W=Promise.resolve(re.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(ye)}try{(0,w.$Oc)(re.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this.s.error(ye)}return W}async db(J,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.fb(J,W).then(re=>{const ye=re.activationTimes;return this.C.$onDidActivateExtension(J.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,W),this.eb(J,W,"success",ye),re},re=>{throw this.eb(J,W,"failure"),re})}eb(J,W,re,ye){const he=x(J,W);this.z.$publicLog2("extensionActivationTimes",{...he,...ye||{},outcome:re})}fb(J,W){const re=x(J,W);this.z.$publicLog2("activatePlugin",re);const ye=this.ub(J);if(!ye)return Promise.resolve(new k.$Igc(k.$Fgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${J.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const he=new k.$Ggc(W.startup);return Promise.all([this.vb(J,(0,P.$Ig)(J.extensionLocation,ye),he),this.gb(J)]).then(fe=>(d.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),z.hb(this.s,J.identifier,fe[0],fe[1],he))).then(fe=>(d.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),fe))}gb(J){const W=new o.$Ogc(J,this.M),re=new o.$Ngc(J.identifier.value,!1,this.M),ye=new T.$Vgc(J,this.N),he=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([W.whenReady,re.whenReady,this.O.whenReady]).then(()=>{const ue=this;let me,V;const Y=(0,m.$KF)(J,"ipc")?this.f.messagePorts?.get(r.$nm.toKey(J.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:re,secrets:ye,subscriptions:[],get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(de){return M.$jc(J.extensionLocation.fsPath,de)},get storagePath(){return ue.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return ue.O.globalValue(J).fsPath},get logPath(){return M.$jc(ue.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return E.URI.joinPath(ue.f.logsLocation,J.identifier.value)},get storageUri(){return ue.O.workspaceValue(J)},get globalStorageUri(){return ue.O.globalValue(J)},get extensionMode(){return he},get extension(){return me===void 0&&(me=new Z(ue,J.identifier,J,fe,!1)),me},get extensionRuntime(){return(0,m.$LF)(J,"extensionRuntime"),ue.extensionRuntime},get environmentVariableCollection(){return ue.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!V){if(!Y)return;const de=g.Event.buffer(g.Event.fromDOMEventEmitter(Y,"message",pe=>pe.data));Y.start(),V={onDidReceiveMessage:de,postMessage:Y.postMessage.bind(Y)}}return V}})})}static hb(J,W,re,ye,he){return re=re||{activate:void 0,deactivate:void 0},this.ib(J,W,re,ye,he).then(fe=>new k.$Hgc(!1,null,he.build(),re,fe,ye.subscriptions))}static ib(J,W,re,ye,he){if(typeof re.activate=="function")try{he.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${W.value}`);const fe=typeof global=="object"?global:self,ue=re.activate.apply(fe,[ye]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(ue).then(me=>(he.activateResolveStop(),me))}catch(fe){return Promise.reject(fe)}else return Promise.resolve(re)}jb(J,W){this.$(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:W}).then(void 0,re=>{this.s.error(re)})}kb(J,W=0){const ye=Date.now();(0,N.$B)(()=>{for(let he=W;he<J.length;he+=1){const fe=J[he];for(const ue of fe.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ye>50){this.kb(J,he);break}else this.jb(fe,ue)}})}lb(){this.C.$setPerformanceMarks(d.getMarks()),this.m.getConfigProvider().then(J=>{const W=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(W)this.kb(re);else for(const ye of re)if(ye.activationEvents)for(const he of ye.activationEvents)he==="onStartupFinished"&&this.jb(ye,he)})}mb(){const J=this.Z("*",!0).then(void 0,fe=>{this.s.error(fe)});this.B(this.j.onDidChangeWorkspace(fe=>this.nb(fe.added)));const W=this.j.workspace?this.j.workspace.folders:[],re=this.nb(W),ye=this.pb(),he=Promise.all([ye,J,re]).then(()=>{});return Promise.race([he,(0,A.$9g)(1e4)]).then(()=>{this.lb()}),he}nb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(J,W))).then(()=>{})}async ob(J,W){if(this.isActivated(W.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:J.map(fe=>fe.uri),forceUsingSearch:re||!this.c.fsExists,exists:fe=>this.c.fsExists(fe.fsPath),checkExists:(fe,ue,me)=>this.y.$checkExists(fe,ue,me)},he=await(0,y.$etb)(ye,W);if(he)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:he.activationEvent}).then(void 0,fe=>this.s.error(fe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(J){throw console.error(J),J}}async qb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:W}=this.f.environment;if(!J||!W)throw new Error(D.localize(0,null));const re=await this.vb(null,W,new k.$Ggc(!1));if(!re||typeof re.run!="function")throw new Error(D.localize(1,null,W.toString()));return new Promise((ye,he)=>{const fe=(V,Y)=>{V?(N.$t&&this.s.error("Test runner called back with error",V),he(V)):(N.$t&&(Y?this.s.info(`Test runner called back with ${Y} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof Y=="number"&&Y>0?1:0))},ue=(0,P.$wg)(W),me=re.run(ue,fe);me&&me.then&&me.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(V=>{N.$t&&this.s.error("Test runner finished with error",V),he(V instanceof Error&&V.stack?V.stack:String(V))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$9g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,W){return this.R[J]=W,(0,w.$Rc)(()=>{delete this.R[J]})}async getRemoteExecServer(J){const{resolver:W}=await this.sb(J);return W?.resolveExecServer?.(J,{resolveAttempt:0})}async sb(J){const W=J.indexOf("+");if(W===-1)throw new t.$sL("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=J.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.R[re]}}async $resolveAuthority(J,W){const re=F.$Sd.create(!1),ye=()=>`[resolveAuthority(${(0,h.$bl)(J)},${W})][${re.elapsed()}ms] `,he=ee=>this.s.info(`${ye()}${ee}`),fe=ee=>this.s.warn(`${ye()}${ee}`),ue=(ee,H=void 0)=>this.s.error(`${ye()}${ee}`,H),me=ee=>{if(ee instanceof t.$sL)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},V=async ee=>{he(`activating resolver for ${ee}...`);const{resolver:H,authorityPrefix:oe}=await this.sb(ee);if(!H)throw ue(`no resolver for ${oe}`),new t.$sL(`No remote extension installed to resolve ${oe}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:oe,remoteAuthority:ee}},Y=J.split(/@|%40/g).reverse();he(`activating remote resolvers ${Y.join(" -> ")}`);let de;try{de=await Promise.all(Y.map(V)).catch(async ee=>{if(!(ee instanceof t.$sL)||ee._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return fe(`resolving nested authorities failed: ${ee.message}`),[await V(J)]})}catch(ee){return me(ee)}const pe=new A.$gh;pe.cancelAndSet(()=>he("waiting..."),1e3);let Pe,ve;for(const[ee,{authorityPrefix:H,resolver:oe,remoteAuthority:le}]of de.entries())try{if(ee===de.length-1)he("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${H}`),Pe=await oe.resolve(le,{resolveAttempt:W,execServer:ve}),d.mark(`code/extHost/didResolveAuthorityOK/${H}`),he("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(oe,t.$rL.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(he(`invoking resolveExecServer() for ${le}`),d.mark(`code/extHost/willResolveExecServer/${H}`),ve=await oe.resolveExecServer?.(le,{resolveAttempt:W,execServer:ve}),!ve)throw new t.$sL(`Exec server was not available for ${le}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Re){return d.mark(`code/extHost/didResolveAuthorityError/${H}`),ue("returned an error",Re),pe.dispose(),me(Re)}pe.dispose();const Ce={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},B={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${t.$rL.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let Q;if(t.$rL.isManagedResolvedAuthority(Pe)){const ee=W;this.X.setFactory(ee,Pe.makeConnection),Q={authority:J,connectTo:new h.$$k(ee),connectionToken:Pe.connectionToken}}else Q={authority:J,connectTo:new h.$_k(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:Q,options:B,tunnelInformation:Ce}}}async $getCanonicalURI(J,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,h.$bl)(J)})`);const{resolver:re}=await this.sb(J);if(!re)return null;const ye=E.URI.revive(W);if(typeof re.getCanonicalURI>"u")return ye;const he=await(0,A.$Zg)(()=>re.getCanonicalURI(ye));return he||ye}$startExtensionHost(J){J.toAdd.forEach(ye=>ye.extensionLocation=E.URI.revive(ye.extensionLocation));const{globalRegistry:W,myExtensions:re}=te(this.I,this.L,this.J,J);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${X(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${X(this.J)}`)),this.rb()}$activateByEvent(J,W){return W===1?this.D.wait().then(re=>this.Z(J,!1)):this.G.wait().then(re=>this.Z(J,!1))}async $activate(J,W){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.$(J,W),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(fe=>fe.extensionLocation=E.URI.revive(fe.extensionLocation));const{globalRegistry:W,myExtensions:re}=te(this.I,this.L,this.J,J),ye=await this.bb(re);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${X(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${X(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const W=n.$ke.alloc(J),re=Math.random()%256;for(let ye=0;ye<J;ye++)W.writeUInt8(re,ye);return W}async $updateRemoteConnectionData(J){this.W=J,this.a.fire()}};e.$2gc=K,e.$2gc=K=z=Ge([Ve(0,s.$7h),Ve(1,e.$1gc),Ve(2,u.$pN),Ve(3,c.$ogc),Ve(4,p.$rgc),Ve(5,R.$pj),Ve(6,f.$FN),Ve(7,l.$ugc),Ve(8,I.$hzb),Ve(9,b.$Pgc),Ve(10,j.$Xgc),Ve(11,O.$Ygc)],K);function te(ne,J,W,re){ne.addActivationEvents(re.addActivationEvents);const ye=new a.$77b(ne,J.getAllExtensionDescriptions());ye.deltaExtensions(re.toAdd,re.toRemove);const he=new r.$om(W.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of re.myToRemove)he.delete(ue);for(const ue of re.myToAdd)he.add(ue);const fe=ce(ye,he);return{globalRegistry:ye,myExtensions:fe}}function x(ne,J){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function X(ne){return ne.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$3gc=(0,s.$8h)("IExtHostExtensionService");class Z{#e;#t;#i;constructor(J,W,re,ye,he){this.#e=J,this.#t=W,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=M.$hc((0,P.$wg)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=ye,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$4gc=Z;function ce(ne,J){return ne.getAllExtensionDescriptions().filter(W=>J.has(W.identifier))}class _{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$5gc=_;class ge{constructor(J){this.a=new r.$pm,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)??[]}addActivationEvents(J){for(const W of Object.keys(J))this.a.set(W,J[W])}}}),define(ke[365],Se([1,0,58,2,6,42,26,25,20,27,5,47,12,13]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;let c=class{constructor(n,o,t,h,s,f,l){this.c=n,this.d=o,this.e=t,this.f=h,this.g=s,this.h=f,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,n,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,o,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const o of n.nodeModuleName)this.a.set(o,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(o=>n.alternativeModuleName(o))}};e.$aic=c,e.$aic=c=Ge([Ve(2,R.$7h),Ve(3,P.$rgc),Ve(4,C.$3gc),Ve(5,E.$FN),Ve(6,p.$pj)],c);let m=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&S.a.size){const o=(0,k.$Pe)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",h=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${s}\\/)(${h})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const o=this.b.exec(this.c(n));if(!o)return;const[,t,h,s]=o,f=S.a.get(h);if(f!==void 0)return console.warn(`${h} as been renamed to ${f}, please update your imports`),t+f+s}c(n){return n.replace(/\\/g,"/")}};m=S=Ge([Ve(0,E.$FN)],m);class a{constructor(n,o,t,h,s){this.c=n,this.d=o,this.e=t,this.f=h,this.g=s,this.nodeModuleName="vscode",this.a=new w.$pm}load(n,o){const t=this.d.findSubstr(o);if(t){let h=this.a.get(t.identifier);return h||(h=this.c(t,this.e,this.f),this.a.set(t.identifier,h)),h}if(!this.b){let h="";this.d.forEach((s,f)=>h+=`	${f} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${h}`),this.b=this.c(A.$FF,this.e,this.f)}return this.b}}let i=class{constructor(n,o,t){this.e=n,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(d.$kL.MainThreadTelemetry);const h=t.getProxy(d.$kL.MainThreadWindow);this.c=(s,f)=>{const l=M.URI.parse(s);return f?this.g(s,f):l.scheme==="http"||l.scheme==="https"?h.$openUri(l,s,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?h.$openUri(l,s,{}):this.g(s,f)}}load(n,o,t){const h=this.e.findSubstr(o);return h&&(this.a=h.identifier.value,this.h()),this.b=t(n),this.c}g(n,o){return this.i(),this.b(n,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([Ve(2,$.$pN)],i)}),define(ke[60],Se([1,0,43,3,17,49,5,73,72,47,7,41,289,42]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=e.$6gc=void 0,e.$6gc=(0,A.$8h)("IExtHostVariableResolverProvider");class S extends p.$qO{constructor(a,i,r,n,o,t,h){function s(){if(r){const f=r.activeEditor();if(f)return f.document.uri;const l=n.tabGroups.all.find(u=>u.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof R.$7M||l.input instanceof R.$_M)return l.input.modified;if(l.input instanceof R.$6M||l.input instanceof R.$$M||l.input instanceof R.$9M)return l.input.uri}}}super({getFolderUri:f=>{const l=t.folders.filter(u=>u.name===f);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(f,l)=>o.getConfiguration(void 0,f).get(l),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=s();if(f)return d.$hc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const f=s();if(f){const l=i.getWorkspaceFolder(f);if(l)return d.$hc(l.uri.fsPath)}}},getSelectedText:()=>{if(r){const f=r.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(r){const f=r.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>a.getExtension(f)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(P.env))}}let c=class extends M.$Tc{constructor(a,i,r,n,o){super(),this.b=a,this.c=i,this.g=r,this.h=n,this.j=o,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$7gc=c,e.$7gc=c=Ge([Ve(0,E.$3gc),Ve(1,C.$ogc),Ve(2,w.$AN),Ve(3,k.$rgc),Ve(4,$.$Dgc)],c)}),define(ke[96],Se([1,0,8,4,2,25,5,6,72,47,20,7,41,140,281,42,60,3,55,33]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=e.$0gc=e.$9gc=e.$8gc=void 0,e.$8gc=(0,A.$8h)("IExtHostDebugService");let n=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q?.api}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(u,v,I,b,g,y,L){this.I=v,this.J=I,this.K=b,this.L=g,this.M=y,this.N=L,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new M.$Wd,this.n=new M.$Wd,this.o=new M.$Wd,this.u=new M.$Wd,this.k=u.getProxy(w.$kL.MainThreadDebugService),this.z=new M.$Wd,this.B=new M.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(T=>{T.onDidChange(U=>{this.O(T)}),this.O(T)})}asDebugSourceUri(u,v){const I=u;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let b=`debug:${encodeURIComponent(I.path||"")}`,g="?";return v&&(b+=`${g}session=${encodeURIComponent(v.id)}`,g="&"),b+=`${g}ref=${I.sourceReference}`,d.URI.parse(b)}else{if(I.path)return d.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(u){const v=[];for(const I of u.getAllExtensionDescriptions())if(I.contributes){const b=I.contributes.debuggers;if(b&&b.length>0)for(const g of b)(0,S.$gG)(g)&&v.push(g.type)}this.k.$registerDebugTypes(v)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const u=[];return this.y.forEach(v=>u.push(v)),u}async $resolveDebugVisualizer(u,v){const I=this.G.get(u);if(!I)throw new Error(`No debug visualizer found with id '${u}'`);let{v:b,provider:g}=I;if(b.visualization||(b=await g.resolveDebugVisualization?.(b,v)||b,I.v=b),!b.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${g}'`);return this.db(b.visualization)}async $executeDebugVisualizerCommand(u){const v=this.G.get(u);if(!v)throw new Error(`No debug visualizer found with id '${u}'`);const I=v.v.visualization;I&&"command"in I&&this.N.executeCommand(I.command,...I.arguments||[])}async $provideDebugVisualizers(u,v,I,b){const g=this.l.get(I.sessionId),y=this.cb(u,v),L=this.E.get(y);if(!g||!L)return[];const T=await L.provideDebugVisualization({session:g.api,variable:I.variable,containerId:I.containerId,frameId:I.frameId,threadId:I.threadId},b);return T?T.map(U=>{const j=++this.H;this.G.set(j,{v:U,provider:L});const F=U.iconPath?this.eb(U.iconPath):void 0;return{id:j,name:U.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.db(U.visualization)}}):[]}$disposeDebugVisualizers(u){for(const v of u)this.G.delete(v)}registerDebugVisualizationProvider(u,v,I){if(!u.contributes?.debugVisualizers?.some(y=>y.id===v))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${v})`);const b=P.$nm.toKey(u.identifier),g=this.cb(b,v);if(this.E.has(g))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.E.set(g,I),this.k.$registerDebugVisualizer(b,v),(0,a.$Rc)(()=>{this.k.$unregisterDebugVisualizer(b,v),this.E.delete(v)})}addBreakpoints(u){const v=u.filter(g=>{const y=g.id;return this.y.has(y)?!1:(this.y.set(y,g),!0)});this.$(v,[],[]);const I=[],b=new Map;for(const g of v)if(g instanceof C.$mM){let y=b.get(g.location.uri.toString());y||(y={type:"sourceMulti",uri:g.location.uri,lines:[]},b.set(g.location.uri.toString(),y),I.push(y)),y.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof C.$nM&&I.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this.k.$registerBreakpoints(I)}removeBreakpoints(u){const v=u.filter(y=>this.y.delete(y.id));this.$([],v,[]);const I=v.filter(y=>y instanceof C.$mM).map(y=>y.id),b=v.filter(y=>y instanceof C.$nM).map(y=>y.id),g=v.filter(y=>y instanceof C.$oM).map(y=>y.id);return this.k.$unregisterBreakpoints(I,b,g)}startDebugging(u,v,I){return this.k.$startDebugging(u?u.uri:void 0,v,{parentSessionID:I.parentSession?I.parentSession.id:void 0,lifecycleManagedByParent:I.lifecycleManagedByParent,repl:I.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact,suppressSaveBeforeStart:I.suppressSaveBeforeStart,suppressDebugStatusbar:I.suppressDebugStatusbar??I.debugUI?.simple,suppressDebugToolbar:I.suppressDebugToolbar??I.debugUI?.simple,suppressDebugView:I.suppressDebugView??I.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,v,I){if(!v)return new C.$mL(()=>{});const b=this.d++;return this.f.push({type:u,handle:b,provider:v}),this.k.$registerDebugConfigurationProvider(u,I,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,b),new C.$mL(()=>{this.f=this.f.filter(g=>g.provider!==v),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(u,v,I){if(!I)return new C.$mL(()=>{});if(!this.W(u,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.S(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:v,handle:b,factory:I}),this.k.$registerDebugAdapterDescriptorFactory(v,b),new C.$mL(()=>{this.h=this.h.filter(g=>g.factory!==I),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(u,v){if(!v)return new C.$mL(()=>{});const I=this.i++;return this.j.push({type:u,handle:I,factory:v}),new C.$mL(()=>{this.j=this.j.filter(b=>b.factory!==v)})}async $runInTerminal(u,v){return Promise.resolve(void 0)}async $substituteVariables(u,v){let I;const b=await this.bb(u);return b&&(I={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(I,v)}P(u,v){if(u.type==="implementation")return new s(u.implementation)}Q(){}async $startDASession(u,v){const I=this,b=await this.ab(v);return this.Y(this.S(b.type),b).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const y=this.R(g),L=this.P(y,b);if(!L)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const T=L;return this.C.set(u,T),this.X(b).then(U=>(U&&this.D.set(u,U),T.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const F=j,N={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const O=await this.F.sign(F.arguments.value);N.body={signature:O},T.sendResponse(N)}else throw new Error("no signer")}catch(O){N.success=!1,N.message=O.message,T.sendResponse(N)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(j),j=(0,S.$lG)(j,!0),I.k.$acceptDAMessage(u,j)}),T.onError(j=>{U&&U.onError&&U.onError(j),this.k.$acceptDAError(u,j.name,j.message,j.stack)}),T.onExit(j=>{U&&U.onExit&&U.onExit(j??void 0,void 0),this.k.$acceptDAExit(u,j??void 0,void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),T.startSession()))})}$sendDAMessage(u,v){v=(0,S.$kG)(v,!1);const I=this.D.get(u);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(v),this.C.get(u)?.sendMessage(v)}$stopDASession(u){const v=this.D.get(u);this.D.delete(u),v&&v.onWillStopSession&&v.onWillStopSession();const I=this.C.get(u);return this.C.delete(u),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const v=[],I=[],b=[];if(u.added)for(const g of u.added){const y=g.id;if(y&&!this.y.has(y)){let L;if(g.type==="function")L=new C.$nM(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")L=new C.$oM(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const T=d.URI.revive(g.uri);L=new C.$mM(new C.$yL(T,new C.$nL(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}(0,C.$kM)(L,y),this.y.set(y,L),v.push(L)}}if(u.removed)for(const g of u.removed){const y=this.y.get(g);y&&(this.y.delete(g),I.push(y))}if(u.changed){for(const g of u.changed)if(g.id){const y=this.y.get(g.id);if(y){if(y instanceof C.$nM&&g.type==="function"){const L=y;L.enabled=g.enabled,L.condition=g.condition,L.hitCondition=g.hitCondition,L.logMessage=g.logMessage,L.functionName=g.functionName}else if(y instanceof C.$mM&&g.type==="source"){const L=y;L.enabled=g.enabled,L.condition=g.condition,L.hitCondition=g.hitCondition,L.logMessage=g.logMessage,L.location=new C.$yL(d.URI.revive(g.uri),new C.$nL(g.line,g.character))}b.push(y)}}}this.$(v,I,b)}async $acceptStackFrameFocus(u){let v;const I=u.sessionId?await this.ab(u.sessionId):void 0;if(!I)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?v=new C.$uM(I.api,u.threadId):v=new C.$tM(I.api,u.threadId,u.frameId),this.A=v,this.B.fire(this.A)}$provideDebugConfigurations(u,v,I){return(0,D.$Zg)(async()=>{const b=this.V(u);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.bb(v);return b.provideDebugConfigurations(g,I)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(u,v,I,b){return(0,D.$Zg)(async()=>{const g=this.V(u);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.bb(v);return g.resolveDebugConfiguration(y,I,b)})}$resolveDebugConfigurationWithSubstitutedVariables(u,v,I,b){return(0,D.$Zg)(async()=>{const g=this.V(u);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.bb(v);return g.resolveDebugConfigurationWithSubstitutedVariables(y,I,b)})}async $provideDebugAdapter(u,v){const I=this.U(u);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.ab(v);return this.Y(I,b).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.R(g)})}async $acceptDebugSessionStarted(u){const v=await this.ab(u);this.m.fire(v.api)}async $acceptDebugSessionTerminated(u){const v=await this.ab(u);v&&(this.n.fire(v.api),this.l.delete(v.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.ab(u):void 0,this.o.fire(this.q?.api)}async $acceptDebugSessionNameChanged(u,v){(await this.ab(u))?._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(u,v){const b={session:(await this.ab(u)).api,event:v.event,body:v.body};this.u.fire(b)}R(u){if(u instanceof C.$pM)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof C.$qM)return{type:"server",port:u.port,host:u.host};if(u instanceof C.$rM)return{type:"pipeServer",path:u.path};if(u instanceof C.$sM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}S(u){const v=this.h.filter(I=>I.type===u);if(v.length>0)return v[0].factory}U(u){const v=this.h.filter(I=>I.handle===u);if(v.length>0)return v[0].factory}V(u){const v=this.f.filter(I=>I.handle===u);if(v.length>0)return v[0].provider}W(u,v){if(u.contributes){const I=u.contributes.debuggers;if(I&&I.length>0){for(const b of I)if(b.label&&b.type&&b.type===v)return!0}}return!1}X(u){const I=u.configuration.type,b=this.j.filter(g=>g.type===I||g.type==="*").map(g=>(0,D.$Zg)(()=>g.factory.createDebugAdapterTracker(u.api)).then(y=>y,y=>null));return Promise.race([Promise.all(b).then(g=>{const y=g.filter(L=>!!L);if(y.length>0)return new h(y)}),new Promise(g=>setTimeout(()=>g(void 0),1e3))]).catch(g=>{})}async Y(u,v){const I=v.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new C.$qM(I));if(u){const g=await this.J.getExtensionRegistry();return(0,D.$Zg)(()=>u.createDebugAdapterDescriptor(v.api,this.Z(v,g))).then(y=>{if(y)return y})}const b=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(v,b))}Z(u,v){}$(u,v,I){(u.length>0||v.length>0||I.length>0)&&this.z.fire(Object.freeze({added:u,removed:v,changed:I}))}async ab(u){if(u)if(typeof u=="string"){const v=this.l.get(u);if(v)return v}else{let v=this.l.get(u.id);if(!v){const I=await this.bb(u.folderUri),b=u.parent?this.l.get(u.parent):void 0;v=new o(this.k,u.id,u.type,u.name,I,u.configuration,b?.api),this.l.set(v.id,v),this.k.$sessionCached(v.id)}return v}throw new Error("cannot find session")}bb(u){if(u){const v=d.URI.revive(u);return this.I.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}cb(u,v){return`${u}\0${v}`}db(u){if(u){if("title"in u&&"command"in u)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(u){const v=this.fb(u);let I,b;return"id"in v?b=i.ThemeIcon.asClassName(v):I=v,{iconPath:I,iconClass:b}}fb(u){if(u instanceof C.$hM)return{id:u.id};const v=typeof u=="object"&&"dark"in u?u.dark:u,I=typeof u=="object"&&"light"in u?u.light:u;return{dark:typeof v=="string"?d.URI.file(v):v,light:typeof I=="string"?d.URI.file(I):I}}};e.$9gc=n,e.$9gc=n=Ge([Ve(0,R.$pN),Ve(1,p.$ogc),Ve(2,E.$3gc),Ve(3,c.$rgc),Ve(4,$.$Dgc),Ve(5,m.$6gc),Ve(6,r.$LN)],n);class o{constructor(u,v,I,b,g,y,L){this.f=u,this.g=v,this.h=I,this.i=b,this.j=g,this.k=y,this.l=L}get api(){const u=this;return this.d??=Object.freeze({id:u.g,type:u.h,get name(){return u.i},set name(v){u.i=v,u.f.$setDebugSessionName(u.g,v)},parentSession:u.l,workspaceFolder:u.j,configuration:u.k,customRequest(v,I){return u.f.$customDebugAdapterRequest(u.g,v,I)},getDebugProtocolBreakpoint(v){return u.f.$getDebugProtocolBreakpoint(u.g,v.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(u){this.i=u}get configuration(){return this.k}}e.$0gc=o;class t{constructor(u){this.value=Object.freeze({append(v){u.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.$$gc=t;class h{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(v=>v.onError?v.onError(u):void 0)}onExit(u,v){this.d.forEach(I=>I.onExit?I.onExit(u,v):void 0)}}class s extends k.$_lb{constructor(u){super(),this.h=u,u.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let f=class extends n{constructor(u,v,I,b,g,y,L){super(u,v,I,b,g,y,L)}};e.$_gc=f,e.$_gc=f=Ge([Ve(0,R.$pN),Ve(1,p.$ogc),Ve(2,E.$3gc),Ve(3,c.$rgc),Ve(4,$.$Dgc),Ve(5,m.$6gc),Ve(6,r.$LN)],f)}),define(ke[366],Se([1,0,14,58,2,6,310,12,84,106,27,247,20,67,47,90]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=void 0;class m{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(w.$pj),t=r.get(p.$pN).getProxy(P.$kL.MainThreadErrors);D.setUnexpectedErrorHandler(h=>{n.error(h);const s=D.$3(h);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(w.$pj),o=r.get(p.$pN),t=r.get(S.$3gc),h=r.get(c.$JN),s=o.getProxy(P.$kL.MainThreadExtensionService),f=o.getProxy(P.$kL.MainThreadErrors),l=await t.getExtensionPathIndex(),u=new WeakMap;function v(g,y){if(u.has(g))return u.get(g).stack;let L="",T,U;for(const F of y)L+=`
	at ${F.toString()}`,U=F.getFileName(),!T&&U&&(T=l.findSubstr(d.URI.file(U)));const j=`${g.name||"Error"}: ${g.message||""}${L}`;return u.set(g,{extensionIdentifier:T?.identifier,stack:j}),j}const I=Symbol("prepareStackTrace wrapped");let b=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(g){if(g===v||!g||g[I]){b=g||v;return}b=function(y,L){return v(y,L),g.call(Error,y,L)},Object.assign(b,{[I]:!0})}}),D.setUnexpectedErrorHandler(g=>{n.error(g);const y=D.$3(g),L=u.get(g);if(!L?.extensionIdentifier){f.$onUnexpectedError(y);return}s.$onExtensionRuntimeError(L.extensionIdentifier,y);const T=h.onExtensionError(L.extensionIdentifier,g);n.trace("forwarded error to extension?",T,L)})}}e.$bic=m;class a{constructor(r,n,o,t,h){this.a=o,this.b=new A.$c8b(r,null,t),n=a.e(n,this.b);const s=new E.$6h(...(0,$.$2r)());s.set(R.$FN,{_serviceBrand:void 0,...n,messagePorts:h}),s.set(p.$pN,new p.$qN(this.b)),s.set(k.$lgc,new k.$mgc(t)),s.set(S.$1gc,o);const f=new C.$Gq(s,!0);f.invokeFunction(m.installEarlyHandler),this.d=f.invokeFunction(l=>l.get(w.$pj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=f.invokeFunction(l=>l.get(S.$3gc)),this.c.initialize(),f.invokeFunction(m.installFullHandler)}async asBrowserUri(r){const n=this.b.getProxy(P.$kL.MainThreadExtensionService);return d.URI.revive(await n.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=d.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=d.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const o=r.environment.extensionDevelopmentLocationURI;return o&&(r.environment.extensionDevelopmentLocationURI=o.map(t=>d.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=d.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=d.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=d.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=d.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=d.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=d.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.$cic=a}),define(ke[367],Se([1,0,8,11,222,241,138,96,72,47,20,46,7,60,41,282,283,42,33]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;let r=class extends w.$9gc{constructor(s,f,l,u,v,I,b,g){super(s,f,l,u,I,b,g),this.ib=v,this.gb=new t}P(s,f){switch(s.type){case"server":return new c.$hic(s);case"pipeServer":return new c.$iic(s);case"executable":return new c.$jic(s,f.type)}return super.P(s,f)}Z(s,f){const l=c.$jic.platformAdapterExecutable(f.getAllExtensionDescriptions(),s.type);if(l)return new p.$pM(l.command,l.args,l.options)}Q(){return new A.$1$b}async $runInTerminal(s,f){if(s.kind==="integrated"){this.hb||(this.hb=this.ib.onDidCloseTerminal(F=>{this.gb.onTerminalClosed(F)}));const l=await this.K.getConfigProvider(),u=this.ib.getDefaultShell(!0),v=this.ib.getDefaultShellArgs(!0),I=s.title||d.localize(0,null),b=JSON.stringify({shell:u,shellArgs:v});let g=await this.gb.checkout(b,I),y,L=!1;if(g)y=s.cwd;else{const F={shellPath:u,shellArgs:v,cwd:s.cwd,name:I,iconPath:new p.$hM("debug")};L=!0,g=this.ib.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.gb.insert(g,b)}g.show(!0);const T=await g.processId;L?await new Promise(F=>setTimeout(F,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?g.sendText("cls"):u.indexOf("bash")>=0?g.sendText("clear"):M.$i?g.sendText("cls"):g.sendText("clear"));const U=(0,m.$lic)(u,s.args,!!s.argsCanBeInterpretedByShell,y,s.env);g.sendText(U);const j=this.onDidTerminateDebugSession(F=>{F.id===f&&(this.gb.free(g),j.dispose())});return T}else if(s.kind==="external")return o(s,await this.K.getConfigProvider());return super.$runInTerminal(s,f)}};e.$mic=r,e.$mic=r=Ge([Ve(0,R.$pN),Ve(1,S.$ogc),Ve(2,E.$3gc),Ve(3,a.$rgc),Ve(4,C.$Pgc),Ve(5,$.$Dgc),Ve(6,k.$6gc),Ve(7,i.$LN)],r);let n;function o(h,s){if(!n)if(M.$i)n=new P.$K0b;else if(M.$j)n=new P.$L0b;else if(M.$k)n=new P.$M0b;else throw new Error("external terminals not supported on this platform");const f=s.getConfiguration("terminal");return n.runInTerminal(h.title,h.cwd,h.args,h.env||{},f.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,f){const u=[...this.b.entries()].map(([v,I])=>(0,D.$Ug)(async b=>{if(v.name!==f||I.lastUsedAt!==-1&&await(0,m.$kic)(await v.processId))return null;const g=Date.now();return I.lastUsedAt+t.a>g||b.isCancellationRequested||I.config!==s?null:(I.lastUsedAt=g,v)}));return await(0,D.$ah)(u,v=>!!v)}insert(s,f){this.b.set(s,{lastUsedAt:Date.now(),config:f})}free(s){const f=this.b.get(s);f&&(f.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(ke[368],Se([1,0,17,2,104,41,73,42,40,46,20,27,95,15,12,91,23,64,60]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;let r=class extends p.$Shc{constructor(o,t,h,s,f,l,u,v,I){super(o,t,h,s,f,l,u,v),this.C=h,this.D=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const h=t;if(!t.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const s=p.TaskHandleDTO.from(h,this.C),f=await this.a.$getTaskExecution(s);if(f.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.z(f,t);return this.a.$executeTask(s).catch(()=>{}),l}else{const s=p.TaskDTO.from(t,o);if(s===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const f=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),f}}v(o,t,h,s){const f=[];if(s)for(const l of s){this.A(l,h),(!l.definition||!o[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const u=p.TaskDTO.from(l,h.extension);u&&(f.push(u),p.CustomExecutionDTO.is(u.execution)&&t.push(this.y(u,l,!0)))}return{tasks:f,extension:h.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const h=M.URI.file((0,a.homedir)());t=new $.$pi({uri:h,name:m.$Fg(h),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const h=M.URI.revive(o),s={process:void 0,variables:Object.create(null)},f=await this.b.resolveWorkspaceFolder(h),l=await this.b.getWorkspaceFolders2()??[],u=await this.D.getResolver(),v=f?{uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(l);for(const I of t.variables)s.variables[I]=await u.resolveAsync(v,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(D.$tc);for(let b=0;b<I.length;b++)I[b]=await u.resolveAsync(v,I[b])}s.process=await d.win32.findExecutable(await u.resolveAsync(v,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(v,t.process.cwd):void 0,I)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,h){return d.win32.findExecutable(o,t,h)}};e.$eic=r,e.$eic=r=Ge([Ve(0,R.$pN),Ve(1,C.$FN),Ve(2,P.$ogc),Ve(3,A.$AN),Ve(4,w.$rgc),Ve(5,E.$Pgc),Ve(6,S.$pj),Ve(7,c.$9fc),Ve(8,i.$6gc)],r)}),define(ke[369],Se([1,0,64,60]),function($e,e,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class d extends M.$7gc{m(){return(0,D.homedir)()}}e.$Wic=d}),define(ke[154],Se([1,0,19,8,22,44,15,17,23,2,36]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=e.$ohc=e.$nhc=void 0;class C{constructor(i,r,n,o){this.d=i,this.e=r,this.f=n,this.g=o,this.a=null,this.b=!1,this.c=0}search(i,r){const n=this.d.folderQueries||[],o=new d.$7d(r);return new Promise((t,h)=>{this.a=new k(i);let s=!1;const f=(l,u)=>{if(!s&&!this.b){const v=this.h(l);c(l)&&typeof this.d.maxResults=="number"&&this.c+v>this.d.maxResults&&(this.b=!0,s=!0,o.cancel(),l=this.j(l,this.d.maxResults-this.c));const I=this.h(l);this.c+=I,(I>0||!c(l))&&this.a.add(l,u)}};Promise.all(n.map((l,u)=>this.k(l,v=>f(v,u),o.token))).then(l=>{o.dispose(),this.a.flush();const u=l.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||u,messages:(0,D.$Rb)(l.map(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[])),stats:{type:this.g}})},l=>{o.dispose();const u=(0,P.$Si)(l);h(new Error(u))})})}h(i){return c(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],o=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:o.slice(0,r),text:i.preview.text},uri:i.uri}}async k(i,r,n){const o=new R.$ZJ(this.d,i),t=[],h={report:l=>{if(!this.l(l))return;const u=i.folder.scheme===A.Schemas.file?(0,R.$1J)(()=>this.f.readdir($.$Hg(l.uri))):void 0,v=$.$Kg(i.folder,l.uri);if(v){const I=o.includedInQuery(v,w.$nc(v),u);(0,M.$Tg)(I)?t.push(I.then(b=>{b&&r(l)})):I&&r(l)}}},s=this.n(i),f=await this.e.provideTextSearchResults(p(this.d.contentPattern),s,h,n);return t.length&&await Promise.all(t),f}l(i){if(c(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const r=(0,R.$YJ)(this.d.includePattern,i.includePattern),n=(0,R.$YJ)(this.d.excludePattern,i.excludePattern),o={folder:E.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return o.usePCRE2=this.d.usePCRE2,o}}e.$nhc=C;function p(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class k{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new m(512,r=>this.g(r))}add(i,r){this.d&&(this.b!==r||!$.$Bg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$ohc=k;function S(a){return c(a)?{preview:{matches:(0,D.$2b)(a.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:a.preview.text},ranges:(0,D.$2b)(a.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function c(a){return!!a.preview}e.$phc=c;class m{static{this.a=4e3}static{this.b=50}constructor(i,r){this.g=i,this.h=r,this.c=0,this.d=[],this.e=0}addItem(i,r){i&&this.j(i,r)}addItems(i,r){i&&this.k(i,r)}j(i,r){this.d.push(i),this.e+=r,this.l()}k(i,r){this.d=this.d.concat(i),this.e+=r,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qhc=m}),define(ke[97],Se([1,0,3,6,5,362,20,67,12,2,154]),function($e,e,D,M,d,P,A,w,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=e.$rhc=void 0,e.$rhc=(0,d.$8h)("IExtHostSearch");let C=class{constructor(c,m,a){this.k=c,this.l=m,this.n=a,this.c=this.k.getProxy(M.$kL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new P.$mhc}o(c){return this.l.transformOutgoingScheme(c)}registerTextSearchProvider(c,m){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const a=this.d++;return this.e.set(a,m),this.c.$registerTextSearchProvider(a,this.o(c)),(0,D.$Rc)(()=>{this.g.delete(c),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(c,m){if(this.i.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.i.add(c);const a=this.d++;return this.h.set(a,m),this.c.$registerFileSearchProvider(a,this.o(c)),(0,D.$Rc)(()=>{this.i.delete(c),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(c,m,a,i){const r=p(a),n=this.h.get(c);if(n)return this.j.fileSearch(r,n,o=>{this.c.$handleFileMatch(c,m,o.map(t=>t.resource))},i);throw new Error("unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,m,a){return{messages:[]}}$clearCache(c){return this.j.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,m,a,i){const r=this.e.get(c);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const n=p(a);return this.q(n,r).search(t=>this.c.$handleTextMatch(c,m,t),i)}$enableExtensionHostSearch(){}q(c,m){return new R.$nhc(c,m,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};e.$shc=C,e.$shc=C=Ge([Ve(0,A.$pN),Ve(1,w.$lgc),Ve(2,$.$pj)],C);function p(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(k),extraFileResources:S.extraFileResources&&S.extraFileResources.map(c=>E.URI.revive(c))}}e.$thc=p;function k(S){return{...S,folder:E.URI.revive(S.folder)}}}),define(ke[370],Se([1,0,22,14,4,3,15,39,2,132,191,172,80,25,32,12,66,87,266,6,312,341,91,313,318,298,319,320,321,299,287,33,322,42,323,96,147,324,301,314,325,326,73,72,315,47,327,70,328,59,27,342,343,316,302,329,330,114,115,303,361,332,272,333,344,334,152,304,335,336,337,20,338,97,116,339,305,340,117,93,95,90,46,345,346,317,347,348,71,16,7,306,67,307,92,349,350,146,41,280,113,26,94]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h,s,f,l,u,v,I,b,g,y,L,T,U,j,F,N,O,z,K,te,x,X,Z,ce,_,ge,ne,J,W,re,ye,he,fe,ue,me,V,Y,de,pe,Pe,ve,Ce,B,Q,ee,H,oe,le,Re,je,He,Qe,_e,at,st,rt,Le,ze,Ae,Ze,ie,se,Ie,qe,Ye,it,nt,Oe,yt,Dt,Tt,Ft,Et,Ht,Ot,Yt,Vt,Ut,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;function Kt(ht){const $t=ht.get(J.$FN),Bt=ht.get(ne.$6fc),Qt=ht.get(_.$tgc),kt=ht.get(Z.$3gc),ft=ht.get(Yt.$ogc),It=ht.get(Ae.$JN),_t=ht.get(L.$rgc),At=ht.get(Dt.$lgc),Ke=ht.get(Re.$pN),Nt=ht.get(rt.$Mgc),jt=ht.get(Le.$ugc),Zt=ht.get(c.$qj),gt=ht.get(c.$pj),Mt=ht.get(it.$hzb),Pt=ht.get(t.$9fc),Wt=ht.get(Ot.$8hc),Ne=ht.get(Qe.$Ugc),Fe=ht.get(x.$Dgc),De=ht.get(V.$Ygc);Ke.set(r.$lL.ExtHostFileSystemInfo,Bt),Ke.set(r.$lL.ExtHostLogLevelServiceShape,Zt),Ke.set(r.$lL.ExtHostWorkspace,ft),Ke.set(r.$lL.ExtHostConfiguration,_t),Ke.set(r.$lL.ExtHostExtensionService,kt),Ke.set(r.$lL.ExtHostStorage,Nt),Ke.set(r.$lL.ExtHostTunnelService,Mt),Ke.set(r.$lL.ExtHostWindow,Wt),Ke.set(r.$lL.ExtHostSecretState,Ne),Ke.set(r.$lL.ExtHostTelemetry,It),Ke.set(r.$lL.ExtHostEditorTabs,Fe),Ke.set(r.$lL.ExtHostManagedSockets,De);const ae=Ke.set(r.$lL.ExtHostDecorations,ht.get(j.$bhc)),Te=Ke.set(r.$lL.ExtHostDocumentsAndEditors,ht.get(te.$AN)),Be=Ke.set(r.$lL.ExtHostCommands,ht.get(g.$LN)),xe=Ke.set(r.$lL.ExtHostTerminalService,ht.get(Ze.$Pgc)),Je=Ke.set(r.$lL.ExtHostDebugService,ht.get(U.$8gc)),ut=Ke.set(r.$lL.ExtHostSearch,ht.get(He.$rhc)),vt=Ke.set(r.$lL.ExtHostTask,ht.get(ze.$Uhc)),Jt=Ke.set(r.$lL.ExtHostOutputService,ht.get(Q.$Hhc)),St=Ke.set(r.$lL.ExtHostLocalization,ht.get(me.$Xgc)),Ct=Ke.set(r.$lL.ExtHostUrls,new Tt.$5hc(Ke)),wt=Ke.set(r.$lL.ExtHostDocuments,new K.$4fc(Ke,Te)),Si=Ke.set(r.$lL.ExtHostDocumentContentProviders,new O.$dhc(Ke,Te,gt)),Ki=Ke.set(r.$lL.ExtHostDocumentSaveParticipant,new z.$ehc(gt,wt,Ke.getProxy(r.$kL.MainThreadBulkEdits))),Lt=Ke.set(r.$lL.ExtHostNotebook,new de.$uhc(Ke,Be,Te,wt,Qt,ut)),si=Ke.set(r.$lL.ExtHostNotebookDocuments,new Pe.$Bhc(Lt)),mi=Ke.set(r.$lL.ExtHostNotebookEditors,new ve.$Chc(gt,Lt)),ui=Ke.set(r.$lL.ExtHostNotebookKernels,new Ce.$Dhc(Ke,$t,Lt,Be,gt)),Di=Ke.set(r.$lL.ExtHostNotebookRenderers,new B.$Fhc(Ke,Lt)),Ci=Ke.set(r.$lL.ExtHostNotebookDocumentSaveParticipant,new pe.$Ahc(gt,Lt,Ke.getProxy(r.$kL.MainThreadBulkEdits))),zt=Ke.set(r.$lL.ExtHostEditors,new se.$igc(Ke,Te)),$i=Ke.set(r.$lL.ExtHostTreeViews,new Ye.$3hc(Ke.getProxy(r.$kL.MainThreadTreeViews),Be,gt)),Ii=Ke.set(r.$lL.ExtHostEditorInsets,new b.$jgc(Ke.getProxy(r.$kL.MainThreadEditorInsets),zt,$t.remote)),li=Ke.set(r.$lL.ExtHostDiagnostics,new F.$8fc(Ke,gt,Bt,Te)),hi=Ke.set(r.$lL.ExtHostLanguages,new ue.$yhc(Ke,wt,Be.converter,At)),dt=Ke.set(r.$lL.ExtHostLanguageFeatures,new fe.$_fc(Ke,At,wt,Be,li,gt,Pt,It)),Qi=Ke.set(r.$lL.ExtHostFileSystem,new ce.$ghc(Ke,dt)),ei=Ke.set(r.$lL.ExtHostFileSystemEventService,new ge.$hhc(Ke,gt,Te)),oi=Ke.set(r.$lL.ExtHostQuickOpen,(0,le.$Lhc)(Ke,ft,Be)),bi=Ke.set(r.$lL.ExtHostSCM,new je.$Nhc(Ke,Be,wt,gt)),Pi=Ke.set(r.$lL.ExtHostQuickDiff,new oe.$Khc(Ke,At)),Zi=Ke.set(r.$lL.ExtHostShare,new _e.$Ohc(Ke,At)),Li=Ke.set(r.$lL.ExtHostComments,(0,y.$kgc)(Ke,Be,wt)),pi=Ke.set(r.$lL.ExtHostProgress,new H.$Jhc(Ke.getProxy(r.$kL.MainThreadProgress))),Yi=Ke.set(r.$lL.ExtHostLabelService,new he.$xhc(Ke)),Ai=Ke.set(r.$lL.ExtHostTheming,new Ie.$Zhc(Ke)),di=Ke.set(r.$lL.ExtHostAuthentication,new h.$bgc(Ke)),Xi=Ke.set(r.$lL.ExtHostTimeline,new qe.$2hc(Ke,Be)),wi=Ke.set(r.$lL.ExtHostWebviews,new Ft.$ygc(Ke,$t.remote,ft,gt,Pt)),Ri=Ke.set(r.$lL.ExtHostWebviewPanels,new Et.$Bgc(Ke,wi,ft)),ln=Ke.set(r.$lL.ExtHostCustomEditors,new T.$Cgc(Ke,wt,jt,wi,Ri)),Ni=Ke.set(r.$lL.ExtHostWebviewViews,new Ht.$6hc(Ke,wi)),ai=Ke.set(r.$lL.ExtHostTesting,new ie.$Vhc(Ke,gt,Be,Te)),hn=Ke.set(r.$lL.ExtHostUriOpeners,new yt.$4hc(Ke)),dn=Ke.set(r.$lL.ExtHostProfileContentHandlers,new ee.$Ihc(Ke));Ke.set(r.$lL.ExtHostInteractive,new re.$vhc(Ke,Lt,Te,Be,gt));const xi=Ke.set(r.$lL.ExtHostInlineChat,new W.$ihc(Ke,Be,wt,gt)),Mi=Ke.set(r.$lL.ExtHostChatProvider,new u.$egc(Ke,gt)),Ti=Ke.set(r.$lL.ExtHostChatAgents2,new l.$fgc(Ke,Mi,gt)),_i=Ke.set(r.$lL.ExtHostChatVariables,new v.$ggc(Ke)),vi=Ke.set(r.$lL.ExtHostChat,new f.$dgc(Ke)),Fi=Ke.set(r.$lL.ExtHostAiRelatedInformation,new n.$3fc(Ke)),fn=Ke.set(r.$lL.ExtHostAiEmbeddingVector,new X.$fhc(Ke)),yi=Ke.set(r.$lL.ExtHostIssueReporter,new ye.$whc(Ke)),Oi=Ke.set(r.$lL.ExtHostStatusBar,new st.$Rhc(Ke,Be.converter)),ni=Ke.set(r.$lL.ExtHostSpeech,new at.$Phc(Ke)),Ei=Object.values(r.$lL);Ke.assertRegistered(Ei);const gn=new s.$cgc(Ke,Te),Xt=new I.$hgc(Ke),fi=new Y.$zhc(Ke,gt),ji=new N.$chc(Ke);return o.$agc.register(Be),function(We,ti,zi){function ot(be){return(Ee,Ue,ct)=>{const pt=be(Rt=>{try{Ee.call(Ue,Rt)}catch(Hi){M.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Hi.toString()}`,{cause:Hi})),It.onExtensionError(We.identifier,Hi)}});return ct?.push(pt),pt}}const bt=function(){let be=!We.isUnderDevelopment;function Ee(){be||(gt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Ee();else{const pt=ct;typeof pt.scheme>"u"&&Ee(),typeof pt.exclusive=="boolean"&&(0,et.$LF)(We,"documentFiltersExclusive")}return ct}}(),en={getSession(be,Ee,Ue){return di.getSession(We,be,Ee,Ue)},getSessions(be,Ee){return(0,et.$LF)(We,"authGetSessions"),di.getSessions(We,be,Ee)},async hasSession(be,Ee){return(0,et.$LF)(We,"authSession"),!!await di.getSession(We,be,Ee,{silent:!0})},get onDidChangeSessions(){return ot(di.onDidChangeSessions)},registerAuthenticationProvider(be,Ee,Ue,ct){return di.registerAuthenticationProvider(be,Ee,Ue,ct)}},mn={registerCommand(be,Ee,Ue){return Be.registerCommand(!0,be,Ee,Ue,void 0,We)},registerTextEditorCommand(be,Ee,Ue){return Be.registerCommand(!0,be,(...ct)=>{const pt=zt.getActiveTextEditor();if(!pt){gt.warn("Cannot execute "+be+" because there is no active text editor.");return}return pt.edit(Rt=>{Ee.apply(Ue,[pt,Rt,...ct])}).then(Rt=>{Rt||gt.warn("Edits from command "+be+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+be,Rt)})},void 0,void 0,We)},registerDiffInformationCommand:(be,Ee,Ue)=>((0,et.$LF)(We,"diffCommand"),Be.registerCommand(!0,be,async(...ct)=>{const pt=Te.activeEditor(!0);if(!pt){gt.warn("Cannot execute "+be+" because there is no active text editor.");return}const Rt=await zt.getDiffInformation(pt.id);Ee.apply(Ue,[Rt,...ct])},void 0,void 0,We)),executeCommand(be,...Ee){return Be.executeCommand(be,...Ee)},getCommands(be=!1){return Be.getCommands(be)}},tn={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Xt.value},get shell(){return xe.getDefaultShell(!1)},get onDidChangeShell(){return ot(xe.onDidChangeShell)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(It.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$LF)(We,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$LF)(We,"telemetry"),ot(It.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ae.$IN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,Ee){return Ae.$HN.validateSender(be),It.instantiateLogger(We,be,Ee)},openExternal(be,Ee){return Wt.openUri(be,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===$t.environment.appUriScheme)return Ct.createAppUri(be);try{return await Wt.asExternalUri(be,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,A.$fg)(be,A.Schemas.http)||(0,A.$fg)(be,A.Schemas.https))return be;throw Ee}},get remoteName(){return(0,m.$dl)($t.remote.authority)},get remoteAuthority(){return(0,et.$LF)(We,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return ot(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(be){return(0,et.$LF)(We,"handleIssueUri"),yi.registerIssueUriRequestHandler(We,be)},registerIssueDataProvider(be){return(0,et.$LF)(We,"handleIssueUri"),yi.registerIssueDataProvider(We,be)},get appQuality(){return(0,et.$LF)(We,"resolvers"),$t.quality},get appCommit(){return(0,et.$LF)(We,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController(be,Ee,Ue){return ai.createTestController(We,be,Ee,Ue)},createTestObserver(){return(0,et.$LF)(We,"testObserver"),ai.createTestObserver()},runTests(be){return(0,et.$LF)(We,"testObserver"),ai.runTests(be)},get onDidChangeTestResults(){return(0,et.$LF)(We,"testObserver"),ot(ai.onResultsChanged)},get testResults(){return(0,et.$LF)(We,"testObserver"),ai.results}},gi=$t.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,rn={getExtension(be,Ee){(0,et.$KF)(We,"extensionsAny")||(Ee=!1);const Ue=ti.mine.getExtensionDescription(be);if(Ue)return new Z.$4gc(kt,We.identifier,Ue,gi,!1);if(Ee){const ct=ti.all.getExtensionDescription(be);if(ct)return new Z.$4gc(kt,We.identifier,ct,gi,!0)}},get all(){const be=[];for(const Ee of ti.mine.getAllExtensionDescriptions())be.push(new Z.$4gc(kt,We.identifier,Ee,gi,!1));return be},get allAcrossExtensionHosts(){(0,et.$LF)(We,"extensionsAny");const be=new k.$om(ti.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of ti.all.getAllExtensionDescriptions()){const ct=!be.has(Ue.identifier);Ee.push(new Z.$4gc(kt,We.identifier,Ue,gi,ct))}return Ee},get onDidChange(){return(0,et.$KF)(We,"extensionsAny")?ot(d.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):ot(ti.mine.onDidChange)}},sn={createDiagnosticCollection(be){return li.createDiagnosticCollection(We.identifier,be)},get onDidChangeDiagnostics(){return ot(li.onDidChangeDiagnostics)},getDiagnostics:be=>li.getDiagnostics(be),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(be,Ee){return hi.changeLanguage(be.uri,Ee)},match(be,Ee){const Ue=wt.getDocumentData(Ee.uri)?.notebook;return(0,R.$Dt)(nt.LanguageSelector.from(be),Ee.uri,Ee.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(be,Ee,Ue){return dt.registerCodeActionProvider(We,bt(be),Ee,Ue)},registerDocumentPasteEditProvider(be,Ee,Ue){return(0,et.$LF)(We,"documentPaste"),dt.registerDocumentPasteEditProvider(We,bt(be),Ee,Ue)},registerCodeLensProvider(be,Ee){return dt.registerCodeLensProvider(We,bt(be),Ee)},registerDefinitionProvider(be,Ee){return dt.registerDefinitionProvider(We,bt(be),Ee)},registerDeclarationProvider(be,Ee){return dt.registerDeclarationProvider(We,bt(be),Ee)},registerImplementationProvider(be,Ee){return dt.registerImplementationProvider(We,bt(be),Ee)},registerTypeDefinitionProvider(be,Ee){return dt.registerTypeDefinitionProvider(We,bt(be),Ee)},registerHoverProvider(be,Ee){return dt.registerHoverProvider(We,bt(be),Ee,We.identifier)},registerEvaluatableExpressionProvider(be,Ee){return dt.registerEvaluatableExpressionProvider(We,bt(be),Ee,We.identifier)},registerInlineValuesProvider(be,Ee){return dt.registerInlineValuesProvider(We,bt(be),Ee,We.identifier)},registerDocumentHighlightProvider(be,Ee){return dt.registerDocumentHighlightProvider(We,bt(be),Ee)},registerMultiDocumentHighlightProvider(be,Ee){return dt.registerMultiDocumentHighlightProvider(We,bt(be),Ee)},registerLinkedEditingRangeProvider(be,Ee){return dt.registerLinkedEditingRangeProvider(We,bt(be),Ee)},registerReferenceProvider(be,Ee){return dt.registerReferenceProvider(We,bt(be),Ee)},registerRenameProvider(be,Ee){return dt.registerRenameProvider(We,bt(be),Ee)},registerDocumentSymbolProvider(be,Ee,Ue){return dt.registerDocumentSymbolProvider(We,bt(be),Ee,Ue)},registerWorkspaceSymbolProvider(be){return dt.registerWorkspaceSymbolProvider(We,be)},registerDocumentFormattingEditProvider(be,Ee){return dt.registerDocumentFormattingEditProvider(We,bt(be),Ee)},registerDocumentRangeFormattingEditProvider(be,Ee){return dt.registerDocumentRangeFormattingEditProvider(We,bt(be),Ee)},registerOnTypeFormattingEditProvider(be,Ee,Ue,...ct){return dt.registerOnTypeFormattingEditProvider(We,bt(be),Ee,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(be,Ee,Ue){return dt.registerDocumentSemanticTokensProvider(We,bt(be),Ee,Ue)},registerDocumentRangeSemanticTokensProvider(be,Ee,Ue){return dt.registerDocumentRangeSemanticTokensProvider(We,bt(be),Ee,Ue)},registerSignatureHelpProvider(be,Ee,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider(We,bt(be),Ee,Ue):dt.registerSignatureHelpProvider(We,bt(be),Ee,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(be,Ee,...Ue){return dt.registerCompletionItemProvider(We,bt(be),Ee,Ue)},registerInlineCompletionItemProvider(be,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,et.$LF)(We,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$LF)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$LF)(We,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(We,bt(be),Ee,Ue)},registerDocumentLinkProvider(be,Ee){return dt.registerDocumentLinkProvider(We,bt(be),Ee)},registerColorProvider(be,Ee){return dt.registerColorProvider(We,bt(be),Ee)},registerFoldingRangeProvider(be,Ee){return dt.registerFoldingRangeProvider(We,bt(be),Ee)},registerSelectionRangeProvider(be,Ee){return dt.registerSelectionRangeProvider(We,be,Ee)},registerCallHierarchyProvider(be,Ee){return dt.registerCallHierarchyProvider(We,be,Ee)},registerTypeHierarchyProvider(be,Ee){return dt.registerTypeHierarchyProvider(We,be,Ee)},setLanguageConfiguration:(be,Ee)=>dt.setLanguageConfiguration(We,be,Ee),getTokenInformationAtPosition(be,Ee){return(0,et.$LF)(We,"tokenInformation"),hi.tokenAtPosition(be,Ee)},registerInlayHintsProvider(be,Ee){return dt.registerInlayHintsProvider(We,be,Ee)},createLanguageStatusItem(be,Ee){return hi.createLanguageStatusItem(We,be,Ee)},registerDocumentDropEditProvider(be,Ee,Ue){return dt.registerDocumentOnDropEditProvider(We,be,Ee,(0,et.$KF)(We,"dropMetadata")?Ue:void 0)}},on={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return xe.activeTerminal},get terminals(){return xe.terminals},async showTextDocument(be,Ee,Ue){$.URI.isUri(be)&&be.scheme===A.Schemas.vscodeRemote&&!be.authority&&Pt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(be)?Promise.resolve(an.openTextDocument(be)):Promise.resolve(be));return zt.showTextDocument(ct,Ee,Ue)},createTextEditorDecorationType(be){return zt.createTextEditorDecorationType(We,be)},onDidChangeActiveTextEditor(be,Ee,Ue){return ot(zt.onDidChangeActiveTextEditor)(be,Ee,Ue)},onDidChangeVisibleTextEditors(be,Ee,Ue){return ot(zt.onDidChangeVisibleTextEditors)(be,Ee,Ue)},onDidChangeTextEditorSelection(be,Ee,Ue){return ot(zt.onDidChangeTextEditorSelection)(be,Ee,Ue)},onDidChangeTextEditorOptions(be,Ee,Ue){return ot(zt.onDidChangeTextEditorOptions)(be,Ee,Ue)},onDidChangeTextEditorVisibleRanges(be,Ee,Ue){return ot(zt.onDidChangeTextEditorVisibleRanges)(be,Ee,Ue)},onDidChangeTextEditorViewColumn(be,Ee,Ue){return ot(zt.onDidChangeTextEditorViewColumn)(be,Ee,Ue)},onDidCloseTerminal(be,Ee,Ue){return ot(xe.onDidCloseTerminal)(be,Ee,Ue)},onDidOpenTerminal(be,Ee,Ue){return ot(xe.onDidOpenTerminal)(be,Ee,Ue)},onDidChangeActiveTerminal(be,Ee,Ue){return ot(xe.onDidChangeActiveTerminal)(be,Ee,Ue)},onDidChangeTerminalDimensions(be,Ee,Ue){return(0,et.$LF)(We,"terminalDimensions"),ot(xe.onDidChangeTerminalDimensions)(be,Ee,Ue)},onDidChangeTerminalState(be,Ee,Ue){return ot(xe.onDidChangeTerminalState)(be,Ee,Ue)},onDidWriteTerminalData(be,Ee,Ue){return(0,et.$LF)(We,"terminalDataWriteEvent"),ot(xe.onDidWriteTerminalData)(be,Ee,Ue)},onDidExecuteTerminalCommand(be,Ee,Ue){return(0,et.$LF)(We,"terminalExecuteCommandEvent"),ot(xe.onDidExecuteTerminalCommand)(be,Ee,Ue)},get state(){return Wt.getState(We)},onDidChangeWindowState(be,Ee,Ue){return ot(Wt.onDidChangeWindowState)(be,Ee,Ue)},showInformationMessage(be,...Ee){return fi.showMessage(We,w.default.Info,be,Ee[0],Ee.slice(1))},showWarningMessage(be,...Ee){return fi.showMessage(We,w.default.Warning,be,Ee[0],Ee.slice(1))},showErrorMessage(be,...Ee){return fi.showMessage(We,w.default.Error,be,Ee[0],Ee.slice(1))},showQuickPick(be,Ee,Ue){return oi.showQuickPick(We,be,Ee,Ue)},showWorkspaceFolderPick(be){return oi.showWorkspaceFolderPick(be)},showInputBox(be,Ee){return oi.showInput(be,Ee)},showOpenDialog(be){return ji.showOpenDialog(We,be)},showSaveDialog(be){return ji.showSaveDialog(be)},createStatusBarItem(be,Ee,Ue){let ct,pt,Rt;return typeof be=="string"?(ct=be,pt=Ee,Rt=Ue):(pt=be,Rt=Ee),Oi.createStatusBarEntry(We,ct,pt,Rt)},setStatusBarMessage(be,Ee){return Oi.setStatusBarMessage(be,Ee)},withScmProgress(be){return Pt.report("window.withScmProgress",We,"Use 'withProgress' instead."),pi.withProgress(We,{location:Oe.ProgressLocation.SourceControl},(Ee,Ue)=>be({report(ct){}}))},withProgress(be,Ee){return pi.withProgress(We,be,Ee)},createOutputChannel(be,Ee){return Jt.createOutputChannel(be,Ee,We)},createWebviewPanel(be,Ee,Ue,ct){return Ri.createWebviewPanel(We,be,Ee,Ue,ct)},createWebviewTextEditorInset(be,Ee,Ue,ct){return(0,et.$LF)(We,"editorInsets"),Ii.createWebviewEditorInset(be,Ee,Ue,ct,We)},createTerminal(be,Ee,Ue){return typeof be=="object"?"pty"in be?xe.createExtensionTerminal(be):xe.createTerminalFromOptions(be):xe.createTerminal(be,Ee,Ue)},registerTerminalLinkProvider(be){return xe.registerLinkProvider(be)},registerTerminalProfileProvider(be,Ee){return xe.registerProfileProvider(We,be,Ee)},registerTerminalQuickFixProvider(be,Ee){return(0,et.$LF)(We,"terminalQuickFixProvider"),xe.registerTerminalQuickFixProvider(be,We.identifier.value,Ee)},registerTreeDataProvider(be,Ee){return $i.registerTreeDataProvider(be,Ee,We)},createTreeView(be,Ee){return $i.createTreeView(be,Ee,We)},registerWebviewPanelSerializer:(be,Ee)=>Ri.registerWebviewPanelSerializer(We,be,Ee),registerCustomEditorProvider:(be,Ee,Ue={})=>ln.registerCustomEditorProvider(We,be,Ee,Ue),registerFileDecorationProvider(be){return ae.registerFileDecorationProvider(be,We)},registerUriHandler(be){return Ct.registerUriHandler(We,be)},createQuickPick(){return oi.createQuickPick(We)},createInputBox(){return oi.createInputBox(We)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(be,Ee,Ue){return ot(Ai.onDidChangeActiveColorTheme)(be,Ee,Ue)},registerWebviewViewProvider(be,Ee,Ue){return Ni.registerWebviewViewProvider(We,be,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return Lt.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,Ee,Ue){return ot(Lt.onDidChangeActiveNotebookEditor)(be,Ee,Ue)},get visibleNotebookEditors(){return Lt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Lt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(be,Ee,Ue){return ot(mi.onDidChangeNotebookEditorSelection)(be,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges(be,Ee,Ue){return ot(mi.onDidChangeNotebookEditorVisibleRanges)(be,Ee,Ue)},showNotebookDocument(be,Ee){return Lt.showNotebookDocument(be,Ee)},registerExternalUriOpener(be,Ee,Ue){return(0,et.$LF)(We,"externalUriOpener"),hn.registerExternalUriOpener(We.identifier,be,Ee,Ue)},registerProfileContentHandler(be,Ee){return(0,et.$LF)(We,"profileContentHandlers"),dn.registerProfileContentHandler(We,be,Ee)},registerQuickDiffProvider(be,Ee,Ue,ct){return(0,et.$LF)(We,"quickDiffProvider"),Pi.registerQuickDiffProvider(bt(be),Ee,Ue,ct)},get tabGroups(){return Fe.tabGroups},registerShareProvider(be,Ee){return(0,et.$LF)(We,"shareProvider"),Zi.registerShareProvider(bt(be),Ee)}},an={get rootPath(){return Pt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(be){throw new M.$9("rootPath")},getWorkspaceFolder(be){return ft.getWorkspaceFolder(be)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(be){throw new M.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(be){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(be,Ee,...Ue)=>ft.updateWorkspaceFolders(We,be,Ee||0,...Ue),onDidChangeWorkspaceFolders:function(be,Ee,Ue){return ot(ft.onDidChangeWorkspace)(be,Ee,Ue)},asRelativePath:(be,Ee)=>ft.getRelativePath(be,Ee),findFiles:(be,Ee,Ue,ct)=>ft.findFiles(be,Ee,Ue,We.identifier,ct),findTextInFiles:(be,Ee,Ue,ct)=>{(0,et.$LF)(We,"findTextInFiles");let pt,Rt;return typeof Ee=="object"?(pt=Ee,Rt=Ue):(pt={},Rt=Ee,ct=Ue),ft.findTextInFiles(be,pt||{},Rt,We.identifier,ct)},save:be=>ft.save(be),saveAs:be=>ft.saveAs(be),saveAll:be=>ft.saveAll(be),applyEdit(be,Ee){return gn.applyWorkspaceEdit(be,We,Ee)},createFileSystemWatcher:(be,Ee,Ue,ct)=>{let pt;return typeof Ee=="boolean"?pt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:Ee&&((0,et.$LF)(We,"createFileSystemWatcher"),pt={...Ee,correlate:!0}),ei.createFileSystemWatcher(ft,We,be,pt)},get textDocuments(){return wt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw new M.$9("textDocuments")},openTextDocument(be){let Ee;const Ue=be;if(typeof be=="string")Ee=Promise.resolve($.URI.file(be));else if($.URI.isUri(be))Ee=Promise.resolve(be);else if(!Ue||typeof Ue=="object")Ee=wt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ct=>(ct.scheme===A.Schemas.vscodeRemote&&!ct.authority&&Pt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),wt.ensureDocumentData(ct).then(pt=>pt.document)))},onDidOpenTextDocument:(be,Ee,Ue)=>ot(wt.onDidAddDocument)(be,Ee,Ue),onDidCloseTextDocument:(be,Ee,Ue)=>ot(wt.onDidRemoveDocument)(be,Ee,Ue),onDidChangeTextDocument:(be,Ee,Ue)=>ot(wt.onDidChangeDocument)(be,Ee,Ue),onDidSaveTextDocument:(be,Ee,Ue)=>ot(wt.onDidSaveDocument)(be,Ee,Ue),onWillSaveTextDocument:(be,Ee,Ue)=>ot(Ki.getOnWillSaveTextDocumentEvent(We))(be,Ee,Ue),get notebookDocuments(){return Lt.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,Ee){let Ue;if($.URI.isUri(be))Ue=be,await Lt.openNotebookDocument(be);else if(typeof be=="string")Ue=$.URI.revive(await Lt.createNotebookDocument({viewType:be,content:Ee}));else throw new Error("Invalid arguments");return Lt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(be,Ee,Ue){return ot(si.onDidSaveNotebookDocument)(be,Ee,Ue)},onDidChangeNotebookDocument(be,Ee,Ue){return ot(si.onDidChangeNotebookDocument)(be,Ee,Ue)},onWillSaveNotebookDocument(be,Ee,Ue){return ot(Ci.getOnWillSaveNotebookDocumentEvent(We))(be,Ee,Ue)},get onDidOpenNotebookDocument(){return ot(Lt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Lt.onDidCloseNotebookDocument)},registerNotebookSerializer(be,Ee,Ue,ct){return Lt.registerNotebookSerializer(We,be,Ee,Ue,(0,et.$KF)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(be,Ee,Ue)=>ot(zi.onDidChangeConfiguration)(be,Ee,Ue),getConfiguration(be,Ee){return Ee=arguments.length===1?void 0:Ee,zi.getConfiguration(be,Ee,We)},registerTextDocumentContentProvider(be,Ee){return Si.registerTextDocumentContentProvider(be,Ee)},registerTaskProvider:(be,Ee)=>(Pt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(We,be,Ee)),registerFileSystemProvider(be,Ee,Ue){return(0,P.$Qc)(Qi.registerFileSystemProvider(We,be,Ee,Ue),Qt.addFileSystemProvider(be,Ee,Ue))},get fs(){return Qt.value},registerFileSearchProvider:(be,Ee)=>((0,et.$LF)(We,"fileSearchProvider"),ut.registerFileSearchProvider(be,Ee)),registerTextSearchProvider:(be,Ee)=>((0,et.$LF)(We,"textSearchProvider"),ut.registerTextSearchProvider(be,Ee)),registerRemoteAuthorityResolver:(be,Ee)=>((0,et.$LF)(We,"resolvers"),kt.registerRemoteAuthorityResolver(be,Ee)),registerResourceLabelFormatter:be=>((0,et.$LF)(We,"resolvers"),Yi.$registerResourceLabelFormatter(be)),getRemoteExecServer:be=>((0,et.$LF)(We,"resolvers"),kt.getRemoteExecServer(be)),onDidCreateFiles:(be,Ee,Ue)=>ot(ei.onDidCreateFile)(be,Ee,Ue),onDidDeleteFiles:(be,Ee,Ue)=>ot(ei.onDidDeleteFile)(be,Ee,Ue),onDidRenameFiles:(be,Ee,Ue)=>ot(ei.onDidRenameFile)(be,Ee,Ue),onWillCreateFiles:(be,Ee,Ue)=>ot(ei.getOnWillCreateFileEvent(We))(be,Ee,Ue),onWillDeleteFiles:(be,Ee,Ue)=>ot(ei.getOnWillDeleteFileEvent(We))(be,Ee,Ue),onWillRenameFiles:(be,Ee,Ue)=>ot(ei.getOnWillRenameFileEvent(We))(be,Ee,Ue),openTunnel:be=>((0,et.$LF)(We,"tunnels"),Mt.openTunnel(We,be).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$LF)(We,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(be,Ee,Ue)=>((0,et.$LF)(We,"tunnels"),ot(Mt.onDidChangeTunnels)(be,Ee,Ue)),registerPortAttributesProvider:(be,Ee)=>((0,et.$LF)(We,"portsAttributes"),Mt.registerPortsAttributesProvider(be,Ee)),registerTunnelProvider:(be,Ee)=>((0,et.$LF)(We,"tunnelFactory"),Mt.registerTunnelProvider(be,Ee)),registerTimelineProvider:(be,Ee)=>((0,et.$LF)(We,"timeline"),Xi.registerTimelineProvider(be,Ee,We.identifier,Be.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:be=>((0,et.$LF)(We,"workspaceTrust"),ft.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,Ee,Ue)=>ot(ft.onDidGrantWorkspaceTrust)(be,Ee,Ue),registerEditSessionIdentityProvider:(be,Ee)=>((0,et.$LF)(We,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(be,Ee)),onWillCreateEditSessionIdentity:(be,Ee,Ue)=>((0,et.$LF)(We,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(We))(be,Ee,Ue)),registerCanonicalUriProvider:(be,Ee)=>((0,et.$LF)(We,"canonicalUriProvider"),ft.registerCanonicalUriProvider(be,Ee)),getCanonicalUri:(be,Ee,Ue)=>((0,et.$LF)(We,"canonicalUriProvider"),ft.provideCanonicalUri(be,Ee,Ue))},$n={get inputBox(){return Pt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(We)},createSourceControl(be,Ee,Ue){return bi.createSourceControl(We,be,Ee,Ue)}},cn={createCommentController(be,Ee){return Li.createCommentController(We,be,Ee)}},un={get activeDebugSession(){return Je.activeDebugSession},get activeDebugConsole(){return Je.activeDebugConsole},get breakpoints(){return Je.breakpoints},get stackFrameFocus(){return Je.stackFrameFocus},registerDebugVisualizationProvider(be,Ee){return(0,et.$LF)(We,"debugVisualization"),Je.registerDebugVisualizationProvider(We,be,Ee)},onDidStartDebugSession(be,Ee,Ue){return ot(Je.onDidStartDebugSession)(be,Ee,Ue)},onDidTerminateDebugSession(be,Ee,Ue){return ot(Je.onDidTerminateDebugSession)(be,Ee,Ue)},onDidChangeActiveDebugSession(be,Ee,Ue){return ot(Je.onDidChangeActiveDebugSession)(be,Ee,Ue)},onDidReceiveDebugSessionCustomEvent(be,Ee,Ue){return ot(Je.onDidReceiveDebugSessionCustomEvent)(be,Ee,Ue)},onDidChangeBreakpoints(be,Ee,Ue){return ot(Je.onDidChangeBreakpoints)(be,Ee,Ue)},onDidChangeStackFrameFocus(be,Ee,Ue){return(0,et.$LF)(We,"debugFocus"),ot(Je.onDidChangeStackFrameFocus)(be,Ee,Ue)},registerDebugConfigurationProvider(be,Ee,Ue){return Je.registerDebugConfigurationProvider(be,Ee,Ue||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,Ee){return Je.registerDebugAdapterDescriptorFactory(We,be,Ee)},registerDebugAdapterTrackerFactory(be,Ee){return Je.registerDebugAdapterTrackerFactory(be,Ee)},startDebugging(be,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Je.startDebugging(be,Ee,{parentSession:Ue}):Je.startDebugging(be,Ee,Ue||{})},stopDebugging(be){return Je.stopDebugging(be)},addBreakpoints(be){return Je.addBreakpoints(be)},removeBreakpoints(be){return Je.removeBreakpoints(be)},asDebugSourceUri(be,Ee){return Je.asDebugSourceUri(be,Ee)}},Ui={registerTaskProvider:(be,Ee)=>vt.registerTaskProvider(We,be,Ee),fetchTasks:be=>vt.fetchTasks(be),executeTask:be=>vt.executeTask(We,be),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(be,Ee,Ue)=>ot(vt.onDidStartTask)(be,Ee,Ue),onDidEndTask:(be,Ee,Ue)=>ot(vt.onDidEndTask)(be,Ee,Ue),onDidStartTaskProcess:(be,Ee,Ue)=>ot(vt.onDidStartTaskProcess)(be,Ee,Ue),onDidEndTaskProcess:(be,Ee,Ue)=>ot(vt.onDidEndTaskProcess)(be,Ee,Ue)},Bi={createNotebookController(be,Ee,Ue,ct,pt){return ui.createNotebookController(We,be,Ee,Ue,ct,(0,et.$KF)(We,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(be,Ee)=>Lt.registerNotebookCellStatusBarItemProvider(We,be,Ee),createRendererMessaging(be){return Di.createRendererMessaging(We,be)},createNotebookControllerDetectionTask(be){return(0,et.$LF)(We,"notebookKernelSource"),ui.createNotebookControllerDetectionTask(We,be)},registerKernelSourceActionProvider(be,Ee){return(0,et.$LF)(We,"notebookKernelSource"),ui.registerKernelSourceActionProvider(We,be,Ee)},onDidChangeNotebookCellExecutionState(be,Ee,Ue){return(0,et.$LF)(We,"notebookCellExecutionState"),ot(ui.onDidChangeNotebookCellExecutionState)(be,Ee,Ue)}},Wi={t(...be){if(typeof be[0]=="string"){const Ee=be.shift(),Ue=!be||typeof be[0]!="object"?be:be[0];return St.getMessage(We.identifier.value,{message:Ee,args:Ue})}return St.getMessage(We.identifier.value,be[0])},get bundle(){return St.getBundle(We.identifier.value)},get uri(){return St.getBundleUri(We.identifier.value)}},ki={_version:1,registerInteractiveEditorSessionProvider(be,Ee){return(0,et.$LF)(We,"interactive"),xi.registerProvider(We,be,Ee)},registerInteractiveSessionProvider(be,Ee){return(0,et.$LF)(We,"interactive"),vi.registerChatProvider(We,be,Ee)},sendInteractiveRequestToProvider(be,Ee){return(0,et.$LF)(We,"interactive"),vi.sendInteractiveRequestToProvider(be,Ee)},transferChatSession(be,Ee){return(0,et.$LF)(We,"interactive"),vi.transferChatSession(be,Ee)}},Vi={getRelatedInformation(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),Fi.getRelatedInformation(We,be,Ee)},registerRelatedInformationProvider(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),Fi.registerRelatedInformationProvider(We,be,Ee)},registerEmbeddingVectorProvider(be,Ee){return(0,et.$LF)(We,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(We,be,Ee)}},qi={registerChatResponseProvider(be,Ee,Ue){return(0,et.$LF)(We,"chatProvider"),Mi.registerProvider(We.identifier,be,Ee,Ue)},requestChatAccess(be){return(0,et.$LF)(We,"chatRequestAccess"),Mi.requestChatResponseProvider(We.identifier,be)},registerVariable(be,Ee,Ue){return(0,et.$LF)(We,"chatAgents2"),_i.registerVariableResolver(We,be,Ee,Ue)},registerMappedEditsProvider(be,Ee){return(0,et.$LF)(We,"mappedEditsProvider"),dt.registerMappedEditsProvider(We,be,Ee)},createChatAgent(be,Ee){return(0,et.$LF)(We,"chatAgents2"),Ti.createChatAgent(We,be,Ee)}},bn={registerSpeechProvider(be,Ee){return(0,et.$LF)(We,"speech"),ni.registerProvider(We.identifier,be,Ee)}};return{version:$t.version,ai:Vi,authentication:en,commands:mn,comments:cn,chat:qi,debug:un,env:tn,extensions:rn,interactive:ki,l10n:Wi,languages:sn,notebooks:Bi,scm:$n,speech:bn,tasks:Ui,tests:nn,window:on,workspace:an,Breakpoint:Oe.$lM,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$eN,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$dN,CallHierarchyIncomingCall:Oe.$KL,CallHierarchyItem:Oe.$JL,CallHierarchyOutgoingCall:Oe.$LL,CancellationError:M.$5,CancellationTokenSource:D.$7d,CandidatePortSource:r.CandidatePortSource,CodeAction:Oe.$GL,CodeActionKind:Oe.$HL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$ML,Color:Oe.$ZL,ColorInformation:Oe.$1L,ColorPresentation:Oe.$2L,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$TL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$UL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$0L,DebugAdapterExecutable:Oe.$pM,DebugAdapterInlineImplementation:Oe.$sM,DebugAdapterNamedPipeServer:Oe.$rM,DebugAdapterServer:Oe.$qM,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.$HM,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$AL,DiagnosticRelatedInformation:Oe.$zL,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$mL,DocumentHighlight:Oe.$CL,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$DL,DocumentLink:Oe.$YL,DocumentSymbol:Oe.$FL,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$vM,InlineValueText:Oe.$wM,InlineValueVariableLookup:Oe.$xM,InlineValueEvaluatableExpression:Oe.$yM,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:d.$Wd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$JM,FileDecoration2:Oe.$JM,FileSystemError:Oe.$AM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$BM,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$nM,InlineCompletionItem:Oe.$VL,InlineCompletionList:Oe.$WL,Hover:Oe.$BL,IndentAction:C.IndentAction,Location:Oe.$yL,MarkdownString:Oe.$NL,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Oe.$OL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$nL,ProcessExecution:Oe.$8L,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$IM,Range:Oe.$oL,RelativePattern:Oe.$jM,Selection:Oe.$pL,SelectionRange:Oe.$IL,SemanticTokens:Oe.$EM,SemanticTokensBuilder:Oe.$DM,SemanticTokensEdit:Oe.$FM,SemanticTokensEdits:Oe.$GM,SemanticTokensLegend:Oe.$CM,ShellExecution:Oe.$9L,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$QL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$PL,SnippetString:Oe.$xL,SourceBreakpoint:Oe.$mM,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$EL,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$$L,TaskGroup:Oe.$7L,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$3L,TerminalQuickFixTerminalCommand:Oe.$5L,TerminalQuickFixOpener:Oe.$4L,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$6L,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$tL,SnippetTextEdit:Oe.$vL,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$iM,ThemeIcon:Oe.$hM,TreeItem:Oe.$_L,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$5M,UIKind:Ut.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$wL,DocumentDropEdit:Oe.$fM,DocumentPasteEdit:Oe.$gM,InlayHint:Oe.$SL,InlayHintLabelPart:Oe.$RL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$sL,ResolvedAuthority:Oe.$qL,ManagedResolvedAuthority:Oe.$rL,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$TM,NotebookRange:Oe.$LM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$MM,NotebookData:Oe.$NM,NotebookRendererScript:Oe.$RM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$PM,NotebookCellOutputItem:Oe.$OM,NotebookCellStatusBarItem:Oe.$QM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$uL,NotebookKernelSourceAction:Oe.$SM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$VM,LinkedEditingRanges:Oe.$UM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$WM,TestMessage:Oe.$XM,TestMessage2:Oe.$XM,TestTag:Oe.$YM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$eM,DataTransferItem:Oe.$aM,CoveredCount:Oe.$ZM,FileCoverage:Oe.$1M,StatementCoverage:Oe.$2M,BranchCoverage:Oe.$3M,FunctionCoverage:Oe.$4M,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$6M,TabInputTextDiff:Oe.$7M,TabInputTextMerge:Oe.$8M,TabInputCustom:Oe.$9M,TabInputNotebook:Oe.$$M,TabInputNotebookDiff:Oe.$_M,TabInputWebview:Oe.$0M,TabInputTerminal:Oe.$aN,TabInputInteractiveWindow:Oe.$bN,TabInputChat:Oe.$cN,TelemetryTrustedValue:a.$No,LogLevel:c.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$tM,ThreadFocus:Oe.$uM,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus}}}e.$9hc=Kt}),define(ke[371],Se([1,0,84,152,41,147,42,33,73,46,95,96,97,117,71,91,146,70,59,116,90,72,145,12,60,114,115]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h,s,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$1r)(f.$Xgc,f.$Wgc,1),(0,D.$1r)(h.$qj,t.$0hc,1),(0,D.$1r)(c.$9fc,c.$0fc,1),(0,D.$1r)(w.$LN,w.$KN,0),(0,D.$1r)(A.$rgc,A.$pgc,0),(0,D.$1r)(a.$tgc,a.$sgc,0),(0,D.$1r)(C.$8gc,C.$_gc,0),(0,D.$1r)(P.$bhc,P.$ahc,0),(0,D.$1r)($.$AN,$.$zN,0),(0,D.$1r)(l.$Ygc,l.$Zgc,0),(0,D.$1r)(i.$6fc,i.$5fc,0),(0,D.$1r)(M.$Hhc,M.$Ghc,1),(0,D.$1r)(p.$rhc,p.$shc,0),(0,D.$1r)(k.$Mgc,k.$Lgc,0),(0,D.$1r)(R.$Uhc,R.$Thc,0),(0,D.$1r)(E.$Pgc,E.$Sgc,0),(0,D.$1r)(S.$hzb,S.$izb,0),(0,D.$1r)(m.$8hc,m.$7hc,0),(0,D.$1r)(d.$ogc,d.$ngc,0),(0,D.$1r)(r.$Ugc,r.$Tgc,0),(0,D.$1r)(n.$JN,n.$GN,0),(0,D.$1r)(o.$Dgc,o.$Egc,0),(0,D.$1r)(s.$6gc,s.$7gc,0)}),define(ke[119],Se([1,0,19,12,36,94]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=e.$oic=e.$nic=void 0;function A(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$nic=A;function w(C,p,k,S){const c=(0,D.$2b)(k,$),m=new d.$LJ(p,c,S),a=m.preview.matches;return{ranges:(0,D.$2b)(c,E),uri:C,preview:{text:m.preview.text,matches:(0,D.$2b)(a,E)}}}e.$oic=w;function $(C){return new d.$MJ(C.start.line,C.start.character,C.end.line,C.end.character)}function E(C){return new P.$AJ(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(p,k){this.a=p,this.b=k}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$pic=R,e.$pic=R=Ge([Ve(1,M.$pj)],R)}),define(ke[372],Se([1,0,50,17,77,34,11,13,119,373]),function($e,e,D,M,d,P,A,w,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=e.$qic=void 0;const R=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(r,n,o,t){const h=p(r,n,o,t),s=n.folder.fsPath;return{cmd:D.spawn(R,h.args,{cwd:s}),rgDiskPath:R,siblingClauses:h.siblingClauses,rgArgs:h,cwd:s}}e.$qic=C;function p(r,n,o,t){const h=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],o,!1).forEach(f=>{const l=(0,$.$nic)(f);if(h.push("-g",l),A.$j){const u=(0,d.$Jl)(l);u!==l&&h.push("-g",u)}});const s=k([n],t,void 0,!1);return s.globArgs.forEach(f=>{const l=`!${(0,$.$nic)(f)}`;if(h.push("-g",l),A.$j){const u=(0,d.$Jl)(l);u!==l&&h.push("-g",u)}}),n.disregardIgnoreFiles!==!1?h.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),n.ignoreSymlinks||h.push("--follow"),r.exists&&h.push("--quiet"),h.push("--no-config"),n.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:s.siblingClauses}}function k(r,n,o,t=!0){const h=[];let s={};return r.forEach(f=>{const l=Object.assign({},f.excludePattern||{},n||{}),u=c(l,t?f.folder.fsPath:void 0,o);h.push(...u.globArgs),u.siblingClauses&&(s=Object.assign(s,u.siblingClauses))}),{globArgs:h,siblingClauses:s}}function S(r,n,o=!0){const t=[];return r.forEach(h=>{const s=Object.assign({},n||{},h.includePattern||{}),f=c(s,o?h.folder.fsPath:void 0);t.push(...f.globArgs)}),t}function c(r,n,o){const t=[],h={};return Object.keys(r).forEach(s=>{if(o&&o.has(s)||!s)return;const f=r[s];s=a(n?m(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof f=="boolean"&&f?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):f&&f.when&&(h[s]=f)}),{globArgs:t,siblingClauses:h}}function m(r,n){return M.$ic(n)?n:M.$jc(r,n)}e.$ric=m;function a(r){return r=w.$Ve(r,"\\"),w.$Ve(r,"/")}function i(r){return P.$5f(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.$sic=i}),define(ke[374],Se([1,0,50,57,17,375,19,44,35,77,34,11,38,13,18,31,36,372,129]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(f){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=f,this.b=f.filePattern||"",this.d=f.includePattern&&$.$Oj(f.includePattern),this.f=f.maxResults||null,this.g=!!f.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$2q)(this.b).normalizedLowercase),this.u=f.excludePattern&&$.$Oj(f.excludePattern),this.t=new Map,f.folderQueries.forEach(l=>{const u=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),v=l.folder.fsPath;f.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==v).forEach(I=>{(0,R.$9f)(I,v)&&(u[d.$lc(v,I)]=!0)}),this.t.set(v,new t(u,v))})}cancel(){this.l=!0,r.forEach(f=>f())}walk(f,l,u,v,I){if(this.m=p.$Sd.create(!1),this.l)return I(null,this.j);l.forEach(b=>{const g=d.$nc(b.fsPath);this.u&&this.u(b.fsPath,g)||this.J(u,{relativePath:b.fsPath,searchPath:void 0})}),this.r=p.$Sd.create(!1),this.w(f,(b,g)=>{this.x(this.y,this,b,u,v,y=>{if(y){const L=(0,w.$Si)(y);console.error(L),this.q.push(L),g(y,void 0)}else g(null,void 0)})},(b,g)=>{this.m.stop();const y=b?A.$Hb(b)[0]:null;I(y,this.j)})}w(f,l,u){const v=new Array(f.length),I=new Array(f.length);let b=!1,g=0;if(f.length===0)return u(null,[]);f.forEach((y,L)=>{l(y,(T,U)=>{if(T?(b=!0,v[L]=null,I[L]=T):(v[L]=U,I[L]=null),++g===f.length)return u(b?I:null,v)})})}x(f,l,...u){try{f.apply(l,u)}catch(v){u[u.length-1](v)}}y(f,l,u,v){const I=f.folder.fsPath,b=C.$j,g=()=>j&&j.kill();r.add(g);let y=z=>{r.delete(g),y=()=>{},v(z)},L="";const T=this.D(),U=(0,a.$qic)(this.a,f,this.a.includePattern,this.t.get(f.folder.fsPath).expression),j=U.cmd,F=!Object.keys(U.siblingClauses).length,N=U.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let O=`${U.rgDiskPath} ${N}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),u({message:O}),this.s=0,this.z(j,"utf8",u,(z,K,te)=>{if(z){y(z);return}if(this.j){y();return}const X=(L+(b?E.$Il(K||""):K)).split(`
`);if(te){const Z=X.length;X[Z-1]=X[Z-1].trim(),X[Z-1]||X.pop()}else L=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=X.length,F){for(const Z of X)if(this.J(l,{base:I,relativePath:Z,searchPath:this.N(f,Z)}),this.j){g();break}(te||this.j)&&y();return}this.G(f,T,I,X,l),te&&(this.H(T,I,l),y())})}spawnFindCmd(f){const l=this.t.get(f.folder.fsPath),u=l.getBasenameTerms(),v=l.getPathTerms(),I=["-L","."];if(u.length||v.length){I.push("-not","(","(");for(const b of u)I.push("-name",b),I.push("-o");for(const b of v)I.push("-path",b),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),D.spawn("find",I,{cwd:f.folder.fsPath})}readStdout(f,l,u){let v="";this.z(f,l,()=>{},(I,b,g)=>{if(I){u(I);return}v+=b,g&&u(null,v)})}z(f,l,u,v){let I=(y,L,T)=>{(y||T)&&(I=()=>{},this.r?.stop()),v(y,L,T)},b=!1;f.stdout?(this.A(f.stdout,l,I),f.stdout.once("data",()=>b=!0)):u({message:"stdout is null"});let g;f.stderr?g=this.B(f.stderr):u({message:"stderr is null"}),f.on("error",y=>{I(y)}),f.on("close",y=>{let L;!b&&(L=this.C(g,l))&&h(L)?I(new Error(`command failed with error code ${y}: ${this.C(g,l)}`)):(this.g&&y===0&&(this.j=!0),I(null,"",!0))})}A(f,l,u){const v=new P.StringDecoder(l);return f.on("data",I=>{u(null,v.write(I))}),v}B(f){const l=[];return f.on("data",u=>{l.push(u)}),l}C(f,l){const u=new P.StringDecoder(l);return f.map(v=>u.write(v)).join("")}D(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}G(f,{pathToEntries:l},u,v,I){v.indexOf(this.b)!==-1&&this.J(I,{base:u,relativePath:this.b,searchPath:this.N(f,this.b)});const b=g=>{const y=d.$nc(g),L=d.$mc(g);let T=l[L];T||(T=l[L]=[],b(L)),T.push({base:u,relativePath:g,basename:y,searchPath:this.N(f,g)})};v.forEach(b)}H({rootEntries:f,pathToEntries:l},u,v){const I=this,b=this.t.get(u),g=this.b;function y(L){I.o++;const T=(0,m.$2J)(()=>L.map(U=>U.basename));for(let U=0,j=L.length;U<j;U++){const F=L[U],{relativePath:N,basename:O}=F;if(b.test(N,O,g!==O?T:void 0))continue;const z=l[N];if(z)y(z);else{if(I.p++,N===g)continue;I.J(v,F)}if(I.j)break}}y(f)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(f,l,u,v,I){const b=f.folder,g=(0,m.$2J)(()=>u);this.w(u,(y,L)=>{if(this.l||this.j)return L(null);const T=l?[l,y].join(d.sep):y;if(this.t.get(f.folder.fsPath).test(T,y,this.a.filePattern!==y?g:void 0))return L(null);const U=[b.fsPath,T].join(d.sep);M.lstat(U,(j,F)=>{if(j||this.l||this.j)return L(null);this.L(U,F,(N,O)=>N||this.l||this.j?L(null):O.isDirectory()?(this.o++,this.M(U,F,(z,K)=>z||this.l||this.j||(K=K||"",this.v[K])?L(null):(this.v[K]=!0,c.Promises.readdir(U).then(te=>{if(this.l||this.j)return L(null);this.I(f,T,te,v,x=>L(x||null))},te=>{L(null)})))):(this.p++,T===this.b||this.h&&S.$Nf(O.size)&&O.size>this.h||this.J(v,{base:b.fsPath,relativePath:T,searchPath:this.N(f,T)}),L(null,void 0)))})},y=>{const L=y&&A.$Hb(y);return I(L&&L.length>0?L[0]:void 0)})}J(f,l){this.K(l)&&(!this.d||this.d(l.relativePath,d.$nc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||f(l))}K(f){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$WJ)(f,this.c)}return!0}L(f,l,u){return l.isSymbolicLink()?M.stat(f,u):u(null,l)}M(f,l,u){return l.isSymbolicLink()?M.realpath(f,(v,I)=>v?u(v):u(null,I)):u(null,f)}N(f,l){return f.folderName?d.$jc(f.folderName,l):l}}e.$tic=n;class o{constructor(f){this.a=f.folderQueries,this.b=f.extraFileResources||[],this.c=new n(f)}search(f,l,u){this.c.walk(this.a,this.b,f,l,(v,I)=>{u(v,{limitHit:I,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$uic=o;class t{constructor(f,l){this.expression=f,this.c=l,this.d(f)}d(f){let l,u;Object.keys(f).filter(v=>f[v]).forEach(v=>{d.$ic(v)?(l=l||$.$Jj(),l[v]=f[v]):(u=u||$.$Jj(),u[v]=f[v])}),this.a=l&&$.$Oj(l,{trimForExclusions:!0}),this.b=u&&$.$Oj(u,{trimForExclusions:!0})}test(f,l,u){return this.b&&this.b(f,l,u)||this.a&&this.a(d.$jc(this.c,f),l,u)}getBasenameTerms(){const f=[];return this.a&&f.push(...$.$Qj(this.a)),this.b&&f.push(...$.$Qj(this.b)),f}getPathTerms(){const f=[];return this.a&&f.push(...$.$Rj(this.a)),this.b&&f.push(...$.$Rj(this.b)),f}}function h(s){const f=s.trim().split(`
`),l=f[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return k.$Bf(f[f.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ke[376],Se([1,0,98,21,186,22]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.DecodeStreamErrorKind=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=void 0,e.$kD="utf8",e.$lD="utf8bom",e.$mD="utf16be",e.$nD="utf16le";function A(l){return[e.$kD,e.$lD,e.$mD,e.$nD].some(u=>u===l)}e.$oD=A,e.$pD=[254,255],e.$qD=[255,254],e.$rD=[239,187,191];const w=512,$=512,E=512*8,R=512*128;var C;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class p extends Error{constructor(u,v){super(u),this.decodeStreamErrorKind=v}}e.$sD=p;class k{static async create(u){let v;if(u!==e.$kD)v=(await(0,d.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(u));else{const I=new TextDecoder;v={write(b){return I.decode(b,{stream:!0})},end(){return I.decode()}}}return new k(v)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function S(l,u){const v=u.minBytesRequiredForDetection??u.guessEncoding?E:$;return new Promise((I,b)=>{const g=(0,D.$$d)(F=>F.join("")),y=[];let L=0,T;const U=new P.$7d,j=async()=>{try{const F=await f({buffer:M.$ke.concat(y),bytesRead:L},u.guessEncoding);if(F.seemsBinary&&u.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);F.encoding=await u.overwriteEncoding(F.encoding),T=await k.create(F.encoding);const N=T.write(M.$ke.concat(y).buffer);g.write(N),y.length=0,L=0,I({stream:g,detected:F})}catch(F){U.cancel(),g.destroy(),b(F)}};(0,D.$ce)(l,{onData:async F=>{T?g.write(T.write(F.buffer)):(y.push(F),L+=F.byteLength,L>=v&&(l.pause(),await j(),setTimeout(()=>l.resume())))},onError:F=>g.error(F),onEnd:async()=>{T||await j(),g.end(T?.end())}},U.token)})}e.$tD=S;async function c(l,u,v){const b=(await(0,d.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(u),v);let g=!1,y=!1;return{read(){if(y)return null;const L=l.read();if(typeof L!="string"){if(y=!0,!g&&v?.addBOM)switch(u){case e.$kD:case e.$lD:return M.$ke.wrap(Uint8Array.from(e.$rD));case e.$mD:return M.$ke.wrap(Uint8Array.from(e.$pD));case e.$nD:return M.$ke.wrap(Uint8Array.from(e.$qD))}const T=b.end();return T&&T.length>0?(g=!0,M.$ke.wrap(T)):null}return g=!0,M.$ke.wrap(b.write(L))}}}e.$uD=c;async function m(l){return(await(0,d.$jD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(l))}e.$vD=m;function a(l){return l===e.$lD||l===null?e.$kD:l}e.$wD=a;function i(l,u){if(!l||u<e.$pD.length)return null;const v=l.readUInt8(0),I=l.readUInt8(1);if(v===e.$pD[0]&&I===e.$pD[1])return e.$mD;if(v===e.$qD[0]&&I===e.$qD[1])return e.$nD;if(u<e.$rD.length)return null;const b=l.readUInt8(2);return v===e.$rD[0]&&I===e.$rD[1]&&b===e.$rD[2]?e.$lD:null}e.$xD=i;const r=["ascii","utf-16","utf-32"];async function n(l){const u=await(0,d.$jD)("jschardet","dist/jschardet.min.js"),v=l.slice(0,R),I=h(v.buffer),b=u.detect(I);if(!b||!b.encoding)return null;const g=b.encoding.toLowerCase();return 0<=r.indexOf(g)?null:t(b.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(l){const u=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[u]||u}function h(l){let u="";for(let v=0;v<l.length;v++)u+=String.fromCharCode(l[v]);return u}function s(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=l.match(/windows(\d+)/);return u?"windows-"+u[1]:l}}}e.$yD=s;function f({buffer:l,bytesRead:u},v){let I=i(l,u),b=!1;if(I!==e.$mD&&I!==e.$nD&&l){let g=!0,y=!0,L=!1;for(let T=0;T<u&&T<w;T++){const U=T%2===1,j=l.readUInt8(T)===0;if(j&&(L=!0),g&&(U&&!j||!U&&j)&&(g=!1),y&&(U&&j||!U&&!j)&&(y=!1),j&&!g&&!y)break}L&&(g?I=e.$nD:y?I=e.$mD:b=!0)}return v&&!b&&!I&&l?n(l.slice(0,u)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:b,encoding:I}}e.$zD=f,e.$AD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[155],Se([1,0,376,31,154]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;class P extends d.$nhc{constructor(w,$,E=M,R="searchProcess"){super(w,$,{readdir:C=>E.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$yD)(C)},R)}}e.$Cic=P}),define(ke[156],Se([1,0,50,392,375,19,74,35,13,2,36,94,393,373,119]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=e.$zic=e.$yic=e.$xic=e.$wic=e.$vic=void 0;const c=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(g){this.a=g}provideTextSearchResults(g,y,L,T){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((U,j)=>{T.onCancellationRequested(()=>X());const F=t(g,y),N=y.folder.fsPath,O=F.map(ne=>ne.match(/^-/)?ne:`'${ne}'`).join(" ");this.a.appendLine(`${c} ${O}
 - cwd: ${N}`);let z=D.spawn(c,F,{cwd:N});z.on("error",ne=>{console.error(ne),this.a.appendLine("Error: "+(ne&&ne.message)),j((0,R.$SJ)(new R.$QJ(ne&&ne.message,R.SearchErrorCode.rgProcessError)))});let K=!1;const te=new r(y.maxResults,y.folder,y.previewOptions);te.on("result",ne=>{K=!0,ce="",L.report(ne)});let x=!1;const X=()=>{x=!0,z?.kill(),te?.cancel()};let Z=!1;te.on("hitLimit",()=>{Z=!0,X()});let ce="";z.stdout.on("data",ne=>{te.handleData(ne),K||(ce+=ne)});let _=!1;z.stdout.once("data",()=>_=!0);let ge="";z.stderr.on("data",ne=>{const J=ne.toString();this.a.appendLine(J),ge.length+J.length<1e6&&(ge+=J)}),z.on("close",()=>{if(this.a.appendLine(_?"Got data from stdout":"No data from stdout"),this.a.appendLine(K?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),x)U({limitHit:Z});else{te.flush(),z=null;let ne;ge&&!_&&(ne=a(ge))?j((0,R.$SJ)(new R.$QJ(ne.message,ne.code))):U({limitHit:Z})}})})}}e.$vic=m;function a(b){const g=b.split(`
`),y=g[0].trim();if(g.some(T=>T.startsWith("regex parse error")))return new R.$QJ(i(g),R.SearchErrorCode.regexParseError);const L=y.match(/grep config error: unknown encoding: (.*)/);if(L)return new R.$QJ(`Unknown encoding: ${L[1]}`,R.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new R.$QJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new R.$QJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new R.$QJ(y,R.SearchErrorCode.regexParseError)}function i(b){const g=["Regex parse error"],y=b.filter(L=>L.startsWith("PCRE2:"));if(y.length>=1){const L=y[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const T=L.split(":")[1];g.push(":"+T)}}return g.join("")}class r extends M.EventEmitter{constructor(g,y,L){super(),this.g=g,this.h=y,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new d.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,y){return super.on(g,y),this}handleData(g){if(this.b)return;const y=typeof g=="string"?g:this.d.write(g);this.k(y)}k(g){let y=g.indexOf(`
`);const L=this.a+g;if(y>=0)y+=this.a.length;else{this.a=L;return}let T=0;for(;y>=0;)this.m(L.substring(T,y).trim()),T=y+1,y=L.indexOf(`
`,T);this.a=L.substring(T)}m(g){if(this.b||!g)return;let y;try{y=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(y.type==="match"){const L=n(y.data.path),T=E.URI.joinPath(this.h,L),U=this.n(y.data,T);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const L=n(y.data.path),T=E.URI.joinPath(this.h,L);this.o(y.data,T).forEach(j=>this.p(j))}}n(g,y){const L=g.line_number-1,T=n(g.lines),U=Buffer.from(T);let j=0,F=0,N=L;g.submatches.length===0&&g.submatches.push(T.length?{start:0,end:1,match:{text:T[0]}}:{start:0,end:0,match:{text:""}});const O=(0,P.$Hb)(g.submatches.map((z,K)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=n(z.match),x=U.slice(j,z.start).toString(),X=o(x),Z=X.numLines>0?X.lastLineLength:X.lastLineLength+F,ce=o(te),_=X.numLines+N,ge=ce.numLines+_,ne=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+Z;return j=z.end,F=ne,N=ge,new C.$AJ(_,Z,ge,ne)}));return(0,S.$oic)(y,T,O,this.j)}o(g,y){const L=n(g.lines),T=g.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((U,j)=>({text:U,uri:y,lineNumber:T+j}))}p(g){this.emit("result",g)}}e.$wic=r;function n(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function o(b){const g=/\n/g;let y=0,L=-1,T;for(;T=g.exec(b);)y++,L=T.index;const U=L>=0?b.length-L-1:b.length;return{numLines:y,lastLineLength:U}}function t(b,g){const y=["--hidden","--no-require-git"];y.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:T}=(0,A.$K)(g.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(T&&T.length){const j=new Set;T.forEach(F=>{j.add(F)}),y.push("-g","!*"),j.forEach(F=>{h(F).map(S.$nic).forEach(N=>{y.push("-g",N)})})}L&&L.length&&L.forEach(j=>{y.push("-g",j)}),g.excludes.map(S.$nic).forEach(j=>y.push("-g",`!${j}`)),g.maxFileSize&&y.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),g.followSymlinks&&y.push("--follow"),g.encoding&&g.encoding!=="utf8"&&y.push("--encoding",g.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,$.$Pe)(b.pattern),b.isRegExp=!0),g.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),b.isRegExp&&(b.pattern=s(b.pattern),y.push("--engine","auto"));let U;if(b.isWordMatch){const F=(0,$.$Ye)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",F)}else if(b.isRegExp){let j=l(b.pattern);j=u(j),y.push("--regexp",j)}else U=b.pattern,y.push("--fixed-strings");return y.push("--no-config"),g.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),b.isMultiline&&y.push("--multiline"),g.beforeContext&&y.push("--before-context",g.beforeContext+""),g.afterContext&&y.push("--after-context",g.afterContext+""),y.push("--"),U&&y.push(U),y.push("."),y}e.$xic=t;function h(b){return I(b).flatMap(y=>{const L=(0,w.$Mj)(y,"/");return L.map((T,U)=>L.slice(0,U+1).join("/"))})}function s(b){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(g);)b=b.replace(g,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(y);)b=b.replace(y,"$1\\x{$2}");return b}e.$yic=s;const f=b=>b.type==="Assertion"&&b.kind==="lookbehind";function l(b){let g;try{g=new p.RegExpParser().parsePattern(b)}catch{return b}let y="",L=0;const T=(F,N,O)=>{y+=b.slice(L,F)+O,L=N},U=[];return new p.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const N=U[0];if(!N)T(F.start,F.end,"\\r?\\n");else if(!U.some(f))if(N.type==="CharacterClass")if(N.negate){const O=b.slice(N.start+2,F.start)+b.slice(F.end,N.end-1);N.parent?.type==="Quantifier"?T(N.start,N.end,O?`[^${O}]`:"."):T(N.start,N.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=b.slice(N.start+1,F.start)+b.slice(F.end,N.end-1);T(N.start,N.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else N.type==="Quantifier"&&T(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){U.unshift(F)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(F){U.unshift(F)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(F){U.unshift(F)},onCharacterClassLeave(){U.shift()},onAssertionEnter(F){f(F)&&U.push(F)},onAssertionLeave(F){U[0]===F&&U.shift()}}).visit(g),y+=b.slice(L),y}e.$zic=l;function u(b){return b.replace(/\n/g,"\\r?\\n")}e.$Aic=u;function v(b){let g=!1,y=!1,L="",T="";for(let U=0;U<b.length;U++){const j=b[U];switch(j){case"\\":y?(g?T+="\\"+j:L+="\\"+j,y=!1):y=!0;break;case"{":if(y)g?T+=j:L+=j,y=!1;else{if(g)return{strInBraces:L+"{"+T+"{"+b.substring(U+1)};g=!0}break;case"}":if(y)g?T+=j:L+=j,y=!1;else{if(g)return{fixedStart:L,strInBraces:T,fixedEnd:b.substring(U+1)};L+=j}break;default:g?T+=(y?"\\":"")+j:L+=(y?"\\":"")+j,y=!1;break}}return{strInBraces:L+(g?"{"+T:"")}}function I(b){const{fixedStart:g,strInBraces:y,fixedEnd:L}=v(b);if(g===void 0||L===void 0)return[y];let T=(0,w.$Mj)(y,",");T.length||(T=[""]);const U=I(L);return T.flatMap(j=>{const F=g+j;return U.map(N=>F+N)})}e.$Bic=I}),define(ke[377],Se([1,0,22,156,107,15]),function($e,e,D,M,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;class A{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,R,C,p){const k=new M.$vic(this.b);if(R.folder.scheme===P.Schemas.vscodeUserData){const S={...R,folder:R.folder.with({scheme:P.Schemas.file})},c=new d.$xv(m=>C.report({...m,uri:m.uri.with({scheme:R.folder.scheme})}));return this.c(p,m=>k.provideTextSearchResults(E,S,c,m))}else return this.c(p,S=>k.provideTextSearchResults(E,R,C,S))}async c(E,R){const C=w(E);this.a.add(C);const p=await R(C.token);return this.a.delete(C),p}d(){this.a.forEach(E=>E.cancel())}}e.$Fic=A;function w($){const E=new D.$7d;return $.onCancellationRequested(()=>E.cancel()),E}}),define(ke[378],Se([1,0,31,156,155]),function($e,e,D,M,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class P{constructor($){this.a=$}search($,E,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(k){R({message:k})}},p=new d.$Cic(this.a,new M.$vic(C),D);return new Promise((k,S)=>p.search(c=>{E(c.map(A))},$).then(c=>k({limitHit:c.limitHit,type:"success",stats:c.stats}),S))}}e.$Dic=P;function A(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce(($,E)=>{if(E.ranges){const R=E;return $+(Array.isArray(R.ranges)?R.ranges.length:1)}else return $+1},0)}}}),define(ke[379],Se([1,0,19,8,14,4,129,17,38,2,32,36,374,378]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;class S{static{this.a=512}constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let o;const t=a(n),h=new P.$Wd({onDidAddFirstListener:()=>{o=(0,M.$Ug)(s=>this.doFileSearchWithEngine(p.$uic,t,f=>h.fire(f),s)),o.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return h.event}textSearch(n){let o;const t=a(n),h=new P.$Wd({onDidAddFirstListener:()=>{o=(0,M.$Ug)(s=>this.f(t,f=>h.fire(f),s)),o.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return h.event}f(n,o,t){return n.maxFileSize=this.g().maxFileSize,new k.$Dic(n).search(t,o,o)}g(){return{maxFileSize:16*R.$1k.GB}}doFileSearch(n,o,t){return this.doFileSearchWithEngine(p.$uic,n,o,t)}doFileSearchWithEngine(n,o,t,h,s=S.a){let f=0;const l=v=>{Array.isArray(v)?(f+=v.length,t(v.map(I=>this.h(I)))):v.relativePath?(f++,t(this.h(v))):t(v)};if(o.sortByScore){let v=this.l(o,l,h);if(!v){const I=o.maxResults?Object.assign({},o,{maxResults:null}):o,b=new n(I);v=this.j(b,o,t,l,h)}return new Promise((I,b)=>{v.then(([g,y])=>{const L=y.map(T=>this.h(T));this.o(L,t,s),I(g)},b)})}const u=new n(o);return this.r(u,l,s,h).then(v=>({limitHit:v.limitHit,type:"success",stats:{detailStats:v.stats,type:this.d,fromCache:!1,resultCount:f,sortingTime:void 0}}))}h(n){return{path:n.base?(0,w.$jc)(n.base,n.relativePath):n.relativePath}}j(n,o,t,h,s){const f=new P.$Wd;let l=(0,M.$Ug)(v=>{let I=[];const b=g=>{Array.isArray(g)?I=g:(h(g),f.fire(g))};return this.r(n,b,-1,v).then(g=>[g,I])}),u;if(o.cacheKey){u=this.k(o.cacheKey);const v={promise:l,event:f.event,resolved:!1};u.resultsToSearchCache[o.filePattern||""]=v,l.then(()=>{v.resolved=!0},I=>{delete u.resultsToSearchCache[o.filePattern||""]}),l=this.s(l)}return l.then(([v,I])=>{const b=u?u.scorerCache:Object.create(null),g=(typeof o.maxResults!="number"||o.maxResults>0)&&$.$Sd.create(!1);return this.n(o,I,b,s).then(y=>{const L=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:v.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:y.length},messages:v.messages,limitHit:v.limitHit||typeof o.maxResults=="number"&&I.length>o.maxResults},y]})})}k(n){const o=this.b[n];return o||(this.b[n]=new c)}l(n,o,t){const h=n.cacheKey&&this.b[n.cacheKey];if(!h)return;const s=this.q(h,n.filePattern||"",o,t);if(s)return s.then(([f,l,u])=>{const v=$.$Sd.create(!1);return this.n(n,l,h.scorerCache,t).then(I=>{const b=v.elapsed(),g={fromCache:!0,detailStats:u,type:this.d,resultCount:l.length,sortingTime:b};return[{type:"success",limitHit:f.limitHit||typeof n.maxResults=="number"&&l.length>n.maxResults,stats:g},I]})})}n(n,o,t,h){const s=(0,A.$2q)(n.filePattern||""),f=(u,v)=>(0,A.$1q)(u,v,s,!0,m,t),l=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return D.$Gb(o,f,l,1e4,h)}o(n,o,t){if(t&&t>0)for(let h=0;h<n.length;h+=t)o(n.slice(h,h+t));else o(n)}q(n,o,t,h){const s=$.$Sd.create(!1),f=o.indexOf(w.sep)>=0;let l;for(const b in n.resultsToSearchCache)if(o.startsWith(b)){if(f&&b.indexOf(w.sep)<0&&b!=="")continue;const g=n.resultsToSearchCache[b];l={promise:this.s(g.promise),event:g.event,resolved:g.resolved};break}if(!l)return null;const u=s.elapsed(),v=$.$Sd.create(!1),I=l.event(t);return h&&h.onCancellationRequested(()=>{I.dispose()}),l.promise.then(([b,g])=>{if(h&&h.isCancellationRequested)throw(0,d.$6)();const y=[],L=(0,A.$2q)(o).normalizedLowercase;for(const T of g)(0,C.$WJ)(T,L)&&y.push(T);return[b,y,{cacheWasResolved:l.resolved,cacheLookupTime:u,cacheFilterTime:v.elapsed(),cacheEntryCount:g.length}]})}r(n,o,t,h){return new Promise((s,f)=>{let l=[];h?.onCancellationRequested(()=>n.cancel()),n.search(u=>{u&&(t?(l.push(u),t>0&&l.length>=t&&(o(l),l=[])):o(u))},u=>{o(u)},(u,v)=>{l.length&&o(l),u?(o({message:"Search finished. Error: "+u.message}),f(u)):(o({message:"Search finished. Stats: "+JSON.stringify(v.stats)}),s(v))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return n.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return n.finally(o)}}}}e.$Eic=S;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(r){return(0,w.$nc)(r.relativePath)}getItemDescription(r){return(0,w.$mc)(r.relativePath)}getItemPath(r){return r.relativePath}};function a(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>E.URI.revive(n))}}function i(r){return{...r,folder:E.URI.revive(r.folder)}}}),define(ke[380],Se([1,0,3,15,2,31,12,27,20,97,67,36,379,377,119,155]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0;let m=class extends E.$shc{constructor(i,r,n,o){super(i,n,o),this.s=P,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new S.$pic("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.vscodeUserData,new k.$Fic(t))),r.remote.isRemote&&r.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$pic("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.file,new k.$Fic(i))),this.x.add(this.z(M.Schemas.file,new p.$Eic("fileSearchProvider")))}z(i,r){const n=this.d++;return this.v=r,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,o){const t=(0,E.$thc)(n);if(i===this.t){const h=Date.now();return this.A(i,r,t,o).then(s=>{const f=Date.now()-h;return this.n.debug(`Ext host file search time: ${f}ms`),s})}return super.$provideFileSearchResults(i,r,n,o)}doInternalFileSearchWithCustomCallback(i,r,n){const o=t=>{if((0,C.$VJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(h=>d.URI.file(h.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,o,r)}async A(i,r,n,o){return this.doInternalFileSearchWithCustomCallback(n,o,t=>{this.c.$handleFileMatch(i,r,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,r){return new c.$Cic(i,r,void 0,"textSearchProvider")}};e.$Gic=m,e.$Gic=m=Ge([Ve(0,$.$pN),Ve(1,w.$FN),Ve(2,R.$lgc),Ve(3,A.$pj)],m)}),define(ke[120],Se([1,0,394,62,64,395,21,14,4,3,17,11,30,81,82]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0;class c{traceSocketEvent(g,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,y)}constructor(g,y=""){this.f=!0,this.debugLabel=y,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,w.$1)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const y=L=>{this.traceSocketEvent("read",L),g(A.$ke.wrap(L))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(g){const y=L=>{g({type:0,hadError:L,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(g){const y=()=>{g()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,w.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,w.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Wh=c;var m;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var a;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(a||(a={}));class i extends E.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,y){this.socket.traceSocketEvent(g,y)}constructor(g,y,L,T){super(),this.f=this.B(new $.$Wd),this.g=this.B(new $.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:L?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new r(this,y,L,T,this.f,(U,j)=>this.m(U,j))),this.B(this.a.onError(U=>{console.error(U),(0,w.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new S.$Rh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let y=0;for(;y<g.byteLength;)this.a.writeMessage(g.slice(y,Math.min(y+262144,g.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(g,{compressed:y,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let T=2;g.byteLength<126?T+=0:g.byteLength<2**16?T+=2:T+=8;const U=A.$ke.alloc(T),j=y?64:0,F=L&15;if(U.writeUInt8(128|j|F,0),g.byteLength<126)U.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){U.writeUInt8(126,1);let N=1;U.writeUInt8(g.byteLength>>>8&255,++N),U.writeUInt8(g.byteLength>>>0&255,++N)}else{U.writeUInt8(127,1);let N=1;U.writeUInt8(0,++N),U.writeUInt8(0,++N),U.writeUInt8(0,++N),U.writeUInt8(0,++N),U.writeUInt8(g.byteLength>>>24&255,++N),U.writeUInt8(g.byteLength>>>16&255,++N),U.writeUInt8(g.byteLength>>>8&255,++N),U.writeUInt8(g.byteLength>>>0&255,++N)}this.socket.write(A.$ke.concat([U,g]))}end(){this.h=!0,this.socket.end()}n(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),L=y.readUInt8(0),T=(L&128)>>>7,U=(L&64)>>>6,j=L&15,F=y.readUInt8(1),N=(F&128)>>>7,O=F&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),L=y.readUInt8(1),T=(L&128)>>>7;let U=L&127,j=1;U===126?U=y.readUInt8(++j)*2**8+y.readUInt8(++j):U===127&&(U=y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j));let F=0;T&&(F=y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j)),this.j.state=3,this.j.readLen=U,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Xh=i;class r extends E.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ke.alloc(0)}constructor(g,y,L,T,U,j){super(),this.n=g,this.r=U,this.s=j,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new n(this.n,T,L,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(g,y){this.g.push({data:g,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:g,options:y}=this.g.shift();if(this.f&&y.compressed){const L=await this.w(this.f,g);this.s(L,y)}else this.s(g,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(g,y){return new Promise((L,T)=>{g.write(y),g.flush(U=>L(U))})}acceptFrame(g,y,L){this.h.push({data:g,isCompressed:y,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const y=await this.C(this.b,g.data,g.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(g.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(g,y,L){return new Promise((T,U)=>{g.write(y),L&&g.write(A.$ke.fromByteArray([0,0,255,255])),g.flush(j=>T(j))})}}class n extends E.$Tc{get recordedInflateBytes(){return this.j?A.$ke.concat(this.f):A.$ke.alloc(0)}constructor(g,y,L,T){super(),this.h=g,this.j=y,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(T),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(A.$ke.wrap(U))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=A.$ke.concat(this.g);this.g.length=0,g(y)})}}class o extends E.$Tc{constructor(g,y){super(),this.g=g,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(A.$ke.wrap(L))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=A.$ke.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),g(y)})}}function t(b,g){if(g===0)return;const y=b.byteLength>>>2;for(let N=0;N<y;N++){const O=b.readUInt32BE(N*4);b.writeUInt32BE(O^g,N*4)}const L=y*4,T=b.byteLength-L,U=g>>>24&255,j=g>>>16&255,F=g>>>8&255;T>=1&&b.writeUInt8(b.readUInt8(L)^U,L),T>=2&&b.writeUInt8(b.readUInt8(L+1)^j,L+1),T>=3&&b.writeUInt8(b.readUInt8(L+2)^F,L+2)}e.$Yh=process.env.XDG_RUNTIME_DIR;const h={2:107,1:103};function s(){const b=(0,p.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const g=process.platform!=="darwin"&&e.$Yh?e.$Yh:(0,d.tmpdir)(),y=(0,R.$jc)(g,`vscode-ipc-${b}.sock`);return l(y),y}e.$Zh=s;function f(b,g,y){const T=(0,D.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${y}-${g}-sock`;const U=y.substr(0,4),j=g.substr(0,6);let F;return process.platform!=="darwin"&&e.$Yh&&!process.env.VSCODE_PORTABLE?F=(0,R.$jc)(e.$Yh,`vscode-${T}-${U}-${j}.sock`):F=(0,R.$jc)(b,`${U}-${j}.sock`),l(F),F}e.$1h=f;function l(b){const g=h[C.$u];typeof g=="number"&&b.length>=g&&console.warn(`WARNING: IPC handle "${b}" is longer than ${g} chars, try a shorter --user-data-dir`)}class u extends k.$Lh{static b(g){const y=$.Event.fromNodeEventEmitter(g,"connection");return $.Event.map(y,L=>({protocol:new S.$Sh(new c(L,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(L,"close"))}))}constructor(g){super(u.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$2h=u;function v(b){return new Promise((g,y)=>{const L=(0,M.createServer)();L.on("error",y),L.listen(b,()=>{L.removeListener("error",y),g(new u(L))})})}e.$3h=v;function I(b,g){return new Promise((y,L)=>{const T=(0,M.createConnection)(b,()=>{T.removeListener("error",L),y(S.$Th.fromSocket(new c(T,`ipc-client${g}`),g))});T.once("error",L)})}e.$4h=I}),define(ke[381],Se([1,0,62,64,166,120,8,3,11,51,12,136,256,257,109,88,21]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=e.$X$b=e.$W$b=e.$V$b=void 0;async function a(t,h,s,f,l){let u;for(let v=3;v&&(u?.dispose(),u=await new i(t,h,s,f,l).waitForReady(),!(l&&d.$ug[l]||!d.$ug[u.tunnelLocalPort]));v--);return u}class i extends w.$Tc{constructor(h,s,f,l,u){super(),this.m=s,this.n=u,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=h,this.b=D.createServer(),this.c=new A.$7g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.r(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=f}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const h=this.n??this.tunnelRemotePort,s=(0,c.$Jv)(this.m)?"0.0.0.0":"127.0.0.1";let f=await(0,d.$vg)(h,2,1e3,s),l=null;return this.b.listen(f,this.m),await this.c.wait(),l=this.b.address(),l||(f=0,this.b.listen(f,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(h){h.pause();const s=(0,c.$Hv)(this.tunnelRemoteHost)||(0,c.$Jv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,f=await(0,p.$nl)(this.a,s,this.tunnelRemotePort),l=f.getSocket(),u=f.readEntireBuffer();f.dispose(),u.byteLength>0&&h.write(u.buffer),h.on("end",()=>{h.localAddress&&this.j.delete(h.localAddress),l.end()}),h.on("close",()=>l.end()),h.on("error",()=>{h.localAddress&&this.j.delete(h.localAddress),l instanceof P.$Wh?l.socket.destroy():l.end()}),l instanceof P.$Wh?this.t(h,l):this.s(h,l),h.localAddress&&this.j.set(h.localAddress,()=>{h.end(),l.end()})}s(h,s){s.onClose(()=>h.destroy()),s.onEnd(()=>h.end()),s.onData(f=>h.write(f.buffer)),h.on("data",f=>s.write(m.$ke.wrap(f))),h.resume()}t(h,s){const f=s.socket;f.on("end",()=>h.end()),f.on("close",()=>h.end()),f.on("error",()=>{h.destroy()}),f.pipe(h),h.pipe(f)}}e.$V$b=i;let r=class extends c.$Mv{constructor(h,s,f,l,u){super(s,u),this.v=h,this.w=f,this.y=l}isPortPrivileged(h){return(0,c.$Kv)(h,this.m,$.OS,M.release())}t(h,s,f,l,u,v,I,b){const g=this.s(s,f);if(g)return++g.refcount,g.value;if((0,c.$Ev)(h))return this.u(h,s,f,u,v,I,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${f} on local port ${u}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:h,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},L=a(y,l,s,f,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,f,L),L}}};e.$W$b=r,e.$W$b=r=Ge([Ve(0,k.$hl),Ve(1,R.$pj),Ve(2,S.$kl),Ve(3,C.$Hj),Ve(4,E.$Bi)],r);let n=class extends r{constructor(h,s,f,l,u){super(h,s,f,l,u)}};e.$X$b=n,e.$X$b=n=Ge([Ve(0,k.$hl),Ve(1,R.$pj),Ve(2,S.$kl),Ve(3,C.$Hj),Ve(4,E.$Bi)],n);let o=class extends w.$Tc{constructor(h,s,f,l,u){super(),this.b=h,this.c=s,this.f=f,this.g=l,this.h=u,this.a=new Map}async openTunnel(h,s,f,l,u,v,I,b,g){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${f}:${l} on local port ${v}.`),!this.a.has(h)){const y=new n(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(h,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(h))})}return this.a.get(h).openTunnel(s,f,l,u,v,I,b,g)}};e.$Y$b=o,e.$Y$b=o=Ge([Ve(0,k.$hl),Ve(1,R.$pj),Ve(2,C.$Hj),Ve(3,S.$kl),Ve(4,E.$Bi)],o)}),define(ke[382],Se([1,0,120,276,57,33,2,12,40]),function($e,e,D,M,d,P,A,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=e.$QN=void 0;class E{constructor(p,k,S){this.b=p,this.c=k,this.f=S,this.a=M.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(k.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,k){const S=(m,a)=>{k.writeHead(m,{"content-type":"application/json"}),k.end(JSON.stringify(a||null),i=>i&&this.c.error(i))},c=[];p.setEncoding("utf8"),p.on("data",m=>c.push(m)),p.on("end",async()=>{try{const m=JSON.parse(c.join(""));let a;switch(m.type){case"open":a=await this.i(m);break;case"openExternal":a=await this.j(m);break;case"status":a=await this.l(m);break;case"extensionManagement":a=await this.k(m);break;default:S(404,`Unknown message type: ${m.type}`);break}S(200,a)}catch(m){const a=m instanceof Error?m.message:JSON.stringify(m);S(500,a),this.c.error("Error while processing pipe request",m)}})}async i(p){const{fileURIs:k,folderURIs:S,forceNewWindow:c,diffMode:m,mergeMode:a,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:o,remoteAuthority:t}=p,h=[];if(Array.isArray(S))for(const u of S)try{h.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(k))for(const u of k)try{(0,$.$Ai)(u)?h.push({workspaceUri:A.URI.parse(u)}):h.push({fileUri:A.URI.parse(u)})}catch{}const s=o?A.URI.file(o):void 0,l={forceNewWindow:c,diffMode:m,mergeMode:a,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",h,l)}async j(p){for(const k of p.uris){const S=A.URI.parse(k),c=S.scheme==="file"?S:k;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(p){const k=c=>c?.map(m=>/\.vsix$/i.test(m)?A.URI.parse(m):m),S={list:p.list,install:k(p.install),uninstall:k(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&d.existsSync(this.f)&&d.unlinkSync(this.f)}}e.$QN=E;let R=class extends E{constructor(p,k){super(p,k,(0,D.$Zh)())}};e.$RN=R,e.$RN=R=Ge([Ve(0,P.$LN),Ve(1,w.$pj)],R)}),define(ke[383],Se([1,0,58,370,365,275,47,352,2,15,7,382,103,308,351]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;class c extends d.$aic{j(){const i=this,r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(s,f,l){return s=t(s),i.a.has(s)?i.a.get(s).load(s,$.URI.file((0,p.$yq)(f.filename)),u=>n.apply(this,[u,f,l])):n.apply(this,arguments)};const o=r._resolveLookupPaths;r._resolveLookupPaths=(h,s)=>o.call(this,t(h),s);const t=h=>{for(const s of i.b){const f=s(h);if(f){h=f;break}}return h}}}class m extends A.$2gc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(k.$Jic);const i=this.h.invokeFunction(M.$9hc);if(this.h.createInstance(w.$Iic),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(C.$RN);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(S.$Kic),await this.h.createInstance(c,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const n=await this.m.getConfigProvider();await(0,P.$Hic)(this.j,n,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,r,n){if(r.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${r}', must be of file-scheme`);let o=null;n.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${r.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),o=$e.__$__nodeRequire(r.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return o}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const r in i){const n=i[r];n===null?delete process.env[r]:process.env[r]=n}}}e.$Lic=m}),define(ke[384],Se([1,0,50,21,4,3,122,11,23,2,31,12,255,65,109,88,381,27,20,71,359]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=e.$Sic=e.$Ric=e.$Qic=e.$Pic=e.$Oic=e.$Nic=e.$Mic=void 0;function o(g){const y=g.trim().split(`
`),L=[];return y.forEach(U=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);j&&j.length>=3&&L.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),L.reduce((U,j)=>(U[j.socket]=j,U),{})}e.$Mic=o;function t(...g){const y=[].concat(...g.map(s));return[...new Map(y.filter(L=>L.st==="0A").map(L=>{const T=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:h(T[0]),port:parseInt(T[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}e.$Nic=t;function h(g){let y="";if(g.length===8)for(let L=g.length-2;L>=0;L-=2)y+=parseInt(g.substr(L,2),16),L!==0&&(y+=".");else for(let L=0;L<g.length;L+=8){const T=g.substring(L,L+8);let U="";for(let j=8;j>=2;j-=2)U+=T.substring(j-2,j),(j===6||j===2)&&(U=parseInt(U,16).toString(16),y+=`${U}`,U="",L+j!==g.length-6&&(y+=":"))}return y}e.$Oic=h;function s(g){const y=g.trim().split(`
`),L=y.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return y.map(U=>U.trim().split(/\s+/).reduce((j,F,N)=>(j[L[N]||N]=F,j),{}))}e.$Pic=s;function f(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function l(g){const y=g.trim().split(`
`),L=[];return y.forEach(T=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(T);U&&U.length>=4&&L.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),L}e.$Qic=l;async function u(g,y,L){const T=L.reduce((j,F)=>(j[F.pid]=F,j),{}),U=[];return g.forEach(({socket:j,ip:F,port:N})=>{const O=y[j]?y[j].pid:void 0,z=O?T[O]?.cmd:void 0;O&&z&&!f(z)&&U.push({host:F,port:N,detail:z,pid:O})}),U}e.$Ric=u;function v(g,y,L){const T=new Map,U=l(y);for(const j of g){const F=L.get(j.port);if(F){T.set(j.port,F);continue}const N=U.find(O=>O.cmd.includes(`${j.port}`));if(N){let O=N,z;do z=U.find(K=>K.ppid===O.pid),z&&(O=z);while(z);T.set(j.port,{host:j.ip,port:j.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else T.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return T}e.$Sic=v;let I=class extends r.$izb{constructor(y,L,T,U){super(y,L,T),this.D=L,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,w.$k&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const T=new A.$_l;let U=0;for(;this.C;){const j=new Date().getTime(),F=(await this.I()).filter(z=>(0,c.$Hv)(z.host)||(0,c.$Jv)(z.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(z=>z.port).join(", ")}`);const N=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),U++>3&&T.update(N),(!L||JSON.stringify(L)!==JSON.stringify(F))&&(L=F,await this.a.$onFoundNewCandidates(L));const O=this.G(T.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(z=>setTimeout(()=>z(),O))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",L="";try{y=await R.Promises.readFile("/proc/net/tcp","utf8"),L=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const T=t(y,L),U=await new Promise(x=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,Z,ce)=>{x(Z)})}),j=o(U),F=await R.Promises.readdir("/proc"),N=[];for(const x of F)try{const X=Number(x),Z=$.$Ig(E.URI.file("/proc"),x);if((await R.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(X)){const _=await R.Promises.readlink($.$Ig(Z,"cwd").fsPath),ge=await R.Promises.readFile($.$Ig(Z,"cmdline").fsPath,"utf8");N.push({pid:X,cwd:_,cmd:ge})}}catch{}const O=[],z=T.filter(x=>{const X=j[x.socket];return X||O.push(x),X}),K=u(z,j,N);let te;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const x=await new Promise(X=>{(0,D.exec)("ps -F -A -l | grep root",(Z,ce,_)=>{X(ce)})});this.z=v(O,x,this.z),te=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${te.map(X=>X.port).join(", ")}`)}return K.then(x=>te?x.concat(te):x)}w(y){return async L=>{const T=new m.$V$b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,F,N,O){const z=await y.makeConnection();return b.connect(z,F,N,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$$k(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await T.waitForReady();const U=new d.$Wd;return{localAddress:(0,n.$KK)(T.localAddress)??T.localAddress,remoteAddress:{port:T.tunnelRemotePort,host:T.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{T.dispose(),U.fire(),U.dispose()}}}}};e.$Tic=I,e.$Tic=I=Ge([Ve(0,i.$pN),Ve(1,a.$FN),Ve(2,C.$pj),Ve(3,S.$kl)],I);class b extends p.$hsb{static connect(y,L,T,U){const j=new P.$Sc,F={onClose:j.add(new d.$Wd),onData:j.add(new d.$Wd),onEnd:j.add(new d.$Wd)};j.add(y.onDidReceiveMessage(O=>F.onData.fire(M.$ke.wrap(O)))),j.add(y.onDidEnd(()=>F.onEnd.fire())),j.add(y.onDidClose(O=>F.onClose.fire({type:0,error:O,hadError:!!O})));const N=new b(y,U,F);return N.B(j),(0,p.$gsb)(N,L,T,U,F)}constructor(y,L,T){super(L,T),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[385],Se([1,0,84,354,368,367,380,383,384,96,47,97,95,46,71,93,353,309,12,369,60,270,105,109,138]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a,i,r,n,o,t,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$1r)(R.$3gc,w.$Lic,0),(0,D.$1r)(i.$qj,a.$Vic,1),(0,D.$1r)(i.$pj,new t.$5h(o.$_hc,[!1],!0)),(0,D.$1r)(h.$kl,s.$1$b,1),(0,D.$1r)(c.$ugc,m.$Uic,0),(0,D.$1r)(E.$8gc,P.$mic,0),(0,D.$1r)(C.$rhc,A.$Gic,0),(0,D.$1r)(p.$Uhc,d.$eic,0),(0,D.$1r)(k.$Pgc,M.$dic,0),(0,D.$1r)(S.$hzb,$.$Tic,0),(0,D.$1r)(n.$6gc,r.$Wic,0)}),define(ke[396],Se([1,0,62,397,58,14,82,120,253,113,366,21,31,103,8,132,277,291,371,385]),function($e,e,D,M,d,P,A,w,$,E,R,C,p,k,S,c,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let v=0;v<process.execArgv.length;v++)process.execArgv[v]==="--inspect-port=0"&&(process.execArgv.splice(v,1),v--)}();const i=M(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const u=globalThis._VSCODE_NODE_MODULES.module,v=u._load;u._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return v.apply(this,arguments)}})();const r=process.exit.bind(process),n=process.on.bind(process);function o(u){process.exit=function(v){if(u)r(v);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const v=new Error("An extension called process.crash() and this was prevented.");console.warn(v.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(v,I){v==="uncaughtException"&&(I=function(){try{return I.call(void 0,arguments)}catch{}}),n(v,I)}}let t=function(u){r()};function h(){const u=(0,a.$Wm)(process.env);if(u.type===3)return new Promise((v,I)=>{const b=g=>{const y=g[0],L=new A.$Uh;y.on("message",T=>L.fire(C.$ke.wrap(T.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),v({onMessage:L.event,send:T=>y.postMessage(T.buffer)})};process.parentPort.on("message",g=>b(g.ports))});if(u.type===2)return new Promise((v,I)=>{let b=null;const g=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,L=3e5,T=new S.$ih(()=>t("renderer disconnected for too long (1)"),y),U=new S.$ih(()=>t("renderer disconnected for too long (2)"),L);process.on("message",(F,N)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const O=C.$ke.wrap(Buffer.from(F.initialDataChunk,"base64"));let z;if(F.skipWebSocketFrames)z=new w.$Wh(N,"extHost-socket");else{const K=C.$ke.wrap(Buffer.from(F.inflateBytes,"base64"));z=new w.$Xh(new w.$Wh(N,"extHost-socket"),F.permessageDeflate,K,!1)}b?(T.cancel(),U.cancel(),b.beginAcceptReconnection(z,O),b.endAcceptReconnection(),b.sendResume()):(clearTimeout(g),b=new A.$Vh({socket:z,initialChunk:O}),b.sendResume(),b.onDidDispose(()=>t("renderer disconnected")),v(b),b.onSocketClose(()=>{T.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;T.isScheduled()&&U.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const v=u.pipeName;return new Promise((I,b)=>{const g=D.createConnection(v,()=>{g.removeListener("error",b);const y=new A.$Vh({socket:new w.$Wh(g,"extHost-renderer")});y.sendResume(),I(y)});g.once("error",b),g.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const u=await h();return new class{constructor(){this.a=new A.$Uh,this.onMessage=this.a.event,this.b=!1,u.onMessage(v=>{(0,E.$wm)(v,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(v)})}send(v){this.b||u.send(v)}async drain(){if(u.drain)return u.drain()}}}function f(u){return new Promise(v=>{const I=u.onMessage(b=>{I.dispose();const g=JSON.parse(b.toString()),y=g.commit,L=$.default.commit;if(y&&L&&y!==L&&r(55),g.parentPid){let T=0;setInterval(function(){try{process.kill(g.parentPid,0),T=0}catch(j){j&&j.code==="EPERM"?(T++,T>=3&&t(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${g.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(g.parentPid)}catch(j){(0,P.$1)(j)}}u.send((0,E.$vm)(0)),v({protocol:u,initData:g})});u.send((0,E.$vm)(1))})}async function l(){const u=[];process.on("unhandledRejection",(T,U)=>{u.push(U),setTimeout(()=>{const j=u.indexOf(U);j>=0&&U.catch(F=>{u.splice(j,1),(0,P.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),T&&(0,P.$1)(T))})},1e3)}),process.on("rejectionHandled",T=>{const U=u.indexOf(T);U>=0&&u.splice(U,1)}),process.on("uncaughtException",function(T){(0,P.$Z)(T)||(0,P.$1)(T)}),d.mark("code/extHost/willConnectToRenderer");const v=await s();d.mark("code/extHost/didConnectToRenderer");const I=await f(v);d.mark("code/extHost/didWaitForInitData");const{initData:b}=I;o(!!b.environment.extensionTestsLocationURI),b.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,b.environment.skipWorkspaceStorageLock=(0,c.boolean)(i.skipWorkspaceStorageLock,!1);const g=new class{constructor(){this.pid=process.pid}exit(U){r(U)}fsExists(U){return p.Promises.exists(U)}fsRealpath(U){return(0,k.$xq)(U)}};let y=null;b.remote.authority&&i.transformURIs&&(y=(0,m.$5r)(b.remote.authority));const L=new R.$cic(I.protocol,b,g,y);t=T=>L.terminate(T)}l().catch(u=>console.log(u))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/937f7b7f88cd044a6ee410bae9578259e52d4582/core/vs/workbench/api/node/extensionHostProcess.js.map
